/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","vs/base/common/network","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","os","vs/base/common/strings","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/base/parts/ipc/common/ipc","vs/platform/update/common/update","vs/base/common/functional","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/base/common/iterator","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","crypto","net","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.net","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/common/storage","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/common/linkedList","vs/base/node/ports","vs/base/parts/sandbox/electron-main/electronTypes","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","string_decoder","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/backup/electron-main/backupMainService","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","graceful-fs","@vscode/policy-watcher","https","zlib","vs/code/electron-main/main"],_=function(x){for(var e=[],E=0,M=x.length;E<M;E++)e[E]=Z[x[E]];return e};define(Z[126],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(k,g){const f=Math.pow(10,g);return Math.round(k*f)/f}class M{constructor(g,f,b,v=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,b))|0,this.a=E(Math.max(Math.min(1,v),0),3)}static equals(g,f){return g.r===f.r&&g.g===f.g&&g.b===f.b&&g.a===f.a}}e.RGBA=M;class n{constructor(g,f,b,v){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,f),0),3),this.l=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,v),0),3)}static equals(g,f){return g.h===f.h&&g.s===f.s&&g.l===f.l&&g.a===f.a}static fromRGBA(g){const f=g.r/255,b=g.g/255,v=g.b/255,y=g.a,d=Math.max(f,b,v),w=Math.min(f,b,v);let p=0,a=0;const h=(w+d)/2,m=d-w;if(m>0){switch(a=Math.min(h<=.5?m/(2*h):m/(2-2*h),1),d){case f:p=(b-v)/m+(b<v?6:0);break;case b:p=(v-f)/m+2;break;case v:p=(f-b)/m+4;break}p*=60,p=Math.round(p)}return new n(p,a,h,y)}static i(g,f,b){return b<0&&(b+=1),b>1&&(b-=1),b<1/6?g+(f-g)*6*b:b<1/2?f:b<2/3?g+(f-g)*(2/3-b)*6:g}static toRGBA(g){const f=g.h/360,{s:b,l:v,a:y}=g;let d,w,p;if(b===0)d=w=p=v;else{const a=v<.5?v*(1+b):v+b-v*b,h=2*v-a;d=n.i(h,a,f+1/3),w=n.i(h,a,f),p=n.i(h,a,f-1/3)}return new M(Math.round(d*255),Math.round(w*255),Math.round(p*255),y)}}e.HSLA=n;class R{constructor(g,f,b,v){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,f),0),3),this.v=E(Math.max(Math.min(1,b),0),3),this.a=E(Math.max(Math.min(1,v),0),3)}static equals(g,f){return g.h===f.h&&g.s===f.s&&g.v===f.v&&g.a===f.a}static fromRGBA(g){const f=g.r/255,b=g.g/255,v=g.b/255,y=Math.max(f,b,v),d=Math.min(f,b,v),w=y-d,p=y===0?0:w/y;let a;return w===0?a=0:y===f?a=((b-v)/w%6+6)%6:y===b?a=(v-f)/w+2:a=(f-b)/w+4,new R(Math.round(a*60),p,y,g.a)}static toRGBA(g){const{h:f,s:b,v,a:y}=g,d=v*b,w=d*(1-Math.abs(f/60%2-1)),p=v-d;let[a,h,m]=[0,0,0];return f<60?(a=d,h=w):f<120?(a=w,h=d):f<180?(h=d,m=w):f<240?(h=w,m=d):f<300?(a=w,m=d):f<=360&&(a=d,m=w),a=Math.round((a+p)*255),h=Math.round((h+p)*255),m=Math.round((m+p)*255),new M(a,h,m,y)}}e.HSVA=R;class C{static fromHex(g){return C.Format.CSS.parseHex(g)||C.red}static equals(g,f){return!g&&!f?!0:!g||!f?!1:g.equals(f)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(g){if(g)if(g instanceof M)this.rgba=g;else if(g instanceof n)this.i=g,this.rgba=n.toRGBA(g);else if(g instanceof R)this.j=g,this.rgba=R.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(g){return!!g&&M.equals(this.rgba,g.rgba)&&n.equals(this.hsla,g.hsla)&&R.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=C.k(this.rgba.r),f=C.k(this.rgba.g),b=C.k(this.rgba.b),v=.2126*g+.7152*f+.0722*b;return E(v,4)}static k(g){const f=g/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(g){const f=this.getRelativeLuminance(),b=g.getRelativeLuminance();return f>b?(f+.05)/(b+.05):(b+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const f=this.getRelativeLuminance(),b=g.getRelativeLuminance();return f>b}isDarkerThan(g){const f=this.getRelativeLuminance(),b=g.getRelativeLuminance();return f<b}lighten(g){return new C(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new C(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:f,g:b,b:v,a:y}=this.rgba;return new C(new M(f,b,v,y*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new C(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const f=g.rgba,b=this.rgba.a,v=f.a,y=b+v*(1-b);if(y<1e-6)return C.transparent;const d=this.rgba.r*b/y+f.r*v*(1-b)/y,w=this.rgba.g*b/y+f.g*v*(1-b)/y,p=this.rgba.b*b/y+f.b*v*(1-b)/y;return new C(new M(d,w,p,y))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:f,g:b,b:v,a:y}=this.rgba;return new C(new M(g.rgba.r-y*(g.rgba.r-f),g.rgba.g-y*(g.rgba.g-b),g.rgba.b-y*(g.rgba.b-v),1))}flatten(...g){const f=g.reduceRight((b,v)=>C.o(v,b));return C.o(this,f)}static o(g,f){const b=1-g.rgba.a;return new C(new M(b*f.rgba.r+g.rgba.a*g.rgba.r,b*f.rgba.g+g.rgba.a*g.rgba.g,b*f.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this.u||(this.u=C.Format.CSS.format(this)),this.u}static getLighterColor(g,f,b){if(g.isLighterThan(f))return g;b=b||.5;const v=g.getRelativeLuminance(),y=f.getRelativeLuminance();return b=b*(y-v)/y,g.lighten(b)}static getDarkerColor(g,f,b){if(g.isDarkerThan(f))return g;b=b||.5;const v=g.getRelativeLuminance(),y=f.getRelativeLuminance();return b=b*(v-y)/v,g.darken(b)}}C.white=new C(new M(255,255,255,1)),C.black=new C(new M(0,0,0,1)),C.red=new C(new M(255,0,0,1)),C.blue=new C(new M(0,0,255,1)),C.green=new C(new M(0,255,0,1)),C.cyan=new C(new M(0,255,255,1)),C.lightgrey=new C(new M(211,211,211,1)),C.transparent=new C(new M(0,0,0,0)),e.Color=C,function(k){let g;(function(f){let b;(function(v){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}v.formatRGB=y;function d(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}v.formatRGBA=d;function w(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}v.formatHSL=w;function p(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}v.formatHSLA=p;function a(t){const c=t.toString(16);return c.length!==2?"0"+c:c}function h(t){return`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}`}v.formatHex=h;function m(t,c=!1){return c&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${a(t.rgba.r)}${a(t.rgba.g)}${a(t.rgba.b)}${a(Math.round(t.rgba.a*255))}`}v.formatHexA=m;function I(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}v.format=I;function S(t){const c=t.length;if(c===0||t.charCodeAt(0)!==35)return null;if(c===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),r=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new k(new M(i,r,o,1))}if(c===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),r=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),u=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new k(new M(i,r,o,u/255))}if(c===4){const i=D(t.charCodeAt(1)),r=D(t.charCodeAt(2)),o=D(t.charCodeAt(3));return new k(new M(16*i+i,16*r+r,16*o+o))}if(c===5){const i=D(t.charCodeAt(1)),r=D(t.charCodeAt(2)),o=D(t.charCodeAt(3)),u=D(t.charCodeAt(4));return new k(new M(16*i+i,16*r+r,16*o+o,(16*u+u)/255))}return null}v.parseHex=S;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(b=f.CSS||(f.CSS={}))})(g=k.Format||(k.Format={}))}(C=e.Color||(e.Color={})),e.Color=C}),define(Z[54],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(C){return(k,g,f)=>{let b=null,v=null;if(typeof f.value=="function"?(b="value",v=f.value):typeof f.get=="function"&&(b="get",v=f.get),!v)throw new Error("not supported");f[b]=C(v,g)}}function M(C,k,g){let f=null,b=null;if(typeof g.value=="function"?(f="value",b=g.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(f="get",b=g.get),!b)throw new Error("not supported");const v=`$memoize$${k}`;g[f]=function(...y){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,y)}),this[v]}}e.memoize=M;function n(C,k,g){return E((f,b)=>{const v=`$debounce$${b}`,y=`$debounce$result$${b}`;return function(...d){this[y]||(this[y]=g?g():void 0),clearTimeout(this[v]),k&&(this[y]=k(this[y],...d),d=[this[y]]),this[v]=setTimeout(()=>{f.apply(this,d),this[y]=g?g():void 0},C)}})}e.debounce=n;function R(C,k,g){return E((f,b)=>{const v=`$throttle$timer$${b}`,y=`$throttle$result$${b}`,d=`$throttle$lastRun$${b}`,w=`$throttle$pending$${b}`;return function(...p){if(this[y]||(this[y]=g?g():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),k&&(this[y]=k(this[y],...p)),this[w])return;const a=this[d]+C;a<=Date.now()?(this[d]=Date.now(),f.apply(this,[this[y]]),this[y]=g?g():void 0):(this[w]=!0,this[v]=setTimeout(()=>{this[w]=!1,this[d]=Date.now(),f.apply(this,[this[y]]),this[y]=g?g():void 0},a-Date.now()))}})}e.throttle=R}),define(Z[13],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(c){setTimeout(()=>{throw c.stack?S.isErrorNoTelemetry(c)?new S(c.message+`

`+c.stack):new Error(c.message+`

`+c.stack):c},0)}}addListener(c){return this.b.push(c),()=>{this.d(c)}}c(c){this.b.forEach(i=>{i(c)})}d(c){this.b.splice(this.b.indexOf(c),1)}setUnexpectedErrorHandler(c){this.a=c}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(c){this.a(c),this.c(c)}onUnexpectedExternalError(c){this.a(c)}}e.ErrorHandler=E,e.errorHandler=new E;function M(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=M;function n(t){if(!t||typeof t!="object")return!1;const c=t;return c.code==="EPIPE"&&c.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=n;function R(t){f(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=R;function C(t){f(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function k(t){if(t instanceof Error){const{name:c,message:i}=t,r=t.stacktrace||t.stack;return{$isError:!0,name:c,message:i,stack:r,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const g="Canceled";function f(t){return t instanceof b?!0:t instanceof Error&&t.name===g&&t.message===g}e.isCancellationError=f;class b extends Error{constructor(){super(g),this.name=this.message}}e.CancellationError=b;function v(){const t=new Error(g);return t.name=t.message,t}e.canceled=v;function y(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=y;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function w(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function p(t){const c=new Error(`${t} has been disposed`);return c.name="DISPOSED",c}e.disposed=p;function a(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=a;class h extends Error{constructor(c){super("NotImplemented"),c&&(this.message=c)}}e.NotImplementedError=h;class m extends Error{constructor(c){super("NotSupported"),c&&(this.message=c)}}e.NotSupportedError=m;class I extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=I;class S extends Error{constructor(c){super(c),this.name="CodeExpectedError"}static fromError(c){if(c instanceof S)return c;const i=new S;return i.message=c.message,i.stack=c.stack,i}static isErrorNoTelemetry(c){return c.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class D extends Error{constructor(c){super(c||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(Z[25],_([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function M(j,K=0){return j[j.length-(1+K)]}e.tail=M;function n(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=n;function R(j,K,J=(re,de)=>re===de){if(j===K)return!0;if(!j||!K||j.length!==K.length)return!1;for(let re=0,de=j.length;re<de;re++)if(!J(j[re],K[re]))return!1;return!0}e.equals=R;function C(j,K){const J=j.length-1;K<J&&(j[K]=j[J]),j.pop()}e.removeFastWithoutKeepingOrder=C;function k(j,K,J){return g(j.length,re=>J(j[re],K))}e.binarySearch=k;function g(j,K){let J=0,re=j-1;for(;J<=re;){const de=(J+re)/2|0,Ce=K(de);if(Ce<0)J=de+1;else if(Ce>0)re=de-1;else return de}return-(J+1)}e.binarySearch2=g;function f(j,K){let J=0,re=j.length;if(re===0)return 0;for(;J<re;){const de=Math.floor((J+re)/2);K(j[de])?re=de:J=de+1}return J}e.findFirstInSorted=f;function b(j,K,J){if(j=j|0,j>=K.length)throw new TypeError("invalid index");const re=K[Math.floor(K.length*Math.random())],de=[],Ce=[],Re=[];for(const De of K){const Oe=J(De,re);Oe<0?de.push(De):Oe>0?Ce.push(De):Re.push(De)}return j<de.length?b(j,de,J):j<de.length+Re.length?Re[0]:b(j-(de.length+Re.length),Ce,J)}e.quickSelect=b;function v(j,K){const J=[];let re;for(const de of j.slice(0).sort(K))!re||K(re[0],de)!==0?(re=[de],J.push(re)):re.push(de);return J}e.groupBy=v;function y(j,K,J){const re=[];function de(De,Oe,$e){if(Oe===0&&$e.length===0)return;const fe=re[re.length-1];fe&&fe.start+fe.deleteCount===De?(fe.deleteCount+=Oe,fe.toInsert.push(...$e)):re.push({start:De,deleteCount:Oe,toInsert:$e})}let Ce=0,Re=0;for(;;){if(Ce===j.length){de(Ce,0,K.slice(Re));break}if(Re===K.length){de(Ce,j.length-Ce,[]);break}const De=j[Ce],Oe=K[Re],$e=J(De,Oe);$e===0?(Ce+=1,Re+=1):$e<0?(de(Ce,1,[]),Ce+=1):$e>0&&(de(Ce,0,[Oe]),Re+=1)}return re}e.sortedDiff=y;function d(j,K,J){const re=y(j,K,J),de=[],Ce=[];for(const Re of re)de.push(...j.slice(Re.start,Re.start+Re.deleteCount)),Ce.push(...Re.toInsert);return{removed:de,added:Ce}}e.delta=d;function w(j,K,J){if(J===0)return[];const re=j.slice(0,J).sort(K);return a(j,K,re,J,j.length),re}e.top=w;function p(j,K,J,re,de){return J===0?Promise.resolve([]):new Promise((Ce,Re)=>{(async()=>{const De=j.length,Oe=j.slice(0,J).sort(K);for(let $e=J,fe=Math.min(J+re,De);$e<De;$e=fe,fe=Math.min(fe+re,De)){if($e>J&&await new Promise(pe=>setTimeout(pe)),de&&de.isCancellationRequested)throw new E.CancellationError;a(j,K,Oe,$e,fe)}return Oe})().then(Ce,Re)})}e.topAsync=p;function a(j,K,J,re,de){for(const Ce=J.length;re<de;re++){const Re=j[re];if(K(Re,J[Ce-1])<0){J.pop();const De=f(J,Oe=>K(Re,Oe)<0);J.splice(De,0,Re)}}}function h(j){return j.filter(K=>!!K)}e.coalesce=h;function m(j){let K=0;for(let J=0;J<j.length;J++)j[J]&&(j[K]=j[J],K+=1);j.length=K}e.coalesceInPlace=m;function I(j,K,J){j.splice(J,0,j.splice(K,1)[0])}e.move=I;function S(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=S;function D(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=D;function t(j,K=J=>J){const J=new Set;return j.filter(re=>{const de=K(re);return J.has(de)?!1:(J.add(de),!0)})}e.distinct=t;function c(j){const K=new Set;return J=>{const re=j(J);return K.has(re)?!1:(K.add(re),!0)}}e.uniqueFilter=c;function i(j,K){const J=r(j,K);if(J!==-1)return j[J]}e.findLast=i;function r(j,K){for(let J=j.length-1;J>=0;J--){const re=j[J];if(K(re))return J}return-1}e.lastIndex=r;function o(j,K){return j.length>0?j[0]:K}e.firstOrDefault=o;function u(j,K){return j.length>0?j[j.length-1]:K}e.lastOrDefault=u;function s(j,K,J=(re,de)=>re===de){let re=0;for(let de=0,Ce=Math.min(j.length,K.length);de<Ce&&J(j[de],K[de]);de++)re++;return re}e.commonPrefixLength=s;function l(j){return[].concat(...j)}e.flatten=l;function P(j,K){let J=typeof K=="number"?j:0;typeof K=="number"?J=j:(J=0,K=j);const re=[];if(J<=K)for(let de=J;de<K;de++)re.push(de);else for(let de=J;de>K;de--)re.push(de);return re}e.range=P;function A(j,K,J){return j.reduce((re,de)=>(re[K(de)]=J?J(de):de,re),Object.create(null))}e.index=A;function O(j,K){return j.push(K),()=>N(j,K)}e.insert=O;function N(j,K){const J=j.indexOf(K);if(J>-1)return j.splice(J,1),K}e.remove=N;function z(j,K,J){const re=j.slice(0,K),de=j.slice(K);return re.concat(J,de)}e.arrayInsert=z;function H(j,K){let J;if(typeof K=="number"){let re=K;J=()=>{const de=Math.sin(re++)*179426549;return de-Math.floor(de)}}else J=Math.random;for(let re=j.length-1;re>0;re-=1){const de=Math.floor(J()*(re+1)),Ce=j[re];j[re]=j[de],j[de]=Ce}}e.shuffle=H;function ie(j,K){const J=j.indexOf(K);J>-1&&(j.splice(J,1),j.unshift(K))}e.pushToStart=ie;function se(j,K){const J=j.indexOf(K);J>-1&&(j.splice(J,1),j.push(K))}e.pushToEnd=se;function oe(j,K){for(const J of K)j.push(J)}e.pushMany=oe;function ue(j,K){return Array.isArray(j)?j.map(K):K(j)}e.mapArrayOrNot=ue;function le(j){return Array.isArray(j)?j:[j]}e.asArray=le;function me(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=me;function G(j,K){for(const J of j){const re=K(J);if(re!==void 0)return re}}e.mapFind=G;function B(j,K,J){const re=q(j,K),de=j.length,Ce=J.length;j.length=de+Ce;for(let Re=de-1;Re>=re;Re--)j[Re+Ce]=j[Re];for(let Re=0;Re<Ce;Re++)j[Re+re]=J[Re]}e.insertInto=B;function T(j,K,J,re){const de=q(j,K),Ce=j.splice(de,J);return B(j,de,re),Ce}e.splice=T;function q(j,K){return K<0?Math.max(K+j.length,0):Math.min(K,j.length)}var Y;(function(j){function K(de){return de<0}j.isLessThan=K;function J(de){return de>0}j.isGreaterThan=J;function re(de){return de===0}j.isNeitherLessOrGreaterThan=re,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(Y=e.CompareResult||(e.CompareResult={}));function te(j,K){return(J,re)=>K(j(J),j(re))}e.compareBy=te;function ne(...j){return(K,J)=>{for(const re of j){const de=re(K,J);if(!Y.isNeitherLessOrGreaterThan(de))return de}return Y.neitherLessOrGreaterThan}}e.tieBreakComparators=ne;const L=(j,K)=>j-K;e.numberComparator=L;function F(j,K){if(j.length===0)return;let J=j[0];for(let re=1;re<j.length;re++){const de=j[re];K(de,J)>0&&(J=de)}return J}e.findMaxBy=F;function U(j,K){if(j.length===0)return;let J=j[0];for(let re=1;re<j.length;re++){const de=j[re];K(de,J)>=0&&(J=de)}return J}e.findLastMaxBy=U;function W(j,K){return F(j,(J,re)=>-K(J,re))}e.findMinBy=W;class ${constructor(K){this.f=K,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(K){let J=this.c;for(;J<this.f.length&&K(this.f[J]);)J++;const re=J===this.c?null:this.f.slice(this.c,J);return this.c=J,re}takeFromEndWhile(K){let J=this.d;for(;J>=0&&K(this.f[J]);)J--;const re=J===this.d?null:this.f.slice(J+1,this.d+1);return this.d=J,re}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const K=this.f[this.c];return this.c++,K}removeLast(){const K=this.f[this.d];return this.d--,K}takeCount(K){const J=this.f.slice(this.c,this.c+K);return this.c+=K,J}}e.ArrayQueue=$;class V{constructor(K){this.iterate=K}forEach(K){this.iterate(J=>(K(J),!0))}toArray(){const K=[];return this.iterate(J=>(K.push(J),!0)),K}filter(K){return new V(J=>this.iterate(re=>K(re)?J(re):!0))}map(K){return new V(J=>this.iterate(re=>J(K(re))))}some(K){let J=!1;return this.iterate(re=>(J=K(re),!J)),J}findFirst(K){let J;return this.iterate(re=>K(re)?(J=re,!1):!0),J}findLast(K){let J;return this.iterate(re=>(K(re)&&(J=re),!0)),J}findLastMaxBy(K){let J,re=!0;return this.iterate(de=>((re||Y.isGreaterThan(K(de,J)))&&(re=!1,J=de),!0)),J}}V.empty=new V(j=>{}),e.CallbackIterable=V}),define(Z[127],_([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function M(g,f){if(!g)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}e.ok=M;function n(g,f="Unreachable"){throw new Error(f)}e.assertNever=n;function R(g){if(!g)throw new E.BugIndicatingError("Assertion Failed")}e.assert=R;function C(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function k(g,f){let b=0;for(;b<g.length-1;){const v=g[b],y=g[b+1];if(!f(v,y))return!1;b++}return!0}e.checkAdjacentItems=k}),define(Z[49],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(M){const n=this;let R=!1,C;return function(){return R||(R=!0,C=M.apply(n,arguments)),C}}e.once=E}),define(Z[70],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(M){function n(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=n;const R=Object.freeze([]);function C(){return R}M.empty=C;function*k(S){yield S}M.single=k;function g(S){return n(S)?S:k(S)}M.wrap=g;function f(S){return S||R}M.from=f;function b(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=b;function v(S){return S[Symbol.iterator]().next().value}M.first=v;function y(S,D){for(const t of S)if(D(t))return!0;return!1}M.some=y;function d(S,D){for(const t of S)if(D(t))return t}M.find=d;function*w(S,D){for(const t of S)D(t)&&(yield t)}M.filter=w;function*p(S,D){let t=0;for(const c of S)yield D(c,t++)}M.map=p;function*a(...S){for(const D of S)for(const t of D)yield t}M.concat=a;function h(S,D,t){let c=t;for(const i of S)c=D(c,i);return c}M.reduce=h;function*m(S,D,t=S.length){for(D<0&&(D+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);D<t;D++)yield S[D]}M.slice=m;function I(S,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,S];const c=S[Symbol.iterator]();for(let i=0;i<D;i++){const r=c.next();if(r.done)return[t,M.empty()];t.push(r.value)}return[t,{[Symbol.iterator](){return c}}]}M.consume=I})(E=e.Iterable||(e.Iterable={}))}),define(Z[43],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M=e.SyntaxKind||(e.SyntaxKind={}));var n;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(n=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function C(t,c=!1){let i=0;const r=t.length;let o="",u=0,s=16,l=0;function P(se){let oe=0,ue=0;for(;oe<se;){const le=t.charCodeAt(i);if(le>=48&&le<=57)ue=ue*16+le-48;else if(le>=65&&le<=70)ue=ue*16+le-65+10;else if(le>=97&&le<=102)ue=ue*16+le-97+10;else break;i++,oe++}return oe<se&&(ue=-1),ue}function A(se){i=se,o="",u=0,s=16,l=0}function O(){const se=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&f(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&f(t.charCodeAt(i)))for(i++;i<t.length&&f(t.charCodeAt(i));)i++;else return l=3,t.substring(se,i);let oe=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&f(t.charCodeAt(i))){for(i++;i<t.length&&f(t.charCodeAt(i));)i++;oe=i}else l=3;return t.substring(se,oe)}function N(){let se="",oe=i;for(;;){if(i>=r){se+=t.substring(oe,i),l=2;break}const ue=t.charCodeAt(i);if(ue===34){se+=t.substring(oe,i),i++;break}if(ue===92){if(se+=t.substring(oe,i),i++,i>=r){l=2;break}switch(t.charCodeAt(i++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const me=P(4);me>=0?se+=String.fromCharCode(me):l=4;break}default:l=5}oe=i;continue}if(ue>=0&&ue<=31)if(g(ue)){se+=t.substring(oe,i),l=2;break}else l=6;i++}return se}function z(){if(o="",l=0,u=i,i>=r)return u=r,s=17;let se=t.charCodeAt(i);if(k(se)){do i++,o+=String.fromCharCode(se),se=t.charCodeAt(i);while(k(se));return s=15}if(g(se))return i++,o+=String.fromCharCode(se),se===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),s=14;switch(se){case 123:return i++,s=1;case 125:return i++,s=2;case 91:return i++,s=3;case 93:return i++,s=4;case 58:return i++,s=6;case 44:return i++,s=5;case 34:return i++,o=N(),s=10;case 47:{const oe=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<r&&!g(t.charCodeAt(i));)i++;return o=t.substring(oe,i),s=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=r-1;let le=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,le=!0;break}i++}return le||(i++,l=1),o=t.substring(oe,i),s=13}return o+=String.fromCharCode(se),i++,s=16}case 45:if(o+=String.fromCharCode(se),i++,i===r||!f(t.charCodeAt(i)))return s=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),s=11;default:for(;i<r&&H(se);)i++,se=t.charCodeAt(i);if(u!==i){switch(o=t.substring(u,i),o){case"true":return s=8;case"false":return s=9;case"null":return s=7}return s=16}return o+=String.fromCharCode(se),i++,s=16}}function H(se){if(k(se)||g(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let se;do se=z();while(se>=12&&se<=15);return se}return{setPosition:A,getPosition:()=>i,scan:c?ie:z,getToken:()=>s,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>l}}e.createScanner=C;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function f(t){return t>=48&&t<=57}var b;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(b||(b={}));function v(t,c){const i=[],r=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function l(P,A,O,N){u.value=P,u.offset=A,u.length=O,u.type=N,u.colonOffset=void 0,o=u}try{I(t,{onObjectBegin:(P,A)=>{if(c<=P)throw r;o=void 0,s=c>P,i.push("")},onObjectProperty:(P,A,O)=>{if(c<A||(l(P,A,O,"property"),i[i.length-1]=P,c<=A+O))throw r},onObjectEnd:(P,A)=>{if(c<=P)throw r;o=void 0,i.pop()},onArrayBegin:(P,A)=>{if(c<=P)throw r;o=void 0,i.push(0)},onArrayEnd:(P,A)=>{if(c<=P)throw r;o=void 0,i.pop()},onLiteralValue:(P,A,O)=>{if(c<A||(l(P,A,O,D(P)),c<=A+O))throw r},onSeparator:(P,A,O)=>{if(c<=A)throw r;if(P===":"&&o&&o.type==="property")o.colonOffset=A,s=!1,o=void 0;else if(P===","){const N=i[i.length-1];typeof N=="number"?i[i.length-1]=N+1:(s=!0,i[i.length-1]=""),o=void 0}}})}catch(P){if(P!==r)throw P}return{path:i,previousNode:o,isAtPropertyKey:s,matches:P=>{let A=0;for(let O=0;A<P.length&&O<i.length;O++)if(P[A]===i[O]||P[A]==="*")A++;else if(P[A]!=="**")return!1;return A===P.length}}}e.getLocation=v;function y(t,c=[],i=R.DEFAULT){let r=null,o=[];const u=[];function s(P){Array.isArray(o)?o.push(P):r!==null&&(o[r]=P)}return I(t,{onObjectBegin:()=>{const P={};s(P),u.push(o),o=P,r=null},onObjectProperty:P=>{r=P},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const P=[];s(P),u.push(o),o=P,r=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:s,onError:(P,A,O)=>{c.push({error:P,offset:A,length:O})}},i),o[0]}e.parse=y;function d(t,c=[],i=R.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(P){r.type==="property"&&(r.length=P-r.offset,r=r.parent)}function u(P){return r.children.push(P),P}I(t,{onObjectBegin:P=>{r=u({type:"object",offset:P,length:-1,parent:r,children:[]})},onObjectProperty:(P,A,O)=>{r=u({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:P,offset:A,length:O,parent:r})},onObjectEnd:(P,A)=>{r.length=P+A-r.offset,r=r.parent,o(P+A)},onArrayBegin:(P,A)=>{r=u({type:"array",offset:P,length:-1,parent:r,children:[]})},onArrayEnd:(P,A)=>{r.length=P+A-r.offset,r=r.parent,o(P+A)},onLiteralValue:(P,A,O)=>{u({type:D(P),offset:A,length:O,parent:r,value:P}),o(A+O)},onSeparator:(P,A,O)=>{r.type==="property"&&(P===":"?r.colonOffset=A:P===","&&o(A))},onError:(P,A,O)=>{c.push({error:P,offset:A,length:O})}},i);const l=r.children[0];return l&&delete l.parent,l}e.parseTree=d;function w(t,c){if(!t)return;let i=t;for(const r of c)if(typeof r=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===r){i=u.children[1],o=!0;break}if(!o)return}else{const o=r;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=w;function p(t){if(!t.parent||!t.parent.children)return[];const c=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;c.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&c.push(i)}return c}e.getNodePath=p;function a(t){switch(t.type){case"array":return t.children.map(a);case"object":{const c=Object.create(null);for(const i of t.children){const r=i.children[1];r&&(c[i.children[0].value]=a(r))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=a;function h(t,c,i=!1){return c>=t.offset&&c<t.offset+t.length||i&&c===t.offset+t.length}e.contains=h;function m(t,c,i=!1){if(h(t,c,i)){const r=t.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=c;o++){const u=m(r[o],c,i);if(u)return u}return t}}e.findNodeAtOffset=m;function I(t,c,i=R.DEFAULT){const r=C(t,!1);function o(te){return te?()=>te(r.getTokenOffset(),r.getTokenLength()):()=>!0}function u(te){return te?ne=>te(ne,r.getTokenOffset(),r.getTokenLength()):()=>!0}const s=o(c.onObjectBegin),l=u(c.onObjectProperty),P=o(c.onObjectEnd),A=o(c.onArrayBegin),O=o(c.onArrayEnd),N=u(c.onLiteralValue),z=u(c.onSeparator),H=o(c.onComment),ie=u(c.onError),se=i&&i.disallowComments,oe=i&&i.allowTrailingComma;function ue(){for(;;){const te=r.scan();switch(r.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:se||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(te){case 12:case 13:se?le(10):H();break;case 16:le(1);break;case 15:case 14:break;default:return te}}}function le(te,ne=[],L=[]){if(ie(te),ne.length+L.length>0){let F=r.getToken();for(;F!==17;){if(ne.indexOf(F)!==-1){ue();break}else if(L.indexOf(F)!==-1)break;F=ue()}}}function me(te){const ne=r.getTokenValue();return te?N(ne):l(ne),ue(),!0}function G(){switch(r.getToken()){case 11:{let te=0;try{te=JSON.parse(r.getTokenValue()),typeof te!="number"&&(le(2),te=0)}catch{le(2)}N(te);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return ue(),!0}function B(){return r.getToken()!==10?(le(3,[],[2,5]),!1):(me(!1),r.getToken()===6?(z(":"),ue(),Y()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function T(){s(),ue();let te=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(te||le(4,[],[]),z(","),ue(),r.getToken()===2&&oe)break}else te&&le(6,[],[]);B()||le(4,[],[2,5]),te=!0}return P(),r.getToken()!==2?le(7,[2],[]):ue(),!0}function q(){A(),ue();let te=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(te||le(4,[],[]),z(","),ue(),r.getToken()===4&&oe)break}else te&&le(6,[],[]);Y()||le(4,[],[4,5]),te=!0}return O(),r.getToken()!==4?le(8,[4],[]):ue(),!0}function Y(){switch(r.getToken()){case 3:return q();case 1:return T();case 10:return me(!0);default:return G()}}return ue(),r.getToken()===17?i.allowEmptyContent?!0:(le(4,[],[]),!1):Y()?(r.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=I;function S(t,c){const i=C(t),r=[];let o,u=0,s;do switch(s=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:u!==s&&r.push(t.substring(u,s)),c!==void 0&&r.push(i.getTokenValue().replace(/[^\r\n]/g,c)),u=i.getPosition();break}while(o!==17);return r.join("")}e.stripComments=S;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(Z[128],_([0,1,43]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function M(f,b,v){let y,d,w,p,a;if(b){for(p=b.offset,a=p+b.length,w=p;w>0&&!g(f,w-1);)w--;let s=a;for(;s<f.length&&!g(f,s);)s++;d=f.substring(w,s),y=C(d,v)}else d=f,y=0,w=0,p=0,a=f.length;const h=k(v,f);let m=!1,I=0,S;v.insertSpaces?S=R(" ",v.tabSize||4):S="	";const D=(0,E.createScanner)(d,!1);let t=!1;function c(){return h+R(S,y+I)}function i(){let s=D.scan();for(m=!1;s===15||s===14;)m=m||s===14,s=D.scan();return t=s===16||D.getTokenError()!==0,s}const r=[];function o(s,l,P){!t&&l<a&&P>p&&f.substring(l,P)!==s&&r.push({offset:l,length:P-l,content:s})}let u=i();if(u!==17){const s=D.getTokenOffset()+w,l=R(S,y);o(l,w,s)}for(;u!==17;){let s=D.getTokenOffset()+D.getTokenLength()+w,l=i(),P="";for(;!m&&(l===12||l===13);){const O=D.getTokenOffset()+w;o(" ",s,O),s=D.getTokenOffset()+D.getTokenLength()+w,P=l===12?c():"",l=i()}if(l===2)u!==1&&(I--,P=c());else if(l===4)u!==3&&(I--,P=c());else{switch(u){case 3:case 1:I++,P=c();break;case 5:case 12:P=c();break;case 13:m?P=c():P=" ";break;case 6:P=" ";break;case 10:if(l===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?P=" ":l!==5&&l!==17&&(t=!0);break;case 16:t=!0;break}m&&(l===12||l===13)&&(P=c())}const A=D.getTokenOffset()+w;o(P,s,A),u=l}return r}e.format=M;function n(f,b){const v=JSON.stringify(f,void 0,b.insertSpaces?b.tabSize||4:"	");return b.eol!==void 0?v.replace(/\r\n|\r|\n/g,b.eol):v}e.toFormattedString=n;function R(f,b){let v="";for(let y=0;y<b;y++)v+=f;return v}function C(f,b){let v=0,y=0;const d=b.tabSize||4;for(;v<f.length;){const w=f.charAt(v);if(w===" ")y++;else if(w==="	")y+=d;else break;v++}return Math.floor(y/d)}function k(f,b){for(let v=0;v<b.length;v++){const y=b.charAt(v);if(y==="\r")return v+1<b.length&&b.charAt(v+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=k;function g(f,b){return`\r
`.indexOf(f.charAt(b))!==-1}e.isEOL=g}),define(Z[129],_([0,1,43,128]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function n(f,b,v){return R(f,b,void 0,v)}e.removeProperty=n;function R(f,b,v,y,d){const w=b.slice(),p=[],a=(0,E.parseTree)(f,p);let h,m;for(;w.length>0&&(m=w.pop(),h=(0,E.findNodeAtLocation)(a,w),h===void 0&&v!==void 0);)typeof m=="string"?v={[m]:v}:v=[v];if(h)if(h.type==="object"&&typeof m=="string"&&Array.isArray(h.children)){const I=(0,E.findNodeAtLocation)(h,[m]);if(I!==void 0)if(v===void 0){if(!I.parent)throw new Error("Malformed AST");const S=h.children.indexOf(I.parent);let D,t=I.parent.offset+I.parent.length;if(S>0){const c=h.children[S-1];D=c.offset+c.length}else D=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return C(f,{offset:D,length:t-D,content:""},y)}else return C(f,{offset:I.offset,length:I.length,content:JSON.stringify(v)},y);else{if(v===void 0)return[];const S=`${JSON.stringify(m)}: ${JSON.stringify(v)}`,D=d?d(h.children.map(c=>c.children[0].value)):h.children.length;let t;if(D>0){const c=h.children[D-1];t={offset:c.offset+c.length,length:0,content:","+S}}else h.children.length===0?t={offset:h.offset+1,length:0,content:S}:t={offset:h.offset+1,length:0,content:S+","};return C(f,t,y)}}else if(h.type==="array"&&typeof m=="number"&&Array.isArray(h.children))if(v!==void 0){const I=`${JSON.stringify(v)}`;let S;if(h.children.length===0||m===0)S={offset:h.offset+1,length:0,content:h.children.length===0?I:I+","};else{const D=m===-1||m>h.children.length?h.children.length:m,t=h.children[D-1];S={offset:t.offset+t.length,length:0,content:","+I}}return C(f,S,y)}else{const I=m,S=h.children[I];let D;if(h.children.length===1)D={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===I){const t=h.children[I-1],c=t.offset+t.length,i=h.offset+h.length;D={offset:c,length:i-2-c,content:""}}else D={offset:S.offset,length:h.children[I+1].offset-S.offset,content:""};return C(f,D,y)}else throw new Error(`Can not add ${typeof m!="number"?"index":"property"} to parent of type ${h.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return C(f,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(v)},y)}}e.setProperty=R;function C(f,b,v){let y=k(f,b),d=b.offset,w=b.offset+b.content.length;if(b.length===0||b.content.length===0){for(;d>0&&!(0,M.isEOL)(y,d-1);)d--;for(;w<y.length&&!(0,M.isEOL)(y,w);)w++}const p=(0,M.format)(y,{offset:d,length:w-d},v);for(let h=p.length-1;h>=0;h--){const m=p[h];y=k(y,m),d=Math.min(d,m.offset),w=Math.max(w,m.offset+m.length),w+=m.content.length-m.length}const a=f.length-(y.length-w)-d;return[{offset:d,length:a,content:y.substring(d,w)}]}e.withFormatting=C;function k(f,b){return f.substring(0,b.offset)+b.content+f.substring(b.offset+b.length)}e.applyEdit=k;function g(f,b){const v=b.slice(0).sort((d,w)=>{const p=d.offset-w.offset;return p===0?d.length-w.length:p});let y=f.length;for(let d=v.length-1;d>=0;d--){const w=v[d];if(w.offset+w.length<=y)f=k(f,w);else throw new Error("Overlapping edit");y=w.offset}return f}e.applyEdits=g}),define(Z[130],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(Z[2],_([0,1,49,70]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const n=!1;let R=null;function C(u){R=u}if(e.setDisposableTracker=C,n){const u="__is_disposable_tracked__";C(new class{trackDisposable(s){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[u]||console.log(l)},3e3)}setParent(s,l){if(s&&s!==m.None)try{s[u]=!0}catch{}}markAsDisposed(s){if(s&&s!==m.None)try{s[u]=!0}catch{}}markAsSingleton(s){}})}function k(u){return R?.trackDisposable(u),u}function g(u){R?.markAsDisposed(u)}function f(u,s){R?.setParent(u,s)}function b(u,s){if(!!R)for(const l of u)R.setParent(l,s)}function v(u){return R?.markAsSingleton(u),u}e.markAsSingleton=v;function y(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=y;function d(u){if(M.Iterable.is(u)){const s=[];for(const l of u)if(l)try{l.dispose()}catch(P){s.push(P)}if(s.length===1)throw s[0];if(s.length>1)throw new AggregateError(s,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=d;function w(u){for(const s of u)y(s)&&s.dispose();return[]}e.disposeIfDisposable=w;function p(...u){const s=a(()=>d(u));return b(u,s),s}e.combinedDisposable=p;function a(u){const s=k({dispose:(0,E.once)(()=>{g(s),u()})});return s}e.toDisposable=a;class h{constructor(){this.c=new Set,this.f=!1,k(this)}dispose(){this.f||(g(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return f(s,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(s),s}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class m{constructor(){this.q=new h,k(this),f(this.q,this)}dispose(){g(this),this.q.dispose()}B(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(s)}}m.None=Object.freeze({dispose(){}}),e.Disposable=m;class I{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(s){this.b||s===this.a||(this.a?.dispose(),s&&f(s,this),this.a=s)}clear(){this.value=void 0}dispose(){this.b=!0,g(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const s=this.a;return this.a=void 0,s&&f(s,null),s}}e.MutableDisposable=I;class S{constructor(s){this.b=s,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(s){let l=s;return this.unset=()=>l=void 0,this.isset=()=>l!==void 0,this.dispose=()=>{l&&(l(),l=void 0,g(this))},this}}e.SafeDisposable=D;class t{constructor(){this.a=new Map}acquire(s,...l){let P=this.a.get(s);P||(P={counter:0,object:this.b(s,...l)},this.a.set(s,P));const{object:A}=P,O=(0,E.once)(()=>{--P.counter===0&&(this.c(s,P.object),this.a.delete(s))});return P.counter++,{object:A,dispose:O}}}e.ReferenceCollection=t;class c{constructor(s){this.a=s}async acquire(s,...l){const P=this.a.acquire(s,...l);try{return{object:await P.object,dispose:()=>P.dispose()}}catch(A){throw P.dispose(),A}}}e.AsyncReferenceCollection=c;class i{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=i;function r(u){const s=new h;try{u(s)}finally{s.dispose()}}e.disposeOnReturn=r;class o{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){g(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(s){return this.a.has(s)}get(s){return this.a.get(s)}set(s,l,P=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),P||this.a.get(s)?.dispose(),this.a.set(s,l)}deleteAndDispose(s){this.a.get(s)?.dispose(),this.a.delete(s)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(Z[98],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let R=this.a;for(;R!==E.Undefined;){const C=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=C}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,C){const k=new E(R);if(this.a===E.Undefined)this.a=k,this.b=k;else if(C){const f=this.b;this.b=k,k.prev=f,f.next=k}else{const f=this.a;this.a=k,k.next=f,f.prev=k}this.c+=1;let g=!1;return()=>{g||(g=!0,this.e(k))}}shift(){if(this.a!==E.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==E.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const C=R.prev;C.next=R.next,R.next.prev=C}else R.prev===E.Undefined&&R.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):R.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):R.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=M}),define(Z[35],_([0,1]),function(x,e){"use strict";var E,M,n;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(w,p,a){let h=w.get(p);return h===void 0&&(h=a,w.set(p,h)),h}e.getOrSet=R;function C(w){const p=[];return w.forEach((a,h)=>{p.push(`${h} => ${a}`)}),`Map(${w.size}) {${p.join(", ")}}`}e.mapToString=C;function k(w){const p=[];return w.forEach(a=>{p.push(a)}),`Set(${w.size}) {${p.join(", ")}}`}e.setToString=k;class g{constructor(p,a){this.uri=p,this.value=a}}class f{constructor(p,a){this[E]="ResourceMap",p instanceof f?(this.b=new Map(p.b),this.c=a??f.a):(this.b=new Map,this.c=p??f.a)}set(p,a){return this.b.set(this.c(p),new g(p,a)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,a){typeof a<"u"&&(p=p.bind(a));for(const[h,m]of this.b)p(m.value,m.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}f.a=w=>w.toString(),e.ResourceMap=f;class b{constructor(p,a){this[M]="ResourceSet",!p||typeof p=="function"?this.a=new f(p):(this.a=new f(a),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,a){this.a.forEach((h,m)=>p.call(a,m,m,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=b;var v;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(v=e.Touch||(e.Touch={}));class y{constructor(){this[n]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,a=0){const h=this.a.get(p);if(!!h)return a!==0&&this.j(h,a),h.value}set(p,a,h=0){let m=this.a.get(p);if(m)m.value=a,h!==0&&this.j(m,h);else{switch(m={key:p,value:a,next:void 0,previous:void 0},h){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(p,m),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const a=this.a.get(p);if(!!a)return this.a.delete(p),this.i(a),this.d--,a.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,a){const h=this.e;let m=this.b;for(;m;){if(a?p.bind(a)(m.value,m.key,this):p(m.value,m.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const p=this,a=this.e;let h=this.b;const m={[Symbol.iterator](){return m},next(){if(p.e!==a)throw new Error("LinkedMap got modified during iteration.");if(h){const I={value:h.key,done:!1};return h=h.next,I}else return{value:void 0,done:!0}}};return m}values(){const p=this,a=this.e;let h=this.b;const m={[Symbol.iterator](){return m},next(){if(p.e!==a)throw new Error("LinkedMap got modified during iteration.");if(h){const I={value:h.value,done:!1};return h=h.next,I}else return{value:void 0,done:!0}}};return m}entries(){const p=this,a=this.e;let h=this.b;const m={[Symbol.iterator](){return m},next(){if(p.e!==a)throw new Error("LinkedMap got modified during iteration.");if(h){const I={value:[h.key,h.value],done:!1};return h=h.next,I}else return{value:void 0,done:!0}}};return m}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let a=this.b,h=this.size;for(;a&&h>p;)this.a.delete(a.key),a=a.next,h--;this.b=a,this.d=h,a&&(a.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const a=p.next,h=p.previous;if(!a||!h)throw new Error("Invalid list");a.previous=h,h.next=a}p.next=void 0,p.previous=void 0,this.e++}j(p,a){if(!this.b||!this.c)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(p===this.b)return;const h=p.next,m=p.previous;p===this.c?(m.next=void 0,this.c=m):(h.previous=m,m.next=h),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(a===2){if(p===this.c)return;const h=p.next,m=p.previous;p===this.b?(h.previous=void 0,this.b=h):(h.previous=m,m.next=h),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((a,h)=>{p.push([h,a])}),p}fromJSON(p){this.clear();for(const[a,h]of p)this.set(a,h)}}e.LinkedMap=y;class d extends y{constructor(p,a=1){super(),this.k=p,this.l=Math.min(Math.max(0,a),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,a=2){return super.get(p,a)}peek(p){return super.get(p,0)}set(p,a){return super.set(p,a,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d}),define(Z[80],_([0,1,35]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new E.LRUCache(1e4);function n(f){return g(f,"NFC",M)}e.normalizeNFC=n;const R=new E.LRUCache(1e4);function C(f){return g(f,"NFD",R)}e.normalizeNFD=C;const k=/[^\u0000-\u0080]/;function g(f,b,v){if(!f)return f;const y=v.get(f);if(y)return y;let d;return k.test(f)?d=f.normalize(b):d=f,v.set(f,d),d}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(b){return C(b).replace(f,"")}}()}),define(Z[131],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(k,g,f){return Math.min(Math.max(k,g),f)}e.clamp=E;function M(k,g){return(g+k%g)%g}e.rot=M;class n{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=n;class R{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class C{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const f=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function x(n){const R=[];typeof n=="number"&&R.push("code/timeOrigin",n);function C(g){R.push(g,Date.now())}function k(){const g=[];for(let f=0;f<R.length;f+=2)g.push({name:R[f],startTime:R[f+1]});return g}return{mark:C,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(n){performance.mark(n)},getMarks(){let n=performance.timeOrigin;typeof n!="number"&&(n=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(n)}];for(const C of performance.getEntriesByType("mark"))R.push({name:C.name,startTime:Math.round(n+C.startTime)});return R}};if(typeof process=="object"){const n=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(n)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function E(n){return n.MonacoPerformanceMarks||(n.MonacoPerformanceMarks=e()),n.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=E(M))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var M in E)(typeof exports=="object"?exports:x)[M]=E[M]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function E(M){if(e[M])return e[M].exports;var n=e[M]={i:M,l:!1,exports:{}};return x[M].call(n.exports,n,n.exports,E),n.l=!0,n.exports}return E.m=x,E.c=e,E.d=function(M,n,R){E.o(M,n)||Object.defineProperty(M,n,{enumerable:!0,get:R})},E.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},E.t=function(M,n){if(1&n&&(M=E(M)),8&n||4&n&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(E.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&n&&typeof M!="string")for(var C in M)E.d(R,C,function(k){return M[k]}.bind(null,C));return R},E.n=function(M){var n=M&&M.__esModule?function(){return M.default}:function(){return M};return E.d(n,"a",n),n},E.o=function(M,n){return Object.prototype.hasOwnProperty.call(M,n)},E.p="",E(E.s=0)}([function(x,e,E){(function(M){var n;e=x.exports=L,n=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],g=e.src=[],f=0,b=f++;g[b]="0|[1-9]\\d*";var v=f++;g[v]="[0-9]+";var y=f++;g[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=f++;g[d]="("+g[b]+")\\.("+g[b]+")\\.("+g[b]+")";var w=f++;g[w]="("+g[v]+")\\.("+g[v]+")\\.("+g[v]+")";var p=f++;g[p]="(?:"+g[b]+"|"+g[y]+")";var a=f++;g[a]="(?:"+g[v]+"|"+g[y]+")";var h=f++;g[h]="(?:-("+g[p]+"(?:\\."+g[p]+")*))";var m=f++;g[m]="(?:-?("+g[a]+"(?:\\."+g[a]+")*))";var I=f++;g[I]="[0-9A-Za-z-]+";var S=f++;g[S]="(?:\\+("+g[I]+"(?:\\."+g[I]+")*))";var D=f++,t="v?"+g[d]+g[h]+"?"+g[S]+"?";g[D]="^"+t+"$";var c="[v=\\s]*"+g[w]+g[m]+"?"+g[S]+"?",i=f++;g[i]="^"+c+"$";var r=f++;g[r]="((?:<|>)?=?)";var o=f++;g[o]=g[v]+"|x|X|\\*";var u=f++;g[u]=g[b]+"|x|X|\\*";var s=f++;g[s]="[v=\\s]*("+g[u]+")(?:\\.("+g[u]+")(?:\\.("+g[u]+")(?:"+g[h]+")?"+g[S]+"?)?)?";var l=f++;g[l]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[m]+")?"+g[S]+"?)?)?";var P=f++;g[P]="^"+g[r]+"\\s*"+g[s]+"$";var A=f++;g[A]="^"+g[r]+"\\s*"+g[l]+"$";var O=f++;g[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=f++;g[N]="(?:~>?)";var z=f++;g[z]="(\\s*)"+g[N]+"\\s+",k[z]=new RegExp(g[z],"g");var H=f++;g[H]="^"+g[N]+g[s]+"$";var ie=f++;g[ie]="^"+g[N]+g[l]+"$";var se=f++;g[se]="(?:\\^)";var oe=f++;g[oe]="(\\s*)"+g[se]+"\\s+",k[oe]=new RegExp(g[oe],"g");var ue=f++;g[ue]="^"+g[se]+g[s]+"$";var le=f++;g[le]="^"+g[se]+g[l]+"$";var me=f++;g[me]="^"+g[r]+"\\s*("+c+")$|^$";var G=f++;g[G]="^"+g[r]+"\\s*("+t+")$|^$";var B=f++;g[B]="(\\s*)"+g[r]+"\\s*("+c+"|"+g[s]+")",k[B]=new RegExp(g[B],"g");var T=f++;g[T]="^\\s*("+g[s]+")\\s+-\\s+("+g[s]+")\\s*$";var q=f++;g[q]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var Y=f++;g[Y]="(<|>)?=?\\s*\\*";for(var te=0;te<35;te++)n(te,g[te]),k[te]||(k[te]=new RegExp(g[te]));function ne(ee,ce){if(ee instanceof L)return ee;if(typeof ee!="string"||ee.length>R||!(ce?k[i]:k[D]).test(ee))return null;try{return new L(ee,ce)}catch{return null}}function L(ee,ce){if(ee instanceof L){if(ee.loose===ce)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof L))return new L(ee,ce);n("SemVer",ee,ce),this.loose=ce;var he=ee.trim().match(ce?k[i]:k[D]);if(!he)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Ae=+Ie;if(Ae>=0&&Ae<C)return Ae}return Ie}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=ne,e.valid=function(ee,ce){var he=ne(ee,ce);return he?he.version:null},e.clean=function(ee,ce){var he=ne(ee.trim().replace(/^[=v]+/,""),ce);return he?he.version:null},e.SemVer=L,L.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},L.prototype.toString=function(){return this.version},L.prototype.compare=function(ee){return n("SemVer.compare",this.version,this.loose,ee),ee instanceof L||(ee=new L(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},L.prototype.compareMain=function(ee){return ee instanceof L||(ee=new L(ee,this.loose)),U(this.major,ee.major)||U(this.minor,ee.minor)||U(this.patch,ee.patch)},L.prototype.comparePre=function(ee){if(ee instanceof L||(ee=new L(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var ce=0;do{var he=this.prerelease[ce],Ie=ee.prerelease[ce];if(n("prerelease compare",ce,he,Ie),he===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(he===void 0)return-1;if(he!==Ie)return U(he,Ie)}while(++ce)},L.prototype.inc=function(ee,ce){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,ce,he,Ie){typeof he=="string"&&(Ie=he,he=void 0);try{return new L(ee,he).inc(ce,Ie).version}catch{return null}},e.diff=function(ee,ce){if(j(ee,ce))return null;var he=ne(ee),Ie=ne(ce);if(he.prerelease.length||Ie.prerelease.length){for(var Ae in he)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&he[Ae]!==Ie[Ae])return"pre"+Ae;return"prerelease"}for(var Ae in he)if((Ae==="major"||Ae==="minor"||Ae==="patch")&&he[Ae]!==Ie[Ae])return Ae},e.compareIdentifiers=U;var F=/^[0-9]+$/;function U(ee,ce){var he=F.test(ee),Ie=F.test(ce);return he&&Ie&&(ee=+ee,ce=+ce),he&&!Ie?-1:Ie&&!he?1:ee<ce?-1:ee>ce?1:0}function W(ee,ce,he){return new L(ee,he).compare(new L(ce,he))}function $(ee,ce,he){return W(ee,ce,he)>0}function V(ee,ce,he){return W(ee,ce,he)<0}function j(ee,ce,he){return W(ee,ce,he)===0}function K(ee,ce,he){return W(ee,ce,he)!==0}function J(ee,ce,he){return W(ee,ce,he)>=0}function re(ee,ce,he){return W(ee,ce,he)<=0}function de(ee,ce,he,Ie){var Ae;switch(ce){case"===":typeof ee=="object"&&(ee=ee.version),typeof he=="object"&&(he=he.version),Ae=ee===he;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof he=="object"&&(he=he.version),Ae=ee!==he;break;case"":case"=":case"==":Ae=j(ee,he,Ie);break;case"!=":Ae=K(ee,he,Ie);break;case">":Ae=$(ee,he,Ie);break;case">=":Ae=J(ee,he,Ie);break;case"<":Ae=V(ee,he,Ie);break;case"<=":Ae=re(ee,he,Ie);break;default:throw new TypeError("Invalid operator: "+ce)}return Ae}function Ce(ee,ce){if(ee instanceof Ce){if(ee.loose===ce)return ee;ee=ee.value}if(!(this instanceof Ce))return new Ce(ee,ce);n("comparator",ee,ce),this.loose=ce,this.parse(ee),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,n("comp",this)}e.rcompareIdentifiers=function(ee,ce){return U(ce,ee)},e.major=function(ee,ce){return new L(ee,ce).major},e.minor=function(ee,ce){return new L(ee,ce).minor},e.patch=function(ee,ce){return new L(ee,ce).patch},e.compare=W,e.compareLoose=function(ee,ce){return W(ee,ce,!0)},e.rcompare=function(ee,ce,he){return W(ce,ee,he)},e.sort=function(ee,ce){return ee.sort(function(he,Ie){return e.compare(he,Ie,ce)})},e.rsort=function(ee,ce){return ee.sort(function(he,Ie){return e.rcompare(he,Ie,ce)})},e.gt=$,e.lt=V,e.eq=j,e.neq=K,e.gte=J,e.lte=re,e.cmp=de,e.Comparator=Ce;var Re={};function De(ee,ce){if(ee instanceof De)return ee.loose===ce?ee:new De(ee.raw,ce);if(ee instanceof Ce)return new De(ee.value,ce);if(!(this instanceof De))return new De(ee,ce);if(this.loose=ce,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function Oe(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function $e(ee,ce,he,Ie,Ae,Te,Fe,je,ze,Ue,He,X,ae){return((ce=Oe(he)?"":Oe(Ie)?">="+he+".0.0":Oe(Ae)?">="+he+"."+Ie+".0":">="+ce)+" "+(je=Oe(ze)?"":Oe(Ue)?"<"+(+ze+1)+".0.0":Oe(He)?"<"+ze+"."+(+Ue+1)+".0":X?"<="+ze+"."+Ue+"."+He+"-"+X:"<="+je)).trim()}function fe(ee,ce){for(var he=0;he<ee.length;he++)if(!ee[he].test(ce))return!1;if(ce.prerelease.length){for(he=0;he<ee.length;he++)if(n(ee[he].semver),ee[he].semver!==Re&&ee[he].semver.prerelease.length>0){var Ie=ee[he].semver;if(Ie.major===ce.major&&Ie.minor===ce.minor&&Ie.patch===ce.patch)return!0}return!1}return!0}function pe(ee,ce,he){try{ce=new De(ce,he)}catch{return!1}return ce.test(ee)}function Me(ee,ce,he,Ie){var Ae,Te,Fe,je,ze;switch(ee=new L(ee,Ie),ce=new De(ce,Ie),he){case">":Ae=$,Te=re,Fe=V,je=">",ze=">=";break;case"<":Ae=V,Te=J,Fe=$,je="<",ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(pe(ee,ce,Ie))return!1;for(var Ue=0;Ue<ce.set.length;++Ue){var He=ce.set[Ue],X=null,ae=null;if(He.forEach(function(ge){ge.semver===Re&&(ge=new Ce(">=0.0.0")),X=X||ge,ae=ae||ge,Ae(ge.semver,X.semver,Ie)?X=ge:Fe(ge.semver,ae.semver,Ie)&&(ae=ge)}),X.operator===je||X.operator===ze||(!ae.operator||ae.operator===je)&&Te(ee,ae.semver)||ae.operator===ze&&Fe(ee,ae.semver))return!1}return!0}Ce.prototype.parse=function(ee){var ce=this.loose?k[me]:k[G],he=ee.match(ce);if(!he)throw new TypeError("Invalid comparator: "+ee);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new L(he[2],this.loose):this.semver=Re},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(ee){return n("Comparator.test",ee,this.loose),this.semver===Re||(typeof ee=="string"&&(ee=new L(ee,this.loose)),de(ee,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(ee,ce){if(!(ee instanceof Ce))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new De(ee.value,ce),pe(this.value,he,ce);if(ee.operator==="")return he=new De(this.value,ce),pe(ee.semver,he,ce);var Ie=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Ae=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),Te=this.semver.version===ee.semver.version,Fe=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),je=de(this.semver,"<",ee.semver,ce)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),ze=de(this.semver,">",ee.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ie||Ae||Te&&Fe||je||ze},e.Range=De,De.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},De.prototype.toString=function(){return this.range},De.prototype.parseRange=function(ee){var ce=this.loose;ee=ee.trim(),n("range",ee,ce);var he=ce?k[q]:k[T];ee=ee.replace(he,$e),n("hyphen replace",ee),ee=ee.replace(k[B],"$1$2$3"),n("comparator trim",ee,k[B]),ee=(ee=(ee=ee.replace(k[z],"$1~")).replace(k[oe],"$1^")).split(/\s+/).join(" ");var Ie=ce?k[me]:k[G],Ae=ee.split(" ").map(function(Te){return function(Fe,je){return n("comp",Fe),Fe=function(ze,Ue){return ze.trim().split(/\s+/).map(function(He){return function(X,ae){n("caret",X,ae);var ge=ae?k[le]:k[ue];return X.replace(ge,function(be,we,Le,We,Ve){var Ge;return n("caret",X,be,we,Le,We,Ve),Oe(we)?Ge="":Oe(Le)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(We)?Ge=we==="0"?">="+we+"."+Le+".0 <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+".0 <"+(+we+1)+".0.0":Ve?(n("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=we==="0"?Le==="0"?">="+we+"."+Le+"."+We+Ve+" <"+we+"."+Le+"."+(+We+1):">="+we+"."+Le+"."+We+Ve+" <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+"."+We+Ve+" <"+(+we+1)+".0.0"):(n("no pr"),Ge=we==="0"?Le==="0"?">="+we+"."+Le+"."+We+" <"+we+"."+Le+"."+(+We+1):">="+we+"."+Le+"."+We+" <"+we+"."+(+Le+1)+".0":">="+we+"."+Le+"."+We+" <"+(+we+1)+".0.0"),n("caret return",Ge),Ge})}(He,Ue)}).join(" ")}(Fe,je),n("caret",Fe),Fe=function(ze,Ue){return ze.trim().split(/\s+/).map(function(He){return function(X,ae){var ge=ae?k[ie]:k[H];return X.replace(ge,function(be,we,Le,We,Ve){var Ge;return n("tilde",X,be,we,Le,We,Ve),Oe(we)?Ge="":Oe(Le)?Ge=">="+we+".0.0 <"+(+we+1)+".0.0":Oe(We)?Ge=">="+we+"."+Le+".0 <"+we+"."+(+Le+1)+".0":Ve?(n("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Ge=">="+we+"."+Le+"."+We+Ve+" <"+we+"."+(+Le+1)+".0"):Ge=">="+we+"."+Le+"."+We+" <"+we+"."+(+Le+1)+".0",n("tilde return",Ge),Ge})}(He,Ue)}).join(" ")}(Fe,je),n("tildes",Fe),Fe=function(ze,Ue){return n("replaceXRanges",ze,Ue),ze.split(/\s+/).map(function(He){return function(X,ae){X=X.trim();var ge=ae?k[A]:k[P];return X.replace(ge,function(be,we,Le,We,Ve,Ge){n("xRange",X,be,we,Le,We,Ve,Ge);var Ke=Oe(Le),Ye=Ke||Oe(We),Ze=Ye||Oe(Ve);return we==="="&&Ze&&(we=""),Ke?be=we===">"||we==="<"?"<0.0.0":"*":we&&Ze?(Ye&&(We=0),Ze&&(Ve=0),we===">"?(we=">=",Ye?(Le=+Le+1,We=0,Ve=0):Ze&&(We=+We+1,Ve=0)):we==="<="&&(we="<",Ye?Le=+Le+1:We=+We+1),be=we+Le+"."+We+"."+Ve):Ye?be=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ze&&(be=">="+Le+"."+We+".0 <"+Le+"."+(+We+1)+".0"),n("xRange return",be),be})}(He,Ue)}).join(" ")}(Fe,je),n("xrange",Fe),Fe=function(ze,Ue){return n("replaceStars",ze,Ue),ze.trim().replace(k[Y],"")}(Fe,je),n("stars",Fe),Fe}(Te,ce)}).join(" ").split(/\s+/);return this.loose&&(Ae=Ae.filter(function(Te){return!!Te.match(Ie)})),Ae=Ae.map(function(Te){return new Ce(Te,ce)})},De.prototype.intersects=function(ee,ce){if(!(ee instanceof De))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ie){return ee.set.some(function(Ae){return Ae.every(function(Te){return Ie.intersects(Te,ce)})})})})},e.toComparators=function(ee,ce){return new De(ee,ce).set.map(function(he){return he.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},De.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new L(ee,this.loose));for(var ce=0;ce<this.set.length;ce++)if(fe(this.set[ce],ee))return!0;return!1},e.satisfies=pe,e.maxSatisfying=function(ee,ce,he){var Ie=null,Ae=null;try{var Te=new De(ce,he)}catch{return null}return ee.forEach(function(Fe){Te.test(Fe)&&(Ie&&Ae.compare(Fe)!==-1||(Ae=new L(Ie=Fe,he)))}),Ie},e.minSatisfying=function(ee,ce,he){var Ie=null,Ae=null;try{var Te=new De(ce,he)}catch{return null}return ee.forEach(function(Fe){Te.test(Fe)&&(Ie&&Ae.compare(Fe)!==1||(Ae=new L(Ie=Fe,he)))}),Ie},e.validRange=function(ee,ce){try{return new De(ee,ce).range||"*"}catch{return null}},e.ltr=function(ee,ce,he){return Me(ee,ce,"<",he)},e.gtr=function(ee,ce,he){return Me(ee,ce,">",he)},e.outside=Me,e.prerelease=function(ee,ce){var he=ne(ee,ce);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(ee,ce,he){return ee=new De(ee,he),ce=new De(ce,he),ee.intersects(ce)},e.coerce=function(ee){if(ee instanceof L)return ee;if(typeof ee!="string")return null;var ce=ee.match(k[O]);return ce==null?null:ne((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,E(1))},function(x,e){var E,M,n=x.exports={};function R(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function k(a){if(E===setTimeout)return setTimeout(a,0);if((E===R||!E)&&setTimeout)return E=setTimeout,setTimeout(a,0);try{return E(a,0)}catch{try{return E.call(null,a,0)}catch{return E.call(this,a,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:R}catch{E=R}try{M=typeof clearTimeout=="function"?clearTimeout:C}catch{M=C}})();var g,f=[],b=!1,v=-1;function y(){b&&g&&(b=!1,g.length?f=g.concat(f):v=-1,f.length&&d())}function d(){if(!b){var a=k(y);b=!0;for(var h=f.length;h;){for(g=f,f=[];++v<h;)g&&g[v].run();v=-1,h=f.length}g=null,b=!1,function(m){if(M===clearTimeout)return clearTimeout(m);if((M===C||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(m);try{M(m)}catch{try{return M.call(null,m)}catch{return M.call(this,m)}}}(a)}}function w(a,h){this.fun=a,this.array=h}function p(){}n.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var m=1;m<arguments.length;m++)h[m-1]=arguments[m];f.push(new w(a,h)),f.length!==1||b||k(d)},w.prototype.run=function(){this.fun.apply(null,this.array)},n.title="browser",n.browser=!0,n.env={},n.argv=[],n.version="",n.versions={},n.on=p,n.addListener=p,n.once=p,n.off=p,n.removeListener=p,n.removeAllListeners=p,n.emit=p,n.prependListener=p,n.prependOnceListener=p,n.listeners=function(a){return[]},n.binding=function(a){throw new Error("process.binding is not supported")},n.cwd=function(){return"/"},n.chdir=function(a){throw new Error("process.chdir is not supported")},n.umask=function(){return 0}}])}),define(Z[132],_([0,1]),function(x,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,g,f){this.level=k,this.key=g,this.value=f,this.forward=[]}}const n=void 0;class R{constructor(k,g=2**16){this.comparator=k,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new M(this.c,n,n)}get size(){return this.f}clear(){this.e=new M(this.c,n,n)}has(k){return Boolean(R.g(this,k,this.comparator))}get(k){return R.g(this,k,this.comparator)?.value}set(k,g){return R.h(this,k,g,this.comparator)&&(this.f+=1),this}delete(k){const g=R.k(this,k,this.comparator);return g&&(this.f-=1),g}forEach(k,g){let f=this.e.forward[0];for(;f;)k.call(g,f.value,f.key,this),f=f.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",g=this.e.forward[0];for(;g;)k+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return k}static g(k,g,f){let b=k.e;for(let v=k.d-1;v>=0;v--)for(;b.forward[v]&&f(b.forward[v].key,g)<0;)b=b.forward[v];if(b=b.forward[0],b&&f(b.key,g)===0)return b}static h(k,g,f,b){const v=[];let y=k.e;for(let d=k.d-1;d>=0;d--){for(;y.forward[d]&&b(y.forward[d].key,g)<0;)y=y.forward[d];v[d]=y}if(y=y.forward[0],y&&b(y.key,g)===0)return y.value=f,!1;{const d=R.j(k);if(d>k.d){for(let w=k.d;w<d;w++)v[w]=k.e;k.d=d}y=new M(d,g,f);for(let w=0;w<d;w++)y.forward[w]=v[w].forward[w],v[w].forward[w]=y;return!0}}static j(k,g=.5){let f=1;for(;Math.random()<g&&f<k.c;)f+=1;return f}static k(k,g,f){const b=[];let v=k.e;for(let y=k.d-1;y>=0;y--){for(;v.forward[y]&&f(v.forward[y].key,g)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],!v||f(v.key,g)!==0)return!1;for(let y=0;y<k.d&&b[y].forward[y]===v;y++)b[y].forward[y]=v.forward[y];for(;k.d>0&&k.e.forward[k.d-1]===n;)k.d-=1;return!0}}e.SkipList=R}),define(Z[59],_([0,1,13,2]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function n(S){const D=S;return D?typeof D.read=="function":!1}e.isReadable=n;function R(S){const D=S;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=R;function C(S){const D=S;return D?R(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=C;function k(S,D){return new g(S,D)}e.newWriteableStream=k;class g{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,E.onUnexpectedError)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let c;switch(D){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const i=c.indexOf(t);i>=0&&c.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(S,D){const t=[];let c;for(;(c=S.read())!==null;)t.push(c);return D(t)}e.consumeReadable=f;function b(S,D,t){const c=[];let i;for(;(i=S.read())!==null&&c.length<t;)c.push(i);return i===null&&c.length>0?D(c):{read:()=>{if(c.length>0)return c.shift();if(typeof i<"u"){const r=i;return i=void 0,r}return S.read()}}}e.peekReadable=b;function v(S,D){return new Promise((t,c)=>{const i=[];y(S,{onData:r=>{D&&i.push(r)},onError:r=>{D?c(r):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=v;function y(S,D){let t=!1;return S.on("error",c=>{t||D.onError(c)}),S.on("end",()=>{t||D.onEnd()}),S.on("data",c=>{t||D.onData(c)}),(0,M.toDisposable)(()=>t=!0)}e.listenStream=y;function d(S,D){return new Promise((t,c)=>{const i=new M.DisposableStore,r=[],o=l=>{if(r.push(l),r.length>D)return i.dispose(),S.pause(),t({stream:S,buffer:r,ended:!1})},u=l=>c(l),s=()=>t({stream:S,buffer:r,ended:!0});i.add((0,M.toDisposable)(()=>S.removeListener("error",u))),S.on("error",u),i.add((0,M.toDisposable)(()=>S.removeListener("end",s))),S.on("end",s),i.add((0,M.toDisposable)(()=>S.removeListener("data",o))),S.on("data",o)})}e.peekStream=d;function w(S,D){const t=k(D);return t.end(S),t}e.toStream=w;function p(){const S=k(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=p;function a(S){let D=!1;return{read:()=>D?null:(D=!0,S)}}e.toReadable=a;function h(S,D,t){const c=k(t);return y(S,{onData:i=>c.write(D.data(i)),onError:i=>c.error(D.error?D.error(i):i),onEnd:()=>c.end()}),c}e.transform=h;function m(S,D,t){let c=!1;return{read:()=>{const i=D.read();return c?i:(c=!0,i!==null?t([S,i]):S)}}}e.prefixedReadable=m;function I(S,D,t){let c=!1;const i=k(t);return y(D,{onData:r=>c?i.write(r):(c=!0,i.write(t([S,r]))),onError:r=>i.error(r),onEnd:()=>{c||(c=!0,i.write(S)),i.end()}}),i}e.prefixedStream=I}),define(Z[17],_([0,1,59]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer<"u";let n,R;class C{static alloc(l){return M?new C(Buffer.allocUnsafe(l)):new C(new Uint8Array(l))}static wrap(l){return M&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new C(l)}static fromString(l,P){return!(P?.dontUseNodeBuffer||!1)&&M?new C(Buffer.from(l)):(n||(n=new TextEncoder),new C(n.encode(l)))}static fromByteArray(l){const P=C.alloc(l.length);for(let A=0,O=l.length;A<O;A++)P.buffer[A]=l[A];return P}static concat(l,P){if(typeof P>"u"){P=0;for(let N=0,z=l.length;N<z;N++)P+=l[N].byteLength}const A=C.alloc(P);let O=0;for(let N=0,z=l.length;N<z;N++){const H=l[N];A.set(H,O),O+=H.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=C.alloc(this.byteLength);return l.set(this),l}toString(){return M?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(l,P){return new C(this.buffer.subarray(l,P))}set(l,P){if(l instanceof C)this.buffer.set(l.buffer,P);else if(l instanceof Uint8Array)this.buffer.set(l,P);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),P);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return f(this.buffer,l)}writeUInt32BE(l,P){b(this.buffer,l,P)}readUInt32LE(l){return v(this.buffer,l)}writeUInt32LE(l,P){y(this.buffer,l,P)}readUInt8(l){return d(this.buffer,l)}writeUInt8(l,P){w(this.buffer,l,P)}}e.VSBuffer=C;function k(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0}e.readUInt16LE=k;function g(s,l,P){s[P+0]=l&255,l=l>>>8,s[P+1]=l&255}e.writeUInt16LE=g;function f(s,l){return s[l]*2**24+s[l+1]*2**16+s[l+2]*2**8+s[l+3]}e.readUInt32BE=f;function b(s,l,P){s[P+3]=l,l=l>>>8,s[P+2]=l,l=l>>>8,s[P+1]=l,l=l>>>8,s[P]=l}e.writeUInt32BE=b;function v(s,l){return s[l+0]<<0>>>0|s[l+1]<<8>>>0|s[l+2]<<16>>>0|s[l+3]<<24>>>0}e.readUInt32LE=v;function y(s,l,P){s[P+0]=l&255,l=l>>>8,s[P+1]=l&255,l=l>>>8,s[P+2]=l&255,l=l>>>8,s[P+3]=l&255}e.writeUInt32LE=y;function d(s,l){return s[l]}e.readUInt8=d;function w(s,l,P){s[P]=l}e.writeUInt8=w;function p(s){return E.consumeReadable(s,l=>C.concat(l))}e.readableToBuffer=p;function a(s){return E.toReadable(s)}e.bufferToReadable=a;function h(s){return E.consumeStream(s,l=>C.concat(l))}e.streamToBuffer=h;async function m(s){return s.ended?C.concat(s.buffer):C.concat([...s.buffer,await h(s.stream)])}e.bufferedStreamToBuffer=m;function I(s){return E.toStream(s,l=>C.concat(l))}e.bufferToStream=I;function S(s){return E.transform(s,{data:l=>typeof l=="string"?C.fromString(l):C.wrap(l)},l=>C.concat(l))}e.streamToBufferReadableStream=S;function D(s){return E.newWriteableStream(l=>C.concat(l),s)}e.newWriteableBufferStream=D;function t(s,l){return E.prefixedReadable(s,l,P=>C.concat(P))}e.prefixedBufferReadable=t;function c(s,l){return E.prefixedStream(s,l,P=>C.concat(P))}e.prefixedBufferStream=c;function i(s){let l=0,P=0,A=0;const O=new Uint8Array(Math.floor(s.length/4*3)),N=H=>{switch(P){case 3:O[A++]=l|H,P=0;break;case 2:O[A++]=l|H>>>2,l=H<<6,P=3;break;case 1:O[A++]=l|H>>>4,l=H<<4,P=2;break;default:l=H<<2,P=1}};for(let H=0;H<s.length;H++){const ie=s.charCodeAt(H);if(ie>=65&&ie<=90)N(ie-65);else if(ie>=97&&ie<=122)N(ie-97+26);else if(ie>=48&&ie<=57)N(ie-48+52);else if(ie===43||ie===45)N(62);else if(ie===47||ie===95)N(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${s[H]}`)}}const z=A;for(;P>0;)N(0);return C.wrap(O).slice(0,z)}e.decodeBase64=i;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:s},l=!0,P=!1){const A=P?o:r;let O="";const N=s.byteLength%3;let z=0;for(;z<s.byteLength-N;z+=3){const H=s[z+0],ie=s[z+1],se=s[z+2];O+=A[H>>>2],O+=A[(H<<4|ie>>>4)&63],O+=A[(ie<<2|se>>>6)&63],O+=A[se&63]}if(N===1){const H=s[z+0];O+=A[H>>>2],O+=A[H<<4&63],l&&(O+="==")}else if(N===2){const H=s[z+0],ie=s[z+1];O+=A[H>>>2],O+=A[(H<<4|ie>>>4)&63],O+=A[ie<<2&63],l&&(O+="=")}return O}e.encodeBase64=u}),define(Z[133],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Z[10],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(c){return typeof c=="string"}e.isString=E;function M(c){return Array.isArray(c)&&c.every(i=>E(i))}e.isStringArray=M;function n(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=n;function R(c){const i=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof i}e.isTypedArray=R;function C(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=C;function k(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=k;function g(c){return c===!0||c===!1}e.isBoolean=g;function f(c){return typeof c>"u"}e.isUndefined=f;function b(c){return!v(c)}e.isDefined=b;function v(c){return f(c)||c===null}e.isUndefinedOrNull=v;function y(c,i){if(!c)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=y;function d(c){if(v(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=d;function w(...c){const i=[];for(let r=0;r<c.length;r++){const o=c[r];if(v(o))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);i.push(o)}return i}e.assertAllDefined=w;const p=Object.prototype.hasOwnProperty;function a(c){if(!n(c))return!1;for(const i in c)if(p.call(c,i))return!1;return!0}e.isEmptyObject=a;function h(c){return typeof c=="function"}e.isFunction=h;function m(...c){return c.length>0&&c.every(h)}e.areFunctions=m;function I(c,i){const r=Math.min(c.length,i.length);for(let o=0;o<r;o++)S(c[o],i[o])}e.validateConstraints=I;function S(c,i){if(E(i)){if(typeof c!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(c instanceof i)return}catch{}if(!v(c)&&c.constructor===i||i.length===1&&i.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function D(c){return c===null?void 0:c}e.withNullAsUndefined=D;function t(c){return typeof c>"u"?null:c}e.withUndefinedAsNull=t}),define(Z[134],_([0,1,10]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const M=Object.create(null);function n(k,g){if((0,E.isString)(g)){const f=M[g];if(f===void 0)throw new Error(`${k} references an unknown codicon: ${g}`);g=f}return M[k]=g,{id:k}}function R(){return M}e.getCodiconFontCharacters=R;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package_:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define(Z[37],_([0,1,10]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const m=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([I,S])=>{m[I]=S&&typeof S=="object"?M(S):S}),m}e.deepClone=M;function n(h){if(!h||typeof h!="object")return h;const m=[h];for(;m.length>0;){const I=m.shift();Object.freeze(I);for(const S in I)if(R.call(I,S)){const D=I[S];typeof D=="object"&&!Object.isFrozen(D)&&!(0,E.isTypedArray)(D)&&m.push(D)}}return h}e.deepFreeze=n;const R=Object.prototype.hasOwnProperty;function C(h,m){return k(h,m,new Set)}e.cloneAndChange=C;function k(h,m,I){if((0,E.isUndefinedOrNull)(h))return h;const S=m(h);if(typeof S<"u")return S;if(Array.isArray(h)){const D=[];for(const t of h)D.push(k(t,m,I));return D}if((0,E.isObject)(h)){if(I.has(h))throw new Error("Cannot clone recursive data-structure");I.add(h);const D={};for(const t in h)R.call(h,t)&&(D[t]=k(h[t],m,I));return I.delete(h),D}return h}function g(h,m,I=!0){return(0,E.isObject)(h)?((0,E.isObject)(m)&&Object.keys(m).forEach(S=>{S in h?I&&((0,E.isObject)(h[S])&&(0,E.isObject)(m[S])?g(h[S],m[S],I):h[S]=m[S]):h[S]=m[S]}),h):m}e.mixin=g;function f(h,m){if(h===m)return!0;if(h==null||m===null||m===void 0||typeof h!=typeof m||typeof h!="object"||Array.isArray(h)!==Array.isArray(m))return!1;let I,S;if(Array.isArray(h)){if(h.length!==m.length)return!1;for(I=0;I<h.length;I++)if(!f(h[I],m[I]))return!1}else{const D=[];for(S in h)D.push(S);D.sort();const t=[];for(S in m)t.push(S);if(t.sort(),!f(D,t))return!1;for(I=0;I<D.length;I++)if(!f(h[D[I]],m[D[I]]))return!1}return!0}e.equals=f;function b(h){const m=new Set;return JSON.stringify(h,(I,S)=>{if((0,E.isObject)(S)||Array.isArray(S)){if(m.has(S))return"[Circular]";m.add(S)}return S})}e.safeStringify=b;function v(h,m){const I=Object.create(null);return!h||!m||Object.keys(m).forEach(D=>{const t=h[D],c=m[D];f(t,c)||(I[D]=c)}),I}e.distinct=v;function y(h,m){const I=m.toLowerCase(),S=Object.keys(h).find(D=>D.toLowerCase()===I);return S?h[S]:h[m]}e.getCaseInsensitive=y;function d(h,m){const I=Object.create(null);for(const[S,D]of Object.entries(h))m(S,D)&&(I[S]=D);return I}e.filter=d;function w(h){let m=[],I=Object.getPrototypeOf(h);for(;Object.prototype!==I;)m=m.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return m}e.getAllPropertyNames=w;function p(h){const m=[];for(const I of w(h))typeof h[I]=="function"&&m.push(I);return m}e.getAllMethodNames=p;function a(h,m){const I=D=>function(){const t=Array.prototype.slice.call(arguments,0);return m(D,t)},S={};for(const D of h)S[D]=I(D);return S}e.createProxyObject=a}),define(Z[135],_([0,1,134]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var M;(function(C){function k(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=k})(M=e.ThemeColor||(e.ThemeColor={}));function n(C){return{id:C}}e.themeColorFromId=n;var R;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function g(m){const I=k.exec(m.id);if(!I)return g(E.Codicon.error);const[,S,D]=I,t=["codicon","codicon-"+S];return D&&t.push("codicon-modifier-"+D.substring(1)),t}C.asClassNameArray=g;function f(m){return g(m).join(" ")}C.asClassName=f;function b(m){return"."+g(m).join(".")}C.asCSSSelector=b;function v(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(typeof m.color>"u"||M.isThemeColor(m.color))}C.isThemeIcon=v;const y=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function d(m){const I=y.exec(m);if(!I)return;const[,S]=I;return{id:S}}C.fromString=d;function w(m){return{id:m}}C.fromId=w;function p(m,I){let S=m.id;const D=S.lastIndexOf("~");return D!==-1&&(S=S.substring(0,D)),I&&(S=`${S}~${I}`),{id:S}}C.modify=p;function a(m){const I=m.id.lastIndexOf("~");if(I!==-1)return m.id.substring(I+1)}C.getModifier=a;function h(m,I){return m.id===I.id&&m.color?.id===I.color?.id}C.isEqual=h})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(Z[31],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(n){return E.test(n)}e.isUUID=M,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(k){for(let g=0;g<k.length;g++)k[g]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),C=[];for(let k=0;k<256;k++)C.push(k.toString(16).padStart(2,"0"));return function(){n(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let g=0,f="";return f+=C[R[g++]],f+=C[R[g++]],f+=C[R[g++]],f+=C[R[g++]],f+="-",f+=C[R[g++]],f+=C[R[g++]],f+="-",f+=C[R[g++]],f+=C[R[g++]],f+="-",f+=C[R[g++]],f+=C[R[g++]],f+="-",f+=C[R[g++]],f+=C[R[g++]],f+=C[R[g++]],f+=C[R[g++]],f+=C[R[g++]],f+=C[R[g++]],f}}()}),define(Z[136],_([0,1,81,41,49]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(C,k){if(await new Promise((b,v)=>{const y=M.createReadStream(C),d=E.createHash("sha1");y.pipe(d);const w=(0,n.once)((p,a)=>{y.removeAllListeners(),d.removeAllListeners(),p?v(p):b(a)});y.once("error",w),y.once("end",w),d.once("error",w),d.once("data",p=>w(void 0,p.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=R}),define(Z[137],_([0,1,26]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function n(C){const k=C.replace(/\-/g,":").toLowerCase();return!M.has(k)}function R(){const C=(0,E.networkInterfaces)();for(const k in C){const g=C[k];if(g){for(const{mac:f}of g)if(n(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(Z[99],_([0,1,82]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function M(k,g,f,b=1){let v=!1;return new Promise(y=>{const d=setTimeout(()=>{if(!v)return v=!0,y(0)},f);n(k,g,b,w=>{if(!v)return v=!0,clearTimeout(d),y(w)})})}e.findFreePort=M;function n(k,g,f,b){if(g===0)return b(0);const v=new E.Socket;v.once("connect",()=>(C(v),n(k+f,g-1,f,b))),v.once("data",()=>{}),v.once("error",y=>(C(v),y.code!=="ECONNREFUSED"?n(k+f,g-1,f,b):b(k))),v.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,g,f,b="127.0.0.1"){let v=!1,y,d=1;const w=E.createServer({pauseOnConnect:!0});function p(a,h){v||(v=!0,w.removeAllListeners(),w.close(),y&&clearTimeout(y),h(a))}return new Promise(a=>{y=setTimeout(()=>{p(0,a)},f),w.on("listening",()=>{p(k,a)}),w.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&d<g?(k++,d++,w.listen(k,b)):p(0,a)}),w.on("close",()=>{p(0,a)}),w.listen(k,b)})}e.findFreePortFaster=R;function C(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(g){console.error(g)}}}),define(Z[138],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[139],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(n,R){this.a=n,this.onMessage=R}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(Z[42],_([0,1,15,13]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class n{constructor(){this.a=new WeakMap}on(C,k){const g=(f,...b)=>{this.b(C,f)&&k(f,...b)};return this.a.set(k,g),E.ipcMain.on(C,g),this}once(C,k){return E.ipcMain.once(C,(g,...f)=>{this.b(C,g)&&k(g,...f)}),this}handle(C,k){return E.ipcMain.handle(C,(g,...f)=>this.b(C,g)?k(g,...f):Promise.reject(`Invalid channel '${C}' or sender for ipcMain.handle() usage.`)),this}removeHandler(C){return E.ipcMain.removeHandler(C),this}removeListener(C,k){const g=this.a.get(k);return g&&(E.ipcMain.removeListener(C,g),this.a.delete(k)),this}b(C,k){if(!C||!C.startsWith("vscode:"))return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because the channel is unknown.`),!1;const g=k.senderFrame,f=g.url;if(!f)return!0;let b="unknown";try{b=new URL(f).host}catch{return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a malformed URL '${f}'.`),!1}return b!=="vscode-app"?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because of a bad origin of '${b}'.`),!1):g.parent!==null?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${C}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new n}),define(Z[140],_([0,1,15,42,10,138]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function C(){M.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(g,f,b,v,y)=>{const d=k(g,v,b);d.popup({window:(0,n.withNullAsUndefined)(E.BrowserWindow.fromWebContents(g.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{d&&g.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,f)}})})}e.registerContextMenuListener=C;function k(g,f,b){const v=new E.Menu;return b.forEach(y=>{let d;y.type==="separator"?d=new E.MenuItem({type:y.type}):Array.isArray(y.submenu)?d=new E.MenuItem({submenu:k(g,f,y.submenu),label:y.label}):d=new E.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(w,p,a)=>g.sender.send(f,y.id,a)}),v.append(d)}),v}}),define(Z[100],_([0,1,15]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.canUseUtilityProcess=e.UtilityProcess=void 0,e.UtilityProcess=E.utilityProcess,e.canUseUtilityProcess=typeof e.UtilityProcess<"u"}),define(Z[141],_([12,11]),function(x,e){return x.create("vs/base/common/date",e)}),define(Z[142],_([0,1,141]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,n=M*60,R=n*24,C=R*7,k=R*30,g=R*365;function f(v,y,d,w){typeof v!="number"&&(v=v.getTime());const p=Math.round((new Date().getTime()-v)/1e3);if(p<-30)return(0,E.localize)(0,null,f(new Date().getTime()+p*1e3,!1));if(!w&&p<30)return(0,E.localize)(1,null);let a;return p<M?(a=p,y?a===1?d?(0,E.localize)(2,null,a):(0,E.localize)(3,null,a):d?(0,E.localize)(4,null,a):(0,E.localize)(5,null,a):a===1?d?(0,E.localize)(6,null,a):(0,E.localize)(7,null,a):d?(0,E.localize)(8,null,a):(0,E.localize)(9,null,a)):p<n?(a=Math.floor(p/M),y?a===1?d?(0,E.localize)(10,null,a):(0,E.localize)(11,null,a):d?(0,E.localize)(12,null,a):(0,E.localize)(13,null,a):a===1?d?(0,E.localize)(14,null,a):(0,E.localize)(15,null,a):d?(0,E.localize)(16,null,a):(0,E.localize)(17,null,a)):p<R?(a=Math.floor(p/n),y?a===1?d?(0,E.localize)(18,null,a):(0,E.localize)(19,null,a):d?(0,E.localize)(20,null,a):(0,E.localize)(21,null,a):a===1?d?(0,E.localize)(22,null,a):(0,E.localize)(23,null,a):d?(0,E.localize)(24,null,a):(0,E.localize)(25,null,a)):p<C?(a=Math.floor(p/R),y?a===1?(0,E.localize)(26,null,a):(0,E.localize)(27,null,a):a===1?(0,E.localize)(28,null,a):(0,E.localize)(29,null,a)):p<k?(a=Math.floor(p/C),y?a===1?d?(0,E.localize)(30,null,a):(0,E.localize)(31,null,a):d?(0,E.localize)(32,null,a):(0,E.localize)(33,null,a):a===1?d?(0,E.localize)(34,null,a):(0,E.localize)(35,null,a):d?(0,E.localize)(36,null,a):(0,E.localize)(37,null,a)):p<g?(a=Math.floor(p/k),y?a===1?d?(0,E.localize)(38,null,a):(0,E.localize)(39,null,a):d?(0,E.localize)(40,null,a):(0,E.localize)(41,null,a):a===1?d?(0,E.localize)(42,null,a):(0,E.localize)(43,null,a):d?(0,E.localize)(44,null,a):(0,E.localize)(45,null,a)):(a=Math.floor(p/g),y?a===1?d?(0,E.localize)(46,null,a):(0,E.localize)(47,null,a):d?(0,E.localize)(48,null,a):(0,E.localize)(49,null,a):a===1?d?(0,E.localize)(50,null,a):(0,E.localize)(51,null,a):d?(0,E.localize)(52,null,a):(0,E.localize)(53,null,a))}e.fromNow=f;function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=b}),define(Z[143],_([12,11]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Z[44],_([0,1,25,10,143]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(v,y){return y&&(v.stack||v.stacktrace)?n.localize(0,null,k(v),C(v.stack)||C(v.stacktrace)):k(v)}function C(v){return Array.isArray(v)?v.join(`
`):v}function k(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?n.localize(1,null,v.message):v.message||n.localize(2,null)}function g(v=null,y=!1){if(!v)return n.localize(3,null);if(Array.isArray(v)){const d=E.coalesce(v),w=g(d[0],y);return d.length>1?n.localize(4,null,w,d.length):w}if(M.isString(v))return v;if(v.detail){const d=v.detail;if(d.error)return R(d.error,y);if(d.exception)return R(d.exception,y)}return v.stack?R(v,y):v.message?v.message:n.localize(5,null)}e.toErrorMessage=g;function f(v){const y=v;return y instanceof Error&&Array.isArray(y.actions)}e.isErrorWithActions=f;function b(v,y){let d;return typeof v=="string"?d=new Error(v):d=v,d.actions=y,d}e.createErrorWithActions=b}),define(Z[144],_([12,11]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Z[145],_([0,1,144]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function M(n){switch(n){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=M}),define(Z[146],_([12,11]),function(x,e){return x.create("vs/base/common/platform",e)}),define(Z[4],_([0,1,146]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let M=!1,n=!1,R=!1,C=!1,k=!1,g=!1,f=!1,b=!1,v=!1,y=!1,d,w=e.LANGUAGE_DEFAULT,p,a;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const m=typeof h?.versions?.electron=="string",I=m&&h?.type==="renderer";if(typeof navigator=="object"&&!I)a=navigator.userAgent,M=a.indexOf("Windows")>=0,n=a.indexOf("Macintosh")>=0,b=(a.indexOf("Macintosh")>=0||a.indexOf("iPad")>=0||a.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=a.indexOf("Linux")>=0,y=a?.indexOf("Mobi")>=0,g=!0,d=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,w=d;else if(typeof h=="object"){M=h.platform==="win32",n=h.platform==="darwin",R=h.platform==="linux",C=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,f=m,v=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT;const s=h.env.VSCODE_NLS_CONFIG;if(s)try{const l=JSON.parse(s),P=l.availableLanguages["*"];d=l.locale,w=P||e.LANGUAGE_DEFAULT,p=l._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var S;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(S=e.Platform||(e.Platform={}));function D(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let t=0;n?t=1:M?t=3:R&&(t=2),e.isWindows=M,e.isMacintosh=n,e.isLinux=R,e.isLinuxSnap=C,e.isNative=k,e.isElectron=f,e.isWeb=g,e.isWebWorker=g&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=y,e.isCI=v,e.platform=t,e.userAgent=a,e.language=w;var c;(function(s){function l(){return e.language}s.value=l;function P(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=P;function A(){return e.language==="en"}s.isDefault=A})(c=e.Language||(e.Language={})),e.locale=d,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const s=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let A=0,O=s.length;A<O;A++){const N=s[A];if(N.id===P.data.vscodeScheduleAsyncWork){s.splice(A,1),N.callback();return}}});let l=0;return P=>{const A=++l;s.push({id:A,callback:P}),e.globals.postMessage({vscodeScheduleAsyncWork:A},"*")}}return s=>setTimeout(s)})();var i;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(i=e.OperatingSystem||(e.OperatingSystem={})),e.OS=n||b?2:M?1:3;let r=!0,o=!1;function u(){if(!o){o=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,r=new Uint16Array(s.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=u,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Z[36],_([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const n=E.globals.vscode.process;M={get platform(){return n.platform},get arch(){return n.arch},get env(){return n.env},cwd(){return n.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.arch=M.arch}),define(Z[9],_([0,1,36]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,n=97,R=90,C=122,k=46,g=47,f=92,b=58,v=63;class y extends Error{constructor(c,i,r){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const u=c.indexOf(".")!==-1?"property":"argument";let s=`The "${c}" ${u} ${o} of type ${i}`;s+=`. Received type ${typeof r}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,c){if(t===null||typeof t!="object")throw new y(c,"Object",t)}function w(t,c){if(typeof t!="string")throw new y(c,"string",t)}const p=E.platform==="win32";function a(t){return t===g||t===f}function h(t){return t===g}function m(t){return t>=M&&t<=R||t>=n&&t<=C}function I(t,c,i,r){let o="",u=0,s=-1,l=0,P=0;for(let A=0;A<=t.length;++A){if(A<t.length)P=t.charCodeAt(A);else{if(r(P))break;P=g}if(r(P)){if(!(s===A-1||l===1))if(l===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const O=o.lastIndexOf(i);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(i)),s=A,l=0;continue}else if(o.length!==0){o="",u=0,s=A,l=0;continue}}c&&(o+=o.length>0?`${i}..`:"..",u=2)}else o.length>0?o+=`${i}${t.slice(s+1,A)}`:o=t.slice(s+1,A),u=A-s-1;s=A,l=0}else P===k&&l!==-1?++l:l=-1}return o}function S(t,c){d(c,"pathObject");const i=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return i?i===c.root?`${i}${r}`:`${i}${t}${r}`:r}e.win32={resolve(...t){let c="",i="",r=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],w(u,"path"),u.length===0)continue}else c.length===0?u=E.cwd():(u=E.env[`=${c}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==c.toLowerCase()&&u.charCodeAt(2)===f)&&(u=`${c}\\`));const s=u.length;let l=0,P="",A=!1;const O=u.charCodeAt(0);if(s===1)a(O)&&(l=1,A=!0);else if(a(O))if(A=!0,a(u.charCodeAt(1))){let N=2,z=N;for(;N<s&&!a(u.charCodeAt(N));)N++;if(N<s&&N!==z){const H=u.slice(z,N);for(z=N;N<s&&a(u.charCodeAt(N));)N++;if(N<s&&N!==z){for(z=N;N<s&&!a(u.charCodeAt(N));)N++;(N===s||N!==z)&&(P=`\\\\${H}\\${u.slice(z,N)}`,l=N)}}}else l=1;else m(O)&&u.charCodeAt(1)===b&&(P=u.slice(0,2),l=2,s>2&&a(u.charCodeAt(2))&&(A=!0,l=3));if(P.length>0)if(c.length>0){if(P.toLowerCase()!==c.toLowerCase())continue}else c=P;if(r){if(c.length>0)break}else if(i=`${u.slice(l)}\\${i}`,r=A,A&&c.length>0)break}return i=I(i,!r,"\\",a),r?`${c}\\${i}`:`${c}${i}`||"."},normalize(t){w(t,"path");const c=t.length;if(c===0)return".";let i=0,r,o=!1;const u=t.charCodeAt(0);if(c===1)return h(u)?"\\":t;if(a(u))if(o=!0,a(t.charCodeAt(1))){let l=2,P=l;for(;l<c&&!a(t.charCodeAt(l));)l++;if(l<c&&l!==P){const A=t.slice(P,l);for(P=l;l<c&&a(t.charCodeAt(l));)l++;if(l<c&&l!==P){for(P=l;l<c&&!a(t.charCodeAt(l));)l++;if(l===c)return`\\\\${A}\\${t.slice(P)}\\`;l!==P&&(r=`\\\\${A}\\${t.slice(P,l)}`,i=l)}}}else i=1;else m(u)&&t.charCodeAt(1)===b&&(r=t.slice(0,2),i=2,c>2&&a(t.charCodeAt(2))&&(o=!0,i=3));let s=i<c?I(t.slice(i),!o,"\\",a):"";return s.length===0&&!o&&(s="."),s.length>0&&a(t.charCodeAt(c-1))&&(s+="\\"),r===void 0?o?`\\${s}`:s:o?`${r}\\${s}`:`${r}${s}`},isAbsolute(t){w(t,"path");const c=t.length;if(c===0)return!1;const i=t.charCodeAt(0);return a(i)||c>2&&m(i)&&t.charCodeAt(1)===b&&a(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,i;for(let u=0;u<t.length;++u){const s=t[u];w(s,"path"),s.length>0&&(c===void 0?c=i=s:c+=`\\${s}`)}if(c===void 0)return".";let r=!0,o=0;if(typeof i=="string"&&a(i.charCodeAt(0))){++o;const u=i.length;u>1&&a(i.charCodeAt(1))&&(++o,u>2&&(a(i.charCodeAt(2))?++o:r=!1))}if(r){for(;o<c.length&&a(c.charCodeAt(o));)o++;o>=2&&(c=`\\${c.slice(o)}`)}return e.win32.normalize(c)},relative(t,c){if(w(t,"from"),w(c,"to"),t===c)return"";const i=e.win32.resolve(t),r=e.win32.resolve(c);if(i===r||(t=i.toLowerCase(),c=r.toLowerCase(),t===c))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===f;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===f;)u--;const s=u-o;let l=0;for(;l<c.length&&c.charCodeAt(l)===f;)l++;let P=c.length;for(;P-1>l&&c.charCodeAt(P-1)===f;)P--;const A=P-l,O=s<A?s:A;let N=-1,z=0;for(;z<O;z++){const ie=t.charCodeAt(o+z);if(ie!==c.charCodeAt(l+z))break;ie===f&&(N=z)}if(z!==O){if(N===-1)return r}else{if(A>O){if(c.charCodeAt(l+z)===f)return r.slice(l+z+1);if(z===2)return r.slice(l+z)}s>O&&(t.charCodeAt(o+z)===f?N=z:z===2&&(N=3)),N===-1&&(N=0)}let H="";for(z=o+N+1;z<=u;++z)(z===u||t.charCodeAt(z)===f)&&(H+=H.length===0?"..":"\\..");return l+=N,H.length>0?`${H}${r.slice(l,P)}`:(r.charCodeAt(l)===f&&++l,r.slice(l,P))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.win32.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===f){if(c.charCodeAt(1)===f){const i=c.charCodeAt(2);if(i!==v&&i!==k)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(m(c.charCodeAt(0))&&c.charCodeAt(1)===b&&c.charCodeAt(2)===f)return`\\\\?\\${c}`;return t},dirname(t){w(t,"path");const c=t.length;if(c===0)return".";let i=-1,r=0;const o=t.charCodeAt(0);if(c===1)return a(o)?t:".";if(a(o)){if(i=r=1,a(t.charCodeAt(1))){let l=2,P=l;for(;l<c&&!a(t.charCodeAt(l));)l++;if(l<c&&l!==P){for(P=l;l<c&&a(t.charCodeAt(l));)l++;if(l<c&&l!==P){for(P=l;l<c&&!a(t.charCodeAt(l));)l++;if(l===c)return t;l!==P&&(i=r=l+1)}}}}else m(o)&&t.charCodeAt(1)===b&&(i=c>2&&a(t.charCodeAt(2))?3:2,r=i);let u=-1,s=!0;for(let l=c-1;l>=r;--l)if(a(t.charCodeAt(l))){if(!s){u=l;break}}else s=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,c){c!==void 0&&w(c,"ext"),w(t,"path");let i=0,r=-1,o=!0,u;if(t.length>=2&&m(t.charCodeAt(0))&&t.charCodeAt(1)===b&&(i=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let s=c.length-1,l=-1;for(u=t.length-1;u>=i;--u){const P=t.charCodeAt(u);if(a(P)){if(!o){i=u+1;break}}else l===-1&&(o=!1,l=u+1),s>=0&&(P===c.charCodeAt(s)?--s===-1&&(r=u):(s=-1,r=l))}return i===r?r=l:r===-1&&(r=t.length),t.slice(i,r)}for(u=t.length-1;u>=i;--u)if(a(t.charCodeAt(u))){if(!o){i=u+1;break}}else r===-1&&(o=!1,r=u+1);return r===-1?"":t.slice(i,r)},extname(t){w(t,"path");let c=0,i=-1,r=0,o=-1,u=!0,s=0;t.length>=2&&t.charCodeAt(1)===b&&m(t.charCodeAt(0))&&(c=r=2);for(let l=t.length-1;l>=c;--l){const P=t.charCodeAt(l);if(a(P)){if(!u){r=l+1;break}continue}o===-1&&(u=!1,o=l+1),P===k?i===-1?i=l:s!==1&&(s=1):i!==-1&&(s=-1)}return i===-1||o===-1||s===0||s===1&&i===o-1&&i===r+1?"":t.slice(i,o)},format:S.bind(null,"\\"),parse(t){w(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.length;let r=0,o=t.charCodeAt(0);if(i===1)return a(o)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(a(o)){if(r=1,a(t.charCodeAt(1))){let N=2,z=N;for(;N<i&&!a(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&a(t.charCodeAt(N));)N++;if(N<i&&N!==z){for(z=N;N<i&&!a(t.charCodeAt(N));)N++;N===i?r=N:N!==z&&(r=N+1)}}}}else if(m(o)&&t.charCodeAt(1)===b){if(i<=2)return c.root=c.dir=t,c;if(r=2,a(t.charCodeAt(2))){if(i===3)return c.root=c.dir=t,c;r=3}}r>0&&(c.root=t.slice(0,r));let u=-1,s=r,l=-1,P=!0,A=t.length-1,O=0;for(;A>=r;--A){if(o=t.charCodeAt(A),a(o)){if(!P){s=A+1;break}continue}l===-1&&(P=!1,l=A+1),o===k?u===-1?u=A:O!==1&&(O=1):u!==-1&&(O=-1)}return l!==-1&&(u===-1||O===0||O===1&&u===l-1&&u===s+1?c.base=c.name=t.slice(s,l):(c.name=t.slice(s,u),c.base=t.slice(s,l),c.ext=t.slice(u,l))),s>0&&s!==r?c.dir=t.slice(0,s-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(p){const t=/\\/g;return()=>{const c=E.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let c="",i=!1;for(let r=t.length-1;r>=-1&&!i;r--){const o=r>=0?t[r]:D();w(o,"path"),o.length!==0&&(c=`${o}/${c}`,i=o.charCodeAt(0)===g)}return c=I(c,!i,"/",h),i?`/${c}`:c.length>0?c:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g,i=t.charCodeAt(t.length-1)===g;return t=I(t,!c,"/",h),t.length===0?c?"/":i?"./":".":(i&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===g},join(...t){if(t.length===0)return".";let c;for(let i=0;i<t.length;++i){const r=t[i];w(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(t,c){if(w(t,"from"),w(c,"to"),t===c||(t=e.posix.resolve(t),c=e.posix.resolve(c),t===c))return"";const i=1,r=t.length,o=r-i,u=1,s=c.length-u,l=o<s?o:s;let P=-1,A=0;for(;A<l;A++){const N=t.charCodeAt(i+A);if(N!==c.charCodeAt(u+A))break;N===g&&(P=A)}if(A===l)if(s>l){if(c.charCodeAt(u+A)===g)return c.slice(u+A+1);if(A===0)return c.slice(u+A)}else o>l&&(t.charCodeAt(i+A)===g?P=A:A===0&&(P=0));let O="";for(A=i+P+1;A<=r;++A)(A===r||t.charCodeAt(A)===g)&&(O+=O.length===0?"..":"/..");return`${O}${c.slice(u+P)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===g;let i=-1,r=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===g){if(!r){i=o;break}}else r=!1;return i===-1?c?"/":".":c&&i===1?"//":t.slice(0,i)},basename(t,c){c!==void 0&&w(c,"ext"),w(t,"path");let i=0,r=-1,o=!0,u;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let s=c.length-1,l=-1;for(u=t.length-1;u>=0;--u){const P=t.charCodeAt(u);if(P===g){if(!o){i=u+1;break}}else l===-1&&(o=!1,l=u+1),s>=0&&(P===c.charCodeAt(s)?--s===-1&&(r=u):(s=-1,r=l))}return i===r?r=l:r===-1&&(r=t.length),t.slice(i,r)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===g){if(!o){i=u+1;break}}else r===-1&&(o=!1,r=u+1);return r===-1?"":t.slice(i,r)},extname(t){w(t,"path");let c=-1,i=0,r=-1,o=!0,u=0;for(let s=t.length-1;s>=0;--s){const l=t.charCodeAt(s);if(l===g){if(!o){i=s+1;break}continue}r===-1&&(o=!1,r=s+1),l===k?c===-1?c=s:u!==1&&(u=1):c!==-1&&(u=-1)}return c===-1||r===-1||u===0||u===1&&c===r-1&&c===i+1?"":t.slice(c,r)},format:S.bind(null,"/"),parse(t){w(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const i=t.charCodeAt(0)===g;let r;i?(c.root="/",r=1):r=0;let o=-1,u=0,s=-1,l=!0,P=t.length-1,A=0;for(;P>=r;--P){const O=t.charCodeAt(P);if(O===g){if(!l){u=P+1;break}continue}s===-1&&(l=!1,s=P+1),O===k?o===-1?o=P:A!==1&&(A=1):o!==-1&&(A=-1)}if(s!==-1){const O=u===0&&i?1:u;o===-1||A===0||A===1&&o===s-1&&o===u+1?c.base=c.name=t.slice(O,s):(c.name=t.slice(O,o),c.base=t.slice(O,s),c.ext=t.slice(o,s))}return u>0?c.dir=t.slice(0,u-1):i&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(Z[71],_([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var M;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(M=e.Source||(e.Source={}));var n;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(k,...g){const f=g.reduce((y,d)=>(y[d]=!0,y),{}),b=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(y=>!f[y]).forEach(y=>{for(let d=0;d<b.length;d++)if(y.search(b[d])!==-1){delete k[y];break}})}e.sanitizeProcessEnvironment=R;function C(k){!k||(delete k.DEBUG,E.isMacintosh&&delete k.DYLD_LIBRARY_PATH,E.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(Z[72],_([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class n{static create(C=!0){return new n(C)}constructor(C){this.a=M&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=n}),define(Z[3],_([0,1,13,49,2,98,72]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,g=!1;var f;(function(u){u.None=()=>n.Disposable.None;function s(W){if(g){const{onDidAddListener:$}=W,V=w.create();let j=0;W.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),$?.()}}}function l(W,$){return oe(W,()=>{},0,void 0,!0,void 0,$)}u.defer=l;function P(W){return($,V=null,j)=>{let K=!1,J;return J=W(re=>{if(!K)return J?J.dispose():K=!0,$.call(V,re)},null,j),K&&J.dispose(),J}}u.once=P;function A(W,$,V){return se((j,K=null,J)=>W(re=>j.call(K,$(re)),null,J),V)}u.map=A;function O(W,$,V){return se((j,K=null,J)=>W(re=>{$(re),j.call(K,re)},null,J),V)}u.forEach=O;function N(W,$,V){return se((j,K=null,J)=>W(re=>$(re)&&j.call(K,re),null,J),V)}u.filter=N;function z(W){return W}u.signal=z;function H(...W){return($,V=null,j)=>(0,n.combinedDisposable)(...W.map(K=>K(J=>$.call(V,J),null,j)))}u.any=H;function ie(W,$,V,j){let K=V;return A(W,J=>(K=$(K,J),K),j)}u.reduce=ie;function se(W,$){let V;const j={onWillAddFirstListener(){V=W(K.fire,K)},onDidRemoveLastListener(){V?.dispose()}};$||s(j);const K=new a(j);return $?.add(K),K.event}function oe(W,$,V=100,j=!1,K=!1,J,re){let de,Ce,Re,De=0,Oe;const $e={leakWarningThreshold:J,onWillAddFirstListener(){de=W(pe=>{De++,Ce=$(Ce,pe),j&&!Re&&(fe.fire(Ce),Ce=void 0),Oe=()=>{const Me=Ce;Ce=void 0,Re=void 0,(!j||De>1)&&fe.fire(Me),De=0},typeof V=="number"?(clearTimeout(Re),Re=setTimeout(Oe,V)):Re===void 0&&(Re=0,queueMicrotask(Oe))})},onWillRemoveListener(){K&&De>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,de.dispose()}};re||s($e);const fe=new a($e);return re?.add(fe),fe.event}u.debounce=oe;function ue(W,$=0,V){return u.debounce(W,(j,K)=>j?(j.push(K),j):[K],$,void 0,!0,void 0,V)}u.accumulate=ue;function le(W,$=(j,K)=>j===K,V){let j=!0,K;return N(W,J=>{const re=j||!$(J,K);return j=!1,K=J,re},V)}u.latch=le;function me(W,$,V){return[u.filter(W,$,V),u.filter(W,j=>!$(j),V)]}u.split=me;function G(W,$=!1,V=[]){let j=V.slice(),K=W(de=>{j?j.push(de):re.fire(de)});const J=()=>{j?.forEach(de=>re.fire(de)),j=null},re=new a({onWillAddFirstListener(){K||(K=W(de=>re.fire(de)))},onDidAddFirstListener(){j&&($?setTimeout(J):J())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return re.event}u.buffer=G;class B{constructor($){this.event=$,this.c=new n.DisposableStore}map($){return new B(A(this.event,$,this.c))}forEach($){return new B(O(this.event,$,this.c))}filter($){return new B(N(this.event,$,this.c))}reduce($,V){return new B(ie(this.event,$,V,this.c))}latch(){return new B(le(this.event,void 0,this.c))}debounce($,V=100,j=!1,K=!1,J){return new B(oe(this.event,$,V,j,K,J,this.c))}on($,V,j){return this.event($,V,j)}once($,V,j){return P(this.event)($,V,j)}dispose(){this.c.dispose()}}function T(W){return new B(W)}u.chain=T;function q(W,$,V=j=>j){const j=(...de)=>re.fire(V(...de)),K=()=>W.on($,j),J=()=>W.removeListener($,j),re=new a({onWillAddFirstListener:K,onDidRemoveLastListener:J});return re.event}u.fromNodeEventEmitter=q;function Y(W,$,V=j=>j){const j=(...de)=>re.fire(V(...de)),K=()=>W.addEventListener($,j),J=()=>W.removeEventListener($,j),re=new a({onWillAddFirstListener:K,onDidRemoveLastListener:J});return re.event}u.fromDOMEventEmitter=Y;function te(W){return new Promise($=>P(W)($))}u.toPromise=te;function ne(W,$){return $(void 0),W(V=>$(V))}u.runAndSubscribe=ne;function L(W,$){let V=null;function j(J){V?.dispose(),V=new n.DisposableStore,$(J,V)}j(void 0);const K=W(J=>j(J));return(0,n.toDisposable)(()=>{K.dispose(),V?.dispose()})}u.runAndSubscribeWithStore=L;class F{constructor($,V){this.obs=$,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{$.addObserver(this)},onDidRemoveLastListener:()=>{$.removeObserver(this)}};V||s(j),this.emitter=new a(j),V&&V.add(this.emitter)}beginUpdate($){this.c++}handleChange($,V){this.d=!0}endUpdate($){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U(W,$){return new F(W,$).emitter.event}u.fromObservable=U})(f=e.Event||(e.Event={}));class b{constructor(s){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${s}_${b.c++}`,b.all.add(this)}start(s){this.d=new C.StopWatch(!0),this.listenerCount=s}stop(){if(this.d){const s=this.d.elapsed();this.durations.push(s),this.elapsedOverall+=s,this.invocationCount+=1,this.d=void 0}}}b.all=new Set,b.c=0,e.EventProfiling=b;let v=-1;function y(u){const s=v;return v=u,{dispose(){v=s}}}e.setGlobalLeakWarningThreshold=y;class d{constructor(s,l=Math.random().toString(18).slice(2,5)){this.threshold=s,this.name=l,this.d=0}dispose(){this.c?.clear()}check(s,l){const P=this.threshold;if(P<=0||l<P)return;this.c||(this.c=new Map);const A=this.c.get(s.value)||0;if(this.c.set(s.value,A+1),this.d-=1,this.d<=0){this.d=P*.5;let O,N=0;for(const[z,H]of this.c)(!O||N<H)&&(O=z,N=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${N}):`),console.warn(O)}return()=>{const O=this.c.get(s.value)||0;this.c.set(s.value,O-1)}}}class w{static create(){return new w(new Error().stack??"")}constructor(s){this.value=s}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(s,l,P){this.callback=s,this.callbackThis=l,this.stack=P,this.subscription=new n.SafeDisposable}invoke(s){this.callback.call(this.callbackThis,s)}}class a{constructor(s){this.j=!1,this.d=s,this.f=v>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??v):void 0,this.g=this.d?._profName?new b(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const s=Array.from(this.q);queueMicrotask(()=>{for(const l of s)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(s,l,P)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.Disposable.None;const A=this.q.isEmpty();A&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=w.create(),O=this.f.check(N,this.q.size+1)),k&&(N=N??w.create());const z=new p(s,l,N),H=this.q.push(z);A&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,s,l);const ie=z.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return P instanceof n.DisposableStore?P.add(ie):Array.isArray(P)&&P.push(ie),ie}),this.l}fire(s){if(this.q){this.m||(this.m=new m);for(const l of this.q)this.m.push(this,l,s);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(s,l,P){this.c.push(new I(s,l,P))}clear(s){const l=new R.LinkedList;for(const P of this.c)P.emitter!==s&&l.push(P);this.c=l}deliver(){for(;this.c.size>0;){const s=this.c.shift();try{s.listener.invoke(s.event)}catch(l){(0,E.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=h;class m extends h{clear(s){this.c.clear()}}class I{constructor(s,l,P){this.emitter=s,this.listener=l,this.event=P}}class S extends a{async fireAsync(s,l,P){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const A of this.q)this.c.push([A,s]);for(;this.c.size>0&&!l.isCancellationRequested;){const[A,O]=this.c.shift(),N=[],z={...O,token:l,waitUntil:H=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");P&&(H=P(H,A.callback)),N.push(H)}};try{A.invoke(z)}catch(H){(0,E.onUnexpectedError)(H);continue}Object.freeze(N),await Promise.allSettled(N).then(H=>{for(const ie of H)ie.status==="rejected"&&(0,E.onUnexpectedError)(ie.reason)})}}}}e.AsyncEmitter=S;class D extends a{constructor(s){super(s),this.h=0,this.s=new R.LinkedList,this.t=s?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const s=Array.from(this.s);this.s.clear(),super.fire(this.t(s))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(s){this.q&&(this.h!==0?this.s.push(s):super.fire(s))}}e.PauseableEmitter=D;class t extends D{constructor(s){super(s),this.c=s.delay??100}fire(s){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(s)}}e.DebounceEmitter=t;class c extends a{constructor(s){super(s),this.c=[],this.h=s?.merge}fire(s){!this.hasListeners()||(this.c.push(s),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(l=>super.fire(l)),this.c=[]}))}}e.MicrotaskEmitter=c;class i{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(s){const l={event:s,listener:null};this.f.push(l),this.d&&this.j(l);const P=()=>{this.d&&this.k(l);const A=this.f.indexOf(l);this.f.splice(A,1)};return(0,n.toDisposable)((0,M.once)(P))}g(){this.d=!0,this.f.forEach(s=>this.j(s))}h(){this.d=!1,this.f.forEach(s=>this.k(s))}j(s){s.listener=s.event(l=>this.c.fire(l))}k(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class r{constructor(){this.c=[]}wrapEvent(s){return(l,P,A)=>s(O=>{const N=this.c[this.c.length-1];N?N.push(()=>l.call(P,O)):l.call(P,O)},void 0,A)}bufferEvents(s){const l=[];this.c.push(l);const P=s();return this.c.pop(),l.forEach(A=>A()),P}}e.EventBufferer=r;class o{constructor(){this.c=!1,this.d=f.None,this.f=n.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(s){this.d=s,this.c&&(this.f.dispose(),this.f=s(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(Z[22],_([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(k,g){const f=setTimeout(k.bind(g),0);return{dispose(){clearTimeout(f)}}});var n;(function(k){function g(f){return f===k.None||f===k.Cancelled||f instanceof R?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}k.isCancellationToken=g,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(n=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(g){this.a=void 0,this.b=void 0,this.b=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=n.Cancelled}dispose(g=!1){g&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=n.None}}e.CancellationTokenSource=C}),define(Z[147],_([0,1,22]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class M{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new E.CancellationTokenSource,g=this.b(k.token);return this.a={promise:g,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=M;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const g=JSON.stringify(k);return this.b!==g&&(this.b=g,this.a=this.c(k)),this.a}}e.LRUCachedFunction=n;class R{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const g=this.b(k);return this.a.set(k,g),g}}e.CachedFunction=R}),define(Z[27],_([0,1,147,130]),function(x,e,E,M){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=R;const C=/{(\d+)}/g;function k(X,...ae){return ae.length===0?X:X.replace(C,function(ge,be){const we=parseInt(be,10);return isNaN(we)||we<0||we>=ae.length?ge:ae[we]})}e.format=k;const g=/{([^}]+)}/g;function f(X,ae){return X.replace(g,(ge,be)=>ae[be]??ge)}e.format2=f;function b(X){return X.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=b;function v(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=v;function y(X,ae){let ge=0;const be=ae.charCodeAt(0);for(let we=X.length-1;we>=0;we--)X.charCodeAt(we)===be&&ge++;return ge}e.count=y;function d(X,ae,ge="\u2026"){return X.length<=ae?X:`${X.substr(0,ae)}${ge}`}e.truncate=d;function w(X,ae=" "){const ge=p(X,ae);return a(ge,ae)}e.trim=w;function p(X,ae){if(!X||!ae)return X;const ge=ae.length;if(ge===0||X.length===0)return X;let be=0;for(;X.indexOf(ae,be)===be;)be=be+ge;return X.substring(be)}e.ltrim=p;function a(X,ae){if(!X||!ae)return X;const ge=ae.length,be=X.length;if(ge===0||be===0)return X;let we=be,Le=-1;for(;Le=X.lastIndexOf(ae,we-1),!(Le===-1||Le+ge!==we);){if(Le===0)return"";we=Le}return X.substring(0,we)}e.rtrim=a;function h(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function m(X){return X.replace(/\*/g,"")}e.stripWildcards=m;function I(X,ae,ge={}){if(!X)throw new Error("Cannot create regex from empty string");ae||(X=v(X)),ge.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let be="";return ge.global&&(be+="g"),ge.matchCase||(be+="i"),ge.multiline&&(be+="m"),ge.unicode&&(be+="u"),new RegExp(X,be)}e.createRegExp=I;function S(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function D(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=t;function c(X){return X.split(/\r\n|\r|\n/)}e.splitLines=c;function i(X){for(let ae=0,ge=X.length;ae<ge;ae++){const be=X.charCodeAt(ae);if(be!==32&&be!==9)return ae}return-1}e.firstNonWhitespaceIndex=i;function r(X,ae=0,ge=X.length){for(let be=ae;be<ge;be++){const we=X.charCodeAt(be);if(we!==32&&we!==9)return X.substring(ae,be)}return X.substring(ae,ge)}e.getLeadingWhitespace=r;function o(X,ae=X.length-1){for(let ge=ae;ge>=0;ge--){const be=X.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function u(X,ae,ge){const be=[];let we=0;for(const Le of X.matchAll(ae)){if(be.push(X.slice(we,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");we=Le.index+Le[0].length,be.push(ge(Le[0],...Le.slice(1),Le.index,X,Le.groups))}return be.push(X.slice(we)),Promise.all(be).then(Le=>Le.join(""))}e.replaceAsync=u;function s(X,ae){return X<ae?-1:X>ae?1:0}e.compare=s;function l(X,ae,ge=0,be=X.length,we=0,Le=ae.length){for(;ge<be&&we<Le;ge++,we++){const Ge=X.charCodeAt(ge),Ke=ae.charCodeAt(we);if(Ge<Ke)return-1;if(Ge>Ke)return 1}const We=be-ge,Ve=Le-we;return We<Ve?-1:We>Ve?1:0}e.compareSubstring=l;function P(X,ae){return A(X,ae,0,X.length,0,ae.length)}e.compareIgnoreCase=P;function A(X,ae,ge=0,be=X.length,we=0,Le=ae.length){for(;ge<be&&we<Le;ge++,we++){let Ge=X.charCodeAt(ge),Ke=ae.charCodeAt(we);if(Ge===Ke)continue;if(Ge>=128||Ke>=128)return l(X.toLowerCase(),ae.toLowerCase(),ge,be,we,Le);N(Ge)&&(Ge-=32),N(Ke)&&(Ke-=32);const Ye=Ge-Ke;if(Ye!==0)return Ye}const We=be-ge,Ve=Le-we;return We<Ve?-1:We>Ve?1:0}e.compareSubstringIgnoreCase=A;function O(X){return X>=48&&X<=57}e.isAsciiDigit=O;function N(X){return X>=97&&X<=122}e.isLowerAsciiLetter=N;function z(X){return X>=65&&X<=90}e.isUpperAsciiLetter=z;function H(X,ae){return X.length===ae.length&&A(X,ae)===0}e.equalsIgnoreCase=H;function ie(X,ae){const ge=ae.length;return ae.length>X.length?!1:A(X,ae,0,ge)===0}e.startsWithIgnoreCase=ie;function se(X,ae){const ge=Math.min(X.length,ae.length);let be;for(be=0;be<ge;be++)if(X.charCodeAt(be)!==ae.charCodeAt(be))return be;return ge}e.commonPrefixLength=se;function oe(X,ae){const ge=Math.min(X.length,ae.length);let be;const we=X.length-1,Le=ae.length-1;for(be=0;be<ge;be++)if(X.charCodeAt(we-be)!==ae.charCodeAt(Le-be))return be;return ge}e.commonSuffixLength=oe;function ue(X){return 55296<=X&&X<=56319}e.isHighSurrogate=ue;function le(X){return 56320<=X&&X<=57343}e.isLowSurrogate=le;function me(X,ae){return(X-55296<<10)+(ae-56320)+65536}e.computeCodePoint=me;function G(X,ae,ge){const be=X.charCodeAt(ge);if(ue(be)&&ge+1<ae){const we=X.charCodeAt(ge+1);if(le(we))return me(be,we)}return be}e.getNextCodePoint=G;function B(X,ae){const ge=X.charCodeAt(ae-1);if(le(ge)&&ae>1){const be=X.charCodeAt(ae-2);if(ue(be))return me(be,ge)}return ge}class T{get offset(){return this.e}constructor(ae,ge=0){this.c=ae,this.d=ae.length,this.e=ge}setOffset(ae){this.e=ae}prevCodePoint(){const ae=B(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=G(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}e.CodePointIterator=T;class q{get offset(){return this.c.offset}constructor(ae,ge=0){this.c=new T(ae,ge)}nextGraphemeLength(){const ae=Ie.getInstance(),ge=this.c,be=ge.offset;let we=ae.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Le=ge.offset,We=ae.getGraphemeBreakType(ge.nextCodePoint());if(ce(we,We)){ge.setOffset(Le);break}we=We}return ge.offset-be}prevGraphemeLength(){const ae=Ie.getInstance(),ge=this.c,be=ge.offset;let we=ae.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Le=ge.offset,We=ae.getGraphemeBreakType(ge.prevCodePoint());if(ce(We,we)){ge.setOffset(Le);break}we=We}return be-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=q;function Y(X,ae){return new q(X,ae).nextGraphemeLength()}e.nextCharLength=Y;function te(X,ae){return new q(X,ae).prevGraphemeLength()}e.prevCharLength=te;function ne(X,ae){ae>0&&le(X.charCodeAt(ae))&&ae--;const ge=ae+Y(X,ae);return[ge-te(X,ge),ge]}e.getCharContainingOffset=ne;function L(X){const ae=new q(X);let ge=0;for(;!ae.eol();)ge++,ae.nextGraphemeLength();return ge}e.charCount=L;let F;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(X){return F||(F=U()),F.test(X)}e.containsRTL=W;const $=/^[\t\n\r\x20-\x7E]*$/;function V(X){return $.test(X)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=j;function K(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=K;function J(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=J;function re(X,ae){if(X.length<ae)return X;const ge=/\b/g;let be=0;for(;ge.test(X)&&!(X.length-ge.lastIndex<ae);)be=ge.lastIndex,ge.lastIndex+=1;return X.substring(be).replace(/^\s/,"")}e.lcut=re;const de=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function Ce(X){return X&&(X=X.replace(de,"")),X}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function De(X){return Re(X)?X.substr(1):X}e.stripUTF8BOM=De;function Oe(X,ae){if(!X||!ae||X.length<ae.length)return!1;const ge=ae.length,be=X.toLowerCase();let we=0,Le=-1;for(;we<ge;){const We=be.indexOf(ae[we],Le+1);if(We<0)return!1;Le=We,we++}return!0}e.fuzzyContains=Oe;function $e(X,ae=!1){return X?(ae&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=$e;function fe(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=fe;function pe(X,ae=1){if(ae===0)return"";let ge=-1;do ge=X.indexOf(`
`,ge+1),ae--;while(ae>0&&ge>=0);return ge===-1?X:(X[ge-1]==="\r"&&ge--,X.substr(0,ge))}e.getNLines=pe;function Me(X){return X=X%(2*26),X<26?String.fromCharCode(97+X):String.fromCharCode(65+X-26)}e.singleLetterHash=Me;function ee(X){return Ie.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=ee;function ce(X,ae){return X===0?ae!==5&&ae!==7:X===2&&ae===3?!1:X===4||X===2||X===3||ae===4||ae===2||ae===3?!0:!(X===8&&(ae===8||ae===9||ae===11||ae===12)||(X===11||X===9)&&(ae===9||ae===10)||(X===12||X===10)&&ae===10||ae===5||ae===13||ae===7||X===1||X===13&&ae===14||X===6&&ae===6)}var he;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(he=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ie{static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Ae()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ge=this.d,be=ge.length/3;let we=1;for(;we<=be;)if(ae<ge[3*we])we=2*we;else if(ae>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}Ie.c=null;function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(X,ae){if(X===0)return 0;const ge=Fe(X,ae);if(ge!==void 0)return ge;const be=new T(ae,X);return be.prevCodePoint(),be.offset}e.getLeftDeleteOffset=Te;function Fe(X,ae){const ge=new T(ae,X);let be=ge.prevCodePoint();for(;je(be)||be===65039||be===8419;){if(ge.offset===0)return;be=ge.prevCodePoint()}if(!J(be))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function je(X){return 127995<=X&&X<=127999}var ze;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class Ue{static getInstance(ae){return Ue.d.get(Array.from(ae))}static getLocales(){return Ue.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}n=Ue,Ue.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ue.d=new E.LRUCachedFunction(X=>{function ae(Ke){const Ye=new Map;for(let Ze=0;Ze<Ke.length;Ze+=2)Ye.set(Ke[Ze],Ke[Ze+1]);return Ye}function ge(Ke,Ye){const Ze=new Map(Ke);for(const[st,ct]of Ye)Ze.set(st,ct);return Ze}function be(Ke,Ye){if(!Ke)return Ye;const Ze=new Map;for(const[st,ct]of Ke)Ye.has(st)&&Ze.set(st,ct);return Ze}const we=n.c.value;let Le=X.filter(Ke=>!Ke.startsWith("_")&&Ke in we);Le.length===0&&(Le=["_default"]);let We;for(const Ke of Le){const Ye=ae(we[Ke]);We=be(We,Ye)}const Ve=ae(we._common),Ge=ge(Ve,We);return new Ue(Ge)}),Ue.e=new M.Lazy(()=>Object.keys(Ue.c.value).filter(X=>!X.startsWith("_"))),e.AmbiguousCharacters=Ue;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(ae){return He.e().has(ae)}static get codePoints(){return He.e()}}He.d=void 0,e.InvisibleCharacters=He}),define(Z[32],_([0,1,9,4,27,10]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(o){return o===47||o===92}e.isPathSeparator=C;function k(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=k;function g(o){return o.indexOf("/")===-1&&(o=k(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=g;function f(o,u=E.posix.sep){if(!o)return"";const s=o.length,l=o.charCodeAt(0);if(C(l)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let A=3;const O=A;for(;A<s&&!C(o.charCodeAt(A));A++);if(O!==A&&!C(o.charCodeAt(A+1))){for(A+=1;A<s;A++)if(C(o.charCodeAt(A)))return o.slice(0,A+1).replace(/[\\/]/g,u)}}return u}else if(h(l)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let P=o.indexOf("://");if(P!==-1){for(P+=3;P<s;P++)if(C(o.charCodeAt(P)))return o.slice(0,P+1)}return""}e.getRoot=f;function b(o){if(!M.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let s=2;const l=s;for(;s<o.length&&(u=o.charCodeAt(s),u!==92);s++);return!(l===s||(u=o.charCodeAt(s+1),isNaN(u)||u===92))}e.isUNC=b;const v=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(o,u=M.isWindows){const s=u?v:y;return!(!o||o.length===0||/^\s+$/.test(o)||(s.lastIndex=0,s.test(o))||u&&d.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=w;function p(o,u,s){const l=o===u;return!s||l?l:!o||!u?!1:(0,n.equalsIgnoreCase)(o,u)}e.isEqual=p;function a(o,u,s,l=E.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(s){if(!(0,n.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let A=u.length;return u.charAt(u.length-1)===l&&A--,o.charAt(A)===l}return u.charAt(u.length-1)!==l&&(u+=l),o.indexOf(u)===0}e.isEqualOrParent=a;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function m(o,u){return M.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(u,o)),o=(0,E.normalize)(o),M.isWindows?(o=(0,n.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,n.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=m;function I(o){const u=(0,E.normalize)(o);return M.isWindows?o.length>3?!1:S(u)&&(o.length===2||u.charCodeAt(2)===92):u===E.posix.sep}e.isRootOrDriveLetter=I;function S(o,u=M.isWindows){return u?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function D(o){return S(o)?o[0]:void 0}e.getDriveLetter=D;function t(o,u,s){return u.length>o.length?-1:o===u?0:(s&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=t;function c(o){const u=o.split(":");let s,l,P;for(const A of u){const O=Number(A);(0,R.isNumber)(O)?l===void 0?l=O:P===void 0&&(P=O):s=s?[s,A].join(":"):A}if(!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:l!==void 0?l:void 0,column:P!==void 0?P:l!==void 0?1:void 0}}e.parseLineAndColumnAware=c;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(o,u,s=8){let l="";for(let A=0;A<s;A++)l+=i.charAt(Math.floor(Math.random()*i.length));let P;return u?P=`${u}-${l}`:P=l,o?(0,E.join)(o,P):P}e.randomPath=r}),define(Z[60],_([0,1,27]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function M(h){return n(h,0)}e.hash=M;function n(h,m){switch(typeof h){case"object":return h===null?R(349,m):Array.isArray(h)?g(h,m):f(h,m);case"string":return k(h,m);case"boolean":return C(h,m);case"number":return R(h,m);case"undefined":return R(937,m);default:return R(617,m)}}e.doHash=n;function R(h,m){return(m<<5)-m+h|0}e.numberHash=R;function C(h,m){return R(h?433:863,m)}function k(h,m){m=R(149417,m);for(let I=0,S=h.length;I<S;I++)m=R(h.charCodeAt(I),m);return m}e.stringHash=k;function g(h,m){return m=R(104579,m),h.reduce((I,S)=>n(S,I),m)}function f(h,m){return m=R(181387,m),Object.keys(h).sort().reduce((I,S)=>(I=k(S,I),n(h[S],I)),m)}class b{constructor(){this.g=0}get value(){return this.g}hash(m){return this.g=n(m,this.g),this.g}}e.Hasher=b;var v;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function y(h,m,I=32){const S=I-m,D=~((1<<S)-1);return(h<<m|(D&h)>>>S)>>>0}function d(h,m=0,I=h.byteLength,S=0){for(let D=0;D<I;D++)h[m+D]=S}function w(h,m,I="0"){for(;h.length<m;)h=I+h;return h}function p(h,m=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(I=>I.toString(16).padStart(2,"0")).join(""):w((h>>>0).toString(16),m/4)}e.toHexString=p;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(m){const I=m.length;if(I===0)return;const S=this.p;let D=this.r,t=this.u,c,i;for(t!==0?(c=t,i=-1,t=0):(c=m.charCodeAt(0),i=0);;){let r=c;if(E.isHighSurrogate(c))if(i+1<I){const o=m.charCodeAt(i+1);E.isLowSurrogate(o)?(i++,r=E.computeCodePoint(c,o)):r=65533}else{t=c;break}else E.isLowSurrogate(c)&&(r=65533);if(D=this.w(S,D,r),i++,i<I)c=m.charCodeAt(i);else break}this.r=D,this.u=t}w(m,I,S){return S<128?m[I++]=S:S<2048?(m[I++]=192|(S&1984)>>>6,m[I++]=128|(S&63)>>>0):S<65536?(m[I++]=224|(S&61440)>>>12,m[I++]=128|(S&4032)>>>6,m[I++]=128|(S&63)>>>0):(m[I++]=240|(S&1835008)>>>18,m[I++]=128|(S&258048)>>>12,m[I++]=128|(S&4032)>>>6,m[I++]=128|(S&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,m[0]=m[64+0],m[1]=m[64+1],m[2]=m[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const m=8*this.t;this.q.setUint32(56,Math.floor(m/4294967296),!1),this.q.setUint32(60,m%4294967296,!1),this.y()}y(){const m=a.g,I=this.q;for(let s=0;s<64;s+=4)m.setUint32(s,I.getUint32(s,!1),!1);for(let s=64;s<320;s+=4)m.setUint32(s,y(m.getUint32(s-12,!1)^m.getUint32(s-32,!1)^m.getUint32(s-56,!1)^m.getUint32(s-64,!1),1),!1);let S=this.h,D=this.l,t=this.m,c=this.n,i=this.o,r,o,u;for(let s=0;s<80;s++)s<20?(r=D&t|~D&c,o=1518500249):s<40?(r=D^t^c,o=1859775393):s<60?(r=D&t|D&c|t&c,o=2400959708):(r=D^t^c,o=3395469782),u=y(S,5)+r+i+o+m.getUint32(s*4,!1)&4294967295,i=c,c=t,t=y(D,30),D=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+i&4294967295}}a.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=a}),define(Z[73],_([0,1,27]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(n){n[n.Ignore=0]="Ignore",n[n.Info=1]="Info",n[n.Warning=2]="Warning",n[n.Error=3]="Error"})(M||(M={})),function(n){const R="error",C="warning",k="warn",g="info",f="ignore";function b(y){return y?E.equalsIgnoreCase(R,y)?n.Error:E.equalsIgnoreCase(C,y)||E.equalsIgnoreCase(k,y)?n.Warning:E.equalsIgnoreCase(g,y)?n.Info:n.Ignore:n.Ignore}n.fromValue=b;function v(y){switch(y){case n.Error:return R;case n.Warning:return C;case n.Info:return g;default:return f}}n.toString=v}(M||(M={})),e.default=M}),define(Z[61],_([0,1,25,27]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class n{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const w=d.charCodeAt(0),p=this.b.charCodeAt(this.c);return w-p}value(){return this.b[this.c]}}e.StringIterator=n;class R{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,M.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class C{constructor(d=!0,w=!0){this.f=d,this.g=w}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let w=d.length-1;w>=0;w--,this.c--){const p=this.b.charCodeAt(w);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const w=this.b.charCodeAt(this.e);if(w===47||this.f&&w===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,M.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var k;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(k||(k={}));class g{constructor(d,w){this.f=d,this.g=w,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,M.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=g;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(b||(b={}));class v{static forUris(d=()=>!1,w=()=>!1){return new v(new g(d,w))}static forPaths(d=!1){return new v(new C(void 0,!d))}static forStrings(){return new v(new n)}static forConfigKeys(){return new v(new R)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,w){if(w){const p=w.slice(0);(0,E.shuffle)(p);for(const a of p)this.set(a,d)}else{const p=d.slice(0);(0,E.shuffle)(p);for(const a of p)this.set(a[0],a[1])}}set(d,w){const p=this.b.reset(d);let a;this.c||(this.c=new f,this.c.segment=p.value());const h=[];for(a=this.c;;){const I=p.cmp(a.segment);if(I>0)a.left||(a.left=new f,a.left.segment=p.value()),h.push([-1,a]),a=a.left;else if(I<0)a.right||(a.right=new f,a.right.segment=p.value()),h.push([1,a]),a=a.right;else if(p.hasNext())p.next(),a.mid||(a.mid=new f,a.mid.segment=p.value()),h.push([0,a]),a=a.mid;else break}const m=a.value;a.value=w,a.key=d;for(let I=h.length-1;I>=0;I--){const S=h[I][1];S.updateHeight();const D=S.balanceFactor();if(D<-1||D>1){const t=h[I][0],c=h[I+1][0];if(t===1&&c===1)h[I][1]=S.rotateLeft();else if(t===-1&&c===-1)h[I][1]=S.rotateRight();else if(t===1&&c===-1)S.right=h[I+1][1]=h[I+1][1].rotateRight(),h[I][1]=S.rotateLeft();else if(t===-1&&c===1)S.left=h[I+1][1]=h[I+1][1].rotateLeft(),h[I][1]=S.rotateRight();else throw new Error;if(I>0)switch(h[I-1][0]){case-1:h[I-1][1].left=h[I][1];break;case 1:h[I-1][1].right=h[I][1];break;case 0:h[I-1][1].mid=h[I][1];break}else this.c=h[0][1]}}return m}get(d){return this.d(d)?.value}d(d){const w=this.b.reset(d);let p=this.c;for(;p;){const a=w.cmp(p.segment);if(a>0)p=p.left;else if(a<0)p=p.right;else if(w.hasNext())w.next(),p=p.mid;else break}return p}has(d){const w=this.d(d);return!(w?.value===void 0&&w?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,w){const p=this.b.reset(d),a=[];let h=this.c;for(;h;){const m=p.cmp(h.segment);if(m>0)a.push([-1,h]),h=h.left;else if(m<0)a.push([1,h]),h=h.right;else if(p.hasNext())p.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(w?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const m=this.f(h.right);if(m.key){const{key:I,value:S,segment:D}=m;this.e(m.key,!1),h.key=I,h.value=S,h.segment=D}}else{const m=h.left??h.right;if(a.length>0){const[I,S]=a[a.length-1];switch(I){case-1:S.left=m;break;case 0:S.mid=m;break;case 1:S.right=m;break}}else this.c=m}for(let m=a.length-1;m>=0;m--){const I=a[m][1];I.updateHeight();const S=I.balanceFactor();if(S>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),a[m][1]=I.rotateLeft()):S<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),a[m][1]=I.rotateRight()),m>0)switch(a[m-1][0]){case-1:a[m-1][1].left=a[m][1];break;case 1:a[m-1][1].right=a[m][1];break;case 0:a[m-1][1].mid=a[m][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const w=this.b.reset(d);let p=this.c,a;for(;p;){const h=w.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(w.hasNext())w.next(),a=p.value||a,p=p.mid;else break}return p&&p.value||a}findSuperstr(d){return this.g(d,!1)}g(d,w){const p=this.b.reset(d);let a=this.c;for(;a;){const h=p.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(p.hasNext())p.next(),a=a.mid;else return a.mid?this.h(a.mid):w?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[w,p]of this)d(p,w)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const w=[];return this.j(d,w),w[Symbol.iterator]()}j(d,w){!d||(d.left&&this.j(d.left,w),d.value&&w.push([d.key,d.value]),d.mid&&this.j(d.mid,w),d.right&&this.j(d.right,w))}_isBalanced(){const d=w=>{if(!w)return!0;const p=w.balanceFactor();return p<-1||p>1?!1:d(w.left)&&d(w.right)};return d(this.c)}}e.TernarySearchTree=v}),define(Z[8],_([0,1,9,4]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const n=/^\w[\w\d+.-]*$/,R=/^\//,C=/^\/\//;function k(i,r){if(!i.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!n.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(i,r){return!i&&!r?"file":i}function f(i,r){switch(i){case"https":case"http":case"file":r?r[0]!==v&&(r=v+r):r=v;break}return r}const b="",v="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(r){return r instanceof d?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}constructor(r,o,u,s,l,P=!1){typeof r=="object"?(this.scheme=r.scheme||b,this.authority=r.authority||b,this.path=r.path||b,this.query=r.query||b,this.fragment=r.fragment||b):(this.scheme=g(r,P),this.authority=o||b,this.path=f(this.scheme,u||b),this.query=s||b,this.fragment=l||b,k(this,P))}get fsPath(){return I(this,!1)}with(r){if(!r)return this;let{scheme:o,authority:u,path:s,query:l,fragment:P}=r;return o===void 0?o=this.scheme:o===null&&(o=b),u===void 0?u=this.authority:u===null&&(u=b),s===void 0?s=this.path:s===null&&(s=b),l===void 0?l=this.query:l===null&&(l=b),P===void 0?P=this.fragment:P===null&&(P=b),o===this.scheme&&u===this.authority&&s===this.path&&l===this.query&&P===this.fragment?this:new p(o,u,s,l,P)}static parse(r,o=!1){const u=y.exec(r);return u?new p(u[2]||b,c(u[4]||b),c(u[5]||b),c(u[7]||b),c(u[9]||b),o):new p(b,b,b,b,b)}static file(r){let o=b;if(M.isWindows&&(r=r.replace(/\\/g,v)),r[0]===v&&r[1]===v){const u=r.indexOf(v,2);u===-1?(o=r.substring(2),r=v):(o=r.substring(2,u),r=r.substring(u)||v)}return new p("file",o,r,b,b)}static from(r){const o=new p(r.scheme,r.authority,r.path,r.query,r.fragment);return k(o,!0),o}static joinPath(r,...o){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return M.isWindows&&r.scheme==="file"?u=d.file(E.win32.join(I(r,!0),...o)).path:u=E.posix.join(r.path,...o),r.with({path:u})}toString(r=!1){return S(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof d)return r;{const o=new p(r);return o._formatted=r.external,o._fsPath=r._sep===w?r.fsPath:null,o}}else return r}}e.URI=d;const w=M.isWindows?1:void 0;class p extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=I(this,!1)),this._fsPath}toString(r=!1){return r?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=w),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,r,o){let u,s=-1;for(let l=0;l<i.length;l++){const P=i.charCodeAt(l);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||r&&P===47||o&&P===91||o&&P===93||o&&P===58)s!==-1&&(u+=encodeURIComponent(i.substring(s,l)),s=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const A=a[P];A!==void 0?(s!==-1&&(u+=encodeURIComponent(i.substring(s,l)),s=-1),u+=A):s===-1&&(s=l)}}return s!==-1&&(u+=encodeURIComponent(i.substring(s))),u!==void 0?u:i}function m(i){let r;for(let o=0;o<i.length;o++){const u=i.charCodeAt(o);u===35||u===63?(r===void 0&&(r=i.substr(0,o)),r+=a[u]):r!==void 0&&(r+=i[o])}return r!==void 0?r:i}function I(i,r){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?r?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,M.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=I;function S(i,r){const o=r?m:h;let u="",{scheme:s,authority:l,path:P,query:A,fragment:O}=i;if(s&&(u+=s,u+=":"),(l||s==="file")&&(u+=v,u+=v),l){let N=l.indexOf("@");if(N!==-1){const z=l.substr(0,N);l=l.substr(N+1),N=z.lastIndexOf(":"),N===-1?u+=o(z,!1,!1):(u+=o(z.substr(0,N),!1,!1),u+=":",u+=o(z.substr(N+1),!1,!0)),u+="@"}l=l.toLowerCase(),N=l.lastIndexOf(":"),N===-1?u+=o(l,!1,!0):(u+=o(l.substr(0,N),!1,!0),u+=l.substr(N))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const N=P.charCodeAt(1);N>=65&&N<=90&&(P=`/${String.fromCharCode(N+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const N=P.charCodeAt(0);N>=65&&N<=90&&(P=`${String.fromCharCode(N+32)}:${P.substr(2)}`)}u+=o(P,!0,!1)}return A&&(u+="?",u+=o(A,!1,!1)),O&&(u+="#",u+=r?O:h(O,!1,!1)),u}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function c(i){return i.match(t)?i.replace(t,r=>D(r)):i}}),define(Z[148],_([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(f){const b=f;return b&&typeof b.type=="string"&&typeof b.severity=="string"}e.isRemoteConsoleLog=M;function n(f){const b=[];let v;try{const y=JSON.parse(f.arguments),d=y[y.length-1];d&&d.__$stack&&(y.pop(),v=d.__$stack),b.push(...y)}catch{b.push("Unable to log remote console arguments",f.arguments)}return{args:b,stack:v}}e.parse=n;function R(f){if(typeof f!="string")return R(n(f).stack);const b=f;if(b){const v=C(b),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(y&&y.length===4)return{uri:E.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.getFirstFrame=R;function C(f){if(!f)return f;const b=f.indexOf(`
`);return b===-1?f:f.substring(0,b)}function k(f,b){const{args:v,stack:y}=n(f),d=typeof v[0]=="string"&&v.length===1;let w=C(y);w&&(w=`(${w.trim()})`);let p=[];if(typeof v[0]=="string"?w&&d?p=[`%c[${b}] %c${v[0]} %c${w}`,g("blue"),g(""),g("grey")]:p=[`%c[${b}] %c${v[0]}`,g("blue"),g(""),...v.slice(1)]:p=[`%c[${b}]%`,g("blue"),...v],w&&!d&&p.push(w),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,p)}e.log=k;function g(f){return`color: ${f}`}}),define(Z[83],_([0,1,17,27,8]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(f){return JSON.stringify(f,k)}e.stringify=R;function C(f){let b=JSON.parse(f);return b=g(b),b}e.parse=C;function k(f,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,M.regExpFlags)(b)}:b}function g(f,b=0){if(!f||b>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return n.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 16:return new Date(f.source)}if(f instanceof E.VSBuffer||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let v=0;v<f.length;++v)f[v]=g(f[v],b+1);else for(const v in f)Object.hasOwnProperty.call(f,v)&&(f[v]=g(f[v],b+1))}return f}e.revive=g}),define(Z[14],_([0,1,13,4,8]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractive="vscode-interactive",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b){this.f=`${b}/${R.vscodeRemoteResource}`}set(b,v,y){this.a[b]=v,this.b[b]=y}setConnectionToken(b,v){this.c[b]=v}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch(a){return E.onUnexpectedError(a),b}const v=b.authority;let y=this.a[v];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const d=this.b[v],w=this.c[v];let p=`path=${encodeURIComponent(b.path)}`;return typeof w=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(w)}`),n.URI.from({scheme:M.isWeb?this.d:R.vscodeRemoteResource,authority:`${y}:${d}`,path:this.f,query:p})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(b){const v=this.b(b,x);return this.uriToBrowserUri(v)}uriToBrowserUri(b){return b.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(b):b.scheme===R.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${R.vscodeFileResource}://${k.a}`)?b.with({scheme:R.vscodeFileResource,authority:b.authority||k.a,query:null,fragment:null}):b}asFileUri(b){const v=this.b(b,x);return this.uriToFileUri(v)}uriToFileUri(b){return b.scheme===R.vscodeFileResource?b.with({scheme:R.file,authority:b.authority!==k.a?b.authority:null,query:null,fragment:null}):b}b(b,v){return n.URI.isUri(b)?b:n.URI.parse(v.toUrl(b))}}k.a="vscode-app",e.FileAccess=new k;var g;(function(f){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(b.get("3"));const v="vscode-coi";function y(w){let p;typeof w=="string"?p=new URL(w).searchParams:w instanceof URL?p=w.searchParams:n.URI.isUri(w)&&(p=new URL(w.toString(!0)).searchParams);const a=p?.get(v);if(!!a)return b.get(a)}f.getHeadersFromQuery=y;function d(w,p,a){if(!globalThis.crossOriginIsolated)return;const h=p&&a?"3":a?"2":"1";w instanceof URLSearchParams?w.set(v,h):w[v]=h}f.addSearchParam=d})(g=e.COI||(e.COI={}))}),define(Z[18],_([0,1,32,14,9,4,27,8]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function g(d){return(0,k.uriToFsPath)(d,!0)}e.originalFSPath=g;class f{constructor(w){this.a=w}compare(w,p,a=!1){return w===p?0:(0,C.compare)(this.getComparisonKey(w,a),this.getComparisonKey(p,a))}isEqual(w,p,a=!1){return w===p?!0:!w||!p?!1:this.getComparisonKey(w,a)===this.getComparisonKey(p,a)}getComparisonKey(w,p=!1){return w.with({path:this.a(w)?w.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(w){return this.a(w)}isEqualOrParent(w,p,a=!1){if(w.scheme===p.scheme){if(w.scheme===M.Schemas.file)return E.isEqualOrParent(g(w),g(p),this.a(w))&&w.query===p.query&&(a||w.fragment===p.fragment);if((0,e.isEqualAuthority)(w.authority,p.authority))return E.isEqualOrParent(w.path,p.path,this.a(w),"/")&&w.query===p.query&&(a||w.fragment===p.fragment)}return!1}joinPath(w,...p){return k.URI.joinPath(w,...p)}basenameOrAuthority(w){return(0,e.basename)(w)||w.authority}basename(w){return n.posix.basename(w.path)}extname(w){return n.posix.extname(w.path)}dirname(w){if(w.path.length===0)return w;let p;return w.scheme===M.Schemas.file?p=k.URI.file(n.dirname(g(w))).path:(p=n.posix.dirname(w.path),w.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${w.toString})) resulted in a relative path`),p="/")),w.with({path:p})}normalizePath(w){if(!w.path.length)return w;let p;return w.scheme===M.Schemas.file?p=k.URI.file(n.normalize(g(w))).path:p=n.posix.normalize(w.path),w.with({path:p})}relativePath(w,p){if(w.scheme!==p.scheme||!(0,e.isEqualAuthority)(w.authority,p.authority))return;if(w.scheme===M.Schemas.file){const m=n.relative(g(w),g(p));return R.isWindows?E.toSlashes(m):m}let a=w.path||"/";const h=p.path||"/";if(this.a(w)){let m=0;for(const I=Math.min(a.length,h.length);m<I&&!(a.charCodeAt(m)!==h.charCodeAt(m)&&a.charAt(m).toLowerCase()!==h.charAt(m).toLowerCase());m++);a=h.substr(0,m)+a.substr(m)}return n.posix.relative(a,h)}resolvePath(w,p){if(w.scheme===M.Schemas.file){const a=k.URI.file(n.resolve(g(w),p));return w.with({authority:a.authority,path:a.path})}return p=E.toPosixPath(p),w.with({path:n.posix.resolve(w.path,p)})}isAbsolutePath(w){return!!w.path&&w.path[0]==="/"}isEqualAuthority(w,p){return w===p||w!==void 0&&p!==void 0&&(0,C.equalsIgnoreCase)(w,p)}hasTrailingPathSeparator(w,p=n.sep){if(w.scheme===M.Schemas.file){const a=g(w);return a.length>E.getRoot(a).length&&a[a.length-1]===p}else{const a=w.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(w.fsPath)}}removeTrailingPathSeparator(w,p=n.sep){return(0,e.hasTrailingPathSeparator)(w,p)?w.with({path:w.path.substr(0,w.path.length-1)}):w}addTrailingPathSeparator(w,p=n.sep){let a=!1;if(w.scheme===M.Schemas.file){const h=g(w);a=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===p}else{p="/";const h=w.path;a=h.length===1&&h.charCodeAt(h.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(w,p)?w.with({path:w.path+"/"}):w}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(d=>d.scheme===M.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new f(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function b(d,w){const p=[];for(let a=0;a<d.length;a++){const h=w(d[a]);d.some((m,I)=>I===a?!1:(0,e.isEqualOrParent)(h,w(m)))||p.push(d[a])}return p}e.distinctParents=b;var v;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function w(p){const a=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(I=>{const[S,D]=I.split(":");S&&D&&a.set(S,D)});const m=p.path.substring(0,p.path.indexOf(";"));return m&&a.set(d.META_DATA_MIME,m),a}d.parseMetaData=w})(v=e.DataUri||(e.DataUri={}));function y(d,w,p){if(w){let a=d.path;return a&&a[0]!==n.posix.sep&&(a=n.posix.sep+a),d.with({scheme:p,authority:w,path:a})}return d.with({scheme:p})}e.toLocalResource=y}),define(Z[7],_([0,1,22,13,3,2,18,4,133]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function f(L){return!!L&&typeof L.then=="function"}e.isThenable=f;function b(L){const F=new E.CancellationTokenSource,U=L(F.token),W=new Promise(($,V)=>{const j=F.token.onCancellationRequested(()=>{j.dispose(),F.dispose(),V(new M.CancellationError)});Promise.resolve(U).then(K=>{j.dispose(),F.dispose(),$(K)},K=>{j.dispose(),F.dispose(),V(K)})});return new class{cancel(){F.cancel()}then($,V){return W.then($,V)}catch($){return this.then(void 0,$)}finally($){return W.finally($)}}}e.createCancelablePromise=b;function v(L,F,U){return new Promise((W,$)=>{const V=F.onCancellationRequested(()=>{V.dispose(),W(U)});L.then(W,$).finally(()=>V.dispose())})}e.raceCancellation=v;function y(L,F){return new Promise((U,W)=>{const $=F.onCancellationRequested(()=>{$.dispose(),W(new M.CancellationError)});L.then(U,W).finally(()=>$.dispose())})}e.raceCancellationError=y;async function d(L){let F=-1;const U=L.map(($,V)=>$.then(j=>(F=V,j))),W=await Promise.race(U);return L.forEach(($,V)=>{V!==F&&$.cancel()}),W}e.raceCancellablePromises=d;function w(L,F,U){let W;const $=setTimeout(()=>{W?.(void 0),U?.()},F);return Promise.race([L.finally(()=>clearTimeout($)),new Promise(V=>W=V)])}e.raceTimeout=w;function p(L){return new Promise((F,U)=>{const W=L();f(W)?W.then(F,U):F(W)})}e.asPromise=p;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(F){if(this.a){if(this.d=F,!this.b){const U=()=>{this.b=null;const W=this.queue(this.d);return this.d=null,W};this.b=new Promise(W=>{this.a.then(U,U).then(W)})}return new Promise((U,W)=>{this.b.then(U,W)})}return this.a=F(),new Promise((U,W)=>{this.a.then($=>{this.a=null,U($)},$=>{this.a=null,W($)})})}}e.Throttler=a;class h{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.Sequencer=h;class m{constructor(){this.a=new Map}queue(F,U){const $=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(F)===$&&this.a.delete(F)});return this.a.set(F,$),$}}e.SequencerByKey=m;const I=(L,F)=>{let U=!0;const W=setTimeout(()=>{U=!1,F()},L);return{isTriggered:()=>U,dispose:()=>{clearTimeout(W),U=!1}}},S=L=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,L())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class D{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,U=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise(($,V)=>{this.d=$,this.f=V}).then(()=>{if(this.b=null,this.d=null,this.g){const $=this.g;return this.g=null,$()}}));const W=()=>{this.a=null,this.d?.(null)};return this.a=U===g.MicrotaskDelay?S(W):I(U,W),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(F){this.a=new D(F),this.b=new a}trigger(F,U){return this.a.trigger(()=>this.b.queue(F),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class c{constructor(){this.a=!1,this.b=new Promise((F,U)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=c;class i extends c{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function r(L,F){return F?new Promise((U,W)=>{const $=setTimeout(()=>{V.dispose(),U()},L),V=F.onCancellationRequested(()=>{clearTimeout($),V.dispose(),W(new M.CancellationError)})}):b(U=>r(L,U))}e.timeout=r;function o(L,F=0){const U=setTimeout(L,F);return(0,R.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=o;function u(L){const F=[];let U=0;const W=L.length;function $(){return U<W?L[U++]():null}function V(j){j!=null&&F.push(j);const K=$();return K?K.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=u;function s(L,F=W=>!!W,U=null){let W=0;const $=L.length,V=()=>{if(W>=$)return Promise.resolve(U);const j=L[W++];return Promise.resolve(j()).then(J=>F(J)?Promise.resolve(J):V())};return V()}e.first=s;function l(L,F=W=>!!W,U=null){if(L.length===0)return Promise.resolve(U);let W=L.length;const $=()=>{W=-1;for(const V of L)V.cancel?.()};return new Promise((V,j)=>{for(const K of L)K.then(J=>{--W>=0&&F(J)?($(),V(J)):W===0&&V(U)}).catch(J=>{--W>=0&&($(),j(J))})})}e.firstParallel=l;class P{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new n.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((U,W)=>{this.f.push({factory:F,c:U,e:W}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const U=F.factory();U.then(F.c,F.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=P;class A extends P{constructor(){super(1)}}e.Queue=A;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const F=new B;return this.b.add(F),F.p}d(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,U=C.extUri){const W=U.getComparisonKey(F);let $=this.a.get(W);return $||($=new A,n.Event.once($.onDrained)(()=>{$?.dispose(),this.a.delete(W),this.f()}),this.a.set(W,$)),$}f(){!this.d()||this.g()}g(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class N{constructor(F,U){this.a=-1,typeof F=="function"&&typeof U=="number"&&this.setIfNotSet(F,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},U)}setIfNotSet(F,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},U))}}e.TimeoutTimer=N;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,U){this.cancel(),this.a=setInterval(()=>{F()},U)}}e.IntervalTimer=z;class H{constructor(F,U){this.b=-1,this.a=F,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class ie{constructor(F,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=F,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=ie;class se extends H{constructor(F,U){super(F,U),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=se;class oe extends R.Disposable{constructor(F,U){super(),this.g=F,this.h=U,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of F)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=oe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=L=>{(0,k.setTimeout0)(()=>{if(F)return;const U=Date.now()+15;L(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(L,F)=>{const U=requestIdleCallback(L,typeof F=="number"?{timeout:F}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(U))}}}}();class ue{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ue;async function le(L,F,U){let W;for(let $=0;$<U;$++)try{return await L()}catch(V){W=V,await r(F)}throw W}e.retry=le;class me{hasPending(F){return this.a?typeof F=="number"?this.a.taskId===F:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(F,U,W){return this.a={taskId:F,cancel:()=>W?.(),promise:U},U.then(()=>this.d(F),()=>this.d(F)),U}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this.b)this.b.run=F;else{let U,W;const $=new Promise((V,j)=>{U=V,W=j});this.b={run:F,promise:$,promiseResolve:U,promiseReject:W}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=me;class G{constructor(F,U=()=>Date.now()){this.d=F,this.f=U,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.IntervalCounter=G;class B{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((F,U)=>{this.a=F,this.b=U})}complete(F){return new Promise(U=>{this.a(F),this.f=!0,U()})}error(F){return new Promise(U=>{this.b(F),this.d=!0,U()})}cancel(){new Promise(F=>{this.b(new M.CancellationError),this.d=!0,F()})}}e.DeferredPromise=B;var T;(function(L){async function F(W){let $;const V=await Promise.all(W.map(j=>j.then(K=>K,K=>{$||($=K)})));if(typeof $<"u")throw $;return V}L.settled=F;function U(W){return new Promise(async($,V)=>{try{await W($,V)}catch(j){V(j)}})}L.withAsyncBody=U})(T=e.Promises||(e.Promises={}));var q;(function(L){L[L.Initial=0]="Initial",L[L.DoneOK=1]="DoneOK",L[L.DoneError=2]="DoneError"})(q||(q={}));class Y{static fromArray(F){return new Y(U=>{U.emitMany(F)})}static fromPromise(F){return new Y(async U=>{U.emitMany(await F)})}static fromPromises(F){return new Y(async U=>{await Promise.all(F.map(async W=>U.emitOne(await W)))})}static merge(F){return new Y(async U=>{await Promise.all(F.map(async W=>{for await(const $ of W)U.emitOne($)}))})}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new n.Emitter,queueMicrotask(async()=>{const U={emitOne:W=>this.g(W),emitMany:W=>this.h(W),reject:W=>this.k(W)};try{await Promise.resolve(F(U)),this.j()}catch(W){this.k(W)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(F,U){return new Y(async W=>{for await(const $ of F)W.emitOne(U($))})}map(F){return Y.map(this,F)}static filter(F,U){return new Y(async W=>{for await(const $ of F)U($)&&W.emitOne($)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,U=>!!U)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const U=[];for await(const W of F)U.push(W);return U}toPromise(){return Y.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}Y.EMPTY=Y.fromArray([]),e.AsyncIterableObject=Y;class te extends Y{constructor(F,U){super(U),this.l=F}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=te;function ne(L){const F=new E.CancellationTokenSource,U=L(F.token);return new te(F,async W=>{const $=F.token.onCancellationRequested(()=>{$.dispose(),F.dispose(),W.reject(new M.CancellationError)});try{for await(const V of U){if(F.token.isCancellationRequested)return;W.emitOne(V)}$.dispose(),F.dispose()}catch(V){$.dispose(),F.dispose(),W.reject(V)}})}e.createCancelableAsyncIterable=ne}),define(Z[101],_([0,1,25,7,32,35,9,4,27]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function f(){return Object.create(null)}e.getEmptyExpression=f,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",v="[^/\\\\]",y=/\//g;function d(G,B){switch(G){case 0:return"";case 1:return`${v}*?`;default:return`(?:${b}|${v}+${b}${B?`|${b}${v}+`:""})*?`}}function w(G,B){if(!G)return[];const T=[];let q=!1,Y=!1,te="";for(const ne of G){switch(ne){case B:if(!q&&!Y){T.push(te),te="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}te+=ne}return te&&T.push(te),T}e.splitGlobAware=w;function p(G){if(!G)return"";let B="";const T=w(G,e.GLOB_SPLIT);if(T.every(q=>q===e.GLOBSTAR))B=".*";else{let q=!1;T.forEach((Y,te)=>{if(Y===e.GLOBSTAR){if(q)return;B+=d(2,te===T.length-1)}else{let ne=!1,L="",F=!1,U="";for(const W of Y){if(W!=="}"&&ne){L+=W;continue}if(F&&(W!=="]"||!U)){let $;W==="-"?$=W:(W==="^"||W==="!")&&!U?$="^":W===e.GLOB_SPLIT?$="":$=(0,g.escapeRegExpCharacters)(W),U+=$;continue}switch(W){case"{":ne=!0;continue;case"[":F=!0;continue;case"}":{B+=`(?:${w(L,",").map(j=>p(j)).join("|")})`,ne=!1,L="";break}case"]":{B+="["+U+"]",F=!1,U="";break}case"?":B+=v;continue;case"*":B+=d(1);continue;default:B+=(0,g.escapeRegExpCharacters)(W)}}te<T.length-1&&(T[te+1]!==e.GLOBSTAR||te+2<T.length)&&(B+=b)}q=Y===e.GLOBSTAR})}return B}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,I=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),c=function(){return!1},i=function(){return null};function r(G,B){if(!G)return i;let T;typeof G!="string"?T=G.pattern:T=G,T=T.trim();const q=`${T}_${!!B.trimForExclusions}`;let Y=t.get(q);if(Y)return o(Y,G);let te;return a.test(T)?Y=s(T.substr(4),T):(te=h.exec(u(T,B)))?Y=l(te[1],T):(B.trimForExclusions?I:m).test(T)?Y=P(T,B):(te=S.exec(u(T,B)))?Y=A(te[1].substr(1),T,!0):(te=D.exec(u(T,B)))?Y=A(te[1],T,!1):Y=O(T),t.set(q,Y),o(Y,G)}function o(G,B){if(typeof B=="string")return G;const T=function(q,Y){return(0,n.isEqualOrParent)(q,B.base,!k.isLinux)?G((0,g.ltrim)(q.substr(B.base.length),C.sep),Y):null};return T.allBasenames=G.allBasenames,T.allPaths=G.allPaths,T.basenames=G.basenames,T.patterns=G.patterns,T}function u(G,B){return B.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function s(G,B){return function(T,q){return typeof T=="string"&&T.endsWith(G)?B:null}}function l(G,B){const T=`/${G}`,q=`\\${G}`,Y=function(ne,L){return typeof ne!="string"?null:L?L===G?B:null:ne===G||ne.endsWith(T)||ne.endsWith(q)?B:null},te=[G];return Y.basenames=te,Y.patterns=[B],Y.allBasenames=te,Y}function P(G,B){const T=le(G.slice(1,-1).split(",").map(L=>r(L,B)).filter(L=>L!==i),G),q=T.length;if(!q)return i;if(q===1)return T[0];const Y=function(L,F){for(let U=0,W=T.length;U<W;U++)if(T[U](L,F))return G;return null},te=T.find(L=>!!L.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=T.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return ne.length&&(Y.allPaths=ne),Y}function A(G,B,T){const q=C.sep===C.posix.sep,Y=q?G:G.replace(y,C.sep),te=C.sep+Y,ne=C.posix.sep+G;let L;return T?L=function(F,U){return typeof F=="string"&&(F===Y||F.endsWith(te)||!q&&(F===G||F.endsWith(ne)))?B:null}:L=function(F,U){return typeof F=="string"&&(F===Y||!q&&F===G)?B:null},L.allPaths=[(T?"*/":"./")+G],L}function O(G){try{const B=new RegExp(`^${p(G)}$`);return function(T){return B.lastIndex=0,typeof T=="string"&&B.test(T)?G:null}}catch{return i}}function N(G,B,T){return!G||typeof B!="string"?!1:z(G)(B,void 0,T)}e.match=N;function z(G,B={}){if(!G)return c;if(typeof G=="string"||H(G)){const T=r(G,B);if(T===i)return c;const q=function(Y,te){return!!T(Y,te)};return T.allBasenames&&(q.allBasenames=T.allBasenames),T.allPaths&&(q.allPaths=T.allPaths),q}return oe(G,B)}e.parse=z;function H(G){const B=G;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=H;function ie(G){return G.allBasenames||[]}e.getBasenameTerms=ie;function se(G){return G.allPaths||[]}e.getPathTerms=se;function oe(G,B){const T=le(Object.getOwnPropertyNames(G).map(L=>ue(L,G[L],B)).filter(L=>L!==i)),q=T.length;if(!q)return i;if(!T.some(L=>!!L.requiresSiblings)){if(q===1)return T[0];const L=function(W,$){let V;for(let j=0,K=T.length;j<K;j++){const J=T[j](W,$);if(typeof J=="string")return J;(0,M.isThenable)(J)&&(V||(V=[]),V.push(J))}return V?(async()=>{for(const j of V){const K=await j;if(typeof K=="string")return K}return null})():null},F=T.find(W=>!!W.allBasenames);F&&(L.allBasenames=F.allBasenames);const U=T.reduce((W,$)=>$.allPaths?W.concat($.allPaths):W,[]);return U.length&&(L.allPaths=U),L}const Y=function(L,F,U){let W,$;for(let V=0,j=T.length;V<j;V++){const K=T[V];K.requiresSiblings&&U&&(F||(F=(0,C.basename)(L)),W||(W=F.substr(0,F.length-(0,C.extname)(L).length)));const J=K(L,F,W,U);if(typeof J=="string")return J;(0,M.isThenable)(J)&&($||($=[]),$.push(J))}return $?(async()=>{for(const V of $){const j=await V;if(typeof j=="string")return j}return null})():null},te=T.find(L=>!!L.allBasenames);te&&(Y.allBasenames=te.allBasenames);const ne=T.reduce((L,F)=>F.allPaths?L.concat(F.allPaths):L,[]);return ne.length&&(Y.allPaths=ne),Y}function ue(G,B,T){if(B===!1)return i;const q=r(G,T);if(q===i)return i;if(typeof B=="boolean")return q;if(B){const Y=B.when;if(typeof Y=="string"){const te=(ne,L,F,U)=>{if(!U||!q(ne,L))return null;const W=Y.replace("$(basename)",()=>F),$=U(W);return(0,M.isThenable)($)?$.then(V=>V?G:null):$?G:null};return te.requiresSiblings=!0,te}}return q}function le(G,B){const T=G.filter(L=>!!L.basenames);if(T.length<2)return G;const q=T.reduce((L,F)=>{const U=F.basenames;return U?L.concat(U):L},[]);let Y;if(B){Y=[];for(let L=0,F=q.length;L<F;L++)Y.push(B)}else Y=T.reduce((L,F)=>{const U=F.patterns;return U?L.concat(U):L},[]);const te=function(L,F){if(typeof L!="string")return null;if(!F){let W;for(W=L.length;W>0;W--){const $=L.charCodeAt(W-1);if($===47||$===92)break}F=L.substr(W)}const U=q.indexOf(F);return U!==-1?Y[U]:null};te.basenames=q,te.patterns=Y,te.allBasenames=q;const ne=G.filter(L=>!L.basenames);return ne.push(te),ne}function me(G,B){return(0,E.equals)(G,B,(T,q)=>typeof T=="string"&&typeof q=="string"?T===q:typeof T!="string"&&typeof q!="string"?T.base===q.base&&T.pattern===q.pattern:!1)}e.patternsEquals=me}),define(Z[45],_([0,1,25,32,9,4,18,27]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function g(i,r){const{os:o,tildify:u,relative:s}=r;if(s){const A=f(i,s,o);if(typeof A=="string")return A}let l=i.fsPath;if(o===1&&!R.isWindows?l=l.replace(/\//g,"\\"):o!==1&&R.isWindows&&(l=l.replace(/\\/g,"/")),o!==1&&u?.userHome){const A=u.userHome.fsPath;let O;i.scheme!==u.userHome.scheme&&i.path.startsWith(n.posix.sep)?O=u.userHome.with({path:i.path}).fsPath:O=i.fsPath,l=y(O,A,o)}return(o===1?n.win32:n.posix).normalize(b(l,o===1))}e.getPathLabel=g;function f(i,r,o){const u=o===1?n.win32:n.posix,s=o===3?C.extUri:C.extUriIgnorePathCase,l=r.getWorkspace(),P=(0,E.firstOrDefault)(l.folders);if(!P)return;i.scheme!==P.uri.scheme&&i.path.startsWith(n.posix.sep)&&(i=P.uri.with({path:i.path}));const A=r.getWorkspaceFolder(i);if(!A)return;let O;if(s.isEqual(A.uri,i)?O="":O=s.relativePath(A.uri,i)??"",O&&(O=u.normalize(O)),l.folders.length>1&&!r.noPrefix){const N=A.name?A.name:s.basenameOrAuthority(A.uri);O=O?`${N} \u2022 ${O}`:N}return O}function b(i,r=R.isWindows){return(0,M.hasDriveLetter)(i,r)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let v=Object.create(null);function y(i,r,o=R.OS){if(o===1||!i||!r)return i;let u=v.original===r?v.normalized:void 0;u||(u=r,R.isWindows&&(u=(0,M.toSlashes)(u)),u=`${(0,k.rtrim)(u,n.posix.sep)}${n.posix.sep}`,v={original:r,normalized:u});let s=i;return R.isWindows&&(s=(0,M.toSlashes)(s)),(o===3?s.startsWith(u):(0,k.startsWithIgnoreCase)(s,u))?`~/${s.substr(u.length)}`:i}e.tildify=y;function d(i,r){return i.replace(/^~($|\/|\\)/,`${r}$1`)}e.untildify=d;const w="\u2026",p="\\\\",a="~";function h(i,r=n.sep){const o=new Array(i.length);let u=!1;for(let s=0;s<i.length;s++){const l=i[s];if(l===""){o[s]=`.${r}`;continue}if(!l){o[s]=l;continue}u=!0;let P="",A=l;A.indexOf(p)===0?(P=A.substr(0,A.indexOf(p)+p.length),A=A.substr(A.indexOf(p)+p.length)):A.indexOf(r)===0?(P=A.substr(0,A.indexOf(r)+r.length),A=A.substr(A.indexOf(r)+r.length)):A.indexOf(a)===0&&(P=A.substr(0,A.indexOf(a)+a.length),A=A.substr(A.indexOf(a)+a.length));const O=A.split(r);for(let N=1;u&&N<=O.length;N++)for(let z=O.length-N;u&&z>=0;z--){u=!1;let H=O.slice(z,z+N).join(r);for(let ie=0;!u&&ie<i.length;ie++)if(ie!==s&&i[ie]&&i[ie].indexOf(H)>-1){const se=z+N===O.length,oe=z>0&&i[ie].indexOf(r)>-1?r+H:H,ue=i[ie].endsWith(oe);u=!se||ue}if(!u){let ie="";(O[0].endsWith(":")||P!=="")&&(z===1&&(z=0,N++,H=O[0]+r+H),z>0&&(ie=O[0]+r),ie=P+ie),z>0&&(ie=ie+w+r),ie=ie+H,z+N<O.length&&(ie=ie+r+w),o[s]=ie}}u&&(o[s]=l)}return o}e.shorten=h;var m;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(m||(m={}));function I(i,r=Object.create(null)){const o=[];let u=!1,s="";for(const l of i)if(l==="$"||u&&l==="{")s&&o.push({value:s,type:m.TEXT}),s="",u=!0;else if(l==="}"&&u){const P=r[s];if(typeof P=="string")P.length&&o.push({value:P,type:m.VARIABLE});else if(P){const A=o[o.length-1];(!A||A.type!==m.SEPARATOR)&&o.push({value:P.label,type:m.SEPARATOR})}s="",u=!1}else s+=l;return s&&!u&&o.push({value:s,type:m.TEXT}),o.filter((l,P)=>{if(l.type===m.SEPARATOR){const A=o[P-1],O=o[P+1];return[A,O].every(N=>N&&(N.type===m.VARIABLE||N.type===m.TEXT)&&N.value.length>0)}return!0}).map(l=>l.value).join("")}e.template=I;function S(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function D(i,r){return R.isMacintosh||r?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function c(i){const r=i.indexOf("/")!==-1?n.posix:n.win32,o=r.basename(i),u=r.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=c}),define(Z[149],_([0,1,17,8]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(v){return v.toJSON()}class R{constructor(y){this.a=y}transformIncoming(y){const d=this.a.transformIncoming(y);return d===y?y:n(M.URI.from(d))}transformOutgoing(y){const d=this.a.transformOutgoing(y);return d===y?y:n(M.URI.from(d))}transformOutgoingURI(y){const d=this.a.transformOutgoing(y);return d===y?y:M.URI.from(d)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function C(v,y,d){if(!v||d>200)return null;if(typeof v=="object"){if(v instanceof M.URI)return y.transformOutgoing(v);for(const w in v)if(Object.hasOwnProperty.call(v,w)){const p=C(v[w],y,d+1);p!==null&&(v[w]=p)}}return null}function k(v,y){const d=C(v,y,0);return d===null?v:d}e.transformOutgoingURIs=k;function g(v,y,d,w){if(!v||w>200)return null;if(typeof v=="object"){if(v.$mid===1)return d?M.URI.revive(y.transformIncoming(v)):y.transformIncoming(v);if(v instanceof E.VSBuffer)return null;for(const p in v)if(Object.hasOwnProperty.call(v,p)){const a=g(v[p],y,d,w+1);a!==null&&(v[p]=a)}}return null}function f(v,y){const d=g(v,y,!1,0);return d===null?v:d}e.transformIncomingURIs=f;function b(v,y){const d=g(v,y,!0,0);return d===null?v:d}e.transformAndReviveIncomingURIs=b}),define(Z[84],_([0,1,26,13,61,31,137]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(b){return this.a||(this.a=n.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,v=0;const y=(0,E.networkInterfaces)();for(const d in y){const w=y[d];if(w)for(const{mac:p,internal:a}of w)a||(v+=1,this.c(p.toUpperCase())&&(b+=1))}this.b=v>0?b/v:0}return this.b}};let k;async function g(){return k||(k=(async()=>await f()||R.generateUuid())()),k}e.getMachineId=g;async function f(){try{const b=await new Promise((y,d)=>{x(["crypto"],y,d)}),v=(0,C.getMac)();return b.createHash("sha256").update(v,"utf8").digest("hex")}catch(b){M.onUnexpectedError(b);return}}}),define(Z[23],_([0,1,41,26,150,7,32,80,9,4,18,8]),function(x,e,E,M,n,R,C,k,g,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(oe){oe[oe.UNLINK=0]="UNLINK",oe[oe.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function d(oe,ue=y.UNLINK){if((0,C.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");return ue===y.UNLINK?p(oe):w(oe)}async function w(oe){try{const ue=(0,C.randomPath)((0,M.tmpdir)());try{await E.promises.rename(oe,ue)}catch(le){return le.code==="ENOENT"?void 0:p(oe)}p(ue).catch(le=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function p(oe){return(0,n.promisify)(E.rm)(oe,{recursive:!0,force:!0,maxRetries:3})}function a(oe){if((0,C.isRootOrDriveLetter)(oe))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(oe,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function h(oe,ue){return S(await(ue?m(oe):(0,n.promisify)(E.readdir)(oe)))}async function m(oe){try{return await(0,n.promisify)(E.readdir)(oe,{withFileTypes:!0})}catch(me){console.warn("[node.js fs] readdir with filetypes failed with error: ",me)}const ue=[],le=await h(oe);for(const me of le){let G=!1,B=!1,T=!1;try{const q=await e.Promises.lstat((0,g.join)(oe,me));G=q.isFile(),B=q.isDirectory(),T=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}ue.push({name:me,isFile:()=>G,isDirectory:()=>B,isSymbolicLink:()=>T})}return ue}function I(oe){return S(E.readdirSync(oe))}e.readdirSync=I;function S(oe){return oe.map(ue=>typeof ue=="string"?f.isMacintosh?(0,k.normalizeNFC)(ue):ue:(ue.name=f.isMacintosh?(0,k.normalizeNFC)(ue.name):ue.name,ue))}async function D(oe){const ue=await h(oe),le=[];for(const me of ue)await c.existsDirectory((0,g.join)(oe,me))&&le.push(me);return le}function t(oe,ue=1e3){return new Promise(le=>{let me=!1;const G=setInterval(()=>{me||(me=!0,E.access(oe,B=>{me=!1,B&&(clearInterval(G),le(void 0))}))},ue)})}e.whenDeleted=t;var c;(function(oe){async function ue(G){let B;try{if(B=await e.Promises.lstat(G),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(G),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(f.isWindows&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(G)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw q}throw T}}oe.stat=ue;async function le(G){try{const{stat:B,symbolicLink:T}=await oe.stat(G);return B.isFile()&&T?.dangling!==!0}catch{}return!1}oe.existsFile=le;async function me(G){try{const{stat:B,symbolicLink:T}=await oe.stat(G);return B.isDirectory()&&T?.dangling!==!0}catch{}return!1}oe.existsDirectory=me})(c=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new R.ResourceQueue;function r(oe,ue,le){return i.queueFor(v.URI.file(oe),b.extUriBiasedIgnorePathCase).queue(()=>{const me=P(le);return new Promise((G,B)=>s(oe,ue,me,T=>T?B(T):G()))})}let o=!0;function u(oe){o=oe}e.configureFlushOnWrite=u;function s(oe,ue,le,me){if(!o)return E.writeFile(oe,ue,{mode:le.mode,flag:le.flag},me);E.open(oe,le.flag,le.mode,(G,B)=>{if(G)return me(G);E.writeFile(B,ue,T=>{if(T)return E.close(B,()=>me(T));E.fdatasync(B,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),u(!1)),E.close(B,Y=>me(Y))))})})}function l(oe,ue,le){const me=P(le);if(!o)return E.writeFileSync(oe,ue,{mode:me.mode,flag:me.flag});const G=E.openSync(oe,me.flag,me.mode);try{E.writeFileSync(G,ue);try{E.fdatasyncSync(G)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{E.closeSync(G)}}e.writeFileSync=l;function P(oe){return oe?{mode:typeof oe.mode=="number"?oe.mode:438,flag:typeof oe.flag=="string"?oe.flag:"w"}:{mode:438,flag:"w"}}async function A(oe,ue){if(oe!==ue)try{await e.Promises.rename(oe,ue)}catch(le){if(oe.toLowerCase()!==ue.toLowerCase()&&le.code==="EXDEV"||oe.endsWith("."))await O(oe,ue,{preserveSymlinks:!1}),await d(oe,y.MOVE);else throw le}}async function O(oe,ue,le){return z(oe,ue,{root:{source:oe,target:ue},options:le,handledSourcePaths:new Set})}const N=511;async function z(oe,ue,le){if(le.handledSourcePaths.has(oe))return;le.handledSourcePaths.add(oe);const{stat:me,symbolicLink:G}=await c.stat(oe);if(G){if(le.options.preserveSymlinks)try{return await se(oe,ue,le)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(G.dangling)return}return me.isDirectory()?H(oe,ue,me.mode&N,le):ie(oe,ue,me.mode&N)}async function H(oe,ue,le,me){await e.Promises.mkdir(ue,{recursive:!0,mode:le});const G=await h(oe);for(const B of G)await z((0,g.join)(oe,B),(0,g.join)(ue,B),me)}async function ie(oe,ue,le){await e.Promises.copyFile(oe,ue),await e.Promises.chmod(ue,le)}async function se(oe,ue,le){let me=await e.Promises.readlink(oe);(0,C.isEqualOrParent)(me,le.root.source,!f.isLinux)&&(me=(0,g.join)(le.root.target,me.substr(le.root.source.length+1))),await e.Promises.symlink(me,ue)}e.Promises=new class{get access(){return(0,n.promisify)(E.access)}get stat(){return(0,n.promisify)(E.stat)}get lstat(){return(0,n.promisify)(E.lstat)}get utimes(){return(0,n.promisify)(E.utimes)}get read(){return(oe,ue,le,me,G)=>new Promise((B,T)=>{E.read(oe,ue,le,me,G,(q,Y,te)=>q?T(q):B({bytesRead:Y,buffer:te}))})}get readFile(){return(0,n.promisify)(E.readFile)}get write(){return(oe,ue,le,me,G)=>new Promise((B,T)=>{E.write(oe,ue,le,me,G,(q,Y,te)=>q?T(q):B({bytesWritten:Y,buffer:te}))})}get appendFile(){return(0,n.promisify)(E.appendFile)}get fdatasync(){return(0,n.promisify)(E.fdatasync)}get truncate(){return(0,n.promisify)(E.truncate)}get rename(){return(0,n.promisify)(E.rename)}get copyFile(){return(0,n.promisify)(E.copyFile)}get open(){return(0,n.promisify)(E.open)}get close(){return(0,n.promisify)(E.close)}get symlink(){return(0,n.promisify)(E.symlink)}get readlink(){return(0,n.promisify)(E.readlink)}get chmod(){return(0,n.promisify)(E.chmod)}get mkdir(){return(0,n.promisify)(E.mkdir)}get unlink(){return(0,n.promisify)(E.unlink)}get rmdir(){return(0,n.promisify)(E.rmdir)}get realpath(){return(0,n.promisify)(E.realpath)}async exists(oe){try{return await e.Promises.access(oe),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return D}get writeFile(){return r}get rm(){return d}get move(){return A}get copy(){return O}}}),define(Z[102],_([0,1,41,9,4,27,23]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(y){if(n.isLinux)return y;const d=(0,M.dirname)(y);if(y===d)return y;const w=((0,M.basename)(y)||y).toLowerCase();try{const a=(0,C.readdirSync)(d).filter(h=>h.toLowerCase()===w);if(a.length===1){const h=k(d);if(h)return(0,M.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(w);if(h>=0){const m=k(d);if(m)return(0,M.join)(m,a[h])}}}catch{}return null}e.realcaseSync=k;async function g(y){if(n.isLinux)return y;const d=(0,M.dirname)(y);if(y===d)return y;const w=((0,M.basename)(y)||y).toLowerCase();try{const a=(await C.Promises.readdir(d)).filter(h=>h.toLowerCase()===w);if(a.length===1){const h=await g(d);if(h)return(0,M.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(w);if(h>=0){const m=await g(d);if(m)return(0,M.join)(m,a[h])}}}catch{}return null}e.realcase=g;async function f(y){try{return await C.Promises.realpath(y)}catch{const w=v(y);return await C.Promises.access(w,E.constants.R_OK),w}}e.realpath=f;function b(y){try{return E.realpathSync(y)}catch{const w=v(y);return E.accessSync(w,E.constants.R_OK),w}}e.realpathSync=b;function v(y){return(0,R.rtrim)((0,M.normalize)(y),M.sep)}}),define(Z[151],_([0,1,26,9,23]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,C=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var g;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(g||(g={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class v{constructor(D,t,c){this.exePath=D,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await n.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:S=!1}={}){return S?f===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:S=!1,findPreview:D=!1}={}){const t=y({useAlternateBitness:S});if(!t)return null;const c=M.join(t,"PowerShell");if(!await n.SymlinkSupport.existsDirectory(c))return null;let i=-1,r=null;for(const s of await n.Promises.readdir(c)){let l=-1;if(D){const A=s.indexOf("-");if(A<0)continue;const O=s.substring(0,A);if(!R.test(O)||s.substring(A+1)!=="preview")continue;l=parseInt(O,10)}else{if(!R.test(s))continue;l=parseInt(s,10)}if(l<=i)continue;const P=M.join(c,s,"pwsh.exe");!await n.SymlinkSupport.existsFile(P)||(r=P,i=l)}if(!r)return null;const o=t.includes("x86")?" (x86)":"",u=D?" Preview":"";return new v(r,`PowerShell${u}${o}`,!0)}async function w({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const D=M.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await n.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=S?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const i of await n.Promises.readdir(D))if(t.test(i)){const r=M.join(D,i,"pwsh.exe");return new v(r,c)}return null}function p(){const S=M.join(E.homedir(),".dotnet","tools","pwsh.exe");return new v(S,".NET Core PowerShell Global Tool")}function a(){const S=M.join(process.env.windir,f===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(S,"Windows PowerShell",!0)}async function*h(){let S=await d();S&&(yield S),S=await d({useAlternateBitness:!0}),S&&(yield S),S=await w(),S&&(yield S),S=p(),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await w({findPreview:!0}),S&&(yield S),S=await d({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=a(),S&&(yield S)}async function*m(){for await(const S of h())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=m;async function I(){for await(const S of m())return S;return null}e.getFirstAvailablePowerShellInstallation=I}),define(Z[85],_([0,1,9,4,36,71,10,23]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function g(v=n.env){return v.comspec||"cmd.exe"}e.getWindowsShell=g;function f(v){let y=[],d=!1;const w=function(p){if(d){y.push(p);return}(!v.send(p,h=>{if(h&&console.error(h),d=!1,y.length>0){const m=y.slice(0);y=[],m.forEach(I=>w(I))}})||M.isWindows)&&(d=!0)};return{send:w}}e.createQueuedSender=f;var b;(function(v){async function y(d,w,p){if(E.isAbsolute(d))return d;if(w===void 0&&(w=n.cwd()),E.dirname(d)!=="."||(p===void 0&&C.isString(n.env.PATH)&&(p=n.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(w,d);async function h(m){if(await k.Promises.exists(m)){let I;try{I=await k.Promises.stat(m)}catch(S){S.message.startsWith("EACCES")&&(I=await k.Promises.lstat(m))}return I?!I.isDirectory():!1}return!1}for(const m of p){let I;if(E.isAbsolute(m)?I=E.join(m,d):I=E.join(w,m,d),await h(I))return I;let S=I+".com";if(await h(S)||(S=I+".exe",await h(S)))return S}return E.join(w,d)}v.findExecutable=y})(b=e.win32||(e.win32={}))}),define(Z[103],_([0,1,46,14]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function n(C){return new Promise((k,g)=>{let f;const b=new Map;function v(d,w,p,a,h){const m=b.get(w);if(d===C||m){const I={name:y(p),cmd:p,pid:d,ppid:w,load:a,mem:h};b.set(d,I),d===C&&(f=I),m&&(m.children||(m.children=[]),m.children.push(I),m.children.length>1&&(m.children=m.children.sort((S,D)=>S.pid-D.pid)))}}function y(d){const w=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,a=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,m=/--vscode-utility-kind=extensionHost/,I=/--vscode-utility-kind=fileWatcher/,S=/--crashes-directory/,D=/\\pipe\\winpty-control/,t=/conhost\.exe/,c=/--type=([a-zA-Z-]+)/;if(S.exec(d))return"electron-crash-reporter";if(D.exec(d))return"winpty-process";if(t.exec(d))return"console-window-host (Windows internal process)";let i=c.exec(d);if(i&&i.length===2){if(i[1]==="renderer")return w.exec(d)?"shared-process":p.exec(d)?"issue-reporter":a.exec(d)?"process-explorer":"window";if(i[1]==="utility"){if(h.exec(d))return"utility-network-service";if(m.exec(d))return"extension-host";if(I.exec(d))return"file-watcher"}else if(i[1]==="extensionHost")return"extension-host";return i[1]}const r=/[a-zA-Z-]+\.js/g;let o="";do i=r.exec(d),i&&(o+=i+" ");while(i);return o&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${o}`:d}if(process.platform==="win32"){const d=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,p)=>{x(["windows-process-tree"],w,p)}).then(w=>{w.getProcessList(C,p=>{if(!p){g(new Error(`Root process ${C} not found`));return}w.getProcessCpuUsage(p,a=>{const h=new Map;a.forEach(m=>{const I=d(m.commandLine||"");h.set(m.pid,{name:y(I),cmd:I,pid:m.pid,ppid:m.ppid,load:m.cpu||0,mem:m.memory||0})}),f=h.get(C),f?(h.forEach(m=>{const I=h.get(m.ppid);I&&(I.children||(I.children=[]),I.children.push(m))}),h.forEach(m=>{m.children&&(m.children=m.children.sort((I,S)=>I.pid-S.pid))}),k(f)):g(new Error(`Root process ${C} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{let d=function(){let w=[f];const p=[];for(;w.length;){const h=w.shift();h&&(p.push(h.pid),h.children&&(w=w.concat(h.children)))}let a=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+p.join(" "),(0,E.exec)(a,{},(h,m,I)=>{if(h||I)g(h||new Error(I.toString()));else{const S=m.toString().split(`
`);for(let D=0;D<p.length;D++){const t=b.get(p[D]);t.load=parseFloat(S[D])}if(!f){g(new Error(`Root process ${C} not found`));return}k(f)}})};(0,E.exec)("which ps",{},(w,p,a)=>{if(w||a)if(process.platform!=="linux")g(w||new Error(a.toString()));else{const h=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(h,{},(m,I,S)=>{m||S?g(m||new Error(S.toString())):(R(I,v),d())})}else{const h=p.toString().trim(),m="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${h} ${m}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(I,S,D)=>{I||D&&!D.includes("screen size is bogus")?g(I||new Error(D.toString())):(R(S,v),process.platform==="linux"?d():f?k(f):g(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=n;function R(C,k){const g=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=C.toString().split(`
`);for(const b of f){const v=g.exec(b.trim());v&&v.length===6&&k(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(Z[152],_([0,1,26,4,151,85]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(v,y){return v===1?M.isWindows?b():R.getWindowsShell(y):g(v,y)}e.getSystemShell=C;let k=null;function g(v,y){if(M.isLinux&&v===2||M.isMacintosh&&v===3)return"/bin/bash";if(!k){let d;if(M.isWindows)d="/bin/bash";else{if(d=y.SHELL,!d)try{d=(0,E.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}k=d}return k}let f=null;async function b(){return f||(f=(await(0,n.getFirstAvailablePowerShellInstallation)()).exePath),f}});var ve=this&&this.__decorate||function(x,e,E,M){var n=arguments.length,R=n<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,E):M,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(x,e,E,M);else for(var k=x.length-1;k>=0;k--)(C=x[k])&&(R=(n<3?C(R):n>3?C(e,E,R):C(e,E))||R);return n>3&&R&&Object.defineProperty(e,E,R),R};define(Z[47],_([0,1,25,7,17,22,54,13,3,2,83,27,10]),function(x,e,E,M,n,R,C,k,g,f,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(d||(d={}));function w(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(p||(p={}));function a(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(h||(h={}));function m(B){let T=0;for(let q=0;;q+=7){const Y=B.read(1);if(T|=(Y.buffer[0]&127)<<q,!(Y.buffer[0]&128))return T}}const I=i(0);function S(B,T){if(T===0){B.write(I);return}let q=0;for(let te=T;te!==0;te=te>>>7)q++;const Y=n.VSBuffer.alloc(q);for(let te=0;T!==0;te++)Y.buffer[te]=T&127,T=T>>>7,T>0&&(Y.buffer[te]|=128);B.write(Y)}class D{constructor(T){this.b=T,this.a=0}read(T){const q=this.b.slice(this.a,this.a+T);return this.a+=q.byteLength,q}}e.BufferReader=D;class t{constructor(){this.a=[]}get buffer(){return n.VSBuffer.concat(this.a)}write(T){this.a.push(T)}}e.BufferWriter=t;var c;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(c||(c={}));function i(B){const T=n.VSBuffer.alloc(1);return T.writeUInt8(B,0),T}const r={Undefined:i(c.Undefined),String:i(c.String),Buffer:i(c.Buffer),VSBuffer:i(c.VSBuffer),Array:i(c.Array),Object:i(c.Object),Uint:i(c.Int)},o=typeof Buffer<"u";function u(B,T){if(typeof T>"u")B.write(r.Undefined);else if(typeof T=="string"){const q=n.VSBuffer.fromString(T);B.write(r.String),S(B,q.byteLength),B.write(q)}else if(o&&Buffer.isBuffer(T)){const q=n.VSBuffer.wrap(T);B.write(r.Buffer),S(B,q.byteLength),B.write(q)}else if(T instanceof n.VSBuffer)B.write(r.VSBuffer),S(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(r.Array),S(B,T.length);for(const q of T)u(B,q)}else if(typeof T=="number"&&(T|0)===T)B.write(r.Uint),S(B,T);else{const q=n.VSBuffer.fromString(JSON.stringify(T));B.write(r.Object),S(B,q.byteLength),B.write(q)}}e.serialize=u;function s(B){switch(B.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return B.read(m(B)).toString();case c.Buffer:return B.read(m(B)).buffer;case c.VSBuffer:return B.read(m(B));case c.Array:{const q=m(B),Y=[];for(let te=0;te<q;te++)Y.push(s(B));return Y}case c.Object:return JSON.parse(B.read(m(B)).toString());case c.Int:return m(B)}}e.deserialize=s;class l{constructor(T,q,Y=null,te=1e3){this.h=T,this.j=q,this.k=Y,this.l=te,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(T,q){this.b.set(T,q),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const q=this.o([T.type]);this.k?.logOutgoing(q,0,1,a(T.type));return}case 201:case 202:case 204:case 203:{const q=this.o([T.type,T.id],T.data);this.k?.logOutgoing(q,T.id,1,a(T.type),T.data);return}}}o(T,q=void 0){const Y=new t;return u(Y,T),u(Y,q),this.p(Y.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const q=new D(T),Y=s(q),te=s(q),ne=Y[0];switch(ne){case 100:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(ne)}: ${Y[2]}.${Y[3]}`,te),this.s({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case 102:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(ne)}: ${Y[2]}.${Y[3]}`,te),this.t({type:ne,id:Y[1],channelName:Y[2],name:Y[3],arg:te});case 101:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(ne)}`),this.u({type:ne,id:Y[1]});case 103:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(ne)}`),this.u({type:ne,id:Y[1]})}}s(T){const q=this.b.get(T.channelName);if(!q){this.v(T);return}const Y=new R.CancellationTokenSource;let te;try{te=q.call(this.j,T.name,T.arg,Y.token)}catch(F){te=Promise.reject(F)}const ne=T.id;te.then(F=>{this.m({id:ne,data:F,type:201}),this.d.delete(T.id)},F=>{F instanceof Error?this.m({id:ne,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:ne,data:F,type:203}),this.d.delete(T.id)});const L=(0,f.toDisposable)(()=>Y.cancel());this.d.set(T.id,L)}t(T){const q=this.b.get(T.channelName);if(!q){this.v(T);return}const Y=T.id,ne=q.listen(this.j,T.name,T.arg)(L=>this.m({id:Y,data:L,type:204}));this.d.set(T.id,ne)}u(T){const q=this.d.get(T.id);q&&(q.dispose(),this.d.delete(T.id))}v(T){let q=this.g.get(T.channelName);q||(q=[],this.g.set(T.channelName,q));const Y=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:T,timeoutTimer:Y})}w(T){const q=this.g.get(T);if(q){for(const Y of q)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,f.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var P;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(P=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(T,q=null){this.l=T,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=q}getChannel(T){const q=this;return{call(Y,te,ne){return q.a?Promise.reject(new k.CancellationError):q.m(T,Y,te,ne)},listen(Y,te){return q.a?g.Event.None:q.o(T,Y,te)}}}m(T,q,Y,te=R.CancellationToken.None){const ne=this.g++,F={id:ne,type:100,channelName:T,name:q,arg:Y};if(te.isCancellationRequested)return Promise.reject(new k.CancellationError);let U;return new Promise(($,V)=>{if(te.isCancellationRequested)return V(new k.CancellationError);const j=()=>{const de=Ce=>{switch(Ce.type){case 201:this.f.delete(ne),$(Ce.data);break;case 202:{this.f.delete(ne);const Re=new Error(Ce.data.message);Re.stack=Array.isArray(Ce.data.stack)?Ce.data.stack.join(`
`):Ce.data.stack,Re.name=Ce.data.name,V(Re);break}case 203:this.f.delete(ne),V(Ce.data);break}};this.f.set(ne,de),this.p(F)};let K=null;this.b===h.Idle?j():(K=(0,M.createCancelablePromise)(de=>this.u()),K.then(()=>{K=null,j()}));const J=()=>{K?(K.cancel(),K=null):this.p({id:ne,type:101}),V(new k.CancellationError)},re=te.onCancellationRequested(J);U=(0,f.combinedDisposable)((0,f.toDisposable)(J),re),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(T,q,Y){const te=this.g++,L={id:te,type:102,channelName:T,name:q,arg:Y};let F=null;const U=new g.Emitter({onWillAddFirstListener:()=>{F=(0,M.createCancelablePromise)($=>this.u()),F.then(()=>{F=null,this.d.add(U),this.p(L)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(U),this.p({id:te,type:103}))}}),W=$=>U.fire($.data);return this.f.set(te,W),U.event}p(T){switch(T.type){case 100:case 102:{const q=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(q,T.id,0,`${w(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const q=this.q([T.type,T.id]);this.j?.logOutgoing(q,T.id,0,w(T.type));return}}}q(T,q=void 0){const Y=new t;return u(Y,T),u(Y,q),this.r(Y.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const q=new D(T),Y=s(q),te=s(q),ne=Y[0];switch(ne){case 200:return this.j?.logIncoming(T.byteLength,0,0,a(ne)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Y[1],0,a(ne),te),this.t({type:Y[0],id:Y[1],data:te})}}t(T){if(T.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,f.dispose)(this.d.values()),this.d.clear()}}ve([C.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class O{get connections(){const T=[];return this.f.forEach(q=>T.push(q)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,T(({protocol:q,onDidClientDisconnect:Y})=>{g.Event.once(q.onMessage)(ne=>{const L=new D(ne),F=s(L),U=new l(q,F),W=new A(q);this.a.forEach((V,j)=>U.registerChannel(j,V));const $={channelServer:U,channelClient:W,ctx:F};this.f.add($),this.g.fire($),Y(()=>{U.dispose(),W.dispose(),this.f.delete($),this.h.fire($)})})})}getChannel(T,q){const Y=this;return{call(te,ne,L){let F;if((0,y.isFunction)(q)){const W=(0,E.getRandomElement)(Y.connections.filter(q));F=W?Promise.resolve(W):g.Event.toPromise(g.Event.filter(Y.onDidAddConnection,q))}else F=q.routeCall(Y,te,ne);const U=F.then(W=>W.channelClient.getChannel(T));return z(U).call(te,ne,L)},listen(te,ne){if((0,y.isFunction)(q))return Y.j(T,q,te,ne);const L=q.routeEvent(Y,te,ne).then(F=>F.channelClient.getChannel(T));return z(L).listen(te,ne)}}}j(T,q,Y,te){const ne=this;let L=new f.DisposableStore;const F=new g.Emitter({onWillAddFirstListener:()=>{L=new f.DisposableStore;const U=new g.EventMultiplexer,W=new Map,$=j=>{const J=j.channelClient.getChannel(T).listen(Y,te),re=U.add(J);W.set(j,re)},V=j=>{const K=W.get(j);!K||(K.dispose(),W.delete(j))};ne.connections.filter(q).forEach($),g.Event.filter(ne.onDidAddConnection,q)($,void 0,L),ne.onDidRemoveConnection(V,void 0,L),U.event(F.fire,F,L),L.add(U)},onDidRemoveLastListener:()=>{L.dispose()}});return F.event}registerChannel(T,q){this.a.set(T,q),this.f.forEach(Y=>{Y.channelServer.registerChannel(T,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class N{constructor(T,q,Y=null){const te=new t;u(te,q),T.send(te.buffer),this.a=new A(T,Y),this.d=new l(T,q,Y)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,q){this.d.registerChannel(T,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function z(B){return{call(T,q,Y){return B.then(te=>te.call(T,q,Y))},listen(T,q){const Y=new g.Relay;return B.then(te=>Y.input=te.listen(T,q)),Y.event}}}e.getDelayedChannel=z;function H(B){let T=!1;return{call(q,Y,te){return T?B.call(q,Y,te):(0,M.timeout)(0).then(()=>T=!0).then(()=>B.call(q,Y,te))},listen(q,Y){if(T)return B.listen(q,Y);const te=new g.Relay;return(0,M.timeout)(0).then(()=>T=!0).then(()=>te.input=B.listen(q,Y)),te.event}}}e.getNextTickChannel=H;class ie{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const q of T.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await g.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.StaticRouter=ie;var se;(function(B){function T(ne,L){const F=ne,U=L&&L.disableMarshalling,W=new Map;for(const $ in F)Y($)&&W.set($,g.Event.buffer(F[$],!0));return new class{listen($,V,j){const K=W.get(V);if(K)return K;if(te(V)){const J=F[V];if(typeof J=="function")return J.call(F,j)}throw new Error(`Event not found: ${V}`)}call($,V,j){const K=F[V];if(typeof K=="function"){if(!U&&Array.isArray(j))for(let J=0;J<j.length;J++)j[J]=(0,b.revive)(j[J]);return K.apply(F,j)}throw new Error(`Method not found: ${V}`)}}}B.fromService=T;function q(ne,L){const F=L&&L.disableMarshalling;return new Proxy({},{get(U,W){if(typeof W=="string")return L?.properties?.has(W)?L.properties.get(W):te(W)?function($){return ne.listen(W,$)}:Y(W)?ne.listen(W):async function(...$){let V;L&&!(0,y.isUndefinedOrNull)(L.context)?V=[L.context,...$]:V=$;const j=await ne.call(W,V);return F?j:(0,b.revive)(j)};throw new Error(`Property not found: ${String(W)}`)}})}B.toService=q;function Y(ne){return ne[0]==="o"&&ne[1]==="n"&&v.isUpperAsciiLetter(ne.charCodeAt(2))}function te(ne){return/^onDynamic/.test(ne)&&v.isUpperAsciiLetter(ne.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function le(B){return Array.isArray(B)?B.map(ue):ue(B)}function me(B,T,q,Y,te,ne,L){L=le(L);const F=oe[te],U=F[Y%F.length];let W=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ne)?(W=W.concat(L),W.push(")")):W.push(L),console.log.apply(console,W)}class G{constructor(T,q){this.d=T,this.f=q,this.a=0,this.b=0}logOutgoing(T,q,Y,te,ne){this.b+=T,me(this.d,this.b,T,q,Y,te,ne)}logIncoming(T,q,Y,te,ne){this.a+=T,me(this.f,this.a,T,q,Y,te,ne)}}e.IPCLogger=G}),define(Z[153],_([0,1,17,3,47]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(g){this.a=g,this.onMessage=M.Event.fromDOMEventEmitter(this.a,"message",f=>E.VSBuffer.wrap(f.data)),g.start()}send(g){this.a.postMessage(g.buffer)}disconnect(){this.a.close()}}e.Protocol=R;class C extends n.IPCClient{constructor(g,f){const b=new R(g);super(b,f),this.b=b}dispose(){this.b.disconnect()}}e.Client=C}),define(Z[104],_([0,1,7,17,3,2,47]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(A){A.Created="created",A.Read="read",A.Write="write",A.Open="open",A.Error="error",A.Close="close",A.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",A.NodeEndReceived="nodeEndReceived",A.NodeEndSent="nodeEndSent",A.NodeDrainBegin="nodeDrainBegin",A.NodeDrainEnd="nodeDrainEnd",A.zlibInflateError="zlibInflateError",A.zlibInflateData="zlibInflateData",A.zlibInflateInitialWrite="zlibInflateInitialWrite",A.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",A.zlibInflateWrite="zlibInflateWrite",A.zlibInflateFlushFired="zlibInflateFlushFired",A.zlibDeflateError="zlibDeflateError",A.zlibDeflateData="zlibDeflateData",A.zlibDeflateWrite="zlibDeflateWrite",A.zlibDeflateFlushFired="zlibDeflateFlushFired",A.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",A.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",A.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",A.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",A.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",A.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",A.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",A.ProtocolHeaderRead="protocolHeaderRead",A.ProtocolMessageRead="protocolMessageRead",A.ProtocolHeaderWrite="protocolHeaderWrite",A.ProtocolMessageWrite="protocolMessageWrite",A.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var g;(function(A){A.enableDiagnostics=!1,A.records=[];const O=new WeakMap;let N=0;function z(ie,se){if(!O.has(ie)){const oe=String(++N);O.set(ie,oe)}return O.get(ie)}function H(ie,se,oe,ue){if(!A.enableDiagnostics)return;const le=z(ie,se);if(ue instanceof M.VSBuffer||ue instanceof Uint8Array||ue instanceof ArrayBuffer||ArrayBuffer.isView(ue)){const me=M.VSBuffer.alloc(ue.byteLength);me.set(ue),A.records.push({timestamp:Date.now(),id:le,label:se,type:oe,buff:me})}else A.records.push({timestamp:Date.now(),id:le,label:se,type:oe,data:ue})}A.traceSocketEvent=H})(g=e.SocketDiagnostics||(e.SocketDiagnostics={}));var f;(function(A){A[A.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",A[A.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function v(){return b||(b=M.VSBuffer.alloc(0)),b}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,N){if(O===0)return v();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const se=this.a[0];return N&&(this.a.shift(),this.b-=O),se}if(this.a[0].byteLength>O){const se=this.a[0].slice(0,O);return N&&(this.a[0]=this.a[0].slice(O),this.b-=O),se}const z=M.VSBuffer.alloc(O);let H=0,ie=0;for(;O>0;){const se=this.a[ie];if(se.byteLength>O){const oe=se.slice(0,O);z.set(oe,H),H+=O,N&&(this.a[ie]=se.slice(O),this.b-=O),O-=O}else z.set(se,H),H+=se.byteLength,N?(this.a.shift(),this.b-=se.byteLength):ie++,O-=se.byteLength}return z}}e.ChunkStream=y;var d;(function(A){A[A.None=0]="None",A[A.Regular=1]="Regular",A[A.Control=2]="Control",A[A.Ack=3]="Ack",A[A.Disconnect=5]="Disconnect",A[A.ReplayRequest=6]="ReplayRequest",A[A.Pause=7]="Pause",A[A.Resume=8]="Resume",A[A.KeepAlive=9]="KeepAlive",A[A.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",A[A.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function w(A){switch(A){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(A){A[A.HeaderLength=13]="HeaderLength",A[A.AcknowledgeTime=2e3]="AcknowledgeTime",A[A.TimeoutTime=2e4]="TimeoutTime",A[A.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",A[A.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",A[A.KeepAliveSendTime=5e3]="KeepAliveSendTime",A[A.LatencySampleTime=6e4]="LatencySampleTime",A[A.LatencySampleCount=5]="LatencySampleCount",A[A.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",A[A.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class a{constructor(O,N,z,H){this.type=O,this.id=N,this.ack=z,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(O){super(),this.f=this.B(new n.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new y,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const z=this.g.messageType,H=this.g.id,ie=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new a(z,H,ie,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class m{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=M.VSBuffer.alloc(13);N.writeUInt8(O.type,0),N.writeUInt32BE(O.id,1),N.writeUInt32BE(O.ack,5),N.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:w(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(N,O.data)}g(O,N){const z=this.f===0;return this.d.push(O,N),this.f+=O.byteLength+N.byteLength,z}h(){const O=M.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,N){this.g(O,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class I extends R.Disposable{constructor(O){super(),this.f=new n.Emitter,this.onMessage=this.f.event,this.g=new n.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new m(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new a(1,0,0,O))}}e.Protocol=I;class S extends C.IPCClient{static fromSocket(O,N){return new S(new I(O),N)}get onDidDispose(){return this.b.onDidDispose}constructor(O,N,z=null){super(O,N,z),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=S;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new n.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class t{constructor(O){this.data=O,this.next=null}}class c{constructor(){this.a=null,this.b=null}length(){let O=0,N=this.a;for(;N;)N=N.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let N=0,z=this.a;for(;z;)O[N++]=z.data,z=z.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const N=new t(O);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let N=0;N<i.a;N++)this.c[N]=O-1e3*N;setInterval(()=>{for(let N=i.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),N=(1+i.a)*1e3;let z=0;for(let H=0;H<i.a;H++)O-this.c[H]<=N&&z++;return 1-z/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var r;(function(A){A[A.Good=0]="Good",A[A.Poor=1]="Poor"})(r=e.ConnectionHealth||(e.ConnectionHealth={}));function o(A){switch(A){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class u{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=u;class s{constructor(O,N){this.roundTripTime=O,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=s;class l{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new c,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=O.socket,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new a(5,0,0,v());this.p.write(O),this.p.flush()}sendPause(){const O=new a(7,0,0,v());this.p.write(O)}sendResume(){const O=new a(8,0,0,v());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,N){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new m(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(z=>this.E(z))),this.t.add(this.o.onClose(z=>this.A.fire(z))),this.r=this.t.add(new P),this.t.add(this.r.onSendLatencyRequest(z=>this.J(z))),this.t.add(this.r.onHighRoundTripTime(z=>this.C.fire(z))),this.t.add(this.r.onDidChangeConnectionHealth(z=>this.D.fire(z))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new a(3,0,this.h,v());this.p.write(O);const N=this.b.toArray();for(let z=0,H=N.length;z<H;z++)this.p.write(N[z]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const N=this.b.peek();if(N&&N.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new a(6,0,0,v())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let z=0,H=N.length;z<H;z++)this.p.write(N[z]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const N=++this.c;this.h=this.g;const z=new a(1,N,this.h,O);this.b.push(z),this.a||(this.p.write(z),this.G())}sendControl(O){const N=new a(2,0,0,O);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),N=Date.now()-O.writtenTime,z=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(N>=2e4&&z>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:z});return}const ie=Math.max(2e4-N,2e4-z,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},ie)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new a(3,0,this.h,v());this.p.write(O)}I(){this.h=this.g;const O=new a(9,0,this.h,v());this.p.write(O)}J(O){this.h=this.g;const N=new a(10,0,this.h,O);this.p.write(N)}K(O){this.h=this.g;const N=new a(11,0,this.h,O);this.p.write(N)}}e.PersistentProtocol=l;class P extends R.Disposable{constructor(){super(),this.a=this.B(new n.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new n.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new n.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,N=M.VSBuffer.alloc(4);N.writeUInt32BE(O,0),this.a.fire(N)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const N=O.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const z=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=z;const ie=this.l,se=this.j.filter(oe=>oe>=1e3).length;this.l=se>=3?1:0,z>1e3&&this.b.fire(new s(z,se)),ie!==this.l&&this.c.fire(this.l)}}}),define(Z[154],_([0,1,42,17,3,2,47,139]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function g(b,v){const y=n.Event.fromNodeEventEmitter(E.validatedIpcMain,v,(w,p)=>({event:w,message:p})),d=n.Event.filter(y,({event:w})=>w.sender.id===b);return n.Event.map(d,({message:w})=>w&&M.VSBuffer.wrap(w))}class f extends C.IPCServer{static d(){const v=n.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:y})=>y);return n.Event.map(v,y=>{const d=y.id;f.b.get(d)?.dispose();const p=new n.Emitter;f.b.set(d,(0,R.toDisposable)(()=>p.fire()));const a=g(d,"vscode:message"),h=n.Event.any(n.Event.signal(g(d,"vscode:disconnect")),p.event);return{protocol:new k.Protocol(y,a),onDidClientDisconnect:h}})}constructor(){super(f.d())}}f.b=new Map,e.Server=f}),define(Z[105],_([0,1,42,3,31,153]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class C extends R.Client{constructor(f,b){super({addEventListener:(v,y)=>f.addListener(v,y),removeEventListener:(v,y)=>f.removeListener(v,y),postMessage:v=>f.postMessage(v),start:()=>f.start(),close:()=>f.close()},b)}}e.Client=C;async function k(g){if(g.isDestroyed()||g.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,n.generateUuid)();g.webContents.send("vscode:createMessageChannel",f);const b=M.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(y,d)=>({nonce:d,port:y.ports[0]})),{port:v}=await M.Event.toPromise(M.Event.once(M.Event.filter(b,y=>y.nonce===f)));return v}e.connect=k}),define(Z[155],_([0,1,46,7,17,22,148,13,3,2,37,85,71,47]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class w extends d.ChannelServer{constructor(h){super({send:m=>{try{process.send?.(m.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",m=>n.VSBuffer.wrap(Buffer.from(m,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=w;class p{constructor(h,m){this.i=h,this.j=m,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const I=m&&m.timeout?m.timeout:6e4;this.b=new M.Delayer(I),this.d=null,this.f=null}getChannel(h){const m=this;return{call(I,S,D){return m.k(h,I,S,D)},listen(I,S){return m.l(h,I,S)}}}k(h,m,I,S=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const D=this.n(h),t=(0,M.createCancelablePromise)(r=>D.call(m,I,r)),c=S.onCancellationRequested(()=>t.cancel()),i=(0,f.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{c.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,m,I){if(!this.b)return g.Event.None;this.b.cancel();let S;const D=new g.Emitter({onWillAddFirstListener:()=>{S=this.n(h).listen(m,I)(D.fire,D),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],m=Object.create(null);m.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(m.env={...m.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(m.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,y.removeDangerousEnvVariables)(m.env),this.d=(0,E.fork)(this.i,h,m);const I=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.isRemoteConsoleLog)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}I.fire(n.VSBuffer.wrap(Buffer.from(o,"base64")))});const D=this.j.useQueue?(0,v.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&D.send(o.buffer.toString("base64")),c=I.event,i={send:t,onMessage:c};this.f=new d.ChannelClient(i);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",r),this.c.forEach(s=>(0,f.dispose)(s)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(h){let m=this.g.get(h);return m||(m=this.m.getChannel(h),this.g.set(h,m)),m}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(Z[86],_([0,1,17,13,3,2,9,4,31,47,104]),function(x,e,E,M,n,R,C,k,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function v(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class y{traceSocketEvent(s,l){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,s,l)}constructor(s,l=""){this.f=!0,this.debugLabel=l,this.socket=s,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,M.onUnexpectedError)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(s){const l=P=>{this.traceSocketEvent("read",P),s(E.VSBuffer.wrap(P))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(s){const l=P=>{s({type:0,hadError:P,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(s){const l=()=>{s()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(s){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",s),this.socket.write(s.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,M.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,M.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((s,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),s();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),s()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.NodeSocket=y;var d;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var w;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(w||(w={}));class p extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(s,l){this.socket.traceSocketEvent(s,l)}constructor(s,l,P,A){super(),this.f=this.B(new n.Emitter),this.g=this.B(new n.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=s,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:P?.byteLength||0,recordInflateBytes:A}),this.a=this.B(new a(this,l,P,A,this.f,(O,N)=>this.k(O,N))),this.B(this.a.onError(O=>{console.error(O),(0,M.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new b.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(O=>this.g.fire(O)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(s){return this.f.event(s)}onClose(s){return this.g.event(s)}onEnd(s){return this.socket.onEnd(s)}write(s){this.a.writeMessage(s)}k(s,l){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",s);let P=2;s.byteLength<126?P+=0:s.byteLength<2**16?P+=2:P+=8;const A=E.VSBuffer.alloc(P);if(l?A.writeUInt8(194,0):A.writeUInt8(130,0),s.byteLength<126)A.writeUInt8(s.byteLength,1);else if(s.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(s.byteLength>>>8&255,++O),A.writeUInt8(s.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(s.byteLength>>>24&255,++O),A.writeUInt8(s.byteLength>>>16&255,++O),A.writeUInt8(s.byteLength>>>8&255,++O),A.writeUInt8(s.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([A,s]))}end(){this.h=!0,this.socket.end()}l(s){if(s.byteLength!==0){for(this.b.acceptChunk(s);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const l=this.b.peek(this.j.readLen),P=l.readUInt8(0),A=(P&128)>>>7,O=(P&64)>>>6,N=l.readUInt8(1),z=(N&128)>>>7,H=N&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=A,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(A),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const l=this.b.read(this.j.readLen),P=l.readUInt8(1),A=(P&128)>>>7;let O=P&127,N=1;O===126?O=l.readUInt8(++N)*2**8+l.readUInt8(++N):O===127&&(O=l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*0+l.readUInt8(++N)*2**24+l.readUInt8(++N)*2**16+l.readUInt8(++N)*2**8+l.readUInt8(++N));let z=0;A&&(z=l.readUInt8(++N)*2**24+l.readUInt8(++N)*2**16+l.readUInt8(++N)*2**8+l.readUInt8(++N)),this.j.state=3,this.j.readLen=O,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const l=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),I(l,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(l,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await n.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class a extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(s,l,P,A,O,N){super(),this.k=s,this.l=O,this.m=N,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new n.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,l?(this.b=this.B(new h(this.k,A,P,{windowBits:15})),this.f=this.B(new m(this.k,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(s){this.g.push(s),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const s=this.g.shift();if(this.f){const l=await this.r(this.f,s);this.m(l,!0)}else this.m(s,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(s,l){return new Promise((P,A)=>{s.write(l),s.flush(O=>P(O))})}acceptFrame(s,l,P){this.h.push({data:s,isCompressed:l,isLastFrameOfMessage:P}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const s=this.h.shift();if(this.b&&s.isCompressed){const l=await this.u(this.b,s.data,s.isLastFrameOfMessage);this.l.fire(l)}else this.l.fire(s.data)}this.s=!1}}u(s,l,P){return new Promise((A,O)=>{s.write(l),P&&s.write(E.VSBuffer.fromByteArray([0,0,255,255])),s.flush(N=>A(N))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(s,l,P,A){super(),this.h=s,this.j=l,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=v().zlib.createInflateRaw(A),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(E.VSBuffer.wrap(O))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(s){this.j&&this.f.push(s.clone()),this.h.traceSocketEvent("zlibInflateWrite",s),this.b.write(s.buffer)}flush(s){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const l=E.VSBuffer.concat(this.g);this.g.length=0,s(l)})}}class m extends R.Disposable{constructor(s,l){super(),this.g=s,this.a=this.B(new n.Emitter),this.onError=this.a.event,this.f=[],this.b=v().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(E.VSBuffer.wrap(P))})}write(s){this.g.traceSocketEvent("zlibDeflateWrite",s.buffer),this.b.write(s.buffer)}flush(s){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let l=E.VSBuffer.concat(this.f);this.f.length=0,l=l.slice(0,l.byteLength-4),s(l)})}}function I(u,s){if(s===0)return;const l=u.byteLength>>>2;for(let H=0;H<l;H++){const ie=u.readUInt32BE(H*4);u.writeUInt32BE(ie^s,H*4)}const P=l*4,A=u.byteLength-P,O=s>>>24&255,N=s>>>16&255,z=s>>>8&255;A>=1&&u.writeUInt8(u.readUInt8(P)^O,P),A>=2&&u.writeUInt8(u.readUInt8(P+1)^N,P+1),A>=3&&u.writeUInt8(u.readUInt8(P+2)^z,P+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const S={[2]:107,[1]:103};function D(){const u=(0,g.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let s;return e.XDG_RUNTIME_DIR?s=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):s=(0,C.join)(v().os.tmpdir(),`vscode-ipc-${u}.sock`),c(s),s}e.createRandomIPCHandle=D;function t(u,s,l){const P=v().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${l}-${s}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${P.substr(0,8)}-${l}-${s}.sock`):A=(0,C.join)(u,`${l}-${s}.sock`),c(A),A}e.createStaticIPCHandle=t;function c(u){const s=S[k.platform];typeof s=="number"&&u.length>=s&&console.warn(`WARNING: IPC handle "${u}" is longer than ${s} chars, try a shorter --user-data-dir`)}class i extends f.IPCServer{static b(s){const l=n.Event.fromNodeEventEmitter(s,"connection");return n.Event.map(l,P=>({protocol:new b.Protocol(new y(P,"ipc-server-connection")),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(P,"close"))}))}constructor(s){super(i.b(s)),this.d=s}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function r(u){return new Promise((s,l)=>{const P=v().net.createServer();P.on("error",l),P.listen(u,()=>{P.removeListener("error",l),s(new i(P))})})}e.serve=r;function o(u,s){return new Promise((l,P)=>{const A=v().net.createConnection(u,()=>{A.removeListener("error",P),l(b.Client.fromSocket(new y(A,`ipc-client${s}`),s))});A.once("error",P)})}e.connect=o}),define(Z[106],_([0,1,7,3,2,10]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function k(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var g;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class f extends n.Disposable{constructor(y,d=Object.create(null)){super(),this.m=y,this.n=d,this.b=this.B(new M.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new E.ThrottledDelayer(f.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(y=>this.r(y)))}r(y){y.changed?.forEach((d,w)=>this.s(w,d)),y.deleted?.forEach(d=>this.s(d,void 0))}s(y,d){if(this.c===g.Closed)return;let w=!1;(0,R.isUndefinedOrNull)(d)?w=this.f.delete(y):this.f.get(y)!==d&&(this.f.set(y,d),w=!0),w&&this.b.fire(y)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(y,d){const w=this.f.get(y);return(0,R.isUndefinedOrNull)(w)?d:w}getBoolean(y,d){const w=this.get(y);return(0,R.isUndefinedOrNull)(w)?d:w==="true"}getNumber(y,d){const w=this.get(y);return(0,R.isUndefinedOrNull)(w)?d:parseInt(w,10)}async set(y,d){if(this.c===g.Closed)return;if((0,R.isUndefinedOrNull)(d))return this.delete(y);const w=String(d);if(this.f.get(y)!==w)return this.f.set(y,w),this.j.set(y,w),this.h.delete(y),this.b.fire(y),this.w()}async delete(y){if(!(this.c===g.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire(y),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(y).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(y){if(!!this.u)return this.w(y)}async w(y){return this.g.trigger(()=>this.v(),y)}async whenFlushed(){if(!!this.u)return new Promise(y=>this.l.push(y))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}f.a=100,e.Storage=f;class b{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((d,w)=>this.a.set(w,d)),y.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=b}),define(Z[156],_([0,1,7,3,35,9,23]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return M.Event.None}constructor(b,v=Object.create(null)){this.g=b,this.h=v,this.c=(0,R.basename)(this.g),this.d=new g(this.h.logging),this.f=this.n(this.g)}async getItems(){const b=await this.f,v=new Map;return(await this.s(b,"SELECT * FROM ItemTable")).forEach(d=>v.set(d.key,d.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${v.size} rows`),v}async updateItems(b){const v=await this.f;return this.j(v,b)}j(b,v){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${v.insert?(0,n.mapToString)(v.insert):"0"}), delete(${v.delete?(0,n.setToString)(v.delete):"0"})`),this.t(b,()=>{const y=v.insert,d=v.delete;if(y&&y.size>0){const w=[];w.push([]);let p=0;y.forEach((a,h)=>{let m=w[p];m.length>k.b&&(p++,m=[],w.push(m)),m.push(h,a)}),w.forEach(a=>{this.u(b,`INSERT INTO ItemTable VALUES ${new Array(a.length/2).fill("(?,?)").join(",")}`,h=>h.run(a),()=>{const h=[];let m=0;return y.forEach((I,S)=>{h.push(S),m+=I.length}),`Keys: ${h.join(", ")} Length: ${m}`})})}if(d&&d.size){const w=[];w.push([]);let p=0;d.forEach(a=>{let h=w[p];h.length>k.b&&(p++,h=[],w.push(h)),h.push(a)}),w.forEach(a=>{this.u(b,`DELETE FROM ItemTable WHERE key IN (${new Array(a.length).fill("?").join(",")})`,h=>h.run(a),()=>{const h=[];return d.forEach(m=>{h.push(m)}),`Keys: ${h.join(", ")}`})})}})}async close(b){this.d.trace(`[storage ${this.c}] close()`);const v=await this.f;return this.k(v,b)}k(b,v){return new Promise((y,d)=>{b.db.close(w=>(w&&this.o(b,`[storage ${this.c}] close(): ${w}`),this.g===k.IN_MEMORY_PATH?y():!b.isErroneous&&!b.isInMemory?this.l().then(y,p=>(this.d.error(`[storage ${this.c}] backup(): ${p}`),y())):typeof v=="function"?C.Promises.unlink(this.g).then(()=>this.p(this.g).then(p=>{const a=()=>this.k(p,void 0);return this.j(p,{insert:v()}).then(()=>a(),h=>(a(),Promise.reject(h)))})).then(y,d):d(w||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const b=this.m(this.g);return C.Promises.copy(this.g,b,{preserveSymlinks:!1})}m(b){return`${b}.backup`}async checkIntegrity(b){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${b})`);const v=await this.f,y=await this.r(v,b?"PRAGMA integrity_check":"PRAGMA quick_check"),d=b?y.integrity_check:y.quick_check;return v.isErroneous?`${d} (last error: ${v.lastError})`:v.isInMemory?`${d} (in-memory!)`:d}async n(b,v=!0){this.d.trace(`[storage ${this.c}] open(${b}, retryOnBusy: ${v})`);try{return await this.p(b)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&v)return await(0,E.timeout)(k.a),this.n(b,!1);try{await C.Promises.unlink(b);try{await C.Promises.rename(this.m(b),b)}catch{}return await this.p(b)}catch(d){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${d}`),this.p(k.IN_MEMORY_PATH)}}}o(b,v){b.isErroneous=!0,b.lastError=v,this.d.error(v)}p(b){return new Promise((v,y)=>{new Promise((d,w)=>{x(["@vscode/sqlite3"],d,w)}).then(d=>{const w={db:new(this.d.isTracing?d.verbose().Database:d.Database)(b,p=>p?w.db&&p.code!=="SQLITE_CANTOPEN"?w.db.close(()=>y(p)):y(p):this.q(w,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>v(w),a=>w.db.close(()=>y(a)))),isInMemory:b===k.IN_MEMORY_PATH};w.db.on("error",p=>this.o(w,`[storage ${this.c}] Error (event): ${p}`)),this.d.isTracing&&w.db.on("trace",p=>this.d.trace(`[storage ${this.c}] Trace (event): ${p}`))},y)})}q(b,v){return new Promise((y,d)=>{b.db.exec(v,w=>w?(this.o(b,`[storage ${this.c}] exec(): ${w}`),d(w)):y())})}r(b,v){return new Promise((y,d)=>{b.db.get(v,(w,p)=>w?(this.o(b,`[storage ${this.c}] get(): ${w}`),d(w)):y(p))})}s(b,v){return new Promise((y,d)=>{b.db.all(v,(w,p)=>w?(this.o(b,`[storage ${this.c}] all(): ${w}`),d(w)):y(p))})}t(b,v){return new Promise((y,d)=>{b.db.serialize(()=>{b.db.run("BEGIN TRANSACTION"),v(),b.db.run("END TRANSACTION",w=>w?(this.o(b,`[storage ${this.c}] transaction(): ${w}`),d(w)):y())})})}u(b,v,y,d){const w=b.db.prepare(v),p=a=>{this.o(b,`[storage ${this.c}] prepare(): ${a} (${v}). Details: ${d()}`)};w.on("error",p),y(w),w.finalize(a=>{a&&p(a),w.removeListener("error",p)})}}k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256,e.SQLiteStorageDatabase=k;class g{constructor(b){b&&typeof b.logTrace=="function"&&process.env[g.VSCODE_TRACE_STORAGE]&&(this.a=b.logTrace),b&&typeof b.logError=="function"&&(this.b=b.logError)}get isTracing(){return!!this.a}trace(b){this.a?.(b)}error(b){this.b?.(b)}}g.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[157],_([12,11]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(Z[158],_([12,11]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[159],_([12,11]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(Z[160],_([12,11]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[161],_([12,11]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(Z[162],_([12,11]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(Z[163],_([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[164],_([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Z[165],_([12,11]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Z[166],_([12,11]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[167],_([12,11]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[168],_([12,11]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Z[169],_([12,11]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(Z[170],_([12,11]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Z[171],_([12,11]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(Z[172],_([12,11]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[173],_([12,11]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[174],_([12,11]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[175],_([12,11]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[176],_([12,11]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Z[177],_([12,11]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Z[178],_([12,11]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[179],_([12,11]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[180],_([12,11]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Z[181],_([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(Z[182],_([12,11]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[183],_([12,11]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Z[184],_([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[185],_([12,11]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[186],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(n){return n&&n.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function M(n){return n&&n.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=M}),define(Z[187],_([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function M(C){return typeof C?.backupFolder=="string"}e.isEmptyWindowBackupInfo=M;function n(C){let k=[];try{Array.isArray(C.workspaces)&&(k=C.workspaces.map(g=>({workspace:{id:g.id,configPath:E.URI.parse(g.configURIPath)},remoteAuthority:g.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=n;function R(C){let k=[];try{Array.isArray(C.folders)&&(k=C.folders.map(g=>({folderUri:E.URI.parse(g.folderUri),remoteAuthority:g.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=R}),define(Z[188],_([0,1,3,2]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class n{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(k,g,f){switch(g){case"close":return Promise.resolve(this.a.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(k,g,f){switch(g){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}n.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=n;class R extends M.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,g,f){this.b.call("attach",[k,g,f])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,g){this.b.call("terminate",[k,g])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,g){return this.b.call("openExtensionDevelopmentHostWindow",[k,g])}}e.ExtensionHostDebugChannelClient=R}),define(Z[189],_([0,1,142,54,14,9,36,18,8]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class f{get appRoot(){return(0,R.dirname)(n.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const w=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",w)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(g.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=C.env.VSCODE_PORTABLE;return w?g.URI.file((0,R.join)(w,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,R.resolve)(w):(0,R.normalize)((0,R.join)(n.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?g.URI.file((0,R.resolve)(w)):g.URI.file((0,R.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,R.resolve)(w);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const a=C.env.VSCODE_PORTABLE;return a?(0,R.join)(a,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(p=>/^[^:/?#]+?:\/\//.test(p)?g.URI.parse(p):g.URI.file((0,R.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?g.URI.parse(w):g.URI.file((0,R.normalize)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(w))}get extensionLogLevel(){const w=[];for(const p of this.args.log||[]){const a=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);a&&a[1]&&a[2]&&w.push([a[1],a[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=C.env.VSCODE_PORTABLE;return w?g.URI.file((0,R.join)(w,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,p,a){this.a=w,this.b=p,this.c=a,this.editSessionId=this.args.editSessionId}}ve([M.memoize],f.prototype,"appRoot",null),ve([M.memoize],f.prototype,"userHome",null),ve([M.memoize],f.prototype,"userDataPath",null),ve([M.memoize],f.prototype,"appSettingsHome",null),ve([M.memoize],f.prototype,"tmpDir",null),ve([M.memoize],f.prototype,"cacheHome",null),ve([M.memoize],f.prototype,"stateResource",null),ve([M.memoize],f.prototype,"userRoamingDataHome",null),ve([M.memoize],f.prototype,"userDataSyncHome",null),ve([M.memoize],f.prototype,"userDataSyncLogResource",null),ve([M.memoize],f.prototype,"editSessionsLogResource",null),ve([M.memoize],f.prototype,"sync",null),ve([M.memoize],f.prototype,"machineSettingsResource",null),ve([M.memoize],f.prototype,"workspaceStorageHome",null),ve([M.memoize],f.prototype,"localHistoryHome",null),ve([M.memoize],f.prototype,"keyboardLayoutResource",null),ve([M.memoize],f.prototype,"argvResource",null),ve([M.memoize],f.prototype,"isExtensionDevelopment",null),ve([M.memoize],f.prototype,"untitledWorkspacesHome",null),ve([M.memoize],f.prototype,"installSourcePath",null),ve([M.memoize],f.prototype,"builtinExtensionsPath",null),ve([M.memoize],f.prototype,"extensionsPath",null),ve([M.memoize],f.prototype,"extensionDevelopmentLocationURI",null),ve([M.memoize],f.prototype,"extensionDevelopmentKind",null),ve([M.memoize],f.prototype,"extensionTestsLocationURI",null),ve([M.memoize],f.prototype,"debugExtensionHost",null),ve([M.memoize],f.prototype,"logLevel",null),ve([M.memoize],f.prototype,"extensionLogLevel",null),ve([M.memoize],f.prototype,"serviceMachineIdResource",null),ve([M.memoize],f.prototype,"telemetryLogResource",null),ve([M.memoize],f.prototype,"disableWorkspaceTrust",null),ve([M.memoize],f.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=f;function b(d,w){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,w,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=b;function v(d,w){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,w,d.extensionEnvironment)}e.parsePtyHostPort=v;function y(d,w,p,a,h,m){const S=Number(w||d)||(a?null:p),D=S?Boolean(!!w):!1;let t;if(m)try{t=JSON.parse(m)}catch{}return{port:S,break:D,debugId:h,env:t}}}),define(Z[107],_([0,1,288,4,161]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,n.localize)(0,null),e:(0,n.localize)(1,null),t:(0,n.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,n.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,n.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,n.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,n.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,n.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,n.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,n.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,n.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,n.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,n.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,n.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,n.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,n.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,n.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,n.localize)(17,null)},category:{type:"string",cat:"e",description:(0,n.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,n.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,n.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,n.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,n.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,n.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,n.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,n.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,n.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,n.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,n.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,n.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,n.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,n.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,n.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,n.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,n.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,n.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(p,a,h=C){const m=p.find(u=>u.length>0&&u[0]!=="-"),I={},S=["_"],D=[],t={};let c;for(const u in a){const s=a[u];s.type==="subcommand"?u===m&&(c=s):(s.alias&&(I[u]=s.alias),s.type==="string"||s.type==="string[]"?(S.push(u),s.deprecates&&S.push(...s.deprecates)):s.type==="boolean"&&(D.push(u),s.deprecates&&D.push(...s.deprecates)),s.global&&(t[u]=s))}if(c&&m){const u=t;for(const A in c.options)u[A]=c.options[A];const s=p.filter(A=>A!==m),l=h.getSubcommandReporter?h.getSubcommandReporter(m):void 0,P=k(s,u,l);return{[m]:P,_:[]}}const i=E(p,{string:S,boolean:D,alias:I}),r={},o=i;r._=i._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in a){const s=a[u];if(s.type==="subcommand")continue;s.alias&&delete o[s.alias];let l=o[u];if(s.deprecates)for(const P of s.deprecates)o.hasOwnProperty(P)&&(l||(l=o[P],l&&h.onDeprecatedOption(P,s.deprecationMessage||(0,n.localize)(36,null,u))),delete o[P]);if(typeof l<"u"){if(s.type==="string[]"){if(Array.isArray(l)||(l=[l]),!s.allowEmptyValue){const P=l.filter(A=>A.length>0);P.length!==l.length&&(h.onEmptyValue(u),l=P.length>0?P:void 0)}}else s.type==="string"&&(Array.isArray(l)?(l=l.pop(),h.onMultipleValues(u,l)):!l&&!s.allowEmptyValue&&(h.onEmptyValue(u),l=void 0));r[u]=l,s.deprecationMessage&&h.onDeprecatedOption(u,s.deprecationMessage)}delete o[u]}for(const u in o)h.onUnknownOption(u);return r}e.parseArgs=k;function g(p,a){let h="";return a.args&&(Array.isArray(a.args)?h=` <${a.args.join("> <")}>`:h=` <${a.args}>`),a.alias?`-${a.alias} --${p}${h}`:`--${p}${h}`}function f(p,a){const h=[];for(const m in p){const I=p[m],S=g(m,I);h.push([S,I.description])}return b(h,a)}e.formatOptions=f;function b(p,a){const m=p.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(a-m<25)return p.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const I=a-m-1,S=[];for(const D of p){const t=D[0],c=y(D[1],I),i=v(m-t.length-2);S.push("  "+t+i+c[0]);for(let r=1;r<c.length;r++)S.push(v(m)+c[r])}return S}function v(p){return" ".repeat(p)}function y(p,a){const h=[];for(;p.length;){const m=p.length<a?p.length:p.lastIndexOf(" ",a),I=p.slice(0,m).trim();p=p.slice(m),h.push(I)}return h}function d(p,a,h,m,I){const S=process.stdout.isTTY&&process.stdout.columns||80,D=I?.noInputFiles!==!0?`[${(0,n.localize)(37,null)}...]`:"",t=[`${p} ${h}`];t.push(""),t.push(`${(0,n.localize)(38,null)}: ${a} [${(0,n.localize)(39,null)}]${D}`),t.push(""),I?.noPipe!==!0&&(M.isWindows?t.push((0,n.localize)(40,null,a)):t.push((0,n.localize)(41,null,a)),t.push(""));const c={},i=[];for(const r in m){const o=m[r];if(o.type==="subcommand")o.description&&i.push({command:r,description:o.description});else if(o.description&&o.cat){let u=c[o.cat];u||(c[o.cat]=u={}),u[r]=o}}for(const r in c){const o=r,u=c[o];u&&(t.push(R[o]),t.push(...f(u,S)),t.push(""))}return i.length&&(t.push((0,n.localize)(42,null)),t.push(...b(i.map(r=>[r.command,r.description]),S)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function w(p,a){return`${p||(0,n.localize)(43,null)}
${a||(0,n.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=w}),define(Z[190],_([0,1,82,188,107]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends M.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,g,f){return g==="openExtensionDevelopmentHostWindow"?this.g(f[0],f[1]):super.call(k,g,f)}async g(k,g){const f=(0,n.parseArgs)(k,n.OPTIONS);f.debugRenderer=g;const b=f.extensionDevelopmentPath;if(!b)return{success:!1};const[v]=await this.f.openExtensionDevelopmentHostWindow(b,{context:5,cli:f,forceProfile:f.profile,forceTempProfile:f["profile-temp"]});if(!g)return{success:!0};const y=v.win;if(!y)return{success:!0};const d=y.webContents.debugger;let w=d.isAttached()?1/0:0;const p=(0,E.createServer)(a=>{w++===0&&d.attach();let h=!1;const m=D=>{h||a.write(JSON.stringify(D)+"\0")},I=(D,t,c,i)=>m({method:t,params:c,sessionId:i});y.on("close",()=>{d.removeListener("message",I),a.end(),h=!0}),d.addListener("message",I);let S=Buffer.alloc(0);a.on("data",D=>{S=Buffer.concat([S,D]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let c;try{const i=S.slice(0,t).toString("utf8");S=S.slice(t+1),c=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}d.sendCommand(c.method,c.params,c.sessionId).then(i=>m({id:c.id,sessionId:c.sessionId,result:i})).catch(i=>m({id:c.id,sessionId:c.sessionId,error:{code:0,message:i.message}}))}}),a.on("error",D=>{console.error("error on cdp pipe:",D)}),a.on("close",()=>{h=!0,--w===0&&d.detach()})});return await new Promise(a=>p.listen(0,a)),y.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(Z[62],_([0,1,289,162,107]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function C(y,d){const w=(S,D)=>{console.warn((0,M.localize)(0,null,S,D))},p=S=>{console.warn((0,M.localize)(1,null,S))},a=(S,D)=>{console.warn((0,M.localize)(2,null,S,D))},h=S=>({onUnknownOption:D=>{S!=="tunnel"&&console.warn((0,M.localize)(3,null,D,S))},onMultipleValues:w,onEmptyValue:p,onDeprecatedOption:a,getSubcommandReporter:S!=="tunnel"?h:void 0}),m={onUnknownOption:S=>{console.warn((0,M.localize)(4,null,S))},onMultipleValues:w,onEmptyValue:p,onDeprecatedOption:a,getSubcommandReporter:h},I=(0,n.parseArgs)(y,n.OPTIONS,d?m:void 0);return I.goto&&I._.forEach(S=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),(0,M.localize)(5,null))),I["max-memory"]&&E(parseInt(I["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),I}function k(y){const d=y.findIndex(w=>!/^-/.test(w));if(d>-1)return[...y.slice(0,d),...y.slice(d+1)]}function g(y){let[,...d]=y;process.env.VSCODE_DEV&&(d=k(d)||[]);const w=!v(process.env);return C(d,w)}e.parseMainProcessArgv=g;function f(y){let[,,...d]=y;return process.env.VSCODE_DEV&&(d=k(d)||[]),C(d,!0)}e.parseCLIProcessArgv=f;function b(y,...d){const w=y.indexOf("--");return w===-1?y.push(...d):y.splice(w,0,...d),y}e.addArg=b;function v(y){return y.VSCODE_CLI==="1"}e.isLaunchedFromCli=v}),function(){"use strict";function x(e,E,M){function n(C,k){const g=R(C,k),f=[g];return e.isAbsolute(g)||f.unshift(M),e.resolve(...f)}function R(C,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,k);const b=C["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(v,"AppData","Roaming")}break;case"darwin":f=e.join(E.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,k)}return{getUserDataPath:n}}if(typeof define=="function")define(Z[191],_([192,26,36]),function(e,E,M){return x(e,E,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=x(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[193],_([0,1,26,189,191]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends M.AbstractNativeEnvironmentService{constructor(k,g){super(k,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,n.getUserDataPath)(k,g.nameShort)},g)}}e.NativeEnvironmentService=R}),define(Z[194],_([0,1,41,26,32]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function R(C){const k=(0,n.randomPath)((0,M.tmpdir)());try{return(0,E.writeFileSync)(k,""),C&&console.log(`Marker file for --wait created: ${k}`),k}catch(g){C&&console.error(`Failed to create marker file for --wait: ${g}`);return}}e.createWaitMarkerFileSync=R}),define(Z[195],_([0,1,10,164]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function n(C,k,g){try{R(C,k,g)}catch(f){console.error(f?.message??f)}return C}e.localizeManifest=n;function R(C,k,g){const f=(b,v,y)=>{const d=b[v];if((0,E.isString)(d)){const w=d,p=w.length;if(p>1&&w[0]==="%"&&w[p-1]==="%"){const a=w.substr(1,p-2);let h=k[a];h===void 0&&g&&(h=g[a]);const m=typeof h=="string"?h:h?.message,I=g?.[a],S=typeof I=="string"?I:I?.message;if(!m){S||console.warn(`[${C.name}]: ${(0,M.localize)(0,null,a)}`);return}if(y&&(v==="title"||v==="category")&&S&&S!==m){const D={value:m,original:S};b[v]=D}else b[v]=m}}else if((0,E.isObject)(d))for(const w in d)d.hasOwnProperty(w)&&(w==="commands"?f(d,w,!0):f(d,w,y));else if(Array.isArray(d))for(let w=0;w<d.length;w++)f(d,w,y)};for(const b in C)C.hasOwnProperty(b)&&f(C,b)}}),define(Z[196],_([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class M{constructor(){this.a=new Map}register(R,C){this.a.set(R,C)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const C in R.contributes){const k=this.a.get(C);if(!k)continue;const g=R.contributes[C],f=Array.isArray(g)?g:[g];try{k(f,R.activationEvents)}catch(b){(0,E.onUnexpectedError)(b)}}}}e.ImplicitActivationEventsImpl=M,e.ImplicitActivationEvents=new M}),define(Z[197],_([0,1,18,73,166,198]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function g(h){return h=h.trim(),h==="*"||C.test(h)}e.isValidVersionStr=g;function f(h){if(!g(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const m=h.match(C);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=f;function b(h){if(!h)return null;const m=h.majorBase,I=h.majorMustEqual,S=h.minorBase;let D=h.minorMustEqual;const t=h.patchBase;let c=h.patchMustEqual;h.hasCaret&&(m===0||(D=!1),c=!1);let i=0;if(h.preRelease){const r=k.exec(h.preRelease);if(r){const[,o,u,s]=r;i=Date.UTC(Number(o),Number(u)-1,Number(s))}}return{majorBase:m,majorMustEqual:I,minorBase:S,minorMustEqual:D,patchBase:t,patchMustEqual:c,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=b;function v(h,m,I){let S;typeof h=="string"?S=b(f(h)):S=h;let D;m instanceof Date?D=m.getTime():typeof m=="string"&&(D=new Date(m).getTime());let t;if(typeof I=="string"?t=b(f(I)):t=I,!S||!t)return!1;const c=S.majorBase,i=S.minorBase,r=S.patchBase;let o=t.majorBase,u=t.minorBase,s=t.patchBase;const l=t.notBefore;let P=t.majorMustEqual,A=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?c>o?!0:c<o?!1:i>u?!0:i<u||D&&D<l?!1:r>=s:(c===1&&o===0&&(!P||!A||!O)&&(o=1,u=0,s=0,P=!0,A=!1,O=!1),c<o?!1:c>o?!P:i<u?!1:i>u?!A:r<s?!1:r>s?!O:!(D&&D<l))}e.isValidVersion=v;function y(h,m,I,S,D){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([M.default.Error,n.localize(0,null)]),t;if(typeof S.name!="string")return t.push([M.default.Error,n.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([M.default.Error,n.localize(2,null,"version")]),t;if(!S.engines)return t.push([M.default.Error,n.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([M.default.Error,n.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!a(S.extensionDependencies))return t.push([M.default.Error,n.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!a(S.activationEvents))return t.push([M.default.Error,n.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([M.default.Error,n.localize(7,null,"activationEvents","main")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([M.default.Warning,n.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([M.default.Error,n.localize(9,null,"main")]),t;{const r=(0,E.joinPath)(I,S.main);(0,E.isEqualOrParent)(r,I)||t.push([M.default.Warning,n.localize(10,null,r.path,I.path)])}if(typeof S.activationEvents>"u")return t.push([M.default.Error,n.localize(11,null,"activationEvents","main")]),t}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([M.default.Error,n.localize(12,null,"browser")]),t;{const r=(0,E.joinPath)(I,S.browser);(0,E.isEqualOrParent)(r,I)||t.push([M.default.Warning,n.localize(13,null,r.path,I.path)])}if(typeof S.activationEvents>"u")return t.push([M.default.Error,n.localize(14,null,"activationEvents","browser")]),t}if(!R.valid(S.version))return t.push([M.default.Error,n.localize(15,null)]),t;const c=[];if(!d(h,m,S,D,c))for(const r of c)t.push([M.default.Error,r]);return t}e.validateExtensionManifest=y;function d(h,m,I,S,D){return S||typeof I.main>"u"&&typeof I.browser>"u"?!0:p(h,m,I.engines.vscode,D)}e.isValidExtensionVersion=d;function w(h,m,I){return h==="*"||p(m,I,h)}e.isEngineValid=w;function p(h,m,I,S=[]){const D=b(f(I));if(!D)return S.push(n.localize(16,null,I)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return S.push(n.localize(17,null,I)),!1}else if(!D.majorMustEqual)return S.push(n.localize(18,null,I)),!1;return v(h,m,D)?!0:(S.push(n.localize(19,null,h,I)),!1)}function a(h){if(!Array.isArray(h))return!1;for(let m=0,I=h.length;m<I;m++)if(typeof h[m]!="string")return!1;return!0}}),define(Z[199],_([0,1,17,31]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function n(R,C,k){let g=k&&k.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const b=(await C.readFile(R.serviceMachineIdResource)).value.toString();g=(0,M.isUUID)(b)?b:null}catch{g=null}if(!g){g=(0,M.generateUuid)();try{await C.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(g))}catch{}}return k?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=n}),define(Z[74],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(n,R=[],C=!1){this.ctor=n,this.staticArguments=R,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=E}),define(Z[200],_([0,1,74]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const M=[];var n;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(n=e.InstantiationType||(e.InstantiationType={}));function R(k,g,f){g instanceof E.SyncDescriptor||(g=new E.SyncDescriptor(g,[],Boolean(f))),M.push([k,g])}e.registerSingleton=R;function C(){return M}e.getSingletonServiceDescriptors=C}),define(Z[201],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R,C){this.key=R,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const C of this.a.values())C.outgoing.size===0&&R.push(C);return R}insertEdge(R,C){const k=this.lookupOrInsertNode(R),g=this.lookupOrInsertNode(C);k.outgoing.set(g.key,g),g.incoming.set(k.key,k)}removeNode(R){const C=this.b(R);this.a.delete(C);for(const k of this.a.values())k.outgoing.delete(C),k.incoming.delete(C)}lookupOrInsertNode(R){const C=this.b(R);let k=this.a.get(C);return k||(k=new E(C,R),this.a.set(C,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[C,k]of this.a)R.push(`${C}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,C]of this.a){const k=new Set([R]),g=this.c(C,k);if(g)return g}}c(R,C){for(const[k,g]of R.outgoing){if(C.has(k))return[...C,k].join(" -> ");C.add(k);const f=this.c(g,C);if(f)return f;C.delete(k)}}}e.Graph=M}),define(Z[6],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function k(g){return g[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=k})(E=e._util||(e._util={})),e.IInstantiationService=n("instantiationService");function M(C,k,g){k[E.DI_TARGET]===k?k[E.DI_DEPENDENCIES].push({id:C,index:g}):(k[E.DI_DEPENDENCIES]=[{id:C,index:g}],k[E.DI_TARGET]=k)}function n(C){if(E.serviceIds.has(C))return E.serviceIds.get(C);const k=function(g,f,b){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(k,g,b)};return k.toString=()=>C,E.serviceIds.set(C,k),k}e.createDecorator=n;function R(C){return C}e.refineServiceDecorator=R}),define(Z[63],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(Z[19],_([0,1,10,8,6]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,n.createDecorator)("configurationService");function R(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationOverrides=R;function C(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=C;var k;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function f(a,h){const m=Object.create(null);for(const I in a)b(m,I,a[I],h);return m}e.toValuesTree=f;function b(a,h,m,I){const S=h.split("."),D=S.pop();let t=a;for(let c=0;c<S.length;c++){const i=S[c];let r=t[i];switch(typeof r){case"undefined":r=t[i]=Object.create(null);break;case"object":break;default:I(`Ignoring ${h} as ${S.slice(0,c+1).join(".")} is ${JSON.stringify(r)}`);return}t=r}if(typeof t=="object"&&t!==null)try{t[D]=m}catch{I(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(t)}`)}else I(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=b;function v(a,h){const m=h.split(".");y(a,m)}e.removeFromValueTree=v;function y(a,h){const m=h.shift();if(h.length===0){delete a[m];return}if(Object.keys(a).indexOf(m)!==-1){const I=a[m];typeof I=="object"&&!Array.isArray(I)&&(y(I,h),Object.keys(I).length===0&&delete a[m])}}function d(a,h,m){function I(t,c){let i=t;for(const r of c){if(typeof i!="object"||i===null)return;i=i[r]}return i}const S=h.split("."),D=I(a,S);return typeof D>"u"?m:D}e.getConfigurationValue=d;function w(a,h,m){Object.keys(h).forEach(I=>{I!=="__proto__"&&(I in a?E.isObject(a[I])&&E.isObject(h[I])?w(a[I],h[I],m):m&&(a[I]=h[I]):a[I]=h[I])})}e.merge=w;function p(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(Z[75],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class M{constructor(){this.a={}}async getPassword(R,C){return this.a[R]?.[C]??null}async setPassword(R,C,k){this.a[R]=this.a[R]??{},this.a[R][C]=k}async deletePassword(R,C){return this.a[R]?.[C]?(delete this.a[R][C],Object.keys(this.a[R]).length===0&&delete this.a[R],!0):!1}async findPassword(R){return JSON.stringify(this.a[R])??null}async findCredentials(R){const C=[];for(const k of Object.keys(this.a[R]||{}))C.push({account:k,password:this.a[R][k]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=M}),define(Z[87],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function M(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=M;class n{async getPerformanceInfo(C,k){return{}}async getSystemInfo(C,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,k){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=n}),define(Z[88],_([0,1,18,73,159,6,45,4,37]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,R.createDecorator)("dialogService");var f;(function(p){p[p.Confirmation=1]="Confirmation",p[p.Prompt=2]="Prompt",p[p.Input=3]="Input"})(f||(f={}));class b{a(a){return this.d(a,f.Confirmation)}b(a){return this.d(a,f.Prompt)}c(a){return this.d(a,f.Input)}d(a,h){const m=[];switch(h){case f.Confirmation:{const I=a;I.primaryButton?m.push(I.primaryButton):m.push((0,n.localize)(0,null)),I.cancelButton?m.push(I.cancelButton):m.push((0,n.localize)(1,null));break}case f.Prompt:{const I=a;Array.isArray(I.buttons)&&I.buttons.length>0&&m.push(...I.buttons.map(S=>S.label)),I.cancelButton&&(I.cancelButton===!0?m.push((0,n.localize)(2,null)):typeof I.cancelButton=="string"?m.push(I.cancelButton):I.cancelButton.label?m.push(I.cancelButton.label):m.push((0,n.localize)(3,null))),m.length===0&&m.push((0,n.localize)(4,null));break}case f.Input:{const I=a;I.primaryButton?m.push(I.primaryButton):m.push((0,n.localize)(5,null)),I.cancelButton?m.push(I.cancelButton):m.push((0,n.localize)(6,null));break}}return m}e(a){if(typeof a=="string")return a;if(typeof a=="number")return a===M.default.Info?"info":a===M.default.Error?"error":a===M.default.Warning?"warning":"none"}async f(a,h,m){const I=[...a.buttons??[]];return a.cancelButton&&typeof a.cancelButton!="string"&&typeof a.cancelButton!="boolean"&&I.push(a.cancelButton),{result:await I[h]?.run({checkboxChecked:m}),checkboxChecked:m}}}e.AbstractDialogHandler=b,e.IFileDialogService=(0,R.createDecorator)("fileDialogService");var v;(function(p){p[p.SAVE=0]="SAVE",p[p.DONT_SAVE=1]="DONT_SAVE",p[p.CANCEL=2]="CANCEL"})(v=e.ConfirmResult||(e.ConfirmResult={}));const y=10;function d(p){const a=[];return a.push(...p.slice(0,y).map(h=>typeof h=="string"?h:(0,E.basename)(h))),p.length>y&&(p.length-y===1?a.push((0,n.localize)(7,null)):a.push((0,n.localize)(8,null,p.length-y))),a.push(""),a.join(`
`)}e.getFileNamesMessage=d;function w(p,a){const h=(0,g.deepClone)(p);let m=(h.buttons??[]).map(t=>(0,C.mnemonicButtonLabel)(t)),I=(p.buttons||[]).map((t,c)=>c),S=0,D=h.cancelId??m.length-1;if(m.length>1){const t=typeof D=="number"?m[D]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&m.length>1&&D!==1){m.splice(D,1),m.splice(1,0,t);const c=I[D];I.splice(D,1),I.splice(1,0,c),D=1}k.isLinux&&m.length>1&&(m=m.reverse(),I=I.reverse(),S=m.length-1,typeof t=="string"&&(D=S-1))}else if(k.isWindows&&typeof t=="string"&&m.length>1&&D!==m.length-1){m.splice(D,1),m.push(t);const c=I[D];I.splice(D,1),I.push(c),D=m.length-1}}return h.buttons=m,h.defaultId=S,h.cancelId=D,h.noLink=!0,h.title=h.title||a.nameLong,{options:h,buttonIndeces:I}}e.massageMessageBoxOptions=w}),define(Z[108],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(Z[34],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[28],_([0,1,54,9,86,34,193,6]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(R.IEnvironmentService);class g extends C.NativeEnvironmentService{get cachedLanguagesPath(){return(0,M.join)(this.userDataPath,"clp")}get backupHome(){return(0,M.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,M.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}ve([E.memoize],g.prototype,"cachedLanguagesPath",null),ve([E.memoize],g.prototype,"backupHome",null),ve([E.memoize],g.prototype,"mainIPCHandle",null),ve([E.memoize],g.prototype,"mainLockfile",null),ve([E.memoize],g.prototype,"disableUpdates",null),ve([E.memoize],g.prototype,"disableKeytar",null),ve([E.memoize],g.prototype,"crossOriginIsolated",null),ve([E.memoize],g.prototype,"codeCachePath",null),ve([E.memoize],g.prototype,"useCodeCache",null),e.EnvironmentMainService=g}),define(Z[109],_([0,1,163,6]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function n(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(h,m){switch(h){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function k(h,m){return m==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function g(h,m,I){return k(m,I)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===I?!0:f(I).includes(h)}e.isTargetPlatformCompatible=g;function f(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=f;function b(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=b;var v;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(v=e.SortBy||(e.SortBy={}));var y;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(y=e.SortOrder||(e.SortOrder={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var w;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var p;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class a extends Error{constructor(m,I){super(m),this.code=I,this.name=I}}e.ExtensionManagementError=a,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Z[202],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(Z[203],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[110],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(Z[204],_([0,1,46,14,9,4,71,23,85,167,110]),function(x,e,E,M,n,R,C,k,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const v=f.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends y{openTerminal(S,D){return this.spawnTerminal(E,S,g.getWindowsShell(),D)}spawnTerminal(S,D,t,c){const i=D.windowsExec||d.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const r=n.basename(i,".exe").toLowerCase();if(r==="cmder")return S.spawn(i,c?[c]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),r==="wt"&&o.push("-d ."),new Promise((u,s)=>{const l=a(process),P=S.spawn(t,o,{cwd:c,env:l});P.on("error",s),P.on("exit",()=>u())})}runInTerminal(S,D,t,c,i){const r="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows();return new Promise((o,u)=>{const s=`"${D} - ${v}"`,l=`""${t.join('" "')}" & pause"`,P=Object.assign({},a(process),c);Object.keys(P).filter(H=>P[H]===null).forEach(H=>delete P[H]);const A={cwd:D,env:P,windowsVerbatimArguments:!0};let O,N;n.basename(r,".exe")==="wt"?(O=r,N=["-d",".",d.b,"/c",l]):(O=d.b,N=["/c","start",s,"/wait",r,"/c",l]),E.spawn(O,N,A).on("error",H=>{u(h(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return d.d}}d.b="cmd.exe",e.WindowsExternalTerminalService=d;class w extends y{openTerminal(S,D){return this.spawnTerminal(E,S,D)}runInTerminal(S,D,t,c,i){const r=i.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((o,u)=>{if(r===b.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const s=r===b.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",P=[M.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${s}.scpt`).fsPath,"-t",S||v,"-w",D];for(const N of t)P.push("-a"),P.push(N);if(c){const N=Object.assign({},a(process),c);for(const z in N){const H=N[z];H===null?(P.push("-u"),P.push(z)):(P.push("-e"),P.push(`${z}=${H}`))}}let A="";const O=E.spawn(w.b,P);O.on("error",N=>{u(h(N))}),O.stderr.on("data",N=>{A+=N.toString()}),O.on("exit",N=>{if(N===0)o(void 0);else if(A){const z=A.split(`
`,1);u(new Error(z[0]))}else u(new Error(f.localize(1,null,s,N)))})}else u(new Error(f.localize(2,null,r)))})}spawnTerminal(S,D,t){const c=D.osxExec||b.DEFAULT_TERMINAL_OSX;return new Promise((i,r)=>{const o=["-a",c];t&&o.push(t);const u=a(process),s=S.spawn("/usr/bin/open",o,{cwd:t,env:u});s.on("error",r),s.on("exit",()=>i())})}}w.b="/usr/bin/osascript",e.MacExternalTerminalService=w;class p extends y{openTerminal(S,D){return this.spawnTerminal(E,S,D)}runInTerminal(S,D,t,c,i){const r=i.linuxExec?Promise.resolve(i.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{const s=[];r.then(l=>{l.indexOf("gnome-terminal")>=0?s.push("-x"):s.push("-e"),s.push("bash"),s.push("-c");const P=`${m(t)}; echo; read -p "${p.b}" -n1;`;s.push(`''${P}''`);const A=Object.assign({},a(process),c);Object.keys(A).filter(H=>A[H]===null).forEach(H=>delete A[H]);const O={cwd:D,env:A};let N="";const z=E.spawn(l,s,O);z.on("error",H=>{u(h(H))}),z.stderr.on("data",H=>{N+=H.toString()}),z.on("exit",H=>{if(H===0)o(void 0);else if(N){const ie=N.split(`
`,1);u(new Error(ie[0]))}else u(new Error(f.localize(4,null,l,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!R.isLinux)p.d=Promise.resolve("xterm");else{const S=await k.Promises.exists("/etc/debian_version");p.d=new Promise(D=>{S?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return p.d}spawnTerminal(S,D,t){const c=D.linuxExec?Promise.resolve(D.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((i,r)=>{c.then(o=>{const u=a(process),s=S.spawn(o,[],{cwd:t,env:u});s.on("error",r),s.on("exit",()=>i())})})}}p.b=f.localize(3,null),e.LinuxExternalTerminalService=p;function a(I){const S={...I.env};return(0,C.sanitizeProcessEnvironment)(S),S}function h(I){return"errno"in I&&I.errno==="ENOENT"&&"path"in I&&typeof I.path=="string"?new Error(f.localize(5,null,I.path)):I}function m(I){let S="";for(const D of I)D.indexOf(" ")>=0?S+='"'+D+'"':S+=D,S+=" ";return S}}),define(Z[16],_([0,1,61,9,27,10,8,169,6,4,14]),function(x,e,E,M,n,R,C,k,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,g.createDecorator)("fileService");function v(T){return T.create===!0}e.isFileOpenForWriteOptions=v;var y;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(y=e.FileType||(e.FileType={}));var d;(function(T){T[T.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var w;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileClone=32768]="FileClone"})(w=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(T){return!!(T.capabilities&2)}e.hasReadWriteCapability=p;function a(T){return!!(T.capabilities&8)}e.hasFileFolderCopyCapability=a;function h(T){return!!(T.capabilities&32768)}e.hasFileCloneCapability=h;function m(T){return!!(T.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function I(T){return!!(T.capabilities&16)}e.hasFileReadStreamCapability=I;function S(T){return p(T)?!!(T.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var D;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(D=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(q,Y){const te=new t(q.toString(),Y);return r(te,Y),te}constructor(q,Y){super(q),this.code=Y}}e.FileSystemProviderError=t;function c(T,q){return t.create(T,q)}e.createFileSystemProviderError=c;function i(T){return T||c((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function r(T,q){return T.name=q?`${q} (FileSystemError)`:"FileSystemError",T}e.markAsFileSystemProviderError=r;function o(T){if(!T)return D.Unknown;if(T instanceof t)return T.code;const q=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!q)return D.Unknown;switch(q[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileExceedsMemoryLimit:return D.FileExceedsMemoryLimit;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=o;function u(T){if(T instanceof N)return T.fileOperationResult;switch(o(T)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 10;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileExceedsMemoryLimit:return 9;case D.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var s;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(s=e.FileOperation||(e.FileOperation={}));class l{constructor(q,Y,te){this.resource=q,this.operation=Y,this.target=te}isOperation(q){return this.operation===q}}e.FileOperationEvent=l;var P;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(P=e.FileChangeType||(e.FileChangeType={}));class A{constructor(q,Y){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ne of q){const L=te.get(ne.type);switch(L?L.push([ne.resource,ne]):te.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,L]of te)switch(ne){case 1:this.a=E.TernarySearchTree.forUris(()=>Y),this.a.fill(L);break;case 0:this.b=E.TernarySearchTree.forUris(()=>Y),this.b.fill(L);break;case 2:this.c=E.TernarySearchTree.forUris(()=>Y),this.c.fill(L);break}}contains(q,...Y){return this.d(q,{includeChildren:!1},...Y)}affects(q,...Y){return this.d(q,{includeChildren:!0},...Y)}d(q,Y,...te){if(!q)return!1;const ne=te.length>0;return!!((!ne||te.includes(1))&&(this.a?.get(q)||Y.includeChildren&&this.a?.findSuperstr(q))||(!ne||te.includes(0))&&(this.b?.get(q)||Y.includeChildren&&this.b?.findSuperstr(q))||(!ne||te.includes(2))&&(this.c?.findSubstr(q)||Y.includeChildren&&this.c?.findSuperstr(q)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=A;function O(T,q,Y){return!T||!q||T===q||q.length>T.length?!1:(q.charAt(q.length-1)!==M.sep&&(q+=M.sep),Y?(0,n.startsWithIgnoreCase)(T,q):T.indexOf(q)===0)}e.isParent=O;class N extends Error{constructor(q,Y,te){super(q),this.fileOperationResult=Y,this.options=te}}e.FileOperationError=N;class z extends N{constructor(q,Y,te,ne){super(q,Y,ne),this.fileOperationResult=Y,this.size=te}}e.TooLargeFileOperationError=z;class H extends N{constructor(q,Y,te){super(q,2,te),this.stat=Y}}e.NotModifiedSinceFileOperationError=H;var ie;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",T[T.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(ie=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var se;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(se=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function oe(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.etag=oe;async function ue(T,q){if(!q.hasProvider(C.URI.from({scheme:T.scheme})))return new Promise(Y=>{const te=q.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===T.scheme&&ne.added&&(te.dispose(),Y())})})}e.whenProviderRegistered=ue,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(q){return(0,R.isNumber)(q)||(q=0),q<le.KB?(0,k.localize)(1,null,q.toFixed(0)):q<le.MB?(0,k.localize)(2,null,(q/le.KB).toFixed(2)):q<le.GB?(0,k.localize)(3,null,(q/le.MB).toFixed(2)):q<le.TB?(0,k.localize)(4,null,(q/le.GB).toFixed(2)):(0,k.localize)(5,null,(q/le.TB).toFixed(2))}}le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB,e.ByteSize=le;var me;(function(T){T[T.IA32=0]="IA32",T[T.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function G(T){return{maxFileSize:T===0?300*le.MB:16*le.GB,maxHeapSize:T===0?700*le.MB:2*700*le.MB}}e.getPlatformFileLimits=G;function B(T){const q=typeof T=="string"||T?.scheme===b.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===b.Schemas.file?1024*le.MB:q?10*le.MB:f.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=B}),define(Z[205],_([0,1,17,44,13,3,2,59,8,31,16]),function(x,e,E,M,n,R,C,k,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class v extends C.Disposable{constructor(d,w){super(),this.a=d,this.b=w,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.h=(0,f.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,w){const{buffer:p}=await this.a.call("readFile",[d,w]);return p}readFileStream(d,w,p){const a=(0,k.newWriteableStream)(m=>E.VSBuffer.concat(m.map(I=>E.VSBuffer.wrap(I))).buffer),h=this.a.listen("readFileStream",[d,w])(m=>{if(m instanceof E.VSBuffer)a.write(m.buffer);else{if(m==="end")a.end();else{let I;if(m instanceof Error)I=m;else{const S=m;I=(0,b.createFileSystemProviderError)(S.message??(0,M.toErrorMessage)(S),S.code??b.FileSystemProviderErrorCode.Unknown)}a.error(I),a.end()}h.dispose()}});return p.onCancellationRequested(()=>{a.error((0,n.canceled)()),a.end(),h.dispose()}),a}writeFile(d,w,p){return this.a.call("writeFile",[d,E.VSBuffer.wrap(w),p])}open(d,w){return this.a.call("open",[d,w])}close(d){return this.a.call("close",[d])}async read(d,w,p,a,h){const[m,I]=await this.a.call("read",[d,w,h]);return p.set(m.buffer.slice(0,I),a),I}write(d,w,p,a,h){return this.a.call("write",[d,w,E.VSBuffer.wrap(p),a,h])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,w){return this.a.call("delete",[d,w])}rename(d,w,p){return this.a.call("rename",[d,w,p])}copy(d,w,p){return this.a.call("copy",[d,w,p])}cloneFile(d,w){return this.a.call("cloneFile",[d,w])}i(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const w=d;this.f.fire(w.map(p=>({resource:g.URI.revive(p.resource),type:p.type})))}else{const w=d;this.g.fire(w)}}))}watch(d,w){const p=(0,f.generateUuid)();return this.a.call("watch",[this.h,p,d,w]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=v}),define(Z[111],_([0,1,17,13,170,16]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(b,v,y,d,w,p){let a;try{await k(b,v,y,d,w,p)}catch(h){a=h}finally{a&&w.errorTransformer&&(a=w.errorTransformer(a)),typeof a<"u"&&y.error(a),y.end()}}e.readFileIntoStream=C;async function k(b,v,y,d,w,p){g(p);const a=await b.open(v,{create:!1});try{g(p);let h=0,m=0,I=w&&typeof w.length=="number"?w.length:void 0,S=E.VSBuffer.alloc(Math.min(w.bufferSize,typeof I=="number"?I:w.bufferSize)),D=w&&typeof w.position=="number"?w.position:0,t=0;do m=await b.read(a,D,S.buffer,t,S.byteLength-t),D+=m,t+=m,h+=m,typeof I=="number"&&(I-=m),t===S.byteLength&&(await y.write(d(S)),S=E.VSBuffer.alloc(Math.min(w.bufferSize,typeof I=="number"?I:w.bufferSize)),t=0);while(m>0&&(typeof I!="number"||I>0)&&g(p)&&f(h,w));if(t>0){let c=t;typeof I=="number"&&(c=Math.min(t,I)),y.write(d(S.slice(0,c)))}}catch(h){throw(0,R.ensureFileSystemProviderError)(h)}finally{await b.close(a)}}function g(b){if(b.isCancellationRequested)throw(0,M.canceled)();return!0}function f(b,v){if(v?.limits){if(typeof v.limits.memory=="number"&&b>v.limits.memory)throw(0,R.createFileSystemProviderError)((0,n.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&b>v.limits.size)throw(0,R.createFileSystemProviderError)((0,n.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[76],_([0,1,101,2,9,4,8,16]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function g(h){return h.recursive===!0}e.isRecursiveWatchRequest=g;class f extends M.Disposable{constructor(m,I,S,D){super(),this.h=m,this.i=I,this.j=S,this.k=D,this.c=this.B(new M.MutableDisposable),this.f=void 0,this.g=0}m(){const m=new M.DisposableStore;this.c.value=m,this.b=this.l(m),this.b.setVerboseLogging(this.j),m.add(this.b.onDidChangeFile(I=>this.h(I))),m.add(this.b.onDidLogMessage(I=>this.i(I))),m.add(this.b.onDidError(I=>this.n(I)))}n(m){this.k.restartOnError?this.g<f.a&&this.f?(this.r(`restarting watcher after error: ${m}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${m}`):this.r(m)}p(m){this.g++,this.m(),this.watch(m)}async watch(m){this.f=m,await this.b?.watch(m)}async setVerboseLogging(m){this.j=m,await this.b?.setVerboseLogging(m)}r(m){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${m}`})}dispose(){return this.b=void 0,super.dispose()}}f.a=5,e.AbstractWatcherClient=f;class b extends f{constructor(m,I,S){super(m,I,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class v extends f{constructor(m,I,S){super(m,I,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=v;function y(h){return h.map(m=>({type:m.type,resource:C.URI.file(m.path)}))}e.toFileChanges=y;function d(h){const m=new a;for(const I of h)m.processEvent(I);return m.coalesce()}e.coalesceEvents=d;function w(h,m){return typeof m=="string"&&!m.startsWith(E.GLOBSTAR)&&!(0,n.isAbsolute)(m)?{base:h,pattern:m}:m}e.normalizeWatcherPattern=w;function p(h,m){const I=[];for(const S of m)I.push((0,E.parse)(w(h,S)));return I}e.parseWatcherPatterns=p;class a{constructor(){this.a=new Set,this.b=new Map}c(m){return R.isLinux?m.path:m.path.toLowerCase()}processEvent(m){const I=this.b.get(this.c(m));let S=!1;if(I){const D=I.type,t=m.type;I.path!==m.path&&(m.type===2||m.type===1)?S=!0:D===1&&t===2?(this.b.delete(this.c(m)),this.a.delete(I)):D===2&&t===1?I.type=0:D===1&&t===0||(I.type=t)}else S=!0;S&&(this.a.add(m),this.b.set(this.c(m),m))}coalesce(){const m=[],I=[];return Array.from(this.a).filter(S=>S.type!==2?(m.push(S),!1):!0).sort((S,D)=>S.path.length-D.path.length).filter(S=>I.some(D=>(0,k.isParent)(S.path,D,!R.isLinux))?!1:(I.push(S.path),!0)).concat(m)}}}),define(Z[206],_([0,1,41,7,22,32,2,80,9,4,102,23,76]),function(x,e,E,M,n,R,C,k,g,f,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends C.Disposable{constructor(a,h,m,I){super(),this.j=a,this.k=h,this.l=m,this.m=I,this.c=this.B(new M.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new M.RunOnceWorker(S=>this.u(S),d.b)),this.g=(0,y.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,y.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new n.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await v.Promises.stat(a);this.B(await this.s(a,h.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let h=a.path;try{h=await v.Promises.realpath(a.path),a.path===h&&(h=await(0,b.realcase)(a.path)??a.path),a.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${h})`)}catch{}return h}async s(a,h){if(f.isMacintosh&&(0,R.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const m=new n.CancellationTokenSource(this.i.token),I=new C.DisposableStore;try{const S=(0,g.basename)(a),D=(0,E.watch)(a);I.add((0,C.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${a}'`);const t=new Set;if(h)try{for(const i of await v.Promises.readdir(a))t.add(i)}catch(i){this.w(i)}const c=new Map;I.add((0,C.toDisposable)(()=>{for(const[,i]of c)i.dispose();c.clear()})),D.on("error",(i,r)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${i}, ${r})`),this.dispose()}),D.on("change",(i,r)=>{if(m.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${r}`);let o="";if(r&&(o=r.toString(),f.isMacintosh&&(o=(0,k.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){c.get(o)?.dispose();const u=setTimeout(async()=>{if(c.delete(o),o===S&&!await v.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const s=await this.v((0,g.join)(a,o));if(m.token.isCancellationRequested)return;let l;s?t.has(o)?l=0:(l=1,t.add(o)):(t.delete(o),l=2),this.t({path:(0,g.join)(this.j.path,o),type:l})},d.a);c.set(o,(0,C.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(o)?u=0:(u=1,t.add(o)),this.t({path:(0,g.join)(this.j.path,o),type:u})}else if(i==="rename"||o!==S){const u=setTimeout(async()=>{const s=await v.Promises.exists(a);m.token.isCancellationRequested||(s?(this.t({path:this.j.path,type:0},!0),I.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);I.clear(),I.add((0,C.toDisposable)(()=>clearTimeout(u)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await v.Promises.exists(a)&&!m.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${S.toString()})`)}return(0,C.toDisposable)(()=>{m.dispose(!0),I.dispose()})}t(a,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!h&&this.g.some(m=>m(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(m=>m(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const h=(0,y.coalesceEvents)(a);if(h.length>0){if(this.m)for(const I of h)this.z(`>> normalized ${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(f.isLinux)return v.Promises.exists(a);try{const h=(0,g.basename)(a);return(await v.Promises.readdir((0,g.dirname)(a))).some(I=>I===h)}catch(h){return this.z(h),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function w(p,a,h,m,I=512){const S=await v.Promises.open(p,"r"),D=Buffer.allocUnsafe(I),t=new n.CancellationTokenSource(m);let c,i=!1;const r={path:p,excludes:[],recursive:!1},o=new d(r,u=>{(async()=>{for(const{type:s}of u)if(s===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:l}=await v.Promises.read(S,D,0,I,null);if(!l||t.token.isCancellationRequested)break;a(D.slice(0,l))}}catch(l){c=new Error(l),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,h(),new Promise((u,s)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await v.Promises.close(S)}catch(l){c=new Error(l)}c?s(c):u()})})}e.watchFileContents=w}),define(Z[207],_([0,1,3,101,2,4,206]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(f){const b=this.i(f),v=b.filter(d=>{const w=this.c.get(d.path);return w?!(0,M.patternsEquals)(w.request.excludes,d.excludes)||!(0,M.patternsEquals)(w.request.includes,d.includes):!0}),y=Array.from(this.c.values()).filter(({request:d})=>!b.find(w=>w.path===d.path&&(0,M.patternsEquals)(w.excludes,d.excludes)&&(0,M.patternsEquals)(w.includes,d.includes))).map(({request:d})=>d.path);v.length&&this.j(`Request to start watching: ${v.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),y.length&&this.j(`Request to stop watching: ${y.join(",")}`);for(const d of y)this.h(d);for(const d of v)this.g(d)}g(f){const b=new C.NodeJSFileWatcherLibrary(f,y=>this.a.fire(y),y=>this.b.fire(y),this.f),v={request:f,instance:b};this.c.set(f.path,v)}async stop(){for(const[f]of this.c)this.h(f);this.c.clear()}h(f){const b=this.c.get(f);b&&(this.c.delete(f),b.instance.dispose())}i(f){const b=new Map;for(const v of f){const y=R.isLinux?v.path:v.path.toLowerCase();b.set(y,v)}return Array.from(b.values())}async setVerboseLogging(f){this.f=f;for(const[,b]of this.c)b.instance.setVerboseLogging(f)}j(f){this.f&&this.b.fire({type:"trace",message:this.k(f)})}k(f,b){return b?`[File Watcher (node.js)] ${f} (path: ${b.request.path})`:`[File Watcher (node.js)] ${f}`}}e.NodeJSWatcher=k}),define(Z[208],_([0,1,76,207]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class n extends E.AbstractNonRecursiveWatcherClient{constructor(C,k,g){super(C,k,g),this.m()}l(){return new M.NodeJSWatcher}}e.NodeJSWatcherClient=n}),define(Z[209],_([0,1,14,47,155,76]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends R.AbstractUniversalWatcherClient{constructor(g,f,b){super(g,f,b),this.m()}l(g){const f=g.add(new n.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(f.onDidProcessExit(({code:b,signal:v})=>this.n(`terminated by itself with code ${b}, signal: ${v}`))),M.ProxyChannel.toService((0,M.getNextTickChannel)(f.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(Z[89],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...n){this.a=new Map;for(const[R,C]of n)this.set(R,C)}set(n,R){const C=this.a.get(n);return this.a.set(n,R),C}has(n){return this.a.has(n)}get(n){return this.a.get(n)}}e.ServiceCollection=E}),define(Z[210],_([0,1,7,13,2,74,201,6,89,98]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class v extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class y{constructor(a=new g.ServiceCollection,h=!1,m,I=b){this.f=a,this.g=h,this.h=m,this.i=I,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=I?m?._globalGraph??new C.Graph(S=>S):void 0}createChild(a){return new y(a,this.g,this,this.i)}invokeFunction(a,...h){const m=w.traceInvocation(this.i,a);let I=!1;try{return a({get:D=>{if(I)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(D,m);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...h)}finally{I=!0,m.stop()}}createInstance(a,...h){let m,I;return a instanceof R.SyncDescriptor?(m=w.traceCreation(this.i,a.ctor),I=this.j(a.ctor,a.staticArguments.concat(h),m)):(m=w.traceCreation(this.i,a),I=this.j(a,h,m)),m.stop(),I}j(a,h=[],m){const I=k._util.getServiceDependencies(a).sort((t,c)=>t.index-c.index),S=[];for(const t of I){const c=this.m(t.id,m);c||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(c)}const D=I.length>0?I[0].index:h.length;if(h.length!==D){console.trace(`[createInstance] First service dependency of ${a.name} at position ${D+1} conflicts with ${h.length} static arguments`);const t=D-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,D)}return Reflect.construct(a,h.concat(S))}k(a,h){if(this.f.get(a)instanceof R.SyncDescriptor)this.f.set(a,h);else if(this.h)this.h.k(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const h=this.f.get(a);return!h&&this.h?this.h.l(a):h}m(a,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const m=this.l(a);return m instanceof R.SyncDescriptor?this.q(a,m,h.branch(a,!0)):(h.branch(a,!1),m)}q(a,h,m){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,h,m)}finally{this.o.delete(a)}}r(a,h,m){const I=new C.Graph(t=>t.id.toString());let S=0;const D=[{id:a,desc:h,_trace:m}];for(;D.length;){const t=D.pop();if(I.lookupOrInsertNode(t),S++>1e3)throw new v(I);for(const c of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(c.id);if(i||this.u(`[createInstance] ${a} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),i instanceof R.SyncDescriptor){const r={id:c.id,desc:i,_trace:t._trace.branch(c.id,!0)};I.insertEdge(t,r),D.push(r)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new v(I);break}for(const{data:c}of t){if(this.l(c.id)instanceof R.SyncDescriptor){const r=this.s(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.k(c.id,r)}I.removeNode(c)}}return this.l(a)}s(a,h,m=[],I,S){if(this.f.get(a)instanceof R.SyncDescriptor)return this.t(a,h,m,I,S);if(this.h)return this.h.s(a,h,m,I,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(a,h,m=[],I,S){if(I){const D=new y(void 0,this.g,this,this.i);D.c=String(a);const t=new Map,c=new E.IdleValue(()=>{const i=D.j(h,m,S);for(const[r,o]of t){const u=i[r];if(typeof u=="function")for(const s of o)u.apply(i,s)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,r){if(!c.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let s=t.get(r);return s||(s=new f.LinkedList,t.set(r,s)),(P,A,O)=>{const N=s.push([P,A,O]);return(0,n.toDisposable)(N)}}if(r in i)return i[r];const o=c.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),i[r]=u),u},set(i,r,o){return c.value[r]=o,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,m,S)}u(a,h){if(h&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=y;var d;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(d||(d={}));class w{static traceInvocation(a,h){return a?new w(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(a,h){return a?new w(1,h.name):w.c}constructor(a,h){this.type=a,this.name=h,this.g=Date.now(),this.h=[]}branch(a,h){const m=new w(3,a.toString());return this.h.push([a,h,m]),m}stop(){const a=Date.now()-this.g;w.f+=a;let h=!1;function m(S,D){const t=[],c=new Array(S+1).join("	");for(const[i,r,o]of D.h)if(r&&o){h=!0,t.push(`${c}CREATES -> ${i}`);const u=m(S+1,o);u&&t.push(u)}else t.push(`${c}uses -> ${i}`);return t.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(a>2||h)&&w.all.add(I.join(`
`))}}w.all=new Set,w.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}},w.f=0,e.Trace=w}),define(Z[5],_([0,1,44,3,2,35,4,10,8,6]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,f.createDecorator)("logService"),e.ILoggerService=(0,f.createDecorator)("loggerService");function b(){return new Date().toISOString()}function v(s){return(0,k.isNumber)(s)}e.isLogLevel=v;var y;(function(s){s[s.Off=0]="Off",s[s.Trace=1]="Trace",s[s.Debug=2]="Debug",s[s.Info=3]="Info",s[s.Warning=4]="Warning",s[s.Error=5]="Error"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;function d(s,l,P){switch(l){case y.Trace:s.trace(P);break;case y.Debug:s.debug(P);break;case y.Info:s.info(P);break;case y.Warning:s.warn(P);break;case y.Error:s.error(P);break;case y.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=d;function w(s){let l="";for(let P=0;P<s.length;P++){let A=s[P];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}l+=(P>0?" ":"")+A}return l}e.format=w;class p extends n.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new M.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==y.Off&&this.b<=l}}e.AbstractLogger=p;class a extends p{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...P){this.f(y.Trace)&&this.g(y.Trace,w([l,...P]))}debug(l,...P){this.f(y.Debug)&&this.g(y.Debug,w([l,...P]))}info(l,...P){this.f(y.Info)&&this.g(y.Info,w([l,...P]))}warn(l,...P){this.f(y.Warning)&&this.g(y.Warning,w([l,...P]))}error(l,...P){if(this.f(y.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(y.Error,w(A))}else this.g(y.Error,w([l,...P]))}flush(){}}e.AbstractMessageLogger=a;class h extends p{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!C.isWindows}trace(l,...P){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...P):console.log(`[main ${b()}]`,l,...P))}debug(l,...P){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...P):console.log(`[main ${b()}]`,l,...P))}info(l,...P){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...P):console.log(`[main ${b()}]`,l,...P))}warn(l,...P){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,l,...P):console.warn(`[main ${b()}]`,l,...P))}error(l,...P){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,l,...P):console.error(`[main ${b()}]`,l,...P))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class m extends p{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...P){this.f(y.Trace)&&console.log("%cTRACE","color: #888",l,...P)}debug(l,...P){this.f(y.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...P)}info(l,...P){this.f(y.Info)&&console.log("%c INFO","color: #33f",l,...P)}warn(l,...P){this.f(y.Warning)&&console.log("%c WARN","color: #993",l,...P)}error(l,...P){this.f(y.Error)&&console.log("%c  ERR","color: #f33",l,...P)}dispose(){}flush(){}}e.ConsoleLogger=m;class I extends p{constructor(l,P=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(P)}trace(l,...P){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(l),...P])}debug(l,...P){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(l),...P])}info(l,...P){this.f(y.Info)&&this.g.log(y.Info,[this.h(l),...P])}warn(l,...P){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(l),...P])}error(l,...P){this.f(y.Error)&&this.g.log(y.Error,[this.h(l),...P])}h(l){return typeof l=="string"?l:(0,E.toErrorMessage)(l,this.f(y.Trace))}dispose(){}flush(){}}e.AdapterLogger=I;class S extends p{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const P of this.g)P.setLevel(l);super.setLevel(l)}trace(l,...P){for(const A of this.g)A.trace(l,...P)}debug(l,...P){for(const A of this.g)A.debug(l,...P)}info(l,...P){for(const A of this.g)A.info(l,...P)}warn(l,...P){for(const A of this.g)A.warn(l,...P)}error(l,...P){for(const A of this.g)A.error(l,...P)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=S;class D extends n.Disposable{constructor(l,P){if(super(),this.j=l,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new M.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new M.Emitter),this.onDidChangeVisibility=this.h.event,P)for(const A of P)this.c.set(A.resource,A)}getLogger(l){return this.b.get(l)}createLogger(l,P){let A=this.b.get(l);const O=P?.logLevel==="always"?y.Trace:P?.logLevel;return A||(A=this.k(l,O??this.getLogLevel(l)??this.j,P),this.b.set(l,A)),this.registerLogger({resource:l,id:P?.id??l.toString(),logLevel:O,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId}),A}setLogLevel(l,P){if(g.URI.isUri(l)){const A=l,O=P,N=this.c.get(A);N&&O!==N.logLevel&&(N.logLevel=O===this.j?void 0:O,this.b.get(A)?.setLevel(O),this.c.set(N.resource,N),this.g.fire([A,O]))}else{this.j=l;for(const[A,O]of this.b.entries())this.c.get(A)?.logLevel===void 0&&O.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,P){const A=this.c.get(l);A&&P!==!A.hidden&&(A.hidden=!P,this.c.set(A.resource,A),this.h.fire([l,P]))}getLogLevel(l){let P;return l&&(P=this.c.get(l)?.logLevel),P??this.j}registerLogger(l){const P=this.c.get(l.resource);P?P.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const P=this.c.get(l);if(P){this.c.delete(l);const A=this.b.get(l);A&&(this.b.delete(l),A.dispose()),this.f.fire({added:[],removed:[P]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=D;class t{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(l){}getLevel(){return y.Info}trace(l,...P){}debug(l,...P){}info(l,...P){}warn(l,...P){}error(l,...P){}critical(l,...P){}dispose(){}flush(){}}e.NullLogger=t;class c extends t{}e.NullLogService=c;class i extends D{constructor(){super(y.Info)}k(l,P,A){return new t}}e.NullLoggerService=i;function r(s){if(s.verbose)return y.Trace;if(typeof s.logLevel=="string"){const l=u(s.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=r;function o(s){switch(s){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.LogLevelToString=o;function u(s){switch(s){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.parseLogLevel=u});var Q=this&&this.__param||function(x,e){return function(E,M){e(E,M,x)}};define(Z[211],_([0,1,75,3,2,5,4,7]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let g=class ut extends n.Disposable{constructor(b){super(),this.g=b,this.c=this.B(new M.Emitter),this.onDidChangePassword=this.c.event}async getPassword(b,v){this.g.trace("Getting password from keytar:",b,v);let y;try{y=await this.h()}catch{return null}const d=await(0,k.retry)(()=>y.getPassword(b,v),50,3);if(!d)return this.g.trace("Did not get a password from keytar for account:",v),d;let w,p;try{const a=JSON.parse(d);w=a.content,p=a.hasNextChunk}catch{}if(!w||!p)return this.g.trace("Got password from keytar for account:",v),d;try{let a=1;for(;p;){const h=await(0,k.retry)(()=>y.getPassword(b,`${v}-${a}`),50,3),m=JSON.parse(h);w+=m.content,p=m.hasNextChunk,a++}return this.g.trace(`Got ${a}-chunked password from keytar for account:`,v),w}catch(a){return this.g.error(a),d}}async setPassword(b,v,y){this.g.trace("Setting password using keytar:",b,v);let d;try{d=await this.h()}catch(w){throw this.i?.(w),w}if(C.isWindows&&y.length>ut.a){let w=0,p=0,a=!0;for(;a;){const h=y.substring(w,w+ut.b);w+=ut.b,a=y.length-w>0;const m={content:h,hasNextChunk:a};await(0,k.retry)(()=>d.setPassword(b,p?`${v}-${p}`:v,JSON.stringify(m)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,v)}else await(0,k.retry)(()=>d.setPassword(b,v,y),50,3),this.g.trace("Got password from keytar for account:",v);this.c.fire({service:b,account:v})}async deletePassword(b,v){this.g.trace("Deleting password using keytar:",b,v);let y;try{y=await this.h()}catch(h){throw this.i?.(h),h}const d=await y.getPassword(b,v);if(!d)return this.g.trace("Did not get a password to delete from keytar for account:",v),!1;let w,p;try{const h=JSON.parse(d);w=h.content,p=h.hasNextChunk}catch{}let a=0;if(w&&p)try{for(a++;p;){const h=`${v}-${a}`,m=await y.getPassword(b,h);await y.deletePassword(b,h),p=JSON.parse(m).hasNextChunk,a++}}catch(h){this.g.error(h)}return await y.deletePassword(b,v)?(this.c.fire({service:b,account:v}),this.g.trace(`Deleted${a?` ${a}-chunked`:""} password from keytar for account:`,v),!0):(this.g.trace(`Keytar failed to delete${a?` ${a}-chunked`:""} password for account:`,v),!1)}async findPassword(b){let v;try{v=await this.h()}catch{return null}return await v.findPassword(b)}async findCredentials(b){let v;try{v=await this.h()}catch{return[]}return await v.findCredentials(b)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};g.a=2500,g.b=g.a-100,g=ve([Q(0,R.ILogService)],g),e.BaseCredentialsMainService=g}),define(Z[212],_([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let M=class{constructor(R,C){this.a=R,this.b=C}c(){return new Promise((R,C)=>x(["vscode-encrypt"],R,C))}async encrypt(R){let C;try{C=await this.c()}catch{return R}try{return C.encrypt(this.a,R)}catch(k){return this.b.error(k),R}}async decrypt(R){let C;try{C=await this.c()}catch{return R}try{return C.decrypt(this.a,R)}catch(k){return this.b.error(k),R}}};M=ve([Q(1,E.ILogService)],M),e.EncryptionMainService=M}),define(Z[213],_([0,1,25,7,13,3,2,9,76,5]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class b extends C.Disposable{constructor(y,d){super(),this.a=y,this.b=d,this.c=this.B(new R.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new R.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.ThrottledDelayer(0)),this.s=[],this.t=this.B(new M.ThrottledDelayer(0))}watch(y,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(y,d):this.u(y,d)}l(y,d){const w={path:this.C(y),excludes:d.excludes,includes:d.includes,recursive:d.recursive},p=(0,E.insert)(this.j,w);return this.m(),(0,C.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(y=>(0,n.onUnexpectedError)(y))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,g.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const d of this.j)(0,g.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const d of this.j)(0,g.isRecursiveWatchRequest)(d)&&y.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(y,d){const w={path:this.C(y),excludes:d.excludes,includes:d.includes,recursive:!1},p=(0,E.insert)(this.s,w);return this.v(),(0,C.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(y=>(0,n.onUnexpectedError)(y))}w(){return this.r||(this.r=this.B(this.y(y=>this.c.fire((0,g.toFileChanges)(y)),y=>this.z(y),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.r.watch(this.s)}z(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}C(y){return(0,k.normalize)(y.fsPath)}}e.AbstractDiskFileSystemProvider=b}),define(Z[214],_([0,1,25,7,17,22,3,60,70,2,61,14,64,18,59,168,16,111,5,13]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=class extends f.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new M.ResourceQueue)}registerProvider(t,c){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const i=new f.DisposableStore;return this.h.set(t,c),this.c.fire({added:!0,scheme:t,provider:c}),i.add(c.onDidChangeFile(r=>this.R.fire(new a.FileChangesEvent(r,!this.O(c))))),typeof c.onDidWatchError=="function"&&i.add(c.onDidWatchError(r=>this.S.fire(new Error(r)))),i.add(c.onDidChangeCapabilities(()=>this.g.fire({provider:c,scheme:t}))),(0,f.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:c}),this.h.delete(t),(0,f.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const c=[];this.f.fire({scheme:t,join(i){c.push(i)}}),!this.h.has(t)&&await M.Promises.settled(c)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,c){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&c)}listCapabilities(){return g.Iterable.map(this.h,([t,c])=>({scheme:t,capabilities:c.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new a.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const c=this.h.get(t.scheme);if(!c){const i=new I.ErrorNoTelemetry;throw i.message=(0,p.localize)(1,null,t.toString()),i}return c}async k(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c)||(0,a.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const c=await this.j(t);if((0,a.hasOpenReadWriteCloseCapability)(c)||(0,a.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,c){try{return await this.n(t,c)}catch(i){throw(0,a.toFileSystemProviderErrorCode)(i)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,a.ensureFileSystemProviderError)(i)}}async n(t,c){const i=await this.j(t),r=this.O(i),o=c?.resolveTo,u=c?.resolveSingleChildDescendants,s=c?.resolveMetadata,l=await i.stat(t);let P;return this.p(i,t,l,void 0,!!s,(A,O)=>(P||(P=b.TernarySearchTree.forUris(()=>!r),P.set(t,!0),o&&P.fill(!0,o)),P.get(A.resource)||P.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&u?O===1:!1))}async p(t,c,i,r,o,u){const{providerExtUri:s}=this.N(t),l={resource:c,name:s.basename(c),isFile:(i.type&a.FileType.File)!==0,isDirectory:(i.type&a.FileType.Directory)!==0,isSymbolicLink:(i.type&a.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&a.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,a.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&u(l,r)){try{const P=await t.readdir(c),A=await M.Promises.settled(P.map(async([O,N])=>{try{const z=s.joinPath(c,O),H=o?await t.stat(z):{type:N};return await this.p(t,z,H,P.length,o,u)}catch(z){return this.b.trace(z),null}}));l.children=(0,E.coalesce)(A)}catch(P){this.b.trace(P),l.children=[]}return l}return l}async resolveAll(t){return M.Promises.settled(t.map(async c=>{try{return{stat:await this.n(c.resource,c.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const c=await this.j(t),i=await c.stat(t);return this.p(c,t,i,void 0,!0,()=>!1)}async exists(t){const c=await this.j(t);try{return!!await c.stat(t)}catch{return!1}}async canCreateFile(t,c){try{await this.r(t,c)}catch(i){return i}return!0}async r(t,c){if(!c?.overwrite&&await this.exists(t))throw new a.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,c)}async createFile(t,c=n.VSBuffer.fromString(""),i){await this.r(t,i);const r=await this.writeFile(t,c);return this.m.fire(new a.FileOperationEvent(t,0,r)),r}async writeFile(t,c,i){const r=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(r);try{await this.s(r,t,i)||await this.P(r,o.dirname(t));let s;if((0,a.hasReadWriteCapability)(r)&&!(c instanceof n.VSBuffer))if((0,w.isReadableStream)(c)){const l=await(0,w.peekStream)(c,3);l.ended?s=n.VSBuffer.concat(l.buffer):s=l}else s=(0,w.peekReadable)(c,l=>n.VSBuffer.concat(l),3);else s=c;!(0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)&&s instanceof n.VSBuffer?await this.cb(r,t,i,s):await this.Y(r,t,i,s instanceof n.VSBuffer?(0,n.bufferToReadable)(s):s),this.m.fire(new a.FileOperationEvent(t,4))}catch(u){throw new a.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,a.ensureFileSystemProviderError)(u).toString()),(0,a.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,c,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(c)));let o;try{o=await t.stat(c)}catch{return}if((o.type&a.FileType.Directory)!==0)throw new a.FileOperationError((0,p.localize)(6,null,this.nb(c)),0,i);if(this.mb(c,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==a.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,a.etag)({mtime:i.mtime,size:o.size}))throw new a.FileOperationError((0,p.localize)(7,null),3,i);return o}async readFile(t,c,i){const r=await this.k(t);return c?.atomic?this.t(r,t,c,i):this.u(r,t,c,i)}async t(t,c,i,r){return new Promise((o,u)=>{this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{try{const s=await this.u(t,c,i,r);o(s)}catch(s){u(s)}})})}async u(t,c,i,r){const o=await this.v(t,c,{...i,preferUnbuffered:!0},r);return{...o,value:await(0,n.streamToBuffer)(o.value)}}async readFileStream(t,c,i){const r=await this.k(t);return this.v(r,t,c,i)}async v(t,c,i,r){const o=new R.CancellationTokenSource(r),u=this.F(c,i).then(l=>l,l=>{throw o.cancel(),l});let s;try{return typeof i?.etag=="string"&&i.etag!==a.ETAG_DISABLED&&await u,i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)||!((0,a.hasOpenReadWriteCloseCapability)(t)||(0,a.hasFileReadStreamCapability)(t))||(0,a.hasReadWriteCapability)(t)&&i?.preferUnbuffered?s=this.D(t,c,i):(0,a.hasFileReadStreamCapability)(t)?s=this.z(t,c,o.token,i):s=this.C(t,c,o.token,i),{...await u,value:s}}catch(l){throw s&&await(0,w.consumeStream)(s),this.w(l,c,i)}}w(t,c,i){const r=(0,p.localize)(8,null,this.nb(c),(0,a.ensureFileSystemProviderError)(t).toString());return t instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(r,t.stat,i):t instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(r,t.fileOperationResult,t.size,t.options):new a.FileOperationError(r,(0,a.toFileOperationResult)(t),i)}z(t,c,i,r=Object.create(null)){const o=t.readFileStream(c,r,i);return(0,w.transform)(o,{data:u=>u instanceof n.VSBuffer?u:n.VSBuffer.wrap(u),error:u=>this.w(u,c,r)},u=>n.VSBuffer.concat(u))}C(t,c,i,r=Object.create(null)){const o=(0,n.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,c,o,u=>u,{...r,bufferSize:this.a,errorTransformer:u=>this.w(u,c,r)},i),o}D(t,c,i){const r=(0,w.newWriteableStream)(o=>n.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,a.hasFileAtomicReadCapability)(t)?o=await t.readFile(c,{atomic:!0}):o=await t.readFile(c),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(c,o.byteLength,i),r.end(n.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async F(t,c){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new a.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,c);if(typeof c?.etag=="string"&&c.etag!==a.ETAG_DISABLED&&c.etag===i.etag)throw new a.NotModifiedSinceFileOperationError((0,p.localize)(10,null),i,c);return this.G(t,i.size,c),i}G(t,c,i){if(i?.limits){let r;if(typeof i.limits.memory=="number"&&c>i.limits.memory&&(r=9),typeof i.limits.size=="number"&&c>i.limits.size&&(r=7),typeof r=="number")throw new a.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),r,c,i)}}async canMove(t,c,i){return this.H(t,c,"move",i)}async canCopy(t,c,i){return this.H(t,c,"copy",i)}async H(t,c,i,r){if(t.toString()!==c.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),u=this.lb(await this.l(c),c);await this.M(o,t,u,c,i,r)}catch(o){return o}return!0}async move(t,c,i){const r=this.lb(await this.l(t),t),o=this.lb(await this.l(c),c),u=await this.I(r,t,o,c,"move",!!i),s=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,u==="move"?2:3,s)),s}async copy(t,c,i){const r=await this.k(t),o=this.lb(await this.l(c),c),u=await this.I(r,t,o,c,"copy",!!i),s=await this.resolve(c,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,u==="copy"?3:2,s)),s}async I(t,c,i,r,o,u){if(c.toString()===r.toString())return o;const{exists:s,isSameResourceWithDifferentPathCase:l}=await this.M(t,c,i,r,o,u);if(s&&!l&&u&&await this.del(r,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(r)),o==="copy"){if(t===i&&(0,a.hasFileFolderCopyCapability)(t))await t.copy(c,r,{overwrite:u});else{const P=await this.resolve(c);P.isDirectory?await this.L(t,P,i,r):await this.J(t,c,i,r)}return o}else return t===i?(await t.rename(c,r,{overwrite:u}),o):(await this.I(t,c,i,r,"copy",u),await this.del(c,{recursive:!0}),"copy")}async J(t,c,i,r){if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.eb(t,c,i,r);if((0,a.hasOpenReadWriteCloseCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.kb(t,c,i,r);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasOpenReadWriteCloseCapability)(i))return this.ib(t,c,i,r);if((0,a.hasReadWriteCapability)(t)&&(0,a.hasReadWriteCapability)(i))return this.gb(t,c,i,r)}async L(t,c,i,r){await i.mkdir(r),Array.isArray(c.children)&&await M.Promises.settled(c.children.map(async o=>{const u=this.N(i).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,u):this.J(t,o.resource,i,u)}))}async M(t,c,i,r,o,u){let s=!1;if(t===i){const{providerExtUri:P,isPathCaseSensitive:A}=this.N(t);if(A||(s=P.isEqual(c,r)),s&&o==="copy")throw new Error((0,p.localize)(12,null,this.nb(c),this.nb(r)));if(!s&&P.isEqualOrParent(r,c))throw new Error((0,p.localize)(13,null,this.nb(c),this.nb(r)))}const l=await this.exists(r);if(l&&!s){if(!u)throw new a.FileOperationError((0,p.localize)(14,null,this.nb(c),this.nb(r)),4);if(t===i){const{providerExtUri:P}=this.N(t);if(P.isEqualOrParent(c,r))throw new Error((0,p.localize)(15,null,this.nb(c),this.nb(r)))}}return{exists:l,isSameResourceWithDifferentPathCase:s}}N(t){const c=this.O(t);return{providerExtUri:c?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:c}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const c=this.lb(await this.j(t),t);await this.P(c,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(t,0,i)),i}async P(t,c){const i=[],{providerExtUri:r}=this.N(t);for(;!r.isEqual(c,r.dirname(c));)try{if(((await t.stat(c)).type&a.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(c)));break}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(r.basename(c)),c=r.dirname(c)}for(let o=i.length-1;o>=0;o--){c=r.joinPath(c,i[o]);try{await t.mkdir(c)}catch(u){if((0,a.toFileSystemProviderErrorCode)(u)!==a.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,c){try{await this.Q(t,c)}catch(i){return i}return!0}async Q(t,c){const i=this.lb(await this.j(t),t);if(!!c?.useTrash&&!(i.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new a.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!c?.recursive){const s=await this.resolve(t);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return i}async del(t,c){const i=await this.Q(t,c),r=!!c?.useTrash,o=!!c?.recursive;await i.delete(t,{recursive:o,useTrash:r}),this.m.fire(new a.FileOperationEvent(t,1))}async cloneFile(t,c){const i=await this.j(t),r=this.lb(await this.l(c),c);if(i===r&&this.N(i).providerExtUri.isEqual(t,c))return;if(i===r&&(0,a.hasFileCloneCapability)(i))return i.cloneFile(t,c);await this.P(r,this.N(r).providerExtUri.dirname(c));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===r&&(0,a.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,c,{overwrite:!0})):o.queue(()=>this.J(i,t,r,c))}watch(t,c={recursive:!1,excludes:[]}){const i=new f.DisposableStore;let r=!1,o=()=>{r=!0};return i.add((0,f.toDisposable)(()=>o())),(async()=>{try{const u=await this.W(t,c);r?(0,f.dispose)(u):o=()=>(0,f.dispose)(u)}catch(u){this.b.error(u)}})(),i}async W(t,c){const i=await this.j(t),r=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),c]);let o=this.U.get(r);return o||(o={count:0,disposable:i.watch(t,c)},this.U.set(r,o)),o.count+=1,(0,f.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,f.dispose)(o.disposable),this.U.delete(r)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,f.dispose)(t.disposable);this.U.clear()}async Y(t,c,i,r){return this.X.queueFor(c,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(c,{create:!0,unlock:i?.unlock??!1});try{(0,w.isReadableStream)(r)||(0,w.isReadableBufferedStream)(r)?await this.Z(t,o,r):await this.ab(t,o,r)}catch(u){throw(0,a.ensureFileSystemProviderError)(u)}finally{await t.close(o)}})}async Z(t,c,i){let r=0,o;if((0,w.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=n.VSBuffer.concat(i.buffer);await this.bb(t,c,u,u.byteLength,r,0),r+=u.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((u,s)=>{(0,w.listenStream)(o,{onData:async l=>{o.pause();try{await this.bb(t,c,l,l.byteLength,r,0)}catch(P){return s(P)}r+=l.byteLength,setTimeout(()=>o.resume())},onError:l=>s(l),onEnd:()=>u()})})}async ab(t,c,i){let r=0,o;for(;(o=i.read())!==null;)await this.bb(t,c,o,o.byteLength,r,0),r+=o.byteLength}async bb(t,c,i,r,o,u){let s=0;for(;s<r;)s+=await t.write(c,o+s,i.buffer,u+s,r-s)}async cb(t,c,i,r){return this.X.queueFor(c,this.N(t).providerExtUri).queue(()=>this.db(t,c,i,r))}async db(t,c,i,r){let o;r instanceof n.VSBuffer?o=r:(0,w.isReadableStream)(r)?o=await(0,n.streamToBuffer)(r):(0,w.isReadableBufferedStream)(r)?o=await(0,n.bufferedStreamToBuffer)(r):o=(0,n.readableToBuffer)(r),await t.writeFile(c,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.fb(t,c,i,r))}async fb(t,c,i,r){let o,u;try{o=await t.open(c,{create:!1}),u=await i.open(r,{create:!0,unlock:!1});const s=n.VSBuffer.alloc(this.a);let l=0,P=0,A=0;do A=await t.read(o,l,s.buffer,P,s.byteLength-P),await this.bb(i,u,s,A,l,P),l+=A,P+=A,P===s.byteLength&&(P=0);while(A>0)}catch(s){throw(0,a.ensureFileSystemProviderError)(s)}finally{await M.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async gb(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.hb(t,c,i,r))}async hb(t,c,i,r){return i.writeFile(r,await t.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async ib(t,c,i,r){return this.X.queueFor(r,this.N(i).providerExtUri).queue(()=>this.jb(t,c,i,r))}async jb(t,c,i,r){const o=await i.open(r,{create:!0,unlock:!1});try{const u=await t.readFile(c);await this.bb(i,o,n.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,a.ensureFileSystemProviderError)(u)}finally{await i.close(o)}}async kb(t,c,i,r){const o=await(0,n.streamToBuffer)(this.C(t,c,R.CancellationToken.None));await this.cb(i,r,void 0,o)}lb(t,c){if(t.capabilities&2048)throw new a.FileOperationError((0,p.localize)(20,null,this.nb(c)),6);return t}mb(t,c){if((c.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===v.Schemas.file?t.fsPath:t.toString(!0)}};S=ve([Q(0,m.ILogService)],S),e.FileService=S}),define(Z[90],_([0,1,41,290,7,35,17,3,32,2,9,4,18,59,23,172,16,111,213,44,209,208]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,M.gracefulify)(E)}catch(c){console.error(`Error enabling graceful-fs: ${(0,I.toErrorMessage)(c)}`)}})();class t extends m.AbstractDiskFileSystemProvider{constructor(i,r){super(i,r),this.onDidChangeCapabilities=k.Event.None,this.H=new R.ResourceMap(o=>y.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,v.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:r,symbolicLink:o}=await w.SymlinkSupport.stat(this.C(i));return{type:this.G(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.Y(r)}}async readdir(i){try{const r=await w.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async u=>{try{let s;u.isSymbolicLink()?s=(await this.stat((0,y.joinPath)(i,u.name))).type:s=this.G(u),o.push([u.name,s])}catch(s){this.a.trace(s)}})),o}catch(r){throw this.Y(r)}}G(i,r){let o;return r?.dangling?o=a.FileType.Unknown:i.isFile()?o=a.FileType.File:i.isDirectory()?o=a.FileType.Directory:o=a.FileType.Unknown,r&&(o|=a.FileType.SymbolicLink),o}async I(i){const r=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const u=new n.Barrier;return this.H.set(i,u),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,f.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.H.get(i)===u&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),u.open()})}async readFile(i,r){let o;try{r?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const u=this.C(i);return await w.Promises.readFile(u)}catch(u){throw this.Y(u)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,r,o){const u=(0,d.newWriteableStream)(s=>C.VSBuffer.concat(s.map(l=>C.VSBuffer.wrap(l))).buffer);return(0,h.readFileIntoStream)(this,i,u,s=>s.buffer,{...r,bufferSize:256*1024},o),u}async writeFile(i,r,o){let u;try{const s=this.C(i);if(!o.create||!o.overwrite){if(await w.Promises.exists(s)){if(!o.overwrite)throw(0,a.createFileSystemProviderError)((0,p.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,a.createFileSystemProviderError)((0,p.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,r,0,r.byteLength)}catch(s){throw await this.Z(i,s)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.O=i}async open(i,r){const o=this.C(i);let u;(0,a.isFileOpenForWriteOptions)(r)&&(u=await this.I(i));let s;try{if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:P}=await w.SymlinkSupport.stat(o);P.mode&128||await w.Promises.chmod(o,P.mode|128)}catch(P){this.a.trace(P)}let l;if((0,a.isFileOpenForWriteOptions)(r)){if(v.isWindows)try{await w.Promises.truncate(o,0),l="r+"}catch(P){P.code!=="ENOENT"&&this.a.trace(P)}l||(l="w")}else l="r";s=await w.Promises.open(o,l)}catch(l){throw u?.dispose(),(0,a.isFileOpenForWriteOptions)(r)?await this.Z(i,l):this.Y(l)}if(this.L.set(s,0),(0,a.isFileOpenForWriteOptions)(r)&&this.N.set(s,i),u){const l=this.M.get(s);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${s} (${o})`),this.M.set(s,u),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${s} (${o})`),l.dispose())}return s}async close(i){const r=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await w.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await w.Promises.close(i)}catch(o){throw this.Y(o)}finally{r&&(this.M.get(i)===r&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),r.dispose())}}async read(i,r,o,u,s){const l=this.P(i,r);let P=null;try{P=(await w.Promises.read(i,o,u,s,l)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,l,P)}return P}P(i,r){return r===this.L.get(i)?null:r}Q(i,r,o){const u=this.L.get(i);typeof u=="number"&&(typeof r=="number"||(typeof o=="number"?this.L.set(i,u+o):this.L.delete(i)))}async write(i,r,o,u,s){return(0,n.retry)(()=>this.R(i,r,o,u,s),100,3)}async R(i,r,o,u,s){const l=this.P(i,r);let P=null;try{P=(await w.Promises.write(i,o,u,s,l)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,l,P)}return P}async mkdir(i){try{await w.Promises.mkdir(this.C(i))}catch(r){throw this.Y(r)}}async delete(i,r){try{const o=this.C(i);r.recursive?await w.Promises.rm(o,w.RimRafMode.MOVE):await w.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,r,o){const u=this.C(i),s=this.C(r);if(u!==s)try{await this.S(i,r,"move",o.overwrite),await w.Promises.move(u,s)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(2,null,(0,b.basename)(u),(0,b.basename)((0,b.dirname)(s)),l.toString()))),this.Y(l)}}async copy(i,r,o){const u=this.C(i),s=this.C(r);if(u!==s)try{await this.S(i,r,"copy",o.overwrite),await w.Promises.copy(u,s,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,p.localize)(3,null,(0,b.basename)(u),(0,b.basename)((0,b.dirname)(s)),l.toString()))),this.Y(l)}}async S(i,r,o,u){const s=this.C(i),l=this.C(r);let P=!1;if(!!(this.capabilities&1024)||(P=(0,g.isEqual)(s,l,!0)),P&&o==="copy")throw(0,a.createFileSystemProviderError)((0,p.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!P&&await w.Promises.exists(l)){if(!u)throw(0,a.createFileSystemProviderError)((0,p.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(i,r){return this.U(i,r,!1)}async U(i,r,o){const u=this.C(i),s=this.C(r),l=!!(this.capabilities&1024);if((0,g.isEqual)(u,s,!l))return;const P=new f.DisposableStore;try{const[A,O]=await Promise.all([this.I(i),this.I(r)]);P.add(A),P.add(O),o&&await w.Promises.mkdir((0,b.dirname)(s),{recursive:!0}),await w.Promises.copyFile(u,s)}catch(A){if(A.code==="ENOENT"&&!o)return this.U(i,r,!0);throw this.Y(A)}finally{P.dispose()}}p(i,r,o){return new S.UniversalWatcherClient(u=>i(u),u=>r(u),o)}y(i,r,o){return new D.NodeJSWatcherClient(u=>i(u),u=>r(u),o)}Y(i){if(i instanceof a.FileSystemProviderError)return i;let r;switch(i.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,r)}async Z(i,r){let o=this.Y(r);if(i&&o.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await w.SymlinkSupport.stat(this.C(i));u.mode&128||(o=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Z[215],_([0,1,3,90,2,17,59,22]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class g extends n.Disposable{constructor(v,y){super(),this.a=v,this.b=y,this.w=new Map,this.y=new Map}call(v,y,d){const w=this.c(v);switch(y){case"stat":return this.g(w,d[0]);case"readdir":return this.h(w,d[0]);case"open":return this.l(w,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(w,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(w,d[0],d[1],d[2]);case"rename":return this.t(w,d[0],d[1],d[2]);case"copy":return this.u(w,d[0],d[1],d[2]);case"cloneFile":return this.v(w,d[0],d[1]);case"mkdir":return this.r(w,d[0]);case"delete":return this.s(w,d[0],d[1]);case"watch":return this.C(w,d[0],d[1],d[2],d[3]);case"unwatch":return this.D(d[0],d[1])}throw new Error(`IPC Command ${y} not found`)}listen(v,y,d){const w=this.c(v);switch(y){case"fileChange":return this.z(w,d[0]);case"readFileStream":return this.j(w,d[0],d[1])}throw new Error(`Unknown event ${y}`)}g(v,y){const d=this.f(v,y,!0);return this.a.stat(d)}h(v,y){const d=this.f(v,y);return this.a.readdir(d)}async i(v,y,d){const w=this.f(v,y,!0),p=await this.a.readFile(w,d);return R.VSBuffer.wrap(p)}j(v,y,d){const w=this.f(v,y,!0),p=new k.CancellationTokenSource,a=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),h=this.a.readFileStream(w,d,p.token);return(0,C.listenStream)(h,{onData:m=>a.fire(R.VSBuffer.wrap(m)),onError:m=>a.fire(m),onEnd:()=>{a.fire("end"),a.dispose(),p.dispose()}}),a.event}k(v,y,d,w){const p=this.f(v,y);return this.a.writeFile(p,d.buffer,w)}l(v,y,d){const w=this.f(v,y,!0);return this.a.open(w,d)}m(v){return this.a.close(v)}async n(v,y,d){const w=R.VSBuffer.alloc(d),p=0,a=await this.a.read(v,y,w.buffer,p,d);return[w,a]}p(v,y,d,w,p){return this.a.write(v,y,d.buffer,w,p)}r(v,y){const d=this.f(v,y);return this.a.mkdir(d)}s(v,y,d){const w=this.f(v,y);return this.a.delete(w,d)}t(v,y,d,w){const p=this.f(v,y),a=this.f(v,d);return this.a.rename(p,a,w)}u(v,y,d,w){const p=this.f(v,y),a=this.f(v,d);return this.a.copy(p,a,w)}v(v,y,d){const w=this.f(v,y),p=this.f(v,d);return this.a.cloneFile(w,p)}z(v,y){const d=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(y,this.F(v,d))},onDidRemoveLastListener:()=>{(0,n.dispose)(this.w.get(y)),this.w.delete(y)}});return d.event}async C(v,y,d,w,p){const a=this.w.get(y);if(a){const h=this.f(v,w),m=a.watch(d,h,p);this.y.set(y+d,m)}}async D(v,y){const d=v+y,w=this.y.get(d);w&&((0,n.dispose)(w),this.y.delete(d))}dispose(){super.dispose();for(const[,v]of this.y)v.dispose();this.y.clear();for(const[,v]of this.w)v.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=g;class f extends n.Disposable{constructor(v,y,d,w){super(),this.c=v,this.f=d,this.g=w,this.a=new Map,this.b=this.B(new M.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(y)}h(v){const y=this.B(new E.Emitter);this.B(y.event(d=>{v.fire(d.map(w=>({resource:this.c.transformOutgoingURI(w.resource),type:w.type})))})),this.B(this.b.onDidChangeFile(d=>y.fire(d))),this.B(this.b.onDidWatchError(d=>v.fire(d)))}i(v){}j(v){}watch(v,y,d){const w=this.j(this.g);return Array.isArray(w)&&(d.excludes=[...d.excludes,...w]),this.a.set(v,this.b.watch(y,d)),(0,n.toDisposable)(()=>{(0,n.dispose)(this.a.get(v)),this.a.delete(v)})}dispose(){super.dispose();for(const[,v]of this.a)v.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=f}),define(Z[216],_([0,1,15,171,4,8,16,9,215,149]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class b extends g.AbstractDiskFileSystemProviderChannel{constructor(d,w,p){super(d,w),this.G=p}c(d){return f.DefaultURITransformer}f(d,w){return R.URI.revive(w)}async s(d,w,p){if(!p.useTrash)return super.s(d,w,p);const a=this.f(d,w),h=(0,k.normalize)(a.fsPath);try{await E.shell.trashItem(h)}catch{throw(0,C.createFileSystemProviderError)(n.isWindows?(0,M.localize)(0,null,(0,k.basename)(h)):(0,M.localize)(1,null,(0,k.basename)(h)),C.FileSystemProviderErrorCode.Unknown)}}F(d,w){return new v(d,w,this.b,this.G)}}e.DiskFileSystemProviderChannel=b;class v extends g.AbstractSessionFileWatcher{watch(d,w,p){if(p.recursive)throw(0,C.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",C.FileSystemProviderErrorCode.Unavailable);return super.watch(d,w,p)}}}),define(Z[217],_([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class M extends E.AbstractMessageLogger{constructor(R=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(C=>{this.l?.setLevel(C)}))}set logger(R){this.l=R;for(const{level:C,message:k}of this.k)(0,E.log)(R,C,k);this.k=[]}g(R,C){this.l?(0,E.log)(this.l,R,C):this.getLevel()<=R&&this.k.push({level:R,message:C})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=M}),define(Z[218],_([0,1,2,5]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class n extends E.Disposable{constructor(C,k=[]){super(),this.a=new M.MultiplexLogger([C,...k]),this.B(C.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...k){this.a.trace(C,...k)}debug(C,...k){this.a.debug(C,...k)}info(C,...k){this.a.info(C,...k)}warn(C,...k){this.a.warn(C,...k)}error(C,...k){this.a.error(C,...k)}flush(){this.a.flush()}}e.LogService=n}),define(Z[219],_([0,1,35,8,5]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class R{constructor(k){this.b=k,this.a=new E.ResourceMap}listen(k,g,f){switch(g){case"onDidChangeLoggers":return f?this.b.getOnDidChangeLoggersEvent(f):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return f?this.b.getOnDidChangeLogLevelEvent(f):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return f?this.b.getOnDidChangeVisibilityEvent(f):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${g}`)}async call(k,g,f){switch(g){case"createLogger":this.c(M.URI.revive(f[0]),f[1],f[2]);return;case"log":return this.e(M.URI.revive(f[0]),f[1]);case"consoleLog":return this.d(f[0],f[1]);case"setLogLevel":return(0,n.isLogLevel)(f[0])?this.b.setLogLevel(f[0]):this.b.setLogLevel(M.URI.revive(f[0]),f[1]);case"setVisibility":return this.b.setVisibility(M.URI.revive(f[0]),f[1]);case"registerLogger":return this.b.registerLogger({...f[0],resource:M.URI.revive(f[0].resource)},f[1]);case"deregisterLogger":return this.b.deregisterLogger(M.URI.revive(f[0]))}throw new Error(`Call not found: ${g}`)}c(k,g,f){this.a.set(k,this.b.createLogger(k,g,f))}d(k,g){let f=console.log;switch(k){case n.LogLevel.Error:f=console.error;break;case n.LogLevel.Warning:f=console.warn;break;case n.LogLevel.Info:f=console.info;break}f.call(console,...g)}e(k,g){const f=this.a.get(k);if(!f)throw new Error("Create the logger before logging");for(const[b,v]of g)(0,n.log)(f,b,v)}}e.LoggerChannel=R}),define(Z[220],_([0,1,16,5]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var n;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(n||(n={}));async function R(f,b,v,y,d){try{const w=await new Promise((a,h)=>{x(["spdlog"],a,h)});w.setFlushOn(n.Trace);const p=await w.createAsyncRotatingLogger(f,b,v,y);return d?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(w){console.error(w)}return null}function C(f,b,v){switch(b){case M.LogLevel.Trace:f.trace(v);break;case M.LogLevel.Debug:f.debug(v);break;case M.LogLevel.Info:f.info(v);break;case M.LogLevel.Warning:f.warn(v);break;case M.LogLevel.Error:f.error(v);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function k(f,b){switch(b){case M.LogLevel.Trace:f.setLevel(n.Trace);break;case M.LogLevel.Debug:f.setLevel(n.Debug);break;case M.LogLevel.Info:f.setLevel(n.Info);break;case M.LogLevel.Warning:f.setLevel(n.Warning);break;case M.LogLevel.Error:f.setLevel(n.Error);break;case M.LogLevel.Off:f.setLevel(n.Off);break;default:throw new Error(`Invalid log level ${b}`)}}class g extends M.AbstractMessageLogger{constructor(b,v,y,d,w){super(),this.k=[],this.setLevel(w),this.l=this.n(b,v,y,d),this.B(this.onDidChangeLogLevel(p=>{this.m&&k(this.m,p)}))}async n(b,v,y,d){const w=y?6:1,p=30/w*E.ByteSize.MB,a=await R(b,v,p,w,d);if(a){this.m=a,k(this.m,this.getLevel());for(const{level:h,message:m}of this.k)C(this.m,h,m);this.k=[]}}g(b,v){this.m?C(this.m,b,v):this.getLevel()<=b&&this.k.push({level:b,message:v})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Z[221],_([0,1,31,5,220]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class R extends M.AbstractLoggerService{k(k,g,f){return new n.SpdLogLogger((0,E.generateUuid)(),k.fsPath,!f?.donotRotate,!!f?.donotUseFormatters,g)}}e.LoggerService=R}),define(Z[65],_([0,1,35,3,6,5,221]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,n.refineServiceDecorator)(R.ILoggerService);class k extends C.LoggerService{constructor(){super(...arguments),this.m=new E.ResourceMap}createLogger(f,b,v){v!==void 0&&this.m.set(f,v);try{return super.createLogger(f,b)}catch(y){throw this.m.delete(f),y}}registerLogger(f,b){b!==void 0&&this.m.set(f.resource,b),super.registerLogger(f)}deregisterLogger(f){this.m.delete(f),super.deregisterLogger(f)}getRegisteredLoggers(f){const b=[];for(const v of super.getRegisteredLoggers())f===this.m.get(v.resource)&&b.push(v);return b}getOnDidChangeLogLevelEvent(f){return M.Event.filter(this.onDidChangeLogLevel,b=>(0,R.isLogLevel)(b)||this.n(b[0],f))}getOnDidChangeVisibilityEvent(f){return M.Event.filter(this.onDidChangeVisibility,([b])=>this.n(b,f))}getOnDidChangeLoggersEvent(f){return M.Event.filter(M.Event.map(this.onDidChangeLoggers,b=>({added:[...b.added].filter(y=>this.n(y.resource,f)),removed:[...b.removed].filter(y=>this.n(y.resource,f))})),b=>b.added.length>0||b.removed.length>0)}deregisterLoggers(f){for(const[b,v]of this.m)v===f&&this.deregisterLogger(b)}n(f,b){const v=this.m.get(f);return v===void 0||v===b}dispose(){super.dispose(),this.m.clear()}}e.LoggerMainService=k}),define(Z[222],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(C){return C.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function M(C){return C.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function n(C){return C.uri!==void 0}e.isMenubarMenuItemRecentAction=n;function R(C){return!E(C)&&!M(C)&&!n(C)}e.isMenubarMenuItemAction=R}),define(Z[38],_([0,1,3,70,2,6]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class C extends n.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(f){const b=Object.keys(this.f).length;return this.f={...f,...this.f},b!==Object.keys(this.f).length&&await this.i(f),M.Iterable.reduce(this.g.entries(),(v,[y,d])=>({...v,[y]:d}),{})}getPolicyValue(f){return this.g.get(f)}serialize(){return M.Iterable.reduce(Object.entries(this.f),(f,[b,v])=>({...f,[b]:{definition:v,value:this.g.get(b)}}),{})}}e.AbstractPolicyService=C;class k{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(Z[223],_([0,1,7,3,70,10,16,5,38]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function f(v,y){const d=[];for(const w of new Set(n.Iterable.concat(v.keys(),y.keys())))v.get(w)!==y.get(w)&&d.push(w);return d}let b=class extends g.AbstractPolicyService{constructor(y,d,w){super(),this.j=y,this.k=d,this.l=w,this.c=this.B(new E.ThrottledDelayer(500));const p=M.Event.filter(d.onDidFilesChange,a=>a.affects(y));this.B(d.watch(y)),this.B(p(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const y=new Map;try{const d=await this.k.readFile(this.j),w=JSON.parse(d.value.toString());if(!(0,R.isObject)(w))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(w))this.f[p]&&y.set(p,w[p])}catch(d){d.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",d)}return y}async p(){const y=await this.n(),d=f(this.g,y);this.g=y,d.length>0&&this.h.fire(d)}};b=ve([Q(1,C.IFileService),Q(2,k.ILogService)],b),e.FilePolicyService=b}),define(Z[224],_([0,1,3,2,38]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(g){this.b=g,this.a=new M.DisposableStore}listen(g,f){switch(f){case"onDidChange":return E.Event.map(this.b.onDidChange,b=>b.reduce((v,y)=>({...v,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${f}`)}call(g,f,b){switch(f){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(b)}throw new Error(`Call not found: ${f}`)}dispose(){this.a.dispose()}}e.PolicyChannel=R;class C extends n.AbstractPolicyService{constructor(g,f){super(),this.a=f;for(const b in g){const{definition:v,value:y}=g[b];this.f[b]=v,y!==void 0&&this.g.set(b,y)}this.a.listen("onDidChange")(b=>{for(const v in b){const y=b[v];y===null?this.g.delete(v):this.g.set(v,y)}this.h.fire(Object.keys(b))})}async i(g){const f=await this.a.call("updatePolicyDefinitions",g);for(const b in f)this.g.set(b,f[b])}}e.PolicyChannelClient=C}),define(Z[225],_([0,1,38,7,291,2,5]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=class extends E.AbstractPolicyService{constructor(f,b){super(),this.j=f,this.k=b,this.a=new M.Throttler,this.b=this.B(new R.MutableDisposable)}async i(f){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`),await this.a.queue(()=>new Promise((b,v)=>{try{this.b.value=(0,n.createWatcher)(this.k,f,y=>{this.m(y),b()})}catch(y){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),v(y)}}))}m(f){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const b in f){const v=f[b];v===void 0?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(f))}};k=ve([Q(0,C.ILogService)],k),e.NativePolicyService=k}),define(Z[66],_([0,1,4,36]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const R=E.globals.vscode.context.configuration();if(R)n=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(n=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`,serverDataFolderName:n.serverDataFolderName?`${n.serverDataFolderName}-dev`:void 0}),!n.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(n,{version:R.version})}}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=n}),define(Z[21],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Z[226],_([0,1,81,5,21]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(k,g){this.b=k,this.c=g,this.a=new Map}async isExtensionUrlTrusted(k,g){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(g);if(!f)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",g),!1;const[,b,v]=f;let y=this.a.get(k);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[k],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...y])}const d=Buffer.from(decodeURIComponent(v),"base64");if(d.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",g),!1;const w=d.slice(0,6),p=d.readUIntBE(0,6),a=Date.now()-p;if(a<0||a>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",g),!1;const h=d.slice(6),m=E.createVerify("SHA256");m.write(w),m.write(Buffer.from(b)),m.end();for(let I=0;I<y.length;I++){let S=y[I];if(S!==null){if(typeof S=="string")try{S=E.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),y[I]=S}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${I+1} for ${k}:`,D),y[I]=null;continue}if(m.verify(S,h))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",g),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",g),!1}};R=ve([Q(0,n.IProductService),Q(1,M.ILogService)],R),e.ExtensionUrlTrustService=R}),define(Z[227],_([0,1,7,5]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let n=class{constructor(C,k,g){this.a=C,this.b=k,this.c=g}async inspect(C){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(C);const g=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),g.profile}async d(){const C=this.a.webContents.debugger;C.attach(),await C.sendCommand("Profiler.enable")}async e(){const C=this.a.webContents.debugger;await C.sendCommand("Profiler.disable"),C.detach()}};n=ve([Q(2,M.ILogService)],n),e.WindowProfiler=n}),define(Z[67],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(Z[50],_([0,1,127,10]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class n{constructor(){this.a=new Map}add(C,k){E.ok(M.isString(C)),E.ok(M.isObject(k)),E.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,k)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new n}),define(Z[228],_([0,1,3,50]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,f){this.a[n(g)]=f,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const C=new R;M.Registry.add(e.Extensions.JSONContribution,C)}),define(Z[68],_([0,1,25,3,10,158,19,228,50]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var f;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(f=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const v=g.Registry.as(k.Extensions.JSONContribution);class y{constructor(){this.h=new Set,this.i=new M.Emitter,this.onDidSchemaChange=this.i.event,this.j=new M.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const i=new Set;this.n(t,c,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const c=new Set;this.o(t,c),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const i=new Set;this.o(c,i),this.n(t,!1,i),v.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const i=[];for(const{overrides:r,source:o}of t)for(const u in r)if(c.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const s=this.a.get(u),l=s?.valuesSources??new Map;if(o)for(const N of Object.keys(r[u]))l.set(N,o);const P={...s?.value||{},...r[u]};this.a.set(u,{source:o,value:P,valuesSources:l});const A=(0,C.getLanguageTagSettingPlainKey)(u),O={type:"object",default:P,description:R.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:P,source:n.isString(o)?void 0:o,defaultValueSource:o};i.push(...p(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:r[u],source:o});const s=this.d[u];s&&(this.w(u,s),this.r(u,s))}this.m(i)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:i,source:r}of t)for(const o in i){const u=this.a.get(o),s=n.isString(r)?r:r?.id,l=n.isString(u?.source)?u?.source:u?.source?.id;if(s===l)if(c.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const P=this.d[o];P&&(this.w(o,P),this.r(o,P))}}this.u()}deltaConfiguration(t){let c=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,i){t.forEach(r=>{this.p(r,c,r.extensionInfo,r.restrictedProperties,void 0,i),this.c.push(r),this.q(r)})}o(t,c){const i=r=>{if(r.properties)for(const o in r.properties){c.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,r.properties[o])}r.allOf?.forEach(o=>i(o))};for(const r of t){i(r);const o=this.c.indexOf(r);o!==-1&&this.c.splice(o,1)}}p(t,c=!0,i,r,o=3,u){o=n.isUndefinedOrNull(t.scope)?o:t.scope;const s=t.properties;if(s)for(const P in s){const A=s[P];if(c&&I(P,A)){delete s[P];continue}if(A.source=i,A.defaultDefaultValue=s[P].default,this.w(P,A),e.OVERRIDE_PROPERTY_REGEX.test(P)?A.scope=void 0:(A.scope=n.isUndefinedOrNull(A.scope)?o:A.scope,A.restricted=n.isUndefinedOrNull(A.restricted)?!!r?.includes(P):A.restricted),s[P].hasOwnProperty("included")&&!s[P].included){this.f[P]=s[P],delete s[P];continue}else this.d[P]=s[P],s[P].policy?.name&&this.e.set(s[P].policy.name,P);!s[P].deprecationMessage&&s[P].markdownDeprecationMessage&&(s[P].deprecationMessage=s[P].markdownDeprecationMessage),u.add(P)}const l=t.allOf;if(l)for(const P of l)this.p(P,c,i,r,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=i=>{const r=i.properties;if(r)for(const u in r)this.r(u,r[u]);i.allOf?.forEach(c)};c(t)}r(t,c){switch(e.allSettings.properties[t]=c,c.scope){case 1:e.applicationSettings.properties[t]=c;break;case 2:e.machineSettings.properties[t]=c;break;case 6:e.machineOverridableSettings.properties[t]=c;break;case 3:e.windowSettings.properties[t]=c;break;case 4:e.resourceSettings.properties[t]=c;break;case 5:e.resourceSettings.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.allSettings.properties[t],c.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,i={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(c,i),e.allSettings.properties[c]=i,e.applicationSettings.properties[c]=i,e.machineSettings.properties[c]=i,e.machineOverridableSettings.properties[c]=i,e.windowSettings.properties[c]=i,e.resourceSettings.properties[c]=i}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,c){const i=this.a.get(t);let r=i?.value,o=i?.source;n.isUndefined(r)&&(r=c.defaultDefaultValue,o=void 0),n.isUndefined(r)&&(r=h(c.type)),c.default=r,c.defaultValueSource=o}}const d="\\[([^\\]]+)\\]",w=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let c=w.exec(D);for(;c?.length;){const i=c[1].trim();i&&t.push(i),c=w.exec(D)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=p;function a(D){return D.reduce((t,c)=>`${t}[${c}]`,"")}e.keyFromOverrideIdentifiers=a;function h(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const m=new y;g.Registry.add(e.Extensions.Configuration,m);function I(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?R.localize(7,null,D):m.getConfigurationProperties()[D]!==void 0?R.localize(8,null,D):t.policy?.name&&m.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,D,t.policy?.name,m.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.validateProperty=I;function S(){const D=[],t=m.getConfigurationProperties();for(const c of Object.keys(t))D.push([c,t[c].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=S}),define(Z[112],_([0,1,25,3,43,2,35,37,10,8,19,68,50]),function(x,e,E,M,n,R,C,k,g,f,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(c){return Object.isFrozen(c)?c:k.deepFreeze(c)}class w{constructor(i={},r=[],o=[],u){this.b=i,this.c=r,this.d=o,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(r=>{if(r instanceof w)return r;const o=new p("");return o.parseRaw(r),o.configurationModel});this.f=i.reduce((r,o)=>o===r?o:r.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,b.getConfigurationValue)(this.contents,i):this.contents}inspect(i,r){const o=this.rawConfiguration.getValue(i),u=r?this.rawConfiguration.getOverrideValue(i,r):void 0,s=r?this.rawConfiguration.override(r).getValue(i):o;return{value:o,override:u,merged:s}}getOverrideValue(i,r){const o=this.i(r);return o?i?(0,b.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const r=[];for(const o of this.overrides)o.identifiers.includes(i)&&r.push(...o.keys);return E.distinct(r)}getAllOverrideIdentifiers(){const i=[];for(const r of this.overrides)i.push(...r.identifiers);return E.distinct(i)}override(i){let r=this.a.get(i);return r||(r=this.g(i),this.a.set(i,r)),r}merge(...i){const r=k.deepClone(this.contents),o=k.deepClone(this.overrides),u=[...this.keys],s=this.raw?.length?[...this.raw]:[this];for(const l of i)if(s.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(r,l.contents);for(const P of l.overrides){const[A]=o.filter(O=>E.equals(O.identifiers,P.identifiers));A?(this.h(A.contents,P.contents),A.keys.push(...P.keys),A.keys=E.distinct(A.keys)):o.push(k.deepClone(P))}for(const P of l.keys)u.indexOf(P)===-1&&u.push(P)}return new w(r,u,o,s.every(l=>l instanceof w)?void 0:s)}g(i){const r=this.i(i);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const u of E.distinct([...Object.keys(this.contents),...Object.keys(r)])){let s=this.contents[u];const l=r[u];l&&(typeof s=="object"&&typeof l=="object"?(s=k.deepClone(s),this.h(s,l)):s=l),o[u]=s}return new w(o,this.keys,this.overrides)}h(i,r){for(const o of Object.keys(r)){if(o in i&&g.isObject(i[o])&&g.isObject(r[o])){this.h(i[o],r[o]);continue}i[o]=k.deepClone(r[o])}}i(i){let r=null,o=null;const u=s=>{s&&(o?this.h(o,s):o=k.deepClone(s))};for(const s of this.overrides)E.equals(s.identifiers,[i])?r=s.contents:s.identifiers.includes(i)&&u(s.contents);return u(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,r){this.j(i,r,!0)}setValue(i,r){this.j(i,r,!1)}removeValue(i){const r=this.keys.indexOf(i);r!==-1&&(this.keys.splice(r,1),(0,b.removeFromValueTree)(this.contents,i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,v.overrideIdentifiersFromKey)(i))),1))}j(i,r,o){(0,b.addToValueTree)(this.contents,i,r,u=>console.error(u)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),v.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,v.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,b.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=w;class p{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,r){if(!g.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,r)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,r){this.a=i;const{contents:o,keys:u,overrides:s,restricted:l,hasExcludedProperties:P}=this.h(i,r);this.b=new w(o,u,s,P?[i]:void 0),this.c=l||[]}g(i){let r={},o=null,u=[];const s=[],l=[];function P(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const A={onObjectBegin:()=>{const O={};P(O),s.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=s.pop()},onArrayBegin:()=>{const O=[];P(O),s.push(u),u=O,o=null},onArrayEnd:()=>{u=s.pop()},onLiteralValue:P,onError:(O,N,z)=>{l.push({error:O,offset:N,length:z})}};if(i)try{n.visit(i,A),r=u[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return r}h(i,r){const o=y.Registry.as(v.Extensions.Configuration).getConfigurationProperties(),u=this.i(i,o,!0,r);i=u.raw;const s=(0,b.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),l=Object.keys(i),P=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:s,keys:l,overrides:P,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(i,r,o,u){let s=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:s};const l={},P=[];for(const A in i)if(v.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const O=this.i(i[A],r,!1,u);l[A]=O.raw,s=s||O.hasExcludedProperties,P.push(...O.restricted)}else{const O=r[A],N=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&P.push(A),(N===void 0||u.scopes===void 0||u.scopes.includes(N))&&!(u.skipRestricted&&O?.restricted)?l[A]=i[A]:s=!0}return{raw:l,restricted:P,hasExcludedProperties:s}}j(i,r){const o=[];for(const u of Object.keys(i))if(v.OVERRIDE_PROPERTY_REGEX.test(u)){const s={};for(const l in i[u])s[l]=i[u][l];o.push({identifiers:(0,v.overrideIdentifiersFromKey)(u),keys:Object.keys(s),contents:(0,b.toValuesTree)(s,r)})}return o}}e.ConfigurationModelParser=p;class a extends R.Disposable{constructor(i,r,o,u){super(),this.f=i,this.g=r,this.h=u,this.c=this.B(new M.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(M.Event.any(M.Event.filter(this.h.onDidFilesChange,s=>s.contains(this.f)),M.Event.filter(this.h.onDidRunOperation,s=>(s.isOperation(0)||s.isOperation(3)||s.isOperation(1)||s.isOperation(4))&&o.isEqual(s.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new w}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class h{constructor(i,r,o,u,s,l,P,A,O,N,z,H,ie){this.a=i,this.b=r,this.c=o,this.overrideIdentifiers=u,this.d=s,this.f=l,this.g=P,this.h=A,this.i=O,this.j=N,this.k=z,this.l=H,this.m=ie}get value(){return d(this.c)}n(i,r,o){const u=i.inspect(r,o);return{get value(){return d(u.value)},get override(){return d(u.override)},get merged(){return d(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class m{constructor(i,r,o,u,s=new w,l=new w,P=new C.ResourceMap,A=new w,O=new C.ResourceMap){this.c=i,this.d=r,this.f=o,this.g=u,this.h=s,this.i=l,this.j=P,this.l=A,this.m=O,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(i,r,o){return this.q(i,r,o).getValue(i)}updateValue(i,r,o={}){let u;o.resource?(u=this.m.get(o.resource),u||(u=new w,this.m.set(o.resource,u))):u=this.l,r===void 0?u.removeValue(i):u.setValue(i,r),o.resource||(this.a=null)}inspect(i,r,o){const u=this.q(i,r,o),s=this.u(r.resource,o),l=r.resource?this.m.get(r.resource)||this.l:this.l,P=new Set;for(const A of u.overrides)for(const O of A.identifiers)u.getOverrideValue(i,O)!==void 0&&P.add(O);return new h(i,r,u.getValue(i),P.size?[...P]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,s||void 0,l)}keys(i){const r=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,r){this.j.set(i,r),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,r){const o=[];if(!r){const{added:u,updated:s,removed:l}=D(this.c,i);r=[...u,...s,...l]}for(const u of r)for(const s of(0,v.overrideIdentifiersFromKey)(u)){const l=this.c.getKeysForOverrideIdentifier(s),P=i.getKeysForOverrideIdentifier(s),A=[...P.filter(O=>l.indexOf(O)===-1),...l.filter(O=>P.indexOf(O)===-1),...l.filter(O=>!k.equals(this.c.override(s).getValue(O),i.override(s).getValue(O)))];o.push([s,A])}return this.updateDefaultConfiguration(i),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:r,updated:o,removed:u}=D(this.d,i),s=[...r,...o,...u];return s.length&&this.updatePolicyConfiguration(i),{keys:s,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:r,updated:o,removed:u,overrides:s}=D(this.applicationConfiguration,i),l=[...r,...o,...u];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:s}}compareAndUpdateLocalUserConfiguration(i){const{added:r,updated:o,removed:u,overrides:s}=D(this.localUserConfiguration,i),l=[...r,...o,...u];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateRemoteUserConfiguration(i){const{added:r,updated:o,removed:u,overrides:s}=D(this.remoteUserConfiguration,i),l=[...r,...o,...u];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:s}}compareAndUpdateWorkspaceConfiguration(i){const{added:r,updated:o,removed:u,overrides:s}=D(this.workspaceConfiguration,i),l=[...r,...o,...u];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:s}}compareAndUpdateFolderConfiguration(i,r){const o=this.p.get(i),{added:u,updated:s,removed:l,overrides:P}=D(o,r),A=[...u,...s,...l];return(A.length||!o)&&this.updateFolderConfiguration(i,r),{keys:A,overrides:P}}compareAndDeleteFolderConfiguration(i){const r=this.p.get(i);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:u,removed:s,overrides:l}=D(r,void 0);return{keys:[...o,...u,...s],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,r,o){let u=this.r(r,o);return r.overrideIdentifier&&(u=u.override(r.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(u=u.merge(this.d)),u}r({resource:i},r){let o=this.s();if(r&&i){const u=r.getFolder(i);u&&(o=this.t(u.uri)||o);const s=this.m.get(i);s&&(o=o.merge(s))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let r=this.b.get(i);if(!r){const o=this.s(),u=this.j.get(i);u?(r=o.merge(u),this.b.set(i,r)):r=o}return r}u(i,r){if(r&&i){const o=r.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,r)=>{const{contents:o,overrides:u,keys:s}=this.j.get(r);return i.push([r,{contents:o,overrides:u,keys:s}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(r=>i.add(r)),this.userConfiguration.keys.forEach(r=>i.add(r)),this.i.keys.forEach(r=>i.add(r)),this.j.forEach(r=>r.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.i.getAllOverrideIdentifiers().forEach(r=>i.add(r)),this.j.forEach(r=>r.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const r=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>r.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(u=>r.add(u))),[...r.values()]}static parse(i){const r=this.x(i.defaults),o=this.x(i.policy),u=this.x(i.application),s=this.x(i.user),l=this.x(i.workspace),P=i.folders.reduce((A,O)=>(A.set(f.URI.revive(O[0]),this.x(O[1])),A),new C.ResourceMap);return new m(r,o,u,s,new w,l,P,new w,new C.ResourceMap)}static x(i){return new w(i.contents,i.keys,i.overrides)}}e.Configuration=m;function I(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const i=new Set,r=new Map;for(const u of c)u.keys.forEach(s=>i.add(s)),u.overrides.forEach(([s,l])=>{const P=(0,C.getOrSet)(r,s,new Set);l.forEach(A=>P.add(A))});const o=[];return r.forEach((u,s)=>o.push([s,[...u.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=I;class S{constructor(i,r,o,u){this.change=i,this.f=r,this.g=o,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const s of i.keys)this.affectedKeys.add(s);for(const[,s]of i.overrides)for(const l of s)this.affectedKeys.add(l);this.d=this.a;for(const s of this.affectedKeys)this.d+=s+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=m.parse(this.f.data)),this.i}affectsConfiguration(i,r){const o=this.a+i,u=this.d.indexOf(o);if(u<0)return!1;const s=u+o.length;if(s>=this.d.length)return!1;const l=this.d.charCodeAt(s);if(l!==this.b&&l!==this.c)return!1;if(r){const P=this.previousConfiguration?this.previousConfiguration.getValue(i,r,this.f?.workspace):void 0,A=this.g.getValue(i,r,this.h);return!k.equals(P,A)}return!0}}e.ConfigurationChangeEvent=S;function D(c,i){const{added:r,removed:o,updated:u}=t(i?.rawConfiguration,c?.rawConfiguration),s=[],l=c?.getAllOverrideIdentifiers()||[],P=i?.getAllOverrideIdentifiers()||[];if(i){const A=P.filter(O=>!l.includes(O));for(const O of A)s.push([O,i.getKeysForOverrideIdentifier(O)])}if(c){const A=l.filter(O=>!P.includes(O));for(const O of A)s.push([O,c.getKeysForOverrideIdentifier(O)])}if(i&&c){for(const A of l)if(P.includes(A)){const O=t({contents:c.getOverrideValue(void 0,A)||{},keys:c.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});s.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:r,removed:o,updated:u,overrides:s}}function t(c,i){const r=c?i?c.keys.filter(s=>i.keys.indexOf(s)===-1):[...c.keys]:[],o=i?c?i.keys.filter(s=>c.keys.indexOf(s)===-1):[...i.keys]:[],u=[];if(c&&i){for(const s of i.keys)if(c.keys.indexOf(s)!==-1){const l=(0,b.getConfigurationValue)(i.contents,s),P=(0,b.getConfigurationValue)(c.contents,s);k.equals(l,P)||u.push(s)}}return{added:r,removed:o,updated:u}}}),define(Z[229],_([0,1,25,3,2,37,10,112,68,5,38,50]),function(x,e,E,M,n,R,C,k,g,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class y extends n.Disposable{constructor(){super(...arguments),this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:h})=>this.c(Array.from(a),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,h){this.h(a,v.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new k.ConfigurationModel;const a=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,h){const m=this.f();for(const I of a){const S=m[I],D=h[I];S!==void 0?this.b.addValue(I,S):D?this.b.addValue(I,D.default):this.b.removeValue(I)}}}e.DefaultConfiguration=y;class d{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let w=class extends n.Disposable{get configurationModel(){return this.b}constructor(a,h,m){super(),this.c=a,this.f=h,this.g=m,this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const h={},m=[],I=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const S of a){const D=I[S];if(!D){m.push(S);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}m.push(S),h[D.policy.name]={type:D.type}}}return(0,C.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),m}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const h=v.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),m=(0,E.coalesce)(a.map(I=>h.get(I)));this.j(m,!0)}j(a,h){this.g.trace("PolicyConfiguration#update",a);const m=v.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),I=[],S=this.b.isEmpty();for(const D of a){const t=m[D]?.policy?.name;if(t){const c=this.f.getPolicyValue(t);(S?c!==void 0:!(0,R.equals)(this.b.getValue(D),c))&&I.push([D,c])}else this.b.getValue(D)!==void 0&&I.push([D,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const D=this.b;this.b=new k.ConfigurationModel;for(const t of D.keys)this.b.setValue(t,D.getValue(t));for(const[t,c]of I)c===void 0?this.b.removeValue(t):this.b.setValue(t,c);h&&this.a.fire(this.b)}}};w=ve([Q(1,b.IPolicyService),Q(2,f.ILogService)],w),e.PolicyConfiguration=w}),define(Z[230],_([0,1,7,3,2,18,19,112,229,38]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class b extends n.Disposable{constructor(y,d,w,p){super(),this.i=y,this.h=this.B(new M.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=w instanceof f.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,w,p)),this.f=this.B(new k.UserSettings(this.i,void 0,R.extUriBiasedIgnorePathCase,d)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:h})=>this.k(a,h))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,d,w]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(y,d,new k.ConfigurationModel,w)}getConfigurationData(){return this.a.toData()}getValue(y,d){const w=typeof y=="string"?y:void 0,p=(0,C.isConfigurationOverrides)(y)?y:(0,C.isConfigurationOverrides)(d)?d:{};return this.a.getValue(w,p,void 0)}updateValue(y,d,w,p){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.j(y)}j(y){const d=this.a.toData(),w=this.a.compareAndUpdateLocalUserConfiguration(y);this.m(w,d,2)}k(y,d){const w=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(y,d);this.m(p,w,7)}l(y){const d=this.a.toData(),w=this.a.compareAndUpdatePolicyConfiguration(y);this.m(w,d,7)}m(y,d,w){const p=new k.ConfigurationChangeEvent(y,{data:d},this.a);p.source=w,p.sourceConfig=this.n(w),this.h.fire(p)}n(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=b}),define(Z[231],_([0,1,13,6]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,M.createDecorator)("remoteAuthorityResolverService");var n;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{static isNotAvailable(g){return g instanceof R&&g._code===n.NotAvailable}static isTemporarilyNotAvailable(g){return g instanceof R&&g._code===n.TemporarilyNotAvailable}static isNoResolverFound(g){return g instanceof R&&g._code===n.NoResolverFound}static isHandled(g){return g instanceof R&&g.isHandled}constructor(g,f=n.Unknown,b){super(g),this._message=g,this._code=f,this._detail=b,this.isHandled=f===n.NotAvailable&&b===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function C(k){const g=k.indexOf("+");return g===-1?k:k.substring(0,g)}e.getRemoteAuthorityPrefix=C}),define(Z[55],_([0,1,14]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function M(f){return f.scheme===E.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=M;function n(f){if(!f)return;const b=f.indexOf("+");return b<0?f:f.substr(0,b)}e.getRemoteName=n;function R(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.getRemoteServerRootPath=R;function C(f){const{host:b,port:v}=g(f);if(typeof v>"u")throw new Error("Remote authority doesn't contain a port!");return{host:b,port:v}}e.parseAuthorityWithPort=C;function k(f,b){let{host:v,port:y}=g(f);return typeof y>"u"&&(y=b),{host:v,port:y}}e.parseAuthorityWithOptionalPort=k;function g(f){const b=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(b)return{host:b[1],port:parseInt(b[2],10)};const v=f.match(/^(\[[0-9a-z:]+\])$/);if(v)return{host:v[1],port:void 0};const y=f.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:f,port:void 0}}}),define(Z[113],_([0,1,27,6,55]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var k;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(k=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(w){this.value=w,this.c=w.toLowerCase()}static equals(w,p){if(typeof w>"u"||w===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof w=="string"||typeof p=="string"){const a=typeof w=="string"?w:w.value,h=typeof p=="string"?p:p.value;return E.equalsIgnoreCase(a,h)}return w.c===p.c}static toKey(w){return typeof w=="string"?w.toLowerCase():w.c}}e.ExtensionIdentifier=g;function f(d){return b(d)}e.isApplicationScopedExtension=f;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function y(d,w){if(w){const p=`onResolveRemoteAuthority:${(0,n.getRemoteName)(w)}`;return!!d.activationEvents?.includes(p)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[232],_([0,1,7,17,22,13,3,2,64,72,31,104,231,55]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const w=30*1e3;var p;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(p=e.ConnectionType||(e.ConnectionType={}));function a(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const W=new n.CancellationTokenSource;return setTimeout(()=>W.cancel(),U),W.token}function m(U,W){if(U.isCancellationRequested||W.isCancellationRequested)return n.CancellationToken.Cancelled;const $=new n.CancellationTokenSource;return U.onCancellationRequested(()=>$.cancel()),W.onCancellationRequested(()=>$.cancel()),$.token}class I{get didTimeout(){return this.c==="timedout"}constructor(W){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise(($,V)=>{this.f=$,this.g=V}),W.isCancellationRequested?this.h():this.d.add(W.onCancellationRequested(()=>this.h()))}registerDisposable(W){this.c==="pending"?this.d.add(W):W.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const W=new Error("Time limit reached");return W.code="ETIMEDOUT",W.syscall="connect",W}resolve(W){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(W))}reject(W){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(W))}}function S(U,W){const $=new I(W);return $.registerDisposable(U.onControlMessage(V=>{const j=JSON.parse(V.toString()),K=q(j);K?$.reject(K):$.resolve(j)})),$.promise}function D(U,W,$,V,j,K,J,re,de){const Ce=new I(de),Re=f.StopWatch.create(!1);return U.info(`Creating a socket (${re})...`),g.mark(`code/willCreateSocket/${J}`),W.connect($,V,j,K,re,(De,Oe)=>{Ce.didTimeout?(g.mark(`code/didCreateSocketError/${J}`),U.info(`Creating a socket (${re}) finished after ${Re.elapsed()} ms, but this is too late and has timed out already.`),De&&U.error(De),Oe?.dispose()):De||!Oe?(g.mark(`code/didCreateSocketError/${J}`),U.info(`Creating a socket (${re}) returned an error after ${Re.elapsed()} ms.`),Ce.reject(De)):(g.mark(`code/didCreateSocketOK/${J}`),U.info(`Creating a socket (${re}) was successful after ${Re.elapsed()} ms.`),Ce.resolve(Oe))}),Ce.promise}function t(U,W){const $=new I(W);return U.then(V=>{$.didTimeout||$.resolve(V)},V=>{$.didTimeout||$.reject(V)}),$.promise}async function c(U,W,$,V){const j=L(U,W);U.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let K;try{K=await D(U.logService,U.socketFactory,U.host,U.port,(0,d.getRemoteServerRootPath)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,a(W),`renderer-${a(W)}-${U.reconnectionToken}`,V)}catch(Re){throw U.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),U.logService.error(Re),Re}U.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let J,re;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(K,null),J=U.reconnectionProtocol,re=!1):(J=new v.PersistentProtocol({socket:K,measureRoundTripTime:!0}),re=!0),U.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const de=await t(U.signService.createNewMessage((0,b.generateUuid)()),V),Ce={type:"auth",auth:U.connectionToken||"00000000000000000000",data:de.data};J.sendControl(M.VSBuffer.fromString(JSON.stringify(Ce)));try{const Re=await S(J,m(V,h(1e4)));if(Re.type!=="sign"||typeof Re.data!="string"){const fe=new Error("Unexpected handshake message");throw fe.code="VSCODE_CONNECTION_ERROR",fe}if(U.logService.trace(`${j} 4/6. received SignRequest control message.`),!await t(U.signService.validate(de,Re.signedData),V)){const fe=new Error("Refused to connect to unsupported server");throw fe.code="VSCODE_CONNECTION_ERROR",fe}const Oe=await t(U.signService.sign(Re.data),V),$e={type:"connectionType",commit:U.commit,signedData:Oe,desiredConnectionType:W};return $&&($e.args=$),U.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),J.sendControl(M.VSBuffer.fromString(JSON.stringify($e))),{protocol:J,ownsProtocol:re}}catch(Re){throw Re&&Re.code==="ETIMEDOUT"&&(U.logService.error(`${j} the handshake timed out. Error:`),U.logService.error(Re)),Re&&Re.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${j} received error control message when negotiating connection. Error:`),U.logService.error(Re)),re&&T(J),Re}}async function i(U,W,$,V){const j=Date.now(),K=L(U,W),{protocol:J,ownsProtocol:re}=await c(U,W,$,V),de=new I(V);return de.registerDisposable(J.onControlMessage(Ce=>{const Re=JSON.parse(Ce.toString()),De=q(Re);De?(U.logService.error(`${K} received error control message when negotiating connection. Error:`),U.logService.error(De),re&&T(J),de.reject(De)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${K} 6/6. handshake finished, connection is up and running after ${F(j)}!`),de.resolve({protocol:J,firstMessage:Re}))})),de.promise}async function r(U,W){const{protocol:$}=await i(U,1,void 0,W);return{protocol:$}}async function o(U,W,$){const{protocol:V,firstMessage:j}=await i(U,2,W,$),K=j&&j.debugPort;return{protocol:V,debugPort:K}}async function u(U,W,$){const V=Date.now(),j=L(U,3),{protocol:K}=await c(U,3,W,$);return U.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${F(V)}!`),K}async function s(U,W,$){const{host:V,port:j,connectionToken:K}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,host:V,port:j,connectionToken:K,reconnectionToken:W,reconnectionProtocol:$,socketFactory:U.socketFactory,signService:U.signService,logService:U.logService}}async function l(U,W,$){return A(U,async V=>{const{protocol:j}=await r(V,n.CancellationToken.None);return new G(U,W,$,V.reconnectionToken,j)})}e.connectRemoteAgentManagement=l;async function P(U,W){return A(U,async $=>{const{protocol:V,debugPort:j}=await o($,W,n.CancellationToken.None);return new B(U,W,$.reconnectionToken,V,j)})}e.connectRemoteAgentExtensionHost=P;async function A(U,W){for(let V=1;;V++)try{const j=(0,b.generateUuid)(),K=await s(U,j,null);return await W(K)}catch(j){if(V<5)U.logService.error(`[remote-connection][attempt ${V}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(j);else throw U.logService.error(`[remote-connection][attempt ${V}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(j),me.triggerPermanentFailure(0,0,y.RemoteAuthorityResolverError.isHandled(j)),j}}async function O(U,W,$){const V=await s(U,(0,b.generateUuid)(),null);return await u(V,{host:W,port:$},n.CancellationToken.None)}e.connectRemoteAgentTunnel=O;function N(U){return(0,E.createCancelablePromise)(W=>new Promise(($,V)=>{const j=setTimeout($,U*1e3);W.onCancellationRequested(()=>{clearTimeout(j),$()})}))}var z;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain",U[U.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(z=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class H{constructor(W,$){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.type=0}}e.ConnectionLostEvent=H;class ie{constructor(W,$,V,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.durationSeconds=V,this.c=j,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=ie;class se{constructor(W,$,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=se;class oe{constructor(W,$,V){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.attempt=V,this.type=4}}e.ConnectionGainEvent=oe;class ue{constructor(W,$){this.reconnectionToken=W,this.connectionHealth=$,this.type=5}}e.ConnectionHealthChangedEvent=ue;class le{constructor(W,$,V,j){this.reconnectionToken=W,this.millisSinceLastIncomingData=$,this.attempt=V,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=le;class me extends k.Disposable{static triggerPermanentFailure(W,$,V){this._permanentFailure=!0,this.f=W,this.g=$,this.h=V,this.i.forEach(j=>j.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(W=>W.s())}static debugPauseSocketWriting(){this.i.forEach(W=>W.w())}get k(){return this.c||me._permanentFailure}constructor(W,$,V,j,K){super(),this.n=W,this.p=$,this.reconnectionToken=V,this.protocol=j,this.r=K,this.j=this.B(new C.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new oe(this.reconnectionToken,0,0)),this.B(j.onSocketClose(J=>{const re=ne(this.n,this.reconnectionToken,!0);J?J.type===0?(this.p.logService.info(`${re} received socket close event (hadError: ${J.hadError}).`),J.error&&this.p.logService.error(J.error)):(this.p.logService.info(`${re} received socket close event (wasClean: ${J.wasClean}, code: ${J.code}, reason: ${J.reason}).`),J.event&&this.p.logService.error(J.event)):this.p.logService.info(`${re} received socket close event.`),this.s()})),this.B(j.onSocketTimeout(J=>{const re=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${J.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${J.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${J.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(j.onHighRoundTripTime(J=>{const re=te(this.n,this.reconnectionToken);this.p.logService.info(`${re} high roundtrip time: ${J.roundTripTime}ms (${J.recentHighRoundTripCount} of ${5} recent samples)`)})),this.B(j.onDidChangeConnectionHealth(J=>{this.j.fire(new ue(this.reconnectionToken,J))})),me.i.push(this),this.B((0,k.toDisposable)(()=>{const J=me.i.indexOf(this);J>=0&&me.i.splice(J,1)})),this.k&&this.v(me.f,me.g,me.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const W=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${W} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const $=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const j=V<$.length?$[V]:$[$.length-1];try{if(j>0){const J=N(j);this.j.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,J)),this.p.logService.info(`${W} waiting for ${j} seconds before reconnecting...`);try{await J}catch{}}if(this.k){this.p.logService.error(`${W} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this.p.logService.info(`${W} resolving connection...`);const K=await s(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${W} connecting to ${K.host}:${K.port}...`),await this.y(K,h(w)),this.p.logService.info(`${W} reconnected!`),this.j.fire(new oe(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(K){if(K.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${W} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this.p.logService.error(`${W} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(y.RemoteAuthorityResolverError.isTemporarilyNotAvailable(K)){this.p.logService.info(`${W} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(K);continue}if((K.code==="ETIMEDOUT"||K.code==="ENETUNREACH"||K.code==="ECONNREFUSED"||K.code==="ECONNRESET")&&K.syscall==="connect"){this.p.logService.info(`${W} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(K);continue}if((0,R.isCancellationError)(K)){this.p.logService.info(`${W} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(K);continue}if(K instanceof y.RemoteAuthorityResolverError){this.p.logService.error(`${W} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,y.RemoteAuthorityResolverError.isHandled(K));break}this.p.logService.error(`${W} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(K),this.u(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!this.k&&!this.m)}u(W,$,V){this.r?me.triggerPermanentFailure(W,$,V):this.v(W,$,V)}v(W,$,V){this.j.fire(new le(this.reconnectionToken,W,$,V)),T(this.protocol)}w(){this.protocol.pauseSocketWriting()}}me._permanentFailure=!1,me.f=0,me.g=0,me.h=!1,me.i=[],e.PersistentConnection=me;class G extends me{constructor(W,$,V,j,K){super(1,W,j,K,!0),this.client=this.B(new v.Client(K,{remoteAuthority:$,clientId:V},W.ipcLogger))}async y(W,$){await r(W,$)}}e.ManagementPersistentConnection=G;class B extends me{constructor(W,$,V,j,K){super(2,W,V,j,!1),this.z=$,this.debugPort=K}async y(W,$){await o(W,this.z,$)}}e.ExtensionHostPersistentConnection=B;function T(U){try{U.acceptDisconnect();const W=U.getSocket();U.dispose(),W.dispose()}catch(W){(0,R.onUnexpectedError)(W)}}function q(U){if(U&&U.type==="error"){const W=new Error(`Connection error: ${U.reason}`);return W.code="VSCODE_CONNECTION_ERROR",W}return null}function Y(U,W){for(;U.length<W;)U+=" ";return U}function te(U,W){return`[remote-connection][${Y(a(U),13)}][${W.substr(0,5)}\u2026]`}function ne(U,W,$){return`${te(U,W)}[${$?"reconnect":"initial"}]`}function L(U,W){return`${ne(W,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.host}:${U.port}]`}function F(U){return`${Date.now()-U} ms`}}),define(Z[233],_([0,1,82,86]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(n,R,C,k,g,f){const b=y=>f(y,void 0),v=E.createConnection({host:n,port:R},()=>{v.removeListener("error",b);const y=Buffer.alloc(16);for(let a=0;a<16;a++)y[a]=Math.round(Math.random()*256);const d=y.toString("base64"),w=[`GET ws://${/:/.test(n)?`[${n}]`:n}:${R}${C}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];v.write(w.join(`\r
`)+`\r
\r
`);const p=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(v.off("data",p),f(void 0,new M.NodeSocket(v,g)))};v.on("data",p)});v.setNoDelay(!0),v.once("error",b)}}}),define(Z[234],_([0,1,26,46,41,192]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let C;async function k(d=!1){return(C===void 0||d)&&(C=g()),C}e.hasWSLFeatureInstalled=k;async function g(){const d=f();if(d===void 0)return!1;if(d>=22e3){const w=v();if(w)return new Promise(p=>{M.execFile(w,["--status"],a=>p(!a))})}else{const w=y();if(w)try{if((await n.promises.stat(w)).isFile())return!0}catch{}}return!1}function f(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(d)return parseInt(d[3])}function b(d){const w=process.env.SystemRoot;if(w){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(w,p?"Sysnative":"System32",d)}}function v(){return b("wsl.exe")}function y(){return b("lxss\\LxssManager.dll")}}),define(Z[56],_([0,1,17,176,68,6,50]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function k(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=k;function g(p){return p.res.statusCode===204}async function f(p){return g(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=f;async function b(p){if(!k(p))throw new Error("Server returned "+p.res.statusCode);return f(p)}e.asTextOrError=b;async function v(p){if(!k(p))throw new Error("Server returned "+p.res.statusCode);if(g(p))return null;const h=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(h)}catch(m){throw m.message+=`:
`+h,m}}e.asJson=v;function y(p){w(p)}e.updateProxyConfigurationsScope=y;let d;function w(p){const a=C.Registry.as(n.Extensions.Configuration),h=d;d={id:"http",order:15,title:(0,M.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(4,null),(0,M.localize)(5,null),(0,M.localize)(6,null),(0,M.localize)(7,null)],default:"override",description:(0,M.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(9,null),restricted:!0}}},a.updateConfigurations({add:[d],remove:h?[h]:[]})}w(2)}),define(Z[235],_([0,1,17,22]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class n{constructor(k){this.a=k}listen(k,g){throw new Error("Invalid listen")}call(k,g,f,b=M.CancellationToken.None){switch(g){case"request":return this.a.request(f[0],b).then(async({res:v,stream:y})=>{const d=await(0,E.streamToBuffer)(y);return[{statusCode:v.statusCode,headers:v.headers},d]});case"resolveProxy":return this.a.resolveProxy(f[0])}throw new Error("Invalid call")}}e.RequestChannel=n;class R{constructor(k){this.a=k}async request(k,g){const[f,b]=await this.a.call("request",[k],g);return{res:f,stream:(0,E.bufferToStream)(b)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=R}),define(Z[236],_([0,1,237,10]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function n(C,k){return C.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:C.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(C,k,g={}){const f=(0,E.parse)(C),b=g.proxyUrl||n(f,k);if(!b)return null;const v=(0,E.parse)(b);if(!/^https?:$/.test(v.protocol||""))return null;const y={host:v.hostname||"",port:v.port||(v.protocol==="https"?"443":"80"),auth:v.auth,rejectUnauthorized:(0,M.isBoolean)(g.strictSSL)?g.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((d,w)=>{x(["http-proxy-agent"],d,w)}))(y):new(await new Promise((d,w)=>{x(["https-proxy-agent"],d,w)}))(y)}e.getProxyAgent=R}),define(Z[114],_([0,1,46,9,177,22,44,13,4,31,152,62,7,131]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let w;async function p(h,m,I,S){return I["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.isLaunchedFromCli)(S)&&!I["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.isLaunchedFromCli)(S)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=y.Promises.withAsyncBody(async(D,t)=>{const c=new R.CancellationTokenSource;let i=1e4;const r=h.getValue("application.shellEnvironmentResolutionTimeout");typeof r=="number"&&(i=(0,d.clamp)(r,1,120)*1e3);const o=setTimeout(()=>{c.dispose(!0),t(new Error((0,n.localize)(0,null)))},i);try{D(await a(m,c.token))}catch(u){!(0,k.isCancellationError)(u)&&!c.token.isCancellationRequested?t(new Error((0,n.localize)(1,null,(0,C.toErrorMessage)(u)))):D({})}finally{clearTimeout(o),c.dispose()}})),w)}e.getResolvedShellEnv=p;async function a(h,m){const I=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",I);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",S);const D=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),c={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",c);const i=await(0,b.getSystemShell)(g.OS,c);return h.trace("getUnixShellEnvironment#shell",i),new Promise((r,o)=>{if(m.isCancellationRequested)return o(new k.CancellationError);const u=(0,M.basename)(i);let s,l;const P=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(s=`& '${process.execPath}' ${P} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,l=["-Login","-Command"]):(s=`'${process.execPath}' ${P} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,u==="tcsh"||u==="csh"?l=["-ic"]:l=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),s);const A=(0,E.spawn)(i,[...l,s],{detached:!0,stdio:["ignore","pipe","pipe"],env:c});m.onCancellationRequested(()=>(A.kill(),o(new k.CancellationError))),A.on("error",z=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(z)),o(z)});const O=[];A.stdout.on("data",z=>O.push(z));const N=[];A.stderr.on("data",z=>N.push(z)),A.on("close",(z,H)=>{const ie=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",ie);const se=Buffer.concat(N).toString("utf8");if(se.trim()&&h.trace("getUnixShellEnvironment#stderr",se),z||H)return o(new Error((0,n.localize)(2,null,z,H)));const oe=t.exec(ie),ue=oe?oe[1]:"{}";try{const le=JSON.parse(ue);I?le.ELECTRON_RUN_AS_NODE=I:delete le.ELECTRON_RUN_AS_NODE,S?le.ELECTRON_NO_ATTACH_CONSOLE=S:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",le),r(le)}catch(le){h.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(le)),o(le)}})})}}),define(Z[91],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[238],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((n,R)=>x(["vsda"],n,R))}async createNewMessage(n){try{const R=await this.c(),C=new R.validator;if(C){const k=String(E.a++);return this.b.set(k,C),{id:k,data:C.createNewMessage(n)}}}catch{}return{id:"",data:n}}async validate(n,R){if(!n.id)return!0;const C=this.b.get(n.id);if(!C)return!1;this.b.delete(n.id);try{return C.validate(R)==="ok"}catch{return!1}}async sign(n){try{const R=await this.c(),C=new R.signer;if(C)return C.sign(n)}catch{}return n}}E.a=1,e.SignService=E}),define(Z[33],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(Z[20],_([0,1,15,42,7,3,2,4,36,10,6,5,33,28]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,b.createDecorator)("lifecycleMainService");var w;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(w=e.ShutdownReason||(e.ShutdownReason={}));var p;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})(p=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let a=class ht extends C.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(m,I,S){super(),this.v=m,this.w=I,this.y=S,this.c=this.B(new R.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new R.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(ht.b),this.j&&this.w.removeItem(ht.b)}C(){const m=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",m);const I=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",I),E.app.once("will-quit",S=>{this.L("Lifecycle#app.on(will-quit) - begin"),S.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),E.app.removeListener("before-quit",m),E.app.removeListener("window-all-closed",I),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}D(m){if(this.s)return this.s;const I=this.v;this.L("Lifecycle#onWillShutdown.fire()");const S=[];return this.f.fire({reason:m,join(D,t){I.trace(`Lifecycle#onWillShutdown - begin '${D}'`),S.push(t.finally(()=>{I.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.s=(async()=>{try{await n.Promises.settled(S)}catch(D){this.v.error(D)}try{await this.w.close()}catch(D){this.v.error(D)}})(),this.s}set phase(m){if(m<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===m)return;this.L(`lifecycle (main): phase changed (value: ${m})`),this.k=m;const I=this.u.get(this.k);I&&(I.open(),this.u.delete(this.k))}async when(m){if(m<=this.k)return;let I=this.u.get(m);I||(I=new n.Barrier,this.u.set(m,I)),await I.wait()}registerWindow(m){const I=new C.DisposableStore;this.n++,I.add(m.onWillLoad(D=>this.g.fire({window:m,workspace:D.workspace,reason:D.reason})));const S=(0,f.assertIsDefined)(m.win);S.on("close",D=>{const t=m.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${m.id}`),D.preventDefault(),this.unload(m,1).then(c=>{if(c){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(m),m.close()})}),S.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${m.id}`),this.n--,I.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(m,I){await this.unload(m,3)||m.reload(I)}unload(m,I){const S=this.t.get(m.id);if(S)return S;const D=this.F(m,I).finally(()=>{this.t.delete(m.id)});return this.t.set(m.id,D),D}async F(m,I){if(!m.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${m.id}`);const S=this.i?2:I,D=await this.I(m,S);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${m.id})`),this.G(D)):(await this.J(m,S),!1)}G(m){return m?(this.H(!0),this.i=!1,!0):!1}H(m){this.r&&(this.r(m),this.r=void 0,this.p=void 0)}I(m,I){return new Promise(S=>{const D=this.m++,t=`vscode:ok${D}`,c=`vscode:cancel${D}`;M.validatedIpcMain.once(t,()=>{S(!1)}),M.validatedIpcMain.once(c,()=>{S(!0)}),m.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:c,reason:I})})}J(m,I){return new Promise(S=>{const t=`vscode:reply${this.m++}`;M.validatedIpcMain.once(t,()=>S()),m.send("vscode:onWillUnload",{replyChannel:t,reason:I})})}quit(m){return this.L(`Lifecycle#quit() - begin (willRestart: ${m})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(m&&this.w.setItem(ht.b,!0),this.p=new Promise(I=>{this.r=I,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(m){this.y.args["enable-smoke-test-driver"]?this.v.info(m):this.v.trace(m)}async relaunch(m){this.L("Lifecycle#relaunch()");const I=process.argv.slice(1);if(m?.addArgs&&I.push(...m.addArgs),m?.removeArgs)for(const t of m.removeArgs){const c=I.indexOf(t);c>=0&&I.splice(c,1)}const S=()=>{try{if(k.isWindows){const t=(0,g.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:I})};E.app.once("quit",S),await this.quit(!0)&&E.app.removeListener("quit",S)}async kill(m){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const I of E.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let S;I.webContents&&!I.webContents.isDestroyed()?S=new Promise(D=>I.once("closed",D)):S=Promise.resolve(),I.destroy(),await S}})()]),E.app.exit(m)}};a.b="lifecycle.quitAndRestart",a=ve([Q(0,v.ILogService),Q(1,y.IStateService),Q(2,d.IEnvironmentMainService)],a),e.LifecycleMainService=a}),define(Z[239],_([0,1,4,3,2,6,20]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let k=class extends n.Disposable{constructor(b){super(),this.a=this.B(new M.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,b.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const b=await new Promise((v,y)=>{x(["native-keymap"],v,y)});this.c=g(b),E.isCI||b.onDidChangeKeyboardLayout(()=>{this.c=g(b),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};k=ve([Q(0,C.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function g(f){const b=f.getKeyMap(),v=f.getCurrentKeyboardLayout();return{keyboardMapping:b,keyboardLayoutInfo:v}}}),define(Z[115],_([0,1,7,17,10,34,16,5]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var g;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(g=e.SaveStrategy||(e.SaveStrategy={}));class f{constructor(d,w,p,a){this.f=d,this.g=p,this.h=a,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=w===0?void 0:new E.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,w){const p=this.a[d];return(0,n.isUndefinedOrNull)(p)?w:p}setItem(d,w){this.setItems([{key:d,data:w}])}setItems(d){let w=!1;for(const{key:p,data:a}of d)this.a[p]!==a&&((0,n.isUndefinedOrNull)(a)?(0,n.isUndefined)(this.a[p])||(this.a[p]=void 0,w=!0):(this.a[p]=a,w=!0));w&&this.j()}removeItem(d){(0,n.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,M.VSBuffer.fromString(d)),this.b=d}catch(w){this.g.error(w)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=f;let b=class{constructor(d,w,p,a){this.a=new f(w.stateResource,d,p,a)}async init(){await this.a.init()}getItem(d,w){return this.a.getItem(d,w)}};b=ve([Q(1,R.IEnvironmentService),Q(2,k.ILogService),Q(3,C.IFileService)],b),e.StateReadonlyService=b;class v extends b{setItem(d,w){this.a.setItem(d,w)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=v}),define(Z[92],_([0,1,4,36,8,31]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(f){if(E.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function k(f,b,v,y,d,w,p,a,h,m){const I=Object.create(null);I["common.machineId"]=p,I.sessionID=(0,R.generateUuid)()+Date.now(),I.commitHash=d,I.version=w,I["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),I["common.platform"]=(0,E.PlatformToString)(E.platform),I["common.nodePlatform"]=M.platform,I["common.nodeArch"]=y,I["common.product"]=m||"desktop",a&&(I["common.msftInternal"]=a);let S=0;const D=Date.now();Object.defineProperties(I,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-D,enumerable:!0},"common.sequence":{get:()=>S++,enumerable:!0}}),E.isLinuxSnap&&(I["common.snap"]="true");const t=C(v);t&&(I["common.platformDetail"]=t);try{const c=await f.readFile(n.URI.file(h));I["common.source"]=c.value.toString().slice(0,30)}catch{}return I}e.resolveCommonProperties=k;function g(f){const b=M.env.USERDNSDOMAIN;if(!b)return!1;const v=b.toLowerCase();return f.some(y=>v===y)}e.verifyMicrosoftInternalDomain=g}),define(Z[24],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M=e.TelemetryLevel||(e.TelemetryLevel={}));var n;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(n=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[240],_([0,1,26,7,43,14,9,4,8,84,23,103,87,16,21,24]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function h(t,c){const i=`${t}::${c.join(":")}`,r=a.get(i);if(r)return r;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,s=new Map,l=2e4;function P(O,N,z,H){const ie=N.substring(O.length+1);return M.Promises.withAsyncBody(async se=>{let oe;try{oe=await b.Promises.readdir(N,{withFileTypes:!0})}catch{se();return}if(H.count>=l){H.count+=oe.length,H.maxReached=!0,se();return}let ue=oe.length;if(ue===0){se();return}let le=oe;H.count+oe.length>l&&(H.maxReached=!0,ue=l-H.count,le=oe.slice(0,ue)),H.count+=oe.length;for(const me of le)if(me.isDirectory()){if(z.includes(me.name)||await P(O,(0,C.join)(N,me.name),z,H),--ue===0){se();return}}else{const G=me.name.lastIndexOf(".");if(G>=0){const B=me.name.substring(G+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(ie)!==!1&&B.filePattern.test(me.name)&&s.set(B.tag,(s.get(B.tag)??0)+1);if(--ue===0){se();return}}})}const A=M.Promises.withAsyncBody(async O=>{const N={count:0,maxReached:!1};await P(t,t,c,N);const z=await S(t);O({configFiles:m(s),fileTypes:m(u),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:z})});return a.set(i,A),A}e.collectWorkspaceStats=h;function m(t){return Array.from(t.entries(),([c,i])=>({name:c,count:i})).sort((c,i)=>i.count-c.count)}function I(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(f.virtualMachineHint.value()*100)}%`},c=E.cpus();return c&&c.length>0&&(t.cpus=`${c[0].model} (${c.length} x ${c[0].speed})`),t}e.getMachineInfo=I;async function S(t){try{const c=new Map,i=(0,C.join)(t,".vscode","launch.json"),r=await b.Promises.readFile(i),o=[],u=(0,n.parse)(r.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,n.getNodeType)(u)==="object"&&u.configurations)for(const s of u.configurations){const l=s.type;l&&(c.has(l)?c.set(l,c.get(l)+1):c.set(l,1))}return m(c)}catch{return[]}}e.collectLaunchConfigs=S;let D=class{constructor(c,i){this.c=c,this.d=i}f(c){const i=[];return i.push(`OS Version:       ${c.os}`),i.push(`CPUs:             ${c.cpus}`),i.push(`Memory (System):  ${c.memory}`),i.push(`VM:               ${c.vmHint}`),i.join(`
`)}g(c){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const r=E.cpus();return r&&r.length>0&&i.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(f.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${c.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${c.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(c.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(c,i){return Promise.all([(0,v.listProcesses)(c.mainPID),this.k(c)]).then(async r=>{let[o,u]=r,s=this.m(c,o);return i.forEach(l=>{if((0,y.isRemoteDiagnosticError)(l))s+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(s+=`

Remote: ${l.hostName}`,l.processes&&(s+=`
${this.m(c,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const P of Object.keys(l.workspaceMetadata)){const A=l.workspaceMetadata[P];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${P}): ${O}`,u+=this.h(A)}}}),{processInfo:s,workspaceInfo:u}})}async getSystemInfo(c,i){const{memory:r,vmHint:o,os:u,cpus:s}=I(),l={os:u,memory:r,cpus:s,vmHint:o,processArgs:`${c.mainArguments.join(" ")}`,gpuStatus:c.gpuFeatureStatus,screenReader:`${c.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(l.load=`${E.loadavg().map(P=>Math.round(P)).join(", ")}`),k.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(c,i){const r=[];return(0,v.listProcesses)(c.mainPID).then(async o=>(r.push(""),r.push(this.g(c)),r.push(""),r.push(this.m(c,o)),c.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.k(c))),i.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))r.push(`
${u.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${u.hostName}`),r.push(this.f(u.machineInfo)),u.processes&&r.push(this.m(c,u.processes)),u.workspaceMetadata)for(const s of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[s];let P=`${l.fileCount} files`;l.maxFilesReached&&(P=`more than ${P}`),r.push(`Folder (${s}): ${P}`),r.push(this.h(l))}}),r.push(""),r.push(""),r.join(`
`)))}h(c){const i=[];let o=0;const u=(A,O)=>{const N=` ${A}(${O})`;o+N.length>60?(i.push(s),s="|                 ",o=s.length):o+=N.length,s+=N};let s="|      File types:";const l=10,P=c.fileTypes.length>l?l:c.fileTypes.length;for(let A=0;A<P;A++){const O=c.fileTypes[A];u(O.name,O.count)}if(i.push(s),c.configFiles.length>=0&&(s="|      Conf files:",o=0,c.configFiles.forEach(A=>{u(A.name,A.count)}),i.push(s)),c.launchConfigFiles.length>0){let A="|      Launch Configs:";c.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(A)}return i.join(`
`)}j(c){const i=Math.max(...Object.keys(c).map(r=>r.length));return Object.keys(c).map(r=>`${r}:  ${" ".repeat(i-r.length)}  ${c[r]}`).join(`
                  `)}k(c){const i=[],r=[];return c.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const s=g.URI.revive(u);if(s.scheme===R.Schemas.file){const l=s.fsPath;r.push(h(l,["node_modules",".git"]).then(P=>{let A=`${P.fileCount} files`;P.maxFilesReached&&(A=`more than ${A}`),i.push(`|    Folder (${(0,C.basename)(l)}): ${A}`),i.push(this.h(P))}).catch(P=>{i.push(`|      Error: Unable to collect workspace stats for folder ${l} (${P.toString()})`)}))}else i.push(`|    Folder (${s.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(c,i){const r=new Map;c.windows.forEach(u=>r.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(c.mainPID,r,o,i,0),o.join(`
`)}n(c,i,r,o,u){const s=u===0;let l;s?l=o.pid===c?`${this.d.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(l=`${l} (${i.get(o.pid)})`));const P=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);r.push(`${o.load.toFixed(0).padStart(5," ")}	${(P/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(o.children)&&o.children.forEach(A=>this.n(c,i,r,A,u+1))}async getWorkspaceFileExtensions(c){const i=new Set;for(const{uri:r}of c.folders){const o=g.URI.revive(r);if(o.scheme!==R.Schemas.file)continue;const u=o.fsPath;try{(await h(u,["node_modules",".git"])).fileTypes.forEach(l=>i.add(l.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(c){for(const{uri:i}of c.folders){const r=g.URI.revive(i);if(r.scheme!==R.Schemas.file)continue;const o=r.fsPath;try{const u=await h(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":c.telemetryId,rendererSessionId:c.rendererSessionId}),u.fileTypes.forEach(s=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})}),u.launchConfigFiles.forEach(s=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})}),u.configFiles.forEach(s=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:c.rendererSessionId,type:s.name,count:s.count})})}catch{}}}};D=ve([Q(0,p.ITelemetryService),Q(1,w.IProductService)],D),e.DiagnosticsService=D}),define(Z[241],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.b=R}listen(R,C){throw new Error(`Event not found: ${C}`)}call(R,C,{eventName:k,data:g}){return this.b.forEach(f=>f.log(k,g)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class M{constructor(R){this.b=R}log(R,C){return this.b.call("log",{eventName:R,data:C}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(Z[51],_([0,1,37,10,3,19,55,92,24]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class f{constructor(s){this.value=s}}e.TelemetryTrustedValue=f;class b{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(s,l){return Promise.resolve(void 0)}publicLog2(s,l){return this.publicLog(s,l)}publicLogError(s,l){return Promise.resolve(void 0)}publicLogError2(s,l){return this.publicLogError(s,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=b,e.NullTelemetryService=new b;class v{async publicLog(s,l,P){}async publicLogError(s,l,P){}}e.NullEndpointTelemetryService=v,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(u,s){return n.Event.debounce(s.onDidChangeConfiguration,(P,A)=>{const O=P?new Set([...P.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:O}},1e3,!0)(P=>{P.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(P.source),configurationKeys:S(P.affectedKeys)})})}e.configurationTelemetry=y;function d(u,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!u.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=d;function w(u,s){return!(s.isBuilt||s.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.isLoggingOnly=w;function p(u){const s=u.getValue(g.TELEMETRY_SETTING_ID),l=u.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(u.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function a(u){const s={},l={},P={};I(u,P);for(let A in P){A=A.length>150?A.substr(A.length-149):A;const O=P[A];typeof O=="number"?l[A]=O:typeof O=="boolean"?l[A]=O?1:0:typeof O=="string"?(O.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${O.length}`),s[A]=O.substring(0,8191)):typeof O<"u"&&O!==null&&(s[A]=O)}return{properties:s,measurements:l}}e.validateTelemetryData=a;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function m(u){if(!u)return"none";const s=(0,C.getRemoteName)(u);return h.has(s)?s:"other"}e.cleanRemoteAuthority=m;function I(u,s,l=0,P){if(!!u)for(const A of Object.getOwnPropertyNames(u)){const O=u[A],N=P?P+A:A;Array.isArray(O)?s[N]=(0,E.safeStringify)(O):O instanceof Date?s[N]=O.toISOString():(0,M.isObject)(O)?l<2?I(O,s,l+1,N+"."):s[N]=(0,E.safeStringify)(O):s[N]=O}}function S(u){if(!u)return[];const s=[];return D(s,"",u),s}function D(u,s,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(P=>D(u,s?`${s}.${P}`:P,l[P])):u.push(s)}function t(u,s){const l=u.msftInternalDomains||[],P=s.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(l)||P}e.isInternalTelemetry=t;function c(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=c;function i(u,s){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let l=u;const P=[];for(const z of s)for(;;){const H=z.exec(u);if(!H)break;P.push([H.index,z.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,O=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let N=0;for(l="";;){const z=O.exec(u);if(!z)break;const H=P.some(([ie,se])=>z.index<se&&ie<O.lastIndex);!A.test(z[0])&&!H&&(l+=u.substring(N,z.index)+"<REDACTED: user-file-path>",N=O.lastIndex)}return N<u.length&&(l+=u.substr(N)),l}function r(u){if(!u)return u;const s=u.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const P of l)if(P.regex.test(s))return`<REDACTED: ${P.label}>`;return u}function o(u,s){return(0,E.cloneAndChange)(u,l=>{if(l instanceof f)return l.value;if(typeof l=="string"){let P=l.replaceAll("%20"," ");P=i(P,s);for(const A of s)P=P.replace(A,"");return P=r(P),P}})}e.cleanData=o}),define(Z[116],_([0,1,27,109,113,4,8,13,36,51]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function b(i,r){return i.uuid&&r.uuid?i.uuid===r.uuid:i.id===r.id?!0:(0,E.compareIgnoreCase)(i.id,r.id)===0}e.areSameExtensions=b;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(r){const o=r.manifest?r.manifest.version:r.version,u=r.manifest?r.targetPlatform:r.properties.targetPlatform;return new y(r.identifier,o,u)}static parse(r){const o=v.exec(r);return o&&o[1]&&o[2]?new y({id:o[1]},o[2],o[4]||void 0):null}constructor(r,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=r.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(r){return r instanceof y?b(this,r)&&this.version===r.version&&this.targetPlatform===r.targetPlatform:!1}}e.ExtensionKey=y;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(i){const r=d.exec(i);return r&&r[1]?[a(r[1]),r[2]]:[a(i),void 0]}e.getIdAndVersion=w;function p(i,r){return`${i}.${r}`}e.getExtensionId=p;function a(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=a;function h(i,r){return a(p(i,r))}e.getGalleryExtensionId=h;function m(i,r){const o=[],u=s=>{for(const l of o)if(l.some(P=>b(r(P),r(s))))return l;return null};for(const s of i){const l=u(s);l?l.push(s):o.push([s])}return o}e.groupByExtension=m;function I(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function S(i){return{id:new f.TelemetryTrustedValue(i.identifier.id),name:new f.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function D(i,r){const o=[],u=r.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const s=u.shift();if(s&&o.every(l=>!b(l.identifier,{id:s}))){const l=i.filter(P=>b(P.identifier,{id:s}));l.length===1&&(o.push(l[0]),u.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=D;async function t(i,r){if(!R.isLinux)return!1;let o;try{o=(await i.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(s){r.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(s))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(i,r){const o=await t(i,r),u=(0,M.getTargetPlatform)(o?"alpine":R.platform,g.arch);return r.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=c}),define(Z[242],_([0,1,199,51]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function n(R,C,k,g,f,b,v){const y={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${C.nameShort})`};if((0,M.supportsTelemetry)(C,k)&&(0,M.getTelemetryLevel)(g)===3){const d=await(0,E.getServiceMachineId)(k,f,b),{machineId:w}=await v.getTelemetryInfo();y["X-Market-User-Id"]=d,y["VSCode-SessionId"]=w||d}return y}e.resolveMarketplaceHeaders=n}),define(Z[243],_([0,1,13,37,51]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function k(f,b,v){const y=await new Promise((h,m)=>{x(["@microsoft/1ds-core-js"],h,m)}),d=await new Promise((h,m)=>{x(["@microsoft/1ds-post-js"],h,m)}),w=new y.AppInsightsCore,p=new d.PostChannel,a={instrumentationKey:f,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(v){a.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:v};a.extensionConfig[p.identifier]=h}return w.initialize(a,[]),w.addTelemetryInitializer(h=>{b&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),w}class g{constructor(b,v,y,d,w){this.e=b,this.f=v,this.g=y,this.h=w,this.c=R,this.d=C,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(b){if(!!this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(v=>{b(v)},v=>{(0,E.onUnexpectedError)(v),console.error(v)})}}log(b,v){if(!this.a)return;v=(0,M.mixin)(v,this.g),v=(0,n.validateTelemetryData)(v);const y=this.f+"/"+b;try{this.i(d=>{d.pluginVersionString=v?.properties.version??"Unknown",d.track({name:y,baseData:{name:y,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Z[117],_([0,1,2,37,4,27,178,19,68,66,21,50,24,51]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let w=class{constructor(h,m,I){this.k=m,this.l=I,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,R.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(y.TELEMETRY_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(y.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,m){this.d[h]=m}m(){let h=(0,d.getTelemetryLevel)(this.k);const m=this.l.enabledTelemetryLevels;if(m){this.h=this.sendErrorTelemetry?m.error:!1;const I=m.usage?3:m.error?2:0;h=Math.min(h,I)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,m=h.sessionID,I=h["common.machineId"],S=h["common.firstSessionDate"],D=h["common.msftInternal"];return{sessionId:m,machineId:I,firstSessionDate:S,msftInternal:D}}dispose(){this.i.dispose()}n(h,m,I){return this.g<m?Promise.resolve(void 0):this.c.then(S=>{I=(0,M.mixin)(I,this.d),I=(0,d.cleanData)(I,this.j),I=(0,M.mixin)(I,S),this.b.forEach(D=>D.log(h,I))},S=>{console.error(S)})}publicLog(h,m){return this.n(h,3,m)}publicLog2(h,m){return this.publicLog(h,m)}publicLogError(h,m){return this.h?this.n(h,2,m):Promise.resolve(void 0)}publicLogError2(h,m){return this.publicLogError(h,m)}};w.IDLE_START_EVENT_NAME="UserIdleStart",w.IDLE_STOP_EVENT_NAME="UserIdleStop",w=ve([Q(1,k.IConfigurationService),Q(2,b.IProductService)],w),e.TelemetryService=w;function p(){const a=(0,C.localize)(0,null,f.default.nameLong),h=f.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=n.isWeb?"":(0,C.localize)(3,null),I=(0,C.localize)(4,null),S=(0,C.localize)(5,null),D=(0,C.localize)(6,null),t=(0,C.localize)(7,null),c=`
|       | ${I} | ${S} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,C.localize)(8,null);return`
${a} ${h} ${m}

&nbsp;

${t}
${c}

&nbsp;

${i}
`}v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,C.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(g.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,C.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,C.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[244],_([0,1,292,243]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class n extends M.AbstractOneDataSystemAppender{constructor(C,k,g,f){const b={sendPOST:(v,y)=>{const d={method:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data)}};try{const w=E.request(v.urlString,d,p=>{p.on("data",function(a){y(p.statusCode??200,p.headers,a.toString())}),p.on("error",function(a){y(0,{})})});w.write(v.data),w.end()}catch{y(0,{})}}};super(C,k,g,f,b)}}e.OneDataSystemAppender=n}),define(Z[245],_([0,1,4,84,24]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function R(C){let k=C.getItem(n.machineIdKey);return(typeof k!="string"||E.isMacintosh&&k==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(k=await(0,M.getMachineId)()),k}e.resolveMachineId=R}),define(Z[118],_([0,1,24,245]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function n(R){const C=await(0,M.resolveMachineId)(R);return R.setItem(E.machineIdKey,C),C}e.resolveMachineId=n}),define(Z[69],_([0,1,15,3,2,4,19,6,33]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const f="#FFFFFF",b="#1E1E1E",v="#000000",y="#FFFFFF",d="theme",w="themeBackground",p="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let a=class extends n.Disposable{constructor(m,I){super(),this.b=m,this.c=I,this.a=this.B(new M.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const m=this.getColorScheme();if(m.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return m.dark?v:y;let I=this.b.getItem(w,null);if(!I)switch(this.b.getItem(d,"vs-dark").split(" ")[0]){case"vs":I=f;break;case"hc-black":I=v;break;case"hc-light":I=y;break;default:I=b}return R.isMacintosh&&I.toUpperCase()===b&&(I="#171717"),I}saveWindowSplash(m,I){this.b.setItems([{key:d,data:I.baseTheme},{key:w,data:I.colorInfo.background},{key:p,data:I}]),typeof m=="number"&&this.f(m,I)}f(m,I){for(const S of E.BrowserWindow.getAllWindows())if(S.id===m){S.setBackgroundColor(I.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(p)}};a=ve([Q(0,g.IStateService),Q(1,C.IConfigurationService)],a),e.ThemeMainService=a}),define(Z[119],_([0,1,3,19,6,5]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,n.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,n.createDecorator)("sharedTunnelsService");var C;(function(p){p.Http="http",p.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var k;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(k=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var g;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(g=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function b(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=b,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=v;function y(p,a,h,m){if(h===1)return!1;if(h===2&&v(a)){const I=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(I?.length===4&&parseInt(I[1])>=18)return!1}return p<1024}e.isPortPrivileged=y;class d{constructor(a,h,m){this.remoteAddress=a,this.localAddress=h,this.b=m,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=d;let w=class{constructor(a,h){this.i=a,this.j=h,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],h=Array.from(this.d.values());for(const m of h){const I=Array.from(m.values());for(const S of I){const D=await S.value;D&&a.push(D)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:h}of a.values())await h.then(m=>m?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,h,m,I,S){this.o(a,h,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:h,localAddress:m,privacy:I,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,h){(v(a)||b(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const m=this.q(a,h);if(m)return++m.refcount,m.value}openTunnel(a,h,m,I,S,D=!1,t,c){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${m} on local port ${S}.`),!a)return;if(h||(h="localhost"),I||(I=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(a,h,m,I,S,D,t,c);return i?i.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(r);return(r.tunnelRemoteHost!==h||r.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const h=this.d.get(a.tunnelRemoteHost);if(h){const m=h.get(a.tunnelRemotePort);m&&(m.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,m))}}}}async n(a,h,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${h}.`);const I=m.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(h),I}}async closeTunnel(a,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${h} `);const m=this.d.get(a);if(m&&m.has(h)){const I=m.get(h);I.refcount=0,await this.n(a,h,I)}}o(a,h,m){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(h,{refcount:1,value:m})}async p(a,h){const m=this.d.get(a);m&&(await m.get(h)||m.delete(h),m.size===0&&this.d.delete(a))}q(a,h){const m=[a];b(a)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):v(a)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const I=m.map(S=>this.d.get(S));for(const S of I){const D=S?.get(h);if(D)return D}}canTunnel(a){return!!f(a)}s(a,h,m,I,S,D,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${m} on local port ${I}.`);const c=m;this.h.add(c);const i=I===void 0?m:I,r={elevationRequired:S?this.isPortPrivileged(i):!1},o={remoteAddress:{host:h,port:m},localAddressPort:I,privacy:D,public:D?D!==k.Private:void 0,protocol:t},u=a.forwardPort(o,r);return u?(this.o(h,m,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(c)})):this.h.delete(c),u}};w=ve([Q(0,R.ILogService),Q(1,M.IConfigurationService)],w),e.AbstractTunnelService=w}),define(Z[246],_([0,1,82,26,99,233,7,2,19,5,21,232,119,91,4]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(S,D,t,c,i){let r;for(let o=3;o&&(r?.dispose(),r=await new a(S,D,t,c,i).waitForReady(),!(i&&n.BROWSER_RESTRICTED_PORTS[i]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));o--);return r}class a extends k.Disposable{constructor(D,t,c,i,r){super(),this.j=t,this.k=r,this.privacy=y.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=E.createServer(),this.c=new C.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=c}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,t=(0,y.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let c=await(0,n.findFreePortFaster)(D,2,1e3,t),i=null;return this.b.listen(c,this.j),await this.c.wait(),i=this.b.address(),i||(c=0,this.b.listen(c,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const t=(0,y.isLocalhost)(this.tunnelRemoteHost)||(0,y.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,c=await(0,v.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=c.getSocket().socket,r=c.readEntireBuffer();c.dispose(),r.byteLength>0&&D.write(r.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let h=class extends y.AbstractTunnelService{constructor(D,t,c,i,r){super(t,r),this.t=D,this.u=c,this.v=i}isPortPrivileged(D){return(0,y.isPortPrivileged)(D,this.k,w.OS,M.release())}r(D,t,c,i,r,o,u,s){const l=this.q(t,c);if(l)return++l.refcount,l.value;if(this.e)return this.s(this.e,t,c,r,o,u,s);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${c} on local port ${r}.`);const P={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},A=p(P,i,t,c,r);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,c,A),A}}};h=ve([Q(1,f.ILogService),Q(2,d.ISignService),Q(3,b.IProductService),Q(4,g.IConfigurationService)],h),e.BaseTunnelService=h;let m=class extends h{constructor(D,t,c,i){super(R.nodeSocketFactory,D,t,c,i)}};m=ve([Q(0,f.ILogService),Q(1,d.ISignService),Q(2,b.IProductService),Q(3,g.IConfigurationService)],m),e.TunnelService=m;let I=class extends k.Disposable{constructor(D,t,c,i){super(),this.b=D,this.c=t,this.f=c,this.g=i,this.a=new Map}async openTunnel(D,t,c,i,r,o,u,s,l){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${c}:${i} on local port ${o}.`),!this.a.has(D)){const P=new m(this.b,this.f,this.c,this.g);this.B(P),this.a.set(D,P),P.onTunnelClosed(async()=>{(await P.tunnels).length===0&&(P.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(t,c,i,r,o,u,s,l)}};I=ve([Q(0,f.ILogService),Q(1,b.IProductService),Q(2,d.ISignService),Q(3,g.IConfigurationService)],I),e.SharedTunnelsService=I}),define(Z[48],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(M=e.StateType||(e.StateType={}));var n;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(n=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,C)=>({type:"idle",updateType:R,error:C}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(Z[247],_([0,1,4,179,68,50]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(n.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,M.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,M.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,M.localize)(2,null),(0,M.localize)(3,null),(0,M.localize)(4,null),(0,M.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,M.localize)(6,null),deprecationMessage:(0,M.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,M.localize)(8,null),description:(0,M.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,M.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[248],_([0,1,3,48]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class n{constructor(k){this.a=k}listen(k,g){switch(g){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${g}`)}call(k,g,f){switch(g){case"checkForUpdates":return this.a.checkForUpdates(f);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(f)}throw new Error(`Call not found: ${g}`)}}e.UpdateChannel=n;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=M.State.Uninitialized,this.c.listen("onStateChange")(g=>this.state=g),this.c.call("_getInitialState").then(g=>this.state=g)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=R}),define(Z[93],_([0,1,7,22,3,19,28,20,5,21,56,48]),function(x,e,E,M,n,R,C,k,g,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function y(w,p,a){return`${a.updateUrl}/api/update/${w}/${p}/${a.commit}`}e.createUpdateURL=y;let d=class{get state(){return this.b}d(p){this.j.info("update#setState",p.type),this.b=p,this.c.fire(p)}constructor(p,a,h,m,I,S){this.f=p,this.g=a,this.h=h,this.i=m,this.j=I,this.k=S,this.b=v.State.Uninitialized,this.c=new n.Emitter,this.onStateChange=this.c.event}async initialize(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.g.getValue("update.mode"),a=this.l(p);if(!a){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.r(a),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(v.State.Idle(this.p())),p==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.m(30*1e3).then(void 0,h=>this.j.error(h))}l(p){return p==="none"?void 0:this.k.quality}m(p=60*60*1e3){return(0,E.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.m(60*60*1e3))}async checkForUpdates(p){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.s(p)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.n(this.state)}async n(p){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.o()}async o(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.q())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},M.CancellationToken.None)).res.statusCode===204}catch(a){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(a);return}}async _applySpecificUpdate(p){}p(){return 1}q(){}};d=ve([Q(0,k.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,C.IEnvironmentMainService),Q(3,b.IRequestService),Q(4,g.ILogService),Q(5,f.IProductService)],d),e.AbstractUpdateService=d}),define(Z[249],_([0,1,15,54,3,2,19,28,20,5,21,56,24,48,93]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends w.AbstractUpdateService{get u(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"error",(h,m)=>m)}get v(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get w(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(h,m,I)=>({url:m,version:I,productVersion:I}))}get x(){return n.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(h,m,I,S)=>({releaseNotes:m,version:I,productVersion:I,date:S}))}constructor(h,m,I,S,D,t,c){super(h,m,S,D,t,c),this.y=I,this.t=new R.DisposableStore}async initialize(){await super.initialize(),this.u(this.z,this,this.t),this.w(this.C,this,this.t),this.x(this.D,this,this.t),this.v(this.E,this,this.t)}z(h){this.j.error("UpdateService error:",h);const I=(this.state.type==="checking for updates"?this.state.explicit:!0)?h:void 0;this.d(d.State.Idle(1,I))}r(h){let m;this.k.darwinUniversalAssetId?m=this.k.darwinUniversalAssetId:m=process.arch==="x64"?"darwin":"darwin-arm64";const I=(0,w.createUpdateURL)(m,h,this.k);try{E.autoUpdater.setFeedURL({url:I})}catch(S){this.j.error("Failed to set update feed URL",S);return}return I}s(h){this.d(d.State.CheckingForUpdates(h)),E.autoUpdater.checkForUpdates()}C(h){this.state.type==="checking for updates"&&this.d(d.State.Downloading(h))}D(h){this.state.type==="downloading"&&(this.y.publicLog2("update:downloaded",{version:h.version}),this.d(d.State.Ready(h)))}E(){this.state.type==="checking for updates"&&(this.y.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.State.Idle(1)))}q(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.t.dispose()}};ve([M.memoize],p.prototype,"u",null),ve([M.memoize],p.prototype,"v",null),ve([M.memoize],p.prototype,"w",null),ve([M.memoize],p.prototype,"x",null),p=ve([Q(0,g.ILifecycleMainService),Q(1,C.IConfigurationService),Q(2,y.ITelemetryService),Q(3,k.IEnvironmentMainService),Q(4,v.IRequestService),Q(5,f.ILogService),Q(6,b.IProductService)],p),e.DarwinUpdateService=p}),define(Z[250],_([0,1,46,41,7,3,9,28,20,5,24,48]),function(x,e,E,M,n,R,C,k,g,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let y=class{get state(){return this.a}d(p){this.g.info("update#setState",p.type),this.a=p,this.b.fire(p)}constructor(p,a,h){if(this.f=p,this.g=h,this.a=v.State.Uninitialized,this.b=new R.Emitter,this.onStateChange=this.b.event,a.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(v.State.Idle(this.k())),this.h(30*1e3).then(void 0,m=>this.g.error(m))}h(p=60*60*1e3){return(0,n.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(p){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(p)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(p){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(p=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(p){}};y=ve([Q(0,g.ILifecycleMainService),Q(1,k.IEnvironmentMainService),Q(2,f.ILogService)],y);let d=class extends y{constructor(p,a,h,m,I,S){super(h,m,I),this.o=p,this.p=a,this.q=S;const D=(0,M.watch)(C.dirname(this.o)),t=R.Event.fromNodeEventEmitter(D,"change",(o,u)=>u),c=R.Event.filter(t,o=>o==="current"),r=R.Event.debounce(c,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));h.onWillShutdown(()=>{r.dispose(),D.close()})}m(){this.d(v.State.CheckingForUpdates(!1)),this.u().then(p=>{p?this.d(v.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2)))},p=>{this.g.error(p),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(v.State.Idle(2,p.message||p))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+C.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const p=await new Promise((h,m)=>(0,M.realpath)(`${C.dirname(this.o)}/current`,(I,S)=>I?m(I):h(S))),a=C.basename(p);return this.p!==a}isLatestVersion(){return this.u().then(void 0,p=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};d=ve([Q(2,g.ILifecycleMainService),Q(3,k.IEnvironmentMainService),Q(4,f.ILogService),Q(5,b.ITelemetryService)],d),e.SnapUpdateService=d}),define(Z[39],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(Z[251],_([0,1,39,200,16,18,132,3,2]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class f{constructor(y){this.uri=y,this.time=f._clock++}touch(){return this.time=f._clock++,this}}f._clock=0;let b=class{constructor(y){this.g=y,this.c=new g.DisposableStore,this.f=2**16;const d=new Map,w=p=>{let a=d.get(p.scheme);return a===void 0&&(a=y.hasProvider(p)&&!this.g.hasCapability(p,1024),d.set(p.scheme,a)),a};this.c.add(k.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(p=>{d.delete(p.scheme)})),this.extUri=new R.ExtUri(w),this.d=new C.SkipList((p,a)=>this.extUri.compare(p,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,R.normalizePath)(y));const d=this.d.get(y);return d?d.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new f(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((w,p)=>w[1].touch<p[1].touch?1:w[1].touch>p[1].touch?-1:0);f._clock=0,this.d.clear();const d=this.f*.5;for(let w=0;w<d;w++)this.d.set(y[w][0],y[w][1].touch())}};b=ve([Q(0,n.IFileService)],b),e.UriIdentityService=b,(0,M.registerSingleton)(E.IUriIdentityService,b,1)}),define(Z[120],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(Z[252],_([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(k){this.a=k}listen(k,g){throw new Error(`Event not found: ${g}`)}call(k,g,f){switch(g){case"handleURL":return this.a.handleURL(E.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${g}`)}}e.URLHandlerChannel=M;class n{constructor(k){this.a=k}handleURL(k,g){return this.a.call("handleURL",[k.toJSON(),g])}}e.URLHandlerChannelClient=n;class R{constructor(k,g){this.a=k,this.b=g}async routeCall(k,g,f,b){if(g!=="handleURL")throw new Error(`Call not found: ${g}`);if(Array.isArray(f)&&f.length>0){const v=E.URI.revive(f[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",v.toString(!0)),v.query){const y=/\bwindowId=(\d+)/.exec(v.query);if(y){const d=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${d}"`,v.toString(!0));const w=new RegExp(`window:${d}`),p=k.connections.find(a=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",a.ctx),w.test(a.ctx)));if(p)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",v.toString(!0)),p;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",v.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",v.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,g,f,b)}routeEvent(k,g){throw new Error(`Event not found: ${g}`)}}e.URLHandlerRouter=R}),define(Z[253],_([0,1,7,2,8,21]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class C extends M.Disposable{constructor(){super(...arguments),this.a=new Set}open(f,b){const v=[...this.a.values()];return(0,E.first)(v.map(y=>()=>y.handleURL(f,b)),void 0,!1).then(y=>y||!1)}registerHandler(f){return this.a.add(f),(0,M.toDisposable)(()=>this.a.delete(f))}}e.AbstractURLService=C;let k=class extends C{constructor(f){super(),this.b=f}create(f){let{authority:b,path:v,query:y,fragment:d}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return b&&v&&v.indexOf("/")!==0&&(v=`/${v}`),n.URI.from({scheme:this.b.urlProtocol,authority:b,path:v,query:y,fragment:d})}};k=ve([Q(0,R.IProductService)],k),e.NativeURLService=k}),define(Z[254],_([0,1,15,7,3,2,4,8]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class g{constructor(b,v,y,d,w,p){if(this.f=v,this.g=p,this.a=[],this.b=0,this.c=R.Disposable.None,this.d=new R.DisposableStore,b&&(p.trace("ElectronURLListener initialUrisToHandle:",b.map(m=>m.originalUrl)),this.a=b),C.isWindows){const m=d.isBuilt?[]:[`"${d.appRoot}"`];m.push("--open-url","--"),E.app.setAsDefaultProtocolClient(w.urlProtocol,process.execPath,m)}const a=n.Event.map(n.Event.fromNodeEventEmitter(E.app,"open-url",(m,I)=>({event:m,url:I})),({event:m,url:I})=>(m.preventDefault(),I));this.d.add(a(m=>{const I=this.h(m);!I||this.f.open(I,{originalUrl:m})})),y.getWindows().filter(m=>m.isReady).length>0?(p.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(p.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),n.Event.once(y.onDidSignalReadyWindow)(this.i,this,this.d))}h(b){try{return k.URI.parse(b)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const b=[];for(const v of this.a)await this.f.open(v.uri,{originalUrl:v.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",v.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",v.originalUrl),b.push(v));b.length!==0&&(this.a=b,this.c=(0,M.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=g}),define(Z[255],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(Z[256],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(Z[257],_([0,1,15,2,14,8]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class C extends M.Disposable{constructor(){super();const g=this.b.bind(this);E.protocol.registerFileProtocol(n.Schemas.vscodeWebview,g)}b(g,f){try{const b=R.URI.parse(g.url),v=C.a.get(b.path);if(typeof v=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${v}`,d=n.FileAccess.asFileUri(y);return f({path:decodeURIComponent(d.fsPath),headers:{...n.COI.getHeadersFromQuery(g.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return f({error:-10})}catch{}return f({error:-2})}}C.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]]),e.WebviewProtocolProvider=C}),define(Z[77],_([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(b){return!!b.workspaceUri}e.isWorkspaceToOpen=M;function n(b){return!!b.folderUri}e.isFolderToOpen=n;function R(b){return!!b.fileUri}e.isFileToOpen=R;function C(b){const v=k(b),y=b.getValue("window.menuBarVisibility");return y==="default"||v==="native"&&y==="compact"||E.isMacintosh&&E.isNative?"classic":y}e.getMenuBarVisibility=C;function k(b){if(E.isWeb)return"custom";const v=b.getValue("window");if(v){if(E.isMacintosh&&v.nativeTabs===!0||E.isMacintosh&&v.nativeFullScreen===!1)return"native";const w=v.titleBarStyle;if(w==="native"||w==="custom")return w}return E.isLinux?"native":"custom"}e.getTitleBarStyle=k;function g(b){if(!E.isWindows||E.isWeb||k(b)==="native")return!1;const v=b.getValue("window.experimental.windowControlsOverlay.enabled");return typeof v=="boolean"?v:!0}e.useWindowControlsOverlay=g;function f(b=0){return Math.pow(1.2,b)}e.zoomLevelToZoomFactor=f}),define(Z[121],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var M;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(M=e.UnloadReason||(e.UnloadReason={}));const n=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=n;var R;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var C;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(C=e.WindowError||(e.WindowError={}))}),define(Z[30],_([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var M;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}))}),define(Z[258],_([0,1,15,22,3,60,2,31,75,108,5,21,30]),function(x,e,E,M,n,R,C,k,g,f,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var d;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(d||(d={}));let w=class extends C.Disposable{constructor(a,h,m,I,S){super(),this.g=a,this.h=h,this.i=m,this.j=I,this.k=S,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=d.Initial,this.f=void 0,this.l()}l(){const a=n.Event.fromNodeEventEmitter(E.app,"login",(h,m,I,S,D)=>({event:h,webContents:m,req:I,authInfo:S,callback:D}));this.B(a(this.m,this))}async m({event:a,authInfo:h,req:m,callback:I}){if(!h.isProxy)return;if(!this.b&&this.c===d.LoginDialogShown&&m.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}a.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(h);try{S=await this.b}finally{this.b=void 0}}I(S?.username,S?.password)}async n(a){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const h=await this.p(a);if(h)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),h;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(a){this.g.trace("auth#doResolveProxyCredentials - enter",a);const h=String((0,R.hash)({scheme:a.scheme,host:a.host,port:a.port}));let m,I;try{const c=await this.i.getPassword(this.a,h);if(c){const i=JSON.parse(await this.j.decrypt(c));m=i.username,I=i.password}}catch(c){this.g.error(c)}if(this.c!==d.StoredCredentialsUsed&&typeof m=="string"&&typeof I=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=d.StoredCredentialsUsed,{username:m,password:I};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const D={authInfo:a,username:this.f?.username??m,password:this.f?.password??I,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,D),this.c=d.LoginDialogShown;const t=await new Promise(c=>{const i=async(r,o,u)=>{if(o===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",i),u){const s={username:u.username,password:u.password};try{if(u.remember){const l=await this.j.encrypt(JSON.stringify(s));await this.i.setPassword(this.a,h,l)}else await this.i.deletePassword(this.a,h)}catch(l){this.g.error(l)}c({username:s.username,password:s.password})}else c(void 0)};S.win?.webContents.on("ipc-message",i)});return this.f=t,t}};w=ve([Q(0,b.ILogService),Q(1,y.IWindowsMainService),Q(2,g.ICredentialsMainService),Q(3,f.IEncryptionMainService),Q(4,v.IProductService)],w),e.ProxyAuthHandler=w}),define(Z[259],_([0,1,75,5,34,21,30,211]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let g=class extends k.BaseCredentialsMainService{constructor(b,v,y,d){super(b),this.j=v,this.k=y,this.l=d,this.i=w=>{this.l.sendToFocused("vscode:showCredentialsError",w.message??w)}}async getSecretStoragePrefix(){return Promise.resolve(this.k.urlProtocol)}async h(){if(this.f)return this.f;if(this.j.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const b=await new Promise((v,y)=>{x(["keytar"],v,y)});return await b.findCredentials("test-keytar-loads"),this.f=b,this.f}};g=ve([Q(0,M.ILogService),Q(1,n.INativeEnvironmentService),Q(2,R.IProductService),Q(3,C.IWindowsMainService)],g),e.CredentialsNativeMainService=g}),define(Z[260],_([0,1,15,25,4,8,23,19,62,6,5,120,30]),function(x,e,E,M,n,R,C,k,g,f,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,f.createDecorator)(e.ID);let d=class{constructor(p,a,h,m){this.a=p,this.b=a,this.c=h,this.d=m}async start(p,a){this.a.trace("Received data from other instance: ",p,a),n.isMacintosh&&E.app.focus({steal:!0});const h=this.e(p);if(h.length){let m=Promise.resolve();if(this.b.getWindowCount()===0){const I=(0,M.firstOrDefault)(await this.b.openEmptyWindow({context:4}));I&&(m=I.ready())}m.then(()=>{for(const{uri:I,originalUrl:S}of h)this.c.open(I,{originalUrl:S})})}else return this.f(p,a)}e(p){return p["open-url"]&&p._urls&&p._urls.length>0?(0,M.coalesce)(p._urls.map(a=>{try{return{uri:R.URI.parse(a),originalUrl:a}}catch{return null}})):[]}async f(p,a){const h=(0,g.isLaunchedFromCli)(a)?0:4;let m=[];const I=p.wait&&p.waitMarkerFilePath?R.URI.file(p.waitMarkerFilePath):void 0,S=p.remote||void 0,D={context:h,cli:p,userEnv:a,waitMarkerFileURI:I,remoteAuthority:S,forceProfile:p.profile,forceTempProfile:p["profile-temp"]};if(p.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(p.extensionDevelopmentPath,D);else if(!p._.length&&!p["folder-uri"]&&!p["file-uri"]){let t=!1;if(p["new-window"]||p["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(p["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!n.isMacintosh}if(t)m=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const c=this.b.getLastActiveWindow();c?(this.b.openExistingWindow(c,D),m=[c]):m=await this.b.open({...D,forceEmpty:!0})}}else m=await this.b.open({...D,forceNewWindow:p["new-window"],preferNewWindow:!p["reuse-window"]&&!p.wait,forceReuseWindow:p["reuse-window"],diffMode:p.diff,mergeMode:p.merge,addMode:p.add,noRecentEntry:!!p["skip-add-to-recently-opened"],gotoLineMode:p.goto});if(I&&m.length===1&&m[0])return Promise.race([m[0].whenClosedOrLoaded,(0,C.whenDeleted)(I.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};d=ve([Q(0,b.ILogService),Q(1,y.IWindowsMainService),Q(2,v.IURLService),Q(3,k.IConfigurationService)],d),e.LaunchMainService=d}),define(Z[122],_([0,1,15,2,3,5,261,7,14,100,30,73,24,20]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcess=void 0;let w=class It extends M.Disposable{constructor(a,h,m,I){super(),this.m=a,this.n=h,this.p=m,this.r=I,this.b=String(++It.a),this.c=this.B(new n.Emitter),this.onStdout=this.c.event,this.f=this.B(new n.Emitter),this.onStderr=this.f.event,this.g=this.B(new n.Emitter),this.onMessage=this.g.event,this.h=this.B(new n.Emitter),this.onExit=this.h.event,this.i=this.B(new n.Emitter),this.onCrash=this.i.event,this.j=void 0,this.k=void 0,this.l=void 0}s(a,h){let m;switch(this.l?.correlationId?m=`[UtilityProcess id: ${this.l?.correlationId}, type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${a}`:m=`[UtilityProcess type: ${this.l?.type}, pid: ${this.k??"<none>"}]: ${a}`,h){case v.default.Error:this.m.error(m);break;case v.default.Warning:this.m.warn(m);break;case v.default.Info:this.m.info(m);break}}t(a){if(!f.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess API from Electron!");if(this.j){this.s("Cannot start utility process because it is already running...",v.default.Error);return}const h=this.n.getWindowById(a.responseWindowId);if(!h?.win||h.win.isDestroyed()||h.win.webContents.isDestroyed()){this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",v.default.Error);return}return h}start(a){const h=this.t(a);if(!h?.win)return!1;this.l=a;const m=`${this.l.type}-${this.b}`,I=g.FileAccess.asFileUri("bootstrap-fork.js").fsPath,S=this.l.args??[],D=[...this.l.execArgv??[],`--vscode-utility-kind=${this.l.type}`],t=this.l.allowLoadingUnsignedLibraries,c="pipe";let i=this.l.env;if(i){i={...i};for(const r of Object.keys(i))i[r]=String(i[r])}return this.s("creating new...",v.default.Info),this.j=f.UtilityProcess.fork(I,S,{serviceName:m,env:i,execArgv:D,allowLoadingUnsignedLibraries:t,stdio:c}),this.u(h.win,this.j,this.l,m,h.isSandboxed),this.v(this.j,this.l,h.win),!0}u(a,h,m,I,S){if(m.windowLifecycleBound&&(this.B(n.Event.filter(this.r.onWillLoadWindow,D=>D.window.win===a)(()=>this.kill())),this.B(n.Event.fromNodeEventEmitter(a,"closed")(()=>this.kill()))),h.stdout){const D=new C.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(h.stdout,"data")(t=>this.c.fire(typeof t=="string"?t:D.write(t))))}if(h.stderr){const D=new C.StringDecoder("utf-8");this.B(n.Event.fromNodeEventEmitter(h.stderr,"data")(t=>this.f.fire(typeof t=="string"?t:D.write(t))))}this.B(n.Event.fromNodeEventEmitter(h,"message")(D=>this.g.fire(D))),this.B(n.Event.fromNodeEventEmitter(h,"spawn")(()=>{this.k=h.pid,this.s("successfully created",v.default.Info)})),this.B(n.Event.fromNodeEventEmitter(h,"exit")(D=>{this.s(`received exit event with code ${D}`,v.default.Info),this.h.fire({pid:this.k,code:D,signal:"unknown"}),this.w()})),this.B(n.Event.fromNodeEventEmitter(E.app,"child-process-gone",(D,t)=>({event:D,details:t}))(({details:D})=>{D.type==="Utility"&&D.name===I&&(this.s(`crashed with code ${D.exitCode} and reason '${D.reason}'`,v.default.Error),this.p.publicLog2("utilityprocesscrash",{type:m.type,reason:D.reason,code:D.exitCode,sandboxed:S?"1":"0"}),this.i.fire({pid:this.k,code:D.exitCode,reason:D.reason}),this.w())}))}v(a,h,m){const{port1:I,port2:S}=new E.MessageChannelMain;a.postMessage("null",[S]),m.webContents.postMessage(h.responseChannel,h.responseNonce,[I])}enableInspectPort(){if(!this.j||typeof this.k!="number")return!1;this.s("enabling inspect port",v.default.Info);const a=process;return typeof a._debugProcess=="function"?(a._debugProcess(this.k),!0):!1}kill(){if(!this.j)return;this.s("attempting to kill the process...",v.default.Info),this.j.kill()?(this.s("successfully killed the process",v.default.Info),this.w()):this.s("unable to kill the process",v.default.Warning)}w(){this.j=void 0}async waitForExit(a){if(!this.j){this.s("no running process to wait for exit",v.default.Warning);return}this.s("waiting to exit...",v.default.Info),await Promise.race([n.Event.toPromise(this.onExit),(0,k.timeout)(a)]),this.j&&(this.s("did not exit within ${maxWaitTimeMs}ms, will kill it now...",v.default.Info),this.kill())}};w.a=0,w=ve([Q(0,R.ILogService),Q(1,b.IWindowsMainService),Q(2,y.ITelemetryService),Q(3,d.ILifecycleMainService)],w),e.UtilityProcess=w}),define(Z[262],_([0,1,13,2,3,5,20,72,46,261,7,14,37,4,36,100,122,30,24]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let I=class Pt{constructor(t,c,i,r){this.d=t,this.f=c,this.g=i,this.h=r,this.c=!1,this.b=new Map,this.f.onWillShutdown(o=>{this.c=!0,o.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(t){const c=this.b.get(t);if(!c)throw new Error("Unknown extension host!");return c}onDynamicStdout(t){return this.i(t).onStdout}onDynamicStderr(t){return this.i(t).onStderr}onDynamicMessage(t){return this.i(t).onMessage}onDynamicError(t){const c=this.i(t);return c instanceof a.UtilityProcess?n.Event.None:c.onError}onDynamicExit(t){return this.i(t).onExit}async canUseUtilityProcess(){return p.canUseUtilityProcess}async createExtensionHost(t){if(this.c)throw(0,E.canceled)();const c=String(++Pt.a);let i;if(t){if(!p.canUseUtilityProcess)throw new Error("Cannot use UtilityProcess!");i=new a.UtilityProcess(this.d,this.g,this.h,this.f)}else i=new S(c,this.d);return this.b.set(c,i),i.onExit(({pid:r,code:o,signal:u})=>{this.d.info(`Extension host with pid ${r} exited with code: ${o}, signal: ${u}.`),setTimeout(()=>{i.dispose(),this.b.delete(c)})}),{id:c}}async start(t,c){if(this.c)throw(0,E.canceled)();this.i(t).start({...c,type:"extensionHost",args:["--skipWorkspaceStorageLock"],execArgv:c.execArgv,allowLoadingUnsignedLibraries:!0,correlationId:t})}async enableInspectPort(t){if(this.c)throw(0,E.canceled)();const c=this.b.get(t);return c?c.enableInspectPort():!1}async kill(t){if(this.c)throw(0,E.canceled)();const c=this.b.get(t);!c||c.kill()}async _killAllNow(){for(const[,t]of this.b)t.kill()}async _waitForAllExit(t){const c=[];for(const[,i]of this.b)c.push(i.waitForExit(t));return b.Promises.settled(c).then(()=>{})}};I.a=0,I=ve([Q(0,R.ILogService),Q(1,C.ILifecycleMainService),Q(2,h.IWindowsMainService),Q(3,m.ITelemetryService)],I),e.ExtensionHostStarter=I;let S=class extends M.Disposable{constructor(t,c){super(),this.id=t,this.c=c,this._onStdout=this.B(new n.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this.B(new n.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this.B(new n.Emitter),this.onMessage=this._onMessage.event,this._onError=this.B(new n.Emitter),this.onError=this._onError.event,this._onExit=this.B(new n.Emitter),this.onExit=this._onExit.event,this.a=null,this.b=!1}start(t){d.isCI&&this.c.info("Calling fork to start extension host...");const c=k.StopWatch.create(!1);this.a=(0,g.fork)(v.FileAccess.asFileUri("bootstrap-fork").fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,y.mixin)({cwd:(0,w.cwd)()},t));const i=c.elapsed(),r=this.a.pid;this.c.info(`Starting extension host with pid ${r} (fork() took ${i} ms).`);const o=new f.StringDecoder("utf-8");this.a.stdout?.on("data",s=>{const l=typeof s=="string"?s:o.write(s);this._onStdout.fire(l)});const u=new f.StringDecoder("utf-8");this.a.stderr?.on("data",s=>{const l=typeof s=="string"?s:u.write(s);this._onStderr.fire(l)}),this.a.on("message",s=>{this._onMessage.fire(s)}),this.a.on("error",s=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(s)})}),this.a.on("exit",(s,l)=>{this.b=!0,this._onExit.fire({pid:r,code:s,signal:l})})}enableInspectPort(){return this.a?(this.c.info(`Enabling inspect port on extension host with pid ${this.a.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this.a.pid),!0):d.isWindows?!1:(this.a.kill("SIGUSR1"),!0)):!1}kill(){!this.a||(this.c.info(`Killing extension host with pid ${this.a.pid}.`),this.a.kill())}async waitForExit(t){if(!this.a)return;const c=this.a.pid;this.c.info(`Waiting for extension host with pid ${c} to exit.`),await Promise.race([n.Event.toPromise(this.onExit),(0,b.timeout)(t)]),this.b||(this.c.info(`Extension host with pid ${c} did not exit within ${t}ms.`),this.a.kill())}};S=ve([Q(1,R.ILogService)],S)}),define(Z[263],_([0,1,2,6,5,30,122,24,37,71,60,3,7,20]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,M.createDecorator)("utilityProcessWorker");let w=class extends E.Disposable{constructor(h,m,I,S){super(),this.b=h,this.c=m,this.f=I,this.g=S,this.a=new Map}async createWorker(h){const m=`window: ${h.reply.windowId}, moduleId: ${h.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${m})`);const I=this.h(h);this.a.has(I)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${m})`),this.disposeWorker(h));const S=new p(this.b,this.c,this.f,this.g,h);if(!S.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(I,S);const D=new y.DeferredPromise;return v.Event.once(S.onDidTerminate)(t=>{this.a.delete(I),D.complete({reason:t})}),D.p}h(h){return(0,b.hash)({moduleId:h.process.moduleId,windowId:h.reply.windowId})}async disposeWorker(h){const m=this.h(h),I=this.a.get(m);!I||(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${h.reply.windowId}, moduleId: ${h.process.moduleId})`),I.kill(),this.a.delete(m))}};w=ve([Q(0,n.ILogService),Q(1,R.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,d.ILifecycleMainService)],w),e.UtilityProcessWorkerMainService=w;let p=class extends E.Disposable{constructor(h,m,I,S,D){super(),this.c=h,this.f=m,this.g=I,this.h=S,this.i=D,this.a=this.B(new v.Emitter),this.onDidTerminate=this.a.event,this.b=new C.UtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(h=>this.a.fire({code:h.code,signal:h.signal}))),this.B(this.b.onCrash(h=>this.a.fire({code:h.code,signal:"ECRASH"})))}spawn(){return this.b.start({windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce,type:this.i.process.type,env:this.k()})}k(){const h={...(0,g.deepClone)(process.env),VSCODE_AMD_ENTRYPOINT:this.i.process.moduleId,VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_PARENT_PID:String(process.pid)};return(0,f.removeDangerousEnvVariables)(h),h}kill(){this.b.kill()}};p=ve([Q(0,n.ILogService),Q(1,R.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,d.ILifecycleMainService)],p)}),define(Z[264],_([0,1,15,3,2,257,30]),function(x,e,E,M,n,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=class extends n.Disposable{constructor(f){super(),this.b=f,this.a=this.B(new M.Emitter),this.onFoundInFrame=this.a.event,this.B(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,b){let v;if(typeof f.windowId=="number"){const{windowId:y}=f,d=this.b.getWindowById(y);if(!d?.win)throw new Error(`Invalid windowId: ${y}`);v=d.win.webContents}else{const{webContentsId:y}=f;if(v=E.webContents.fromId(y),!v)throw new Error(`Invalid webContentsId: ${y}`)}v.isDestroyed()||v.setIgnoreMenuShortcuts(b)}async findInFrame(f,b,v,y){const w=this.c(f,b);if(typeof w.findInFrame=="function"){w.findInFrame(v,{findNext:y.findNext,forward:y.forward});const p=(a,h)=>{h.finalUpdate&&(this.a.fire(h),w.removeListener("found-in-frame",p))};w.on("found-in-frame",p)}}async stopFindInFrame(f,b,v){const d=this.c(f,b);typeof d.stopFindInFrame=="function"&&d.stopFindInFrame(v.keepSelection?"keepSelection":"clearSelection")}c(f,b){const v=this.b.getWindowById(f.windowId);if(!v?.win)throw new Error(`Invalid windowId: ${f}`);const y=v.win.webContents.mainFrame.framesInSubtree.find(d=>d.name===b);if(!y)throw new Error(`Unknown frame: ${b}`);return y}};k=ve([Q(0,C.IWindowsMainService)],k),e.WebviewMainService=k}),define(Z[265],_([0,1,7,3,2]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends n.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:g,getActiveWindowId:f}){super(),this.a=this.B(new n.DisposableStore),M.Event.latch(M.Event.any(k,g))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>f()),(async()=>{try{const v=await this.b;this.c=typeof this.c=="number"?this.c:v}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=R}),define(Z[29],_([0,1,183,9,61,18,8,6,14]),function(x,e,E,M,n,R,C,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function f(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.uri)}e.isSingleFolderWorkspaceIdentifier=f;function b(i){return typeof i?.id=="string"&&!f(i)&&!y(i)}e.isEmptyWorkspaceIdentifier=b,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function v(i,r){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,M.basename)(i)}:r?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=v;function y(i){const r=i;return typeof r?.id=="string"&&C.URI.isUri(r.configPath)}e.isWorkspaceIdentifier=y;function d(i){const r=i;if(r?.uri)return{id:r.id,uri:C.URI.revive(r.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var w;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(w=e.WorkbenchState||(e.WorkbenchState={}));function p(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}e.isWorkspace=p;function a(i){const r=i;return!!(r&&typeof r=="object"&&C.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}e.isWorkspaceFolder=a;class h{constructor(r,o,u,s,l){this.h=r,this.j=u,this.k=s,this.l=l,this.c=n.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=n.TernarySearchTree.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class m{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,R.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function I(i){return new m({uri:i,index:0,name:(0,R.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=I,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,r){return R.extUriBiasedIgnorePathCase.isEqualOrParent(i,r.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function D(i){let r;return C.URI.isUri(i)?r=i:r=i.configuration,r?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=D;function t(i,r){return!S(i,r)&&!D(i)}e.isSavedWorkspace=t;function c(i){return(typeof i=="string"?(0,M.extname)(i):(0,R.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=c}),define(Z[57],_([0,1,15,7,60,45,2,80,4,10,23,160,88,6,5,21,29]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,d.createDecorator)("dialogMainService");let h=class{constructor(I,S){this.d=I,this.e=S,this.a=new Map,this.b=new Map,this.c=new M.Queue}pickFileFolder(I,S){return this.f({...I,pickFolders:!0,pickFiles:!0,title:(0,v.localize)(0,null)},S)}pickFolder(I,S){return this.f({...I,pickFolders:!0,title:(0,v.localize)(1,null)},S)}pickFile(I,S){return this.f({...I,pickFiles:!0,title:(0,v.localize)(2,null)},S)}pickWorkspace(I,S){const D=(0,v.localize)(3,null),t=(0,R.mnemonicButtonLabel)((0,v.localize)(4,null)),c=a.WORKSPACE_FILTER;return this.f({...I,pickFiles:!0,title:D,filters:c,buttonLabel:t},S)}async f(I,S){const D={title:I.title,buttonLabel:I.buttonLabel,filters:I.filters,defaultPath:I.defaultPath};(typeof I.pickFiles=="boolean"||typeof I.pickFolders=="boolean")&&(D.properties=void 0,I.pickFiles&&I.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",I.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,f.withNullAsUndefined)(S||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(I){if(I){let S=this.b.get(I.id);return S||(S=new M.Queue,this.b.set(I.id,S)),S}else return this.c}showMessageBox(I,S){return this.g(S).queue(async()=>{const{options:D,buttonIndeces:t}=(0,y.massageMessageBoxOptions)(I,this.e);let c;return S?c=await E.dialog.showMessageBox(S,D):c=await E.dialog.showMessageBox(D),{response:t[c.response],checkboxChecked:c.checkboxChecked}})}async showSaveDialog(I,S){const D=this.j(I,S);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(S).queue(async()=>{let t;return S?t=await E.dialog.showSaveDialog(S,I):t=await E.dialog.showSaveDialog(I),t.filePath=this.h(t.filePath),t})}finally{(0,C.dispose)(D)}}h(I){return I&&g.isMacintosh&&(I=(0,k.normalizeNFC)(I)),I}i(I){return I.map(S=>this.h(S))}async showOpenDialog(I,S){I.defaultPath&&(await b.Promises.exists(I.defaultPath)||(I.defaultPath=void 0));const D=this.j(I,S);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(S).queue(async()=>{let t;return S?t=await E.dialog.showOpenDialog(S,I):t=await E.dialog.showOpenDialog(I),t.filePaths=this.i(t.filePaths),t})}finally{(0,C.dispose)(D)}}j(I,S){if(!S)return C.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",I);let D=this.a.get(S.id);D||(D=new Set,this.a.set(S.id,D));const t=(0,n.hash)(I);if(!D.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",I),D.add(t),(0,C.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",I),D?.delete(t),D?.size===0&&this.a.delete(S.id)})}};h=ve([Q(0,w.ILogService),Q(1,p.IProductService)],h),e.DialogMainService=h}),define(Z[266],_([0,1,3,2,83,29]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class C extends M.Disposable{constructor(g,f){super(),this.f=g,this.g=f,this.b=this.B(new E.Emitter),this.c=new Map,this.h(f.applicationStorage,this.b)}h(g,f){this.B(E.Event.debounce(g.onDidChangeStorage,(b,v)=>(b?b.push(v):b=[v],b),C.a)(b=>{b.length&&f.fire(this.i(b,g))}))}i(g,f){const b=new Map,v=new Set;return g.forEach(y=>{const d=f.get(y.key);typeof d=="string"?b.set(y.key,d):v.add(y.key)}),{changed:Array.from(b.entries()),deleted:Array.from(v.values())}}listen(g,f,b){switch(f){case"onDidChangeStorage":{const v=b.profile?(0,n.revive)(b.profile):void 0;if(!v)return this.b.event;let y=this.c.get(v.id);return y||(y=this.B(new E.Emitter),this.h(this.g.profileStorage(v),y),this.c.set(v.id,y)),y.event}}throw new Error(`Event not found: ${f}`)}async call(g,f,b){const v=b.profile?(0,n.revive)(b.profile):void 0,y=(0,R.reviveIdentifier)(b.workspace),d=await this.j(v,y);switch(f){case"getItems":return Array.from(d.items.entries());case"updateItems":{const w=b;if(w.insert)for(const[p,a]of w.insert)d.set(p,a);w.delete?.forEach(p=>d.delete(p));break}case"isUsed":{const w=b.payload;if(typeof w=="string")return this.g.isUsed(w)}default:throw new Error(`Call not found: ${f}`)}}async j(g,f){let b;f?b=this.g.workspaceStorage(f):g?b=this.g.profileStorage(g):b=this.g.applicationStorage;try{await b.init()}catch(v){this.f.error(`StorageIPC#init: Unable to init ${f?"workspace":g?"profile":"application"} storage due to ${v}`)}return b}}C.a=100,e.StorageDatabaseChannel=C}),define(Z[40],_([0,1,60,3,2,18,8,180,34,16,6,5,29,35,39,7,31,27,10]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function I(i){const r=i;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&C.URI.isUri(r.location)&&C.URI.isUri(r.globalStorageHome)&&C.URI.isUri(r.settingsResource)&&C.URI.isUri(r.keybindingsResource)&&C.URI.isUri(r.tasksResource)&&C.URI.isUri(r.snippetsHome)&&C.URI.isUri(r.extensionsResource))}e.isUserDataProfile=I,e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function S(i,r){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:C.URI.revive(i.location).with({scheme:r}),globalStorageHome:C.URI.revive(i.globalStorageHome).with({scheme:r}),settingsResource:C.URI.revive(i.settingsResource).with({scheme:r}),keybindingsResource:C.URI.revive(i.keybindingsResource).with({scheme:r}),tasksResource:C.URI.revive(i.tasksResource).with({scheme:r}),snippetsHome:C.URI.revive(i.snippetsHome).with({scheme:r}),extensionsResource:C.URI.revive(i.extensionsResource)?.with({scheme:r}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=S;function D(i,r,o,u){return{id:i,name:r,location:o,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,R.joinPath)(o,"globalStorage"),settingsResource:(0,R.joinPath)(o,"settings.json"),keybindingsResource:(0,R.joinPath)(o,"keybindings.json"),tasksResource:(0,R.joinPath)(o,"tasks.json"),snippetsHome:(0,R.joinPath)(o,"snippets"),extensionsResource:(0,R.joinPath)(o,"extensions.json"),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=D;let t=class extends n.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(r,o,u,s){super(),this.m=r,this.n=o,this.r=u,this.s=s,this.f=!0,this.g=this.B(new M.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new M.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new M.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new M.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,R.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(r){this.f!==r&&(this.t=void 0,this.f=r)}isEnabled(){return this.f}get u(){if(!this.t){const r=[];if(this.f)try{for(const l of this.I()){if(!l.name||!(0,m.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}r.push(D((0,R.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}}catch(l){this.s.error(l)}const o=new d.ResourceMap,u=new Map,s=this.v();if(r.unshift({...s,extensionsResource:this.N()??s.extensionsResource,isDefault:!0}),r.length)try{const l=this.L();if(l.workspaces)for(const[P,A]of Object.entries(l.workspaces)){const O=C.URI.parse(P),N=r.find(z=>z.id===A);N&&o.set(O,N)}if(l.emptyWindows)for(const[P,A]of Object.entries(l.emptyWindows)){const O=r.find(N=>N.id===A);O&&u.set(P,O)}}catch(l){this.s.error(l)}this.t={profiles:r,workspaces:o,emptyWindows:u}}return this.t}v(){return D("__default__profile__",(0,k.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(r){const o="Temp",u=new RegExp(`${(0,h.escapeRegExpCharacters)(o)}\\s(\\d+)`);let s=0;for(const P of this.profiles){const A=u.exec(P.name),O=A?parseInt(A[1]):0;s=O>s?O:s}const l=`${o} ${s+1}`;return this.createProfile((0,E.hash)((0,a.generateUuid)()).toString(16),l,{transient:!0},r)}async createNamedProfile(r,o,u){return this.createProfile((0,E.hash)((0,a.generateUuid)()).toString(16),r,o,u)}async createProfile(r,o,u,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.w(r,o,u);return s&&await this.setProfileForWorkspace(s,l),l}async w(r,o,u){if(!(0,m.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let s=this.k.get(o);return s||(s=(async()=>{try{const l=this.profiles.find(O=>O.name===o||O.id===r);if(l)return l;const P=D(r,o,(0,R.joinPath)(this.profilesHome,r),u);await this.n.createFolder(P.location);const A=[];return this.h.fire({profile:P,join(O){A.push(O)}}),await p.Promises.settled(A),this.C([P],[],[]),P}finally{this.k.delete(o)}})(),this.k.set(o,s)),s}async updateProfile(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(s=>s.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);return u=D(u.id,o.name??u.name,u.location,{shortName:o.shortName??u.shortName,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags}),this.C([],[],[u]),u}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(s=>s.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const u=[];this.i.fire({profile:o,join(s){u.push(s)}});try{await Promise.allSettled(u)}catch(s){this.s.error(s)}for(const s of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(s)?.id&&this.u.emptyWindows.delete(s);for(const s of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(s)?.id&&this.u.workspaces.delete(s);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(s){this.s.error(s)}}async setProfileForWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(s=>s.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.F(r,u)}unsetWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(r,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const r=await this.n.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.r.extUri.isEqual(u.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.y(r);return C.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}y(r){return(0,y.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,y.isWorkspaceIdentifier)(r)?r.configPath:r.id}z(r){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,r.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,r.location)))}C(r,o,u){const s=[...this.profiles,...r],l=[];this.l.profiles=[];for(let P of s)P.isDefault||o.some(A=>P.id===A.id)||(P=u.find(A=>P.id===A.id)??P,P.isTransient?this.l.profiles.push(P):l.push({location:P.location,name:P.name,shortName:P.shortName,useDefaultFlags:P.useDefaultFlags}));this.J(l),this.t=void 0,this.D(r,o,u)}D(r,o,u){this.g.fire({added:r,removed:o,updated:u,all:this.profiles})}F(r,o,u){u=o?.isTransient?!0:u,u||this.F(r,void 0,!0);const s=this.y(r),l=u?this.l:this.u;C.URI.isUri(s)?(l.workspaces.delete(s),o&&l.workspaces.set(s,o)):(l.emptyWindows.delete(s),o&&l.emptyWindows.set(s,o)),u||this.G()}G(){const r={};for(const[u,s]of this.u.workspaces.entries())r[u.toString()]=s.id;const o={};for(const[u,s]of this.u.emptyWindows.entries())o[u.toString()]=s.id;this.M({workspaces:r,emptyWindows:o}),this.t=void 0}H(r){const o={},u=this.v();if(r.workspaces)for(const[l,P]of Object.entries(r.workspaces)){const A=C.URI.parse(P);o[l]=this.r.extUri.isEqual(A,u.location)?u.id:this.r.extUri.basename(A)}const s={};if(r.emptyWindows)for(const[l,P]of Object.entries(r.emptyWindows)){const A=C.URI.parse(P);s[l]=this.r.extUri.isEqual(A,u.location)?u.id:this.r.extUri.basename(A)}return{workspaces:o,emptyWindows:s}}I(){return[]}J(r){throw new Error("not implemented")}L(){return{}}M(r){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=ve([Q(0,g.IEnvironmentService),Q(1,f.IFileService),Q(2,w.IUriIdentityService),Q(3,v.ILogService)],t),e.UserDataProfilesService=t;class c extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(r){this.a=r}L(){return this.Q}M(r){this.Q=r}}e.InMemoryUserDataProfilesService=c}),define(Z[78],_([0,1,7,17,2,3,35,8,109,116,16,6,5,40,39,10,13,24,14]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var I;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(I=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class S extends Error{constructor(r,o){super(r),this.code=o}}e.ExtensionsProfileScanningError=S,e.IExtensionsProfileScannerService=(0,v.createDecorator)("IExtensionsProfileScannerService");let D=class extends n.Disposable{constructor(r,o,u,s,l,P){super(),this.i=r,this.j=o,this.k=u,this.l=s,this.m=l,this.n=P,this.b=this.B(new R.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new R.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(r,o){return this.p(r,void 0,o)}async addExtensionsToProfile(r,o){const u=[],s=[];try{return await this.p(o,l=>{const P=[];for(const A of l)r.some(([O])=>(0,f.areSameExtensions)(O.identifier,A.identifier)&&O.manifest.version!==A.version)?u.push(A):P.push(A);for(const[A,O]of r)if(!P.some(N=>(0,f.areSameExtensions)(N.identifier,A.identifier)&&N.version===A.manifest.version)){const N={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:O};s.push(N),P.push(N)}return s.length&&this.b.fire({extensions:s,profileLocation:o}),u.length&&this.f.fire({extensions:u,profileLocation:o}),P}),s.length&&this.c.fire({extensions:s,profileLocation:o}),u.length&&this.g.fire({extensions:u,profileLocation:o}),s}catch(l){throw s.length&&this.c.fire({extensions:s,error:l,profileLocation:o}),u.length&&this.g.fire({extensions:u,error:l,profileLocation:o}),l}}async updateMetadata(r,o){const u=[];return await this.p(o,s=>{const l=[];for(const P of s){const A=r.find(([O])=>(0,f.areSameExtensions)(O.identifier,P.identifier)&&O.manifest.version===P.version);A&&(P.metadata={...P.metadata,...A[1]},u.push(P)),l.push(P)}return l}),u}async removeExtensionFromProfile(r,o){const u=[];this.f.fire({extensions:u,profileLocation:o});try{await this.p(o,s=>{const l=[];for(const P of s)(0,f.areSameExtensions)(P.identifier,r.identifier)?u.push(P):l.push(P);return u.length&&this.f.fire({extensions:u,profileLocation:o}),l}),u.length&&this.g.fire({extensions:u,profileLocation:o})}catch(s){throw u.length&&this.g.fire({extensions:u,error:s,profileLocation:o}),s}}async p(r,o,u){return this.w(r).queue(async()=>{let s=[],l;try{const P=await this.j.readFile(r);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,b.toFileOperationResult)(P)!==1)throw P;if(this.l.extUri.isEqual(r,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&u?.bailOutWhenFileNotFound)throw new S((0,a.getErrorMessage)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(r);let P=!1;for(const A of l){t(A)||this.r(r);let O;if((0,p.isString)(A.relativeLocation)&&A.relativeLocation)O=this.t(A.relativeLocation);else if((0,p.isString)(A.location))O=this.t(A.location),P=!0,A.relativeLocation=A.location,A.location=O.toJSON();else{O=k.URI.revive(A.location);const N=this.s(O);N&&(P=!0,A.relativeLocation=N)}s.push({identifier:A.identifier,location:O,version:A.version,metadata:A.metadata})}P&&await this.j.writeFile(r,M.VSBuffer.fromString(JSON.stringify(l)))}if(o){s=o(s);const P=s.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.s(A.location),metadata:A.metadata}));await this.j.writeFile(r,M.VSBuffer.fromString(JSON.stringify(P)))}return s})}r(r){const o=new S(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:o.code}),o}s(r){if(this.l.extUri.isEqualOrParent(r,this.i)){const o=this.l.extUri.relativePath(this.i,r);return this.i.scheme===m.Schemas.file&&this.n.getLevel()===y.LogLevel.Trace&&this.n.trace("Relative path",r.fsPath,this.i.fsPath,o),o}}t(r){return this.l.extUri.joinPath(this.i,r)}async v(){return this.u||(this.u=(async()=>{const r=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),o=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let u;try{u=(await this.j.readFile(r)).value.toString()}catch(l){if((0,b.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",r.toString());let s;try{const l=JSON.parse(u);Array.isArray(l)&&l.every(P=>t(P))?s=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(s)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify(s)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",r.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,b.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",r.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(r)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(o)}catch(l){(0,b.toFileOperationResult)(l)!==1&&this.n.error(l)}return s})()),this.u}w(r){let o=this.h.get(r);return o||(o=new E.Queue,this.h.set(r,o)),o}};D=ve([Q(1,b.IFileService),Q(2,d.IUserDataProfilesService),Q(3,w.IUriIdentityService),Q(4,h.ITelemetryService),Q(5,y.ILogService)],D),e.AbstractExtensionsProfileScannerService=D;function t(i){return(0,p.isObject)(i)&&(0,g.isIExtensionIdentifier)(i.identifier)&&(c(i.location)||(0,p.isString)(i.location)&&i.location)&&((0,p.isUndefined)(i.relativeLocation)||(0,p.isString)(i.relativeLocation))&&i.version&&(0,p.isString)(i.version)}function c(i){return i?(0,p.isString)(i.path)&&(0,p.isString)(i.scheme):!1}}),define(Z[123],_([0,1,25,7,37,17,13,43,145,2,14,9,4,18,198,73,10,8,165,34,116,113,197,16,6,5,21,3,83,78,40,39,195,196]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c,i,r,o,u,s,l,P,A,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var z;(function(me){function G(B,T){if(B===T)return!0;const q=Object.keys(B),Y=new Set;for(const te of Object.keys(T))Y.add(te);if(q.length!==Y.size)return!1;for(const te of q){if(B[te]!==T[te])return!1;Y.delete(te)}return Y.size===0}me.equals=G})(z=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let H=class extends f.Disposable{constructor(G,B,T,q,Y,te,ne,L,F,U,W,$){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=B,this.l=T,this.m=q,this.n=Y,this.p=te,this.r=ne,this.s=L,this.t=F,this.u=U,this.v=W,this.w=$,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(oe,(0,d.joinPath)(this.m,D.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(oe,(0,d.joinPath)(this.m,D.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(se,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,S.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(G,B,T){const[q,Y]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(B)]),te=T?await this.scanExtensionsUnderDevelopment(G,[...q,...Y]):[];return this.F(q,Y,te,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const B=[];B.push(this.G(!!G.useCache,G.language)),B.push(this.H(G.language,!!G.checkControlFile));const[T,q]=await Promise.all(B);return this.D([...T,...q],0,G,!1)}async scanUserExtensions(G){const B=G.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",B);const T=this.v.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.J(B,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,T),Y=G.useCache&&!q.devMode&&q.excludeObsolete?this.j:this.k;let te;try{te=await Y.scanExtensions(q)}catch(ne){if(ne instanceof l.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),te=await Y.scanExtensions(q);else throw ne}return te=await this.D(te,1,G,!0),this.s.trace("Scanned user extensions:",te.length),te}async scanExtensionsUnderDevelopment(G,B){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const T=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(q=>q.scheme===b.Schemas.file).map(async q=>{const Y=await this.J(q,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(Y)).map(ne=>(ne.type=B.find(L=>(0,S.areSameExtensions)(L.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,Y)))}))).flat();return this.D(T,"development",G,!0)}return[]}async scanExistingExtension(G,B,T){const q=await this.J(G,!1,B,!0,T.language,!0,void 0),Y=await this.k.scanExtension(q);return!Y||!T.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions(G,B,T){const q=await this.J(G,!1,B,!0,T.language,!0,void 0),Y=await this.k.scanOneOrMultipleExtensions(q);return this.D(Y,B,T,!0)}async scanMetadata(G){const B=(0,d.joinPath)(G,"package.json"),T=(await this.r.readFile(B)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(G,B){const T=(0,d.joinPath)(G,"package.json"),q=(await this.r.readFile(T)).value.toString(),Y=JSON.parse(q);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,Y.__metadata={...Y.__metadata,...B},await this.r.writeFile((0,d.joinPath)(G,"package.json"),R.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof l.ExtensionsProfileScanningError&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw G}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.p.addExtensionsToProfile(G.map(B=>[B,B.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify([])))}catch(B){(0,c.toFileOperationResult)(B)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(B))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.s.error(G)}finally{this.z=void 0}})()),this.z}async D(G,B,T,q){return T.includeAllVersions||(G=this.F(B===0?G:void 0,B===1?G:void 0,B==="development"?G:void 0,await this.getTargetPlatform(),q)),T.includeInvalid||(G=G.filter(Y=>Y.isValid)),G.sort((Y,te)=>{const ne=v.basename(Y.location.fsPath),L=v.basename(te.location.fsPath);return ne<L?-1:ne>L?1:0})}F(G,B,T,q,Y){const te=(L,F,U)=>{if(L.isValid&&!F.isValid)return!1;if(L.isValid===F.isValid){if(Y&&w.gt(L.manifest.version,F.manifest.version))return this.s.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${L.location.path} with version ${L.manifest.version}`),!1;if(w.eq(L.manifest.version,F.manifest.version)){if(L.type===0)return this.s.debug(`Skipping extension ${F.location.path} in favour of system extension ${L.location.path} with same version`),!1;if(L.targetPlatform===q)return this.s.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return U?this.s.warn(`Overwriting user extension ${L.location.path} with ${F.location.path}.`):this.s.debug(`Overwriting user extension ${L.location.path} with ${F.location.path}.`),!0},ne=new Map;return G?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),U=ne.get(F);(!U||te(U,L,!1))&&ne.set(F,L)}),B?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),U=ne.get(F);if(!U&&G&&L.type===0){this.s.debug(`Skipping obsolete system extension ${L.location.path}.`);return}(!U||te(U,L,!1))&&ne.set(F,L)}),T?.forEach(L=>{const F=D.ExtensionIdentifier.toKey(L.identifier.id),U=ne.get(F);(!U||te(U,L,!0))&&ne.set(F,L),ne.set(F,L)}),[...ne.values()]}async G(G,B){this.s.trace("Started scanning system extensions");const T=await this.J(this.systemExtensionsLocation,!1,0,!0,B,!0,void 0),Y=await(G&&!T.devMode?this.i:this.k).scanExtensions(T);return this.s.trace("Scanned system extensions:",Y.length),Y}async H(G,B){const T=this.t.isBuilt?[]:this.u.builtInExtensions;if(!T?.length)return[];this.s.trace("Started scanning dev system extensions");const q=B?await this.I():{},Y=[],te=h.URI.file(v.normalize(v.join(b.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const L of T){const F=q[L.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":Y.push((0,d.joinPath)(te,L.name));break;default:Y.push(h.URI.file(F));break}}const ne=await Promise.all(Y.map(async L=>this.k.scanExtension(await this.J(L,!1,0,!0,G,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ne.length),(0,E.coalesce)(ne)}async I(){try{const G=await this.r.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async J(G,B,T,q,Y,te,ne){const L=await this.f(Y??y.language),F=await this.L(G),U=B&&!this.v.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,W=U?await this.L(U):void 0;return new ie(G,F,U,W,B,ne,T,q,te,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,Y,L)}async L(G){try{const B=await this.r.stat(G);if(typeof B.mtime=="number")return B.mtime}catch{}}};H=ve([Q(4,P.IUserDataProfilesService),Q(5,l.IExtensionsProfileScannerService),Q(6,c.IFileService),Q(7,r.ILogService),Q(8,I.IEnvironmentService),Q(9,o.IProductService),Q(10,A.IUriIdentityService),Q(11,i.IInstantiationService)],H),e.AbstractExtensionsScannerService=H;class ie{constructor(G,B,T,q,Y,te,ne,L,F,U,W,$,V,j,K){this.location=G,this.mtime=B,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=q,this.profile=Y,this.profileScanOptions=te,this.type=ne,this.excludeObsolete=L,this.validate=F,this.productVersion=U,this.productDate=W,this.productCommit=$,this.devMode=V,this.language=j,this.translations=K}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,B){return(0,d.isEqual)(G.location,B.location)&&G.mtime===B.mtime&&(0,d.isEqual)(G.applicationExtensionslocation,B.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&G.profile===B.profile&&n.equals(G.profileScanOptions,B.profileScanOptions)&&G.type===B.type&&G.excludeObsolete===B.excludeObsolete&&G.validate===B.validate&&G.productVersion===B.productVersion&&G.productDate===B.productDate&&G.productCommit===B.productCommit&&G.devMode===B.devMode&&G.language===B.language&&z.equals(G.translations,B.translations)}}e.ExtensionScannerInput=ie;let se=class extends f.Disposable{constructor(G,B,T,q,Y){super(),this.f=G,this.g=B,this.h=T,this.i=q,this.j=Y}async scanExtensions(G){const B=G.profile?await this.l(G):await this.k(G);let T={};if(G.excludeObsolete&&G.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();T=JSON.parse(q)}catch{}return(0,a.isEmptyObject)(T)?B:B.filter(q=>!T[S.ExtensionKey.create(q).toString()])}async k(G){const B=await this.i.resolve(G.location);if(!B.children?.length)return[];const T=await Promise.all(B.children.map(async q=>{if(!q.isDirectory||G.type===1&&(0,d.basename)(q.resource).indexOf(".")===0)return null;const Y=new ie(q.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(Y)}));return(0,E.coalesce)(T).sort((q,Y)=>q.location.path<Y.location.path?-1:1)}async l(G){let B=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){B=B.filter(q=>!q.metadata?.isApplicationScoped);const T=await this.m(G.applicationExtensionslocation,q=>!!q.metadata?.isApplicationScoped,G);B.push(...T)}return B}async m(G,B,T){const q=await this.g.scanProfileExtensions(G,T.profileScanOptions);if(!q.length)return[];const Y=await Promise.all(q.map(async te=>{if(B(te)){const ne=new ie(te.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(ne,te.metadata)}return null}));return(0,E.coalesce)(Y)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,d.joinPath)(G.location,"package.json"))){const B=await this.scanExtension(G);return B?[B]:[]}else return await this.scanExtensions(G)}catch(B){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,C.getErrorMessage)(B)),[]}}async scanExtension(G,B){try{let T=await this.scanExtensionManifest(G.location);if(T){T.publisher||(T.publisher=D.UNDEFINED_PUBLISHER),B=B??T.__metadata,delete T.__metadata;const q=(0,S.getGalleryExtensionId)(T.publisher,T.name),Y=B?.id?{id:q,uuid:B.id}:{id:q},te=B?.isSystem?0:G.type,ne=te===0||!!B?.isBuiltin;N.ImplicitActivationEvents.updateManifest(T),T=await this.n(G.location,T,ie.createNlsConfiguration(G));const L={type:te,identifier:Y,manifest:T,location:G.location,isBuiltin:ne,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return G.validate?this.validate(L,G):L}}catch(T){G.type!==0&&this.j.error(T)}return null}validate(G,B){let T=!0;const q=(0,t.validateExtensionManifest)(B.productVersion,B.productDate,B.location,G.manifest,G.isBuiltin);for(const[Y,te]of q)Y===p.default.Error&&(T=!1,this.j.error(this.t(B.location,te)));return G.isValid=T,G.validations=q,G}async scanExtensionManifest(G){const B=(0,d.joinPath)(G,"package.json");let T;try{T=(await this.i.readFile(B)).value.toString()}catch(Y){return(0,c.toFileOperationResult)(Y)!==1&&this.j.error(this.t(G,(0,m.localize)(0,null,B.path,Y.message))),null}let q;try{q=JSON.parse(T)}catch{const te=[];(0,k.parse)(T,te);for(const ne of te)this.j.error(this.t(G,(0,m.localize)(1,null,B.path,ne.offset,ne.length,(0,g.getParseErrorMessage)(ne.error))));return null}return(0,k.getNodeType)(q)!=="object"?(this.j.error(this.t(G,(0,m.localize)(2,null,B.path))),null):q}async n(G,B,T){const q=await this.p(G,B,T);if(q)try{const Y=[],te=await this.r(q.default,Y);if(Y.length>0)return Y.forEach(L=>{this.j.error(this.t(G,(0,m.localize)(3,null,q.default?.path,(0,g.getParseErrorMessage)(L.error))))}),B;if((0,k.getNodeType)(q)!=="object")return this.j.error(this.t(G,(0,m.localize)(4,null,q.default?.path))),B;const ne=q.values||Object.create(null);return(0,O.localizeManifest)(B,ne,te)}catch{}return B}async p(G,B,T){const q=(0,d.joinPath)(G,"package.nls.json"),Y=(F,U)=>{U.forEach(W=>{this.j.error(this.t(G,(0,m.localize)(5,null,F?.path,(0,g.getParseErrorMessage)(W.error))))})},te=F=>{this.j.error(this.t(G,(0,m.localize)(6,null,F?.path)))},ne=`${B.publisher}.${B.name}`,L=T.translations[ne];if(L)try{const F=h.URI.file(L),U=(await this.i.readFile(F)).value.toString(),W=[],$=(0,k.parse)(U,W);return W.length>0?(Y(F,W),{values:void 0,default:q}):(0,k.getNodeType)($)!=="object"?(te(F),{values:void 0,default:q}):{values:$.contents?$.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let U;try{U=await this.s(G,T)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const W=(await this.i.readFile(U.localized)).value.toString(),$=[],V=(0,k.parse)(W,$);return $.length>0?(Y(U.localized,$),{values:void 0,default:U.original}):(0,k.getNodeType)(V)!=="object"?(te(U.localized),{values:void 0,default:U.original}):{values:V,default:U.original}}catch{return{values:void 0,default:U.original}}}}async r(G,B){if(G)try{const T=(await this.i.readFile(G)).value.toString();return(0,k.parse)(T,B)}catch{}}s(G,B){return new Promise((T,q)=>{const Y=te=>{const ne=(0,d.joinPath)(G,`package.nls.${te}.json`);this.i.exists(ne).then(L=>{L&&T({localized:ne,original:(0,d.joinPath)(G,"package.nls.json")});const F=te.lastIndexOf("-");F===-1?T({localized:(0,d.joinPath)(G,"package.nls.json"),original:null}):(te=te.substring(0,F),Y(te))})};if(B.devMode||B.pseudo||!B.language)return T({localized:(0,d.joinPath)(G,"package.nls.json"),original:null});Y(B.language)})}t(G,B){return`[${G.path}]: ${B}`}};se=ve([Q(1,l.IExtensionsProfileScannerService),Q(2,A.IUriIdentityService),Q(3,c.IFileService),Q(4,r.ILogService)],se);let oe=class extends se{constructor(G,B,T,q,Y,te){super(B,T,q,Y,te),this.y=G,this.v=this.B(new M.ThrottledDelayer(3e3)),this.w=this.B(new u.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(G){const B=await this.z();if(this.u=G,B&&B.input&&ie.equals(B.input,this.u))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.v.trigger(()=>this.D()),B.result.map(q=>(q.location=h.URI.revive(q.location),q));const T=await super.scanExtensions(G);return await this.C({input:G,result:T}),T}async z(){try{const G=await this.i.readFile(this.y),B=JSON.parse(G.value.toString());return{result:B.result,input:(0,s.revive)(B.input)}}catch(G){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,C.getErrorMessage)(G))}return null}async C(G){try{await this.i.writeFile(this.y,R.VSBuffer.fromString(JSON.stringify(G)))}catch(B){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,C.getErrorMessage)(B))}}async D(){if(!this.u)return;const G=await this.z();if(!G)return;const B=G.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!n.equals(T,B))try{await this.i.del(this.y),this.w.fire()}catch(q){this.j.error(q)}}};oe=ve([Q(2,l.IExtensionsProfileScannerService),Q(3,A.IUriIdentityService),Q(4,c.IFileService),Q(5,r.ILogService)],oe);function ue(me,G){const B=(0,S.getExtensionId)(me.manifest.publisher,me.manifest.name);return{id:B,identifier:new D.ExtensionIdentifier(B),isBuiltin:me.type===0,isUserBuiltin:me.type===1&&me.isBuiltin,isUnderDevelopment:G,extensionLocation:me.location,uuid:me.identifier.uuid,targetPlatform:me.targetPlatform,...me.manifest}}e.toExtensionDescription=ue;class le extends H{constructor(G,B,T,q,Y,te,ne,L,F,U,W,$){super(G,B,(0,d.joinPath)(T,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(q,D.MANIFEST_CACHE_FOLDER),Y,te,ne,L,F,U,W,$),this.M=(async()=>{if(y.translationsConfigFile)try{const V=await this.r.readFile(h.URI.file(y.translationsConfigFile));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}f(G){return this.M}}e.NativeExtensionsScannerService=le}),define(Z[267],_([0,1,5,40,39,24,78,16,34,8]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let b=class extends C.AbstractExtensionsProfileScannerService{constructor(y,d,w,p,a,h){super(f.URI.file(y.extensionsPath),d,w,p,a,h)}};b=ve([Q(0,g.INativeEnvironmentService),Q(1,k.IFileService),Q(2,M.IUserDataProfilesService),Q(3,n.IUriIdentityService),Q(4,R.ITelemetryService),Q(5,E.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(Z[268],_([0,1,8,34,78,123,16,6,5,21,39,40]),function(x,e,E,M,n,R,C,k,g,f,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let y=class extends R.NativeExtensionsScannerService{constructor(w,p,a,h,m,I,S,D){super(E.URI.file(m.builtinExtensionsPath),E.URI.file(m.extensionsPath),m.userHome,E.URI.file(m.userDataPath),w,p,a,h,m,I,S,D)}};y=ve([Q(0,v.IUserDataProfilesService),Q(1,n.IExtensionsProfileScannerService),Q(2,C.IFileService),Q(3,g.ILogService),Q(4,M.INativeEnvironmentService),Q(5,f.IProductService),Q(6,b.IUriIdentityService),Q(7,k.IInstantiationService)],y),e.ExtensionsScannerService=y}),define(Z[269],_([0,1,15,2,14,9,4,61,8,31,42,34,5,40]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let w=class extends M.Disposable{constructor(a,h,m){super(),this.c=a,this.f=m,this.a=k.TernarySearchTree.forPaths(!C.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(a.appRoot),this.addValidFileRoot(a.extensionsPath),this.addValidFileRoot(h.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(a.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:a}=E.session;a.protocol.registerFileProtocol(n.Schemas.vscodeFileResource,(h,m)=>this.i(h,m)),a.protocol.interceptFileProtocol(n.Schemas.file,(h,m)=>this.h(h,m)),this.B((0,M.toDisposable)(()=>{a.protocol.unregisterProtocol(n.Schemas.vscodeFileResource),a.protocol.uninterceptProtocol(n.Schemas.file)}))}addValidFileRoot(a){const h=(0,R.normalize)(a);return this.a.get(h)?M.Disposable.None:(this.a.set(h,!0),(0,M.toDisposable)(()=>this.a.delete(h)))}h(a,h){const m=g.URI.parse(a.url);return this.f.error(`Refused to load resource ${m.fsPath} from ${n.Schemas.file}: protocol (original URL: ${a.url})`),h({error:-3})}i(a,h){const m=this.j(a);let I;return this.c.crossOriginIsolated&&((0,R.basename)(m)==="workbench.html"||(0,R.basename)(m)==="workbench-dev.html"?I=n.COI.CoopAndCoep:I=n.COI.getHeadersFromQuery(a.url)),this.a.findSubstr(m)?h({path:m,headers:I}):this.b.has((0,R.extname)(m).toLowerCase())?h({path:m}):(this.f.error(`${n.Schemas.vscodeFileResource}: Refused to load resource ${m} from ${n.Schemas.vscodeFileResource}: protocol (original URL: ${a.url})`),h({error:-3}))}j(a){const h=g.URI.parse(a.url),m=n.FileAccess.uriToFileUri(h);return(0,R.normalize)(m.fsPath)}createIPCObjectUrl(){let a;const h=g.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),m=h.toString(),I=async()=>a;return b.validatedIpcMain.handle(m,I),this.f.trace(`IPC Object URL: Registered new channel ${m}.`),{resource:h,update:S=>a=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${m}.`),b.validatedIpcMain.removeHandler(m)}}}};w=ve([Q(0,v.INativeEnvironmentService),Q(1,d.IUserDataProfilesService),Q(2,y.ILogService)],w),e.ProtocolMainService=w}),define(Z[270],_([0,1,15,42,7,3,2,14,10,105,28,20,5,66,67,69,44,40,38,65]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let S=class extends C.Disposable{constructor(t,c,i,r,o,u,s,l,P,A){super(),this.g=t,this.h=c,this.i=i,this.j=r,this.k=o,this.l=u,this.m=s,this.n=l,this.p=P,this.r=A,this.a=new n.Barrier,this.b=void 0,this.c=void 0,this.f=this.B(new R.Emitter),this.onDidError=R.Event.buffer(this.f.event),this.y=void 0,this.z=void 0,this.s()}s(){M.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(t,c)=>this.t(t,c)),M.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(t,c)=>this.u(t,c)),this.B(this.k.onWillShutdown(()=>this.v()))}async t(t,c){this.l.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const i=await this.connect();if(t.sender.isDestroyed())return i.close();t.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[i])}u(t,c){this.l.trace("SharedProcess: onWorkerConnection",c);const i=new C.DisposableStore,r=u=>{!this.G()||(this.l.trace(`SharedProcess: disposing worker (reason: '${u}')`,c),i.dispose(),this.w("vscode:electron-main->shared-process=disposeWorker",c))},o=E.BrowserWindow.fromId(c.reply.windowId);if(!o||o.isDestroyed()||o.webContents.isDestroyed()||!c.reply.channel){r("unavailable");return}i.add(R.Event.filter(this.k.onWillLoadWindow,u=>u.window.win===o)(()=>r("load"))),i.add(R.Event.fromNodeEventEmitter(o,"closed")(()=>r("closed"))),o.webContents.postMessage(c.reply.channel,c.reply.nonce,t.ports)}v(){this.l.trace("SharedProcess: onWillShutdown");const t=this.b;!t||(this.w("vscode:electron-main->shared-process=exit"),this.c&&(t.removeListener("close",this.c),this.c=void 0),setTimeout(()=>{try{this.l.trace("SharedProcess: onWillShutdown window.close()"),t.close()}catch(c){this.l.trace(`SharedProcess: onWillShutdown window.close() error: ${c}`)}this.b=void 0},0))}w(t,...c){if(!this.G()){this.l.warn(`Sending IPC message to channel '${t}' for shared process window that is destroyed`);return}try{this.b?.webContents.send(t,...c)}catch(i){this.l.warn(`Error sending IPC message to channel '${t}' of shared process: ${(0,a.toErrorMessage)(i)}`)}}whenReady(){return this.y||(this.y=new Promise(t=>M.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.l.trace("SharedProcess: Overall ready"),t()}))),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D(),this.F(),await new Promise(t=>M.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.l.trace("SharedProcess: IPC ready"),t()}))})()),this.z}D(){const t=this.B(this.r.createIPCObjectUrl());this.b=new E.BrowserWindow({show:!1,backgroundColor:this.p.getBackgroundColor(),webPreferences:{preload:k.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.i.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),t.update({machineId:this.g,windowId:this.b.id,appRoot:this.i.appRoot,codeCachePath:this.i.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},userEnv:this.h,args:this.i.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),product:d.default,policiesData:this.n.serialize()}),this.b.loadURL(k.FileAccess.asBrowserUri(`vs/code/electron-browser/sharedProcess/sharedProcess${this.i.isBuilt?"":"-dev"}.html`).toString(!0))}F(){!this.b||(this.c=t=>{this.l.trace("SharedProcess#close prevented"),t.preventDefault(),this.b?.isVisible()&&this.b.hide()},this.b.on("close",this.c),this.b.webContents.on("render-process-gone",(t,c)=>this.f.fire({type:2,details:c})),this.b.on("unresponsive",()=>this.f.fire({type:1})),this.b.webContents.on("did-fail-load",(t,c,i)=>this.f.fire({type:3,details:{reason:i,exitCode:c}})))}async connect(){await this.C;const t=(0,g.assertIsDefined)(this.b);return(0,f.connect)(t)}async toggle(){await this.C,this.b&&(this.b.isVisible()?(this.b.webContents.closeDevTools(),this.b.hide()):(this.b.show(),this.b.webContents.openDevTools()))}isVisible(){return this.b?.isVisible()??!1}G(){const t=this.b;return t?!t.isDestroyed()&&!t.webContents.isDestroyed():!1}};S=ve([Q(2,b.IEnvironmentMainService),Q(3,h.IUserDataProfilesService),Q(4,v.ILifecycleMainService),Q(5,y.ILogService),Q(6,I.ILoggerMainService),Q(7,m.IPolicyService),Q(8,p.IThemeMainService),Q(9,w.IProtocolMainService)],S),e.SharedProcess=S}),define(Z[94],_([0,1,7,3,2,64,10,106,6,40]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var b;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(m){m[m.APPLICATION=-1]="APPLICATION",m[m.PROFILE=0]="PROFILE",m[m.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));function d(m){const I=m.get(e.TARGET_KEY);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.loadKeyTargets=d;class w extends n.Disposable{constructor(I={flushInterval:w.a}){super(),this.j=I,this.b=this.B(new M.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new M.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new n.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,n.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.J()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(I,S){if(S===e.TARGET_KEY){switch(I){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:S,target:this.F(I)[S]})}r(I){this.f.fire({reason:I})}get(I,S,D){return this.L(S)?.get(I,D)}getBoolean(I,S,D){return this.L(S)?.getBoolean(I,D)}getNumber(I,S,D){return this.L(S)?.getNumber(I,D)}store(I,S,D,t){if((0,C.isUndefinedOrNull)(S)){this.remove(I,D);return}this.t(()=>{this.u(I,D,t),this.L(D)?.set(I,S)})}remove(I,S){this.t(()=>{this.u(I,S,void 0),this.L(S)?.delete(I)})}t(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,S){const D=[],t=this.F(I);for(const c of Object.keys(t))t[c]===S&&D.push(c);return D}u(I,S,D){const t=this.F(S);typeof D=="number"?t[I]!==D&&(t[I]=D,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[I]=="number"&&(delete t[I],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(I){switch(I){case-1:return this.D;case 0:return this.z;default:return this.w}}G(I){const S=this.L(I);return S?d(S):Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(I=b.NONE){this.f.fire({reason:I});const S=this.L(-1),D=this.L(0),t=this.L(1);switch(I){case b.NONE:await E.Promises.settled([S?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await E.Promises.settled([S?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return h(I,S,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(I,S){return this.r(b.NONE),(0,f.isUserDataProfile)(I)?this.N(I,S):this.O(I,S)}H(I,S){return!(I.id===S.id||p(S)&&p(I))}I(I,S,D,t){this.t(()=>{if(t)for(const[c,i]of I)S.set(c,i);else{const c=new Set;for(const[i,r]of I)c.add(i),S.get(i)!==r&&this.n(D,i);for(const[i]of S.items)c.has(i)||this.n(D,i)}})}}w.a=60*1e3,e.AbstractStorageService=w;function p(m){return m.isDefault||!!m.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class a extends w{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(I=>this.n(1,I))),this.B(this.P.onDidChangeStorage(I=>this.n(0,I))),this.B(this.p.onDidChangeStorage(I=>this.n(-1,I)))}L(I){switch(I){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(I){return!1}}e.InMemoryStorageService=a;async function h(m,I,S,D,t,c){const i=N=>{try{return JSON.parse(N)}catch{return N}},r=new Map,o=new Map;m.forEach((N,z)=>{r.set(z,N),o.set(z,i(N))});const u=new Map,s=new Map;I.forEach((N,z)=>{u.set(z,N),s.set(z,i(N))});const l=new Map,P=new Map;S.forEach((N,z)=>{l.set(z,N),P.set(z,i(N))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const A=[];if(r.forEach((N,z)=>{A.push({key:z,value:N})}),console.table(A),console.groupEnd(),console.log(o),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];u.forEach((z,H)=>{N.push({key:H,value:z})}),console.table(N),console.groupEnd(),console.log(s)}console.group(`Storage: Workspace (path: ${c})`);const O=[];l.forEach((N,z)=>{O.push({key:z,value:N})}),console.table(O),console.groupEnd(),console.log(P)}e.logStorage=h}),define(Z[271],_([0,1,25,7,3,2,9,72,8,23,106,156,5,94,24,29]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class a extends R.Disposable{get storage(){return this.f}constructor(c,i){super(),this.j=c,this.k=i,this.b=this.B(new n.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new n.Emitter),this.onDidCloseStorage=this.c.event,this.f=new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new M.DeferredPromise,this.whenInit=this.h.p,this.i=b.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===b.StorageState.None)try{const c=await this.n();this.f.dispose(),this.f=c,this.B(c.onDidChangeStorage(r=>this.b.fire({key:r}))),await this.m(c);const i=c.getBoolean(d.IS_NEW_KEY);i===void 0?c.set(d.IS_NEW_KEY,!0):i&&c.set(d.IS_NEW_KEY,!1)}catch(c){this.j.error(`[storage main] initialize(): Unable to init storage due to ${c}`)}finally{this.i=b.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===y.LogLevel.Trace?c=>this.j.trace(c):void 0,logError:c=>this.j.error(c)}}m(c){return c.init()}get items(){return this.f.items}get(c,i){return this.f.get(c,i)}set(c,i){return this.f.set(c,i)}delete(c){return this.f.delete(c)}async close(){const c=new k.StopWatch(!1);await this.s(),c.stop(),c.elapsed()>a.a&&await this.r(c),this.c.fire()}async r(c){if(!!this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([o,u])=>({key:o,length:u.length})),(o,u)=>u.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),r=(await this.k.stat(g.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${c.elapsed()}ms, DB size: ${r}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=b.StorageState.Closed,await this.f.close()}}a.a=2e3;class h extends a{get path(){if(!this.v.useInMemoryStorage)return(0,C.join)(this.u.globalStorageHome.fsPath,h.t)}constructor(c,i,r,o){super(r,o),this.u=c,this.v=i}async n(){return new b.Storage(new v.SQLiteStorageDatabase(this.path??v.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:b.StorageHint.STORAGE_IN_MEMORY})}}h.t="state.vscdb";class m extends h{constructor(c,i,r,o){super(c,i,r,o)}}e.ProfileStorageMain=m;class I extends h{constructor(c,i,r,o){super(i.defaultProfile,c,r,o)}async m(c){await super.m(c),this.z(c)}z(c){c.get(w.firstSessionDateStorageKey,void 0)===void 0&&c.set(w.firstSessionDateStorageKey,new Date().toUTCString());const r=c.get(w.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();c.set(w.lastSessionDateStorageKey,typeof r>"u"?null:r),c.set(w.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=I;class S extends a{get path(){if(!this.w.useInMemoryStorage)return(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(c,i,r,o,u){super(r,u),this.v=c,this.w=i,this.y=o}async n(){const{storageFilePath:c,wasCreated:i}=await this.C();return new b.Storage(new v.SQLiteStorageDatabase(c,{logging:this.l()}),{hint:this.w.useInMemoryStorage?b.StorageHint.STORAGE_IN_MEMORY:i?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:v.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const c=(0,C.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,C.join)(c,S.t);return await f.Promises.exists(c)?{storageFilePath:i,wasCreated:!1}:(await f.Promises.mkdir(c,{recursive:!0}),this.D(c),{storageFilePath:i,wasCreated:!0})}async D(c){let i;if((0,p.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const r=(0,C.join)(c,S.u);await f.Promises.exists(r)||await f.Promises.writeFile(r,JSON.stringify(i,void 0,2))}catch(r){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${r}`)}}}S.t="state.vscdb",S.u="workspace.json",e.WorkspaceStorageMain=S;class D extends a{get path(){}async n(){return new b.Storage(new b.InMemoryStorageDatabase,{hint:b.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(Z[272],_([0,1,3,2,94]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class R extends M.Disposable{constructor(k,g,f){super(),this.b=k,this.c=g,this.f=f;const b=this.B(new M.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>b.value=this.g(),onDidRemoveLastListener:()=>b.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new M.DisposableStore;return k.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(g,f)=>(g?g.push(f.key):g=[f.key],g),100)(g=>this.h(g))),k.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(g,f)=>{g||(g=new Map);let b=g.get(f.profile.id);return b||g.set(f.profile.id,b={profile:f.profile,keys:[],storage:f.storage}),b.keys.push(f.key),g},100)(g=>this.i(g))),k}h(k){const g=k.includes(n.TARGET_KEY)?[this.c.defaultProfile]:[],f=[];if(k=k.filter(b=>b!==n.TARGET_KEY),k.length){const b=(0,n.loadKeyTargets)(this.b.applicationStorage.storage);f.push({profile:this.c.defaultProfile,changes:k.map(v=>({key:v,scope:0,target:b[v]}))})}this.j(g,f)}i(k){const g=[],f=new Map;for(const[b,v]of k.entries()){v.keys.includes(n.TARGET_KEY)&&g.push(v.profile);const y=v.keys.filter(d=>d!==n.TARGET_KEY);if(y.length){const d=(0,n.loadKeyTargets)(v.storage.storage);f.set(b,{profile:v.profile,changes:y.map(w=>({key:w,scope:0,target:d[w]}))})}}this.j(g,[...f.values()])}j(k,g){(k.length||g.length)&&this.a.fire({valueChanges:g,targetChanges:k})}listen(k,g,f){switch(g){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${g}`)}async call(k,g){throw new Error(`Call not found: ${g}`)}}e.ProfileStorageChangesListenerChannel=R}),define(Z[273],_([0,1,8,34,16,5,33,39,40,10,115]),function(x,e,E,M,n,R,C,k,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let v=class dt extends g.UserDataProfilesService{constructor(p,a,h,m,I){super(h,m,a,I),this.O=p,this.P=h}I(){return this.O.getItem(dt.b,[]).map(a=>({...a,location:(0,f.isString)(a.location)?this.r.extUri.joinPath(this.profilesHome,a.location):E.URI.revive(a.location)}))}L(){const p=this.O.getItem(dt.c,{});return this.O.getItem(dt.a,!1)?p:this.H(p)}N(){return this.r.extUri.joinPath(E.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};v.a="profileAssociationsMigration",v=ve([Q(0,C.IStateReadService),Q(1,k.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,n.IFileService),Q(4,R.ILogService)],v),e.UserDataProfilesReadonlyService=v;let y=class rt extends v{constructor(p,a,h,m,I){super(p,a,h,m,I),this.U=p}J(p){p.length?this.U.setItem(rt.b,p.map(a=>({...a,location:this.r.extUri.basename(a.location)}))):this.U.removeItem(rt.b)}I(){const p=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(p),this.U.setItem("userDataProfilesMigration",!0)),p}M(p){p.emptyWindows||p.workspaces?this.U.setItem(rt.c,p):this.U.removeItem(rt.c)}L(){const p="workspaceAndProfileInfo",a=this.U.getItem(p,void 0);if(a){this.U.removeItem(p);const m=a.reduce((I,{workspace:S,profile:D})=>(I[E.URI.revive(S).toString()]=E.URI.revive(D).toString(),I),{});this.U.setItem(rt.c,{workspaces:m})}const h=super.L();return this.U.getItem(rt.a,!1)||(this.M(h),this.U.setItem(rt.a,!0)),h}};y=ve([Q(0,C.IStateService),Q(1,k.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,n.IFileService),Q(4,R.ILogService)],y),e.UserDataProfilesService=y;let d=class extends y{constructor(p,a,h,m){super(new b.StateService(0,a,m,h),p,a,h,m)}async init(){return await this.U.init(),super.init()}};d=ve([Q(0,k.IUriIdentityService),Q(1,M.INativeEnvironmentService),Q(2,n.IFileService),Q(3,R.ILogService)],d),e.ServerUserDataProfilesService=d}),define(Z[52],_([0,1,34,16,6,5,39,40,273,33]),function(x,e,E,M,n,R,C,k,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,n.refineServiceDecorator)(k.IUserDataProfilesService);let b=class extends g.UserDataProfilesService{constructor(y,d,w,p,a){super(y,d,w,p,a)}getAssociatedEmptyWindows(){const y=[];for(const d of this.u.emptyWindows.keys())y.push({id:d});return y}};b=ve([Q(0,f.IStateService),Q(1,C.IUriIdentityService),Q(2,E.INativeEnvironmentService),Q(3,M.IFileService),Q(4,R.ILogService)],b),e.UserDataProfilesMainService=b}),define(Z[95],_([0,1,8,49,3,2,34,16,6,20,5,94,271,40,52,39]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,g.createDecorator)("storageMainService");let a=class extends R.Disposable{constructor(I,S,D,t,c,i){super(),this.c=I,this.f=S,this.g=D,this.h=t,this.i=c,this.j=i,this.a=void 0,this.b=this.B(new n.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(I=>{I.window.profile&&this.profileStorage(I.window.profile).init(),I.workspace&&this.workspaceStorage(I.workspace).init()})),this.B(this.h.onWillShutdown(I=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=I.reason,I.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.n)I.join("profileStorage",S.close());for(const[,S]of this.r)I.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(I=>{I.join((async()=>{await this.i.exists(I.profile.globalStorageHome)||await this.i.createFolder(I.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(I=>{const S=this.n.get(I.profile.id);S&&I.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const I=new y.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,M.once)(I.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),I}profileStorage(I){if((0,v.isProfileUsingDefaultStorage)(I))return this.applicationStorage;let S=this.n.get(I.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${I.name})`),S=this.p(I),this.n.set(I.id,S);const D=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:I})));(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${I.name})`),this.n.delete(I.id),D.dispose()})}return S}p(I){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.ProfileStorageMain(I,this.k(),this.c,this.i)}workspaceStorage(I){let S=this.r.get(I.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${I.id})`),S=this.s(I),this.r.set(I.id,S),(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${I.id})`),this.r.delete(I.id)})),S}s(I){return this.a===2?new y.InMemoryStorageMain(this.c,this.i):new y.WorkspaceStorageMain(I,this.k(),this.c,this.f,this.i)}isUsed(I){const S=E.URI.file(I);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(!!D.path&&this.j.extUri.isEqualOrParent(E.URI.file(D.path),S))return!0;return!1}};a=ve([Q(0,b.ILogService),Q(1,C.IEnvironmentService),Q(2,w.IUserDataProfilesMainService),Q(3,f.ILifecycleMainService),Q(4,k.IFileService),Q(5,p.IUriIdentityService)],a),e.StorageMainService=a,e.IApplicationStorageMainService=(0,g.createDecorator)("applicationStorageMainService");let h=class extends v.AbstractStorageService{constructor(I,S){super(),this.p=I,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(I){if(I===-1)return this.s.applicationStorage.storage}M(I){if(I===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};h=ve([Q(0,d.IUserDataProfilesService),Q(1,e.IStorageMainService)],h),e.ApplicationStorageMainService=h}),define(Z[274],_([0,1,2,20,52,29,7,30]),function(x,e,E,M,n,R,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let g=class extends E.Disposable{constructor(b,v,y){super(),this.a=v,this.b=y,this.B(b.onWillLoadWindow(d=>{d.reason===2&&this.c(d.window)})),this.B(b.onBeforeCloseWindow(d=>this.c(d))),this.B(new C.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(b){const v=this.f(b),y=this.a.getProfileForWorkspace(v);y?.isTransient&&(this.a.unsetWorkspace(v,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(b){return b.openedWorkspace??(0,R.toWorkspaceIdentifier)(b.backupPath,b.isExtensionDevelopmentHost)}g(){const b=this.a.getAssociatedEmptyWindows();if(b.length===0)return;const v=this.b.getWindows().map(y=>this.f(y));for(const y of b)v.some(d=>d.id===y.id)||this.a.unsetWorkspace(y,!1)}};g=ve([Q(0,M.ILifecycleMainService),Q(1,n.IUserDataProfilesMainService),Q(2,k.IWindowsMainService)],g),e.UserDataProfilesHandler=g}),define(Z[124],_([0,1,18,8,29]),function(x,e,E,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function R(g,f,b){for(const y of g){const d=y.openedWorkspace;if((0,n.isWorkspaceIdentifier)(d)){const w=await b(d);if(w){if(w.folders.some(p=>E.extUriBiasedIgnorePathCase.isEqualOrParent(f,p.uri)))return y}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(f,d.configPath))return y}}const v=g.filter(y=>(0,n.isSingleFolderWorkspaceIdentifier)(y.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(f,y.openedWorkspace.uri));if(v.length)return v.sort((y,d)=>-(y.openedWorkspace.uri.path.length-d.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function C(g,f){for(const b of g)if((0,n.isWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.configPath,f)||(0,n.isSingleFolderWorkspaceIdentifier)(b.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(b.openedWorkspace.uri,f))return b}e.findWindowOnWorkspaceOrFolder=C;function k(g,f){const b=v=>f.some(y=>E.extUriBiasedIgnorePathCase.isEqual(M.URI.file(y),M.URI.file(v)));for(const v of g)if(v.config?.extensionDevelopmentPath?.some(y=>b(y)))return v}e.findWindowOnExtensionDevelopmentPath=k}),define(Z[275],_([0,1,15,2,4,18,8,19,20,5,33,30,121,29]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class wt extends M.Disposable{get state(){return this.b}constructor(S,D,t,c,i){super(),this.g=S,this.h=D,this.i=t,this.j=c,this.k=i,this.b=p(this.h.getItem(wt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(S=>this.p(S)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(S=>{S.newCount-S.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(S=>this.p(S))}m(){this.f=!0,this.n()}n(){const S=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(r=>!r.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.r(i),D.lastActiveWindow.uiState.mode===3&&S.add(D.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.r(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(S.has(D.lastPluginDevelopmentHostWindow.uiState.display)?n.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):S.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const r=this.r(i);return r.uiState.mode===3&&(S.has(r.uiState.display)?n.isMacintosh&&r.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(r.uiState.mode=1):S.add(r.uiState.display)),r}));const c=h(D);this.h.setItem(wt.a,c),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",c)}p(S){if(this.i.quitRequested)return;const D=this.r(S);S.isExtensionDevelopmentHost&&!S.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!S.isExtensionDevelopmentHost&&S.openedWorkspace&&this.b.openedWindows.forEach(t=>{const c=(0,d.isWorkspaceIdentifier)(S.openedWorkspace)&&t.workspace?.id===S.openedWorkspace.id,i=(0,d.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&t.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(t.folderUri,S.openedWorkspace.uri);(c||i)&&(t.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(S){return{windowId:S.id,workspace:(0,d.isWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace:void 0,folderUri:(0,d.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace.uri:void 0,backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.serializeWindowState()}}getNewWindowState(S){const D=this.s(S),t=this.k.getValue("window");if(D.mode===3){let c;D.hasDefaultState?c=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):c=!!(this.i.wasRestarted||t?.restoreFullscreen),c||(D.mode=1)}return D}s(S){const D=this.g.getLastActiveWindow();if(!S.extensionTestsPath){if(!!S.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=S.workspace;if((0,d.isWorkspaceIdentifier)(u)){const l=this.state.openedWindows.filter(P=>P.workspace&&P.workspace.id===u.id).map(P=>P.uiState);if(l.length)return l[0]}if((0,d.isSingleFolderWorkspaceIdentifier)(u)){const l=this.state.openedWindows.filter(P=>P.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(P.folderUri,u.uri)).map(P=>P.uiState);if(l.length)return l[0]}else if(S.backupPath){const l=this.state.openedWindows.filter(P=>P.backupPath===S.backupPath).map(P=>P.uiState);if(l.length)return l[0]}const s=this.c||this.state.lastActiveWindow;if(!D&&s)return s.uiState}let t;const c=E.screen.getAllDisplays();if(c.length===1)t=c[0];else{if(n.isMacintosh){const u=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(u)}!t&&D&&(t=E.screen.getDisplayMatching(D.getBounds())),t||(t=E.screen.getPrimaryDisplay()||c[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const r=this.k.getValue("window");let o=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(r.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&D){const u=D.serializeWindowState();u.mode===3?i.mode=3:i=u,o=i.mode!==3&&r.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(S){if(this.g.getWindows().length===0)return S;S.x=typeof S.x=="number"?S.x:0,S.y=typeof S.y=="number"?S.y:0;const D=this.g.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===S.x||t.y===S.y);)S.x+=30,S.y+=30;return S}};w.a="windowsState",w=ve([Q(0,v.IWindowsMainService),Q(1,b.IStateService),Q(2,g.ILifecycleMainService),Q(3,f.ILogService),Q(4,k.IConfigurationService)],w),e.WindowsStateHandler=w;function p(I){const S={openedWindows:[]},D=I||{openedWindows:[]};return D.lastActiveWindow&&(S.lastActiveWindow=a(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(S.lastPluginDevelopmentHostWindow=a(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(S.openedWindows=D.openedWindows.map(t=>a(t))),S}e.restoreWindowsState=p;function a(I){const S={uiState:I.uiState};return I.backupPath&&(S.backupPath=I.backupPath),I.remoteAuthority&&(S.remoteAuthority=I.remoteAuthority),I.folder&&(S.folderUri=C.URI.parse(I.folder)),I.workspaceIdentifier&&(S.workspace={id:I.workspaceIdentifier.id,configPath:C.URI.parse(I.workspaceIdentifier.configURIPath)}),S}function h(I){return{lastActiveWindow:I.lastActiveWindow&&m(I.lastActiveWindow),lastPluginDevelopmentHostWindow:I.lastPluginDevelopmentHostWindow&&m(I.lastPluginDevelopmentHostWindow),openedWindows:I.openedWindows.map(S=>m(S))}}e.getWindowsStateStoreData=h;function m(I){return{workspaceIdentifier:I.workspace&&{id:I.workspace.id,configURIPath:I.workspace.configPath.toString()},folder:I.folderUri&&I.folderUri.toString(),backupPath:I.backupPath,remoteAuthority:I.remoteAuthority,uiState:I.uiState}}}),define(Z[96],_([0,1,32,43,129,45,14,9,4,18,8,6,55,29]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function w(P){return P.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function p(P){return P.hasOwnProperty("folderUri")}e.isRecentFolder=p;function a(P){return P.hasOwnProperty("fileUri")}e.isRecentFile=a;function h(P){return m(P)||I(P)}e.isStoredWorkspaceFolder=h;function m(P){const A=P;return typeof A?.path=="string"&&(!A.name||typeof A.name=="string")}function I(P){const A=P;return typeof A?.uri=="string"&&(!A.name||typeof A.name=="string")}function S(P,A,O,N,z){if(P.scheme!==N.scheme)return{name:O,uri:P.toString(!0)};let H=A?void 0:z.relativePath(N,P);if(H!==void 0)H.length===0?H=".":g.isWindows&&(H=D(H));else if(P.scheme===C.Schemas.file)H=P.fsPath,g.isWindows&&(H=D(H));else if(z.isEqualAuthority(P.authority,N.authority))H=P.path;else return{name:O,uri:P.toString(!0)};return{name:O,path:H}}e.getStoredWorkspaceFolder=S;function D(P){return P=(0,R.normalizeDriveLetter)(P),(0,E.isUNC)(P)||(P=(0,E.toSlashes)(P)),P}function t(P,A,O){const N=[],z=new Set,H=O.dirname(A);for(const ie of P){let se;if(m(ie))ie.path&&(se=O.resolvePath(H,ie.path));else if(I(ie))try{se=b.URI.parse(ie.uri),se.path[0]!==k.posix.sep&&(se=se.with({path:k.posix.sep+se.path}))}catch(oe){console.warn(oe)}if(se){const oe=O.getComparisonKey(se);if(!z.has(oe)){z.add(oe);const ue=ie.name||O.basenameOrAuthority(se);N.push(new d.WorkspaceFolder({uri:se,name:ue,index:N.length},ie))}}}return N}e.toWorkspaceFolders=t;function c(P,A,O,N,z){const H=i(A,P),ie=z.dirname(A),se=z.dirname(N),oe=[];for(const G of H.folders){const B=m(G)?z.resolvePath(ie,G.path):b.URI.parse(G.uri);let T;O?T=!1:T=!m(G)||(0,k.isAbsolute)(G.path),oe.push(S(B,T,G.name,se,z))}const ue={insertSpaces:!1,tabSize:4,eol:g.isLinux||g.isMacintosh?`
`:`\r
`},le=n.setProperty(P,["folders"],oe,ue);let me=n.applyEdits(P,le);return(0,f.isEqualAuthority)(H.remoteAuthority,(0,y.getRemoteAuthority)(N))&&(me=n.applyEdits(me,n.removeProperty(me,["remoteAuthority"],ue))),me}e.rewriteWorkspaceFileForNewLocation=c;function i(P,A){const O=M.parse(A);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(N=>h(N));else throw new Error(`${P} looks like an invalid workspace file.`);return O}function r(P){return P.workspace&&typeof P.workspace=="object"&&typeof P.workspace.id=="string"&&typeof P.workspace.configPath=="string"}function o(P){return typeof P.folderUri=="string"}function u(P){return typeof P.fileUri=="string"}function s(P,A){const O={workspaces:[],files:[]};if(P){const N=function(H,ie){for(let se=0;se<H.length;se++)try{ie(H[se],se)}catch(oe){A.warn(`Error restoring recent entry ${JSON.stringify(H[se])}: ${oe.toString()}. Skip entry.`)}},z=P;Array.isArray(z.entries)&&N(z.entries,H=>{const ie=H.label,se=H.remoteAuthority;r(H)?O.workspaces.push({label:ie,remoteAuthority:se,workspace:{id:H.workspace.id,configPath:b.URI.parse(H.workspace.configPath)}}):o(H)?O.workspaces.push({label:ie,remoteAuthority:se,folderUri:b.URI.parse(H.folderUri)}):u(H)&&O.files.push({label:ie,remoteAuthority:se,fileUri:b.URI.parse(H.fileUri)})})}return O}e.restoreRecentlyOpened=s;function l(P){const A={entries:[]};for(const O of P.workspaces)p(O)?A.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):A.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of P.files)A.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return A}e.toStoreData=l}),define(Z[97],_([0,1,81,14,4,18]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function C(f){function b(){let v=f.scheme===M.Schemas.file?(0,R.originalFSPath)(f):f.toString();return n.isLinux||(v=v.toLowerCase()),(0,E.createHash)("md5").update(v).digest("hex")}return{id:b(),configPath:f}}e.getWorkspaceIdentifier=C;function k(f,b){function v(){if(f.scheme!==M.Schemas.file)return(0,E.createHash)("md5").update(f.toString()).digest("hex");if(!b)return;let d;return n.isLinux?d=b.ino:n.isMacintosh?d=b.birthtime.getTime():n.isWindows&&(typeof b.birthtimeMs=="number"?d=Math.floor(b.birthtimeMs):d=b.birthtime.getTime()),(0,E.createHash)("md5").update(f.fsPath).update(d?String(d):"").digest("hex")}const y=v();if(typeof y=="string")return{id:y,uri:f}}e.getSingleFolderWorkspaceIdentifier=k;function g(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=g}),define(Z[276],_([0,1,81,32,14,9,4,18,23,187,19,28,33,16,5,186,29,97]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let m=class vt{constructor(S,D,t,c){this.j=S,this.k=D,this.l=t,this.m=c,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,r)=>(0,M.isEqual)(i,r,!C.isLinux)}}async initialize(){const S=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(S.emptyWindows),this.d=await this.u((0,f.deserializeWorkspaceInfos)(S)),this.e=await this.v((0,f.deserializeFolderInfos)(S)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==d.HotExitConfiguration.OFF}q(){return this.s()===d.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||d.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(S,D){this.d.some(c=>S.workspace.id===c.workspace.id)||(this.d.push(S),this.C());const t=(0,R.join)(this.c,S.workspace.id);return D?this.t(t,D).then(()=>t):t}async t(S,D){if(await g.Promises.exists(S)&&await this.z(S),await g.Promises.exists(D))try{await g.Promises.rename(D,S)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(S){return this.e.some(D=>this.h.isEqual(S.folderUri,D.folderUri))||(this.e.push(S),this.C()),(0,R.join)(this.c,this.D(S))}registerEmptyWindowBackup(S){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.backupFolder))||(this.g.push(S),this.C()),(0,R.join)(this.c,S.backupFolder)}async u(S){if(!Array.isArray(S))return[];const D=new Set,t=[];for(const c of S){const i=c.workspace;if(!(0,a.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const r=(0,R.join)(this.c,i.id);await this.B(r)?i.configPath.scheme!==n.Schemas.file||await g.Promises.exists(i.configPath.fsPath)?t.push(c):await this.z(r):await this.x(r)}}return t}async v(S){if(!Array.isArray(S))return[];const D=[],t=new Set;for(const c of S){const i=c.folderUri,r=this.h.getComparisonKey(i);if(!t.has(r)){t.add(r);const o=(0,R.join)(this.c,this.D(c));await this.B(o)?i.scheme!==n.Schemas.file||await g.Promises.exists(i.fsPath)?D.push(c):await this.z(o):await this.x(o)}}return D}async w(S){if(!Array.isArray(S))return[];const D=[],t=new Set;for(const c of S){const i=c.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const r=(0,R.join)(this.c,i);await this.B(r)?D.push(c):await this.x(r)}}return D}async x(S){try{await g.Promises.rm(S,g.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let S=(0,h.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.id));)S=(0,h.createEmptyWorkspaceIdentifier)();return{backupFolder:S.id}}async z(S){const D=this.y(),t=(0,R.join)(this.c,D.backupFolder);try{await g.Promises.rename(S,t)}catch(c){return this.l.error(`Backup: Could not rename backup folder: ${c.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const S=[];for(const D of this.d)await this.A(D)&&S.push(D);for(const D of this.e)await this.A(D)&&S.push(D);return S}A(S){let D;return(0,f.isEmptyWindowBackupInfo)(S)?D=(0,R.join)(this.c,S.backupFolder):(0,p.isFolderBackupInfo)(S)?D=(0,R.join)(this.c,this.D(S)):D=(0,R.join)(this.c,S.workspace.id),this.B(D)}async B(S){try{const D=await g.Promises.readdir(S);for(const t of D)try{if((await g.Promises.readdir((0,R.join)(S,t))).length>0)return!0}catch{}}catch{}return!1}C(){const S={workspaces:this.d.map(({workspace:D,remoteAuthority:t})=>{const c={id:D.id,configURIPath:D.configPath.toString()};return t&&(c.remoteAuthority=t),c}),folders:this.e.map(({folderUri:D,remoteAuthority:t})=>{const c={folderUri:D.toString()};return t&&(c.remoteAuthority=t),c}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:t})=>{const c={backupFolder:D};return t&&(c.remoteAuthority=t),c})};this.m.setItem(vt.a,S)}D(S){const D=S.folderUri;let t;return D.scheme===n.Schemas.file?t=C.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};m.a="backupWorkspaces",m=ve([Q(0,v.IEnvironmentMainService),Q(1,b.IConfigurationService),Q(2,w.ILogService),Q(3,y.IStateService)],m),e.BackupMainService=m}),define(Z[53],_([0,1,15,3,43,2,14,9,18,10,23,185,63,57,28,6,5,52,124,29,96,97]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,p.createDecorator)("workspacesManagementMainService");let t=class extends R.Disposable{constructor(i,r,o,u,s){super(),this.g=i,this.h=r,this.i=o,this.j=u,this.k=s,this.a=this.B(new M.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new M.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await b.Promises.readdir(this.c.fsPath)).map(r=>(0,g.joinPath)(this.c,r,I.UNTITLED_WORKSPACE_NAME));for(const r of i){const o=(0,D.getWorkspaceIdentifier)(r),u=await this.resolveLocalWorkspace(r);u?this.f.push({workspace:o,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,r=>b.Promises.readFile(r,"utf8"))}l(i,r){if(!!this.m(i)&&i.scheme===C.Schemas.file)try{const o=r(i.fsPath);return o instanceof Promise?o.then(u=>this.n(i,u),u=>{}):this.n(i,o)}catch{return}}m(i){return(0,I.isUntitledWorkspace)(i,this.g)||(0,I.hasWorkspaceFileExtension)(i)}n(i,r){try{const o=this.p(i,r),u=(0,D.getWorkspaceIdentifier)(i);return{id:u.id,configPath:u.configPath,folders:(0,S.toWorkspaceFolders)(o.folders,u.configPath,g.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(i,r){const o=(0,n.parse)(r);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(u=>(0,S.isStoredWorkspaceFolder)(u));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,r){const{workspace:o,storedWorkspace:u}=this.r(i,r),s=o.configPath.fsPath;return await b.Promises.mkdir((0,k.dirname)(s),{recursive:!0}),await b.Promises.writeFile(s,JSON.stringify(u,null,"	")),this.f.push({workspace:o,remoteAuthority:r}),o}r(i=[],r){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,g.joinPath)(this.c,o),s=(0,g.joinPath)(u,I.UNTITLED_WORKSPACE_NAME),l=[];for(const P of i)l.push((0,S.getStoredWorkspaceFolder)(P.uri,!0,P.name,u,g.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(s),storedWorkspace:{folders:l,remoteAuthority:r}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,I.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){!this.isUntitledWorkspace(i)||(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const r=(0,g.originalFSPath)(i.configPath);try{await b.Promises.rm((0,k.dirname)(r));const o=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await b.Promises.exists(o)&&await b.Promises.writeFile((0,k.join)(o,"obsolete"),""),this.f=this.f.filter(u=>u.workspace.id!==i.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${r} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,r,o){if(!i||!i.win||!i.isReady||!await this.t(i,r,o))return;const s=await this.u(i,(0,D.getWorkspaceIdentifier)(o));if(!!s)return this.b.fire({window:i,workspace:s.workspace}),s}async t(i,r,o){return o?(0,I.isWorkspaceIdentifier)(i.openedWorkspace)&&g.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,m.findWindowOnWorkspaceOrFolder)(r,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:(0,v.localize)(1,null,(0,g.basename)(o)),detail:(0,v.localize)(2,null)},(0,f.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,r){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:r,remoteAuthority:i.remoteAuthority})),(0,I.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=r,i.config.backupPath=o,{workspace:r,backupPath:o}}};t=ve([Q(0,w.IEnvironmentMainService),Q(1,a.ILogService),Q(2,h.IUserDataProfilesMainService),Q(3,y.IBackupMainService),Q(4,d.IDialogMainService)],t),e.WorkspacesManagementMainService=t}),define(Z[125],_([0,1,15,42,22,6,30,29,53,10,5]),function(x,e,E,M,n,R,C,k,g,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,R.createDecorator)(e.ID);let v=class{constructor(d,w,p){this.a=d,this.b=w,this.c=p}async getRemoteDiagnostics(d){const w=this.a.getWindows();return(await Promise.all(w.map(async a=>{const h=a.remoteAuthority;if(!h)return;const m=`vscode:getDiagnosticInfoResponse${a.id}`,I={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.f(a):void 0};return new Promise(S=>{a.sendWhenReady("vscode:getDiagnosticInfo",n.CancellationToken.None,{replyChannel:m,args:I}),M.validatedIpcMain.once(m,(D,t)=>{t||S({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),S(t)}),setTimeout(()=>{S({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(a=>!!a)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const d=[];for(const w of E.BrowserWindow.getAllWindows()){const p=this.a.getWindowById(w.id);p?d.push(await this.d(p)):d.push(this.e(w))}return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(d){const w=await this.f(d),p=(0,f.assertIsDefined)(d.win);return this.e(p,w,d.remoteAuthority)}e(d,w=[],p){return{pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:w,remoteAuthority:p}}async f(d){const w=[],p=d.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(p))w.push(p.uri);else if((0,k.isWorkspaceIdentifier)(p)){const a=await this.b.resolveLocalWorkspace(p.configPath);a&&a.folders.forEach(m=>{w.push(m.uri)})}return w}};v=ve([Q(0,C.IWindowsMainService),Q(1,g.IWorkspacesManagementMainService),Q(2,b.ILogService)],v),e.DiagnosticsMainService=v}),define(Z[58],_([0,1,46,15,26,150,54,3,2,14,9,4,8,102,84,23,99,175,57,28,6,20,5,21,69,30,29,53,17,234,227,33]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c,i,r,o,u,s,l,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,S.createDecorator)("nativeHostMainService");let O=class extends g.Disposable{constructor(z,H,ie,se,oe,ue,le,me,G,B){super(),this.a=z,this.b=H,this.c=ie,this.f=se,this.g=oe,this.h=ue,this.i=le,this.j=me,this.k=G,this.l=B,this.onDidOpenWindow=k.Event.map(this.b.onDidOpenWindow,T=>T.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:T,x:q,y:Y})=>({windowId:T.id,x:q,y:Y})),({windowId:T})=>!!this.b.getWindowById(T)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-maximize",(T,q)=>q.id),T=>!!this.b.getWindowById(T)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-unmaximize",(T,q)=>q.id),T=>!!this.b.getWindowById(T)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-blur",(T,q)=>q.id),T=>!!this.b.getWindowById(T)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.b.onDidChangeWindowsCount,()=>this.b.getLastActiveWindow()),T=>!!T),T=>T.id),k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-focus",(T,q)=>q.id),T=>!!this.b.getWindowById(T))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(M.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.m=this.B(new k.Emitter),this.onDidChangePassword=this.m.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(M.screen,"display-metrics-changed",(T,q,Y)=>Y),T=>!(Array.isArray(T)&&T.length===1&&T[0]==="workArea")),k.Event.fromNodeEventEmitter(M.screen,"display-added"),k.Event.fromNodeEventEmitter(M.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.b.getWindows().map(H=>({id:H.id,workspace:H.openedWorkspace??(0,o.toWorkspaceIdentifier)(H.backupPath,H.isExtensionDevelopmentHost),title:H.win?.getTitle()??"",filename:H.getRepresentedFilename(),dirty:H.isDocumentEdited()}))}async getWindowCount(z){return this.b.getWindowCount()}async getActiveWindowId(z){const H=M.BrowserWindow.getFocusedWindow()||this.b.getLastActiveWindow();if(H)return H.id}openWindow(z,H,ie){return Array.isArray(H)?this.n(z,H,ie):this.p(z,H)}async n(z,H,ie=Object.create(null)){H.length>0&&await this.b.open({context:5,contextWindowId:z,urisToOpen:H,cli:this.g.args,forceNewWindow:ie.forceNewWindow,forceReuseWindow:ie.forceReuseWindow,preferNewWindow:ie.preferNewWindow,diffMode:ie.diffMode,mergeMode:ie.mergeMode,addMode:ie.addMode,gotoLineMode:ie.gotoLineMode,noRecentEntry:ie.noRecentEntry,waitMarkerFileURI:ie.waitMarkerFileURI,remoteAuthority:ie.remoteAuthority||void 0,forceProfile:ie.forceProfile,forceTempProfile:ie.forceTempProfile})}async p(z,H){await this.b.openEmptyWindow({context:5,contextWindowId:z},H)}async toggleFullScreen(z){this.w(z)?.toggleFullScreen()}async handleTitleDoubleClick(z){this.w(z)?.handleTitleDoubleClick()}async isMaximized(z){const H=this.w(z);return H?.win?H.win.isMaximized():!1}async maximizeWindow(z){const H=this.w(z);H?.win&&H.win.maximize()}async unmaximizeWindow(z){const H=this.w(z);H?.win&&H.win.unmaximize()}async minimizeWindow(z){const H=this.w(z);H?.win&&H.win.minimize()}async updateWindowControls(z,H){const ie=this.w(z);ie&&ie.updateWindowControls(H)}async focusWindow(z,H){H&&typeof H.windowId=="number"&&(z=H.windowId),this.w(z)?.focus({force:H?.force??!1})}async setMinimumSize(z,H,ie){const se=this.w(z);if(se?.win){const[oe,ue]=se.win.getSize(),[le,me]=se.win.getMinimumSize(),[G,B]=[H??le,ie??me],[T,q]=[Math.max(oe,G),Math.max(ue,B)];(le!==G||me!==B)&&se.win.setMinimumSize(G,B),(oe!==T||ue!==q)&&se.win.setSize(T,q)}}async saveWindowSplash(z,H){this.j.saveWindowSplash(z,H)}async installShellCommand(z){const{source:H,target:ie}=await this.r();try{const{symbolicLink:se}=await p.SymlinkSupport.stat(H);if(se&&!se.dangling){const oe=await(0,d.realpath)(H);if(ie===oe)return}await p.Promises.unlink(H)}catch(se){if(se.code!=="ENOENT")throw se}try{await p.Promises.symlink(ie,H)}catch(se){if(se.code!=="EACCES"&&se.code!=="ENOENT")throw se;const{response:oe}=await this.showMessageBox(z,{type:"info",message:(0,h.localize)(0,null,this.i.nameShort),buttons:[(0,h.localize)(1,null),(0,h.localize)(2,null)]});if(oe===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${ie}' '${H}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(ue)}catch{throw new Error((0,h.localize)(3,null,H))}}}async uninstallShellCommand(z){const{source:H}=await this.r();try{await p.Promises.unlink(H)}catch(ie){switch(ie.code){case"EACCES":{const{response:se}=await this.showMessageBox(z,{type:"info",message:(0,h.localize)(4,null,this.i.nameShort),buttons:[(0,h.localize)(5,null),(0,h.localize)(6,null)]});if(se===0)try{const oe=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(oe)}catch{throw new Error((0,h.localize)(7,null,H))}break}case"ENOENT":break;default:throw ie}}}async r(){const z=(0,b.resolve)(this.g.appRoot,"bin","code"),H=`/usr/local/bin/${this.i.applicationName}`;if(!await p.Promises.exists(z))throw new Error((0,h.localize)(8,null,z));return{source:H,target:z}}async showMessageBox(z,H){return this.c.showMessageBox(H,this.s(z))}async showSaveDialog(z,H){return this.c.showSaveDialog(H,this.s(z))}async showOpenDialog(z,H){return this.c.showOpenDialog(H,this.s(z))}s(z){const H=this.w(z);if(H?.win)return H.win}async pickFileFolderAndOpen(z,H){const ie=await this.c.pickFileFolder(H);ie&&await this.t(await Promise.all(ie.map(async se=>await p.SymlinkSupport.existsDirectory(se)?{folderUri:y.URI.file(se)}:{fileUri:y.URI.file(se)})),H,z)}async pickFolderAndOpen(z,H){const ie=await this.c.pickFolder(H);ie&&await this.t(ie.map(se=>({folderUri:y.URI.file(se)})),H,z)}async pickFileAndOpen(z,H){const ie=await this.c.pickFile(H);ie&&await this.t(ie.map(se=>({fileUri:y.URI.file(se)})),H,z)}async pickWorkspaceAndOpen(z,H){const ie=await this.c.pickWorkspace(H);ie&&await this.t(ie.map(se=>({workspaceUri:y.URI.file(se)})),H,z)}async t(z,H,ie){await this.b.open({context:3,contextWindowId:ie,cli:this.g.args,urisToOpen:z,forceNewWindow:H.forceNewWindow})}async showItemInFolder(z,H){M.shell.showItemInFolder(H)}async setRepresentedFilename(z,H){this.w(z)?.setRepresentedFilename(H)}async setDocumentEdited(z,H){this.w(z)?.setDocumentEdited(H)}async openExternal(z,H){return v.isLinuxSnap?this.u(H):M.shell.openExternal(H),!0}u(z){const H=process.env.GDK_PIXBUF_MODULE_FILE,ie=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,M.shell.openExternal(z),process.env.GDK_PIXBUF_MODULE_FILE=H,process.env.GDK_PIXBUF_MODULEDIR=ie}moveItemToTrash(z,H){return M.shell.trashItem(H)}async isAdmin(){let z;return v.isWindows?z=(await new Promise((H,ie)=>{x(["native-is-elevated"],H,ie)}))():z=process.getuid()===0,z}async writeElevated(z,H,ie,se){const oe=await new Promise((ue,le)=>{x(["@vscode/sudo-prompt"],ue,le)});return new Promise((ue,le)=>{const me=[`"${this.v}"`];se?.unlock&&me.push("--file-chmod"),me.push("--file-write",`"${H.fsPath}"`,`"${ie.fsPath}"`);const G={name:this.i.nameLong.replace("-",""),icns:v.isMacintosh&&this.g.isBuilt?(0,b.join)((0,b.dirname)(this.g.appRoot),`${this.i.nameShort}.icns`):void 0};oe.exec(me.join(" "),G,(B,T,q)=>{T&&this.h.trace(`[sudo-prompt] received stdout: ${T}`),q&&this.h.trace(`[sudo-prompt] received stderr: ${q}`),B?le(B):ue(void 0)})})}get v(){return v.isWindows?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}.cmd`):(0,b.join)(this.g.appRoot,"scripts","code-cli.bat"):v.isLinux?this.g.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.i.applicationName}`):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,b.join)(this.g.appRoot,"bin","code"):(0,b.join)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,n.totalmem)(),freemem:(0,n.freemem)(),loadavg:(0,n.loadavg)()}}async getOSProperties(){return{arch:(0,n.arch)(),platform:(0,n.platform)(),release:(0,n.release)(),type:(0,n.type)(),cpus:(0,n.cpus)()}}async getOSVirtualMachineHint(){return w.virtualMachineHint.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return v.isWindows&&(0,l.hasWSLFeatureInstalled)()}async killProcess(z,H,ie){process.kill(H,ie)}async readClipboardText(z,H){return M.clipboard.readText(H)}async writeClipboardText(z,H,ie){return M.clipboard.writeText(H,ie)}async readClipboardFindText(z){return M.clipboard.readFindText()}async writeClipboardFindText(z,H){return M.clipboard.writeFindText(H)}async writeClipboardBuffer(z,H,ie,se){return M.clipboard.writeBuffer(H,Buffer.from(ie.buffer),se)}async readClipboardBuffer(z,H){return s.VSBuffer.wrap(M.clipboard.readBuffer(H))}async hasClipboard(z,H,ie){return M.clipboard.has(H,ie)}async newWindowTab(){await this.b.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){M.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){M.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){M.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){M.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){M.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(z,H){this.w(z)?.updateTouchBar(H)}async notifyReady(z){this.w(z)?.setReady()}async relaunch(z,H){return this.f.relaunch(H)}async reload(z,H){const ie=this.w(z);if(ie){if((0,o.isWorkspaceIdentifier)(ie.openedWorkspace)){const se=ie.openedWorkspace.configPath;if(se.scheme===f.Schemas.file&&(await this.l.resolveLocalWorkspace(se))?.transient)return this.openWindow(ie.id,{forceReuseWindow:!0})}return this.f.reload(ie,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow(z){this.closeWindowById(z,z)}async closeWindowById(z,H){const ie=this.w(H);if(ie?.win)return ie.win.close()}async quit(z){const H=this.b.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.b.getWindowCount()>1&&H.win?H.win.close():this.f.quit()}async exit(z,H){await this.f.kill(H)}async resolveProxy(z,H){const se=this.w(z)?.win?.webContents?.session;if(se)return se.resolveProxy(H)}findFreePort(z,H,ie,se,oe=1){return(0,a.findFreePort)(H,ie,se,oe)}async openDevTools(z,H){const ie=this.w(z);ie?.win&&ie.win.webContents.openDevTools(H)}async toggleDevTools(z){const H=this.w(z);H?.win&&H.win.webContents.toggleDevTools()}async sendInputEvent(z,H){const ie=this.w(z);ie?.win&&(H.type==="mouseDown"||H.type==="mouseUp")&&ie.win.webContents.sendInputEvent(H)}async enableSandbox(z,H){H?this.k.setItem("window.experimental.useSandbox",!0):this.k.removeItem("window.experimental.useSandbox")}async toggleSharedProcessWindow(){return this.a.toggle()}async profileRenderer(z,H,ie){const se=this.w(z);if(!se||!se.win)throw new Error;return await new P.WindowProfiler(se.win,H,this.h).inspect(ie)}async windowsGetStringRegKey(z,H,ie,se){if(!v.isWindows)return;const oe=await new Promise((ue,le)=>{x(["@vscode/windows-registry"],ue,le)});try{return oe.GetStringRegKey(H,ie,se)}catch{return}}w(z){if(typeof z=="number")return this.b.getWindowById(z)}};ve([C.memoize],O.prototype,"v",null),O=ve([Q(1,r.IWindowsMainService),Q(2,m.IDialogMainService),Q(3,D.ILifecycleMainService),Q(4,I.IEnvironmentMainService),Q(5,t.ILogService),Q(6,c.IProductService),Q(7,i.IThemeMainService),Q(8,A.IStateService),Q(9,u.IWorkspacesManagementMainService)],O),e.NativeHostMainService=O}),define(Z[277],_([0,1,15,42,26,2,14,4,103,173,87,125,57,28,6,5,58,66,21,67,77,32,10,33]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");const i="issue.processExplorerWindowState";let r=class kt{constructor(s,l,P,A,O,N,z,H,ie,se){this.g=s,this.h=l,this.i=P,this.j=A,this.k=O,this.l=N,this.m=z,this.n=H,this.o=ie,this.p=se,this.b=null,this.c=null,this.d=null,this.f=null,this.q()}q(){M.validatedIpcMain.on("vscode:issueSystemInfoRequest",async s=>{const[l,P]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),A=await this.j.getSystemInfo(l,P);this.r(s,"vscode:issueSystemInfoResponse",A)}),M.validatedIpcMain.on("vscode:listProcesses",async s=>{const l=[];try{l.push({name:(0,f.localize)(0,null),rootProcess:await(0,g.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(A=>{(0,b.isRemoteDiagnosticError)(A)?l.push({name:A.hostName,rootProcess:A}):A.processes&&l.push({name:A.hostName,rootProcess:A.processes})})}catch(P){this.i.error(`Listing processes failed: ${P}`)}this.r(s,"vscode:listProcessesResponse",l)}),M.validatedIpcMain.on("vscode:issueReporterClipboard",async s=>{if(this.b){const{response:l}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(1,null),buttons:[(0,f.localize)(2,null),(0,f.localize)(3,null)]},this.b);this.r(s,"vscode:issueReporterClipboardResponse",l===0)}}),M.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const l=await this.v();this.r(s,"vscode:issuePerformanceInfoResponse",l)}),M.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{if(this.b){const{response:s}=await this.l.showMessageBox({type:"warning",message:(0,f.localize)(4,null),buttons:[(0,f.localize)(5,null),(0,f.localize)(6,null)]},this.b);s===0&&this.b&&(this.b.destroy(),this.b=null)}}),M.validatedIpcMain.on("vscode:workbenchCommand",(s,l)=>{const{id:P,from:A,args:O}=l;let N;switch(A){case"issueReporter":N=this.c;break;case"processExplorer":N=this.f;break;default:throw new Error(`Unexpected command source: ${A}`)}N?.webContents.send("vscode:runAction",{id:P,from:A,args:O})}),M.validatedIpcMain.on("vscode:openExternal",(s,l)=>{this.m.openExternal(void 0,l)}),M.validatedIpcMain.on("vscode:closeIssueReporter",s=>{this.b?.close()}),M.validatedIpcMain.on("vscode:closeProcessExplorer",s=>{this.d?.close()}),M.validatedIpcMain.on("vscode:windowsInfoRequest",async s=>{const l=await this.k.getMainDiagnostics();this.r(s,"vscode:windowsInfoResponse",l.windows)})}r(s,l,...P){s.sender.isDestroyed()||s.sender.send(l,...P)}async openReporter(s){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const l=new R.DisposableStore,P=l.add(this.n.createIPCObjectUrl()),A=this.u(this.c,700,800);this.b=this.t(A,P,{backgroundColor:s.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:s.zoomLevel,alwaysOnTop:!1},"issue-reporter"),P.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:s,disableExtensions:!!this.h.disableExtensions,os:{type:(0,n.type)(),arch:(0,n.arch)(),release:(0,n.release)()},product:h.default}),this.b.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,l.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,l.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(s){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const l=new R.DisposableStore,P=l.add(this.n.createIPCObjectUrl()),A=this.p.getItem(i,void 0),O=o(A)?A:this.u(this.f,800,500),N=E.screen.getDisplayNearestPoint({x:O.x,y:O.y});O.width/=N.scaleFactor,O.height/=N.scaleFactor,this.d=this.t(O,P,{backgroundColor:s.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:s.zoomLevel,alwaysOnTop:!0},"process-explorer"),P.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:s,product:h.default}),this.d.loadURL(C.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,l.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,l.dispose())});const z=()=>{if(!this.d)return;const H=this.d.getSize(),ie=this.d.getPosition();if(!H||!ie)return;const se={width:H[0],height:H[1],x:ie[0],y:ie[1]};this.p.setItem(i,se)};this.d.on("moved",z),this.d.on("resized",z)}this.d&&this.s(this.d)}s(s){s.isMinimized()&&s.restore(),s.focus()}t(s,l,P,A){const O=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:P.title,backgroundColor:P.backgroundColor||kt.a,webPreferences:{preload:C.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,`--vscode-window-kind=${A}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,S.zoomLevelToZoomFactor)(P.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:P.alwaysOnTop,experimentalDarkMode:!0});return O.setMenuBarVisibility(!1),O}async getSystemStatus(){const[s,l]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(s,l)}u(s,l,P){let A;const O=E.screen.getAllDisplays();if(O.length===1)A=O[0];else{if(k.isMacintosh){const H=E.screen.getCursorScreenPoint();A=E.screen.getDisplayNearestPoint(H)}!A&&s&&(A=E.screen.getDisplayMatching(s.getBounds())),A||(A=E.screen.getPrimaryDisplay()||O[0])}const N=A.bounds,z={width:l,height:P,x:N.x+N.width/2-l/2,y:N.y+N.height/2-P/2};return N.width>0&&N.height>0&&(z.x<N.x&&(z.x=N.x),z.y<N.y&&(z.y=N.y),z.x>N.x+N.width&&(z.x=N.x),z.y>N.y+N.height&&(z.y=N.y),z.width>N.width&&(z.width=N.width),z.height>N.height&&(z.height=N.height)),z}async v(){try{const[s,l]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(s,l)}catch(s){throw this.i.warn("issueService#getPerformanceInfo ",s.message),s}}async stopTracing(){if(!this.h.args.trace)return;const s=await E.contentTracing.stopRecording(`${(0,D.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,f.localize)(9,null),detail:(0,f.localize)(10,null,s),buttons:[(0,f.localize)(11,null)]},(0,t.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,s)}};r.a="#1E1E1E",r=ve([Q(1,d.IEnvironmentMainService),Q(2,p.ILogService),Q(3,b.IDiagnosticsService),Q(4,v.IDiagnosticsMainService),Q(5,y.IDialogMainService),Q(6,a.INativeHostMainService),Q(7,I.IProtocolMainService),Q(8,m.IProductService),Q(9,c.IStateService)],r),e.IssueMainService=r;function o(u){return typeof u!="object"||u===null?!1:"x"in u&&"y"in u&&"width"in u&&"height"in u}}),define(Z[278],_([0,1,22,19,28,20,5,58,21,56,24,48,93]),function(x,e,E,M,n,R,C,k,g,f,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let d=class extends y.AbstractUpdateService{constructor(p,a,h,m,I,S,D,t){super(p,a,m,I,S,t),this.e=h,this.t=D}r(p){return(0,y.createUpdateURL)(`linux-${process.arch}`,p,this.k)}s(p){!this.a||(this.d(v.State.CheckingForUpdates(p)),this.i.request({url:this.a},E.CancellationToken.None).then(f.asJson).then(a=>{!a||!a.url||!a.version||!a.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!p}),this.d(v.State.Idle(1))):this.d(v.State.AvailableForDownload(a))}).then(void 0,a=>{this.j.error(a),this.e.publicLog2("update:notAvailable",{explicit:!!p});const h=p?a.message||a:void 0;this.d(v.State.Idle(1,h))}))}async n(p){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.t.openExternal(void 0,this.k.downloadUrl):p.update.url&&this.t.openExternal(void 0,p.update.url),this.d(v.State.Idle(1))}};d=ve([Q(0,R.ILifecycleMainService),Q(1,M.IConfigurationService),Q(2,b.ITelemetryService),Q(3,n.IEnvironmentMainService),Q(4,f.IRequestService),Q(5,C.ILogService),Q(6,k.INativeHostMainService),Q(7,g.IProductService)],d),e.LinuxUpdateService=d}),define(Z[279],_([0,1,46,41,26,7,22,54,9,8,136,23,19,28,16,20,5,58,21,56,24,48,93]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function c(u,s=1e3){for(;!u();)await(0,R.timeout)(s)}let i;function r(){return typeof i>"u"&&(i=M.existsSync(g.join(g.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=class extends t.AbstractUpdateService{get cachePath(){const s=g.join((0,n.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return v.Promises.mkdir(s,{recursive:!0}).then(()=>s)}constructor(s,l,P,A,O,N,z,H,ie){super(s,l,A,O,N,ie),this.t=P,this.u=z,this.v=H}async initialize(){if(this.k.target==="user"&&await this.v.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}r(s){let l="win32";return process.arch!=="ia32"&&(l+=`-${process.arch}`),r()===1?l+="-archive":this.k.target==="user"&&(l+="-user"),(0,t.createUpdateURL)(l,s,this.k)}s(s){!this.a||(this.d(D.State.CheckingForUpdates(s)),this.i.request({url:this.a},C.CancellationToken.None).then(I.asJson).then(l=>{const P=r();return!l||!l.url||!l.version||!l.productVersion?(this.t.publicLog2("update:notAvailable",{explicit:!!s}),this.d(D.State.Idle(P)),Promise.resolve(null)):P===1?(this.d(D.State.AvailableForDownload(l)),Promise.resolve(null)):(this.d(D.State.Downloading(l)),this.A(l.version).then(()=>this.z(l.version).then(A=>v.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const N=l.url,z=l.hash,H=`${A}.tmp`;return this.i.request({url:N},C.CancellationToken.None).then(ie=>this.u.writeFile(f.URI.file(H),ie.stream)).then(z?()=>(0,b.checksum)(H,l.hash):()=>{}).then(()=>v.Promises.rename(H,A)).then(()=>A)})).then(A=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:A},O&&l.supportsFastUpdate?this.k.target==="user"?this.o():this.d(D.State.Downloaded(l)):this.d(D.State.Ready(l))})))}).then(void 0,l=>{this.j.error(l),this.t.publicLog2("update:notAvailable",{explicit:!!s});const P=s?l.message||l:void 0;this.d(D.State.Idle(r(),P))}))}async n(s){s.update.url&&this.v.openExternal(void 0,s.update.url),this.d(D.State.Idle(r()))}async z(s){const l=await this.cachePath;return g.join(l,`CodeSetup-${this.k.quality}-${s}.exe`)}async A(s=null){const l=s?N=>!new RegExp(`${this.k.quality}-${s}\\.exe$`).test(N):()=>!0,P=await this.cachePath,O=(await v.Promises.readdir(P)).filter(l).map(async N=>{try{await v.Promises.unlink(g.join(P,N))}catch{}});await Promise.all(O)}async o(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const s=this.state.update;this.d(D.State.Updating(s));const l=await this.cachePath;this.e.updateFilePath=g.join(l,`CodeSetup-${this.k.quality}-${s.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(r()))});const A=`${this.k.win32MutexName}-ready`,O=await new Promise((N,z)=>{x(["windows-mutex"],N,z)});c(()=>O.isActive(A)).then(()=>this.d(D.State.Ready(s)))}q(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?M.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}p(){return r()}async _applySpecificUpdate(s){if(this.state.type!=="idle")return;const l=this.g.getValue("update.enableWindowsBackgroundUpdates"),P={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!l};this.d(D.State.Downloading(P)),this.e={packagePath:s},l?this.k.target==="user"?this.o():this.d(D.State.Downloaded(P)):this.d(D.State.Ready(P))}};ve([k.memoize],o.prototype,"cachePath",null),o=ve([Q(0,p.ILifecycleMainService),Q(1,y.IConfigurationService),Q(2,S.ITelemetryService),Q(3,d.IEnvironmentMainService),Q(4,I.IRequestService),Q(5,a.ILogService),Q(6,w.IFileService),Q(7,h.INativeHostMainService),Q(8,m.IProductService)],o),e.Win32UpdateService=o}),define(Z[280],_([0,1,15,7,22,44,3,2,14,9,64,4,8,181,63,19,57,28,62,16,20,5,21,67,242,95,24,135,69,77,30,29,53,121,126,38,33,52,58,244,117,51,92,26,118,65]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c,i,r,o,u,s,l,P,A,O,N,z,H,ie,se,oe,ue,le,me,G,B,T,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Y;(function(ne){ne[ne.NONE=0]="NONE",ne[ne.NAVIGATING=1]="NAVIGATING",ne[ne.READY=2]="READY"})(Y||(Y={}));let te=class ot extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const L=this.Q.profiles.find(F=>F.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.Q.getProfileForWorkspace(this.config.workspace??(0,A.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(L,F,U,W,$,V,j,K,J,re,de,Ce,Re,De,Oe,$e,fe,pe,Me,ee,ce){super(),this.M=F,this.N=U,this.O=W,this.P=$,this.Q=V,this.R=j,this.S=K,this.U=J,this.W=re,this.X=de,this.Y=Ce,this.Z=Re,this.ab=De,this.bb=Oe,this.db=$e,this.eb=fe,this.fb=pe,this.gb=Me,this.hb=ee,this.ib=ce,this.c=this.B(new C.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new C.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new C.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new C.Emitter),this.onDidClose=this.h.event,this.j=this.B(new C.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.u=void 0,this.v=void 0,this.C=!1,this.D=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.B(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let he=!1;{const[Ie,Ae]=this.ub(L.state);this.s=Ie,this.M.trace("window#ctor: using window state",Ie);const Te=this.s.mode===0||this.s.mode===3;typeof ot.b>"u"&&(ot.b=this.hb.getItem("window.experimental.useSandbox",!1));const Fe=this.W.getValue("window");typeof Fe?.experimental?.useSandbox=="boolean"?he=Fe.experimental.useSandbox:this.eb.quality==="stable"&&ot.b?he=!0:he=typeof this.eb.quality=="string"&&this.eb.quality!=="stable",this.n=he;const je={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.X.getBackgroundColor(),minWidth:l.WindowMinimumSize.WIDTH,minHeight:l.WindowMinimumSize.HEIGHT,show:!Te,title:this.eb.nameLong,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,l.zoomLevelToZoomFactor)(Fe?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...he?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};v.isLinux?je.icon=(0,f.join)(this.O.appRoot,"resources/linux/code.png"):v.isWindows&&!this.O.isBuilt&&(je.icon=(0,f.join)(this.O.appRoot,"resources/win32/code_150x150.png")),v.isMacintosh&&!this.Bb()&&(je.fullscreenable=!1),v.isMacintosh&&(je.acceptFirstMouse=!0,Fe?.clickThroughInactive===!1&&(je.acceptFirstMouse=!1));const ze=v.isMacintosh&&Fe?.nativeTabs===!0;ze&&(je.tabbingIdentifier=this.eb.nameShort);const Ue=(0,l.getTitleBarStyle)(this.W)==="custom";if(Ue&&(je.titleBarStyle="hidden",v.isMacintosh||(je.frame=!1),(0,l.useWindowControlsOverlay)(this.W))){const He=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),X=z.Color.fromHex(He).isDarker()?"#FFFFFF":"#000000";je.titleBarOverlay={height:29,color:He,symbolColor:X},this.C=!0}if((0,b.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(je),(0,b.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,v.isMacintosh&&Ue&&this.l.setSheetOffset(22),Ue&&(v.isWindows&&(0,l.useWindowControlsOverlay)(this.W)||v.isMacintosh)){const He=this.hb.getItem(ot.a);He&&this.updateWindowControls({height:He})}v.isWindows&&Ue&&this.l.hookWindowMessage(278,()=>{const[X,ae]=this.l.getPosition(),ge=E.screen.getCursorScreenPoint(),be=ge.x-X,we=ge.y-ae;return(()=>!(be>30&&we>=0&&we<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:be,y:we})),0}),(v.isMacintosh||v.isWindows)&&Ae&&(!ze||E.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(He=>typeof He=="number")&&this.l.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),Te&&((0,b.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.s.mode===3&&this.xb(!0),this.l.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(he)}setRepresentedFilename(L){v.isMacintosh?this.l.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return v.isMacintosh?this.l.getRepresentedFilename():this.w}setDocumentEdited(L){v.isMacintosh&&this.l.setDocumentEdited(L),this.z=L}isDocumentEdited(){return v.isMacintosh?this.l.isDocumentEdited():!!this.z}focus(L){v.isMacintosh&&L?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.D.length;)this.D.pop()(this);this.f.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.D.push(L)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(L=>{function F(){U.dispose(),W.dispose(),L()}const U=this.onDidClose(()=>F()),W=this.onWillLoad(()=>F())})}kb(L){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:L})),this.l.webContents.on("render-process-gone",(U,W)=>this.nb(2,{...W,sandboxed:L})),this.l.webContents.on("did-fail-load",(U,W,$)=>this.nb(3,{reason:$,exitCode:W,sandboxed:L})),this.l.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.r=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",U=>{this.r&&(this.r.maximized=!0),E.app.emit("browser-window-maximize",U,this.l)}),this.l.on("unmaximize",U=>{this.r&&(this.r.maximized=!1),E.app.emit("browser-window-unmaximize",U,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",n.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.B(this.W.onDidChangeConfiguration(U=>this.rb(U))),this.B(this.Y.onDidDeleteUntitledWorkspace(U=>this.qb(U)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(U,W)=>{const $=await this.mb();W({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,$)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(L,F){switch(L){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${F?.reason||"<unknown>"}, code: ${F?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:L,reason:F?.reason,code:F?.exitCode,sandboxed:F?.sandboxed?"1":"0"}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:U,checkboxChecked:W}=await this.bb.showMessageBox({type:"warning",buttons:[(0,d.localize)(0,null),(0,d.localize)(1,null),(0,d.localize)(2,null)],message:(0,d.localize)(3,null),detail:(0,d.localize)(4,null),checkboxLabel:this.r?.workspace?(0,d.localize)(5,null):void 0},this.l);if(U!==2){const $=U===0;await this.pb($,W)}}else if(L===2)if(v.isWindows&&F?.reason==="launch-failed"&&F.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(F);else{let U;F?U=(0,d.localize)(7,null,F.reason,F.exitCode??"<unknown>"):U=(0,d.localize)(6,null);const{response:W,checkboxChecked:$}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,d.localize)(8,null):(0,d.localize)(9,null),(0,d.localize)(10,null)],message:U,detail:this.r?.workspace?(0,d.localize)(11,null):(0,d.localize)(12,null),checkboxLabel:this.r?.workspace?(0,d.localize)(13,null):void 0},this.l),V=W===0;await this.pb(V,$)}break}}async ob(L){const F=[],U=(0,me.isInternalTelemetry)(this.eb,this.W);if((0,me.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&F.push(new ue.OneDataSystemAppender(U,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const{installSourcePath:$}=this.O,V=await(0,T.resolveMachineId)(this.hb),j={appenders:F,sendErrorTelemetry:!1,commonProperties:(0,G.resolveCommonProperties)(this.R,(0,B.release)(),(0,B.hostname)(),process.arch,this.eb.commit,this.eb.version,V,U,$),piiPaths:(0,me.getPiiPathsFromEnvironment)(this.O)};await new le.TelemetryService(j,this.W,this.eb).publicLog2("windowadminerror",{reason:L.reason,code:L.exitCode})}const{response:W}=await this.bb.showMessageBox({type:"error",buttons:[(0,d.localize)(14,null),(0,d.localize)(15,null)],message:(0,d.localize)(16,null),detail:(0,d.localize)(17,null,this.eb.nameLong)},this.l);W===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(F.map($=>$.flush())),await this.pb(!1,!1)}async pb(L,F){const U=this.r?.workspace;if(F&&U)try{const W=this.U.workspaceStorage(U);await W.init(),W.delete("memento/workbench.parts.editor"),await W.close()}catch(W){this.M.error(W)}if(this.j.fire(),this.l?.destroy(),L&&this.r){let W,$;(0,A.isSingleFolderWorkspaceIdentifier)(U)?W={folderUri:U.uri}:(0,A.isWorkspaceIdentifier)(U)?W={workspaceUri:U.configPath}:$=!0;const[V]=await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.O.args,_:[]},urisToOpen:W?[W]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});V.focus()}}qb(L){this.r?.workspace?.id===L.id&&(this.r.workspace=void 0)}rb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const F=this.Cb();F!==this.t&&(this.t=F,this.Db(F))}if(!L||L.affectsConfiguration("http.proxy")){let F=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;F?.endsWith("/")&&(F=F.substr(0,F.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((F||"").indexOf("@")===-1&&(F!==this.G||U!==this.H)){this.G=F,this.H=U;const W=F||"",$=U?`${U},<local>`:"<local>";this.M.trace(`Setting proxy to '${W}', bypassing '${$}'`),this.l.webContents.session.setProxy({proxyRules:W,proxyBypassRules:$,pacScript:""})}}}addTabbedWindow(L){v.isMacintosh&&L.win&&this.l.addTabbedWindow(L.win)}load(L,F=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!F.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),F.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(L,F),this.jb===0?this.r=L:this.J=L,this.jb=1,this.l.loadURL(g.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.B(new M.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:L.workspace,reason:F.isReload?3:U?2:1})}sb(L,F){const U=(this.r??this.J)?.userEnv;if(U){const W=(0,m.isLaunchedFromCli)(U)&&!(0,m.isLaunchedFromCli)(L.userEnv),$=this.isExtensionDevelopmentHost;(W||$)&&(L.userEnv={...U,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),F.disableExtensions!==void 0&&(L["disable-extensions"]=F.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.l.isMaximized(),L.partsSplash=this.X.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),L.perfMarks=(0,b.getMarks)(),this.I.update(L)}async reload(L){const F=Object.assign({},this.r);F.workspace=await this.tb(F),delete F.filesToOpenOrCreate,delete F.filesToDiff,delete F.filesToMerge,delete F.filesToWait,this.isExtensionDevelopmentHost&&L&&(F.verbose=L.verbose,F.debugId=L.debugId,F.extensionEnvironment=L.extensionEnvironment,F["inspect-extensions"]=L["inspect-extensions"],F["inspect-brk-extensions"]=L["inspect-brk-extensions"],F["extensions-dir"]=L["extensions-dir"]),F.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),F.isInitialStartup=!1,F.policiesData=this.P.serialize(),F.continueOn=this.O.continueOn,F.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},F.logLevel=this.N.getLogLevel(),F.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(F,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async tb(L){if((0,A.isWorkspaceIdentifier)(L.workspace)){const F=L.workspace.configPath;if(F.scheme===g.Schemas.file&&!await this.R.exists(F))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(L.workspace)){const F=L.workspace.uri;if(F.scheme===g.Schemas.file&&!await this.R.exists(F))return}return L.workspace}serializeWindowState(){if(!this.l)return(0,N.defaultWindowState)();if(this.isFullScreen){let U;try{U=E.screen.getDisplayMatching(this.getBounds())}catch{}const W=(0,N.defaultWindowState)();return{mode:3,display:U?U.id:void 0,width:this.s.width||W.width,height:this.s.height||W.height,x:this.s.x||0,y:this.s.y||0}}const L=Object.create(null);let F;if(!v.isMacintosh&&this.l.isMaximized()?F=0:F=1,F===0?L.mode=0:L.mode=1,F===1||F===0){let U;F===1?U=this.getBounds():U=this.l.getNormalBounds(),L.x=U.x,L.y=U.y,L.width=U.width,L.height=U.height}return L}updateWindowControls(L){if(L.height&&this.hb.setItem(ot.a,L.height),v.isWindows&&this.C)this.l.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(v.isMacintosh&&L.height!==void 0){const F=(L.height-15)/2;this.l.setTrafficLightPosition({x:F,y:F})}}ub(L){(0,b.mark)("code/willRestoreCodeWindowState");let F=!1;if(L)try{const U=E.screen.getAllDisplays();F=U.length>1,L=this.vb(L,U)}catch(U){this.M.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[L||(0,N.defaultWindowState)(),F]}vb(L,F){if(this.M.trace(`window#validateWindowState: validating window state on ${F.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(F.length===1){const $=this.wb(F[0]);if($){let V=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!$||(L.x<$.x&&(L.x=$.x),L.y<$.y&&(L.y=$.y))};this.M.trace("window#validateWindowState: 1 monitor working area",$),V(),L.width>$.width&&(L.width=$.width),L.height>$.height&&(L.height=$.height),L.x>$.x+$.width-128&&(L.x=$.x+$.width-L.width),L.y>$.y+$.height-128&&(L.y=$.y+$.height-L.height),V()}return L}if(L.display&&L.mode===3){const $=F.find(V=>V.id===L.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const V=(0,N.defaultWindowState)(3);return V.x=$.bounds.x,V.y=$.bounds.y,V}}let U,W;try{U=E.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),W=this.wb(U)}catch{}if(U&&W&&L.x+L.width>W.x&&L.y+L.height>W.y&&L.x<W.x+W.width&&L.y<W.y+W.height)return this.M.trace("window#validateWindowState: multi-monitor working area",W),L}wb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,F]=this.l.getPosition(),[U,W]=this.l.getSize();return{x:L,y:F,width:U,height:W}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(L){this.Bb()?this.yb(L):this.Ab(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",n.CancellationToken.None),this.t&&this.Db(this.t,!1)}get isFullScreen(){return v.isMacintosh&&typeof this.u=="boolean"?this.u:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(L){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(L)}zb(L){v.isMacintosh&&(this.u=L,this.v=new M.DeferredPromise,Promise.race([this.v.p,(0,M.timeout)(1e3)]).finally(()=>this.u=void 0)),this.l.setFullScreen(L)}Ab(L){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(L),this.l.webContents.focus()}Bb(){const L=this.W.getValue("window");return!L||typeof L.nativeFullScreen!="boolean"||L.nativeTabs?!0:L.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let L=(0,l.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Db(L,F=!0){v.isMacintosh||(L==="toggle"&&F&&this.send("vscode:showInfoMessage",(0,d.localize)(18,null)),L==="hidden"?setTimeout(()=>{this.Eb(L)}):this.Eb(L))}Eb(L){const F=this.isFullScreen;switch(L){case"classic":this.l.setMenuBarVisibility(!F),this.l.autoHideMenuBar=F;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(v.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(L,F,...U){this.isReady?this.send(L,...U):this.ready().then(()=>{F.isCancellationRequested||this.send(L,...U)})}send(L,...F){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.l.webContents.send(L,...F)}catch(U){this.M.warn(`Error sending IPC message to channel '${L}' of window ${this.k}: ${(0,R.toErrorMessage)(U)}`)}}}updateTouchBar(L){!v.isMacintosh||this.F.forEach((F,U)=>{const W=L[U];F.segments=this.Hb(W)})}Fb(){if(!!v.isMacintosh){for(let L=0;L<10;L++){const F=this.Gb();this.F.push(F)}this.l.setTouchBar(new E.TouchBar({items:this.F}))}}Gb(L=[]){const F=this.Hb(L),U=new E.TouchBar.TouchBarSegmentedControl({segments:F,mode:"buttons",segmentStyle:"automatic",change:W=>{this.sendWhenReady("vscode:runAction",n.CancellationToken.None,{id:U.segments[W].id,from:"touchbar"})}});return U}Hb(L=[]){return L.map(U=>{let W;U.icon&&!u.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===g.Schemas.file&&(W=E.nativeImage.createFromPath(y.URI.revive(U.icon.dark).fsPath),W.isEmpty()&&(W=void 0));let $;return typeof U.title=="string"?$=U.title:$=U.title.value,{id:U.id,label:W?void 0:$,icon:W}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};te.a="windowControlHeight",te.b=void 0,te=ve([Q(1,D.ILogService),Q(2,q.ILoggerMainService),Q(3,h.IEnvironmentMainService),Q(4,H.IPolicyService),Q(5,se.IUserDataProfilesMainService),Q(6,I.IFileService),Q(7,r.IApplicationStorageMainService),Q(8,r.IStorageMainService),Q(9,p.IConfigurationService),Q(10,s.IThemeMainService),Q(11,O.IWorkspacesManagementMainService),Q(12,w.IBackupMainService),Q(13,o.ITelemetryService),Q(14,a.IDialogMainService),Q(15,S.ILifecycleMainService),Q(16,t.IProductService),Q(17,c.IProtocolMainService),Q(18,P.IWindowsMainService),Q(19,ie.IStateService),Q(20,oe.INativeHostMainService)],te),e.CodeWindow=te}),define(Z[79],_([0,1,15,25,7,3,45,2,14,4,18,8,23,184,6,20,5,95,96,29,53,35]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,w.createDecorator)("workspacesHistoryMainService");let t=class tt extends k.Disposable{constructor(i,r,o,u){super(),this.f=i,this.g=r,this.h=o,this.j=u,this.c=this.B(new R.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new n.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let r=[],o=[];for(const s of i)if((0,m.isRecentWorkspace)(s))!this.g.isUntitledWorkspace(s.workspace)&&!this.r(r,s.workspace)&&r.push(s);else if((0,m.isRecentFolder)(s))this.s(r,s.folderUri)||r.push(s);else{const l=this.t(o,s.fileUri),P=s.fileUri.scheme===g.Schemas.file&&tt.y.indexOf((0,b.basename)(s.fileUri))>=0;!l&&!P&&(o.push(s),f.isWindows&&s.fileUri.scheme===g.Schemas.file&&E.app.addRecentDocument(s.fileUri.fsPath))}const u=await this.l({workspaces:r,files:o});r=u.workspaces,o=u.files,r.length>tt.a&&(r.length=tt.a),o.length>tt.a&&(o.length=tt.a),await this.n({workspaces:r,files:o}),this.c.fire(),f.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const r=l=>{const P=this.p(l);for(const A of i)if(b.extUriBiasedIgnorePathCase.isEqual(A,P))return!1;return!0},o=await this.getRecentlyOpened(),u=o.workspaces.filter(r),s=o.files.filter(r);(u.length!==o.workspaces.length||s.length!==o.files.length)&&(await this.n({files:s,workspaces:u}),this.c.fire(),f.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const r=new D.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.workspaces)for(const s of i.workspaces)r.set(this.p(s),s);const o=new D.ResourceMap(s=>b.extUriBiasedIgnorePathCase.getComparisonKey(s));if(i?.files)for(const s of i.files)o.set(this.p(s),s);const u=await this.m();for(const s of u.workspaces){const l=r.get(this.p(s));l?l.label=l.label??s.label:r.set(this.p(s),s)}for(const s of u.files){const l=o.get(this.p(s));l?l.label=l.label??s.label:o.set(this.p(s),s)}return{workspaces:[...r.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const r=this.j.get(tt.b,-1);if(typeof r=="string")try{i=JSON.parse(r)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,m.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(tt.b,JSON.stringify((0,m.toStoreData)(i)),-1,1)}p(i){return(0,m.isRecentFolder)(i)?i.folderUri:(0,m.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,r){return!!i.find(o=>(0,m.isRecentWorkspace)(o)&&o.workspace.id===r.id)}s(i,r){return!!i.find(o=>(0,m.isRecentFolder)(o)&&b.extUriBiasedIgnorePathCase.isEqual(o.folderUri,r))}t(i,r){return!!i.find(o=>b.extUriBiasedIgnorePathCase.isEqual(o.fileUri,r))}async C(){!f.isWindows||(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!f.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,d.localize)(0,null),description:(0,d.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const r=[];for(const s of E.app.getJumpListSettings().removedItems){const l=s.args;if(l){const P=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(l);P&&r.push(v.URI.parse(P[2]))}}await this.removeRecentlyOpened(r);let o=!1;const u=(0,M.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.w).map(s=>{const l=(0,m.isRecentWorkspace)(s)?s.workspace:s.folderUri,{title:P,description:A}=this.F(l,s.label);let O;return v.URI.isUri(l)?O=`--folder-uri "${l.toString()}"`:(o=!0,O=`--file-uri "${l.configPath.toString()}"`),{type:"task",title:P.substr(0,255),description:A.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));u.length>0&&i.push({type:"custom",name:o?(0,d.localize)(2,null):(0,d.localize)(3,null),items:u})}i.push({type:"recent"});try{const r=E.app.setJumpList(i);r&&r!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${r}`)}catch(r){this.f.warn("updateWindowsJumpList#setJumpList",r)}}F(i,r){if(r)return{title:(0,C.splitName)(r).name,description:r};if(v.URI.isUri(i))return{title:(0,b.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,d.localize)(4,null),description:""};let o=(0,b.basename)(i.configPath);return o.endsWith(I.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-I.WORKSPACE_EXTENSION.length-1)),{title:(0,d.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,C.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!f.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),r=[];let o=0;for(let s=0;s<i.workspaces.length&&o<tt.u;s++){const l=this.p(i.workspaces[s]);if(l.scheme===g.Schemas.file){const P=(0,b.originalFSPath)(l);await y.Promises.exists(P)&&(r.push(P),o++)}}const u=[];for(let s=0;s<i.files.length&&o<tt.v;s++){const l=this.p(i.files[s]);if(l.scheme===g.Schemas.file){const P=(0,b.originalFSPath)(l);if(tt.y.includes((0,b.basename)(l))||r.includes(P))continue;await y.Promises.exists(P)&&(u.push(P),o++)}}u.reverse().forEach(s=>E.app.addRecentDocument(s)),r.reverse().forEach(s=>E.app.addRecentDocument(s))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],t=ve([Q(0,a.ILogService),Q(1,S.IWorkspacesManagementMainService),Q(2,p.ILifecycleMainService),Q(3,h.IApplicationStorageMainService)],t),e.WorkspacesHistoryMainService=t}),define(Z[281],_([0,1,15,7,22,45,4,8,174,19,28,20,5,222,58,21,33,24,48,77,30,79]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let c=class bt{constructor(o,u,s,l,P,A,O,N,z,H,ie){this.n=o,this.o=u,this.p=s,this.q=l,this.r=P,this.s=A,this.t=O,this.u=N,this.v=z,this.w=H,this.x=ie,this.m=Object.create(null),this.g=new M.RunOnceScheduler(()=>this.E(),0),this.h=new M.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(C.isMacintosh||(0,I.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(bt.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(A,O,N)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(A,O,N)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(A,O,N)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(A,O,N)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(A,O,N)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(N),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const u=this.x.requestFeatureUrl;u&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(u,"openUserVoiceUrl"));const s=this.x.reportIssueUrl;s&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(s,"openReportIssues"));const l=this.x.licenseUrl;l&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(C.language){const A=l.indexOf("?")>0?"&":"?";this.Z(`${l}${A}lang=${C.language}`,"openLicenseUrl")}else this.Z(l,"openLicenseUrl")});const P=this.x.privacyStatementUrl;P&&l&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(P,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!C.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,u){this.k=o.menus,this.l=o.keybindings,this.t.setItem(bt.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){!C.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){!C.isMacintosh||(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=E.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(C.isMacintosh?new E.Menu:null);return}const u=new E.Menu;let s;if(C.isMacintosh){const P=new E.Menu;s=new E.MenuItem({label:this.x.nameShort,submenu:P}),this.I(P),u.append(s)}if(C.isMacintosh&&!this.c){this.c=!0;const P=new E.Menu;P.append(new E.MenuItem({label:this.bb(g.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(P)}if(this.K("File")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(1,null)),submenu:P});this.M(P,"File"),u.append(A)}if(this.K("Edit")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(2,null)),submenu:P});this.M(P,"Edit"),u.append(A)}if(this.K("Selection")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(3,null)),submenu:P});this.M(P,"Selection"),u.append(A)}if(this.K("View")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(4,null)),submenu:P});this.M(P,"View"),u.append(A)}if(this.K("Go")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(5,null)),submenu:P});this.M(P,"Go"),u.append(A)}if(this.K("Run")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(6,null)),submenu:P});this.M(P,"Run"),u.append(A)}if(this.K("Terminal")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(7,null)),submenu:P});this.M(P,"Terminal"),u.append(A)}let l;if(this.K("Window")){const P=new E.Menu;l=new E.MenuItem({label:this.bb(g.localize(8,null)),submenu:P,role:"window"}),this.S(P)}if(l&&u.append(l),this.K("Help")){const P=new E.Menu,A=new E.MenuItem({label:this.bb(g.localize(9,null)),submenu:P,role:"help"});this.M(P,"Help"),u.append(A)}u.items&&u.items.length>0?E.Menu.setApplicationMenu(u):E.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const u=this.U(g.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),s=this.T();let l;if(this.K("Preferences")){const se=new E.Menu;this.M(se,"Preferences"),l=new E.MenuItem({label:this.bb(g.localize(11,null)),submenu:se})}const P=new E.Menu,A=new E.MenuItem({label:g.localize(12,null),role:"services",submenu:P}),O=new E.MenuItem({label:g.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),N=new E.MenuItem({label:g.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new E.MenuItem({label:g.localize(15,null),role:"unhide"}),H=new E.MenuItem(this.Y("workbench.action.quit",{label:g.localize(16,null,this.x.nameLong),click:async(se,oe,ue)=>{const le=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||le?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),ie=[u];ie.push(...s),l&&ie.push(i(),l),ie.push(i(),A,i(),O,N,z,i(),H),ie.forEach(se=>o.append(se))}async J(o){if(this.p.getWindowCount()===0)return!0;const u=this.o.getValue("window.confirmBeforeClose");if(u==="always"||u==="keyboardOnly"&&this.Q(o)){const{response:s}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[g.localize(17,null),g.localize(18,null)],message:g.localize(19,null)});return s===0}return!0}K(o){if(!C.isMacintosh&&(0,I.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(C.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,u){u.forEach(s=>{if((0,d.isMenubarMenuItemSeparator)(s))o.append(i());else if((0,d.isMenubarMenuItemSubmenu)(s)){const l=new E.Menu,P=new E.MenuItem({label:this.bb(s.label),submenu:l});this.L(l,s.submenu.items),o.append(P)}else(0,d.isMenubarMenuItemRecentAction)(s)?o.append(this.O(s)):(0,d.isMenubarMenuItemAction)(s)&&(s.id==="workbench.action.showAboutDialog"&&this.N(o),C.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[s.id]?o.append(new E.MenuItem(this.Y(s.id,{label:this.bb(s.label),click:this.m[s.id]}))):o.append(this.U(s.label,s.id,!1,s.checked)):o.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)):o.append(this.U(s.label,s.id,s.enabled!==!1,!!s.checked)))})}M(o,u){this.k&&this.k[u]&&this.L(o,this.k[u].items)}N(o){const u=this.T();u.length&&(u.forEach(s=>o.append(s)),o.append(i()))}O(o){const u=k.URI.revive(o.uri),s=o.id,l=s==="openRecentFile"?{fileUri:u}:s==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new E.MenuItem(this.Y(s,{label:o.label,click:async(P,A,O)=>{const N=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[l],forceNewWindow:N,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([u])}},!1))}P(o){return!!(o&&(!C.isMacintosh&&(o.ctrlKey||o.shiftKey)||C.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,u,s){const l={label:this.bb(o),role:s,enabled:!0};return new E.MenuItem(this.X(u,l))}S(o){const u=new E.MenuItem({label:g.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),s=new E.MenuItem({label:g.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),l=new E.MenuItem({label:g.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),P=this.U(g.localize(23,null),"workbench.action.switchWindow"),A=[];this.C&&(A.push(i()),A.push(this.U(g.localize(24,null),"workbench.action.newWindowTab")),A.push(this.R(g.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.R(g.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.R(g.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.R(g.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,s,i(),P,...A,i(),l].forEach(O=>o.append(O))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(g.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:g.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(g.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:g.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(g.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:g.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(g.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,u,s,l){const P=this.bb(o),A=typeof u=="function"?u:(ie,se,oe)=>{const ue=ie?ie.userSettingsLabel:null;let le=u;Array.isArray(u)&&(le=this.P(oe)?u[1]:u[0]),ue&&oe.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:le})},O=typeof s=="boolean"?s:this.p.getWindowCount()>0,N=typeof l=="boolean"?l:!1,z={label:P,click:A,enabled:O};N&&(z.type="checkbox",z.checked=N);let H;return typeof u=="string"?H=u:Array.isArray(u)&&(H=u[0]),C.isMacintosh&&(H==="editor.action.clipboardCutAction"?z.role="cut":H==="editor.action.clipboardCopyAction"?z.role="copy":H==="editor.action.clipboardPasteAction"&&(z.role="paste"),H==="undo"?z.click=this.V(A,{inDevTools:ie=>ie.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?z.click=this.V(A,{inDevTools:ie=>ie.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&(z.click=this.V(A,{inDevTools:ie=>ie.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(H,z))}V(o,u){return(s,l,P)=>{const A=E.BrowserWindow.getFocusedWindow();if(!A)return u.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return u.inDevTools(A.webContents.devToolsWebContents);o(s,l||A,P)}}W(o){let u=E.BrowserWindow.getFocusedWindow();if(!u){const l=this.p.getLastActiveWindow();l?.isMinimized()&&(u=l.win)}const s=u?this.p.getWindowById(u.id):void 0;if(s){if(this.v.trace("menubar#runActionInRenderer",o),C.isMacintosh&&!this.q.isBuilt&&!s.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const l={id:o.commandId,from:"menu"};s.sendWhenReady("vscode:runAction",n.CancellationToken.None,l)}else{const l={userSettingsLabel:o.userSettingsLabel};s.sendWhenReady("vscode:runKeybinding",n.CancellationToken.None,l)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,u){const s=typeof o=="string"?this.l[o]:void 0;if(s?.label){if(s.isNative!==!1)u.accelerator=s.label,u.userSettingsLabel=s.userSettingsLabel;else if(typeof u.label=="string"){const l=u.label.indexOf("[");l>=0?u.label=`${u.label.substr(0,l)} [${s.label}]`:u.label=`${u.label} [${s.label}]`}}else u.accelerator=void 0;return u}Y(o,u,s=!u.accelerator){s&&(u=this.X(o,u));const l=u.click;return u.click=(P,A,O)=>{this.ab(o),l?.(P,A,O)},u}Z(o,u){this.w.openExternal(void 0,o),this.ab(u)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,R.mnemonicMenuLabel)(o,!this.B)}};c.a="lastKnownMenubarData",c=ve([Q(0,m.IUpdateService),Q(1,f.IConfigurationService),Q(2,S.IWindowsMainService),Q(3,b.IEnvironmentMainService),Q(4,h.ITelemetryService),Q(5,D.IWorkspacesHistoryMainService),Q(6,a.IStateService),Q(7,v.ILifecycleMainService),Q(8,y.ILogService),Q(9,w.INativeHostMainService),Q(10,p.IProductService)],c),e.Menubar=c;function i(){return new E.MenuItem({type:"separator"})}}),define(Z[282],_([0,1,6,20,5,281]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let C=class{constructor(g,f,b){this.b=g,this.c=f,this.d=b,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.Menubar)}async updateMenubar(g,f){this.d.trace("menubarService#updateMenubar",g),(await this.a).updateMenu(f,g)}};C=ve([Q(0,E.IInstantiationService),Q(1,M.ILifecycleMainService),Q(2,n.ILogService)],C),e.MenubarMainService=C}),define(Z[283],_([0,1,15,23,26,25,22,3,32,49,45,2,14,9,64,4,36,18,10,8,182,63,19,57,28,16,6,20,5,66,67,55,33,77,280,124,275,29,97,79,53,69,38,52,65]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c,i,r,o,u,s,l,P,A,O,N,z,H,ie,se,oe,ue,le,me,G,B,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function q(ne){return(0,se.isWorkspaceIdentifier)(ne?.workspace)}function Y(ne){return(0,se.isSingleFolderWorkspaceIdentifier)(ne?.workspace)}let te=class at extends v.Disposable{constructor(L,F,U,W,$,V,j,K,J,re,de,Ce,Re,De,Oe,$e,fe,pe){super(),this.k=L,this.l=F,this.m=U,this.n=W,this.r=$,this.s=V,this.t=j,this.u=K,this.v=J,this.w=re,this.z=de,this.C=Ce,this.D=Re,this.F=De,this.G=Oe,this.H=$e,this.I=fe,this.J=pe,this.b=this.B(new k.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new k.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new k.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new k.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ie.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(L=>this.c.fire(L.window))),this.B(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const F=new v.DisposableStore;if(F.add(k.Event.any(L.onDidClose,L.onDidDestroy)(()=>F.dispose())),L.config.extensionDevelopmentPath)for(const U of L.config.extensionDevelopmentPath)F.add(this.I.addValidFileRoot(U));L.config.extensionTestsPath&&F.add(this.I.addValidFileRoot(L.config.extensionTestsPath))}}))}openEmptyWindow(L,F){const U=this.t.args,W=F?.remoteAuthority||void 0,$=!0,V=F?.forceReuseWindow,j=!V;return this.open({...L,cli:U,forceEmpty:$,forceNewWindow:j,forceReuseWindow:V,remoteAuthority:W})}openExistingWindow(L,F){L.focus(),this.M(F,[L])}async open(L){this.m.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const F=[],U=[],W=[],$=[],V=[];let j,K=0;const J=await this.S(L);this.m.trace("windowsManager#open pathsToOpen",J);for(const De of J)Y(De)?L.addMode?F.push(De):U.push(De):q(De)?W.push(De):De.fileUri?(j||(j={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:De.remoteAuthority}),j.filesToOpenOrCreate.push(De)):De.backupPath?V.push({backupFolder:(0,d.basename)(De.backupPath),remoteAuthority:De.remoteAuthority}):K++;L.diffMode&&j&&j.filesToOpenOrCreate.length>=2&&(j.filesToDiff=j.filesToOpenOrCreate.slice(0,2),j.filesToOpenOrCreate=[]),L.mergeMode&&j&&j.filesToOpenOrCreate.length===4&&(j.filesToMerge=j.filesToOpenOrCreate.slice(0,4),j.filesToOpenOrCreate=[],j.filesToDiff=[]),j&&L.waitMarkerFileURI&&(j.filesToWait={paths:(0,R.coalesce)([...j.filesToDiff,j.filesToMerge[3],...j.filesToOpenOrCreate]),waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?($.push(...this.D.getUntitledWorkspaces()),W.push(...$),V.push(...this.w.getEmptyWindowBackups())):V.length=0;const{windows:re,filesOpenedInWindow:de}=await this.N(L,W,U,V,K,j,F);if(this.m.trace(`windowsManager#open used window count ${re.length} (workspacesToOpen: ${W.length}, foldersToOpen: ${U.length}, emptyToRestore: ${V.length}, emptyToOpen: ${K})`),re.length>1)if(de)de.focus();else{const De=this.j.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let Oe=!0,$e=!0;if(De){const fe=re.filter(pe=>this.j.state.lastActiveWindow&&pe.backupPath===this.j.state.lastActiveWindow.backupPath);fe.length&&(fe[0].focus(),Oe=!1,$e=!1)}if(Oe)for(let fe=re.length-1;fe>=0;fe--){const pe=re[fe];if(!(pe.openedWorkspace&&$.some(Me=>pe.openedWorkspace&&Me.workspace.id===pe.openedWorkspace.id)||pe.backupPath&&V.some(Me=>pe.backupPath&&Me.backupFolder===(0,d.basename)(pe.backupPath)))){pe.focus(),$e=!1;break}}$e&&re[re.length-1].focus()}const Ce=j&&j.filesToDiff.length>0,Re=j&&j.filesToMerge.length>0;if(!re.some(De=>De.isExtensionDevelopmentHost)&&!Ce&&!Re&&!L.noRecentEntry){const De=[];for(const Oe of J)q(Oe)&&!Oe.transient?De.push({label:Oe.label,workspace:Oe.workspace,remoteAuthority:Oe.remoteAuthority}):Y(Oe)?De.push({label:Oe.label,folderUri:Oe.workspace.uri,remoteAuthority:Oe.remoteAuthority}):Oe.fileUri&&De.push({label:Oe.label,fileUri:Oe.fileUri,remoteAuthority:Oe.remoteAuthority});this.C.addRecentlyOpened(De)}return this.M(L,re),re}M(L,F){const U=L.waitMarkerFileURI;L.context===0&&U&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.H.del(U)}catch{}})()}async N(L,F,U,W,$,V,j){const K=[];let J;function re(fe,pe){K.push(fe),pe&&(J=fe,V=void 0)}let{openFolderInNewWindow:de,openFilesInNewWindow:Ce}=this.fb(L);if(!L.initialStartup&&j.length>0){const fe=j[0].remoteAuthority,pe=this.kb(fe);pe&&re(this.P(pe,j.map(Me=>Me.workspace.uri)))}const Re=U.length+F.length+W.length;if(V&&Re===0){const fe=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],pe=this.getWindows().filter(ee=>V&&(0,h.isEqualAuthority)(ee.remoteAuthority,V.remoteAuthority));let Me;fe?.fileUri&&!Ce&&((L.context===4||L.context===0||L.context===1)&&(Me=await(0,H.findWindowOnFile)(pe,fe.fileUri,async ee=>ee.configPath.scheme===y.Schemas.file?this.D.resolveLocalWorkspace(ee.configPath):void 0)),Me||(Me=this.lb(pe))),Me?(0,se.isWorkspaceIdentifier)(Me.openedWorkspace)?F.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)?U.push({workspace:Me.openedWorkspace,remoteAuthority:Me.remoteAuthority}):re(this.O(L,Me,V),!0):re(await this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile}),!0)}const De=(0,R.distinct)(F,fe=>fe.workspace.id);if(De.length>0){const fe=(0,R.coalesce)(De.map(pe=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.configPath)));if(fe.length>0){const pe=fe[0],Me=(0,h.isEqualAuthority)(V?.remoteAuthority,pe.remoteAuthority)?V:void 0;re(this.O(L,pe,Me),!!Me),de=!0}for(const pe of De){if(fe.some(ce=>ce.openedWorkspace&&ce.openedWorkspace.id===pe.workspace.id))continue;const Me=pe.remoteAuthority,ee=(0,h.isEqualAuthority)(V?.remoteAuthority,Me)?V:void 0;re(await this.R(L,pe,de,ee),!!ee),de=!0}}const Oe=(0,R.distinct)(U,fe=>h.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(Oe.length>0){const fe=(0,R.coalesce)(Oe.map(pe=>(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),pe.workspace.uri)));if(fe.length>0){const pe=fe[0],Me=(0,h.isEqualAuthority)(V?.remoteAuthority,pe.remoteAuthority)?V:void 0;re(this.O(L,pe,Me),!!Me),de=!0}for(const pe of Oe){if(fe.some(ce=>(0,se.isSingleFolderWorkspaceIdentifier)(ce.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(ce.openedWorkspace.uri,pe.workspace.uri)))continue;const Me=pe.remoteAuthority,ee=(0,h.isEqualAuthority)(V?.remoteAuthority,Me)?V:void 0;re(await this.R(L,pe,de,ee),!!ee),de=!0}}const $e=(0,R.distinct)(W,fe=>fe.backupFolder);if($e.length>0)for(const fe of $e){const pe=fe.remoteAuthority,Me=(0,h.isEqualAuthority)(V?.remoteAuthority,pe)?V:void 0;re(await this.Q(L,!0,pe,Me,fe),!!Me),de=!0}if(K.length===0||V){V&&!$&&$++;const fe=V?V.remoteAuthority:L.remoteAuthority;for(let pe=0;pe<$;pe++)re(await this.Q(L,de,fe,V),!!V),de=!0}return{windows:(0,R.distinct)(K),filesOpenedInWindow:J}}O(L,F,U){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),F.focus();const W={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",C.CancellationToken.None,W),F}P(L,F){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),L.focus();const U={foldersToAdd:F};return L.sendWhenReady("vscode:addFolders",C.CancellationToken.None,U),L}Q(L,F,U,W,$){this.m.trace("windowsManager#doOpenEmpty",{restore:!!$,remoteAuthority:U,filesToOpen:W,forceNewWindow:F});let V;return!F&&typeof L.contextWindowId=="number"&&(V=this.getWindowById(L.contextWindowId)),this.gb({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:U,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:W,windowToUse:V,emptyWindowBackupInfo:$,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}R(L,F,U,W,$){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:W}),!U&&!$&&typeof L.contextWindowId=="number"&&($=this.getWindowById(L.contextWindowId)),this.gb({workspace:F.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:W,windowToUse:$,forceProfile:L.forceProfile,forceTempProfile:L.forceTempProfile})}async S(L){let F,U=!1,W=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(F=await this.U(L),U=!0):L.forceEmpty?F=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(F=await this.W(L.cli),F.length===0&&F.push(Object.create(null)),U=!0):(F=await this.Y(),F.length===0&&F.push(Object.create(null)),W=!0),!L.addMode&&U){const $=F.filter(V=>Y(V));if($.length>1){const V=$[0].remoteAuthority;if($.every(j=>(0,h.isEqualAuthority)(j.remoteAuthority,V))){const j=await this.D.createUntitledWorkspace($.map(K=>({uri:K.workspace.uri})));F.push({workspace:j,remoteAuthority:V}),F=F.filter(K=>!Y(K))}}}if(L.initialStartup&&!W&&this.z.getValue("window")?.restoreWindows==="preserve"){const $=await this.Y();F.unshift(...$.filter(V=>q(V)||Y(V)||V.backupPath))}return F}async U(L){const F={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority},U=await Promise.all((0,R.coalesce)(L.urisToOpen||[]).map(async W=>{const $=await this.ab(W,F);if($)return $.label=W.label,$;const V=this.cb(W);this.G.showMessageBox({type:"info",buttons:[(0,S.localize)(0,null)],message:V.scheme===y.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:V.scheme===y.Schemas.file?(0,S.localize)(3,null,(0,b.getPathLabel)(V,{os:p.OS,tildify:this.t})):(0,S.localize)(4,null,V.toString(!0))},(0,m.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(U)}async W(L){const F=[],U={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:L.diff&&L._.length===2||L.merge&&L._.length===4},W=L["folder-uri"];if(W){const j=await Promise.all(W.map(K=>{const J=this.X(K);if(!!J)return this.ab({folderUri:J},U)}));F.push(...(0,R.coalesce)(j))}const $=L["file-uri"];if($){const j=await Promise.all($.map(K=>{const J=this.X(K);if(!!J)return this.ab((0,se.hasWorkspaceFileExtension)(K)?{workspaceUri:J}:{fileUri:J},U)}));F.push(...(0,R.coalesce)(j))}const V=await Promise.all(L._.map(j=>U.remoteAuthority?this.eb(j,U):this.db(j,U)));return F.push(...(0,R.coalesce)(V)),F}X(L){try{const F=I.URI.parse(L);if(!F.scheme){this.m.error(`Invalid URI input string, scheme missing: ${L}`);return}return F}catch(F){this.m.error(`Invalid URI input string: ${L}, ${F.message}`)}}async Y(){const L=this.Z();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];L!=="one"&&F.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&F.push(this.j.state.lastActiveWindow);const U=await Promise.all(F.map(async W=>{if(W.workspace){const $=await this.ab({workspaceUri:W.workspace.configPath},{remoteAuthority:W.remoteAuthority,rejectTransientWorkspaces:!0});if(q($))return $}else if(W.folderUri){const $=await this.ab({folderUri:W.folderUri},{remoteAuthority:W.remoteAuthority});if(Y($))return $}else if(L!=="folders"&&W.backupPath)return{backupPath:W.backupPath,remoteAuthority:W.remoteAuthority}}));return(0,R.coalesce)(U)}}}Z(){let L;return this.v.wasRestarted?L="all":(L=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}async ab(L,F=Object.create(null)){const U=this.cb(L);return U.scheme===y.Schemas.file?((0,N.isFileToOpen)(L)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.db(U.fsPath,F)):this.bb(L,F)}bb(L,F){let U=this.cb(L);const W=(0,A.getRemoteAuthority)(U)||F.remoteAuthority;if(U=(0,h.removeTrailingPathSeparator)((0,h.normalizePath)(U)),(0,N.isFileToOpen)(L)){if(F.gotoLineMode){const{path:$,line:V,column:j}=(0,g.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:$}),options:{selection:V?{startLineNumber:V,startColumn:j||1}:void 0},remoteAuthority:W}}return{fileUri:U,remoteAuthority:W}}else if((0,N.isWorkspaceToOpen)(L))return{workspace:(0,oe.getWorkspaceIdentifier)(U),remoteAuthority:W};return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:W}}cb(L){return(0,N.isWorkspaceToOpen)(L)?L.workspaceUri:(0,N.isFolderToOpen)(L)?L.folderUri:L.fileUri}async db(L,F){let U,W;F.gotoLineMode&&({path:L,line:U,column:W}=(0,g.parseLineAndColumnAware)(L)),L=(0,g.sanitizeFilePath)((0,d.normalize)(L),(0,a.cwd)());try{const $=await M.Promises.stat(L);if($.isFile()){if(!F.forceOpenWorkspaceAsFile){const V=await this.D.resolveLocalWorkspace(I.URI.file(L));if(V)return V.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:r.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:I.URI.file(L),type:r.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:W||1}:void 0}}}else{if($.isDirectory())return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(I.URI.file(L),$),type:r.FileType.Directory,exists:!0};if(!p.isWindows&&L==="/dev/null")return{fileUri:I.URI.file(L),type:r.FileType.File,exists:!0}}}catch{const V=I.URI.file(L);if(this.C.removeRecentlyOpened([V]),F.ignoreFileNotFound)return{fileUri:V,type:r.FileType.File,exists:!1}}}eb(L,F){const U=L.charCodeAt(0),W=F.remoteAuthority;let $,V;F.gotoLineMode&&({path:L,line:$,column:V}=(0,g.parseLineAndColumnAware)(L)),U!==47&&((0,g.isWindowsDriveLetter)(U)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,g.toSlashes)(L)),L=`/${L}`);const j=I.URI.from({scheme:y.Schemas.vscodeRemote,authority:W,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(L))return F.forceOpenWorkspaceAsFile?{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:V||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,oe.getWorkspaceIdentifier)(j),remoteAuthority:W};if(F.gotoLineMode||d.posix.basename(L).indexOf(".")!==-1)return{fileUri:j,options:{selection:$?{startLineNumber:$,startColumn:V||1}:void 0},remoteAuthority:W}}return{workspace:(0,oe.getSingleFolderWorkspaceIdentifier)(j),remoteAuthority:W}}fb(L){const F=this.z.getValue("window"),U=F?.openFoldersInNewWindow||"default",W=F?.openFilesInNewWindow||"off";let $=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(U==="on"||U==="off")&&($=U==="on");let V=!1;return L.forceNewWindow||L.forceReuseWindow?V=!!L.forceNewWindow&&!L.forceReuseWindow:(p.isMacintosh?L.context===1&&(V=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!L.cli.extensionDevelopmentPath&&(W==="on"||W==="off")&&(V=W==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(L,F){const U=(0,H.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(U)return this.v.reload(U,F.cli),U.focus(),[U];let W=F.cli["folder-uri"]||[],$=F.cli["file-uri"]||[],V=F.cli._;if(!V.length&&!W.length&&!$.length&&!F.cli.extensionTestsPath){const J=this.j.state.lastPluginDevelopmentHostWindow,re=J?.workspace??J?.folderUri;re&&(I.URI.isUri(re)?re.scheme===y.Schemas.file?V=[re.fsPath]:W=[re.toString()]:re.configPath.scheme===y.Schemas.file?V=[(0,h.originalFSPath)(re.configPath)]:$=[re.configPath.toString()])}let j=F.remoteAuthority;for(const J of L)if(J.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=I.URI.parse(J),de=(0,A.getRemoteAuthority)(re);de&&(j?(0,h.isEqualAuthority)(de,j)||this.m.error("more than one extension development path authority"):j=de)}V=V.filter(J=>{const re=I.URI.file(J);return(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,h.isEqualAuthority)((0,A.getRemoteAuthority)(re),j)}),W=W.filter(J=>{const re=this.X(J);return re&&!!(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,h.isEqualAuthority)((0,A.getRemoteAuthority)(re),j):!1}),$=$.filter(J=>{const re=this.X(J);return re&&!!(0,H.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,h.isEqualAuthority)((0,A.getRemoteAuthority)(re),j):!1}),F.cli._=V,F.cli["folder-uri"]=W,F.cli["file-uri"]=$;const K={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!V.length&&!W.length&&!$.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:j,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(K)}async gb(L){const F=this.z.getValue("window"),U=this.z.getValue("files"),W=this.getLastActiveWindow(),$=W?.profile??this.u.defaultProfile;let V;!L.forceNewWindow&&!L.forceNewTabbedWindow&&(V=L.windowToUse||W,V&&V.focus());const j={...this.t.args,...L.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,d.join)(this.t.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:$},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.l,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToMerge:L.filesToOpen?.filesToMerge,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsPath,product:l.default,isInitialStartup:L.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,n.release)(),hostname:(0,n.hostname)()},zoomLevel:typeof F?.zoomLevel=="number"?F.zoomLevel:void 0,autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn,preferUtilityProcess:U?.experimental?.watcherUseUtilityProcess??!1};if(V){const K=V.config;!j.extensionDevelopmentPath&&K?.extensionDevelopmentPath&&(j.extensionDevelopmentPath=K.extensionDevelopmentPath,j.extensionDevelopmentKind=K.extensionDevelopmentKind,j["enable-proposed-api"]=K["enable-proposed-api"],j.verbose=K.verbose,j["inspect-extensions"]=K["inspect-extensions"],j["inspect-brk-extensions"]=K["inspect-brk-extensions"],j.debugId=K.debugId,j.extensionEnvironment=K.extensionEnvironment,j["extensions-dir"]=K["extensions-dir"],j["disable-extensions"]=K["disable-extensions"]),j.loggers=K?.loggers??j.loggers}else{const K=this.j.getNewWindowState(j);(0,w.mark)("code/willCreateCodeWindow");const J=V=this.F.createInstance(z.CodeWindow,{state:K,extensionDevelopmentPath:j.extensionDevelopmentPath,isExtensionTestHost:!!j.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(J),at.a.push(J),this.b.fire(J),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(J.onDidSignalReady)(()=>this.c.fire(J)),(0,f.once)(J.onDidClose)(()=>this.jb(J)),(0,f.once)(J.onDidDestroy)(()=>this.f.fire(J)),J.onDidTriggerSystemContextMenu(({x:de,y:Ce})=>this.h.fire({window:J,x:de,y:Ce}));const re=(0,m.assertIsDefined)(J.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.v.reload(J)),this.v.registerWindow(J)}return j.windowId=V.id,V.isReady?this.v.unload(V,4).then(async K=>{K||await this.hb(V,j,L,$)}):await this.hb(V,j,L,$),V}async hb(L,F,U,W){if(F.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(F.workspace)?F.backupPath=this.w.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(F.workspace)?F.backupPath=this.w.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.w.registerEmptyWindowBackup({backupFolder:U.emptyWindowBackupInfo?.backupFolder??(0,oe.createEmptyWorkspaceIdentifier)().id,remoteAuthority:F.remoteAuthority})),this.u.isEnabled()){const $=F.workspace??(0,se.toWorkspaceIdentifier)(F.backupPath,!1),V=this.ib(U,$,W),j=V instanceof Promise?await V:V;F.profiles.profile=j,F.extensionDevelopmentPath||await this.u.setProfileForWorkspace($,j)}L.load(F)}ib(L,F,U){return L.forceProfile?this.u.profiles.find(W=>W.name===L.forceProfile)??this.u.createNamedProfile(L.forceProfile):L.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(F)??U}jb(L){const F=at.a.indexOf(L);at.a.splice(F,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=E.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(L){return this.lb(this.getWindows().filter(F=>(0,h.isEqualAuthority)(F.remoteAuthority,L)))}lb(L){const F=Math.max.apply(Math,L.map(U=>U.lastFocusTime));return L.find(U=>U.lastFocusTime===F)}sendToFocused(L,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(L,C.CancellationToken.None,...F)}sendToAll(L,F,U){for(const W of this.getWindows())U&&U.indexOf(W.id)>=0||W.sendWhenReady(L,C.CancellationToken.None,F)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(L){const F=this.getWindows().filter(U=>U.id===L);return(0,R.firstOrDefault)(F)}getWindowByWebContents(L){const F=E.BrowserWindow.fromWebContents(L);if(!!F)return this.getWindowById(F.id)}};te.a=[],te=ve([Q(2,s.ILogService),Q(3,T.ILoggerMainService),Q(4,O.IStateService),Q(5,G.IPolicyService),Q(6,i.IEnvironmentMainService),Q(7,B.IUserDataProfilesMainService),Q(8,u.ILifecycleMainService),Q(9,D.IBackupMainService),Q(10,t.IConfigurationService),Q(11,ue.IWorkspacesHistoryMainService),Q(12,le.IWorkspacesManagementMainService),Q(13,o.IInstantiationService),Q(14,c.IDialogMainService),Q(15,r.IFileService),Q(16,P.IProtocolMainService),Q(17,me.IThemeMainService)],te),e.WindowsMainService=te}),define(Z[284],_([0,1,63,30,79,53]),function(x,e,E,M,n,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let C=class{constructor(g,f,b,v){this.a=g,this.b=f,this.c=b,this.d=v,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(g,f){const b=this.b.getWindowById(g);if(b)return this.a.enterWorkspace(b,this.b.getWindows(),f)}createUntitledWorkspace(g,f,b){return this.a.createUntitledWorkspace(f,b)}deleteUntitledWorkspace(g,f){return this.a.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(g,f){return this.a.getWorkspaceIdentifier(f)}getRecentlyOpened(g){return this.c.getRecentlyOpened()}addRecentlyOpened(g,f){return this.c.addRecentlyOpened(f)}removeRecentlyOpened(g,f){return this.c.removeRecentlyOpened(f)}clearRecentlyOpened(g){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};C=ve([Q(0,R.IWorkspacesManagementMainService),Q(1,M.IWindowsMainService),Q(2,n.IWorkspacesHistoryMainService),Q(3,E.IBackupMainService)],C),e.WorkspacesMainService=C}),define(Z[285],_([0,1,15,42,26,17,44,13,32,49,43,45,2,14,9,4,10,8,31,140,47,154,105,258,157,63,276,19,75,190,87,125,57,108,212,28,62,114,202,226,203,262,110,204,205,16,216,90,74,6,89,277,239,260,20,5,282,58,21,55,270,91,33,266,95,92,24,241,117,51,48,248,249,278,250,279,120,252,253,254,256,264,30,283,265,29,96,79,284,53,259,38,224,52,235,56,78,123,268,274,272,7,118,267,219,65,88,263,255]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c,i,r,o,u,s,l,P,A,O,N,z,H,ie,se,oe,ue,le,me,G,B,T,q,Y,te,ne,L,F,U,W,$,V,j,K,J,re,de,Ce,Re,De,Oe,$e,fe,pe,Me,ee,ce,he,Ie,Ae,Te,Fe,je,ze,Ue,He,X,ae,ge,be,we,Le,We,Ve,Ge,Ke,Ye,Ze,st,ct,ft,Dt,Ct,Rt,Mt,At,Lt,Ot,gt,Tt,Ft,Ut,Wt,Nt,mt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let pt=class extends y.Disposable{constructor(Pe,Ee,ye,Se,ke,Be,Xe,Qe,qe,Ne,xe){super(),this.c=Pe,this.f=Ee,this.g=ye,this.h=Se,this.i=ke,this.j=Be,this.k=Xe,this.l=Qe,this.m=qe,this.n=Ne,this.p=xe,this.r(),this.s()}r(){const Pe=qe=>qe?.startsWith(`${d.Schemas.vscodeWebview}://`),Ee=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?xe(Ee.has(Ne)):xe(!1)),E.session.defaultSession.setPermissionCheckHandler((qe,Ne,xe,Je)=>Pe(Je.requestingUrl)?Ee.has(Ne):!1);const ye=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),Se=qe=>{for(let Ne=qe;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},ke=qe=>qe.resourceType==="xhr"||Se(qe.frame),Be=qe=>{const Ne=qe.frame;if(!Ne||!this.a)return!1;const xe=E.BrowserWindow.getAllWindows();for(const Je of xe)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Xe=(qe,Ne)=>{if(qe.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.a)return!1;for(const Je of this.a.getWindows())if(Je.win&&xe.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((qe,Ne)=>{const xe=h.URI.parse(qe.url);return xe.scheme===d.Schemas.vscodeWebview&&!Xe(xe,qe)?(this.h.error("Blocked vscode-webview request",qe.url),Ne({cancel:!0})):xe.scheme===d.Schemas.vscodeFileResource&&!Be(qe)?(this.h.error("Blocked vscode-file request",qe.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!ye.has(xe.scheme)?Ne({cancel:!ke(qe)}):Ne({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((qe,Ne)=>{const xe=qe.responseHeaders,Je=xe["content-type"]||xe["Content-Type"];if(Je&&Array.isArray(Je)){const _e=h.URI.parse(qe.url);if(_e.path.endsWith(".svg")&&ye.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!ke(qe)})}return Ne({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,w.join)(this.i.codeCachePath,"chrome"))}s(){(0,k.setUnexpectedErrorHandler)(ye=>this.u(ye)),process.on("uncaughtException",ye=>(0,k.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,k.onUnexpectedError)(ye)),this.j.onWillShutdown(()=>this.dispose()),(0,I.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(ye,Se)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Se)}),E.app.on("activate",async(ye,Se)=>{this.h.trace("app#activate"),Se||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(ye,Se)=>{Se.on("will-navigate",ke=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Se.setWindowOpenHandler(({url:ke})=>(this.b?.openExternal(void 0,ke),{action:"deny"}))});let Pe=[],Ee;E.app.on("open-file",(ye,Se)=>{this.h.trace("app#open-file: ",Se),ye.preventDefault(),Pe.push((0,We.hasWorkspaceFileExtension)(Se)?{workspaceUri:h.URI.file(Se)}:{fileUri:h.URI.file(Se)}),Ee!==void 0&&(clearTimeout(Ee),Ee=void 0),Ee=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:Pe,gotoLineMode:!1,preferNewWindow:!0}),Pe=[],Ee=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),M.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const Se=this.a?.getWindowByWebContents(ye.sender);let ke,Be;return Se?.config?(ke=Se.config,Be={...process.env,...Se.config.userEnv}):(ke=this.i.args,Be=process.env),this.M(ke,Be,!1)}),M.validatedIpcMain.handle("vscode:writeNlsFile",(ye,Se,ke)=>{const Be=this.t([Se]);if(!Be||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile(Be,R.VSBuffer.fromString(ke))}),M.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...Se)=>{const ke=this.t(Se);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(ke)).value.toString()}),M.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),M.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),M.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}t(Pe){let Ee;for(const ye of Pe)typeof ye=="string"&&(typeof Ee!="string"?Ee=ye:Ee=(0,w.join)(Ee,ye));if(!(typeof Ee!="string"||!(0,w.isAbsolute)(Ee)||!(0,g.isEqualOrParent)(Ee,this.i.cachedLanguagesPath,!p.isLinux)))return h.URI.file(Ee)}u(Pe){if(Pe){const Ee={message:`[uncaught exception in main]: ${Pe.message}`,stack:Pe.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ee))}this.h.error(`[uncaught exception in main]: ${Pe}`),Pe.stack&&this.h.error(Pe.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const Pe=this.n.win32AppUserModelId;p.isWindows&&Pe&&E.app.setAppUserModelId(Pe);try{p.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.h.error(Ne)}const Ee=new D.Server;this.j.onWillShutdown(Ne=>{Ne.reason===2&&Ee.dispose()}),this.h.trace("Resolving machine identifier...");const ye=await(0,Tt.resolveMachineId)(this.l);this.h.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:Se,sharedProcessReady:ke,sharedProcessClient:Be}=this.D(ye),Xe=await this.F(ye,Se,ke);this.B(Xe.createInstance(c.ProxyAuthHandler)),this.B(Xe.createInstance(Lt.UserDataProfilesHandler)),Xe.invokeFunction(Ne=>this.G(Ne,Ee,Be));const Qe=Xe.invokeFunction(Ne=>this.v(Ne,Ee));this.j.phase=2,await Xe.invokeFunction(Ne=>this.H(Ne,Qe)),this.j.phase=3,Xe.invokeFunction(Ne=>this.I(Ne,Se)),this.B(new gt.RunOnceScheduler(()=>{this.B((0,gt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(Pe,Ee){const ye=this.a=Pe.get(be.IWindowsMainService),Se=Pe.get(ze.IURLService),ke=this.b=Pe.get(J.INativeHostMainService),Be=this;Se.registerHandler({async handleURL(Je,_e){return Be.C(ye,Se,Je,_e)}});const Xe=this.B(new Le.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),Qe=new S.StaticRouter(Je=>Xe.getActiveClientId().then(_e=>Je===_e)),qe=new Ue.URLHandlerRouter(Qe,this.h),Ne=Ee.getChannel("urlHandler",qe);Se.registerHandler(new Ue.URLHandlerChannelClient(Ne));const xe=this.w();return this.B(new X.ElectronURLListener(xe?.urls,Se,ye,this.i,this.n,this.h)),xe}w(){const Pe=this.i.args["open-url"]?this.i.args._urls||[]:[];Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Pe);const Ee=global.getOpenUrls()||[];if(Ee.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ee),Pe.length+Ee.length===0)return;const ye=[];return{urls:[...Pe,...Ee].map(ke=>{try{return{uri:h.URI.parse(ke),originalUrl:ke}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",ke);return}}).filter(ke=>{if(!ke)return!1;if(this.y(ke.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",ke.uri.toString(!0)),!1;const Be=this.z(ke.uri);return Be?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",ke.uri.toString(!0),Be),ye.push(Be),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",ke.uri.toString(!0)),!0)}),openables:ye}}y(Pe){if(Pe.authority===d.Schemas.file&&p.isWindows){const{options:Ee,buttonIndeces:ye}=(0,Nt.massageMessageBoxOptions)({type:"question",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,v.getPathLabel)(Pe,{os:p.OS,tildify:this.i}),this.n.nameShort),detail:(0,i.localize)(3,null)},this.n);if(ye[E.dialog.showMessageBoxSync(Ee)]===1)return!0}return!1}z(Pe){if(!!Pe.path){if(Pe.authority===d.Schemas.file){const Ee=h.URI.file(Pe.fsPath);return(0,We.hasWorkspaceFileExtension)(Ee)?{workspaceUri:Ee}:{fileUri:Ee}}else if(Pe.authority===d.Schemas.vscodeRemote){const Ee=Pe.path.indexOf(w.posix.sep,1);if(Ee!==-1){const ye=Pe.path.substring(1,Ee),Se=Pe.path.substring(Ee),ke=h.URI.from({scheme:d.Schemas.vscodeRemote,authority:ye,path:Se,query:Pe.query,fragment:Pe.fragment});return(0,We.hasWorkspaceFileExtension)(Se)?{workspaceUri:ke}:/:[\d]+$/.test(Se)?{fileUri:ke}:{folderUri:ke}}}}}async C(Pe,Ee,ye,Se){if(this.h.trace("app#handleProtocolUrl():",ye.toString(!0),Se),ye.scheme===this.n.urlProtocol&&ye.path==="workspace"&&(ye=ye.with({authority:"file",path:h.URI.parse(ye.query).path,query:""})),this.y(ye))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",ye.toString(!0)),!0;let ke=!1;const Be=new URLSearchParams(ye.query);Be.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",ye.toString(!0)),Be.delete("windowId"),ye=ye.with({query:Be.toString()}),ke=!0):p.isMacintosh&&Pe.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",ye.toString(!0)),ke=!0);const Xe=Be.get("continueOn");Xe!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",ye.toString(!0)),Be.delete("continueOn"),ye=ye.with({query:Be.toString()}),this.i.continueOn=Xe??void 0);const Qe=this.z(ye);if(Qe){this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,ye.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:ke,gotoLineMode:!0});return qe.focus(),!0}if(ke){this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",ye.toString(!0));const[qe]=await Pe.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(ye)});return await qe.ready(),Ee.open(ye,Se)}return this.h.trace("app#handleProtocolUrl(): not handled",ye.toString(!0),Se),!1}D(Pe){const Ee=this.B(this.g.createInstance(Ce.SharedProcess,Pe,this.f)),ye=(async()=>{this.h.trace("Main->SharedProcess#connect");const ke=await Ee.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new t.Client(ke,"main")})(),Se=(async()=>(await Ee.whenReady(),ye))();return{sharedProcess:Ee,sharedProcessReady:Se,sharedProcessClient:ye}}async F(Pe,Ee,ye){const Se=new F.ServiceCollection;switch(process.platform){case"win32":Se.set(he.IUpdateService,new ne.SyncDescriptor(je.Win32UpdateService));break;case"linux":p.isLinuxSnap?Se.set(he.IUpdateService,new ne.SyncDescriptor(Fe.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(he.IUpdateService,new ne.SyncDescriptor(Te.LinuxUpdateService));break;case"darwin":Se.set(he.IUpdateService,new ne.SyncDescriptor(Ae.DarwinUpdateService));break}Se.set(be.IWindowsMainService,new ne.SyncDescriptor(we.WindowsMainService,[Pe,this.f],!1));const ke=new O.DialogMainService(this.h,this.n);Se.set(O.IDialogMainService,ke),Se.set($.ILaunchMainService,new ne.SyncDescriptor($.LaunchMainService,void 0,!1)),Se.set(A.IDiagnosticsMainService,new ne.SyncDescriptor(A.DiagnosticsMainService,void 0,!1)),Se.set(P.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(ye.then(Qe=>Qe.getChannel("diagnostics"))))),Se.set(U.IIssueMainService,new ne.SyncDescriptor(U.IssueMainService,[this.f])),Se.set(N.IEncryptionMainService,new ne.SyncDescriptor(z.EncryptionMainService,[Pe])),Se.set(W.IKeyboardLayoutMainService,new ne.SyncDescriptor(W.KeyboardLayoutMainService)),Se.set(J.INativeHostMainService,new ne.SyncDescriptor(J.NativeHostMainService,[Ee],!1)),Se.set(s.ICredentialsMainService,new ne.SyncDescriptor(Ze.CredentialsNativeMainService)),Se.set(ae.IWebviewManagerService,new ne.SyncDescriptor(ge.WebviewMainService)),Se.set(K.IMenubarMainService,new ne.SyncDescriptor(K.MenubarMainService)),Se.set(oe.IExtensionUrlTrustService,new ne.SyncDescriptor(ue.ExtensionUrlTrustService)),Se.set(le.IExtensionHostStarter,new ne.SyncDescriptor(me.ExtensionHostStarter)),Se.set($e.IStorageMainService,new ne.SyncDescriptor($e.StorageMainService)),Se.set($e.IApplicationStorageMainService,new ne.SyncDescriptor($e.ApplicationStorageMainService)),p.isWindows?Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.WindowsExternalTerminalService)):p.isMacintosh?Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.MacExternalTerminalService)):p.isLinux&&Se.set(G.IExternalTerminalMainService,new ne.SyncDescriptor(B.LinuxExternalTerminalService));const Be=new o.BackupMainService(this.i,this.k,this.h,this.l);Se.set(r.IBackupMainService,Be);const Xe=new Ye.WorkspacesManagementMainService(this.i,this.h,this.p,Be,ke);if(Se.set(Ye.IWorkspacesManagementMainService,Xe),Se.set(Ve.IWorkspacesService,new ne.SyncDescriptor(Ke.WorkspacesMainService,void 0,!1)),Se.set(Ge.IWorkspacesHistoryMainService,new ne.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),Se.set(ze.IURLService,new ne.SyncDescriptor(He.NativeURLService,void 0,!1)),(0,ce.supportsTelemetry)(this.n,this.i)){const Qe=(0,ce.isInternalTelemetry)(this.n,this.k),qe=(0,S.getDelayedChannel)(ye.then(nt=>nt.getChannel("telemetryAppender"))),Ne=new Me.TelemetryAppenderClient(qe),xe=(0,fe.resolveCommonProperties)(this.m,(0,n.release)(),(0,n.hostname)(),process.arch,this.n.commit,this.n.version,Pe,Qe,this.i.installSourcePath),Je=(0,ce.getPiiPathsFromEnvironment)(this.i),_e={appenders:[Ne],commonProperties:xe,piiPaths:Je,sendErrorTelemetry:!0};Se.set(pe.ITelemetryService,new ne.SyncDescriptor(ee.TelemetryService,[_e],!1))}else Se.set(pe.ITelemetryService,ce.NullTelemetryService);return Se.set(Rt.IExtensionsProfileScannerService,new ne.SyncDescriptor(Ft.ExtensionsProfileScannerService,void 0,!0)),Se.set(Mt.IExtensionsScannerService,new ne.SyncDescriptor(At.ExtensionsScannerService,void 0,!0)),Se.set(mt.IUtilityProcessWorkerMainService,new ne.SyncDescriptor(mt.UtilityProcessWorkerMainService,void 0,!0)),await gt.Promises.settled([Be.initialize(),Xe.initialize()]),this.g.createChild(Se)}G(Pe,Ee,ye){const Se=S.ProxyChannel.fromService(Pe.get($.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Se);const ke=S.ProxyChannel.fromService(Pe.get(A.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",ke);const Be=new ct.PolicyChannel(Pe.get(st.IPolicyService));Ee.registerChannel("policy",Be),ye.then(et=>et.registerChannel("policy",Be));const Xe=this.m.getProvider(d.Schemas.file);(0,a.assertType)(Xe instanceof te.DiskFileSystemProvider);const Qe=new Y.DiskFileSystemProviderChannel(Xe,this.h,this.i);Ee.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),ye.then(et=>et.registerChannel(T.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const qe=S.ProxyChannel.fromService(Pe.get(ft.IUserDataProfilesMainService));Ee.registerChannel("userDataProfiles",qe),ye.then(et=>et.registerChannel("userDataProfiles",qe));const Ne=new Dt.RequestChannel(Pe.get(Ct.IRequestService));ye.then(et=>et.registerChannel("request",Ne));const xe=new Ie.UpdateChannel(Pe.get(he.IUpdateService));Ee.registerChannel("update",xe);const Je=S.ProxyChannel.fromService(Pe.get(U.IIssueMainService));Ee.registerChannel("issue",Je);const _e=S.ProxyChannel.fromService(Pe.get(N.IEncryptionMainService));Ee.registerChannel("encryption",_e);const nt=S.ProxyChannel.fromService(Pe.get(s.ICredentialsMainService));Ee.registerChannel("credentials",nt);const it=S.ProxyChannel.fromService(Pe.get(Re.ISignService));Ee.registerChannel("sign",it);const lt=S.ProxyChannel.fromService(Pe.get(W.IKeyboardLayoutMainService));Ee.registerChannel("keyboardLayout",lt),this.b=Pe.get(J.INativeHostMainService);const yt=S.ProxyChannel.fromService(this.b);Ee.registerChannel("nativeHost",yt),ye.then(et=>et.registerChannel("nativeHost",yt));const Bt=S.ProxyChannel.fromService(Pe.get(Ve.IWorkspacesService));Ee.registerChannel("workspaces",Bt);const $t=S.ProxyChannel.fromService(Pe.get(K.IMenubarMainService));Ee.registerChannel("menubar",$t);const zt=S.ProxyChannel.fromService(Pe.get(ze.IURLService));Ee.registerChannel("url",zt);const qt=S.ProxyChannel.fromService(Pe.get(oe.IExtensionUrlTrustService));Ee.registerChannel("extensionUrlTrust",qt);const Ht=S.ProxyChannel.fromService(Pe.get(ae.IWebviewManagerService));Ee.registerChannel("webview",Ht);const St=this.B(new Oe.StorageDatabaseChannel(this.h,Pe.get($e.IStorageMainService)));Ee.registerChannel("storage",St),ye.then(et=>et.registerChannel("storage",St));const Vt=this.B(new Ot.ProfileStorageChangesListenerChannel(Pe.get($e.IStorageMainService),Pe.get(ft.IUserDataProfilesMainService),this.h));ye.then(et=>et.registerChannel("profileStorageListener",Vt));const xt=S.ProxyChannel.fromService(Pe.get(G.IExternalTerminalMainService));Ee.registerChannel("externalTerminal",xt);const Et=new Ut.LoggerChannel(Pe.get(Wt.ILoggerMainService));Ee.registerChannel("logger",Et),ye.then(et=>et.registerChannel("logger",Et));const Gt=new l.ElectronExtensionHostDebugBroadcastChannel(Pe.get(be.IWindowsMainService));Ee.registerChannel("extensionhostdebugservice",Gt);const Kt=S.ProxyChannel.fromService(Pe.get(le.IExtensionHostStarter));Ee.registerChannel(le.ipcExtensionHostStarterChannelName,Kt);const Xt=S.ProxyChannel.fromService(Pe.get(mt.IUtilityProcessWorkerMainService));Ee.registerChannel(jt.ipcUtilityProcessWorkerChannelName,Xt)}async H(Pe,Ee){const ye=this.a=Pe.get(be.IWindowsMainService),Se=(0,ie.isLaunchedFromCli)(process.env)?0:4,ke=this.i.args;if(Ee){if(Ee.openables.length>0)return ye.open({context:Se,cli:ke,urisToOpen:Ee.openables,gotoLineMode:!0,initialStartup:!0});if(Ee.urls.length>0)for(const it of Ee.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),ye.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,Xe=ke._.length,Qe=!!ke["folder-uri"],qe=!!ke["file-uri"],Ne=ke["skip-add-to-recently-opened"]===!0,xe=ke.wait&&ke.waitMarkerFilePath?h.URI.file(ke.waitMarkerFilePath):void 0,Je=ke.remote||void 0,_e=ke.profile,nt=ke["profile-temp"];if(!Xe&&!Qe&&!qe){if(ke["new-window"]||_e||nt)return ye.open({context:Se,cli:ke,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt});if(Be.length)return ye.open({context:1,cli:ke,urisToOpen:Be.map(it=>(0,We.hasWorkspaceFileExtension)(it)?{workspaceUri:h.URI.file(it)}:{fileUri:h.URI.file(it)}),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return ye.open({context:Se,cli:ke,forceNewWindow:ke["new-window"]||!Xe&&ke["unity-launch"],diffMode:ke.diff,mergeMode:ke.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:ke.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:_e,forceTempProfile:nt})}I(Pe,Ee){const ye=Pe.get(pe.ITelemetryService),Se=Pe.get(he.IUpdateService);this.L(ye,Ee),this.J(),E.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(ke,Be)=>{Be({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})}),(Se instanceof je.Win32UpdateService||Se instanceof Te.LinuxUpdateService||Se instanceof Ae.DarwinUpdateService)&&Se.initialize(),this.M(this.i.args,process.env,!0),this.N()}async J(){const Pe=this.n.win32MutexName;if(p.isWindows&&Pe)try{const Ee=await new Promise((Se,ke)=>{x(["windows-mutex"],Se,ke)}),ye=new Ee.Mutex(Pe);(0,f.once)(this.j.onWillShutdown)(()=>ye.release())}catch(Ee){this.h.error(Ee)}}L(Pe,Ee){let ye=!1;(0,f.once)(this.j.onWillShutdown)(()=>ye=!0),this.B(Ee.onDidError(({type:Se,details:ke})=>{switch(Se){case 2:this.h.error(`SharedProcess: renderer process gone (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break;case 1:this.h.error("SharedProcess: detected unresponsive");break;case 3:this.h.error(`SharedProcess: failed to load (reason: ${ke?.reason||"<unknown>"}, code: ${ke?.exitCode||"<unknown>"})`);break}Pe.publicLog2("sharedprocesserror",{type:Se,reason:ke?.reason,code:ke?.exitCode,visible:Ee.isVisible(),shuttingdown:ye})}))}async M(Pe,Ee,ye){try{return await(0,se.getResolvedShellEnv)(this.k,this.h,Pe,Ee)}catch(Se){const ke=(0,C.toErrorMessage)(Se);ye?this.a?.sendToFocused("vscode:showResolveShellEnvError",ke):this.h.error(ke)}return{}}async N(){try{const Ee=(await this.m.readFile(this.i.argvResource)).value.toString(),ye=JSON.parse((0,b.stripComments)(Ee)),ke=(0,ce.getTelemetryLevel)(this.k)>=1;if(ye["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ke},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,m.generateUuid)()}"`,"}"],Xe=Ee.substring(0,Ee.length-2).concat(`,
`,Be.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Xe))}else{const Be=Ee.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${ke},`);Be!==Ee&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Be))}}catch(Pe){this.h.error(Pe)}}};pt=ve([Q(2,L.IInstantiationService),Q(3,j.ILogService),Q(4,H.IEnvironmentMainService),Q(5,V.ILifecycleMainService),Q(6,u.IConfigurationService),Q(7,De.IStateService),Q(8,q.IFileService),Q(9,re.IProductService),Q(10,ft.IUserDataProfilesMainService)],pt),e.CodeApplication=pt}),define(Z[286],_([0,1,237,7,17,13,2,10,19,34,114,5,236,293]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends C.Disposable{constructor(a,h,m){super(),this.h=a,this.i=h,this.j=m,this.k(),this.B(a.onDidChangeConfiguration(I=>{I.affectsConfiguration("http")&&this.k()}))}k(){const a=this.h.getValue("http");this.a=a?.proxy,this.b=!!a?.proxyStrictSSL,this.f=a?.proxyAuthorization}async request(a,h){this.j.trace("RequestService#request (node) - begin",a.url);const{a:m,b:I}=this;let S;try{S=await(0,b.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(c){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",c))}const D={...process.env,...S},t=a.agent?a.agent:await(0,y.getProxyAgent)(a.url||"",D,{proxyUrl:m,strictSSL:I});a.agent=t,a.strictSSL=I,this.f&&(a.headers={...a.headers||{},"Proxy-Authorization":this.f});try{const c=await this.m(a,h);return this.j.trace("RequestService#request (node) - success",a.url),c}catch(c){throw this.j.trace("RequestService#request (node) - error",a.url,c),c}}async l(a){return((0,E.parse)(a.url).protocol==="https:"?await new Promise((I,S)=>{x(["https"],I,S)}):await new Promise((I,S)=>{x(["http"],I,S)})).request}m(a,h){return M.Promises.withAsyncBody(async(m,I)=>{const S=(0,E.parse)(a.url),D=a.getRawRequest?a.getRawRequest(a):await this.l(a),t={hostname:S.hostname,port:S.port?parseInt(S.port):S.protocol==="https:"?443:80,protocol:S.protocol,path:S.path,method:a.type||"GET",headers:a.headers,agent:a.agent,rejectUnauthorized:(0,k.isBoolean)(a.strictSSL)?a.strictSSL:!0};a.user&&a.password&&(t.auth=a.user+":"+a.password);const c=D(t,i=>{const r=(0,k.isNumber)(a.followRedirects)?a.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&r>0&&i.headers.location)this.m({...a,url:i.headers.location,followRedirects:r-1},h).then(m,I);else{let o=i;!a.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,d.createGunzip)())),m({res:i,stream:(0,n.streamToBufferReadableStream)(o)})}});c.on("error",I),a.timeout&&c.setTimeout(a.timeout),a.isChromiumNetwork&&c.removeHeader("Content-Length"),a.data&&typeof a.data=="string"&&c.write(a.data),c.end(),h.onCancellationRequested(()=>{c.abort(),I(new R.CancellationError)})})}async resolveProxy(a){}};w=ve([Q(0,g.IConfigurationService),Q(1,f.INativeEnvironmentService),Q(2,v.ILogService)],w),e.RequestService=w}),define(Z[287],_([0,1,15,286]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function n(C){return E.net.request}class R extends M.RequestService{request(k,g){return super.request({...k||{},getRawRequest:n,isChromiumNetwork:!0},g)}}e.RequestMainService=R}),define(Z[294],_([0,1,15,41,8,25,7,44,13,32,49,45,14,9,64,4,36,27,23,47,86,285,11,19,230,240,28,62,194,16,214,90,74,210,89,20,217,5,66,21,67,269,119,246,56,287,91,238,33,51,69,52,38,225,223,2,39,251,65,218,88,115,247]),function(x,e,E,M,n,R,C,k,g,f,b,v,y,d,w,p,a,h,m,I,S,D,t,c,i,r,o,u,s,l,P,A,O,N,z,H,ie,se,oe,ue,le,me,G,B,T,q,Y,te,ne,L,F,U,W,$,V,j,K,J,re,de,Ce,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class De{main(){try{this.a()}catch(fe){console.error(fe.message),E.app.exit(1)}}async a(){(0,g.setUnexpectedErrorHandler)(Te=>console.error(Te));const[fe,pe,Me,ee,ce,he,Ie,Ae]=this.b();try{try{await this.d(Me,Ae,ee,ce,Ie)}catch(Te){throw this.f(Me,Ie,Te),Te}await fe.invokeFunction(async Te=>{const Fe=Te.get(se.ILogService),je=Te.get(H.ILifecycleMainService),ze=Te.get(l.IFileService),Ue=Te.get(se.ILoggerService),He=await this.e(Fe,Me,je,fe,Ie,!0);return m.Promises.writeFile(Me.mainLockfile,String(process.pid)).catch(X=>{Fe.warn(`app#startup(): Error writing main lockfile: ${X.stack}`)}),he.logger=Ue.createLogger(n.URI.file((0,d.join)(Me.logsPath,"main.log")),{id:"mainLog",name:(0,t.localize)(0,null)}),(0,b.once)(je.onWillShutdown)(X=>{ze.dispose(),ee.dispose(),X.join("instanceLockfile",m.Promises.unlink(Me.mainLockfile).catch(()=>{}))}),fe.createInstance(D.CodeApplication,He,pe).startup()})}catch(Te){fe.invokeFunction(this.i,Te)}}b(){const fe=new z.ServiceCollection,pe=new j.DisposableStore;process.once("exit",()=>pe.dispose());const Me={_serviceBrand:void 0,...oe.default};fe.set(ue.IProductService,Me);const ee=new o.EnvironmentMainService(this.j(),Me),ce=this.c(ee);fe.set(o.IEnvironmentMainService,ee);const he=new re.LoggerMainService((0,se.getLogLevel)(ee));fe.set(re.ILoggerMainService,he);const Ie=new ie.BufferLogger(he.getLogLevel()),Ae=pe.add(new de.LogService(Ie,[new se.ConsoleMainLogger(he.getLogLevel())]));fe.set(se.ILogService,Ae);const Te=new P.FileService(Ae);fe.set(l.IFileService,Te);const Fe=new A.DiskFileSystemProvider(Ae);Te.registerProvider(y.Schemas.file,Fe);const je=new J.UriIdentityService(Te);fe.set(K.IUriIdentityService,je);const ze=new Re.StateService(1,ee,Ae,Te);fe.set(ne.IStateReadService,ze),fe.set(ne.IStateService,ze);const Ue=new U.UserDataProfilesMainService(ze,je,ee,Te,Ae);fe.set(U.IUserDataProfilesMainService,Ue);const He=p.isWindows&&Me.win32RegValueName?pe.add(new $.NativePolicyService(Ae,Me.win32RegValueName)):ee.policyFile?pe.add(new V.FilePolicyService(ee.policyFile,Te,Ae)):new W.NullPolicyService;fe.set(W.IPolicyService,He);const X=new i.ConfigurationService(Ue.defaultProfile.settingsResource,Te,He,Ae);return fe.set(c.IConfigurationService,X),fe.set(H.ILifecycleMainService,new O.SyncDescriptor(H.LifecycleMainService,void 0,!1)),fe.set(T.IRequestService,new O.SyncDescriptor(q.RequestMainService,void 0,!0)),fe.set(F.IThemeMainService,new O.SyncDescriptor(F.ThemeMainService)),fe.set(Y.ISignService,new O.SyncDescriptor(te.SignService,void 0,!1)),fe.set(G.ITunnelService,new O.SyncDescriptor(B.TunnelService)),fe.set(le.IProtocolMainService,new me.ProtocolMainService(ee,Ue,Ae)),[new N.InstantiationService(fe,!0),ce,ee,X,ze,Ie,Me,Ue]}c(fe){const pe={VSCODE_IPC_HOOK:fe.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Me=>{const ee=process.env[Me];typeof ee=="string"&&(pe[Me]=ee)}),Object.assign(process.env,pe),pe}async d(fe,pe,Me,ee,ce){await C.Promises.settled([Promise.all([fe.extensionsPath,fe.codeCachePath,fe.logsPath,pe.defaultProfile.globalStorageHome.fsPath,fe.workspaceStorageHome.fsPath,fe.localHistoryHome.fsPath,fe.backupHome].map(he=>he?m.Promises.mkdir(he,{recursive:!0}):void 0)),ee.init(),Me.initialize()]),pe.init()}async e(fe,pe,Me,ee,ce,he){let Ie;try{(0,w.mark)("code/willStartMainServer"),Ie=await(0,S.serve)(pe.mainIPCHandle),(0,w.mark)("code/didStartMainServer"),(0,b.once)(Me.onWillShutdown)(()=>Ie.dispose())}catch(Ae){if(Ae.code!=="EADDRINUSE")throw this.f(pe,ce,Ae),Ae;let Te;try{Te=await(0,S.connect)(pe.mainIPCHandle,"main")}catch(Ue){if(!he||p.isWindows||Ue.code!=="ECONNREFUSED")throw Ue.code==="EPERM"&&this.g((0,t.localize)(1,null,ce.nameShort),(0,t.localize)(2,null),ce),Ue;try{(0,M.unlinkSync)(pe.mainIPCHandle)}catch(He){throw fe.warn("Could not delete obsolete instance handle",He),He}return this.e(fe,pe,Me,ee,ce,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ue=`Running extension tests from the command line is currently only supported if no other instance of ${ce.nameShort} is running.`;throw fe.error(Ue),Te.dispose(),new Error(Ue)}let Fe;!pe.args.wait&&!pe.args.status&&(Fe=setTimeout(()=>{this.g((0,t.localize)(3,null,ce.nameShort),(0,t.localize)(4,null),ce)},1e4));const je=I.ProxyChannel.toService(Te.getChannel("launch"),{disableMarshalling:!0}),ze=I.ProxyChannel.toService(Te.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return ee.invokeFunction(async()=>{const Ue=new r.DiagnosticsService(L.NullTelemetryService,ce),He=await ze.getMainDiagnostics(),X=await ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ae=await Ue.getDiagnostics(He,X);throw console.log(ae),new g.ExpectedError});throw p.isWindows&&await this.h(je,fe),fe.trace("Sending env to running instance..."),await je.start(pe.args,process.env),Te.dispose(),Fe&&clearTimeout(Fe),new g.ExpectedError("Sent env to running instance. Terminating...")}if(pe.args.status)throw fe.warn(`Warning: The --status argument can only be used if ${ce.nameShort} is already running. Please run it again after {0} has started.`),new g.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ie}f(fe,pe,Me){if(Me.code==="EACCES"||Me.code==="EPERM"){const ee=(0,R.coalesce)([fe.userDataPath,fe.extensionsPath,S.XDG_RUNTIME_DIR]).map(ce=>(0,v.getPathLabel)(n.URI.file(ce),{os:p.OS,tildify:fe}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Me),ee.join(`
`)),pe)}}g(fe,pe,Me){E.dialog.showMessageBoxSync((0,Ce.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:fe,detail:pe},Me).options)}async h(fe,pe){if(p.isWindows){const Me=await fe.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",Me);try{(await new Promise((ee,ce)=>{x(["windows-foreground-love"],ee,ce)})).allowSetForegroundWindow(Me)}catch(ee){pe.error(ee)}}}i(fe,pe){const Me=fe.get(se.ILogService),ee=fe.get(H.ILifecycleMainService);let ce=0;pe&&(pe.isExpected?pe.message&&Me.trace(pe.message):(ce=1,pe.stack?Me.error(pe.stack):Me.error(`Startup error: ${pe.toString()}`))),ee.kill(ce)}j(){const fe=this.k((0,u.parseMainProcessArgv)(process.argv));if(fe.wait&&!fe.waitMarkerFilePath){const pe=(0,s.createWaitMarkerFileSync)(fe.verbose);pe&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",pe),fe.waitMarkerFilePath=pe)}return fe}k(fe){if(fe["open-url"]&&(fe._urls=fe._,fe._=[]),!fe.remote){const pe=this.l(fe._,fe.goto);fe._=pe}return fe}l(fe,pe){const Me=(0,a.cwd)(),ee=fe.map(Ie=>{let Ae=String(Ie),Te;pe&&(Te=(0,f.parseLineAndColumnAware)(Ae),Ae=Te.path),Ae&&(Ae=this.m(Me,Ae));const Fe=(0,f.sanitizeFilePath)(Ae,Me),je=(0,d.basename)(Fe);return je&&!(0,f.isValidBasename)(je)?null:pe&&Te?(Te.path=Fe,this.n(Te)):Fe}),ce=p.isWindows||p.isMacintosh,he=(0,R.distinct)(ee,Ie=>Ie&&ce?Ie.toLowerCase():Ie||"");return(0,R.coalesce)(he)}m(fe,pe){return p.isWindows&&(pe=(0,h.rtrim)(pe,'"')),pe=(0,h.trim)((0,h.trim)(pe," "),"	"),p.isWindows&&(pe=(0,d.resolve)(fe,pe),pe=(0,h.rtrim)(pe,".")),pe}n(fe){const pe=[fe.path];return typeof fe.line=="number"&&pe.push(String(fe.line)),typeof fe.column=="number"&&pe.push(String(fe.column)),pe.join(":")}}new De().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc619de8d9efdabd781fc5658d0051813c347055/core/vs/code/electron-main/main.js.map
