/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/path","vs/base/common/network","vs/platform/environment/common/environment","vs/base/common/resources","vs/base/common/arrays","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/base/common/strings","vs/platform/product/common/productService","vs/platform/extensions/common/extensions","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/base/common/stream","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/hash","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","https","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],_=function(x){for(var e=[],O=0,R=x.length;O<R;O++)e[O]=Q[x[O]];return e};define(Q[48],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function O(D){return(S,g,u)=>{let I=null,E=null;if(typeof u.value=="function"?(I="value",E=u.value):typeof u.get=="function"&&(I="get",E=u.get),!E)throw new Error("not supported");u[I]=D(E,g)}}function R(D,S,g){let u=null,I=null;if(typeof g.value=="function"?(u="value",I=g.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(u="get",I=g.get),!I)throw new Error("not supported");const E=`$memoize$${S}`;g[u]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,d)}),this[E]}}e.memoize=R;function P(D,S,g){return O((u,I)=>{const E=`$debounce$${I}`,d=`$debounce$result$${I}`;return function(...w){this[d]||(this[d]=g?g():void 0),clearTimeout(this[E]),S&&(this[d]=S(this[d],...w),w=[this[d]]),this[E]=setTimeout(()=>{u.apply(this,w),this[d]=g?g():void 0},D)}})}e.debounce=P;function k(D,S,g){return O((u,I)=>{const E=`$throttle$timer$${I}`,d=`$throttle$result$${I}`,w=`$throttle$lastRun$${I}`,y=`$throttle$pending$${I}`;return function(...N){if(this[d]||(this[d]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...N)),this[y])return;const c=this[w]+D;c<=Date.now()?(this[w]=Date.now(),u.apply(this,[this[d]]),this[d]=g?g():void 0):(this[y]=!0,this[E]=setTimeout(()=>{this[y]=!1,this[w]=Date.now(),u.apply(this,[this[d]]),this[d]=g?g():void 0},c-Date.now()))}})}e.throttle=k}),define(Q[70],_([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(g,u){if(!g)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=R;function P(g,u="Unreachable"){throw new Error(u)}e.assertNever=P;function k(g){if(!g)throw new O.BugIndicatingError("Assertion Failed")}e.assert=k;function D(g){if(!g()){debugger;g(),(0,O.onUnexpectedError)(new O.BugIndicatingError("Assertion Failed"))}}e.assertFn=D;function S(g,u){let I=0;for(;I<g.length-1;){const E=g[I],d=g[I+1];if(!u(E,d))return!1;I++}return!0}e.checkAdjacentItems=S}),define(Q[49],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(O=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k=e.ParseOptions||(e.ParseOptions={}));function D(t,s=!1){let i=0;const n=t.length;let r="",o=0,a=16,l=0;function h(ne){let ae=0,fe=0;for(;ae<ne;){const oe=t.charCodeAt(i);if(oe>=48&&oe<=57)fe=fe*16+oe-48;else if(oe>=65&&oe<=70)fe=fe*16+oe-65+10;else if(oe>=97&&oe<=102)fe=fe*16+oe-97+10;else break;i++,ae++}return ae<ne&&(fe=-1),fe}function A(ne){i=ne,r="",o=0,a=16,l=0}function F(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&u(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&u(t.charCodeAt(i)))for(i++;i<t.length&&u(t.charCodeAt(i));)i++;else return l=3,t.substring(ne,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&u(t.charCodeAt(i))){for(i++;i<t.length&&u(t.charCodeAt(i));)i++;ae=i}else l=3;return t.substring(ne,ae)}function X(){let ne="",ae=i;for(;;){if(i>=n){ne+=t.substring(ae,i),l=2;break}const fe=t.charCodeAt(i);if(fe===34){ne+=t.substring(ae,i),i++;break}if(fe===92){if(ne+=t.substring(ae,i),i++,i>=n){l=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ve=h(4);ve>=0?ne+=String.fromCharCode(ve):l=4;break}default:l=5}ae=i;continue}if(fe>=0&&fe<=31)if(g(fe)){ne+=t.substring(ae,i),l=2;break}else l=6;i++}return ne}function ee(){if(r="",l=0,o=i,i>=n)return o=n,a=17;let ne=t.charCodeAt(i);if(S(ne)){do i++,r+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(S(ne));return a=15}if(g(ne))return i++,r+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,r+=`
`),a=14;switch(ne){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,r=X(),a=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!g(t.charCodeAt(i));)i++;return r=t.substring(ae,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const fe=n-1;let oe=!1;for(;i<fe;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,oe=!0;break}i++}return oe||(i++,l=1),r=t.substring(ae,i),a=13}return r+=String.fromCharCode(ne),i++,a=16}case 45:if(r+=String.fromCharCode(ne),i++,i===n||!u(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=F(),a=11;default:for(;i<n&&te(ne);)i++,ne=t.charCodeAt(i);if(o!==i){switch(r=t.substring(o,i),r){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return r+=String.fromCharCode(ne),i++,a=16}}function te(ne){if(S(ne)||g(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let ne;do ne=ee();while(ne>=12&&ne<=15);return ne}return{setPosition:A,getPosition:()=>i,scan:s?ie:ee,getToken:()=>a,getTokenValue:()=>r,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>l}}e.createScanner=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function g(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function E(t,s){const i=[],n=new Object;let r;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(h,A,F,X){o.value=h,o.offset=A,o.length=F,o.type=X,o.colonOffset=void 0,r=o}try{b(t,{onObjectBegin:(h,A)=>{if(s<=h)throw n;r=void 0,a=s>h,i.push("")},onObjectProperty:(h,A,F)=>{if(s<A||(l(h,A,F,"property"),i[i.length-1]=h,s<=A+F))throw n},onObjectEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onArrayBegin:(h,A)=>{if(s<=h)throw n;r=void 0,i.push(0)},onArrayEnd:(h,A)=>{if(s<=h)throw n;r=void 0,i.pop()},onLiteralValue:(h,A,F)=>{if(s<A||(l(h,A,F,m(h)),s<=A+F))throw n},onSeparator:(h,A,F)=>{if(s<=A)throw n;if(h===":"&&r&&r.type==="property")r.colonOffset=A,a=!1,r=void 0;else if(h===","){const X=i[i.length-1];typeof X=="number"?i[i.length-1]=X+1:(a=!0,i[i.length-1]=""),r=void 0}}})}catch(h){if(h!==n)throw h}return{path:i,previousNode:r,isAtPropertyKey:a,matches:h=>{let A=0;for(let F=0;A<h.length&&F<i.length;F++)if(h[A]===i[F]||h[A]==="*")A++;else if(h[A]!=="**")return!1;return A===h.length}}}e.getLocation=E;function d(t,s=[],i=k.DEFAULT){let n=null,r=[];const o=[];function a(h){Array.isArray(r)?r.push(h):n!==null&&(r[n]=h)}return b(t,{onObjectBegin:()=>{const h={};a(h),o.push(r),r=h,n=null},onObjectProperty:h=>{n=h},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{const h=[];a(h),o.push(r),r=h,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(h,A,F)=>{s.push({error:h,offset:A,length:F})}},i),r[0]}e.parse=d;function w(t,s=[],i=k.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(h){n.type==="property"&&(n.length=h-n.offset,n=n.parent)}function o(h){return n.children.push(h),h}b(t,{onObjectBegin:h=>{n=o({type:"object",offset:h,length:-1,parent:n,children:[]})},onObjectProperty:(h,A,F)=>{n=o({type:"property",offset:A,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:h,offset:A,length:F,parent:n})},onObjectEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onArrayBegin:(h,A)=>{n=o({type:"array",offset:h,length:-1,parent:n,children:[]})},onArrayEnd:(h,A)=>{n.length=h+A-n.offset,n=n.parent,r(h+A)},onLiteralValue:(h,A,F)=>{o({type:m(h),offset:A,length:F,parent:n,value:h}),r(A+F)},onSeparator:(h,A,F)=>{n.type==="property"&&(h===":"?n.colonOffset=A:h===","&&r(A))},onError:(h,A,F)=>{s.push({error:h,offset:A,length:F})}},i);const l=n.children[0];return l&&delete l.parent,l}e.parseTree=w;function y(t,s){if(!t)return;let i=t;for(const n of s)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let r=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===n){i=o.children[1],r=!0;break}if(!r)return}else{const r=n;if(i.type!=="array"||r<0||!Array.isArray(i.children)||r>=i.children.length)return;i=i.children[r]}return i}e.findNodeAtLocation=y;function N(t){if(!t.parent||!t.parent.children)return[];const s=N(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;s.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&s.push(i)}return s}e.getNodePath=N;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const s=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(s[i.children[0].value]=c(n))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function f(t,s,i=!1){return s>=t.offset&&s<t.offset+t.length||i&&s===t.offset+t.length}e.contains=f;function p(t,s,i=!1){if(f(t,s,i)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const o=p(n[r],s,i);if(o)return o}return t}}e.findNodeAtOffset=p;function b(t,s,i=k.DEFAULT){const n=D(t,!1);function r(q){return q?()=>q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(q){return q?J=>q(J,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=r(s.onObjectBegin),l=o(s.onObjectProperty),h=r(s.onObjectEnd),A=r(s.onArrayBegin),F=r(s.onArrayEnd),X=o(s.onLiteralValue),ee=o(s.onSeparator),te=r(s.onComment),ie=o(s.onError),ne=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function fe(){for(;;){const q=n.scan();switch(n.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ne||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(q){case 12:case 13:ne?oe(10):te();break;case 16:oe(1);break;case 15:case 14:break;default:return q}}}function oe(q,J=[],C=[]){if(ie(q),J.length+C.length>0){let L=n.getToken();for(;L!==17;){if(J.indexOf(L)!==-1){fe();break}else if(C.indexOf(L)!==-1)break;L=fe()}}}function ve(q){const J=n.getTokenValue();return q?X(J):l(J),fe(),!0}function V(){switch(n.getToken()){case 11:{let q=0;try{q=JSON.parse(n.getTokenValue()),typeof q!="number"&&(oe(2),q=0)}catch{oe(2)}X(q);break}case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return fe(),!0}function j(){return n.getToken()!==10?(oe(3,[],[2,5]),!1):(ve(!1),n.getToken()===6?(ee(":"),fe(),W()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function M(){a(),fe();let q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(q||oe(4,[],[]),ee(","),fe(),n.getToken()===2&&ae)break}else q&&oe(6,[],[]);j()||oe(4,[],[2,5]),q=!0}return h(),n.getToken()!==2?oe(7,[2],[]):fe(),!0}function $(){A(),fe();let q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(q||oe(4,[],[]),ee(","),fe(),n.getToken()===4&&ae)break}else q&&oe(6,[],[]);W()||oe(4,[],[4,5]),q=!0}return F(),n.getToken()!==4?oe(8,[4],[]):fe(),!0}function W(){switch(n.getToken()){case 3:return $();case 1:return M();case 10:return ve(!0);default:return V()}}return fe(),n.getToken()===17?i.allowEmptyContent?!0:(oe(4,[],[]),!1):W()?(n.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.visit=b;function v(t,s){const i=D(t),n=[];let r,o=0,a;do switch(a=i.getPosition(),r=i.scan(),r){case 12:case 13:case 17:o!==a&&n.push(t.substring(o,a)),s!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,s)),o=i.getPosition();break}while(r!==17);return n.join("")}e.stripComments=v;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(Q[71],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function O(S,g,u){return Math.min(Math.max(S,g),u)}e.clamp=O;function R(S,g){return(g+S%g)%g}e.rot=R;class P{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=P;class k{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=k;class D{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const u=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=D}),function(){function x(P){const k=[];typeof P=="number"&&k.push("code/timeOrigin",P);function D(g){k.push(g,Date.now())}function S(){const g=[];for(let u=0;u<k.length;u+=2)g.push({name:k[u],startTime:k[u+1]});return g}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const D of performance.getEntriesByType("mark"))k.push({name:D.name,startTime:Math.round(P+D.startTime)});return k}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function O(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=O(R))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var R in O)(typeof exports=="object"?exports:x)[R]=O[R]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function O(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return x[R].call(P.exports,P,P.exports,O),P.l=!0,P.exports}return O.m=x,O.c=e,O.d=function(R,P,k){O.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:k})},O.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},O.t=function(R,P){if(1&P&&(R=O(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var k=Object.create(null);if(O.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var D in R)O.d(k,D,function(S){return R[S]}.bind(null,D));return k},O.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return O.d(P,"a",P),P},O.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},O.p="",O(O.s=0)}([function(x,e,O){(function(R){var P;e=x.exports=C,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],g=e.src=[],u=0,I=u++;g[I]="0|[1-9]\\d*";var E=u++;g[E]="[0-9]+";var d=u++;g[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=u++;g[w]="("+g[I]+")\\.("+g[I]+")\\.("+g[I]+")";var y=u++;g[y]="("+g[E]+")\\.("+g[E]+")\\.("+g[E]+")";var N=u++;g[N]="(?:"+g[I]+"|"+g[d]+")";var c=u++;g[c]="(?:"+g[E]+"|"+g[d]+")";var f=u++;g[f]="(?:-("+g[N]+"(?:\\."+g[N]+")*))";var p=u++;g[p]="(?:-?("+g[c]+"(?:\\."+g[c]+")*))";var b=u++;g[b]="[0-9A-Za-z-]+";var v=u++;g[v]="(?:\\+("+g[b]+"(?:\\."+g[b]+")*))";var m=u++,t="v?"+g[w]+g[f]+"?"+g[v]+"?";g[m]="^"+t+"$";var s="[v=\\s]*"+g[y]+g[p]+"?"+g[v]+"?",i=u++;g[i]="^"+s+"$";var n=u++;g[n]="((?:<|>)?=?)";var r=u++;g[r]=g[E]+"|x|X|\\*";var o=u++;g[o]=g[I]+"|x|X|\\*";var a=u++;g[a]="[v=\\s]*("+g[o]+")(?:\\.("+g[o]+")(?:\\.("+g[o]+")(?:"+g[f]+")?"+g[v]+"?)?)?";var l=u++;g[l]="[v=\\s]*("+g[r]+")(?:\\.("+g[r]+")(?:\\.("+g[r]+")(?:"+g[p]+")?"+g[v]+"?)?)?";var h=u++;g[h]="^"+g[n]+"\\s*"+g[a]+"$";var A=u++;g[A]="^"+g[n]+"\\s*"+g[l]+"$";var F=u++;g[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var X=u++;g[X]="(?:~>?)";var ee=u++;g[ee]="(\\s*)"+g[X]+"\\s+",S[ee]=new RegExp(g[ee],"g");var te=u++;g[te]="^"+g[X]+g[a]+"$";var ie=u++;g[ie]="^"+g[X]+g[l]+"$";var ne=u++;g[ne]="(?:\\^)";var ae=u++;g[ae]="(\\s*)"+g[ne]+"\\s+",S[ae]=new RegExp(g[ae],"g");var fe=u++;g[fe]="^"+g[ne]+g[a]+"$";var oe=u++;g[oe]="^"+g[ne]+g[l]+"$";var ve=u++;g[ve]="^"+g[n]+"\\s*("+s+")$|^$";var V=u++;g[V]="^"+g[n]+"\\s*("+t+")$|^$";var j=u++;g[j]="(\\s*)"+g[n]+"\\s*("+s+"|"+g[a]+")",S[j]=new RegExp(g[j],"g");var M=u++;g[M]="^\\s*("+g[a]+")\\s+-\\s+("+g[a]+")\\s*$";var $=u++;g[$]="^\\s*("+g[l]+")\\s+-\\s+("+g[l]+")\\s*$";var W=u++;g[W]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)P(q,g[q]),S[q]||(S[q]=new RegExp(g[q]));function J(B,K){if(B instanceof C)return B;if(typeof B!="string"||B.length>k||!(K?S[i]:S[m]).test(B))return null;try{return new C(B,K)}catch{return null}}function C(B,K){if(B instanceof C){if(B.loose===K)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof C))return new C(B,K);P("SemVer",B,K),this.loose=K;var Y=B.trim().match(K?S[i]:S[m]);if(!Y)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+Y[1],this.minor=+Y[2],this.patch=+Y[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");Y[4]?this.prerelease=Y[4].split(".").map(function(de){if(/^[0-9]+$/.test(de)){var pe=+de;if(pe>=0&&pe<D)return pe}return de}):this.prerelease=[],this.build=Y[5]?Y[5].split("."):[],this.format()}e.parse=J,e.valid=function(B,K){var Y=J(B,K);return Y?Y.version:null},e.clean=function(B,K){var Y=J(B.trim().replace(/^[=v]+/,""),K);return Y?Y.version:null},e.SemVer=C,C.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},C.prototype.toString=function(){return this.version},C.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof C||(B=new C(B,this.loose)),this.compareMain(B)||this.comparePre(B)},C.prototype.compareMain=function(B){return B instanceof C||(B=new C(B,this.loose)),T(this.major,B.major)||T(this.minor,B.minor)||T(this.patch,B.patch)},C.prototype.comparePre=function(B){if(B instanceof C||(B=new C(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var K=0;do{var Y=this.prerelease[K],de=B.prerelease[K];if(P("prerelease compare",K,Y,de),Y===void 0&&de===void 0)return 0;if(de===void 0)return 1;if(Y===void 0)return-1;if(Y!==de)return T(Y,de)}while(++K)},C.prototype.inc=function(B,K){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Y=this.prerelease.length;--Y>=0;)typeof this.prerelease[Y]=="number"&&(this.prerelease[Y]++,Y=-2);Y===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,K,Y,de){typeof Y=="string"&&(de=Y,Y=void 0);try{return new C(B,Y).inc(K,de).version}catch{return null}},e.diff=function(B,K){if(H(B,K))return null;var Y=J(B),de=J(K);if(Y.prerelease.length||de.prerelease.length){for(var pe in Y)if((pe==="major"||pe==="minor"||pe==="patch")&&Y[pe]!==de[pe])return"pre"+pe;return"prerelease"}for(var pe in Y)if((pe==="major"||pe==="minor"||pe==="patch")&&Y[pe]!==de[pe])return pe},e.compareIdentifiers=T;var L=/^[0-9]+$/;function T(B,K){var Y=L.test(B),de=L.test(K);return Y&&de&&(B=+B,K=+K),Y&&!de?-1:de&&!Y?1:B<K?-1:B>K?1:0}function U(B,K,Y){return new C(B,Y).compare(new C(K,Y))}function z(B,K,Y){return U(B,K,Y)>0}function G(B,K,Y){return U(B,K,Y)<0}function H(B,K,Y){return U(B,K,Y)===0}function re(B,K,Y){return U(B,K,Y)!==0}function le(B,K,Y){return U(B,K,Y)>=0}function ye(B,K,Y){return U(B,K,Y)<=0}function me(B,K,Y,de){var pe;switch(K){case"===":typeof B=="object"&&(B=B.version),typeof Y=="object"&&(Y=Y.version),pe=B===Y;break;case"!==":typeof B=="object"&&(B=B.version),typeof Y=="object"&&(Y=Y.version),pe=B!==Y;break;case"":case"=":case"==":pe=H(B,Y,de);break;case"!=":pe=re(B,Y,de);break;case">":pe=z(B,Y,de);break;case">=":pe=le(B,Y,de);break;case"<":pe=G(B,Y,de);break;case"<=":pe=ye(B,Y,de);break;default:throw new TypeError("Invalid operator: "+K)}return pe}function ce(B,K){if(B instanceof ce){if(B.loose===K)return B;B=B.value}if(!(this instanceof ce))return new ce(B,K);P("comparator",B,K),this.loose=K,this.parse(B),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,K){return T(K,B)},e.major=function(B,K){return new C(B,K).major},e.minor=function(B,K){return new C(B,K).minor},e.patch=function(B,K){return new C(B,K).patch},e.compare=U,e.compareLoose=function(B,K){return U(B,K,!0)},e.rcompare=function(B,K,Y){return U(K,B,Y)},e.sort=function(B,K){return B.sort(function(Y,de){return e.compare(Y,de,K)})},e.rsort=function(B,K){return B.sort(function(Y,de){return e.rcompare(Y,de,K)})},e.gt=z,e.lt=G,e.eq=H,e.neq=re,e.gte=le,e.lte=ye,e.cmp=me,e.Comparator=ce;var ge={};function se(B,K){if(B instanceof se)return B.loose===K?B:new se(B.raw,K);if(B instanceof ce)return new se(B.value,K);if(!(this instanceof se))return new se(B,K);if(this.loose=K,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(Y){return this.parseRange(Y.trim())},this).filter(function(Y){return Y.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function ue(B){return!B||B.toLowerCase()==="x"||B==="*"}function we(B,K,Y,de,pe,Oe,be,Ne,Re,Le,Me,ke,Te){return((K=ue(Y)?"":ue(de)?">="+Y+".0.0":ue(pe)?">="+Y+"."+de+".0":">="+K)+" "+(Ne=ue(Re)?"":ue(Le)?"<"+(+Re+1)+".0.0":ue(Me)?"<"+Re+"."+(+Le+1)+".0":ke?"<="+Re+"."+Le+"."+Me+"-"+ke:"<="+Ne)).trim()}function Pe(B,K){for(var Y=0;Y<B.length;Y++)if(!B[Y].test(K))return!1;if(K.prerelease.length){for(Y=0;Y<B.length;Y++)if(P(B[Y].semver),B[Y].semver!==ge&&B[Y].semver.prerelease.length>0){var de=B[Y].semver;if(de.major===K.major&&de.minor===K.minor&&de.patch===K.patch)return!0}return!1}return!0}function je(B,K,Y){try{K=new se(K,Y)}catch{return!1}return K.test(B)}function Ue(B,K,Y,de){var pe,Oe,be,Ne,Re;switch(B=new C(B,de),K=new se(K,de),Y){case">":pe=z,Oe=ye,be=G,Ne=">",Re=">=";break;case"<":pe=G,Oe=le,be=z,Ne="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(B,K,de))return!1;for(var Le=0;Le<K.set.length;++Le){var Me=K.set[Le],ke=null,Te=null;if(Me.forEach(function(Ae){Ae.semver===ge&&(Ae=new ce(">=0.0.0")),ke=ke||Ae,Te=Te||Ae,pe(Ae.semver,ke.semver,de)?ke=Ae:be(Ae.semver,Te.semver,de)&&(Te=Ae)}),ke.operator===Ne||ke.operator===Re||(!Te.operator||Te.operator===Ne)&&Oe(B,Te.semver)||Te.operator===Re&&be(B,Te.semver))return!1}return!0}ce.prototype.parse=function(B){var K=this.loose?S[ve]:S[V],Y=B.match(K);if(!Y)throw new TypeError("Invalid comparator: "+B);this.operator=Y[1],this.operator==="="&&(this.operator=""),Y[2]?this.semver=new C(Y[2],this.loose):this.semver=ge},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===ge||(typeof B=="string"&&(B=new C(B,this.loose)),me(B,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(B,K){if(!(B instanceof ce))throw new TypeError("a Comparator is required");var Y;if(this.operator==="")return Y=new se(B.value,K),je(this.value,Y,K);if(B.operator==="")return Y=new se(this.value,K),je(B.semver,Y,K);var de=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),pe=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Oe=this.semver.version===B.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ne=me(this.semver,"<",B.semver,K)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),Re=me(this.semver,">",B.semver,K)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return de||pe||Oe&&be||Ne||Re},e.Range=se,se.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},se.prototype.toString=function(){return this.range},se.prototype.parseRange=function(B){var K=this.loose;B=B.trim(),P("range",B,K);var Y=K?S[$]:S[M];B=B.replace(Y,we),P("hyphen replace",B),B=B.replace(S[j],"$1$2$3"),P("comparator trim",B,S[j]),B=(B=(B=B.replace(S[ee],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var de=K?S[ve]:S[V],pe=B.split(" ").map(function(Oe){return function(be,Ne){return P("comp",be),be=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(ke,Te){P("caret",ke,Te);var Ae=Te?S[oe]:S[fe];return ke.replace(Ae,function(Fe,Ee,Se,Ie,De){var Ce;return P("caret",ke,Fe,Ee,Se,Ie,De),ue(Ee)?Ce="":ue(Se)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ce=Ee==="0"?">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+".0 <"+(+Ee+1)+".0.0":De?(P("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ce=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Ie+De+" <"+Ee+"."+Se+"."+(+Ie+1):">="+Ee+"."+Se+"."+Ie+De+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Ie+De+" <"+(+Ee+1)+".0.0"):(P("no pr"),Ce=Ee==="0"?Se==="0"?">="+Ee+"."+Se+"."+Ie+" <"+Ee+"."+Se+"."+(+Ie+1):">="+Ee+"."+Se+"."+Ie+" <"+Ee+"."+(+Se+1)+".0":">="+Ee+"."+Se+"."+Ie+" <"+(+Ee+1)+".0.0"),P("caret return",Ce),Ce})}(Me,Le)}).join(" ")}(be,Ne),P("caret",be),be=function(Re,Le){return Re.trim().split(/\s+/).map(function(Me){return function(ke,Te){var Ae=Te?S[ie]:S[te];return ke.replace(Ae,function(Fe,Ee,Se,Ie,De){var Ce;return P("tilde",ke,Fe,Ee,Se,Ie,De),ue(Ee)?Ce="":ue(Se)?Ce=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ue(Ie)?Ce=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0":De?(P("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ce=">="+Ee+"."+Se+"."+Ie+De+" <"+Ee+"."+(+Se+1)+".0"):Ce=">="+Ee+"."+Se+"."+Ie+" <"+Ee+"."+(+Se+1)+".0",P("tilde return",Ce),Ce})}(Me,Le)}).join(" ")}(be,Ne),P("tildes",be),be=function(Re,Le){return P("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(Me){return function(ke,Te){ke=ke.trim();var Ae=Te?S[A]:S[h];return ke.replace(Ae,function(Fe,Ee,Se,Ie,De,Ce){P("xRange",ke,Fe,Ee,Se,Ie,De,Ce);var xe=ue(Se),Be=xe||ue(Ie),Ve=Be||ue(De);return Ee==="="&&Ve&&(Ee=""),xe?Fe=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(Be&&(Ie=0),Ve&&(De=0),Ee===">"?(Ee=">=",Be?(Se=+Se+1,Ie=0,De=0):Ve&&(Ie=+Ie+1,De=0)):Ee==="<="&&(Ee="<",Be?Se=+Se+1:Ie=+Ie+1),Fe=Ee+Se+"."+Ie+"."+De):Be?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ve&&(Fe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),P("xRange return",Fe),Fe})}(Me,Le)}).join(" ")}(be,Ne),P("xrange",be),be=function(Re,Le){return P("replaceStars",Re,Le),Re.trim().replace(S[W],"")}(be,Ne),P("stars",be),be}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(pe=pe.filter(function(Oe){return!!Oe.match(de)})),pe=pe.map(function(Oe){return new ce(Oe,K)})},se.prototype.intersects=function(B,K){if(!(B instanceof se))throw new TypeError("a Range is required");return this.set.some(function(Y){return Y.every(function(de){return B.set.some(function(pe){return pe.every(function(Oe){return de.intersects(Oe,K)})})})})},e.toComparators=function(B,K){return new se(B,K).set.map(function(Y){return Y.map(function(de){return de.value}).join(" ").trim().split(" ")})},se.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new C(B,this.loose));for(var K=0;K<this.set.length;K++)if(Pe(this.set[K],B))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(B,K,Y){var de=null,pe=null;try{var Oe=new se(K,Y)}catch{return null}return B.forEach(function(be){Oe.test(be)&&(de&&pe.compare(be)!==-1||(pe=new C(de=be,Y)))}),de},e.minSatisfying=function(B,K,Y){var de=null,pe=null;try{var Oe=new se(K,Y)}catch{return null}return B.forEach(function(be){Oe.test(be)&&(de&&pe.compare(be)!==1||(pe=new C(de=be,Y)))}),de},e.validRange=function(B,K){try{return new se(B,K).range||"*"}catch{return null}},e.ltr=function(B,K,Y){return Ue(B,K,"<",Y)},e.gtr=function(B,K,Y){return Ue(B,K,">",Y)},e.outside=Ue,e.prerelease=function(B,K){var Y=J(B,K);return Y&&Y.prerelease.length?Y.prerelease:null},e.intersects=function(B,K,Y){return B=new se(B,Y),K=new se(K,Y),B.intersects(K)},e.coerce=function(B){if(B instanceof C)return B;if(typeof B!="string")return null;var K=B.match(S[F]);return K==null?null:J((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,O(1))},function(x,e){var O,R,P=x.exports={};function k(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(c){if(O===setTimeout)return setTimeout(c,0);if((O===k||!O)&&setTimeout)return O=setTimeout,setTimeout(c,0);try{return O(c,0)}catch{try{return O.call(null,c,0)}catch{return O.call(this,c,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:k}catch{O=k}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var g,u=[],I=!1,E=-1;function d(){I&&g&&(I=!1,g.length?u=g.concat(u):E=-1,u.length&&w())}function w(){if(!I){var c=S(d);I=!0;for(var f=u.length;f;){for(g=u,u=[];++E<f;)g&&g[E].run();E=-1,f=u.length}g=null,I=!1,function(p){if(R===clearTimeout)return clearTimeout(p);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(p);try{R(p)}catch{try{return R.call(null,p)}catch{return R.call(this,p)}}}(c)}}function y(c,f){this.fun=c,this.array=f}function N(){}P.nextTick=function(c){var f=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)f[p-1]=arguments[p];u.push(new y(c,f)),u.length!==1||I||S(w)},y.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=N,P.addListener=N,P.once=N,P.off=N,P.removeListener=N,P.removeAllListeners=N,P.emit=N,P.prependListener=N,P.prependOnceListener=N,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[72],_([0,1]),function(x,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class R{constructor(S,g,u){this.level=S,this.key=g,this.value=u,this.forward=[]}}const P=void 0;class k{constructor(S,g=2**16){this.comparator=S,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(g)|0),this.e=new R(this.c,P,P)}get size(){return this.f}clear(){this.e=new R(this.c,P,P)}has(S){return Boolean(k.g(this,S,this.comparator))}get(S){return k.g(this,S,this.comparator)?.value}set(S,g){return k.h(this,S,g,this.comparator)&&(this.f+=1),this}delete(S){const g=k.k(this,S,this.comparator);return g&&(this.f-=1),g}forEach(S,g){let u=this.e.forward[0];for(;u;)S.call(g,u.value,u.key,this),u=u.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",g=this.e.forward[0];for(;g;)S+=`node(${g.key}, ${g.value}, lvl:${g.level})`,g=g.forward[0];return S}static g(S,g,u){let I=S.e;for(let E=S.d-1;E>=0;E--)for(;I.forward[E]&&u(I.forward[E].key,g)<0;)I=I.forward[E];if(I=I.forward[0],I&&u(I.key,g)===0)return I}static h(S,g,u,I){const E=[];let d=S.e;for(let w=S.d-1;w>=0;w--){for(;d.forward[w]&&I(d.forward[w].key,g)<0;)d=d.forward[w];E[w]=d}if(d=d.forward[0],d&&I(d.key,g)===0)return d.value=u,!1;{const w=k.j(S);if(w>S.d){for(let y=S.d;y<w;y++)E[y]=S.e;S.d=w}d=new R(w,g,u);for(let y=0;y<w;y++)d.forward[y]=E[y].forward[y],E[y].forward[y]=d;return!0}}static j(S,g=.5){let u=1;for(;Math.random()<g&&u<S.c;)u+=1;return u}static k(S,g,u){const I=[];let E=S.e;for(let d=S.d-1;d>=0;d--){for(;E.forward[d]&&u(E.forward[d].key,g)<0;)E=E.forward[d];I[d]=E}if(E=E.forward[0],!E||u(E.key,g)!==0)return!1;for(let d=0;d<S.d&&I[d].forward[d]===E;d++)I[d].forward[d]=E.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===P;)S.d-=1;return!0}}e.SkipList=k}),define(Q[43],_([0,1,7,2]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function P(v){const m=v;return m?typeof m.read=="function":!1}e.isReadable=P;function k(v){const m=v;return m?[m.on,m.pause,m.resume,m.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=k;function D(v){const m=v;return m?k(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=D;function S(v,m){return new g(v,m)}e.newWriteableStream=S;class g{constructor(m,t){this.e=m,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(m){if(!this.a.destroyed){if(this.a.flowing)this.g(m);else if(this.b.data.push(m),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(m){this.a.destroyed||(this.a.flowing?this.h(m):this.b.error.push(m))}end(m){this.a.destroyed||(typeof m<"u"&&this.write(m),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(m){this.c.data.slice(0).forEach(t=>t(m))}h(m){this.c.error.length===0?(0,O.onUnexpectedError)(m):this.c.error.slice(0).forEach(t=>t(m))}i(){this.c.end.slice(0).forEach(m=>m())}on(m,t){if(!this.a.destroyed)switch(m){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(m,t){if(this.a.destroyed)return;let s;switch(m){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const i=s.indexOf(t);i>=0&&s.splice(i,1)}}j(){if(this.b.data.length>0){const m=this.e(this.b.data);this.g(m),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const m of this.b.error)this.h(m);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(v,m){const t=[];let s;for(;(s=v.read())!==null;)t.push(s);return m(t)}e.consumeReadable=u;function I(v,m,t){const s=[];let i;for(;(i=v.read())!==null&&s.length<t;)s.push(i);return i===null&&s.length>0?m(s):{read:()=>{if(s.length>0)return s.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return v.read()}}}e.peekReadable=I;function E(v,m){return new Promise((t,s)=>{const i=[];d(v,{onData:n=>{m&&i.push(n)},onError:n=>{m?s(n):t(void 0)},onEnd:()=>{t(m?m(i):void 0)}})})}e.consumeStream=E;function d(v,m){let t=!1;return v.on("error",s=>{t||m.onError(s)}),v.on("end",()=>{t||m.onEnd()}),v.on("data",s=>{t||m.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=d;function w(v,m){return new Promise((t,s)=>{const i=new R.DisposableStore,n=[],r=l=>{if(n.push(l),n.length>m)return i.dispose(),v.pause(),t({stream:v,buffer:n,ended:!1})},o=l=>s(l),a=()=>t({stream:v,buffer:n,ended:!0});i.add((0,R.toDisposable)(()=>v.removeListener("error",o))),v.on("error",o),i.add((0,R.toDisposable)(()=>v.removeListener("end",a))),v.on("end",a),i.add((0,R.toDisposable)(()=>v.removeListener("data",r))),v.on("data",r)})}e.peekStream=w;function y(v,m){const t=S(m);return t.end(v),t}e.toStream=y;function N(){const v=S(()=>{throw new Error("not supported")});return v.end(),v}e.emptyStream=N;function c(v){let m=!1;return{read:()=>m?null:(m=!0,v)}}e.toReadable=c;function f(v,m,t){const s=S(t);return d(v,{onData:i=>s.write(m.data(i)),onError:i=>s.error(m.error?m.error(i):i),onEnd:()=>s.end()}),s}e.transform=f;function p(v,m,t){let s=!1;return{read:()=>{const i=m.read();return s?i:(s=!0,i!==null?t([v,i]):v)}}}e.prefixedReadable=p;function b(v,m,t){let s=!1;const i=S(t);return d(m,{onData:n=>s?i.write(n):(s=!0,i.write(t([v,n]))),onError:n=>i.error(n),onEnd:()=>{s||(s=!0,i.write(v)),i.end()}}),i}e.prefixedStream=b}),define(Q[14],_([0,1,43]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let P,k;class D{static alloc(l){return R?new D(Buffer.allocUnsafe(l)):new D(new Uint8Array(l))}static wrap(l){return R&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new D(l)}static fromString(l,h){return!(h?.dontUseNodeBuffer||!1)&&R?new D(Buffer.from(l)):(P||(P=new TextEncoder),new D(P.encode(l)))}static fromByteArray(l){const h=D.alloc(l.length);for(let A=0,F=l.length;A<F;A++)h.buffer[A]=l[A];return h}static concat(l,h){if(typeof h>"u"){h=0;for(let X=0,ee=l.length;X<ee;X++)h+=l[X].byteLength}const A=D.alloc(h);let F=0;for(let X=0,ee=l.length;X<ee;X++){const te=l[X];A.set(te,F),F+=te.byteLength}return A}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=D.alloc(this.byteLength);return l.set(this),l}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(l,h){return new D(this.buffer.subarray(l,h))}set(l,h){if(l instanceof D)this.buffer.set(l.buffer,h);else if(l instanceof Uint8Array)this.buffer.set(l,h);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),h);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),h);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return u(this.buffer,l)}writeUInt32BE(l,h){I(this.buffer,l,h)}readUInt32LE(l){return E(this.buffer,l)}writeUInt32LE(l,h){d(this.buffer,l,h)}readUInt8(l){return w(this.buffer,l)}writeUInt8(l,h){y(this.buffer,l,h)}}e.VSBuffer=D;function S(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=S;function g(a,l,h){a[h+0]=l&255,l=l>>>8,a[h+1]=l&255}e.writeUInt16LE=g;function u(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=u;function I(a,l,h){a[h+3]=l,l=l>>>8,a[h+2]=l,l=l>>>8,a[h+1]=l,l=l>>>8,a[h]=l}e.writeUInt32BE=I;function E(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=E;function d(a,l,h){a[h+0]=l&255,l=l>>>8,a[h+1]=l&255,l=l>>>8,a[h+2]=l&255,l=l>>>8,a[h+3]=l&255}e.writeUInt32LE=d;function w(a,l){return a[l]}e.readUInt8=w;function y(a,l,h){a[h]=l}e.writeUInt8=y;function N(a){return O.consumeReadable(a,l=>D.concat(l))}e.readableToBuffer=N;function c(a){return O.toReadable(a)}e.bufferToReadable=c;function f(a){return O.consumeStream(a,l=>D.concat(l))}e.streamToBuffer=f;async function p(a){return a.ended?D.concat(a.buffer):D.concat([...a.buffer,await f(a.stream)])}e.bufferedStreamToBuffer=p;function b(a){return O.toStream(a,l=>D.concat(l))}e.bufferToStream=b;function v(a){return O.transform(a,{data:l=>typeof l=="string"?D.fromString(l):D.wrap(l)},l=>D.concat(l))}e.streamToBufferReadableStream=v;function m(a){return O.newWriteableStream(l=>D.concat(l),a)}e.newWriteableBufferStream=m;function t(a,l){return O.prefixedReadable(a,l,h=>D.concat(h))}e.prefixedBufferReadable=t;function s(a,l){return O.prefixedStream(a,l,h=>D.concat(h))}e.prefixedBufferStream=s;function i(a){let l=0,h=0,A=0;const F=new Uint8Array(Math.floor(a.length/4*3)),X=te=>{switch(h){case 3:F[A++]=l|te,h=0;break;case 2:F[A++]=l|te>>>2,l=te<<6,h=3;break;case 1:F[A++]=l|te>>>4,l=te<<4,h=2;break;default:l=te<<2,h=1}};for(let te=0;te<a.length;te++){const ie=a.charCodeAt(te);if(ie>=65&&ie<=90)X(ie-65);else if(ie>=97&&ie<=122)X(ie-97+26);else if(ie>=48&&ie<=57)X(ie-48+52);else if(ie===43||ie===45)X(62);else if(ie===47||ie===95)X(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${a[te]}`)}}const ee=A;for(;h>0;)X(0);return D.wrap(F).slice(0,ee)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:a},l=!0,h=!1){const A=h?r:n;let F="";const X=a.byteLength%3;let ee=0;for(;ee<a.byteLength-X;ee+=3){const te=a[ee+0],ie=a[ee+1],ne=a[ee+2];F+=A[te>>>2],F+=A[(te<<4|ie>>>4)&63],F+=A[(ie<<2|ne>>>6)&63],F+=A[ne&63]}if(X===1){const te=a[ee+0];F+=A[te>>>2],F+=A[te<<4&63],l&&(F+="==")}else if(X===2){const te=a[ee+0],ie=a[ee+1];F+=A[te>>>2],F+=A[(te<<4|ie>>>4)&63],F+=A[ie<<2&63],l&&(F+="=")}return F}e.encodeBase64=o}),define(Q[28],_([0,1,3]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const p=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([b,v])=>{p[b]=v&&typeof v=="object"?R(v):v}),p}e.deepClone=R;function P(f){if(!f||typeof f!="object")return f;const p=[f];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const v in b)if(k.call(b,v)){const m=b[v];typeof m=="object"&&!Object.isFrozen(m)&&!(0,O.isTypedArray)(m)&&p.push(m)}}return f}e.deepFreeze=P;const k=Object.prototype.hasOwnProperty;function D(f,p){return S(f,p,new Set)}e.cloneAndChange=D;function S(f,p,b){if((0,O.isUndefinedOrNull)(f))return f;const v=p(f);if(typeof v<"u")return v;if(Array.isArray(f)){const m=[];for(const t of f)m.push(S(t,p,b));return m}if((0,O.isObject)(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const m={};for(const t in f)k.call(f,t)&&(m[t]=S(f[t],p,b));return b.delete(f),m}return f}function g(f,p,b=!0){return(0,O.isObject)(f)?((0,O.isObject)(p)&&Object.keys(p).forEach(v=>{v in f?b&&((0,O.isObject)(f[v])&&(0,O.isObject)(p[v])?g(f[v],p[v],b):f[v]=p[v]):f[v]=p[v]}),f):p}e.mixin=g;function u(f,p){if(f===p)return!0;if(f==null||p===null||p===void 0||typeof f!=typeof p||typeof f!="object"||Array.isArray(f)!==Array.isArray(p))return!1;let b,v;if(Array.isArray(f)){if(f.length!==p.length)return!1;for(b=0;b<f.length;b++)if(!u(f[b],p[b]))return!1}else{const m=[];for(v in f)m.push(v);m.sort();const t=[];for(v in p)t.push(v);if(t.sort(),!u(m,t))return!1;for(b=0;b<m.length;b++)if(!u(f[m[b]],p[m[b]]))return!1}return!0}e.equals=u;function I(f){const p=new Set;return JSON.stringify(f,(b,v)=>{if((0,O.isObject)(v)||Array.isArray(v)){if(p.has(v))return"[Circular]";p.add(v)}return v})}e.safeStringify=I;function E(f,p){const b=Object.create(null);return!f||!p||Object.keys(p).forEach(m=>{const t=f[m],s=p[m];u(t,s)||(b[m]=s)}),b}e.distinct=E;function d(f,p){const b=p.toLowerCase(),v=Object.keys(f).find(m=>m.toLowerCase()===b);return v?f[v]:f[p]}e.getCaseInsensitive=d;function w(f,p){const b=Object.create(null);for(const[v,m]of Object.entries(f))p(v,m)&&(b[v]=m);return b}e.filter=w;function y(f){let p=[],b=Object.getPrototypeOf(f);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=y;function N(f){const p=[];for(const b of y(f))typeof f[b]=="function"&&p.push(b);return p}e.getAllMethodNames=N;function c(f,p){const b=m=>function(){const t=Array.prototype.slice.call(arguments,0);return p(m,t)},v={};for(const m of f)v[m]=b(m);return v}e.createProxyObject=c}),define(Q[29],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return O.test(P)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(S){for(let g=0;g<S.length;g++)S[g]=Math.floor(Math.random()*256);return S};const k=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){P(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let g=0,u="";return u+=D[k[g++]],u+=D[k[g++]],u+=D[k[g++]],u+=D[k[g++]],u+="-",u+=D[k[g++]],u+=D[k[g++]],u+="-",u+=D[k[g++]],u+=D[k[g++]],u+="-",u+=D[k[g++]],u+=D[k[g++]],u+="-",u+=D[k[g++]],u+=D[k[g++]],u+=D[k[g++]],u+=D[k[g++]],u+=D[k[g++]],u+=D[k[g++]],u}}()}),define(Q[73],_([0,1,33]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(D){const S=D.replace(/\-/g,":").toLowerCase();return!R.has(S)}function k(){const D=(0,O.networkInterfaces)();for(const S in D){const g=D[S];if(g){for(const{mac:u}of g)if(P(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=k}),define(Q[74],_([8,9]),function(x,e){return x.create("vs/base/common/date",e)}),define(Q[75],_([0,1,74]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,P=R*60,k=P*24,D=k*7,S=k*30,g=k*365;function u(E,d,w,y){typeof E!="number"&&(E=E.getTime());const N=Math.round((new Date().getTime()-E)/1e3);if(N<-30)return(0,O.localize)(0,null,u(new Date().getTime()+N*1e3,!1));if(!y&&N<30)return(0,O.localize)(1,null);let c;return N<R?(c=N,d?c===1?w?(0,O.localize)(2,null,c):(0,O.localize)(3,null,c):w?(0,O.localize)(4,null,c):(0,O.localize)(5,null,c):c===1?w?(0,O.localize)(6,null,c):(0,O.localize)(7,null,c):w?(0,O.localize)(8,null,c):(0,O.localize)(9,null,c)):N<P?(c=Math.floor(N/R),d?c===1?w?(0,O.localize)(10,null,c):(0,O.localize)(11,null,c):w?(0,O.localize)(12,null,c):(0,O.localize)(13,null,c):c===1?w?(0,O.localize)(14,null,c):(0,O.localize)(15,null,c):w?(0,O.localize)(16,null,c):(0,O.localize)(17,null,c)):N<k?(c=Math.floor(N/P),d?c===1?w?(0,O.localize)(18,null,c):(0,O.localize)(19,null,c):w?(0,O.localize)(20,null,c):(0,O.localize)(21,null,c):c===1?w?(0,O.localize)(22,null,c):(0,O.localize)(23,null,c):w?(0,O.localize)(24,null,c):(0,O.localize)(25,null,c)):N<D?(c=Math.floor(N/k),d?c===1?(0,O.localize)(26,null,c):(0,O.localize)(27,null,c):c===1?(0,O.localize)(28,null,c):(0,O.localize)(29,null,c)):N<S?(c=Math.floor(N/D),d?c===1?w?(0,O.localize)(30,null,c):(0,O.localize)(31,null,c):w?(0,O.localize)(32,null,c):(0,O.localize)(33,null,c):c===1?w?(0,O.localize)(34,null,c):(0,O.localize)(35,null,c):w?(0,O.localize)(36,null,c):(0,O.localize)(37,null,c)):N<g?(c=Math.floor(N/S),d?c===1?w?(0,O.localize)(38,null,c):(0,O.localize)(39,null,c):w?(0,O.localize)(40,null,c):(0,O.localize)(41,null,c):c===1?w?(0,O.localize)(42,null,c):(0,O.localize)(43,null,c):w?(0,O.localize)(44,null,c):(0,O.localize)(45,null,c)):(c=Math.floor(N/g),d?c===1?w?(0,O.localize)(46,null,c):(0,O.localize)(47,null,c):w?(0,O.localize)(48,null,c):(0,O.localize)(49,null,c):c===1?w?(0,O.localize)(50,null,c):(0,O.localize)(51,null,c):w?(0,O.localize)(52,null,c):(0,O.localize)(53,null,c))}e.fromNow=u;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(Q[76],_([8,9]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(Q[34],_([0,1,19,3,76]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function k(E,d){return d&&(E.stack||E.stacktrace)?P.localize(0,null,S(E),D(E.stack)||D(E.stacktrace)):S(E)}function D(E){return Array.isArray(E)?E.join(`
`):E}function S(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?P.localize(1,null,E.message):E.message||P.localize(2,null)}function g(E=null,d=!1){if(!E)return P.localize(3,null);if(Array.isArray(E)){const w=O.coalesce(E),y=g(w[0],d);return w.length>1?P.localize(4,null,y,w.length):y}if(R.isString(E))return E;if(E.detail){const w=E.detail;if(w.error)return k(w.error,d);if(w.exception)return k(w.exception,d)}return E.stack?k(E,d):E.message?E.message:P.localize(5,null)}e.toErrorMessage=g;function u(E){const d=E;return d instanceof Error&&Array.isArray(d.actions)}e.isErrorWithActions=u;function I(E,d){let w;return typeof E=="string"?w=new Error(E):w=E,w.actions=d,w}e.createErrorWithActions=I}),define(Q[77],_([8,9]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(Q[78],_([0,1,77]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function R(P){switch(P){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.getParseErrorMessage=R}),define(Q[50],_([0,1,12]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R=e.Source||(e.Source={}));var P;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(S,...g){const u=g.reduce((d,w)=>(d[w]=!0,d),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!u[d]).forEach(d=>{for(let w=0;w<I.length;w++)if(d.search(I[w])!==-1){delete S[d];break}})}e.sanitizeProcessEnvironment=k;function D(S){!S||(delete S.DEBUG,O.isMacintosh&&delete S.DYLD_LIBRARY_PATH,O.isLinux&&delete S.LD_PRELOAD)}e.removeDangerousEnvVariables=D}),define(Q[51],_([0,1,30]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(f){return P(f,0)}e.hash=R;function P(f,p){switch(typeof f){case"object":return f===null?k(349,p):Array.isArray(f)?g(f,p):u(f,p);case"string":return S(f,p);case"boolean":return D(f,p);case"number":return k(f,p);case"undefined":return k(937,p);default:return k(617,p)}}e.doHash=P;function k(f,p){return(p<<5)-p+f|0}e.numberHash=k;function D(f,p){return k(f?433:863,p)}function S(f,p){p=k(149417,p);for(let b=0,v=f.length;b<v;b++)p=k(f.charCodeAt(b),p);return p}e.stringHash=S;function g(f,p){return p=k(104579,p),f.reduce((b,v)=>P(v,b),p)}function u(f,p){return p=k(181387,p),Object.keys(f).sort().reduce((b,v)=>(b=S(v,b),P(f[v],b)),p)}class I{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=P(p,this.g),this.g}}e.Hasher=I;var E;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(f,p,b=32){const v=b-p,m=~((1<<v)-1);return(f<<p|(m&f)>>>v)>>>0}function w(f,p=0,b=f.byteLength,v=0){for(let m=0;m<b;m++)f[p+m]=v}function y(f,p,b="0"){for(;f.length<p;)f=b+f;return f}function N(f,p=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((f>>>0).toString(16),p/4)}e.toHexString=N;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const v=this.p;let m=this.r,t=this.u,s,i;for(t!==0?(s=t,i=-1,t=0):(s=p.charCodeAt(0),i=0);;){let n=s;if(O.isHighSurrogate(s))if(i+1<b){const r=p.charCodeAt(i+1);O.isLowSurrogate(r)?(i++,n=O.computeCodePoint(s,r)):n=65533}else{t=s;break}else O.isLowSurrogate(s)&&(n=65533);if(m=this.w(v,m,n),i++,i<b)s=p.charCodeAt(i);else break}this.r=m,this.u=t}w(p,b,v){return v<128?p[b++]=v:v<2048?(p[b++]=192|(v&1984)>>>6,p[b++]=128|(v&63)>>>0):v<65536?(p[b++]=224|(v&61440)>>>12,p[b++]=128|(v&4032)>>>6,p[b++]=128|(v&63)>>>0):(p[b++]=240|(v&1835008)>>>18,p[b++]=128|(v&258048)>>>12,p[b++]=128|(v&4032)>>>6,p[b++]=128|(v&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=c.g,b=this.q;for(let a=0;a<64;a+=4)p.setUint32(a,b.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)p.setUint32(a,d(p.getUint32(a-12,!1)^p.getUint32(a-32,!1)^p.getUint32(a-56,!1)^p.getUint32(a-64,!1),1),!1);let v=this.h,m=this.l,t=this.m,s=this.n,i=this.o,n,r,o;for(let a=0;a<80;a++)a<20?(n=m&t|~m&s,r=1518500249):a<40?(n=m^t^s,r=1859775393):a<60?(n=m&t|m&s|t&s,r=2400959708):(n=m^t^s,r=3395469782),o=d(v,5)+n+i+r+p.getUint32(a*4,!1)&4294967295,i=s,s=t,t=d(m,30),m=v,v=o;this.h=this.h+v&4294967295,this.l=this.l+m&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+i&4294967295}}c.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(Q[52],_([0,1,30]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const k="error",D="warning",S="warn",g="info",u="ignore";function I(d){return d?O.equalsIgnoreCase(k,d)?P.Error:O.equalsIgnoreCase(D,d)||O.equalsIgnoreCase(S,d)?P.Warning:O.equalsIgnoreCase(g,d)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function E(d){switch(d){case P.Error:return k;case P.Warning:return D;case P.Info:return g;default:return u}}P.toString=E}(R||(R={})),e.default=R}),define(Q[79],_([0,1,11]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(u){const I=u;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=R;function P(u){const I=[];let E;try{const d=JSON.parse(u.arguments),w=d[d.length-1];w&&w.__$stack&&(d.pop(),E=w.__$stack),I.push(...d)}catch{I.push("Unable to log remote console arguments",u.arguments)}return{args:I,stack:E}}e.parse=P;function k(u){if(typeof u!="string")return k(P(u).stack);const I=u;if(I){const E=D(I),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:O.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=k;function D(u){if(!u)return u;const I=u.indexOf(`
`);return I===-1?u:u.substring(0,I)}function S(u,I){const{args:E,stack:d}=P(u),w=typeof E[0]=="string"&&E.length===1;let y=D(d);y&&(y=`(${y.trim()})`);let N=[];if(typeof E[0]=="string"?y&&w?N=[`%c[${I}] %c${E[0]} %c${y}`,g("blue"),g(""),g("grey")]:N=[`%c[${I}] %c${E[0]}`,g("blue"),g(""),...E.slice(1)]:N=[`%c[${I}]%`,g("blue"),...E],y&&!w&&N.push(y),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,N)}e.log=S;function g(u){return`color: ${u}`}}),define(Q[53],_([0,1,14,30,11]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function k(u){return JSON.stringify(u,S)}e.stringify=k;function D(u){let I=JSON.parse(u);return I=g(I),I}e.parse=D;function S(u,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,R.regExpFlags)(I)}:I}function g(u,I=0){if(!u||I>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return P.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof O.VSBuffer||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let E=0;E<u.length;++E)u[E]=g(u[E],I+1);else for(const E in u)Object.hasOwnProperty.call(u,E)&&(u[E]=g(u[E],I+1))}return u}e.revive=g}),define(Q[80],_([0,1,33,7,54,29,73]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(I){return this.a||(this.a=P.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(I)}value(){if(this.b===void 0){let I=0,E=0;const d=(0,O.networkInterfaces)();for(const w in d){const y=d[w];if(y)for(const{mac:N,internal:c}of y)c||(E+=1,this.c(N.toUpperCase())&&(I+=1))}this.b=E>0?I/E:0}return this.b}};let S;async function g(){return S||(S=(async()=>await u()||k.generateUuid())()),S}e.getMachineId=g;async function u(){try{const I=await new Promise((d,w)=>{x(["crypto"],d,w)}),E=(0,D.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){R.onUnexpectedError(I);return}}}),define(Q[81],_([0,1,33,15,20]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const k=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var g;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(g||(g={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(m,t,s){this.exePath=m,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:v=!1}={}){return v?u===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:v=!1,findPreview:m=!1}={}){const t=d({useAlternateBitness:v});if(!t)return null;const s=R.join(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(s))return null;let i=-1,n=null;for(const a of await P.Promises.readdir(s)){let l=-1;if(m){const A=a.indexOf("-");if(A<0)continue;const F=a.substring(0,A);if(!k.test(F)||a.substring(A+1)!=="preview")continue;l=parseInt(F,10)}else{if(!k.test(a))continue;l=parseInt(a,10)}if(l<=i)continue;const h=R.join(s,a,"pwsh.exe");!await P.SymlinkSupport.existsFile(h)||(n=h,i=l)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",o=m?" Preview":"";return new E(n,`PowerShell${o}${r}`,!0)}async function y({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const m=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(m))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=v?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const i of await P.Promises.readdir(m))if(t.test(i)){const n=R.join(m,i,"pwsh.exe");return new E(n,s)}return null}function N(){const v=R.join(O.homedir(),".dotnet","tools","pwsh.exe");return new E(v,".NET Core PowerShell Global Tool")}function c(){const v=R.join(process.env.windir,u===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(v,"Windows PowerShell",!0)}async function*f(){let v=await w();v&&(yield v),v=await w({useAlternateBitness:!0}),v&&(yield v),v=await y(),v&&(yield v),v=N(),v&&(yield v),v=await w({findPreview:!0}),v&&(yield v),v=await y({findPreview:!0}),v&&(yield v),v=await w({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=c(),v&&(yield v)}async function*p(){for await(const v of f())await v.exists()&&(yield v)}e.enumeratePowerShellInstallations=p;async function b(){for await(const v of p())return v;return null}e.getFirstAvailablePowerShellInstallation=b}),define(Q[55],_([0,1,15,12,35,50,3,20]),function(x,e,O,R,P,k,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function g(E=P.env){return E.comspec||"cmd.exe"}e.getWindowsShell=g;function u(E){let d=[],w=!1;const y=function(N){if(w){d.push(N);return}(!E.send(N,f=>{if(f&&console.error(f),w=!1,d.length>0){const p=d.slice(0);d=[],p.forEach(b=>y(b))}})||R.isWindows)&&(w=!0)};return{send:y}}e.createQueuedSender=u;var I;(function(E){async function d(w,y,N){if(O.isAbsolute(w))return w;if(y===void 0&&(y=P.cwd()),O.dirname(w)!=="."||(N===void 0&&D.isString(P.env.PATH)&&(N=P.env.PATH.split(O.delimiter)),N===void 0||N.length===0))return O.join(y,w);async function f(p){if(await S.Promises.exists(p)){let b;try{b=await S.Promises.stat(p)}catch(v){v.message.startsWith("EACCES")&&(b=await S.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of N){let b;if(O.isAbsolute(p)?b=O.join(p,w):b=O.join(y,p,w),await f(b))return b;let v=b+".com";if(await f(v)||(v=b+".exe",await f(v)))return v}return O.join(y,w)}E.findExecutable=d})(I=e.win32||(e.win32={}))}),define(Q[82],_([0,1,33,12,81,55]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function D(E,d){return E===1?R.isWindows?I():k.getWindowsShell(d):g(E,d)}e.getSystemShell=D;let S=null;function g(E,d){if(R.isLinux&&E===2||R.isMacintosh&&E===3)return"/bin/bash";if(!S){let w;if(R.isWindows)w="/bin/bash";else{if(w=d.SHELL,!w)try{w=(0,O.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}S=w}return S}let u=null;async function I(){return u||(u=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),u}});var he=this&&this.__decorate||function(x,e,O,R){var P=arguments.length,k=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,O):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(x,e,O,R);else for(var S=x.length-1;S>=0;S--)(D=x[S])&&(k=(P<3?D(k):P>3?D(e,O,k):D(e,O))||k);return P>3&&k&&Object.defineProperty(e,O,k),k};define(Q[56],_([0,1,19,5,14,23,48,7,4,2,53,30,3]),function(x,e,O,R,P,k,D,S,g,u,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var w;(function(j){j[j.Promise=100]="Promise",j[j.PromiseCancel=101]="PromiseCancel",j[j.EventListen=102]="EventListen",j[j.EventDispose=103]="EventDispose"})(w||(w={}));function y(j){switch(j){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var N;(function(j){j[j.Initialize=200]="Initialize",j[j.PromiseSuccess=201]="PromiseSuccess",j[j.PromiseError=202]="PromiseError",j[j.PromiseErrorObj=203]="PromiseErrorObj",j[j.EventFire=204]="EventFire"})(N||(N={}));function c(j){switch(j){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(j){j[j.Uninitialized=0]="Uninitialized",j[j.Idle=1]="Idle"})(f||(f={}));function p(j){let M=0;for(let $=0;;$+=7){const W=j.read(1);if(M|=(W.buffer[0]&127)<<$,!(W.buffer[0]&128))return M}}const b=i(0);function v(j,M){if(M===0){j.write(b);return}let $=0;for(let q=M;q!==0;q=q>>>7)$++;const W=P.VSBuffer.alloc($);for(let q=0;M!==0;q++)W.buffer[q]=M&127,M=M>>>7,M>0&&(W.buffer[q]|=128);j.write(W)}class m{constructor(M){this.b=M,this.a=0}read(M){const $=this.b.slice(this.a,this.a+M);return this.a+=$.byteLength,$}}e.BufferReader=m;class t{constructor(){this.a=[]}get buffer(){return P.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var s;(function(j){j[j.Undefined=0]="Undefined",j[j.String=1]="String",j[j.Buffer=2]="Buffer",j[j.VSBuffer=3]="VSBuffer",j[j.Array=4]="Array",j[j.Object=5]="Object",j[j.Int=6]="Int"})(s||(s={}));function i(j){const M=P.VSBuffer.alloc(1);return M.writeUInt8(j,0),M}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object),Uint:i(s.Int)},r=typeof Buffer<"u";function o(j,M){if(typeof M>"u")j.write(n.Undefined);else if(typeof M=="string"){const $=P.VSBuffer.fromString(M);j.write(n.String),v(j,$.byteLength),j.write($)}else if(r&&Buffer.isBuffer(M)){const $=P.VSBuffer.wrap(M);j.write(n.Buffer),v(j,$.byteLength),j.write($)}else if(M instanceof P.VSBuffer)j.write(n.VSBuffer),v(j,M.byteLength),j.write(M);else if(Array.isArray(M)){j.write(n.Array),v(j,M.length);for(const $ of M)o(j,$)}else if(typeof M=="number"&&(M|0)===M)j.write(n.Uint),v(j,M);else{const $=P.VSBuffer.fromString(JSON.stringify(M));j.write(n.Object),v(j,$.byteLength),j.write($)}}e.serialize=o;function a(j){switch(j.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return j.read(p(j)).toString();case s.Buffer:return j.read(p(j)).buffer;case s.VSBuffer:return j.read(p(j));case s.Array:{const $=p(j),W=[];for(let q=0;q<$;q++)W.push(a(j));return W}case s.Object:return JSON.parse(j.read(p(j)).toString());case s.Int:return p(j)}}e.deserialize=a;class l{constructor(M,$,W=null,q=1e3){this.h=M,this.j=$,this.k=W,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(M,$){this.b.set(M,$),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const $=this.o([M.type]);this.k?.logOutgoing($,0,1,c(M.type));return}case 201:case 202:case 204:case 203:{const $=this.o([M.type,M.id],M.data);this.k?.logOutgoing($,M.id,1,c(M.type),M.data);return}}}o(M,$=void 0){const W=new t;return o(W,M),o(W,$),this.p(W.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const $=new m(M),W=a($),q=a($),J=W[0];switch(J){case 100:return this.k?.logIncoming(M.byteLength,W[1],1,`${y(J)}: ${W[2]}.${W[3]}`,q),this.s({type:J,id:W[1],channelName:W[2],name:W[3],arg:q});case 102:return this.k?.logIncoming(M.byteLength,W[1],1,`${y(J)}: ${W[2]}.${W[3]}`,q),this.t({type:J,id:W[1],channelName:W[2],name:W[3],arg:q});case 101:return this.k?.logIncoming(M.byteLength,W[1],1,`${y(J)}`),this.u({type:J,id:W[1]});case 103:return this.k?.logIncoming(M.byteLength,W[1],1,`${y(J)}`),this.u({type:J,id:W[1]})}}s(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=new k.CancellationTokenSource;let q;try{q=$.call(this.j,M.name,M.arg,W.token)}catch(L){q=Promise.reject(L)}const J=M.id;q.then(L=>{this.m({id:J,data:L,type:201}),this.d.delete(M.id)},L=>{L instanceof Error?this.m({id:J,data:{message:L.message,name:L.name,stack:L.stack?L.stack.split?L.stack.split(`
`):L.stack:void 0},type:202}):this.m({id:J,data:L,type:203}),this.d.delete(M.id)});const C=(0,u.toDisposable)(()=>W.cancel());this.d.set(M.id,C)}t(M){const $=this.b.get(M.channelName);if(!$){this.v(M);return}const W=M.id,J=$.listen(this.j,M.name,M.arg)(C=>this.m({id:W,data:C,type:204}));this.d.set(M.id,J)}u(M){const $=this.d.get(M.id);$&&($.dispose(),this.d.delete(M.id))}v(M){let $=this.g.get(M.channelName);$||($=[],this.g.set(M.channelName,$));const W=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);$.push({request:M,timeoutTimer:W})}w(M){const $=this.g.get(M);if($){for(const W of $)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.s(W.request);break;case 102:this.t(W.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=l;var h;(function(j){j[j.LocalSide=0]="LocalSide",j[j.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(M,$=null){this.l=M,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new g.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(W=>this.s(W)),this.j=$}getChannel(M){const $=this;return{call(W,q,J){return $.a?Promise.reject(new S.CancellationError):$.m(M,W,q,J)},listen(W,q){return $.a?g.Event.None:$.o(M,W,q)}}}m(M,$,W,q=k.CancellationToken.None){const J=this.g++,L={id:J,type:100,channelName:M,name:$,arg:W};if(q.isCancellationRequested)return Promise.reject(new S.CancellationError);let T;return new Promise((z,G)=>{if(q.isCancellationRequested)return G(new S.CancellationError);const H=()=>{const me=ce=>{switch(ce.type){case 201:this.f.delete(J),z(ce.data);break;case 202:{this.f.delete(J);const ge=new Error(ce.data.message);ge.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ge.name=ce.data.name,G(ge);break}case 203:this.f.delete(J),G(ce.data);break}};this.f.set(J,me),this.p(L)};let re=null;this.b===f.Idle?H():(re=(0,R.createCancelablePromise)(me=>this.u()),re.then(()=>{re=null,H()}));const le=()=>{re?(re.cancel(),re=null):this.p({id:J,type:101}),G(new S.CancellationError)},ye=q.onCancellationRequested(le);T=(0,u.combinedDisposable)((0,u.toDisposable)(le),ye),this.d.add(T)}).finally(()=>{this.d.delete(T)})}o(M,$,W){const q=this.g++,C={id:q,type:102,channelName:M,name:$,arg:W};let L=null;const T=new g.Emitter({onWillAddFirstListener:()=>{L=(0,R.createCancelablePromise)(z=>this.u()),L.then(()=>{L=null,this.d.add(T),this.p(C)})},onDidRemoveLastListener:()=>{L?(L.cancel(),L=null):(this.d.delete(T),this.p({id:q,type:103}))}}),U=z=>T.fire(z.data);return this.f.set(q,U),T.event}p(M){switch(M.type){case 100:case 102:{const $=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing($,M.id,0,`${y(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const $=this.q([M.type,M.id]);this.j?.logOutgoing($,M.id,0,y(M.type));return}}}q(M,$=void 0){const W=new t;return o(W,M),o(W,$),this.r(W.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const $=new m(M),W=a($),q=a($),J=W[0];switch(J){case 200:return this.j?.logIncoming(M.byteLength,0,0,c(J)),this.t({type:W[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,W[1],0,c(J),q),this.t({type:W[0],id:W[1],data:q})}}t(M){if(M.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.dispose)(this.d.values()),this.d.clear()}}he([D.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class F{get connections(){const M=[];return this.f.forEach($=>M.push($)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new g.Emitter,this.onDidAddConnection=this.g.event,this.h=new g.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:$,onDidClientDisconnect:W})=>{g.Event.once($.onMessage)(J=>{const C=new m(J),L=a(C),T=new l($,L),U=new A($);this.a.forEach((G,H)=>T.registerChannel(H,G));const z={channelServer:T,channelClient:U,ctx:L};this.f.add(z),this.g.fire(z),W(()=>{T.dispose(),U.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(M,$){const W=this;return{call(q,J,C){let L;if((0,d.isFunction)($)){const U=(0,O.getRandomElement)(W.connections.filter($));L=U?Promise.resolve(U):g.Event.toPromise(g.Event.filter(W.onDidAddConnection,$))}else L=$.routeCall(W,q,J);const T=L.then(U=>U.channelClient.getChannel(M));return ee(T).call(q,J,C)},listen(q,J){if((0,d.isFunction)($))return W.j(M,$,q,J);const C=$.routeEvent(W,q,J).then(L=>L.channelClient.getChannel(M));return ee(C).listen(q,J)}}}j(M,$,W,q){const J=this;let C=new u.DisposableStore;const L=new g.Emitter({onWillAddFirstListener:()=>{C=new u.DisposableStore;const T=new g.EventMultiplexer,U=new Map,z=H=>{const le=H.channelClient.getChannel(M).listen(W,q),ye=T.add(le);U.set(H,ye)},G=H=>{const re=U.get(H);!re||(re.dispose(),U.delete(H))};J.connections.filter($).forEach(z),g.Event.filter(J.onDidAddConnection,$)(z,void 0,C),J.onDidRemoveConnection(G,void 0,C),T.event(L.fire,L,C),C.add(T)},onDidRemoveLastListener:()=>{C.dispose()}});return L.event}registerChannel(M,$){this.a.set(M,$),this.f.forEach(W=>{W.channelServer.registerChannel(M,$)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=F;class X{constructor(M,$,W=null){const q=new t;o(q,$),M.send(q.buffer),this.a=new A(M,W),this.d=new l(M,$,W)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,$){this.d.registerChannel(M,$)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=X;function ee(j){return{call(M,$,W){return j.then(q=>q.call(M,$,W))},listen(M,$){const W=new g.Relay;return j.then(q=>W.input=q.listen(M,$)),W.event}}}e.getDelayedChannel=ee;function te(j){let M=!1;return{call($,W,q){return M?j.call($,W,q):(0,R.timeout)(0).then(()=>M=!0).then(()=>j.call($,W,q))},listen($,W){if(M)return j.listen($,W);const q=new g.Relay;return(0,R.timeout)(0).then(()=>M=!0).then(()=>q.input=j.listen($,W)),q.event}}}e.getNextTickChannel=te;class ie{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const $ of M.connections)if(await Promise.resolve(this.a($.ctx)))return Promise.resolve($);return await g.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=ie;var ne;(function(j){function M(J,C){const L=J,T=C&&C.disableMarshalling,U=new Map;for(const z in L)W(z)&&U.set(z,g.Event.buffer(L[z],!0));return new class{listen(z,G,H){const re=U.get(G);if(re)return re;if(q(G)){const le=L[G];if(typeof le=="function")return le.call(L,H)}throw new Error(`Event not found: ${G}`)}call(z,G,H){const re=L[G];if(typeof re=="function"){if(!T&&Array.isArray(H))for(let le=0;le<H.length;le++)H[le]=(0,I.revive)(H[le]);return re.apply(L,H)}throw new Error(`Method not found: ${G}`)}}}j.fromService=M;function $(J,C){const L=C&&C.disableMarshalling;return new Proxy({},{get(T,U){if(typeof U=="string")return C?.properties?.has(U)?C.properties.get(U):q(U)?function(z){return J.listen(U,z)}:W(U)?J.listen(U):async function(...z){let G;C&&!(0,d.isUndefinedOrNull)(C.context)?G=[C.context,...z]:G=z;const H=await J.call(U,G);return L?H:(0,I.revive)(H)};throw new Error(`Property not found: ${String(U)}`)}})}j.toService=$;function W(J){return J[0]==="o"&&J[1]==="n"&&E.isUpperAsciiLetter(J.charCodeAt(2))}function q(J){return/^onDynamic/.test(J)&&E.isUpperAsciiLetter(J.charCodeAt(9))}})(ne=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function fe(j){if(Array.isArray(j))return j;if(j&&typeof j=="object"&&typeof j.toString=="function"){const M=j.toString();if(M!=="[object Object]")return M}return j}function oe(j){return Array.isArray(j)?j.map(fe):fe(j)}function ve(j,M,$,W,q,J,C){C=oe(C);const L=ae[q],T=L[W%L.length];let U=[`%c[${j}]%c[${String(M).padStart(7," ")}]%c[len: ${String($).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${T}`];/\($/.test(J)?(U=U.concat(C),U.push(")")):U.push(C),console.log.apply(console,U)}class V{constructor(M,$){this.d=M,this.f=$,this.a=0,this.b=0}logOutgoing(M,$,W,q,J){this.b+=M,ve(this.d,this.b,M,$,W,q,J)}logIncoming(M,$,W,q,J){this.a+=M,ve(this.f,this.a,M,$,W,q,J)}}e.IPCLogger=V}),define(Q[83],_([0,1,57,5,14,23,79,7,4,2,28,55,50,56]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends w.ChannelServer{constructor(f){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:g.Event.fromNodeEventEmitter(process,"message",p=>P.VSBuffer.wrap(Buffer.from(p,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.Server=y;class N{constructor(f,p){this.i=f,this.j=p,this.c=new Set,this.g=new Map,this.h=new g.Emitter,this.onDidProcessExit=this.h.event;const b=p&&p.timeout?p.timeout:6e4;this.b=new R.Delayer(b),this.d=null,this.f=null}getChannel(f){const p=this;return{call(b,v,m){return p.k(f,b,v,m)},listen(b,v){return p.l(f,b,v)}}}k(f,p,b,v=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(S.canceled());this.b.cancel();const m=this.n(f),t=(0,R.createCancelablePromise)(n=>m.call(p,b,n)),s=v.onCancellationRequested(()=>t.cancel()),i=(0,u.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{s.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,p,b){if(!this.b)return g.Event.None;this.b.cancel();let v;const m=new g.Emitter({onWillAddFirstListener:()=>{v=this.n(f).listen(p,b)(m.fire,m),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return m.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,d.removeDangerousEnvVariables)(p.env),this.d=(0,O.fork)(this.i,f,p);const b=new g.Emitter;g.Event.fromNodeEventEmitter(this.d,"message",r=>r)(r=>{if((0,D.isRemoteConsoleLog)(r)){(0,D.log)(r,`IPC Library: ${this.j.serverName}`);return}b.fire(P.VSBuffer.wrap(Buffer.from(r,"base64")))});const m=this.j.useQueue?(0,E.createQueuedSender)(this.d):this.d,t=r=>this.d&&this.d.connected&&m.send(r.buffer.toString("base64")),s=b.event,i={send:t,onMessage:s};this.f=new w.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",r=>console.warn('IPC "'+this.j.serverName+'" errored with '+r)),this.d.on("exit",(r,o)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,u.dispose)(a)),this.c.clear(),r!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+r+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:r,signal:o})})}return this.f}n(f){let p=this.g.get(f);return p||(p=this.m.getChannel(f),this.g.set(f,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=N}),define(Q[84],_([0,1,5,4,2,3]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var D;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",E[E.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(D=e.StorageHint||(e.StorageHint={}));function S(E){const d=E;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=S;var g;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(g=e.StorageState||(e.StorageState={}));class u extends P.Disposable{constructor(d,w=Object.create(null)){super(),this.m=d,this.n=w,this.b=this.B(new R.Emitter),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new O.ThrottledDelayer(u.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(d=>this.r(d)))}r(d){d.changed?.forEach((w,y)=>this.s(y,w)),d.deleted?.forEach(w=>this.s(w,void 0))}s(d,w){if(this.c===g.Closed)return;let y=!1;(0,k.isUndefinedOrNull)(w)?y=this.f.delete(d):this.f.get(d)!==w&&(this.f.set(d,w),y=!0),y&&this.b.fire(d)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(d,w){const y=this.f.get(d);return(0,k.isUndefinedOrNull)(y)?w:y}getBoolean(d,w){const y=this.get(d);return(0,k.isUndefinedOrNull)(y)?w:y==="true"}getNumber(d,w){const y=this.get(d);return(0,k.isUndefinedOrNull)(y)?w:parseInt(y,10)}async set(d,w){if(this.c===g.Closed)return;if((0,k.isUndefinedOrNull)(w))return this.delete(d);const y=String(w);if(this.f.get(d)!==y)return this.f.set(d,y),this.j.set(d,y),this.h.delete(d),this.b.fire(d),this.w()}async delete(d){if(!(this.c===g.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire(d),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(d).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(d){if(!!this.u)return this.w(d)}async w(d){return this.g.trigger(()=>this.v(),d)}async whenFlushed(){if(!!this.u)return new Promise(d=>this.l.push(d))}isInMemory(){return this.n.hint===D.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}u.a=100,e.Storage=u;class I{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((w,y)=>this.a.set(y,w)),d.delete?.forEach(w=>this.a.delete(w))}async close(){}}e.InMemoryStorageDatabase=I}),define(Q[85],_([8,9]),function(x,e){return x.create("vs/base/node/zip",e)}),define(Q[86],_([8,9]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[87],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Q[88],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[89],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Q[90],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Q[91],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Q[92],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Q[93],_([8,9]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Q[94],_([8,9]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[95],_([8,9]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(Q[96],_([8,9]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(Q[97],_([8,9]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[98],_([8,9]),function(x,e){return x.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Q[99],_([8,9]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(Q[100],_([8,9]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(Q[101],_([8,9]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[102],_([8,9]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Q[103],_([8,9]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(Q[104],_([0,1,75,48,16,15,35,18,11]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,k.dirname)(P.FileAccess.asFileUri("").fsPath)}get userHome(){return g.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return g.URI.file((0,k.join)(this.userDataPath,"User"))}get tmpDir(){return g.URI.file(this.b.tmpDir)}get cacheHome(){return g.URI.file(this.userDataPath)}get stateResource(){return(0,S.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,S.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return g.URI.file((0,k.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return g.URI.file((0,k.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.joinPath)(g.URI.file((0,k.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=D.env.VSCODE_PORTABLE;return y?g.URI.file((0,k.join)(y,"argv.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return g.URI.file((0,k.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,k.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,k.resolve)(y):(0,k.normalize)((0,k.join)(P.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const y=this.args["extensions-download-dir"];return y?g.URI.file((0,k.resolve)(y)):g.URI.file((0,k.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,k.resolve)(y);const N=D.env.VSCODE_EXTENSIONS;if(N)return N;const c=D.env.VSCODE_PORTABLE;return c?(0,k.join)(c,"extensions"):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(N=>/^[^:/?#]+?:\/\//.test(N)?g.URI.parse(N):g.URI.file((0,k.normalize)(N)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?g.URI.parse(y):g.URI.file((0,k.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(y=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(y))}get extensionLogLevel(){const y=[];for(const N of this.args.log||[]){const c=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(N);c&&c[1]&&c[2]&&y.push([c[1],c[2]])}return y.length?y:void 0}get serviceMachineIdResource(){return(0,S.joinPath)(g.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return g.URI.file((0,k.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=D.env.VSCODE_PORTABLE;return y?g.URI.file((0,k.join)(y,"policy.json")):(0,S.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this.a}constructor(y,N,c){this.a=y,this.b=N,this.c=c,this.editSessionId=this.args.editSessionId}}he([R.memoize],u.prototype,"appRoot",null),he([R.memoize],u.prototype,"userHome",null),he([R.memoize],u.prototype,"userDataPath",null),he([R.memoize],u.prototype,"appSettingsHome",null),he([R.memoize],u.prototype,"tmpDir",null),he([R.memoize],u.prototype,"cacheHome",null),he([R.memoize],u.prototype,"stateResource",null),he([R.memoize],u.prototype,"userRoamingDataHome",null),he([R.memoize],u.prototype,"userDataSyncHome",null),he([R.memoize],u.prototype,"userDataSyncLogResource",null),he([R.memoize],u.prototype,"editSessionsLogResource",null),he([R.memoize],u.prototype,"sync",null),he([R.memoize],u.prototype,"machineSettingsResource",null),he([R.memoize],u.prototype,"workspaceStorageHome",null),he([R.memoize],u.prototype,"localHistoryHome",null),he([R.memoize],u.prototype,"keyboardLayoutResource",null),he([R.memoize],u.prototype,"argvResource",null),he([R.memoize],u.prototype,"isExtensionDevelopment",null),he([R.memoize],u.prototype,"untitledWorkspacesHome",null),he([R.memoize],u.prototype,"installSourcePath",null),he([R.memoize],u.prototype,"builtinExtensionsPath",null),he([R.memoize],u.prototype,"extensionsPath",null),he([R.memoize],u.prototype,"extensionDevelopmentLocationURI",null),he([R.memoize],u.prototype,"extensionDevelopmentKind",null),he([R.memoize],u.prototype,"extensionTestsLocationURI",null),he([R.memoize],u.prototype,"debugExtensionHost",null),he([R.memoize],u.prototype,"logLevel",null),he([R.memoize],u.prototype,"extensionLogLevel",null),he([R.memoize],u.prototype,"serviceMachineIdResource",null),he([R.memoize],u.prototype,"telemetryLogResource",null),he([R.memoize],u.prototype,"disableWorkspaceTrust",null),he([R.memoize],u.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=u;function I(w,y){return d(w["inspect-extensions"],w["inspect-brk-extensions"],5870,y,w.debugId,w.extensionEnvironment)}e.parseExtensionHostPort=I;function E(w,y){return d(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,y,w.extensionEnvironment)}e.parsePtyHostPort=E;function d(w,y,N,c,f,p){const v=Number(y||w)||(c?null:N),m=v?Boolean(!!y):!1;let t;if(p)try{t=JSON.parse(p)}catch{}return{port:v,break:m,debugId:f,env:t}}}),function(){"use strict";function x(e,O,R){function P(D,S){const g=k(D,S),u=[g];return e.isAbsolute(g)||u.unshift(R),e.resolve(...u)}function k(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const g=process.env.VSCODE_PORTABLE;if(g)return e.join(g,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const I=D["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(E,"AppData","Roaming")}break;case"darwin":u=e.join(O.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:P}}if(typeof define=="function")define(Q[105],_([157,33,35]),function(e,O,R){return x(e,O,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=x(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[106],_([0,1,33,104,105]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class k extends R.AbstractNativeEnvironmentService{constructor(S,g){super(S,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,P.getUserDataPath)(S,g.nameShort)},g)}}e.NativeEnvironmentService=k}),define(Q[107],_([0,1,3,90]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function P(D,S,g){try{k(D,S,g)}catch(u){console.error(u?.message??u)}return D}e.localizeManifest=P;function k(D,S,g){const u=(I,E,d)=>{const w=I[E];if((0,O.isString)(w)){const y=w,N=y.length;if(N>1&&y[0]==="%"&&y[N-1]==="%"){const c=y.substr(1,N-2);let f=S[c];f===void 0&&g&&(f=g[c]);const p=typeof f=="string"?f:f?.message,b=g?.[c],v=typeof b=="string"?b:b?.message;if(!p){v||console.warn(`[${D.name}]: ${(0,R.localize)(0,null,c)}`);return}if(d&&(E==="title"||E==="category")&&v&&v!==p){const m={value:p,original:v};I[E]=m}else I[E]=p}}else if((0,O.isObject)(w))for(const y in w)w.hasOwnProperty(y)&&(y==="commands"?u(w,y,!0):u(w,y,d));else if(Array.isArray(w))for(let y=0;y<w.length;y++)u(w,y,d)};for(const I in D)D.hasOwnProperty(I)&&u(D,I)}}),define(Q[108],_([0,1,7]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class R{constructor(){this.a=new Map}register(k,D){this.a.set(k,D)}updateManifest(k){if(!(typeof k.main>"u"&&typeof k.browser>"u")&&(k.activationEvents===void 0&&Object.assign(k,{activationEvents:[]}),!(!Array.isArray(k.activationEvents)||!k.contributes)))for(const D in k.contributes){const S=this.a.get(D);if(!S)continue;const g=k.contributes[D],u=Array.isArray(g)?g:[g];try{S(u,k.activationEvents)}catch(I){(0,O.onUnexpectedError)(I)}}}}e.ImplicitActivationEventsImpl=R,e.ImplicitActivationEvents=new R}),define(Q[44],_([0,1,18,52,94,41]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function g(f){return f=f.trim(),f==="*"||D.test(f)}e.isValidVersionStr=g;function u(f){if(!g(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=f.match(D);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=u;function I(f){if(!f)return null;const p=f.majorBase,b=f.majorMustEqual,v=f.minorBase;let m=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(p===0||(m=!1),s=!1);let i=0;if(f.preRelease){const n=S.exec(f.preRelease);if(n){const[,r,o,a]=n;i=Date.UTC(Number(r),Number(o)-1,Number(a))}}return{majorBase:p,majorMustEqual:b,minorBase:v,minorMustEqual:m,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:i}}e.normalizeVersion=I;function E(f,p,b){let v;typeof f=="string"?v=I(u(f)):v=f;let m;p instanceof Date?m=p.getTime():typeof p=="string"&&(m=new Date(p).getTime());let t;if(typeof b=="string"?t=I(u(b)):t=b,!v||!t)return!1;const s=v.majorBase,i=v.minorBase,n=v.patchBase;let r=t.majorBase,o=t.minorBase,a=t.patchBase;const l=t.notBefore;let h=t.majorMustEqual,A=t.minorMustEqual,F=t.patchMustEqual;return t.isMinimum?s>r?!0:s<r?!1:i>o?!0:i<o||m&&m<l?!1:n>=a:(s===1&&r===0&&(!h||!A||!F)&&(r=1,o=0,a=0,h=!0,A=!1,F=!1),s<r?!1:s>r?!h:i<o?!1:i>o?!A:n<a?!1:n>a?!F:!(m&&m<l))}e.isValidVersion=E;function d(f,p,b,v,m){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([R.default.Error,P.localize(0,null)]),t;if(typeof v.name!="string")return t.push([R.default.Error,P.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([R.default.Error,P.localize(2,null,"version")]),t;if(!v.engines)return t.push([R.default.Error,P.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([R.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!c(v.extensionDependencies))return t.push([R.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!c(v.activationEvents))return t.push([R.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([R.default.Error,P.localize(7,null,"activationEvents","main")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([R.default.Warning,P.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([R.default.Error,P.localize(9,null,"main")]),t;{const n=(0,O.joinPath)(b,v.main);(0,O.isEqualOrParent)(n,b)||t.push([R.default.Warning,P.localize(10,null,n.path,b.path)])}if(typeof v.activationEvents>"u")return t.push([R.default.Error,P.localize(11,null,"activationEvents","main")]),t}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([R.default.Error,P.localize(12,null,"browser")]),t;{const n=(0,O.joinPath)(b,v.browser);(0,O.isEqualOrParent)(n,b)||t.push([R.default.Warning,P.localize(13,null,n.path,b.path)])}if(typeof v.activationEvents>"u")return t.push([R.default.Error,P.localize(14,null,"activationEvents","browser")]),t}if(!k.valid(v.version))return t.push([R.default.Error,P.localize(15,null)]),t;const s=[];if(!w(f,p,v,m,s))for(const n of s)t.push([R.default.Error,n]);return t}e.validateExtensionManifest=d;function w(f,p,b,v,m){return v||typeof b.main>"u"&&typeof b.browser>"u"?!0:N(f,p,b.engines.vscode,m)}e.isValidExtensionVersion=w;function y(f,p,b){return f==="*"||N(p,b,f)}e.isEngineValid=y;function N(f,p,b,v=[]){const m=I(u(b));if(!m)return v.push(P.localize(16,null,b)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return v.push(P.localize(17,null,b)),!1}else if(!m.majorMustEqual)return v.push(P.localize(18,null,b)),!1;return E(f,p,m)?!0:(v.push(P.localize(19,null,f,b)),!1)}function c(f){if(!Array.isArray(f))return!1;for(let p=0,b=f.length;p<b;p++)if(typeof f[p]!="string")return!1;return!0}}),define(Q[109],_([0,1,14,29]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function P(k,D,S){let g=S&&S.get("storage.serviceMachineId",-1)||null;if(g)return g;try{const I=(await D.readFile(k.serviceMachineIdResource)).value.toString();g=(0,R.isUUID)(I)?I:null}catch{g=null}if(!g){g=(0,R.generateUuid)();try{await D.writeFile(k.serviceMachineIdResource,O.VSBuffer.fromString(g))}catch{}}return S?.store("storage.serviceMachineId",g,-1,1),g}e.getServiceMachineId=P}),define(Q[45],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class O{constructor(P,k=[],D=!1){this.ctor=P,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=O}),define(Q[110],_([0,1,45]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var P;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(P=e.InstantiationType||(e.InstantiationType={}));function k(S,g,u){g instanceof O.SyncDescriptor||(g=new O.SyncDescriptor(g,[],Boolean(u))),R.push([S,g])}e.registerSingleton=k;function D(){return R}e.getSingletonServiceDescriptors=D}),define(Q[111],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class O{constructor(k,D){this.key=k,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.Node=O;class R{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const D of this.a.values())D.outgoing.size===0&&k.push(D);return k}insertEdge(k,D){const S=this.lookupOrInsertNode(k),g=this.lookupOrInsertNode(D);S.outgoing.set(g.key,g),g.incoming.set(S.key,S)}removeNode(k){const D=this.b(k);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(k){const D=this.b(k);let S=this.a.get(D);return S||(S=new O(D,k),this.a.set(D,S)),S}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[D,S]of this.a)k.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,D]of this.a){const S=new Set([k]),g=this.c(D,S);if(g)return g}}c(k,D){for(const[S,g]of k.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const u=this.c(g,D);if(u)return u;D.delete(S)}}}e.Graph=R}),define(Q[24],_([0,1,3,11,10]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function k(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationOverrides=k;function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=D;var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S=e.ConfigurationTarget||(e.ConfigurationTarget={}));function g(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=g;function u(c,f){const p=Object.create(null);for(const b in c)I(p,b,c[b],f);return p}e.toValuesTree=u;function I(c,f,p,b){const v=f.split("."),m=v.pop();let t=c;for(let s=0;s<v.length;s++){const i=v[s];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${f} as ${v.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[m]=p}catch{b(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}else b(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=I;function E(c,f){const p=f.split(".");d(c,p)}e.removeFromValueTree=E;function d(c,f){const p=f.shift();if(f.length===0){delete c[p];return}if(Object.keys(c).indexOf(p)!==-1){const b=c[p];typeof b=="object"&&!Array.isArray(b)&&(d(b,f),Object.keys(b).length===0&&delete c[p])}}function w(c,f,p){function b(t,s){let i=t;for(const n of s){if(typeof i!="object"||i===null)return;i=i[n]}return i}const v=f.split("."),m=b(c,v);return typeof m>"u"?p:m}e.getConfigurationValue=w;function y(c,f,p){Object.keys(f).forEach(b=>{b!=="__proto__"&&(b in c?O.isObject(c[b])&&O.isObject(f[b])?y(c[b],f[b],p):p&&(c[b]=f[b]):c[b]=f[b])})}e.merge=y;function N(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=N}),define(Q[58],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Q[17],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,O.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,O.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[21],_([0,1,88,10]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function P(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function k(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=k;function D(f,p){switch(f){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function S(f,p){return p==="web"&&!f.includes("web")}e.isNotWebExtensionInWebTargetPlatform=S;function g(f,p,b){return S(p,b)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===b?!0:u(b).includes(f)}e.isTargetPlatformCompatible=g;function u(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=u;function I(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=I;var E;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(E=e.SortBy||(e.SortBy={}));var d;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(d=e.SortOrder||(e.SortOrder={}));var w;(function(f){f.Install="install",f.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var y;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var N;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal",f.Signature="Signature"})(N=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,O.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,O.localize)(1,null),original:"Preferences"}}),define(Q[59],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,O.createDecorator)("IExtensionSignatureVerificationService");class R{b(){return this.a||(this.a=new Promise((k,D)=>x(["node-vsce-sign"],async S=>k(S),D))),this.a}async verify(k,D){let S;try{S=await this.b()}catch{return!1}return S.verify(k,D)}}e.ExtensionSignatureVerificationService=R}),define(Q[60],_([0,1,14,7,96,13]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function D(I,E,d,w,y,N){let c;try{await S(I,E,d,w,y,N)}catch(f){c=f}finally{c&&y.errorTransformer&&(c=y.errorTransformer(c)),typeof c<"u"&&d.error(c),d.end()}}e.readFileIntoStream=D;async function S(I,E,d,w,y,N){g(N);const c=await I.open(E,{create:!1});try{g(N);let f=0,p=0,b=y&&typeof y.length=="number"?y.length:void 0,v=O.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),m=y&&typeof y.position=="number"?y.position:0,t=0;do p=await I.read(c,m,v.buffer,t,v.byteLength-t),m+=p,t+=p,f+=p,typeof b=="number"&&(b-=p),t===v.byteLength&&(await d.write(w(v)),v=O.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),t=0);while(p>0&&(typeof b!="number"||b>0)&&g(N)&&u(f,y));if(t>0){let s=t;typeof b=="number"&&(s=Math.min(t,b)),d.write(w(v.slice(0,s)))}}catch(f){throw(0,k.ensureFileSystemProviderError)(f)}finally{await I.close(c)}}function g(I){if(I.isCancellationRequested)throw(0,R.canceled)();return!0}function u(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,k.createFileSystemProviderError)((0,P.localize)(0,null),k.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,k.createFileSystemProviderError)((0,P.localize)(1,null),k.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[112],_([0,1,4,158,2,12,159]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class S extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new O.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new O.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(u){const I=this.i(u),E=I.filter(w=>{const y=this.c.get(w.path);return y?!(0,R.patternsEquals)(y.request.excludes,w.excludes)||!(0,R.patternsEquals)(y.request.includes,w.includes):!0}),d=Array.from(this.c.values()).filter(({request:w})=>!I.find(y=>y.path===w.path&&(0,R.patternsEquals)(y.excludes,w.excludes)&&(0,R.patternsEquals)(y.includes,w.includes))).map(({request:w})=>w.path);E.length&&this.j(`Request to start watching: ${E.map(w=>`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"})`).join(",")}`),d.length&&this.j(`Request to stop watching: ${d.join(",")}`);for(const w of d)this.h(w);for(const w of E)this.g(w)}g(u){const I=new D.NodeJSFileWatcherLibrary(u,d=>this.a.fire(d),d=>this.b.fire(d),this.f),E={request:u,instance:I};this.c.set(u.path,E)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const I=this.c.get(u);I&&(this.c.delete(u),I.instance.dispose())}i(u){const I=new Map;for(const E of u){const d=k.isLinux?E.path:E.path.toLowerCase();I.set(d,E)}return Array.from(I.values())}async setVerboseLogging(u){this.f=u;for(const[,I]of this.c)I.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,I){return I?`[File Watcher (node.js)] ${u} (path: ${I.request.path})`:`[File Watcher (node.js)] ${u}`}}e.NodeJSWatcher=S}),define(Q[113],_([0,1,61,112]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class P extends O.AbstractNonRecursiveWatcherClient{constructor(D,S,g){super(D,S,g),this.m()}l(){return new R.NodeJSWatcher}}e.NodeJSWatcherClient=P}),define(Q[114],_([0,1,16,56,83,61]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class D extends k.AbstractUniversalWatcherClient{constructor(g,u,I){super(g,u,I),this.m()}l(g){const u=g.add(new P.Client(O.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return g.add(u.onDidProcessExit(({code:I,signal:E})=>this.n(`terminated by itself with code ${I}, signal: ${E}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(u.getChannel("watcher")))}}e.UniversalWatcherClient=D}),define(Q[62],_([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class O{constructor(...P){this.a=new Map;for(const[k,D]of P)this.set(k,D)}set(P,k){const D=this.a.get(P);return this.a.set(P,k),D}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.ServiceCollection=O}),define(Q[115],_([0,1,5,7,2,45,111,10,62,160]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const I=!1;class E extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class d{constructor(c=new g.ServiceCollection,f=!1,p,b=I){this.f=c,this.g=f,this.h=p,this.i=b,this.o=new Set,this.f.set(S.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new D.Graph(v=>v):void 0}createChild(c){return new d(c,this.g,this,this.i)}invokeFunction(c,...f){const p=y.traceInvocation(this.i,c);let b=!1;try{return c({get:m=>{if(b)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(m,p);if(!t)throw new Error(`[invokeFunction] unknown service '${m}'`);return t}},...f)}finally{b=!0,p.stop()}}createInstance(c,...f){let p,b;return c instanceof k.SyncDescriptor?(p=y.traceCreation(this.i,c.ctor),b=this.j(c.ctor,c.staticArguments.concat(f),p)):(p=y.traceCreation(this.i,c),b=this.j(c,f,p)),p.stop(),b}j(c,f=[],p){const b=S._util.getServiceDependencies(c).sort((t,s)=>t.index-s.index),v=[];for(const t of b){const s=this.m(t.id,p);s||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(s)}const m=b.length>0?b[0].index:f.length;if(f.length!==m){console.trace(`[createInstance] First service dependency of ${c.name} at position ${m+1} conflicts with ${f.length} static arguments`);const t=m-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,m)}return Reflect.construct(c,f.concat(v))}k(c,f){if(this.f.get(c)instanceof k.SyncDescriptor)this.f.set(c,f);else if(this.h)this.h.k(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const f=this.f.get(c);return!f&&this.h?this.h.l(c):f}m(c,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const p=this.l(c);return p instanceof k.SyncDescriptor?this.q(c,p,f.branch(c,!0)):(f.branch(c,!1),p)}q(c,f,p){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,f,p)}finally{this.o.delete(c)}}r(c,f,p){const b=new D.Graph(t=>t.id.toString());let v=0;const m=[{id:c,desc:f,_trace:p}];for(;m.length;){const t=m.pop();if(b.lookupOrInsertNode(t),v++>1e3)throw new E(b);for(const s of S._util.getServiceDependencies(t.desc.ctor)){const i=this.l(s.id);if(i||this.u(`[createInstance] ${c} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),i instanceof k.SyncDescriptor){const n={id:s.id,desc:i,_trace:t._trace.branch(s.id,!0)};b.insertEdge(t,n),m.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new E(b);break}for(const{data:s}of t){if(this.l(s.id)instanceof k.SyncDescriptor){const n=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,n)}b.removeNode(s)}}return this.l(c)}s(c,f,p=[],b,v){if(this.f.get(c)instanceof k.SyncDescriptor)return this.t(c,f,p,b,v);if(this.h)return this.h.s(c,f,p,b,v);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(c,f,p=[],b,v){if(b){const m=new d(void 0,this.g,this,this.i);m.c=String(c);const t=new Map,s=new O.IdleValue(()=>{const i=m.j(f,p,v);for(const[n,r]of t){const o=i[n];if(typeof o=="function")for(const a of r)o.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!s.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new u.LinkedList,t.set(n,a)),(h,A,F)=>{const X=a.push([h,A,F]);return(0,P.toDisposable)(X)}}if(n in i)return i[n];const r=s.value;let o=r[n];return typeof o!="function"||(o=o.bind(r),i[n]=o),o},set(i,n,r){return s.value[n]=r,!0},getPrototypeOf(i){return f.prototype}})}else return this.j(f,p,v)}u(c,f){if(f&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=d;var w;(function(N){N[N.None=0]="None",N[N.Creation=1]="Creation",N[N.Invocation=2]="Invocation",N[N.Branch=3]="Branch"})(w||(w={}));class y{static traceInvocation(c,f){return c?new y(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(c,f){return c?new y(1,f.name):y.c}constructor(c,f){this.type=c,this.name=f,this.g=Date.now(),this.h=[]}branch(c,f){const p=new y(3,c.toString());return this.h.push([c,f,p]),p}stop(){const c=Date.now()-this.g;y.f+=c;let f=!1;function p(v,m){const t=[],s=new Array(v+1).join("	");for(const[i,n,r]of m.h)if(n&&r){f=!0,t.push(`${s}CREATES -> ${i}`);const o=p(v+1,r);o&&t.push(o)}else t.push(`${s}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(c>2||f)&&y.all.add(b.join(`
`))}}y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0,e.Trace=y});var Z=this&&this.__param||function(x,e){return function(O,R){e(O,R,x)}};define(Q[63],_([0,1,23,2,12,98,21,10]),function(x,e,O,R,P,k,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function g(I){return I.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=g,e.ILanguagePackService=(0,S.createDecorator)("languagePackService");let u=class extends R.Disposable{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new O.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const y=d.firstPage.filter(N=>N.properties.localizedLanguages?.length&&N.tags.some(c=>c.startsWith("lp-"))).map(N=>{const c=N.properties.localizedLanguages?.[0],f=g(N);return{...this.f(f,c,N),extensionId:N.identifier.id,galleryExtension:N}});return y.push(this.f("en","English")),y}f(E,d,w){const y=d??E;let N;if(y!==E&&(N=`(${E})`),E.toLowerCase()===P.language.toLowerCase()&&(N??="",N+=(0,k.localize)(0,null)),w?.installCount){N??="";const c=w.installCount;let f;c>1e6?f=`${Math.floor(c/1e5)/10}M`:c>1e3?f=`${Math.floor(c/1e3)}K`:f=String(c),N+=` $(cloud-download) ${f}`}return{id:E,label:y,description:N}}};u=he([Z(0,D.IExtensionGalleryService)],u),e.LanguagePackBaseService=u}),define(Q[6],_([0,1,34,4,2,36,12,3,11,10]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,u.createDecorator)("logService"),e.ILoggerService=(0,u.createDecorator)("loggerService");function I(){return new Date().toISOString()}function E(a){return(0,S.isNumber)(a)}e.isLogLevel=E;var d;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function w(a,l,h){switch(l){case d.Trace:a.trace(h);break;case d.Debug:a.debug(h);break;case d.Info:a.info(h);break;case d.Warning:a.warn(h);break;case d.Error:a.error(h);break;case d.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=w;function y(a){let l="";for(let h=0;h<a.length;h++){let A=a[h];if(typeof A=="object")try{A=JSON.stringify(A)}catch{}l+=(h>0?" ":"")+A}return l}e.format=y;class N extends P.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==d.Off&&this.b<=l}}e.AbstractLogger=N;class c extends N{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...h){this.f(d.Trace)&&this.g(d.Trace,y([l,...h]))}debug(l,...h){this.f(d.Debug)&&this.g(d.Debug,y([l,...h]))}info(l,...h){this.f(d.Info)&&this.g(d.Info,y([l,...h]))}warn(l,...h){this.f(d.Warning)&&this.g(d.Warning,y([l,...h]))}error(l,...h){if(this.f(d.Error))if(l instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=l.stack,this.g(d.Error,y(A))}else this.g(d.Error,y([l,...h]))}flush(){}}e.AbstractMessageLogger=c;class f extends N{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l),this.g=!D.isWindows}trace(l,...h){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...h):console.log(`[main ${I()}]`,l,...h))}debug(l,...h){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...h):console.log(`[main ${I()}]`,l,...h))}info(l,...h){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${I()}]\x1B[0m`,l,...h):console.log(`[main ${I()}]`,l,...h))}warn(l,...h){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${I()}]\x1B[0m`,l,...h):console.warn(`[main ${I()}]`,l,...h))}error(l,...h){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${I()}]\x1B[0m`,l,...h):console.error(`[main ${I()}]`,l,...h))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class p extends N{constructor(l=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(l)}trace(l,...h){this.f(d.Trace)&&console.log("%cTRACE","color: #888",l,...h)}debug(l,...h){this.f(d.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",l,...h)}info(l,...h){this.f(d.Info)&&console.log("%c INFO","color: #33f",l,...h)}warn(l,...h){this.f(d.Warning)&&console.log("%c WARN","color: #993",l,...h)}error(l,...h){this.f(d.Error)&&console.log("%c  ERR","color: #f33",l,...h)}dispose(){}flush(){}}e.ConsoleLogger=p;class b extends N{constructor(l,h=e.DEFAULT_LOG_LEVEL){super(),this.g=l,this.setLevel(h)}trace(l,...h){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(l),...h])}debug(l,...h){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(l),...h])}info(l,...h){this.f(d.Info)&&this.g.log(d.Info,[this.h(l),...h])}warn(l,...h){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(l),...h])}error(l,...h){this.f(d.Error)&&this.g.log(d.Error,[this.h(l),...h])}h(l){return typeof l=="string"?l:(0,O.toErrorMessage)(l,this.f(d.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class v extends N{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const h of this.g)h.setLevel(l);super.setLevel(l)}trace(l,...h){for(const A of this.g)A.trace(l,...h)}debug(l,...h){for(const A of this.g)A.debug(l,...h)}info(l,...h){for(const A of this.g)A.info(l,...h)}warn(l,...h){for(const A of this.g)A.warn(l,...h)}error(l,...h){for(const A of this.g)A.error(l,...h)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.MultiplexLogger=v;class m extends P.Disposable{constructor(l,h){if(super(),this.j=l,this.b=new k.ResourceMap,this.c=new k.ResourceMap,this.f=this.B(new R.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new R.Emitter),this.onDidChangeVisibility=this.h.event,h)for(const A of h)this.c.set(A.resource,A)}getLogger(l){return this.b.get(l)}createLogger(l,h){let A=this.b.get(l);const F=h?.logLevel==="always"?d.Trace:h?.logLevel;return A||(A=this.k(l,F??this.getLogLevel(l)??this.j,h),this.b.set(l,A)),this.registerLogger({resource:l,id:h?.id??l.toString(),logLevel:F,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId}),A}setLogLevel(l,h){if(g.URI.isUri(l)){const A=l,F=h,X=this.c.get(A);X&&F!==X.logLevel&&(X.logLevel=F===this.j?void 0:F,this.b.get(A)?.setLevel(F),this.c.set(X.resource,X),this.g.fire([A,F]))}else{this.j=l;for(const[A,F]of this.b.entries())this.c.get(A)?.logLevel===void 0&&F.setLevel(this.j);this.g.fire(this.j)}}setVisibility(l,h){const A=this.c.get(l);A&&h!==!A.hidden&&(A.hidden=!h,this.c.set(A.resource,A),this.h.fire([l,h]))}getLogLevel(l){let h;return l&&(h=this.c.get(l)?.logLevel),h??this.j}registerLogger(l){const h=this.c.get(l.resource);h?h.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.c.set(l.resource,l),this.f.fire({added:[l],removed:[]}))}deregisterLogger(l){const h=this.c.get(l);if(h){this.c.delete(l);const A=this.b.get(l);A&&(this.b.delete(l),A.dispose()),this.f.fire({added:[],removed:[h]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(l){return this.c.get(l)}dispose(){this.b.forEach(l=>l.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=m;class t{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(l){}getLevel(){return d.Info}trace(l,...h){}debug(l,...h){}info(l,...h){}warn(l,...h){}error(l,...h){}critical(l,...h){}dispose(){}flush(){}}e.NullLogger=t;class s extends t{}e.NullLogService=s;class i extends m{constructor(){super(d.Info)}k(l,h,A){return new t}}e.NullLoggerService=i;function n(a){if(a.verbose)return d.Trace;if(typeof a.logLevel=="string"){const l=o(a.logLevel.toLowerCase());if(l!==void 0)return l}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function r(a){switch(a){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}e.LogLevelToString=r;function o(a){switch(a){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.parseLogLevel=o}),define(Q[116],_([0,1,19,5,7,4,2,15,61,6]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends D.Disposable{constructor(d,w){super(),this.a=d,this.b=w,this.c=this.B(new k.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new k.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new R.ThrottledDelayer(0)),this.s=[],this.t=this.B(new R.ThrottledDelayer(0))}watch(d,w){return w.recursive||this.b?.watcher?.forceUniversal?this.l(d,w):this.u(d,w)}l(d,w){const y={path:this.C(d),excludes:w.excludes,includes:w.includes,recursive:w.recursive},N=(0,O.insert)(this.j,y);return this.m(),(0,D.toDisposable)(()=>{N(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(d=>(0,P.onUnexpectedError)(d))}n(){this.h||(this.h=this.B(this.p(w=>this.c.fire((0,g.toFileChanges)(w)),w=>this.z(w),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const w of this.j)(0,g.isRecursiveWatchRequest)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const w of this.j)(0,g.isRecursiveWatchRequest)(w)&&d.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(d,w){const y={path:this.C(d),excludes:w.excludes,includes:w.includes,recursive:!1},N=(0,O.insert)(this.s,y);return this.v(),(0,D.toDisposable)(()=>{N(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(d=>(0,P.onUnexpectedError)(d))}w(){return this.r||(this.r=this.B(this.y(d=>this.c.fire((0,g.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}C(d){return(0,S.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(Q[117],_([0,1,19,5,14,23,4,51,64,2,54,16,118,18,43,95,13,60,6,7]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let v=class extends u.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new D.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new D.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new D.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new R.ResourceQueue)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${t}`);const i=new u.DisposableStore;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),i.add(s.onDidChangeFile(n=>this.R.fire(new c.FileChangesEvent(n,!this.O(s))))),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,u.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,u.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(i){s.push(i)}}),!this.h.has(t)&&await R.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return g.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,w.isAbsolutePath)(t))throw new c.FileOperationError((0,N.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const i=new b.ErrorNoTelemetry;throw i.message=(0,N.localize)(1,null,t.toString()),i}return s}async k(t){const s=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s)||(0,c.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const s=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.n(t,s)}catch(i){throw(0,c.toFileSystemProviderErrorCode)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,N.localize)(2,null,this.nb(t)),1):(0,c.ensureFileSystemProviderError)(i)}}async n(t,s){const i=await this.j(t),n=this.O(i),r=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,l=await i.stat(t);let h;return this.p(i,t,l,void 0,!!a,(A,F)=>(h||(h=I.TernarySearchTree.forUris(()=>!n),h.set(t,!0),r&&h.fill(!0,r)),h.get(A.resource)||h.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&o?F===1:!1))}async p(t,s,i,n,r,o){const{providerExtUri:a}=this.N(t),l={resource:s,name:a.basename(s),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&c.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,c.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(l.isDirectory&&o(l,n)){try{const h=await t.readdir(s),A=await R.Promises.settled(h.map(async([F,X])=>{try{const ee=a.joinPath(s,F),te=r?await t.stat(ee):{type:X};return await this.p(t,ee,te,h.length,r,o)}catch(ee){return this.b.trace(ee),null}}));l.children=(0,O.coalesce)(A)}catch(h){this.b.trace(h),l.children=[]}return l}return l}async resolveAll(t){return R.Promises.settled(t.map(async s=>{try{return{stat:await this.n(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),i=await s.stat(t);return this.p(s,t,i,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.r(t,s)}catch(i){return i}return!0}async r(t,s){if(!s?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,N.localize)(3,null,this.nb(t)),3,s)}async createFile(t,s=P.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,s);return this.m.fire(new c.FileOperationEvent(t,0,n)),n}async writeFile(t,s,i){const n=this.lb(await this.l(t),t),{providerExtUri:r}=this.N(n);try{await this.s(n,t,i)||await this.P(n,r.dirname(t));let a;if((0,c.hasReadWriteCapability)(n)&&!(s instanceof P.VSBuffer))if((0,y.isReadableStream)(s)){const l=await(0,y.peekStream)(s,3);l.ended?a=P.VSBuffer.concat(l.buffer):a=l}else a=(0,y.peekReadable)(s,l=>P.VSBuffer.concat(l),3);else a=s;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&a instanceof P.VSBuffer?await this.cb(n,t,i,a):await this.Y(n,t,i,a instanceof P.VSBuffer?(0,P.bufferToReadable)(a):a),this.m.fire(new c.FileOperationEvent(t,4))}catch(o){throw new c.FileOperationError((0,N.localize)(4,null,this.nb(t),(0,c.ensureFileSystemProviderError)(o).toString()),(0,c.toFileOperationResult)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,s,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,N.localize)(5,null,this.nb(s)));let r;try{r=await t.stat(s)}catch{return}if((r.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,N.localize)(6,null,this.nb(s)),0,i);if(this.mb(s,r),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&i.mtime<r.mtime&&i.etag!==(0,c.etag)({mtime:i.mtime,size:r.size}))throw new c.FileOperationError((0,N.localize)(7,null),3,i);return r}async readFile(t,s,i){const n=await this.k(t);return s?.atomic?this.t(n,t,s,i):this.u(n,t,s,i)}async t(t,s,i,n){return new Promise((r,o)=>{this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,s,i,n);r(a)}catch(a){o(a)}})})}async u(t,s,i,n){const r=await this.v(t,s,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,P.streamToBuffer)(r.value)}}async readFileStream(t,s,i){const n=await this.k(t);return this.v(n,t,s,i)}async v(t,s,i,n){const r=new k.CancellationTokenSource(n),o=this.F(s,i).then(l=>l,l=>{throw r.cancel(),l});let a;try{return typeof i?.etag=="string"&&i.etag!==c.ETAG_DISABLED&&await o,i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.D(t,s,i):(0,c.hasFileReadStreamCapability)(t)?a=this.z(t,s,r.token,i):a=this.C(t,s,r.token,i),{...await o,value:a}}catch(l){throw a&&await(0,y.consumeStream)(a),this.w(l,s,i)}}w(t,s,i){const n=(0,N.localize)(8,null,this.nb(s),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(t),i)}z(t,s,i,n=Object.create(null)){const r=t.readFileStream(s,n,i);return(0,y.transform)(r,{data:o=>o instanceof P.VSBuffer?o:P.VSBuffer.wrap(o),error:o=>this.w(o,s,n)},o=>P.VSBuffer.concat(o))}C(t,s,i,n=Object.create(null)){const r=(0,P.newWriteableBufferStream)();return(0,f.readFileIntoStream)(t,s,r,o=>o,{...n,bufferSize:this.a,errorTransformer:o=>this.w(o,s,n)},i),r}D(t,s,i){const n=(0,y.newWriteableStream)(r=>P.VSBuffer.concat(r));return(async()=>{try{let r;i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?r=await t.readFile(s,{atomic:!0}):r=await t.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.G(s,r.byteLength,i),n.end(P.VSBuffer.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async F(t,s){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new c.FileOperationError((0,N.localize)(9,null,this.nb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==c.ETAG_DISABLED&&s.etag===i.etag)throw new c.NotModifiedSinceFileOperationError((0,N.localize)(10,null),i,s);return this.G(t,i.size,s),i}G(t,s,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&s>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&s>i.limits.size&&(n=7),typeof n=="number")throw new c.TooLargeFileOperationError((0,N.localize)(11,null,this.nb(t)),n,s,i)}}async canMove(t,s,i){return this.H(t,s,"move",i)}async canCopy(t,s,i){return this.H(t,s,"copy",i)}async H(t,s,i,n){if(t.toString()!==s.toString())try{const r=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(s),s);await this.M(r,t,o,s,i,n)}catch(r){return r}return!0}async move(t,s,i){const n=this.lb(await this.l(t),t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"move",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,o==="move"?2:3,a)),a}async copy(t,s,i){const n=await this.k(t),r=this.lb(await this.l(s),s),o=await this.I(n,t,r,s,"copy",!!i),a=await this.resolve(s,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,o==="copy"?3:2,a)),a}async I(t,s,i,n,r,o){if(s.toString()===n.toString())return r;const{exists:a,isSameResourceWithDifferentPathCase:l}=await this.M(t,s,i,n,r,o);if(a&&!l&&o&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),r==="copy"){if(t===i&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(s,n,{overwrite:o});else{const h=await this.resolve(s);h.isDirectory?await this.L(t,h,i,n):await this.J(t,s,i,n)}return r}else return t===i?(await t.rename(s,n,{overwrite:o}),r):(await this.I(t,s,i,n,"copy",o),await this.del(s,{recursive:!0}),"copy")}async J(t,s,i,n){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.eb(t,s,i,n);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.kb(t,s,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.ib(t,s,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.gb(t,s,i,n)}async L(t,s,i,n){await i.mkdir(n),Array.isArray(s.children)&&await R.Promises.settled(s.children.map(async r=>{const o=this.N(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.L(t,await this.resolve(r.resource),i,o):this.J(t,r.resource,i,o)}))}async M(t,s,i,n,r,o){let a=!1;if(t===i){const{providerExtUri:h,isPathCaseSensitive:A}=this.N(t);if(A||(a=h.isEqual(s,n)),a&&r==="copy")throw new Error((0,N.localize)(12,null,this.nb(s),this.nb(n)));if(!a&&h.isEqualOrParent(n,s))throw new Error((0,N.localize)(13,null,this.nb(s),this.nb(n)))}const l=await this.exists(n);if(l&&!a){if(!o)throw new c.FileOperationError((0,N.localize)(14,null,this.nb(s),this.nb(n)),4);if(t===i){const{providerExtUri:h}=this.N(t);if(h.isEqualOrParent(s,n))throw new Error((0,N.localize)(15,null,this.nb(s),this.nb(n)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}N(t){const s=this.O(t);return{providerExtUri:s?w.extUri:w.extUriIgnorePathCase,isPathCaseSensitive:s}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.lb(await this.j(t),t);await this.P(s,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,0,i)),i}async P(t,s){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(s,n.dirname(s));)try{if(((await t.stat(s)).type&c.FileType.Directory)===0)throw new Error((0,N.localize)(16,null,this.nb(s)));break}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(s)),s=n.dirname(s)}for(let r=i.length-1;r>=0;r--){s=n.joinPath(s,i[r]);try{await t.mkdir(s)}catch(o){if((0,c.toFileSystemProviderErrorCode)(o)!==c.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,s){try{await this.Q(t,s)}catch(i){return i}return!0}async Q(t,s){const i=this.lb(await this.j(t),t);if(!!s?.useTrash&&!(i.capabilities&4096))throw new Error((0,N.localize)(17,null,this.nb(t)));let r;try{r=await i.stat(t)}catch{}if(r)this.mb(t,r);else throw new c.FileOperationError((0,N.localize)(18,null,this.nb(t)),1);if(!!!s?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,N.localize)(19,null,this.nb(t)))}return i}async del(t,s){const i=await this.Q(t,s),n=!!s?.useTrash,r=!!s?.recursive;await i.delete(t,{recursive:r,useTrash:n}),this.m.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,s){const i=await this.j(t),n=this.lb(await this.l(s),s);if(i===n&&this.N(i).providerExtUri.isEqual(t,s))return;if(i===n&&(0,c.hasFileCloneCapability)(i))return i.cloneFile(t,s);await this.P(n,this.N(n).providerExtUri.dirname(s));const r=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,c.hasFileFolderCopyCapability)(i)?r.queue(()=>i.copy(t,s,{overwrite:!0})):r.queue(()=>this.J(i,t,n,s))}watch(t,s={recursive:!1,excludes:[]}){const i=new u.DisposableStore;let n=!1,r=()=>{n=!0};return i.add((0,u.toDisposable)(()=>r())),(async()=>{try{const o=await this.W(t,s);n?(0,u.dispose)(o):r=()=>(0,u.dispose)(o)}catch(o){this.b.error(o)}})(),i}async W(t,s){const i=await this.j(t),n=(0,S.hash)([this.N(i).providerExtUri.getComparisonKey(t),s]);let r=this.U.get(n);return r||(r={count:0,disposable:i.watch(t,s)},this.U.set(n,r)),r.count+=1,(0,u.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,u.dispose)(r.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.dispose)(t.disposable);this.U.clear()}async Y(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(async()=>{const r=await t.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(n)||(0,y.isReadableBufferedStream)(n)?await this.Z(t,r,n):await this.ab(t,r,n)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await t.close(r)}})}async Z(t,s,i){let n=0,r;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const o=P.VSBuffer.concat(i.buffer);await this.bb(t,s,o,o.byteLength,n,0),n+=o.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((o,a)=>{(0,y.listenStream)(r,{onData:async l=>{r.pause();try{await this.bb(t,s,l,l.byteLength,n,0)}catch(h){return a(h)}n+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>a(l),onEnd:()=>o()})})}async ab(t,s,i){let n=0,r;for(;(r=i.read())!==null;)await this.bb(t,s,r,r.byteLength,n,0),n+=r.byteLength}async bb(t,s,i,n,r,o){let a=0;for(;a<n;)a+=await t.write(s,r+a,i.buffer,o+a,n-a)}async cb(t,s,i,n){return this.X.queueFor(s,this.N(t).providerExtUri).queue(()=>this.db(t,s,i,n))}async db(t,s,i,n){let r;n instanceof P.VSBuffer?r=n:(0,y.isReadableStream)(n)?r=await(0,P.streamToBuffer)(n):(0,y.isReadableBufferedStream)(n)?r=await(0,P.bufferedStreamToBuffer)(n):r=(0,P.readableToBuffer)(n),await t.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,s,i,n))}async fb(t,s,i,n){let r,o;try{r=await t.open(s,{create:!1}),o=await i.open(n,{create:!0,unlock:!1});const a=P.VSBuffer.alloc(this.a);let l=0,h=0,A=0;do A=await t.read(r,l,a.buffer,h,a.byteLength-h),await this.bb(i,o,a,A,l,h),l+=A,h+=A,h===a.byteLength&&(h=0);while(A>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await R.Promises.settled([typeof r=="number"?t.close(r):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,s,i,n))}async hb(t,s,i,n){return i.writeFile(n,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async ib(t,s,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,s,i,n))}async jb(t,s,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const o=await t.readFile(s);await this.bb(i,r,P.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,c.ensureFileSystemProviderError)(o)}finally{await i.close(r)}}async kb(t,s,i,n){const r=await(0,P.streamToBuffer)(this.C(t,s,k.CancellationToken.None));await this.cb(i,n,void 0,r)}lb(t,s){if(t.capabilities&2048)throw new c.FileOperationError((0,N.localize)(20,null,this.nb(s)),6);return t}mb(t,s){if((s.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,N.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};v=he([Z(0,p.ILogService)],v),e.FileService=v}),define(Q[119],_([0,1,120,161,5,36,14,4,162,2,15,12,18,43,20,97,13,60,116,34,114,113]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(O)}catch(s){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(s)}`)}})();class t extends p.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=S.Event.None,this.H=new k.ResourceMap(r=>d.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,E.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:r}=await y.SymlinkSupport.stat(this.C(i));return{type:this.G(n,r),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await y.Promises.readdir(this.C(i),{withFileTypes:!0}),r=[];return await Promise.all(n.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,d.joinPath)(i,o.name))).type:a=this.G(o),r.push([o.name,a])}catch(a){this.a.trace(a)}})),r}catch(n){throw this.Y(n)}}G(i,n){let r;return n?.dangling?r=c.FileType.Unknown:i.isFile()?r=c.FileType.File:i.isDirectory()?r=c.FileType.Directory:r=c.FileType.Unknown,n&&(r|=c.FileType.SymbolicLink),r}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let r;for(;r=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await r.wait();const o=new P.Barrier;return this.H.set(i,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(i,n){let r;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),r=await this.I(i));const o=this.C(i);return await y.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{r?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,r){const o=(0,w.newWriteableStream)(a=>D.VSBuffer.concat(a.map(l=>D.VSBuffer.wrap(l))).buffer);return(0,f.readFileIntoStream)(this,i,o,a=>a.buffer,{...n,bufferSize:256*1024},r),o}async writeFile(i,n,r){let o;try{const a=this.C(i);if(!r.create||!r.overwrite){if(await y.Promises.exists(a)){if(!r.overwrite)throw(0,c.createFileSystemProviderError)((0,N.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,c.createFileSystemProviderError)((0,N.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:r.unlock}),await this.write(o,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const r=this.C(i);let o;(0,c.isFileOpenForWriteOptions)(n)&&(o=await this.I(i));let a;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:h}=await y.SymlinkSupport.stat(r);h.mode&128||await y.Promises.chmod(r,h.mode|128)}catch(h){this.a.trace(h)}let l;if((0,c.isFileOpenForWriteOptions)(n)){if(E.isWindows)try{await y.Promises.truncate(r,0),l="r+"}catch(h){h.code!=="ENOENT"&&this.a.trace(h)}l||(l="w")}else l="r";a=await y.Promises.open(r,l)}catch(l){throw o?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.Z(i,l):this.Y(l)}if(this.L.set(a,0),(0,c.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),o){const l=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${r})`),this.M.set(a,o),l&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${r})`),l.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await y.Promises.fdatasync(i)}catch(r){t.configureFlushOnWrite(!1),this.a.error(r)}return await y.Promises.close(i)}catch(r){throw this.Y(r)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,r,o,a){const l=this.P(i,n);let h=null;try{h=(await y.Promises.read(i,r,o,a,l)).bytesRead}catch(A){throw this.Y(A)}finally{this.Q(i,l,h)}return h}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,r){const o=this.L.get(i);typeof o=="number"&&(typeof n=="number"||(typeof r=="number"?this.L.set(i,o+r):this.L.delete(i)))}async write(i,n,r,o,a){return(0,P.retry)(()=>this.R(i,n,r,o,a),100,3)}async R(i,n,r,o,a){const l=this.P(i,n);let h=null;try{h=(await y.Promises.write(i,r,o,a,l)).bytesWritten}catch(A){throw await this.Z(this.N.get(i),A)}finally{this.Q(i,l,h)}return h}async mkdir(i){try{await y.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const r=this.C(i);n.recursive?await y.Promises.rm(r,y.RimRafMode.MOVE):await y.Promises.unlink(r)}catch(r){throw this.Y(r)}}async rename(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"move",r.overwrite),await y.Promises.move(o,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,N.localize)(2,null,(0,I.basename)(o),(0,I.basename)((0,I.dirname)(a)),l.toString()))),this.Y(l)}}async copy(i,n,r){const o=this.C(i),a=this.C(n);if(o!==a)try{await this.S(i,n,"copy",r.overwrite),await y.Promises.copy(o,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,N.localize)(3,null,(0,I.basename)(o),(0,I.basename)((0,I.dirname)(a)),l.toString()))),this.Y(l)}}async S(i,n,r,o){const a=this.C(i),l=this.C(n);let h=!1;if(!!(this.capabilities&1024)||(h=(0,g.isEqual)(a,l,!0)),h&&r==="copy")throw(0,c.createFileSystemProviderError)((0,N.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!h&&await y.Promises.exists(l)){if(!o)throw(0,c.createFileSystemProviderError)((0,N.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,r){const o=this.C(i),a=this.C(n),l=!!(this.capabilities&1024);if((0,g.isEqual)(o,a,!l))return;const h=new u.DisposableStore;try{const[A,F]=await Promise.all([this.I(i),this.I(n)]);h.add(A),h.add(F),r&&await y.Promises.mkdir((0,I.dirname)(a),{recursive:!0}),await y.Promises.copyFile(o,a)}catch(A){if(A.code==="ENOENT"&&!r)return this.U(i,n,!0);throw this.Y(A)}finally{h.dispose()}}p(i,n,r){return new v.UniversalWatcherClient(o=>i(o),o=>n(o),r)}y(i,n,r){return new m.NodeJSWatcherClient(o=>i(o),o=>n(o),r)}Y(i){if(i instanceof c.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,n)}async Z(i,n){let r=this.Y(n);if(i&&r.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await y.SymlinkSupport.stat(this.C(i));o.mode&128||(r=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return r}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(Q[121],_([0,1,2,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class P extends O.Disposable{constructor(D,S=[]){super(),this.a=new R.MultiplexLogger([D,...S]),this.B(D.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.LogService=P}),define(Q[122],_([0,1,13,6]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var P;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(P||(P={}));async function k(u,I,E,d,w){try{const y=await new Promise((c,f)=>{x(["spdlog"],c,f)});y.setFlushOn(P.Trace);const N=await y.createAsyncRotatingLogger(u,I,E,d);return w?N.clearFormatters():N.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),N}catch(y){console.error(y)}return null}function D(u,I,E){switch(I){case R.LogLevel.Trace:u.trace(E);break;case R.LogLevel.Debug:u.debug(E);break;case R.LogLevel.Info:u.info(E);break;case R.LogLevel.Warning:u.warn(E);break;case R.LogLevel.Error:u.error(E);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function S(u,I){switch(I){case R.LogLevel.Trace:u.setLevel(P.Trace);break;case R.LogLevel.Debug:u.setLevel(P.Debug);break;case R.LogLevel.Info:u.setLevel(P.Info);break;case R.LogLevel.Warning:u.setLevel(P.Warning);break;case R.LogLevel.Error:u.setLevel(P.Error);break;case R.LogLevel.Off:u.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class g extends R.AbstractMessageLogger{constructor(I,E,d,w,y){super(),this.k=[],this.setLevel(y),this.l=this.n(I,E,d,w),this.B(this.onDidChangeLogLevel(N=>{this.m&&S(this.m,N)}))}async n(I,E,d,w){const y=d?6:1,N=30/y*O.ByteSize.MB,c=await k(I,E,N,y,w);if(c){this.m=c,S(this.m,this.getLevel());for(const{level:f,message:p}of this.k)D(this.m,f,p);this.k=[]}}g(I,E){this.m?D(this.m,I,E):this.getLevel()<=I&&this.k.push({level:I,message:E})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=g}),define(Q[38],_([0,1,4,64,2,10]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,k.createDecorator)("policy");class D extends P.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const I=Object.keys(this.f).length;return this.f={...u,...this.f},I!==Object.keys(this.f).length&&await this.i(u),R.Iterable.reduce(this.g.entries(),(E,[d,w])=>({...E,[d]:w}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(u,[I,E])=>({...u,[I]:{definition:E,value:this.g.get(I)}}),{})}}e.AbstractPolicyService=D;class S{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=S}),define(Q[123],_([0,1,5,4,64,3,13,6,38]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function u(E,d){const w=[];for(const y of new Set(P.Iterable.concat(E.keys(),d.keys())))E.get(y)!==d.get(y)&&w.push(y);return w}let I=class extends g.AbstractPolicyService{constructor(d,w,y){super(),this.j=d,this.k=w,this.l=y,this.c=this.B(new O.ThrottledDelayer(500));const N=R.Event.filter(w.onDidFilesChange,c=>c.affects(d));this.B(w.watch(d)),this.B(N(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const d=new Map;try{const w=await this.k.readFile(this.j),y=JSON.parse(w.value.toString());if(!(0,k.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const N of Object.keys(y))this.f[N]&&d.set(N,y[N])}catch(w){w.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",w)}return d}async p(){const d=await this.n(),w=u(this.g,d);this.g=d,w.length>0&&this.h.fire(w)}};I=he([Z(1,D.IFileService),Z(2,S.ILogService)],I),e.FilePolicyService=I}),define(Q[124],_([0,1,38,5,163,2,6]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let S=class extends O.AbstractPolicyService{constructor(u,I){super(),this.j=u,this.k=I,this.a=new R.Throttler,this.b=this.B(new k.MutableDisposable)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise((I,E)=>{try{this.b.value=(0,P.createWatcher)(this.k,u,d=>{this.m(d),I()})}catch(d){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),E(d)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const I in u){const E=u[I];E===void 0?this.g.delete(I):this.g.set(I,E)}this.h.fire(Object.keys(u))}};S=he([Z(0,D.ILogService)],S),e.NativePolicyService=S}),define(Q[31],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,O.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(Q[37],_([0,1,70,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.a=new Map}add(D,S){O.ok(R.isString(D)),O.ok(R.isObject(S)),O.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.Registry=new P}),define(Q[125],_([0,1,4,37]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class k{constructor(){this.b=new O.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,u){this.a[P(g)]=u,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const D=new k;R.Registry.add(e.Extensions.JSONContribution,D)}),define(Q[42],_([0,1,19,4,3,86,24,125,37]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var u;(function(m){m.Multiline="multilineText",m.Singleline="singlelineText"})(u=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var I;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.MACHINE=2]="MACHINE",m[m.WINDOW=3]="WINDOW",m[m.RESOURCE=4]="RESOURCE",m[m.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",m[m.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const E=g.Registry.as(S.Extensions.JSONContribution);class d{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const i=new Set;this.n(t,s,i),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const s=new Set;this.o(t,s),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const i=new Set;this.o(s,i),this.n(t,!1,i),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const i=[];for(const{overrides:n,source:r}of t)for(const o in n)if(s.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const a=this.a.get(o),l=a?.valuesSources??new Map;if(r)for(const X of Object.keys(n[o]))l.set(X,r);const h={...a?.value||{},...n[o]};this.a.set(o,{source:r,value:h,valuesSources:l});const A=(0,D.getLanguageTagSettingPlainKey)(o),F={type:"object",default:h,description:k.localize(1,null,A),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:P.isString(r)?void 0:r,defaultValueSource:r};i.push(...N(o)),this.d[o]=F,this.b.properties[o]=F}else{this.a.set(o,{value:n[o],source:r});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(i)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:i,source:n}of t)for(const r in i){const o=this.a.get(r),a=P.isString(n)?n:n?.id,l=P.isString(o?.source)?o?.source:o?.source?.id;if(a===l)if(s.add(r),this.a.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.d[r],delete this.b.properties[r];else{const h=this.d[r];h&&(this.w(r,h),this.r(r,h))}}this.u()}deltaConfiguration(t){let s=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,i){t.forEach(n=>{this.p(n,s,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,s){const i=n=>{if(n.properties)for(const r in n.properties){s.add(r);const o=this.d[r];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[r],this.s(r,n.properties[r])}n.allOf?.forEach(r=>i(r))};for(const n of t){i(n);const r=this.c.indexOf(n);r!==-1&&this.c.splice(r,1)}}p(t,s=!0,i,n,r=3,o){r=P.isUndefinedOrNull(t.scope)?r:t.scope;const a=t.properties;if(a)for(const h in a){const A=a[h];if(s&&b(h,A)){delete a[h];continue}if(A.source=i,A.defaultDefaultValue=a[h].default,this.w(h,A),e.OVERRIDE_PROPERTY_REGEX.test(h)?A.scope=void 0:(A.scope=P.isUndefinedOrNull(A.scope)?r:A.scope,A.restricted=P.isUndefinedOrNull(A.restricted)?!!n?.includes(h):A.restricted),a[h].hasOwnProperty("included")&&!a[h].included){this.f[h]=a[h],delete a[h];continue}else this.d[h]=a[h],a[h].policy?.name&&this.e.set(a[h].policy.name,h);!a[h].deprecationMessage&&a[h].markdownDeprecationMessage&&(a[h].deprecationMessage=a[h].markdownDeprecationMessage),o.add(h)}const l=t.allOf;if(l)for(const h of l)this.p(h,s,i,n,r,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=i=>{const n=i.properties;if(n)for(const o in n)this.r(o,n[o]);i.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,i={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,i),e.allSettings.properties[s]=i,e.applicationSettings.properties[s]=i,e.machineSettings.properties[s]=i,e.machineOverridableSettings.properties[s]=i,e.windowSettings.properties[s]=i,e.resourceSettings.properties[s]=i}}v(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const i=this.a.get(t);let n=i?.value,r=i?.source;P.isUndefined(n)&&(n=s.defaultDefaultValue,r=void 0),P.isUndefined(n)&&(n=f(s.type)),s.default=n,s.defaultValueSource=r}}const w="\\[([^\\]]+)\\]",y=new RegExp(w,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${w})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function N(m){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(m)){let s=y.exec(m);for(;s?.length;){const i=s[1].trim();i&&t.push(i),s=y.exec(m)}}return(0,O.distinct)(t)}e.overrideIdentifiersFromKey=N;function c(m){return m.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=c;function f(m){switch(Array.isArray(m)?m[0]:m){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=f;const p=new d;g.Registry.add(e.Extensions.Configuration,p);function b(m,t){return m.trim()?e.OVERRIDE_PROPERTY_REGEX.test(m)?k.localize(7,null,m):p.getConfigurationProperties()[m]!==void 0?k.localize(8,null,m):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,m,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}e.validateProperty=b;function v(){const m=[],t=p.getConfigurationProperties();for(const s of Object.keys(t))m.push([s,t[s].scope]);return m.push(["launch",4]),m.push(["task",4]),m}e.getScopes=v}),define(Q[65],_([0,1,19,4,49,2,36,28,3,11,24,42,37]),function(x,e,O,R,P,k,D,S,g,u,I,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function w(s){return Object.isFrozen(s)?s:S.deepFreeze(s)}class y{constructor(i={},n=[],r=[],o){this.b=i,this.c=n,this.d=r,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof y)return n;const r=new N("");return r.parseRaw(n),r.configurationModel});this.f=i.reduce((n,r)=>r===n?r:n.merge(r),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const r=this.rawConfiguration.getValue(i),o=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):r;return{value:r,override:o,merged:a}}getOverrideValue(i,n){const r=this.i(n);return r?i?(0,I.getConfigurationValue)(r,i):r:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const r of this.overrides)r.identifiers.includes(i)&&n.push(...r.keys);return O.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return O.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=S.deepClone(this.contents),r=S.deepClone(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const l of i)if(a.push(...l.raw?.length?l.raw:[l]),!l.isEmpty()){this.h(n,l.contents);for(const h of l.overrides){const[A]=r.filter(F=>O.equals(F.identifiers,h.identifiers));A?(this.h(A.contents,h.contents),A.keys.push(...h.keys),A.keys=O.distinct(A.keys)):r.push(S.deepClone(h))}for(const h of l.keys)o.indexOf(h)===-1&&o.push(h)}return new y(n,o,r,a.every(l=>l instanceof y)?void 0:a)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const r={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const l=n[o];l&&(typeof a=="object"&&typeof l=="object"?(a=S.deepClone(a),this.h(a,l)):a=l),r[o]=a}return new y(r,this.keys,this.overrides)}h(i,n){for(const r of Object.keys(n)){if(r in i&&g.isObject(i[r])&&g.isObject(n[r])){this.h(i[r],n[r]);continue}i[r]=S.deepClone(n[r])}}i(i){let n=null,r=null;const o=a=>{a&&(r?this.h(r,a):r=S.deepClone(a))};for(const a of this.overrides)O.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&o(a.contents);return o(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,I.removeFromValueTree)(this.contents,i),E.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(r=>O.equals(r.identifiers,(0,E.overrideIdentifiersFromKey)(i))),1))}j(i,n,r){(0,I.addToValueTree)(this.contents,i,n,o=>console.error(o)),r=r||this.keys.indexOf(i)===-1,r&&this.keys.push(i),E.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,E.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,I.toValuesTree)(this.contents[i],o=>console.error(o))})}}e.ConfigurationModel=y;class N{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!g.isUndefinedOrNull(i)){const r=this.g(i);this.parseRaw(r,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:r,keys:o,overrides:a,restricted:l,hasExcludedProperties:h}=this.h(i,n);this.b=new y(r,o,a,h?[i]:void 0),this.c=l||[]}g(i){let n={},r=null,o=[];const a=[],l=[];function h(F){Array.isArray(o)?o.push(F):r!==null&&(o[r]=F)}const A={onObjectBegin:()=>{const F={};h(F),a.push(o),o=F,r=null},onObjectProperty:F=>{r=F},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const F=[];h(F),a.push(o),o=F,r=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:h,onError:(F,X,ee)=>{l.push({error:F,offset:X,length:ee})}};if(i)try{P.visit(i,A),n=o[0]||{}}catch(F){console.error(`Error while parsing settings file ${this.f}: ${F}`),this.d=[F]}return n}h(i,n){const r=d.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.i(i,r,!0,n);i=o.raw;const a=(0,I.toValuesTree)(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`)),l=Object.keys(i),h=this.j(i,A=>console.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:a,keys:l,overrides:h,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,n,r,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const l={},h=[];for(const A in i)if(E.OVERRIDE_PROPERTY_REGEX.test(A)&&r){const F=this.i(i[A],n,!1,o);l[A]=F.raw,a=a||F.hasExcludedProperties,h.push(...F.restricted)}else{const F=n[A],X=F?typeof F.scope<"u"?F.scope:3:void 0;F?.restricted&&h.push(A),(X===void 0||o.scopes===void 0||o.scopes.includes(X))&&!(o.skipRestricted&&F?.restricted)?l[A]=i[A]:a=!0}return{raw:l,restricted:h,hasExcludedProperties:a}}j(i,n){const r=[];for(const o of Object.keys(i))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const l in i[o])a[l]=i[o][l];r.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,I.toValuesTree)(a,n)})}return r}}e.ConfigurationModelParser=N;class c extends k.Disposable{constructor(i,n,r,o){super(),this.f=i,this.g=n,this.h=o,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new N(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(r.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&r.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class f{constructor(i,n,r,o,a,l,h,A,F,X,ee,te,ie){this.a=i,this.b=n,this.c=r,this.overrideIdentifiers=o,this.d=a,this.f=l,this.g=h,this.h=A,this.i=F,this.j=X,this.k=ee,this.l=te,this.m=ie}get value(){return w(this.c)}n(i,n,r){const o=i.inspect(n,r);return{get value(){return w(o.value)},get override(){return w(o.override)},get merged(){return w(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(i,n,r,o,a=new y,l=new y,h=new D.ResourceMap,A=new y,F=new D.ResourceMap){this.c=i,this.d=n,this.f=r,this.g=o,this.h=a,this.i=l,this.j=h,this.l=A,this.m=F,this.a=null,this.b=new D.ResourceMap,this.n=null}getValue(i,n,r){return this.q(i,n,r).getValue(i)}updateValue(i,n,r={}){let o;r.resource?(o=this.m.get(r.resource),o||(o=new y,this.m.set(r.resource,o))):o=this.l,n===void 0?o.removeValue(i):o.setValue(i,n),r.resource||(this.a=null)}inspect(i,n,r){const o=this.q(i,n,r),a=this.u(n.resource,r),l=n.resource?this.m.get(n.resource)||this.l:this.l,h=new Set;for(const A of o.overrides)for(const F of A.identifiers)o.getOverrideValue(i,F)!==void 0&&h.add(F);return new f(i,n,o.getValue(i),h.size?[...h]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,r?this.i:void 0,a||void 0,l)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const r=[];if(!n){const{added:o,updated:a,removed:l}=m(this.c,i);n=[...o,...a,...l]}for(const o of n)for(const a of(0,E.overrideIdentifiersFromKey)(o)){const l=this.c.getKeysForOverrideIdentifier(a),h=i.getKeysForOverrideIdentifier(a),A=[...h.filter(F=>l.indexOf(F)===-1),...l.filter(F=>h.indexOf(F)===-1),...l.filter(F=>!S.equals(this.c.override(a).getValue(F),i.override(a).getValue(F)))];r.push([a,A])}return this.updateDefaultConfiguration(i),{keys:n,overrides:r}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:r,removed:o}=m(this.d,i),a=[...n,...r,...o];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.applicationConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateApplicationConfiguration(i),{keys:l,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.localUserConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateLocalUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.remoteUserConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateRemoteUserConfiguration(i),{keys:l,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:r,removed:o,overrides:a}=m(this.workspaceConfiguration,i),l=[...n,...r,...o];return l.length&&this.updateWorkspaceConfiguration(i),{keys:l,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const r=this.p.get(i),{added:o,updated:a,removed:l,overrides:h}=m(r,n),A=[...o,...a,...l];return(A.length||!r)&&this.updateFolderConfiguration(i,n),{keys:A,overrides:h}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:r,updated:o,removed:a,overrides:l}=m(n,void 0);return{keys:[...r,...o,...a],overrides:l}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,r){let o=this.r(n,r);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},n){let r=this.s();if(n&&i){const o=n.getFolder(i);o&&(r=this.t(o.uri)||r);const a=this.m.get(i);a&&(r=r.merge(a))}return r}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const r=this.s(),o=this.j.get(i);o?(n=r.merge(o),this.b.set(i,n)):n=r}return n}u(i,n){if(n&&i){const r=n.getFolder(i);if(r)return this.j.get(r.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:r,overrides:o,keys:a}=this.j.get(n);return i.push([n,{contents:r,overrides:o,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(r=>i.add(r))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(r=>i.add(r))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.i.getKeysForOverrideIdentifier(i).forEach(r=>n.add(r)),this.j.forEach(r=>r.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o))),[...n.values()]}static parse(i){const n=this.x(i.defaults),r=this.x(i.policy),o=this.x(i.application),a=this.x(i.user),l=this.x(i.workspace),h=i.folders.reduce((A,F)=>(A.set(u.URI.revive(F[0]),this.x(F[1])),A),new D.ResourceMap);return new p(n,r,o,a,new y,l,h,new y,new D.ResourceMap)}static x(i){return new y(i.contents,i.keys,i.overrides)}}e.Configuration=p;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const i=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>i.add(a)),o.overrides.forEach(([a,l])=>{const h=(0,D.getOrSet)(n,a,new Set);l.forEach(A=>h.add(A))});const r=[];return n.forEach((o,a)=>r.push([a,[...o.values()]])),{keys:[...i.values()],overrides:r}}e.mergeChanges=b;class v{constructor(i,n,r,o){this.change=i,this.f=n,this.g=r,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const l of a)this.affectedKeys.add(l);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(i,n){const r=this.a+i,o=this.d.indexOf(r);if(o<0)return!1;const a=o+r.length;if(a>=this.d.length)return!1;const l=this.d.charCodeAt(a);if(l!==this.b&&l!==this.c)return!1;if(n){const h=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,A=this.g.getValue(i,n,this.h);return!S.equals(h,A)}return!0}}e.ConfigurationChangeEvent=v;function m(s,i){const{added:n,removed:r,updated:o}=t(i?.rawConfiguration,s?.rawConfiguration),a=[],l=s?.getAllOverrideIdentifiers()||[],h=i?.getAllOverrideIdentifiers()||[];if(i){const A=h.filter(F=>!l.includes(F));for(const F of A)a.push([F,i.getKeysForOverrideIdentifier(F)])}if(s){const A=l.filter(F=>!h.includes(F));for(const F of A)a.push([F,s.getKeysForOverrideIdentifier(F)])}if(i&&s){for(const A of l)if(h.includes(A)){const F=t({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:i.getOverrideValue(void 0,A)||{},keys:i.getKeysForOverrideIdentifier(A)});a.push([A,[...F.added,...F.removed,...F.updated]])}}return{added:n,removed:r,updated:o,overrides:a}}function t(s,i){const n=s?i?s.keys.filter(a=>i.keys.indexOf(a)===-1):[...s.keys]:[],r=i?s?i.keys.filter(a=>s.keys.indexOf(a)===-1):[...i.keys]:[],o=[];if(s&&i){for(const a of i.keys)if(s.keys.indexOf(a)!==-1){const l=(0,I.getConfigurationValue)(i.contents,a),h=(0,I.getConfigurationValue)(s.contents,a);S.equals(l,h)||o.push(a)}}return{added:n,removed:r,updated:o}}}),define(Q[126],_([0,1,19,4,2,28,3,65,42,6,38,37]),function(x,e,O,R,P,k,D,S,g,u,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class d extends P.Disposable{constructor(){super(...arguments),this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.Registry.as(g.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:f})=>this.c(Array.from(c),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,f){this.h(c,E.Registry.as(g.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new S.ConfigurationModel;const c=E.Registry.as(g.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,f){const p=this.f();for(const b of c){const v=p[b],m=f[b];v!==void 0?this.b.addValue(b,v):m?this.b.addValue(b,m.default):this.b.removeValue(b)}}}e.DefaultConfiguration=d;class w{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=w;let y=class extends P.Disposable{get configurationModel(){return this.b}constructor(c,f,p){super(),this.c=c,this.f=f,this.g=p,this.a=this.B(new R.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new S.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const f={},p=[],b=E.Registry.as(g.Extensions.Configuration).getConfigurationProperties();for(const v of c){const m=b[v];if(!m){p.push(v);continue}if(m.policy){if(m.type!=="string"&&m.type!=="number"){this.g.warn(`Policy ${m.policy.name} has unsupported type ${m.type}`);continue}p.push(v),f[m.policy.name]={type:m.type}}}return(0,D.isEmptyObject)(f)||await this.f.updatePolicyDefinitions(f),p}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const f=E.Registry.as(g.Extensions.Configuration).getPolicyConfigurations(),p=(0,O.coalesce)(c.map(b=>f.get(b)));this.j(p,!0)}j(c,f){this.g.trace("PolicyConfiguration#update",c);const p=E.Registry.as(g.Extensions.Configuration).getConfigurationProperties(),b=[],v=this.b.isEmpty();for(const m of c){const t=p[m]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(v?s!==void 0:!(0,k.equals)(this.b.getValue(m),s))&&b.push([m,s])}else this.b.getValue(m)!==void 0&&b.push([m,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const m=this.b;this.b=new S.ConfigurationModel;for(const t of m.keys)this.b.setValue(t,m.getValue(t));for(const[t,s]of b)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};y=he([Z(1,I.IPolicyService),Z(2,u.ILogService)],y),e.PolicyConfiguration=y}),define(Q[127],_([0,1,5,4,2,18,24,65,126,38]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends P.Disposable{constructor(d,w,y,N){super(),this.i=d,this.h=this.B(new R.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.DefaultConfiguration),this.c=y instanceof u.NullPolicyService?new g.NullPolicyConfiguration:this.B(new g.PolicyConfiguration(this.b,y,N)),this.f=this.B(new S.UserSettings(this.i,void 0,k.extUriBiasedIgnorePathCase,w)),this.a=new S.Configuration(this.b.configurationModel,this.c.configurationModel,new S.ConfigurationModel,new S.ConfigurationModel),this.g=this.B(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:f})=>this.k(c,f))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,w,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.Configuration(d,w,new S.ConfigurationModel,y)}getConfigurationData(){return this.a.toData()}getValue(d,w){const y=typeof d=="string"?d:void 0,N=(0,D.isConfigurationOverrides)(d)?d:(0,D.isConfigurationOverrides)(w)?w:{};return this.a.getValue(y,N,void 0)}updateValue(d,w,y,N){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.j(d)}j(d){const w=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(d);this.m(y,w,2)}k(d,w){const y=this.a.toData(),N=this.a.compareAndUpdateDefaultConfiguration(d,w);this.m(N,y,7)}l(d){const w=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(d);this.m(y,w,7)}m(d,w,y){const N=new S.ConfigurationChangeEvent(d,{data:w},this.a);N.source=y,N.sourceConfig=this.n(y),this.h.fire(N)}n(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(Q[66],_([0,1,16]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(u){return u.scheme===O.Schemas.vscodeRemote?u.authority:void 0}e.getRemoteAuthority=R;function P(u){if(!u)return;const I=u.indexOf("+");return I<0?u:u.substr(0,I)}e.getRemoteName=P;function k(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.getRemoteServerRootPath=k;function D(u){const{host:I,port:E}=g(u);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:I,port:E}}e.parseAuthorityWithPort=D;function S(u,I){let{host:E,port:d}=g(u);return typeof d>"u"&&(d=I),{host:E,port:d}}e.parseAuthorityWithOptionalPort=S;function g(u){const I=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(I)return{host:I[1],port:parseInt(I[2],10)};const E=u.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const d=u.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:u,port:void 0}}}),define(Q[32],_([0,1,30,10,66]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function k(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D=e.ExtensionType||(e.ExtensionType={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S=e.TargetPlatform||(e.TargetPlatform={}));class g{constructor(y){this.value=y,this.c=y.toLowerCase()}static equals(y,N){if(typeof y>"u"||y===null)return typeof N>"u"||N===null;if(typeof N>"u"||N===null)return!1;if(typeof y=="string"||typeof N=="string"){const c=typeof y=="string"?y:y.value,f=typeof N=="string"?N:N.value;return O.equalsIgnoreCase(c,f)}return y.c===N.c}static toKey(y){return typeof y=="string"?y.toLowerCase():y.c}}e.ExtensionIdentifier=g;function u(w){return I(w)}e.isApplicationScopedExtension=u;function I(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=I;function E(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=E;function d(w,y){if(y){const N=`onResolveRemoteAuthority:${(0,P.getRemoteName)(y)}`;return!!w.activationEvents?.includes(N)}return!1}e.isResolverExtension=d,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[128],_([0,1,2,15,20,32]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class D extends O.Disposable{constructor(g,u){super(),this.b=g,this.a=(0,R.join)(this.b.userDataPath,k.MANIFEST_CACHE_FOLDER,k.USER_MANIFEST_CACHE_FILE),this.B(u.onDidInstallExtensions(I=>this.c(I))),this.B(u.onDidUninstallExtension(I=>this.f(I)))}c(g){g.some(u=>!!u.local)&&this.invalidate()}f(g){g.error||this.invalidate()}invalidate(){P.Promises.rm(this.a,P.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=D}),define(Q[46],_([0,1,14,99,42,10,37]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");function S(N){return N.res.statusCode&&N.res.statusCode>=200&&N.res.statusCode<300||N.res.statusCode===1223}e.isSuccess=S;function g(N){return N.res.statusCode===204}async function u(N){return g(N)?null:(await(0,O.streamToBuffer)(N.stream)).toString()}e.asText=u;async function I(N){if(!S(N))throw new Error("Server returned "+N.res.statusCode);return u(N)}e.asTextOrError=I;async function E(N){if(!S(N))throw new Error("Server returned "+N.res.statusCode);if(g(N))return null;const f=(await(0,O.streamToBuffer)(N.stream)).toString();try{return JSON.parse(f)}catch(p){throw p.message+=`:
`+f,p}}e.asJson=E;function d(N){y(N)}e.updateProxyConfigurationsScope=d;let w;function y(N){const c=D.Registry.as(P.Extensions.Configuration),f=w;w={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:N,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[w],remove:f?[f]:[]})}y(2)}),define(Q[129],_([0,1,23,16,13,46]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let D=class{constructor(g,u){this.a=g,this.b=u}async download(g,u,I=O.CancellationToken.None){if(g.scheme===R.Schemas.file||g.scheme===R.Schemas.vscodeRemote){await this.b.copy(g,u);return}const E={type:"GET",url:g.toString(!0)},d=await this.a.request(E,I);if(d.res.statusCode===200)await this.b.writeFile(u,d.stream);else{const w=await(0,k.asTextOrError)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${w}`)}}};D=he([Z(0,k.IRequestService),Z(1,P.IFileService)],D),e.DownloadService=D}),define(Q[130],_([0,1,131,3]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function P(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function k(D,S,g={}){const u=(0,O.parse)(D),I=g.proxyUrl||P(u,S);if(!I)return null;const E=(0,O.parse)(I);if(!/^https?:$/.test(E.protocol||""))return null;const d={host:E.hostname||"",port:E.port||(E.protocol==="https"?"443":"80"),auth:E.auth,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((w,y)=>{x(["http-proxy-agent"],w,y)}))(d):new(await new Promise((w,y)=>{x(["https-proxy-agent"],w,y)}))(d)}e.getProxyAgent=k}),define(Q[132],_([0,1,57,15,100,23,34,7,12,29,82,164,5,71]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function N(f,p,b,v){return b["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):g.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(v)&&!b["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(v)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=d.Promises.withAsyncBody(async(m,t)=>{const s=new k.CancellationTokenSource;let i=1e4;const n=f.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,w.clamp)(n,1,120)*1e3);const r=setTimeout(()=>{s.dispose(!0),t(new Error((0,P.localize)(0,null)))},i);try{m(await c(p,s.token))}catch(o){!(0,S.isCancellationError)(o)&&!s.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,D.toErrorMessage)(o)))):m({})}finally{clearTimeout(r),s.dispose()}})),y)}e.getResolvedShellEnv=N;async function c(f,p){const b=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",b);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",v);const m=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(m+"({.*})"+m),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const i=await(0,I.getSystemShell)(g.OS,s);return f.trace("getUnixShellEnvironment#shell",i),new Promise((n,r)=>{if(p.isCancellationRequested)return r(new S.CancellationError);const o=(0,R.basename)(i);let a,l;const h=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(a=`& '${process.execPath}' ${h} -p '''${m}'' + JSON.stringify(process.env) + ''${m}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' ${h} -p '"${m}" + JSON.stringify(process.env) + "${m}"'`,o==="tcsh"||o==="csh"?l=["-ic"]:l=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const A=(0,O.spawn)(i,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});p.onCancellationRequested(()=>(A.kill(),r(new S.CancellationError))),A.on("error",ee=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ee)),r(ee)});const F=[];A.stdout.on("data",ee=>F.push(ee));const X=[];A.stderr.on("data",ee=>X.push(ee)),A.on("close",(ee,te)=>{const ie=Buffer.concat(F).toString("utf8");f.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(X).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),ee||te)return r(new Error((0,P.localize)(2,null,ee,te)));const ae=t.exec(ie),fe=ae?ae[1]:"{}";try{const oe=JSON.parse(fe);b?oe.ELECTRON_RUN_AS_NODE=b:delete oe.ELECTRON_RUN_AS_NODE,v?oe.ELECTRON_NO_ATTACH_CONSOLE=v:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",oe),n(oe)}catch(oe){f.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(oe)),r(oe)}})})}}),define(Q[133],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,O.createDecorator)("stateReadService"),e.IStateService=(0,O.createDecorator)("stateService")}),define(Q[67],_([0,1,5,14,3,17,13,6]),function(x,e,O,R,P,k,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var g;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(g=e.SaveStrategy||(e.SaveStrategy={}));class u{constructor(w,y,N,c){this.f=w,this.g=N,this.h=c,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=y===0?void 0:new O.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.g.error(w)}}getItem(w,y){const N=this.a[w];return(0,P.isUndefinedOrNull)(N)?y:N}setItem(w,y){this.setItems([{key:w,data:y}])}setItems(w){let y=!1;for(const{key:N,data:c}of w)this.a[N]!==c&&((0,P.isUndefinedOrNull)(c)?(0,P.isUndefined)(this.a[N])||(this.a[N]=void 0,y=!0):(this.a[N]=c,y=!0));y&&this.j()}removeItem(w){(0,P.isUndefined)(this.a[w])||(this.a[w]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.h.writeFile(this.f,R.VSBuffer.fromString(w)),this.b=w}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=u;let I=class{constructor(w,y,N,c){this.a=new u(y.stateResource,w,N,c)}async init(){await this.a.init()}getItem(w,y){return this.a.getItem(w,y)}};I=he([Z(1,k.IEnvironmentService),Z(2,S.ILogService),Z(3,D.IFileService)],I),e.StateReadonlyService=I;class E extends I{setItem(w,y){this.a.setItem(w,y)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.StateService=E}),define(Q[68],_([0,1,12,35,11,29]),function(x,e,O,R,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function D(u){if(O.platform===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}async function S(u,I,E,d,w,y,N,c,f,p){const b=Object.create(null);b["common.machineId"]=N,b.sessionID=(0,k.generateUuid)()+Date.now(),b.commitHash=w,b.version=y,b["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,O.PlatformToString)(O.platform),b["common.nodePlatform"]=R.platform,b["common.nodeArch"]=d,b["common.product"]=p||"desktop",c&&(b["common.msftInternal"]=c);let v=0;const m=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>v++,enumerable:!0}}),O.isLinuxSnap&&(b["common.snap"]="true");const t=D(E);t&&(b["common.platformDetail"]=t);try{const s=await u.readFile(P.URI.file(f));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=S;function g(u){const I=R.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return u.some(d=>E===d)}e.verifyMicrosoftInternalDomain=g}),define(Q[25],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,O.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(R=e.TelemetryLevel||(e.TelemetryLevel={}));var P;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(P=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[39],_([0,1,28,3,4,24,66,68,25]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class u{constructor(a){this.value=a}}e.TelemetryTrustedValue=u;class I{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,l){return Promise.resolve(void 0)}publicLog2(a,l){return this.publicLog(a,l)}publicLogError(a,l){return Promise.resolve(void 0)}publicLogError2(a,l){return this.publicLogError(a,l)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=I,e.NullTelemetryService=new I;class E{async publicLog(a,l,h){}async publicLogError(a,l,h){}}e.NullEndpointTelemetryService=E,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(o,a){return P.Event.debounce(a.onDidChangeConfiguration,(h,A)=>{const F=h?new Set([...h.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:F}},1e3,!0)(h=>{h.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(h.source),configurationKeys:v(h.affectedKeys)})})}e.configurationTelemetry=d;function w(o,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!o.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=w;function y(o,a){return!(a.isBuilt||a.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=y;function N(o){const a=o.getValue(g.TELEMETRY_SETTING_ID),l=o.getValue(g.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(g.TELEMETRY_OLD_SETTING_ID)===!1||l===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=N;function c(o){const a={},l={},h={};b(o,h);for(let A in h){A=A.length>150?A.substr(A.length-149):A;const F=h[A];typeof F=="number"?l[A]=F:typeof F=="boolean"?l[A]=F?1:0:typeof F=="string"?(F.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${F.length}`),a[A]=F.substring(0,8191)):typeof F<"u"&&F!==null&&(a[A]=F)}return{properties:a,measurements:l}}e.validateTelemetryData=c;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function p(o){if(!o)return"none";const a=(0,D.getRemoteName)(o);return f.has(a)?a:"other"}e.cleanRemoteAuthority=p;function b(o,a,l=0,h){if(!!o)for(const A of Object.getOwnPropertyNames(o)){const F=o[A],X=h?h+A:A;Array.isArray(F)?a[X]=(0,O.safeStringify)(F):F instanceof Date?a[X]=F.toISOString():(0,R.isObject)(F)?l<2?b(F,a,l+1,X+"."):a[X]=(0,O.safeStringify)(F):a[X]=F}}function v(o){if(!o)return[];const a=[];return m(a,"",o),a}function m(o,a,l){l&&typeof l=="object"&&!Array.isArray(l)?Object.keys(l).forEach(h=>m(o,a?`${a}.${h}`:h,l[h])):o.push(a)}function t(o,a){const l=o.msftInternalDomains||[],h=a.getValue("telemetry.internalTesting");return(0,S.verifyMicrosoftInternalDomain)(l)||h}e.isInternalTelemetry=t;function s(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=s;function i(o,a){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let l=o;const h=[];for(const ee of a)for(;;){const te=ee.exec(o);if(!te)break;h.push([te.index,ee.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,F=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let X=0;for(l="";;){const ee=F.exec(o);if(!ee)break;const te=h.some(([ie,ne])=>ee.index<ne&&ie<F.lastIndex);!A.test(ee[0])&&!te&&(l+=o.substring(X,ee.index)+"<REDACTED: user-file-path>",X=F.lastIndex)}return X<o.length&&(l+=o.substr(X)),l}function n(o){if(!o)return o;const a=o.toLowerCase(),l=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of l)if(h.regex.test(a))return`<REDACTED: ${h.label}>`;return o}function r(o,a){return(0,O.cloneAndChange)(o,l=>{if(l instanceof u)return l.value;if(typeof l=="string"){let h=l.replaceAll("%20"," ");h=i(h,a);for(const A of a)h=h.replace(A,"");return h=n(h),h}})}e.cleanData=r}),define(Q[26],_([0,1,30,21,32,12,11,7,35,39]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,O.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const r=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,r,o)}static parse(n){const r=E.exec(n);return r&&r[1]&&r[2]?new d({id:r[1]},r[2],r[4]||void 0):null}constructor(n,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?I(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const n=w.exec(i);return n&&n[1]?[c(n[1]),n[2]]:[c(i),void 0]}e.getIdAndVersion=y;function N(i,n){return`${i}.${n}`}e.getExtensionId=N;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function f(i,n){return c(N(i,n))}e.getGalleryExtensionId=f;function p(i,n){const r=[],o=a=>{for(const l of r)if(l.some(h=>I(n(h),n(a))))return l;return null};for(const a of i){const l=o(a);l?l.push(a):r.push([a])}return r}e.groupByExtension=p;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function v(i){return{id:new u.TelemetryTrustedValue(i.identifier.id),name:new u.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=v,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function m(i,n){const r=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&r.every(l=>!I(l.identifier,{id:a}))){const l=i.filter(h=>I(h.identifier,{id:a}));l.length===1&&(r.push(l[0]),o.push(...l[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}e.getExtensionDependencies=m;async function t(i,n){if(!k.isLinux)return!1;let r;try{r=(await i.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await i.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,S.getErrorMessage)(a))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(i,n){const r=await t(i,n),o=(0,R.getTargetPlatform)(r?"alpine":k.platform,g.arch);return n.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(Q[134],_([0,1,23,7,16,18,41,11,89,21,26,32]),function(x,e,O,R,P,k,D,S,g,u,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const d=c=>(0,g.localize)(0,null,c),w=(0,g.localize)(1,null,"ms-dotnettools.csharp");function y(c,f){return f?`${c.publisher}.${c.name}@${c.version}`:`${c.publisher}.${c.name}`}let N=class{constructor(f,p){this.a=f,this.b=p}get d(){}async listExtensions(f,p,b,v=console){let m=await this.a.getInstalled(1,b);const t=E.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(p&&p!==""){if(t.indexOf(p.toLowerCase())<0){v.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(i=>i.manifest.categories?i.manifest.categories.map(r=>r.toLowerCase()).indexOf(p.toLowerCase())>-1:!1)}else if(p===""){v.log("Possible Categories: "),t.forEach(i=>{v.log(i)});return}this.d&&v.log((0,g.localize)(2,null,this.d)),m=m.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let s;for(const i of m)s!==i.identifier.id&&(s=i.identifier.id,v.log(y(i.manifest,f)))}async installExtensions(f,p,b,v,m=console){const t=[],s=[];f.length&&m.log(this.d?(0,g.localize)(3,null,this.d):(0,g.localize)(4,null));const i=await this.a.getInstalled(1,b.profileLocation),n=(l,h)=>{const A=i.find(F=>(0,I.areSameExtensions)(F.identifier,{id:l}));if(A){if(!v&&(!h||h==="prerelease"&&A.preRelease))return m.log((0,g.localize)(5,null,l,A.manifest.version,l)),!1;if(h&&A.manifest.version===h)return m.log((0,g.localize)(6,null,`${l}@${h}`)),!1}return!0},r=(l,h,A)=>{a.push({id:l,version:h!=="prerelease"?h:void 0,installOptions:{...b,isBuiltin:A,installPreReleaseVersion:h==="prerelease"||b.installPreReleaseVersion}})},o=[],a=[];for(const l of f)if(l instanceof S.URI)o.push(l);else{const[h,A]=(0,I.getIdAndVersion)(l);n(h,A)&&r(h,A,!1)}for(const l of p){const[h,A]=(0,I.getIdAndVersion)(l);n(h,A)&&r(h,A,!0)}if(o.length&&await Promise.all(o.map(async l=>{try{const h=await this.f(l,{...b,isBuiltin:!1},v,m);h&&s.push(h)}catch(h){m.error(h.message||h.stack||h),t.push(l.toString())}})),a.length){const l=await this.g(a);await Promise.all(a.map(async h=>{const A=l.get(h.id.toLowerCase());if(A)try{const F=await this.h(h,A,i,v,m);F&&s.push(F)}catch(F){m.error(F.message||F.stack||F),t.push(h.id)}else m.error(`${d(h.version?`${h.id}@${h.version}`:h.id)}
${w}`),t.push(h.id)}))}if(t.length)throw new Error((0,g.localize)(7,null,t.join(", ")))}async f(f,p,b,v){const m=await this.a.getManifest(f);if(!m)throw new Error("Invalid vsix");if(await this.k(m,b,p.profileLocation,v))try{return await this.a.install(f,p),v.log((0,g.localize)(8,null,(0,k.basename)(f))),m}catch(s){if((0,R.isCancellationError)(s))return v.log((0,g.localize)(9,null,(0,k.basename)(f))),null;throw s}return null}async g(f){const p=new Map,b=f.some(m=>m.installOptions.installPreReleaseVersion),v=await this.b.getExtensions(f.map(m=>({...m,preRelease:b})),O.CancellationToken.None);for(const m of v)p.set(m.identifier.id.toLowerCase(),m);return p}async h({id:f,version:p,installOptions:b},v,m,t,s){const i=await this.b.getManifest(v,O.CancellationToken.None);if(i&&!this.j(i,s))return null;const n=m.find(r=>(0,I.areSameExtensions)(r.identifier,v.identifier));if(n){if(v.version===n.manifest.version)return s.log((0,g.localize)(10,null,p?`${f}@${p}`:f)),null;s.log((0,g.localize)(11,null,f,v.version))}try{b.isBuiltin?s.log(p?(0,g.localize)(12,null,f,p):(0,g.localize)(13,null,f)):s.log(p?(0,g.localize)(14,null,f,p):(0,g.localize)(15,null,f));const r=await this.a.installFromGallery(v,{...b,installGivenVersion:!!p});return s.log((0,g.localize)(16,null,f,r.manifest.version)),i}catch(r){if((0,R.isCancellationError)(r))return s.log((0,g.localize)(17,null,f)),null;throw r}}j(f,p){return!0}async k(f,p,b,v){const m={id:(0,I.getGalleryExtensionId)(f.publisher,f.name)},s=(await this.a.getInstalled(1,b)).find(i=>(0,I.areSameExtensions)(m,i.identifier)&&(0,D.gt)(i.manifest.version,f.version));return s&&!p?(v.log((0,g.localize)(18,null,s.identifier.id,s.manifest.version,f.version)),!1):this.j(f,v)}async uninstallExtensions(f,p,b,v=console){const m=async s=>{if(s instanceof S.URI){const i=await this.a.getManifest(s);return y(i)}return s},t=[];for(const s of f){const i=await m(s),r=(await this.a.getInstalled(void 0,b)).filter(o=>(0,I.areSameExtensions)(o.identifier,{id:i}));if(!r.length)throw new Error(`${this.l(i)}
${w}`);if(r.some(o=>o.type===0)){v.log((0,g.localize)(19,null,i));return}if(!p&&r.some(o=>o.isBuiltin)){v.log((0,g.localize)(20,null,i));return}v.log((0,g.localize)(21,null,i));for(const o of r)await this.a.uninstall(o,{profileLocation:b}),t.push(o);this.d?v.log((0,g.localize)(22,null,i,this.d)):v.log((0,g.localize)(23,null,i))}}async locateExtension(f,p=console){const b=await this.a.getInstalled();f.forEach(v=>{b.forEach(m=>{if(m.identifier.id===v&&m.location.scheme===P.Schemas.file){p.log(m.location.fsPath);return}})})}l(f){return this.d?(0,g.localize)(24,null,f,this.d):(0,g.localize)(25,null,f)}};N=he([Z(0,u.IExtensionManagementService),Z(1,u.IExtensionGalleryService)],N),e.ExtensionManagementCLI=N}),define(Q[135],_([0,1,5,7,2,16,12,18,41,3,29,20,24,17,21,26,59,13,6]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let b=class We extends P.Disposable{constructor(m,t,s,i,n,r){super(),this.h=t,this.i=s,this.j=i,this.k=n,this.l=r,this.extensionsDownloadDir=m.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(m,t){await this.g;const s=(0,S.joinPath)(this.extensionsDownloadDir,this.v(m));try{await this.r(m,s,n=>this.i.download(m,n,t))}catch(n){throw new y.ExtensionManagementError(n.message,y.ExtensionManagementErrorCode.Download)}let i="Unverified";if(await this.m(m)){const n=await this.n(m);try{await this.k.verify(s.fsPath,n.fsPath)&&(i="Verified"),this.l.info(`Extension signature verification: ${m.identifier.id}. Verification status: ${i}.`)}catch(r){const o=r,a=o.code;if(a==="UnknownError")i="UnknownError",this.l.warn(`Extension signature verification: ${m.identifier.id}. Verification status: ${i}.`);else if(!o.didExecute)this.l.warn(`Extension signature verification: ${m.identifier.id}. Verification status: ${i} (${a})`);else throw await this.delete(n),await this.delete(s),new y.ExtensionManagementError(a,y.ExtensionManagementErrorCode.Signature)}}return{location:s,verificationStatus:i}}async m(m){if(!m.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,u.isBoolean)(t)?t:!0}async n(m){await this.g;const t=(0,S.joinPath)(this.extensionsDownloadDir,`${this.v(m)}${We.c}`);return await this.r(m,t,s=>this.i.downloadSignatureArchive(m,s)),t}async r(m,t,s){if(await this.h.exists(t))return;if(t.scheme!==k.Schemas.file){await s(t);return}const i=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.h.exists(i)||await s(i);try{await this.t(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",m.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,R.getErrorMessage)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(m){await this.g,await this.h.del(m)}async t(m,t,s){try{await E.Promises.rename(m.fsPath,t.fsPath)}catch(i){if(D.isWindows&&i&&i.code==="EPERM"&&Date.now()<s)return this.l.info(`Failed renaming ${m} to ${t} with 'EPERM' error. Trying again...`),this.t(m,t,s);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const m=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const t=[],s=[],i=[];for(const o of m.children)if(o.name.endsWith(We.c))i.push(o.resource);else{const a=N.ExtensionKey.parse(o.name);a&&s.push([a,o])}const n=(0,N.groupByExtension)(s,([o])=>o),r=[];for(const o of n)o.sort((a,l)=>g.rcompare(a[0].version,l[0].version)),t.push(...o.slice(1).map(a=>a[1].resource)),r.push(o[0][1]);r.sort((o,a)=>o.mtime-a.mtime),t.push(...r.slice(0,Math.max(0,r.length-this.f)).map(o=>o.resource)),t.push(...i),await O.Promises.settled(t.map(o=>(this.l.trace("Deleting from cache",o.path),this.h.del(o))))}}catch(m){this.l.error(m)}}v(m){return this.f?N.ExtensionKey.create(m).toString().toLowerCase():(0,I.generateUuid)()}};b.c=".sigzip",b=he([Z(0,w.INativeEnvironmentService),Z(1,f.IFileService),Z(2,y.IExtensionGalleryService),Z(3,d.IConfigurationService),Z(4,c.IExtensionSignatureVerificationService),Z(5,p.ILogService)],b),e.ExtensionsDownloader=b}),define(Q[136],_([0,1,4,2,36,26,32]),function(x,e,O,R,P,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class S extends R.Disposable{constructor(u,I,E,d,w,y,N){super(),this.f=u,this.g=I,this.h=E,this.i=d,this.j=w,this.k=y,this.l=N,this.a=this.B(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new R.DisposableMap),this.m().then(null,c=>N.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(u=>this.p(u.added,u.removed))),this.B(this.i.onAddExtensions(u=>this.r(u))),this.B(this.i.onDidAddExtensions(u=>this.s(u))),this.B(this.i.onRemoveExtensions(u=>this.t(u))),this.B(this.i.onDidRemoveExtensions(u=>this.u(u))),this.B(this.k.onDidFilesChange(u=>this.v(u)))}async p(u,I){try{await Promise.all(I.map(E=>(this.c.deleteAndDispose(E.id),this.z(E.extensionsResource)))),u.length&&await Promise.all(u.map(E=>(this.c.set(E.id,(0,R.combinedDisposable)(this.k.watch(this.j.extUri.dirname(E.extensionsResource)),this.k.watch(E.extensionsResource))),this.y(E.extensionsResource))))}catch(E){throw this.l.error(E),E}}async r(u){for(const I of u.extensions)this.D(this.G(I.identifier,I.version),u.profileLocation)}async s(u){for(const I of u.extensions){const E=this.G(I.identifier,I.version);u.error?this.F(E,u.profileLocation):this.D(E,u.profileLocation)}}async t(u){for(const I of u.extensions)this.F(this.G(I.identifier,I.version),u.profileLocation)}async u(u){const I=[],E=[];for(const d of u.extensions){const w=this.G(d.identifier,d.version);u.error?this.D(w,u.profileLocation):(this.F(w,u.profileLocation),this.b.has(w)||(this.l.debug("Extension is removed from all profiles",d.identifier.id,d.version),E.push(this.f.scanInstalledExtensionAtLocation(d.location).then(y=>{y?I.push(y):this.l.info("Extension not found at the location",d.location.toString())},y=>this.l.error(y)))))}try{await Promise.all(E),I.length&&await this.C(I)}catch(d){this.l.error(d)}}v(u){for(const I of this.h.profiles)u.contains(I.extensionsResource,0,1)&&this.w(I.extensionsResource)}async w(u){const I=[],E=[],d=await this.i.scanProfileExtensions(u),w=new Set,y=new Set;for(const[N,c]of this.b)c.has(u)&&y.add(N);for(const N of d){const c=this.G(N.identifier,N.version);w.add(c),y.has(c)||(I.push(N.identifier),this.D(c,u))}for(const N of y)if(!w.has(N)){const c=this.H(N);c&&(E.push(c.identifier),this.F(N,u))}(I.length||E.length)&&this.a.fire({added:I.length?{extensions:I,profileLocation:u}:void 0,removed:E.length?{extensions:E,profileLocation:u}:void 0})}async y(u){const I=await this.i.scanProfileExtensions(u);for(const E of I)this.D(this.G(E.identifier,E.version),u)}async z(u){for(const I of[...this.b.keys()])this.F(I,u);await this.C()}async C(u){u||(u=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.G(E.identifier,E.manifest.version)))),u.length&&await this.f.markAsUninstalled(...u)}D(u,I){let E=this.b.get(u);E||this.b.set(u,E=new P.ResourceSet(d=>this.j.extUri.getComparisonKey(d))),E.add(I)}F(u,I){const E=this.b.get(u);E&&E.delete(I),E?.size||this.b.delete(u)}G(u,I){return`${D.ExtensionIdentifier.toKey(u.id)}@${I}`}H(u){const[I,E]=(0,k.getIdAndVersion)(u);return E?{identifier:{id:I},version:E}:void 0}}e.ExtensionsWatcher=S}),define(Q[137],_([0,1,109,39]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function P(k,D,S,g,u,I,E){const d={"X-Market-Client-Id":`VSCode ${k}`,"User-Agent":`VSCode ${k} (${D.nameShort})`};if((0,R.supportsTelemetry)(D,S)&&(0,R.getTelemetryLevel)(g)===3){const w=await(0,O.getServiceMachineId)(S,u,I),{machineId:y}=await E.getTelemetryInfo();d["X-Market-User-Id"]=w,d["VSCode-SessionId"]=y||w}return d}e.resolveMarketplaceHeaders=P}),define(Q[138],_([0,1,165,19,5,2,16,15,20,17,21,26,6,63,12,11]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let c=class extends w.LanguagePackBaseService{constructor(v,m,t,s){super(t),this.h=v,this.i=s,this.g=this.B(new f(m,s)),this.h.registerParticipant({postInstall:async i=>this.j(i),postUninstall:async i=>this.k(i)})}async getBuiltInExtensionTranslationsUri(v){const t=(await this.g.getLanguagePacks())[y.Language.value()];if(!t){this.i.warn(`No language pack found for ${y.Language.value()}`);return}const s=t.translations[v];return s?N.URI.file(s):void 0}async getInstalledLanguages(){const v=await this.g.getLanguagePacks(),m=Object.keys(v).map(t=>{const s=v[t];return{...this.f(t,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((t,s)=>t.label.localeCompare(s.label)),m}async j(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",v.identifier.id),await this.update())}async k(v){const m=await this.g.getLanguagePacks();Object.keys(m).some(t=>m[t]&&m[t].extensions.some(s=>(0,E.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.i.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(m);return!(0,R.equals)(Object.keys(v),Object.keys(t))}};c=he([Z(0,I.IExtensionManagementService),Z(1,u.INativeEnvironmentService),Z(2,I.IExtensionGalleryService),Z(3,d.ILogService)],c),e.NativeLanguagePackService=c;let f=class extends k.Disposable{constructor(v,m){super(),this.i=m,this.c={},this.f=(0,S.join)(v.userDataPath,"languagepacks.json"),this.g=new P.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(v){return this.m(m=>{Object.keys(m).forEach(t=>delete m[t]),this.j(m,...v)}).then(()=>this.c)}j(v,...m){for(const t of m)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(v,t);Object.keys(v).forEach(t=>this.l(v[t]))}k(v,m){const t=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const i of s)if(m.location.scheme===D.Schemas.file&&p(i)){let n=v[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},v[i.languageId]=n);const r=n.extensions.filter(o=>(0,E.areSameExtensions)(o.extensionIdentifier,t))[0];r?r.version=m.manifest.version:n.extensions.push({extensionIdentifier:t,version:m.manifest.version});for(const o of i.translations)n.translations[o.id]=(0,S.join)(m.location.fsPath,o.path)}}l(v){if(v){const m=(0,O.createHash)("md5");for(const t of v.extensions)m.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);v.hash=m.digest("hex")}}m(v=()=>null){return this.g.queue(()=>{let m=null;return g.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(m=v(t),t)).then(t=>{for(const i of Object.keys(t))t[i]||delete t[i];this.c=t,this.h=!0;const s=JSON.stringify(this.c);return this.i.debug("Writing language packs",s),g.Promises.writeFile(this.f,s)}).then(()=>m,t=>this.i.error(t))})}};f=he([Z(0,u.INativeEnvironmentService),Z(1,d.ILogService)],f);function p(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const v of b.translations)if(typeof v.id!="string"||typeof v.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(Q[139],_([0,1,7,28,39]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const k="https://mobile.events.data.microsoft.com/OneCollector/1.0",D="https://mobile.events.data.microsoft.com/ping";async function S(u,I,E){const d=await new Promise((f,p)=>{x(["@microsoft/1ds-core-js"],f,p)}),w=await new Promise((f,p)=>{x(["@microsoft/1ds-post-js"],f,p)}),y=new d.AppInsightsCore,N=new w.PostChannel,c={instrumentationKey:u,endpointUrl:k,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[N]]};if(E){c.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:E};c.extensionConfig[N.identifier]=f}return y.initialize(c,[]),y.addTelemetryInitializer(f=>{I&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),y}class g{constructor(I,E,d,w,y){this.e=I,this.f=E,this.g=d,this.h=y,this.c=k,this.d=D,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(I){if(!!this.a){if(typeof this.a!="string"){I(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(E=>{I(E)},E=>{(0,O.onUnexpectedError)(E),console.error(E)})}}log(I,E){if(!this.a)return;E=(0,R.mixin)(E,this.g),E=(0,P.validateTelemetryData)(E);const d=this.f+"/"+I;try{this.i(w=>{w.pluginVersionString=E?.properties.version??"Unknown",w.track({name:d,baseData:{name:d,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this.a?new Promise(I=>{this.i(E=>{E.unload(!0,()=>{this.a=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=g}),define(Q[140],_([0,1,2,28,12,30,101,24,42,141,31,37,25,39]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(f,p,b){this.k=p,this.l=b,this.d={},this.i=new O.DisposableStore,this.j=[],this.b=f.appenders,this.c=f.commonProperties||Promise.resolve({}),this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,k.escapeRegExpCharacters)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.escapeRegExpCharacters)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(d.TELEMETRY_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_OLD_SETTING_ID)||v.affectsConfiguration(d.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(f,p){this.d[f]=p}m(){let f=(0,w.getTelemetryLevel)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const b=p.usage?3:p.error?2:0;f=Math.min(f,b)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const f=await this.c,p=f.sessionID,b=f["common.machineId"],v=f["common.firstSessionDate"],m=f["common.msftInternal"];return{sessionId:p,machineId:b,firstSessionDate:v,msftInternal:m}}dispose(){this.i.dispose()}n(f,p,b){return this.g<p?Promise.resolve(void 0):this.c.then(v=>{b=(0,R.mixin)(b,this.d),b=(0,w.cleanData)(b,this.j),b=(0,R.mixin)(b,v),this.b.forEach(m=>m.log(f,b))},v=>{console.error(v)})}publicLog(f,p){return this.n(f,3,p)}publicLog2(f,p){return this.publicLog(f,p)}publicLogError(f,p){return this.h?this.n(f,2,p):Promise.resolve(void 0)}publicLogError2(f,p){return this.publicLogError(f,p)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=he([Z(1,S.IConfigurationService),Z(2,I.IProductService)],y),e.TelemetryService=y;function N(){const c=(0,D.localize)(0,null,u.default.nameLong),f=u.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=P.isWeb?"":(0,D.localize)(3,null),b=(0,D.localize)(4,null),v=(0,D.localize)(5,null),m=(0,D.localize)(6,null),t=(0,D.localize)(7,null),s=`
|       | ${b} | ${v} | ${m} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,D.localize)(8,null);return`
${c} ${f} ${p}

&nbsp;

${t}
${s}

&nbsp;

${i}
`}E.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[d.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:N(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(g.Extensions.Configuration).registerConfiguration({id:d.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[d.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,D.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,D.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${d.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[142],_([0,1,166,139]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class P extends R.AbstractOneDataSystemAppender{constructor(D,S,g,u){const I={sendPOST:(E,d)=>{const w={method:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data)}};try{const y=O.request(E.urlString,w,N=>{N.on("data",function(c){d(N.statusCode??200,N.headers,c.toString())}),N.on("error",function(c){d(0,{})})});y.write(E.data),y.end()}catch{d(0,{})}}};super(D,S,g,u,I)}}e.OneDataSystemAppender=P}),define(Q[143],_([0,1,15,20]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildTelemetryMessage=void 0;async function P(k,D){const S=Object.create(null),g=(I,E)=>{const d=JSON.parse(I);S[E]=d};if(D){const I=[],E=await R.Promises.readdir(D);for(const w of E)try{(await R.Promises.stat((0,O.join)(D,w))).isDirectory()&&I.push(w)}catch{}const d=[];for(const w of I)(await R.Promises.readdir((0,O.join)(D,w))).filter(N=>N==="telemetry.json").length===1&&d.push(w);for(const w of d){const y=(await R.Promises.readFile((0,O.join)(D,w,"telemetry.json"))).toString();g(y,w)}}let u=(await R.Promises.readFile((0,O.join)(k,"telemetry-core.json"))).toString();return g(u,"vscode-core"),u=(await R.Promises.readFile((0,O.join)(k,"telemetry-extensions.json"))).toString(),g(u,"vscode-extensions"),JSON.stringify(S,null,4)}e.buildTelemetryMessage=P}),define(Q[144],_([0,1,12,80,25]),function(x,e,O,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function k(D){let S=D.getItem(P.machineIdKey);return(typeof S!="string"||O.isMacintosh&&S==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(S=await(0,R.getMachineId)()),S}e.resolveMachineId=k}),define(Q[27],_([0,1,10]),function(x,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,O.createDecorator)("IUriIdentityService")}),define(Q[145],_([0,1,27,110,13,18,72,4,2]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class u{constructor(d){this.uri=d,this.time=u._clock++}touch(){return this.time=u._clock++,this}}u._clock=0;let I=class{constructor(d){this.g=d,this.c=new g.DisposableStore,this.f=2**16;const w=new Map,y=N=>{let c=w.get(N.scheme);return c===void 0&&(c=d.hasProvider(N)&&!this.g.hasCapability(N,1024),w.set(N.scheme,c)),c};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(N=>{w.delete(N.scheme)})),this.extUri=new k.ExtUri(y),this.d=new D.SkipList((N,c)=>this.extUri.compare(N,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,k.normalizePath)(d));const w=this.d.get(d);return w?w.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new u(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((y,N)=>y[1].touch<N[1].touch?1:y[1].touch>N[1].touch?-1:0);u._clock=0,this.d.clear();const w=this.f*.5;for(let y=0;y<w;y++)this.d.set(d[y][0],d[y][1].touch())}};I=he([Z(0,P.IFileService)],I),e.UriIdentityService=I,(0,R.registerSingleton)(O.IUriIdentityService,I,1)}),define(Q[146],_([0,1,103,15,54,18,11,10,16]),function(x,e,O,R,P,k,D,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,S.createDecorator)("contextService");function u(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=u;function I(i){return typeof i?.id=="string"&&!u(i)&&!d(i)}e.isEmptyWorkspaceIdentifier=I,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function E(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.toWorkspaceIdentifier=E;function d(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=d;function w(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=w;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function N(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=N;function c(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=c;class f{constructor(n,r,o,a,l){this.h=n,this.j=o,this.k=a,this.l=l,this.c=P.TernarySearchTree.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=P.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,k.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(i){return new p({uri:i,index:0,name:(0,k.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,O.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(i,n){return k.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=v;function m(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===g.Schemas.tmp}e.isTemporaryWorkspace=m;function t(i,n){return!v(i,n)&&!m(i)}e.isSavedWorkspace=t;function s(i){return(typeof i=="string"?(0,R.extname)(i):(0,k.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(Q[22],_([0,1,51,4,2,18,11,102,17,13,10,6,146,36,27,5,29,30,3]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,I.createDecorator)("IUserDataProfilesService");function v(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=v;function m(i,n,r,o){return{id:i,name:n,location:r,isDefault:!1,shortName:o?.shortName,globalStorageHome:(0,k.joinPath)(r,"globalStorage"),settingsResource:(0,k.joinPath)(r,"settings.json"),keybindingsResource:(0,k.joinPath)(r,"keybindings.json"),tasksResource:(0,k.joinPath)(r,"tasks.json"),snippetsHome:(0,k.joinPath)(r,"snippets"),extensionsResource:(0,k.joinPath)(r,"extensions.json"),useDefaultFlags:o?.useDefaultFlags,isTransient:o?.transient}}e.toUserDataProfile=m;let t=class extends P.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,r,o,a){super(),this.m=n,this.n=r,this.r=o,this.s=a,this.f=!0,this.g=this.B(new R.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new R.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new R.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new R.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new w.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,k.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const l of this.I()){if(!l.name||!(0,p.isString)(l.name)||!l.location){this.s.warn("Skipping the invalid stored profile",l.location||l.name);continue}n.push(m((0,k.basename)(l.location),l.name,l.location,{shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}))}}catch(l){this.s.error(l)}const r=new w.ResourceMap,o=new Map,a=this.v();if(n.unshift({...a,extensionsResource:this.N()??a.extensionsResource,isDefault:!0}),n.length)try{const l=this.L();if(l.workspaces)for(const[h,A]of Object.entries(l.workspaces)){const F=D.URI.parse(h),X=n.find(ee=>ee.id===A);X&&r.set(F,X)}if(l.emptyWindows)for(const[h,A]of Object.entries(l.emptyWindows)){const F=n.find(X=>X.id===A);F&&o.set(h,F)}}catch(l){this.s.error(l)}this.t={profiles:n,workspaces:r,emptyWindows:o}}return this.t}v(){return m("__default__profile__",(0,S.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const r="Temp",o=new RegExp(`${(0,f.escapeRegExpCharacters)(r)}\\s(\\d+)`);let a=0;for(const h of this.profiles){const A=o.exec(h.name),F=A?parseInt(A[1]):0;a=F>a?F:a}const l=`${r} ${a+1}`;return this.createProfile((0,O.hash)((0,c.generateUuid)()).toString(16),l,{transient:!0},n)}async createNamedProfile(n,r,o){return this.createProfile((0,O.hash)((0,c.generateUuid)()).toString(16),n,r,o)}async createProfile(n,r,o,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=await this.w(n,r,o);return a&&await this.setProfileForWorkspace(a,l),l}async w(n,r,o){if(!(0,p.isString)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(r);return a||(a=(async()=>{try{const l=this.profiles.find(F=>F.name===r||F.id===n);if(l)return l;const h=m(n,r,(0,k.joinPath)(this.profilesHome,n),o);await this.n.createFolder(h.location);const A=[];return this.h.fire({profile:h,join(F){A.push(F)}}),await N.Promises.settled(A),this.C([h],[],[]),h}finally{this.k.delete(r)}})(),this.k.set(r,a)),a}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=m(o.id,r.name??o.name,o.location,{shortName:r.shortName??o.shortName,transient:r.transient??o.isTransient,useDefaultFlags:r.useDefaultFlags??o.useDefaultFlags}),this.C([],[],[o]),o}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(a=>a.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const o=[];this.i.fire({profile:r,join(a){o.push(a)}});try{await Promise.allSettled(o)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])r.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])r.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[r],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(r.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);this.F(n,o)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,r)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(o=>!this.r.extUri.isEqual(o.location,r.resource))).map(r=>this.n.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(r=>!this.z(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.y(n);return D.URI.isUri(r)?this.l.workspaces.get(r)??this.u.workspaces.get(r):this.l.emptyWindows.get(r)??this.u.emptyWindows.get(r)}y(n){return(0,d.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,d.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.l.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.emptyWindows.values()].some(r=>this.r.extUri.isEqual(r.location,n.location))||[...this.u.workspaces.values()].some(r=>this.r.extUri.isEqual(r.location,n.location)))}C(n,r,o){const a=[...this.profiles,...n],l=[];this.l.profiles=[];for(let h of a)h.isDefault||r.some(A=>h.id===A.id)||(h=o.find(A=>h.id===A.id)??h,h.isTransient?this.l.profiles.push(h):l.push({location:h.location,name:h.name,shortName:h.shortName,useDefaultFlags:h.useDefaultFlags}));this.J(l),this.t=void 0,this.D(n,r,o)}D(n,r,o){this.g.fire({added:n,removed:r,updated:o,all:this.profiles})}F(n,r,o){o=r?.isTransient?!0:o,o||this.F(n,void 0,!0);const a=this.y(n),l=o?this.l:this.u;D.URI.isUri(a)?(l.workspaces.delete(a),r&&l.workspaces.set(a,r)):(l.emptyWindows.delete(a),r&&l.emptyWindows.set(a,r)),o||this.G()}G(){const n={};for(const[o,a]of this.u.workspaces.entries())n[o.toString()]=a.id;const r={};for(const[o,a]of this.u.emptyWindows.entries())r[o.toString()]=a.id;this.M({workspaces:n,emptyWindows:r}),this.t=void 0}H(n){const r={},o=this.v();if(n.workspaces)for(const[l,h]of Object.entries(n.workspaces)){const A=D.URI.parse(h);r[l]=this.r.extUri.isEqual(A,o.location)?o.id:this.r.extUri.basename(A)}const a={};if(n.emptyWindows)for(const[l,h]of Object.entries(n.emptyWindows)){const A=D.URI.parse(h);a[l]=this.r.extUri.isEqual(A,o.location)?o.id:this.r.extUri.basename(A)}return{workspaces:r,emptyWindows:a}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=he([Z(0,g.IEnvironmentService),Z(1,u.IFileService),Z(2,y.IUriIdentityService),Z(3,E.ILogService)],t),e.UserDataProfilesService=t;class s extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=s}),define(Q[147],_([0,1,19,5,23,7,4,2,12,11,87,21,26,32,6,31,25,22]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var p;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(p=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let b=class extends S.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,r,o,a,l){super(),this.t=n,this.u=r,this.v=o,this.w=a,this.y=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new D.Emitter),this.m=this.B(new D.Emitter),this.n=this.B(new D.Emitter),this.p=this.B(new D.Emitter),this.s=[],this.B((0,S.toDisposable)(()=>{this.j.forEach(({task:h})=>h.cancel()),this.k.forEach(h=>h.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(o=>(0,E.isTargetPlatformCompatible)(o,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{if(!this.t.isEnabled())throw new E.ExtensionManagementError(I.localize(0,null),E.ExtensionManagementErrorCode.Internal);const o=await this.G(n,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.z(o.manifest,o.extension,r)}catch(o){throw t(this.u,"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(n),error:o}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(o),m(o)}}async uninstall(n,r={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,r)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,r,o){const a={...o,installOnlyNewlyAddedFromExtensionPack:u.URI.isUri(r)?o.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,w.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},l=te=>`${d.ExtensionKey.create(te).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!u.URI.isUri(r)){const te=this.j.get(l(r));if(te)return this.v.info("Extensions is already requested to install",r.identifier.id),te.task.waitUntilTaskIsFinished()}const h=[],A=[],F=[],X=this.Q(n,r,a);u.URI.isUri(r)||this.j.set(l(r),{task:X,waitingTasks:[]}),this.l.fire({identifier:X.identifier,source:r,profileLocation:a.profileLocation}),this.v.info("Installing extension:",X.identifier.id),h.push({task:X,manifest:n});let ee=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",X.identifier.id);else try{const ie=await this.F(X.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ne=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:ae,manifest:fe}of(0,O.distinct)(ie,({gallery:oe})=>oe.identifier.id)){ee=ee||!!fe.extensionDependencies?.some(V=>(0,d.areSameExtensions)({id:V},X.identifier));const oe=l(ae),ve=this.j.get(oe);if(ve){if(this.C(X,ve.task)){const V=ve.task.identifier;this.v.info("Waiting for already requested installing extension",V.id,X.identifier.id),ve.waitingTasks.push(X),A.push(D.Event.toPromise(D.Event.filter(this.onDidInstallExtensions,j=>j.some(M=>(0,d.areSameExtensions)(M.identifier,V)))).then(j=>{if(this.v.info("Finished waiting for already requested installing extension",V.id,X.identifier.id),!j.find($=>(0,d.areSameExtensions)($.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!ne.some(({identifier:V})=>(0,d.areSameExtensions)(V,ae.identifier))){const V=this.Q(fe,ae,{...a,donotIncludePackAndDependencies:!0});this.j.set(oe,{task:V,waitingTasks:[X]}),this.l.fire({identifier:V.identifier,source:ae,profileLocation:a.profileLocation}),this.v.info("Installing extension:",V.identifier.id,X.identifier.id),h.push({task:V,manifest:fe})}}}catch(ie){if(u.URI.isUri(X.source))(0,O.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",X.identifier.id,ie.message),(0,O.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",X.identifier.id,ie.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",X.identifier.id),ie}const te=h.reduce((ie,{task:ne,manifest:ae})=>(ie.set(ne.identifier.id.toLowerCase(),{task:ne,manifest:ae}),ie),new Map);for(;te.size;){let ie;const ne=[...te.values()].filter(({manifest:ae})=>!ae.extensionDependencies?.some(fe=>te.has(fe.toLowerCase())));ne.length?ie=te.size===1?ne:ne.filter(({task:ae})=>!(ae===X&&!ee)):(this.v.info("Found extensions with circular dependencies",ne.map(({task:ae})=>ae.identifier.id)),ie=[...te.values()]),await this.D(ie.map(async({task:ae})=>{const fe=new Date().getTime();try{const oe=await ae.run();if(await this.D(this.s.map(ve=>ve.postInstall(oe,ae.source,a,P.CancellationToken.None))),!u.URI.isUri(ae.source)){const ve=ae.operation===3,V=ve?void 0:(new Date().getTime()-ae.source.lastUpdated)/1e3;if(t(this.u,ve?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,durationSinceUpdate:V}),g.isWeb&&ae.operation!==3)try{await this.t.reportStatistic(oe.manifest.publisher,oe.manifest.name,oe.manifest.version,"install")}catch{}}F.push({local:oe,identifier:ae.identifier,operation:ae.operation,source:ae.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:oe.isApplicationScoped})}catch(oe){throw u.URI.isUri(ae.source)||t(this.u,ae.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.getGalleryExtensionTelemetryData)(ae.source),verificationStatus:ae.verificationStatus,duration:new Date().getTime()-fe,error:oe}),this.v.error("Error while installing the extension:",ae.identifier.id),oe}finally{te.delete(ae.identifier.id.toLowerCase())}}))}return A.length&&await this.D(A),F.forEach(({identifier:ie})=>this.v.info("Extension installed successfully:",ie.id)),this.m.fire(F),F.filter(({identifier:ie})=>(0,d.areSameExtensions)(ie,X.identifier))[0].local}catch(te){if(h.forEach(({task:ie})=>ie.cancel()),F.length)try{const ie=await Promise.allSettled(F.map(({local:ne})=>this.R(ne,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ne=0;ne<ie.length;ne++){const ae=ie[ne],{identifier:fe}=F[ne];ae.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",fe.id):this.v.warn("Rollback: Error while uninstalling extension",fe.id,(0,k.getErrorMessage)(ae.reason))}}catch(ie){this.v.warn("Error while rolling back extensions",(0,k.getErrorMessage)(ie),F.map(({identifier:ne})=>ne.id))}throw this.m.fire(h.map(({task:ie})=>({identifier:ie.identifier,operation:2,source:ie.source,context:a.context,profileLocation:a.profileLocation}))),te}finally{for(const{task:te}of h)te.source&&!u.URI.isUri(te.source)&&this.j.delete(l(te.source))}}C(n,r){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===n&&(a.includes(r)||a.some(l=>this.C(l,r)))||o===r&&a[0]&&!this.C(n,a[0]))return!1;return!0}async D(n){const r=[],o=[],a=await Promise.allSettled(n);for(const l of a)l.status==="fulfilled"?r.push(l.value):o.push(l.reason);if(o.length)throw v(o);return r}async F(n,r,o,a,l){if(!this.t.isEnabled())return[];const h=await this.getInstalled(void 0,l),A=[],F=[],X=async(ee,te)=>{A.push(ee);const ie=te.extensionDependencies||[],ne=[...ie];if(te.extensionPack){const ae=o?h.find(fe=>(0,d.areSameExtensions)(fe.identifier,ee)):void 0;for(const fe of te.extensionPack)ae&&ae.manifest.extensionPack&&ae.manifest.extensionPack.some(oe=>(0,d.areSameExtensions)({id:oe},{id:fe}))||ne.every(oe=>!(0,d.areSameExtensions)({id:oe},{id:fe}))&&ne.push(fe)}if(ne.length){const ae=ne.filter(fe=>A.every(oe=>!(0,d.areSameExtensions)(oe,{id:fe})));if(ae.length){const fe=await this.t.getExtensions(ae.map(oe=>({id:oe,preRelease:a})),P.CancellationToken.None);for(const oe of fe){if(A.find(j=>(0,d.areSameExtensions)(j,oe.identifier)))continue;const ve=ie.some(j=>(0,d.areSameExtensions)({id:j},oe.identifier));let V;try{V=await this.G(oe,!1,a)}catch(j){if(j instanceof E.ExtensionManagementError&&j.code===E.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!ve){this.v.info("Skipping the packed extension as it cannot be installed",oe.identifier.id);continue}else throw j}F.push({gallery:V.extension,manifest:V.manifest}),await X(V.extension.identifier,V.manifest)}}}};return await X(n,r),F}async G(n,r,o){if((await this.getExtensionsControlManifest()).malicious.some(A=>(0,d.areSameExtensions)(n.identifier,A)))throw new E.ExtensionManagementError(I.localize(1,null,n.identifier.id),E.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const A=await this.getTargetPlatform();throw new E.ExtensionManagementError(I.localize(2,null,n.identifier.id,this.w.nameLong,(0,E.TargetPlatformToString)(A)),E.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.H(n,r,o);if(l){if(o&&!r&&n.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new E.ExtensionManagementError(I.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],P.CancellationToken.None))[0]?new E.ExtensionManagementError(I.localize(4,null,n.identifier.id),E.ExtensionManagementErrorCode.ReleaseVersionNotFound):new E.ExtensionManagementError(I.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),E.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",l.identifier.id);const h=await this.t.getManifest(l,P.CancellationToken.None);if(h===null)throw new E.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,E.ExtensionManagementErrorCode.Invalid);if(h.version!==l.version)throw new E.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,E.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:h}}async H(n,r,o){const a=await this.getTargetPlatform();let l=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==o&&(l=(await this.t.getExtensions([{...n.identifier,preRelease:o}],{targetPlatform:a,compatible:!0},P.CancellationToken.None))[0]||null),!l&&await this.t.isExtensionCompatible(n,o,a)&&(l=n),l||(r?l=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},P.CancellationToken.None))[0]||null:l=await this.t.getCompatibleExtension(n,o,a)),l}async I(n,r){const o={...r,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:r.profileLocation??this.P()},a=ee=>`${ee.id.toLowerCase()}${o.versionOnly?`-${n.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,l=this.k.get(a(n.identifier));if(l)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),l.waitUntilTaskIsFinished();const h=ee=>{const te=this.R(ee,o);return this.k.set(a(te.extension.identifier),te),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ee.identifier.id}@${ee.manifest.version}`),this.n.fire({identifier:ee.identifier,profileLocation:o.profileLocation,applicationScoped:ee.isApplicationScoped}),te},A=(ee,te)=>{te?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ee.identifier.id}@${ee.manifest.version}`,o.profileLocation.toString(),te.message):this.v.error("Failed to uninstall extension:",`${ee.identifier.id}@${ee.manifest.version}`,te.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ee.identifier.id}@${ee.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ee.identifier.id}@${ee.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,d.getLocalExtensionTelemetryData)(ee),error:te}),this.p.fire({identifier:ee.identifier,error:te?.code,profileLocation:o.profileLocation,applicationScoped:ee.isApplicationScoped})},F=[],X=[];try{F.push(h(n));const ee=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const te=this.M(n,ee);for(const ie of te)this.k.has(a(ie.identifier))?this.v.info("Extensions is already requested to uninstall",ie.identifier.id):F.push(h(ie))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(F.map(te=>te.extension),ee,n),await this.D(F.map(async te=>{try{if(await te.run(),await this.D(this.s.map(ie=>ie.postUninstall(te.extension,o,P.CancellationToken.None))),te.extension.identifier.uuid)try{await this.t.reportStatistic(te.extension.manifest.publisher,te.extension.manifest.name,te.extension.manifest.version,"uninstall")}catch{}A(te.extension)}catch(ie){const ne=ie instanceof E.ExtensionManagementError?ie:new E.ExtensionManagementError((0,k.getErrorMessage)(ie),E.ExtensionManagementErrorCode.Internal);throw A(te.extension,ne),ne}finally{X.push(te)}}))}catch(ee){const te=ee instanceof E.ExtensionManagementError?ee:new E.ExtensionManagementError((0,k.getErrorMessage)(ee),E.ExtensionManagementErrorCode.Internal);for(const ie of F){try{ie.cancel()}catch{}X.includes(ie)||A(ie.extension,te)}throw te}finally{for(const ee of F)this.k.delete(a(ee.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ee.extension.identifier.id)}}J(n,r,o){for(const a of n){const l=this.N(a,r);if(l.length){const h=l.filter(A=>!n.some(F=>(0,d.areSameExtensions)(F.identifier,A.identifier)));if(h.length)throw new Error(this.L(a,h,o))}}}L(n,r,o){return o===n?r.length===1?I.localize(6,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(7,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?I.localize(9,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?I.localize(10,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):I.localize(11,null,o.manifest.displayName||o.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}M(n,r,o=[]){if(o.indexOf(n)!==-1)return[];o.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const l=r.filter(A=>!A.isBuiltin&&a.some(F=>(0,d.areSameExtensions)({id:F},A.identifier))),h=[];for(const A of l)h.push(...this.M(A,r,o));return[...l,...h]}return[]}N(n,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,d.areSameExtensions)({id:a},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};b=he([Z(0,E.IExtensionGalleryService),Z(1,c.ITelemetryService),Z(2,y.ILogService),Z(3,N.IProductService),Z(4,f.IUserDataProfilesService)],b),e.AbstractExtensionManagementService=b;function v(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=v;function m(i){if(i instanceof E.ExtensionManagementError)return i;const n=new E.ExtensionManagementError(i.message,E.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:r,verificationStatus:o,duration:a,error:l,durationSinceUpdate:h}){let A,F;l&&(l instanceof E.ExtensionManagementError?(A=l.code,l.code===E.ExtensionManagementErrorCode.Signature&&(F=l.message)):A=E.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:o,success:!l,duration:a,errorcode:A,errorcodeDetail:F,durationSinceUpdate:h})}class s{constructor(){this.d=new R.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,R.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,R.createCancelablePromise)(n=>new Promise((r,o)=>{const a=n.onCancellationRequested(()=>{a.dispose(),o(new k.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=s}),define(Q[40],_([0,1,5,14,2,4,36,11,21,26,13,10,6,22,27,3,7,25,16]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var b;(function(i){i.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",i.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(b=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class v extends Error{constructor(n,r){super(n),this.code=r}}e.ExtensionsProfileScanningError=v,e.IExtensionsProfileScannerService=(0,E.createDecorator)("IExtensionsProfileScannerService");let m=class extends P.Disposable{constructor(n,r,o,a,l,h){super(),this.i=n,this.j=r,this.k=o,this.l=a,this.m=l,this.n=h,this.b=this.B(new k.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new k.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new D.ResourceMap}scanProfileExtensions(n,r){return this.p(n,void 0,r)}async addExtensionsToProfile(n,r){const o=[],a=[];try{return await this.p(r,l=>{const h=[];for(const A of l)n.some(([F])=>(0,u.areSameExtensions)(F.identifier,A.identifier)&&F.manifest.version!==A.version)?o.push(A):h.push(A);for(const[A,F]of n)if(!h.some(X=>(0,u.areSameExtensions)(X.identifier,A.identifier)&&X.version===A.manifest.version)){const X={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:F};a.push(X),h.push(X)}return a.length&&this.b.fire({extensions:a,profileLocation:r}),o.length&&this.f.fire({extensions:o,profileLocation:r}),h}),a.length&&this.c.fire({extensions:a,profileLocation:r}),o.length&&this.g.fire({extensions:o,profileLocation:r}),a}catch(l){throw a.length&&this.c.fire({extensions:a,error:l,profileLocation:r}),o.length&&this.g.fire({extensions:o,error:l,profileLocation:r}),l}}async updateMetadata(n,r){const o=[];return await this.p(r,a=>{const l=[];for(const h of a){const A=n.find(([F])=>(0,u.areSameExtensions)(F.identifier,h.identifier)&&F.manifest.version===h.version);A&&(h.metadata={...h.metadata,...A[1]},o.push(h)),l.push(h)}return l}),o}async removeExtensionFromProfile(n,r){const o=[];this.f.fire({extensions:o,profileLocation:r});try{await this.p(r,a=>{const l=[];for(const h of a)(0,u.areSameExtensions)(h.identifier,n.identifier)?o.push(h):l.push(h);return o.length&&this.f.fire({extensions:o,profileLocation:r}),l}),o.length&&this.g.fire({extensions:o,profileLocation:r})}catch(a){throw o.length&&this.g.fire({extensions:o,error:a,profileLocation:r}),a}}async p(n,r,o){return this.w(n).queue(async()=>{let a=[],l;try{const h=await this.j.readFile(n);l=JSON.parse(h.value.toString().trim()||"[]")}catch(h){if((0,I.toFileOperationResult)(h)!==1)throw h;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&o?.bailOutWhenFileNotFound)throw new v((0,c.getErrorMessage)(h),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(n);let h=!1;for(const A of l){t(A)||this.r(n);let F;if((0,N.isString)(A.relativeLocation)&&A.relativeLocation)F=this.t(A.relativeLocation);else if((0,N.isString)(A.location))F=this.t(A.location),h=!0,A.relativeLocation=A.location,A.location=F.toJSON();else{F=S.URI.revive(A.location);const X=this.s(F);X&&(h=!0,A.relativeLocation=X)}a.push({identifier:A.identifier,location:F,version:A.version,metadata:A.metadata})}h&&await this.j.writeFile(n,R.VSBuffer.fromString(JSON.stringify(l)))}if(r){a=r(a);const h=a.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.s(A.location),metadata:A.metadata}));await this.j.writeFile(n,R.VSBuffer.fromString(JSON.stringify(h)))}return a})}r(n){const r=new v(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:r.code}),r}s(n){if(this.l.extUri.isEqualOrParent(n,this.i)){const r=this.l.extUri.relativePath(this.i,n);return this.i.scheme===p.Schemas.file&&this.n.getLevel()===d.LogLevel.Trace&&this.n.trace("Relative path",n.fsPath,this.i.fsPath,r),r}}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),r=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(n)).value.toString()}catch(l){if((0,I.toFileOperationResult)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",n.toString());let a;try{const l=JSON.parse(o);Array.isArray(l)&&l.every(h=>t(h))?a=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,R.VSBuffer.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,I.toFileOperationResult)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(n)}catch(l){(0,I.toFileOperationResult)(l)!==1&&this.n.error(l)}try{await this.j.del(r)}catch(l){(0,I.toFileOperationResult)(l)!==1&&this.n.error(l)}return a})()),this.u}w(n){let r=this.h.get(n);return r||(r=new O.Queue,this.h.set(n,r)),r}};m=he([Z(1,I.IFileService),Z(2,w.IUserDataProfilesService),Z(3,y.IUriIdentityService),Z(4,f.ITelemetryService),Z(5,d.ILogService)],m),e.AbstractExtensionsProfileScannerService=m;function t(i){return(0,N.isObject)(i)&&(0,g.isIExtensionIdentifier)(i.identifier)&&(s(i.location)||(0,N.isString)(i.location)&&i.location)&&((0,N.isUndefined)(i.relativeLocation)||(0,N.isString)(i.relativeLocation))&&i.version&&(0,N.isString)(i.version)}function s(i){return i?(0,N.isString)(i.path)&&(0,N.isString)(i.scheme):!1}}),define(Q[47],_([0,1,19,5,28,14,7,49,78,2,16,15,12,18,41,52,3,11,91,17,26,32,44,13,10,6,31,4,53,40,22,27,107,108]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p,b,v,m,t,s,i,n,r,o,a,l,h,A,F,X){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ee;(function(ve){function V(j,M){if(j===M)return!0;const $=Object.keys(j),W=new Set;for(const q of Object.keys(M))W.add(q);if($.length!==W.size)return!1;for(const q of $){if(j[q]!==M[q])return!1;W.delete(q)}return W.size===0}ve.equals=V})(ee=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let te=class extends u.Disposable{constructor(V,j,M,$,W,q,J,C,L,T,U,z){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=j,this.l=M,this.m=$,this.n=W,this.p=q,this.r=J,this.s=C,this.t=L,this.u=T,this.v=U,this.w=z,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,w.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(ae,(0,w.joinPath)(this.m,m.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(ae,(0,w.joinPath)(this.m,m.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ne,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,v.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(V,j,M){const[$,W]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(j)]),q=M?await this.scanExtensionsUnderDevelopment(V,[...$,...W]):[];return this.F($,W,q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const j=[];j.push(this.G(!!V.useCache,V.language)),j.push(this.H(V.language,!!V.checkControlFile));const[M,$]=await Promise.all(j);return this.D([...M,...$],0,V,!1)}async scanUserExtensions(V){const j=V.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",j);const M=this.v.extUri.isEqual(V.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,$=await this.J(j,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,M),W=V.useCache&&!$.devMode&&$.excludeObsolete?this.j:this.k;let q;try{q=await W.scanExtensions($)}catch(J){if(J instanceof l.ExtensionsProfileScanningError&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),q=await W.scanExtensions($);else throw J}return q=await this.D(q,1,V,!0),this.s.trace("Scanned user extensions:",q.length),q}async scanExtensionsUnderDevelopment(V,j){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter($=>$.scheme===I.Schemas.file).map(async $=>{const W=await this.J($,!1,1,!0,V.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(W)).map(J=>(J.type=j.find(C=>(0,v.areSameExtensions)(C.identifier,J.identifier))?.type??J.type,this.k.validate(J,W)))}))).flat();return this.D(M,"development",V,!0)}return[]}async scanExistingExtension(V,j,M){const $=await this.J(V,!1,j,!0,M.language,!0,void 0),W=await this.k.scanExtension($);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(V,j,M){const $=await this.J(V,!1,j,!0,M.language,!0,void 0),W=await this.k.scanOneOrMultipleExtensions($);return this.D(W,j,M,!0)}async scanMetadata(V){const j=(0,w.joinPath)(V,"package.json"),M=(await this.r.readFile(j)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(V,j){const M=(0,w.joinPath)(V,"package.json"),$=(await this.r.readFile(M)).value.toString(),W=JSON.parse($);j.isMachineScoped=j.isMachineScoped||void 0,j.isBuiltin=j.isBuiltin||void 0,W.__metadata={...W.__metadata,...j},await this.r.writeFile((0,w.joinPath)(V,"package.json"),k.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof l.ExtensionsProfileScanningError&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw V}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.p.addExtensionsToProfile(V.map(j=>[j,j.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify([])))}catch(j){(0,s.toFileOperationResult)(j)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.getErrorMessage)(j))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.s.error(V)}finally{this.z=void 0}})()),this.z}async D(V,j,M,$){return M.includeAllVersions||(V=this.F(j===0?V:void 0,j===1?V:void 0,j==="development"?V:void 0,await this.getTargetPlatform(),$)),M.includeInvalid||(V=V.filter(W=>W.isValid)),V.sort((W,q)=>{const J=E.basename(W.location.fsPath),C=E.basename(q.location.fsPath);return J<C?-1:J>C?1:0})}F(V,j,M,$,W){const q=(C,L,T)=>{if(C.isValid&&!L.isValid)return!1;if(C.isValid===L.isValid){if(W&&y.gt(C.manifest.version,L.manifest.version))return this.s.debug(`Skipping extension ${L.location.path} with lower version ${L.manifest.version} in favour of ${C.location.path} with version ${C.manifest.version}`),!1;if(y.eq(C.manifest.version,L.manifest.version)){if(C.type===0)return this.s.debug(`Skipping extension ${L.location.path} in favour of system extension ${C.location.path} with same version`),!1;if(C.targetPlatform===$)return this.s.debug(`Skipping extension ${L.location.path} from different target platform ${L.targetPlatform}`),!1}}return T?this.s.warn(`Overwriting user extension ${C.location.path} with ${L.location.path}.`):this.s.debug(`Overwriting user extension ${C.location.path} with ${L.location.path}.`),!0},J=new Map;return V?.forEach(C=>{const L=m.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);(!T||q(T,C,!1))&&J.set(L,C)}),j?.forEach(C=>{const L=m.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);if(!T&&V&&C.type===0){this.s.debug(`Skipping obsolete system extension ${C.location.path}.`);return}(!T||q(T,C,!1))&&J.set(L,C)}),M?.forEach(C=>{const L=m.ExtensionIdentifier.toKey(C.identifier.id),T=J.get(L);(!T||q(T,C,!0))&&J.set(L,C),J.set(L,C)}),[...J.values()]}async G(V,j){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,j,!0,void 0),W=await(V&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",W.length),W}async H(V,j){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const $=j?await this.I():{},W=[],q=f.URI.file(E.normalize(E.join(I.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const C of M){const L=$[C.name]||"marketplace";switch(L){case"disabled":break;case"marketplace":W.push((0,w.joinPath)(q,C.name));break;default:W.push(f.URI.file(L));break}}const J=await Promise.all(W.map(async C=>this.k.scanExtension(await this.J(C,!1,0,!0,V,!0,void 0))));return this.s.trace("Scanned dev system extensions:",J.length),(0,O.coalesce)(J)}async I(){try{const V=await this.r.readFile(this.l);return JSON.parse(V.value.toString())}catch{return{}}}async J(V,j,M,$,W,q,J){const C=await this.f(W??d.language),L=await this.L(V),T=j&&!this.v.extUri.isEqual(V,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,U=T?await this.L(T):void 0;return new ie(V,L,T,U,j,J,M,$,q,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,W,C)}async L(V){try{const j=await this.r.stat(V);if(typeof j.mtime=="number")return j.mtime}catch{}}};te=he([Z(4,h.IUserDataProfilesService),Z(5,l.IExtensionsProfileScannerService),Z(6,s.IFileService),Z(7,n.ILogService),Z(8,b.IEnvironmentService),Z(9,r.IProductService),Z(10,A.IUriIdentityService),Z(11,i.IInstantiationService)],te),e.AbstractExtensionsScannerService=te;class ie{constructor(V,j,M,$,W,q,J,C,L,T,U,z,G,H,re){this.location=V,this.mtime=j,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=$,this.profile=W,this.profileScanOptions=q,this.type=J,this.excludeObsolete=C,this.validate=L,this.productVersion=T,this.productDate=U,this.productCommit=z,this.devMode=G,this.language=H,this.translations=re}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,j){return(0,w.isEqual)(V.location,j.location)&&V.mtime===j.mtime&&(0,w.isEqual)(V.applicationExtensionslocation,j.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===j.applicationExtensionslocationMtime&&V.profile===j.profile&&P.equals(V.profileScanOptions,j.profileScanOptions)&&V.type===j.type&&V.excludeObsolete===j.excludeObsolete&&V.validate===j.validate&&V.productVersion===j.productVersion&&V.productDate===j.productDate&&V.productCommit===j.productCommit&&V.devMode===j.devMode&&V.language===j.language&&ee.equals(V.translations,j.translations)}}e.ExtensionScannerInput=ie;let ne=class extends u.Disposable{constructor(V,j,M,$,W){super(),this.f=V,this.g=j,this.h=M,this.i=$,this.j=W}async scanExtensions(V){const j=V.profile?await this.l(V):await this.k(V);let M={};if(V.excludeObsolete&&V.type===1)try{const $=(await this.i.readFile(this.f)).value.toString();M=JSON.parse($)}catch{}return(0,c.isEmptyObject)(M)?j:j.filter($=>!M[v.ExtensionKey.create($).toString()])}async k(V){const j=await this.i.resolve(V.location);if(!j.children?.length)return[];const M=await Promise.all(j.children.map(async $=>{if(!$.isDirectory||V.type===1&&(0,w.basename)($.resource).indexOf(".")===0)return null;const W=new ie($.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(W)}));return(0,O.coalesce)(M).sort(($,W)=>$.location.path<W.location.path?-1:1)}async l(V){let j=await this.m(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){j=j.filter($=>!$.metadata?.isApplicationScoped);const M=await this.m(V.applicationExtensionslocation,$=>!!$.metadata?.isApplicationScoped,V);j.push(...M)}return j}async m(V,j,M){const $=await this.g.scanProfileExtensions(V,M.profileScanOptions);if(!$.length)return[];const W=await Promise.all($.map(async q=>{if(j(q)){const J=new ie(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(J,q.metadata)}return null}));return(0,O.coalesce)(W)}async scanOneOrMultipleExtensions(V){try{if(await this.i.exists((0,w.joinPath)(V.location,"package.json"))){const j=await this.scanExtension(V);return j?[j]:[]}else return await this.scanExtensions(V)}catch(j){return this.j.error(`Error scanning extensions at ${V.location.path}:`,(0,D.getErrorMessage)(j)),[]}}async scanExtension(V,j){try{let M=await this.scanExtensionManifest(V.location);if(M){M.publisher||(M.publisher=m.UNDEFINED_PUBLISHER),j=j??M.__metadata,delete M.__metadata;const $=(0,v.getGalleryExtensionId)(M.publisher,M.name),W=j?.id?{id:$,uuid:j.id}:{id:$},q=j?.isSystem?0:V.type,J=q===0||!!j?.isBuiltin;X.ImplicitActivationEvents.updateManifest(M),M=await this.n(V.location,M,ie.createNlsConfiguration(V));const C={type:q,identifier:W,manifest:M,location:V.location,isBuiltin:J,targetPlatform:j?.targetPlatform??"undefined",metadata:j,isValid:!0,validations:[]};return V.validate?this.validate(C,V):C}}catch(M){V.type!==0&&this.j.error(M)}return null}validate(V,j){let M=!0;const $=(0,t.validateExtensionManifest)(j.productVersion,j.productDate,j.location,V.manifest,V.isBuiltin);for(const[W,q]of $)W===N.default.Error&&(M=!1,this.j.error(this.t(j.location,q)));return V.isValid=M,V.validations=$,V}async scanExtensionManifest(V){const j=(0,w.joinPath)(V,"package.json");let M;try{M=(await this.i.readFile(j)).value.toString()}catch(W){return(0,s.toFileOperationResult)(W)!==1&&this.j.error(this.t(V,(0,p.localize)(0,null,j.path,W.message))),null}let $;try{$=JSON.parse(M)}catch{const q=[];(0,S.parse)(M,q);for(const J of q)this.j.error(this.t(V,(0,p.localize)(1,null,j.path,J.offset,J.length,(0,g.getParseErrorMessage)(J.error))));return null}return(0,S.getNodeType)($)!=="object"?(this.j.error(this.t(V,(0,p.localize)(2,null,j.path))),null):$}async n(V,j,M){const $=await this.p(V,j,M);if($)try{const W=[],q=await this.r($.default,W);if(W.length>0)return W.forEach(C=>{this.j.error(this.t(V,(0,p.localize)(3,null,$.default?.path,(0,g.getParseErrorMessage)(C.error))))}),j;if((0,S.getNodeType)($)!=="object")return this.j.error(this.t(V,(0,p.localize)(4,null,$.default?.path))),j;const J=$.values||Object.create(null);return(0,F.localizeManifest)(j,J,q)}catch{}return j}async p(V,j,M){const $=(0,w.joinPath)(V,"package.nls.json"),W=(L,T)=>{T.forEach(U=>{this.j.error(this.t(V,(0,p.localize)(5,null,L?.path,(0,g.getParseErrorMessage)(U.error))))})},q=L=>{this.j.error(this.t(V,(0,p.localize)(6,null,L?.path)))},J=`${j.publisher}.${j.name}`,C=M.translations[J];if(C)try{const L=f.URI.file(C),T=(await this.i.readFile(L)).value.toString(),U=[],z=(0,S.parse)(T,U);return U.length>0?(W(L,U),{values:void 0,default:$}):(0,S.getNodeType)(z)!=="object"?(q(L),{values:void 0,default:$}):{values:z.contents?z.contents.package:void 0,default:$}}catch{return{values:void 0,default:$}}else{if(!await this.i.exists($))return;let T;try{T=await this.s(V,M)}catch{return}if(!T.localized)return{values:void 0,default:T.original};try{const U=(await this.i.readFile(T.localized)).value.toString(),z=[],G=(0,S.parse)(U,z);return z.length>0?(W(T.localized,z),{values:void 0,default:T.original}):(0,S.getNodeType)(G)!=="object"?(q(T.localized),{values:void 0,default:T.original}):{values:G,default:T.original}}catch{return{values:void 0,default:T.original}}}}async r(V,j){if(V)try{const M=(await this.i.readFile(V)).value.toString();return(0,S.parse)(M,j)}catch{}}s(V,j){return new Promise((M,$)=>{const W=q=>{const J=(0,w.joinPath)(V,`package.nls.${q}.json`);this.i.exists(J).then(C=>{C&&M({localized:J,original:(0,w.joinPath)(V,"package.nls.json")});const L=q.lastIndexOf("-");L===-1?M({localized:(0,w.joinPath)(V,"package.nls.json"),original:null}):(q=q.substring(0,L),W(q))})};if(j.devMode||j.pseudo||!j.language)return M({localized:(0,w.joinPath)(V,"package.nls.json"),original:null});W(j.language)})}t(V,j){return`[${V.path}]: ${j}`}};ne=he([Z(1,l.IExtensionsProfileScannerService),Z(2,A.IUriIdentityService),Z(3,s.IFileService),Z(4,n.ILogService)],ne);let ae=class extends ne{constructor(V,j,M,$,W,q){super(j,M,$,W,q),this.y=V,this.v=this.B(new R.ThrottledDelayer(3e3)),this.w=this.B(new o.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(V){const j=await this.z();if(this.u=V,j&&j.input&&ie.equals(j.input,this.u))return this.j.debug("Using cached extensions scan result",V.location.toString()),this.v.trigger(()=>this.D()),j.result.map($=>($.location=f.URI.revive($.location),$));const M=await super.scanExtensions(V);return await this.C({input:V,result:M}),M}async z(){try{const V=await this.i.readFile(this.y),j=JSON.parse(V.value.toString());return{result:j.result,input:(0,a.revive)(j.input)}}catch(V){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,D.getErrorMessage)(V))}return null}async C(V){try{await this.i.writeFile(this.y,k.VSBuffer.fromString(JSON.stringify(V)))}catch(j){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,D.getErrorMessage)(j))}}async D(){if(!this.u)return;const V=await this.z();if(!V)return;const j=V.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!P.equals(M,j))try{await this.i.del(this.y),this.w.fire()}catch($){this.j.error($)}}};ae=he([Z(2,l.IExtensionsProfileScannerService),Z(3,A.IUriIdentityService),Z(4,s.IFileService),Z(5,n.ILogService)],ae);function fe(ve,V){const j=(0,v.getExtensionId)(ve.manifest.publisher,ve.manifest.name);return{id:j,identifier:new m.ExtensionIdentifier(j),isBuiltin:ve.type===0,isUserBuiltin:ve.type===1&&ve.isBuiltin,isUnderDevelopment:V,extensionLocation:ve.location,uuid:ve.identifier.uuid,targetPlatform:ve.targetPlatform,...ve.manifest}}e.toExtensionDescription=fe;class oe extends te{constructor(V,j,M,$,W,q,J,C,L,T,U,z){super(V,j,(0,w.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,w.joinPath)($,m.MANIFEST_CACHE_FOLDER),W,q,J,C,L,T,U,z),this.M=(async()=>{if(d.translationsConfigFile)try{const G=await this.r.readFile(f.URI.file(d.translationsConfigFile));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(V){return this.M}}e.NativeExtensionsScannerService=oe}),define(Q[148],_([0,1,57,5,34,4,2,16,15,20,6,22]),function(x,e,O,R,P,k,D,S,g,u,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends D.Disposable{constructor(y,N){super(),this.b=y,this.f=N,this.a=new R.Limiter(5)}async postUninstall(y){const N=this.g(y,"uninstall");N&&(this.f.info(y.identifier.id,y.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(N.script,"uninstall",N.args,!0,y),this.f.info("Finished running post uninstall script",y.identifier.id,y.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",y.identifier.id,y.manifest.version),this.f.error(c)}}));try{await u.Promises.rm(this.j(y))}catch(c){this.f.error("Error while removing extension storage path",y.identifier.id),this.f.error(c)}}g(y,N){const c=`vscode:${N}`;if(y.location.scheme===S.Schemas.file&&y.manifest&&y.manifest.scripts&&typeof y.manifest.scripts[c]=="string"){const f=y.manifest.scripts[c].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(y.identifier.id,y.manifest.version,`${c} should be a node script`),null):{script:(0,g.join)(y.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(y,N,c,f,p){return new Promise((b,v)=>{const m=this.i(y,N,c,p);let t;const s=i=>{t&&(clearTimeout(t),t=null),i?v(i):b(void 0)};m.on("error",i=>{s((0,P.toErrorMessage)(i)||"Unknown")}),m.on("exit",(i,n)=>{s(i?`post-${N} process exited with code ${i}`:void 0)}),f&&(t=setTimeout(()=>{t=null,m.kill(),v("timed out")},5e3))})}i(y,N,c,f){const p={silent:!0,execArgv:void 0},b=(0,O.fork)(y,[`--type=extension-post-${N}`,...c],p);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const v=k.Event.fromNodeEventEmitter(b.stdout,"data"),m=k.Event.fromNodeEventEmitter(b.stderr,"data");v(i=>this.f.info(f.identifier.id,f.manifest.version,`post-${N}`,i)),m(i=>this.f.error(f.identifier.id,f.manifest.version,`post-${N}`,i));const t=k.Event.any(k.Event.map(v,i=>({data:`%c${i}`,format:[""]})),k.Event.map(m,i=>({data:`%c${i}`,format:["color: red"]})));return k.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(f.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),b}j(y){return(0,g.join)(this.b.defaultProfile.globalStorageHome.fsPath,y.identifier.id.toLowerCase())}};d=he([Z(0,E.IUserDataProfilesService),Z(1,I.ILogService)],d),e.ExtensionsLifecycle=d}),define(Q[149],_([0,1,6,22,27,25,40,13,17,11]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let I=class extends D.AbstractExtensionsProfileScannerService{constructor(d,w,y,N,c,f){super(u.URI.file(d.extensionsPath),w,y,N,c,f)}};I=he([Z(0,g.INativeEnvironmentService),Z(1,S.IFileService),Z(2,R.IUserDataProfilesService),Z(3,P.IUriIdentityService),Z(4,k.ITelemetryService),Z(5,O.ILogService)],I),e.ExtensionsProfileScannerService=I}),define(Q[150],_([0,1,11,17,40,47,13,10,6,31,27,22]),function(x,e,O,R,P,k,D,S,g,u,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let d=class extends k.NativeExtensionsScannerService{constructor(y,N,c,f,p,b,v,m){super(O.URI.file(p.builtinExtensionsPath),O.URI.file(p.extensionsPath),p.userHome,O.URI.file(p.userDataPath),y,N,c,f,p,b,v,m)}};d=he([Z(0,E.IUserDataProfilesService),Z(1,P.IExtensionsProfileScannerService),Z(2,D.IFileService),Z(3,g.ILogService),Z(4,R.INativeEnvironmentService),Z(5,u.IProductService),Z(6,I.IUriIdentityService),Z(7,S.IInstantiationService)],d),e.ExtensionsScannerService=d}),define(Q[151],_([0,1,5,4,2,118,3,84,10,22]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,g.createDecorator)("storageService");var I;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var d;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));function w(p){const b=p.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=w;class y extends P.Disposable{constructor(b={flushInterval:y.a}){super(),this.j=b,this.b=this.B(new R.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new R.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new O.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new P.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,O.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,P.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.J()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,v){if(v===e.TARGET_KEY){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:v,target:this.F(b)[v]})}r(b){this.f.fire({reason:b})}get(b,v,m){return this.L(v)?.get(b,m)}getBoolean(b,v,m){return this.L(v)?.getBoolean(b,m)}getNumber(b,v,m){return this.L(v)?.getNumber(b,m)}store(b,v,m,t){if((0,D.isUndefinedOrNull)(v)){this.remove(b,m);return}this.t(()=>{this.u(b,m,t),this.L(m)?.set(b,v)})}remove(b,v){this.t(()=>{this.u(b,v,void 0),this.L(v)?.delete(b)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,v){const m=[],t=this.F(b);for(const s of Object.keys(t))t[s]===v&&m.push(s);return m}u(b,v,m){const t=this.F(v);typeof m=="number"?t[b]!==m&&(t[b]=m,this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.L(v)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const v=this.L(b);return v?w(v):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=I.NONE){this.f.fire({reason:b});const v=this.L(-1),m=this.L(0),t=this.L(1);switch(b){case I.NONE:await O.Promises.settled([v?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await O.Promises.settled([v?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,v=this.L(0)?.items??new Map,m=this.L(1)?.items??new Map;return f(b,v,m,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,v){return this.r(I.NONE),(0,u.isUserDataProfile)(b)?this.N(b,v):this.O(b,v)}H(b,v){return!(b.id===v.id||N(v)&&N(b))}I(b,v,m,t){this.t(()=>{if(t)for(const[s,i]of b)v.set(s,i);else{const s=new Set;for(const[i,n]of b)s.add(i),v.get(i)!==n&&this.n(m,i);for(const[i]of v.items)s.has(i)||this.n(m,i)}})}}y.a=60*1e3,e.AbstractStorageService=y;function N(p){return p.isDefault||!!p.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=N;class c extends y{constructor(){super(),this.p=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.Storage(new S.InMemoryStorageDatabase,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.InMemoryStorageService=c;async function f(p,b,v,m,t,s){const i=X=>{try{return JSON.parse(X)}catch{return X}},n=new Map,r=new Map;p.forEach((X,ee)=>{n.set(ee,X),r.set(ee,i(X))});const o=new Map,a=new Map;b.forEach((X,ee)=>{o.set(ee,X),a.set(ee,i(X))});const l=new Map,h=new Map;v.forEach((X,ee)=>{l.set(ee,X),h.set(ee,i(X))}),console.group(m!==t?`Storage: Application (path: ${m})`:`Storage: Application & Profile (path: ${m}, default profile)`);const A=[];if(n.forEach((X,ee)=>{A.push({key:ee,value:X})}),console.table(A),console.groupEnd(),console.log(r),m!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const X=[];o.forEach((ee,te)=>{X.push({key:te,value:ee})}),console.table(X),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${s})`);const F=[];l.forEach((X,ee)=>{F.push({key:ee,value:X})}),console.table(F),console.groupEnd(),console.log(h)}e.logStorage=f}),define(Q[152],_([0,1,19,23,7,12,35,3,11,24,17,21,26,44,13,6,31,46,137,151,25]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const m=k.isWeb?"web":(0,E.getTargetPlatform)(k.platform,D.arch),t="X-Market-Search-Activity-Id";var s;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished",L[L.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...L){return String(L.reduce((T,U)=>T|U,0))}var n;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},l={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(T=l){this.d=T}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(T,U=this.d.pageSize){return new h({...this.d,pageNumber:T,pageSize:U})}withFilter(T,...U){const z=[...this.d.criteria,...U.length?U.map(G=>({filterType:T,value:G})):[{filterType:T}]];return new h({...this.d,criteria:z})}withSortBy(T){return new h({...this.d,sortBy:T})}withSortOrder(T){return new h({...this.d,sortOrder:T})}withFlags(...T){return new h({...this.d,flags:T.reduce((U,z)=>U|z,0)})}withAssetTypes(...T){return new h({...this.d,assetTypes:T})}withSource(T){return new h({...this.d,source:T})}get raw(){const{criteria:T,pageNumber:U,pageSize:z,sortBy:G,sortOrder:H,flags:re,assetTypes:le}=this.d;return{filters:[{criteria:T,pageNumber:U,pageSize:z,sortBy:G,sortOrder:H}],assetTypes:le,flags:re}}get searchText(){const T=this.d.criteria.filter(U=>U.filterType===n.SearchText)[0];return T&&T.value?T.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(T=>String(T.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function A(L,T){const U=(L||[]).filter(z=>z.statisticName===T)[0];return U?U.value:0}function F(L){const T="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(z=>z.assetType.indexOf(T)===0).reduce((z,G)=>{const H=te(L,G.assetType);return H&&z.push([G.assetType.substring(T.length),H]),z},[])}function X(L){if(L.properties){const T=L.properties.filter(G=>G.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=T.filter(G=>U.test(G.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return te(L,r.Repository)}function ee(L){return{uri:`${L.fallbackAssetUri}/${r.VSIX}?redirect=true${L.targetPlatform?`&targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${r.VSIX}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}}function te(L,T){return L.files.filter(z=>z.assetType===T)[0]?{uri:`${L.assetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`,fallbackUri:`${L.fallbackAssetUri}/${T}${L.targetPlatform?`?targetPlatform=${L.targetPlatform}`:""}`}:null}function ie(L,T){const U=L.properties?L.properties.filter(G=>G.key===T):[],z=U.length>0&&U[0].value;return z?z.split(",").map(G=>(0,d.adoptToGalleryExtensionId)(G)):[]}function ne(L){const T=L.properties?L.properties.filter(U=>U.key===o.Engine):[];return T.length>0&&T[0].value||""}function ae(L){const T=L.properties?L.properties.filter(U=>U.key===o.PreRelease):[];return T.length>0&&T[0].value==="true"}function fe(L){const T=L.properties?L.properties.filter(z=>z.key===o.LocalizedLanguages):[],U=T.length>0&&T[0].value||"";return U?U.split(","):[]}function oe(L){return L.properties?.find(T=>T.key===o.SponsorLink)?.value}function ve(L){return L.indexOf("preview")!==-1}function V(L){return L.targetPlatform?(0,E.toTargetPlatform)(L.targetPlatform):"undefined"}function j(L){const T=(0,O.distinct)(L.versions.map(V)),U=!!L.tags?.includes(E.WEB_EXTENSION_TAG),z=T.indexOf("web");return U?z===-1&&T.push("web"):z!==-1&&T.splice(z,1),T}function M(L,T){const U=(0,E.getFallbackTargetPlarforms)(T);for(let z=0;z<L.length;z++){const G=L[z];if(G.version===L[z-1]?.version){let H=z;const re=V(G);if(re===T)for(;H>0&&L[H-1].version===G.version;)H--;else if(U.includes(re))for(;H>0&&L[H-1].version===G.version&&V(L[H-1])!==T;)H--;H!==z&&(L.splice(z,1),L.splice(H,0,G))}}return L}e.sortExtensionVersions=M;function $(L,T,U){L.telemetryData={index:T,querySource:U,queryActivityId:L.queryContext?.[t]}}function W(L,T,U,z){const G=L.versions[0],H={manifest:te(T,r.Manifest),readme:te(T,r.Details),changelog:te(T,r.Changelog),license:te(T,r.License),repository:X(T),download:ee(T),icon:te(T,r.Icon),signature:te(T,r.Signature),coreTranslations:F(T)};return{identifier:{id:(0,d.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:T.version,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,publisherDomain:L.publisher.domain?{link:L.publisher.domain,verified:!!L.publisher.isDomainVerified}:void 0,publisherSponsorLink:oe(G),description:L.shortDescription||"",installCount:A(L.statistics,"install"),rating:A(L.statistics,"averagerating"),ratingCount:A(L.statistics,"ratingcount"),categories:L.categories||[],tags:L.tags||[],releaseDate:Date.parse(L.releaseDate),lastUpdated:Date.parse(L.lastUpdated),allTargetPlatforms:U,assets:H,properties:{dependencies:ie(T,o.Dependency),extensionPack:ie(T,o.ExtensionPack),engine:ne(T),localizedLanguages:fe(T),targetPlatform:V(T),isPreReleaseVersion:ae(T)},hasPreReleaseVersion:ae(G),hasReleaseVersion:!0,preview:ve(L.flags),isSigned:!!H.signature,queryContext:z}}let q=class{constructor(T,U,z,G,H,re,le,ye){this.k=U,this.l=z,this.n=G,this.o=H,this.q=re,this.u=le,this.w=ye;const me=le.extensionsGallery,ce=me?.servicePPEUrl&&ye.getValue("_extensionsGallery.enablePPE");this.d=ce?me.servicePPEUrl:me?.serviceUrl,this.g=ce?void 0:me?.searchUrl,this.h=me?.controlUrl,this.j=(0,p.resolveMarketplaceHeaders)(le.version,le,this.n,this.w,this.q,T,this.o)}x(T=""){return`${this.d}${T}`}isEnabled(){return!!this.d}async getExtensions(T,U,z){const G=R.CancellationToken.isCancellationToken(U)?{}:U,H=R.CancellationToken.isCancellationToken(U)?U:z,re=[],le=[],ye=[],me=[];let ce=!0;for(const ue of T){ue.uuid?le.push(ue.uuid):re.push(ue.id);const we=!!(ue.version||ue.preRelease);ye.push({id:ue.id,uuid:ue.uuid,includePreRelease:we}),ue.version&&me.push({id:ue.id,uuid:ue.uuid,version:ue.version}),ce=ce&&!!ue.hasPreRelease&&!we}if(!le.length&&!re.length)return[];let ge=new h().withPage(1,T.length);le.length&&(ge=ge.withFilter(n.ExtensionId,...le)),re.length&&(ge=ge.withFilter(n.ExtensionName,...re)),(G.queryAllVersions||ce)&&(ge=ge.withFlags(ge.flags,s.IncludeVersions)),G.source&&(ge=ge.withSource(G.source));const{extensions:se}=await this.z(ge,{targetPlatform:G.targetPlatform??m,includePreRelease:ye,versions:me,compatible:!!G.compatible},H);return G.source&&se.forEach((ue,we)=>$(ue,we,G.source)),se}async getCompatibleExtension(T,U,z){if((0,E.isNotWebExtensionInWebTargetPlatform)(T.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(T,U,z))return T;const G=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,T.identifier.uuid),{extensions:H}=await this.z(G,{targetPlatform:z,compatible:!0,includePreRelease:U},R.CancellationToken.None);return H[0]||null}async isExtensionCompatible(T,U,z){if(!(0,E.isTargetPlatformCompatible)(T.properties.targetPlatform,T.allTargetPlatforms,z)||!U&&T.properties.isPreReleaseVersion)return!1;let G=T.properties.engine;if(!G){const H=await this.getManifest(T,R.CancellationToken.None);if(!H)throw new Error("Manifest was not found");G=H.engines.vscode}return(0,w.isEngineValid)(G,this.u.version,this.u.date)}async y(T,U,z,G,H){if(!(0,E.isTargetPlatformCompatible)(V(T),G,H)||U!=="any"&&ae(T)!==(U==="prerelease"))return!1;if(z)try{const re=await this.E(T);if(!(0,w.isEngineValid)(re,this.u.version,this.u.date))return!1}catch(re){return this.l.error(`Error while getting the engine for the version ${T.version}.`,(0,P.getErrorMessage)(re)),!1}return!0}async query(T,U){let z=T.text||"";const G=T.pageSize??50;let H=new h().withPage(1,G);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,ge,se)=>(H=H.withFilter(n.Category,se||ge),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ce,ge,se)=>(H=H.withFilter(n.Tag,se||ge),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(n.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),H=H.withFilter(n.SearchText,z)),H=H.withSortBy(0)):T.ids?H=H.withFilter(n.ExtensionId,...T.ids):T.names?H=H.withFilter(n.ExtensionName,...T.names):H=H.withSortBy(4),typeof T.sortBy=="number"&&(H=H.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(H=H.withSortOrder(T.sortOrder)),T.source&&(H=H.withSource(T.source));const re=async(ce,ge)=>{const{extensions:se,total:ue}=await this.z(ce,{targetPlatform:m,compatible:!1,includePreRelease:!!T.includePreRelease},ge);return se.forEach((we,Pe)=>$(we,(ce.pageNumber-1)*ce.pageSize+Pe,T.source)),{extensions:se,total:ue}},{extensions:le,total:ye}=await re(H,U),me=async(ce,ge)=>{if(ge.isCancellationRequested)throw new P.CancellationError;const{extensions:se}=await re(H.withPage(ce+1),ge);return se};return{firstPage:le,total:ye,pageSize:H.pageSize,getPage:me}}async z(T,U,z){const G=T.flags;!!(T.flags&s.IncludeLatestVersionOnly)&&!!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(T.flags&s.IncludeLatestVersionOnly)&&!(T.flags&s.IncludeVersions)&&(T=T.withFlags(T.flags,s.IncludeLatestVersionOnly)),U.versions?.length&&(T=T.withFlags(T.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),T=T.withFlags(T.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:H,total:re,context:le}=await this.B(T,z);if(!(T.flags&s.IncludeLatestVersionOnly)){const ge=[];for(const se of H){const ue=await this.A(se,U,le);ue&&ge.push(ue)}return{extensions:ge,total:re}}const me=[],ce=new Map;for(let ge=0;ge<H.length;ge++){const se=H[ge],ue={id:(0,d.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},we=(0,S.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(je=>(0,d.areSameExtensions)(je,ue))?.includePreRelease;if(U.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(j(se),U.targetPlatform))continue;const Pe=await this.A(se,U,le);!Pe||Pe.properties.isPreReleaseVersion&&(!we||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==U.targetPlatform&&Pe.hasPreReleaseVersion?ce.set(se.extensionId,ge):me.push([ge,Pe])}if(ce.size){const ge=new Date().getTime(),se=new h().withFlags(G&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ce.size).withFilter(n.ExtensionId,...ce.keys()),{extensions:ue}=await this.z(se,U,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ge,count:ce.size});for(const we of ue){const Pe=ce.get(we.identifier.uuid);me.push([Pe,we])}}return{extensions:me.sort((ge,se)=>ge[0]-se[0]).map(([,ge])=>ge),total:re}}async A(T,U,z){const G={id:(0,d.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},H=U.versions?.find(me=>(0,d.areSameExtensions)(me,G))?.version,re=(0,S.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(me=>(0,d.areSameExtensions)(me,G))?.includePreRelease,le=j(T),ye=M(T.versions,U.targetPlatform);if(U.compatible&&(0,E.isNotWebExtensionInWebTargetPlatform)(le,U.targetPlatform))return null;for(let me=0;me<ye.length;me++){const ce=ye[me];if(!(H&&ce.version!==H)){if(await this.y(ce,re?"any":"release",U.compatible,le,U.targetPlatform))return W(T,ce,le,z);if(H&&ce.version===H)return null}}return H||U.compatible?null:W(T,T.versions[0],le)}async B(T,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");T=T.withFlags(T.flags,s.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(s.Unpublished));const z=await this.j,G=JSON.stringify(T.raw),H={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},re=new Date().getTime();let le,ye,me=0;try{if(le=await this.k.request({type:"POST",url:this.g&&T.criteria.some(ge=>ge.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:H},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:me};const ce=await(0,f.asJson)(le);if(ce){const ge=ce.results[0],se=ge.extensions,ue=ge.resultMetadata&&ge.resultMetadata.filter(we=>we.metadataType==="ResultCount")[0];return me=ue&&ue.metadataItems.filter(we=>we.name==="TotalCount")[0].count||0,{galleryExtensions:se,total:me,context:{[t]:le.res.headers.activityid}}}return{galleryExtensions:[],total:me}}catch(ce){throw ye=ce,ce}finally{this.o.publicLog2("galleryService:query",{...T.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-re,success:!!le&&(0,f.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:ye?(0,P.isCancellationError)(ye)?"canceled":(0,P.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(me)})}}async reportStatistic(T,U,z,G){if(!this.isEnabled())return;const H=k.isWeb?this.x(`/itemName/${T}.${U}/version/${z}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${T}/extensions/${U}/${z}/stats?statType=${G}`),re=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ye={...await this.j,Accept:re};try{await this.k.request({type:"POST",url:H,headers:ye},R.CancellationToken.None)}catch{}}async download(T,U,z){this.l.trace("ExtensionGalleryService#download",T.identifier.id);const G=(0,d.getGalleryExtensionTelemetryData)(T),H=new Date().getTime(),re=ge=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ge}),le=z===2?"install":z===3?"update":"",ye=le?{uri:`${T.assets.download.uri}${g.URI.parse(T.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${T.assets.download.fallbackUri}${g.URI.parse(T.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:T.assets.download,me=T.queryContext?.[t]?{[t]:T.queryContext[t]}:void 0,ce=await this.D(ye,me?{headers:me}:void 0);await this.q.writeFile(U,ce.stream),re(new Date().getTime()-H)}async downloadSignatureArchive(T,U){if(!T.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",T.identifier.id);const z=await this.D(T.assets.signature);await this.q.writeFile(U,z.stream)}async getReadme(T,U){if(T.assets.readme){const z=await this.D(T.assets.readme,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getManifest(T,U){if(T.assets.manifest){const z=await this.D(T.assets.manifest,{},U),G=await(0,f.asTextOrError)(z);return G?JSON.parse(G):null}return null}async C(T,U){const z=te(T,r.Manifest);if(!z)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},H=await this.D(z,{headers:G});return await(0,f.asJson)(H)}async getCoreTranslation(T,U){const z=T.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(z){const G=await this.D(z[1]),H=await(0,f.asTextOrError)(G);return H?JSON.parse(H):null}return null}async getChangelog(T,U){if(T.assets.changelog){const z=await this.D(T.assets.changelog,{},U);return await(0,f.asTextOrError)(z)||""}return""}async getAllCompatibleVersions(T,U,z){let G=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);T.identifier.uuid?G=G.withFilter(n.ExtensionId,T.identifier.uuid):G=G.withFilter(n.ExtensionName,T.identifier.id);const{galleryExtensions:H}=await this.B(G,R.CancellationToken.None);if(!H.length)return[];const re=j(H[0]);if((0,E.isNotWebExtensionInWebTargetPlatform)(re,z))return[];const le=[];await Promise.all(H[0].versions.map(async ce=>{try{await this.y(ce,U?"any":"release",!0,re,z)&&le.push(ce)}catch{}}));const ye=[],me=new Set;for(const ce of M(le,z))me.has(ce.version)||(me.add(ce.version),ye.push({version:ce.version,date:ce.lastUpdated,isPreReleaseVersion:ae(ce)}));return ye}async D(T,U={},z=R.CancellationToken.None){const G=await this.j,H={type:"GET"},re={...G,...U.headers||{}};U={...U,...H,headers:re};const le=T.uri,ye=T.fallbackUri,me={...U,url:le};try{const ce=await this.k.request(me,z);if(ce.res.statusCode===200)return ce;const ge=await(0,f.asTextOrError)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ge}`)}catch(ce){if((0,P.isCancellationError)(ce))throw ce;const ge=(0,P.getErrorMessage)(ce);this.o.publicLog2("galleryService:cdnFallback",{url:le,message:ge});const se={...U,url:ye};return this.k.request(se,z)}}async E(T){let U=ne(T);if(!U){const z=await this.C(T,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");U=z.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const T=await this.k.request({type:"GET",url:this.h},R.CancellationToken.None);if(T.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.asJson)(T),z=[],G={};if(U){for(const H of U.malicious)z.push({id:H});if(U.migrateToPreRelease)for(const[H,re]of Object.entries(U.migrateToPreRelease))(!re.engine||(0,w.isEngineValid)(re.engine,this.u.version,this.u.date))&&(G[H.toLowerCase()]={disallowInstall:!0,extension:{id:re.id,displayName:re.displayName,autoMigrate:{storage:!!re.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[H,re]of Object.entries(U.deprecated))re&&(G[H.toLowerCase()]=(0,S.isBoolean)(re)?{}:re)}return{malicious:z,deprecated:G}}};q=he([Z(1,f.IRequestService),Z(2,N.ILogService),Z(3,I.IEnvironmentService),Z(4,v.ITelemetryService),Z(5,y.IFileService),Z(6,c.IProductService),Z(7,u.IConfigurationService)],q);let J=class extends q{constructor(T,U,z,G,H,re,le,ye){super(T,U,z,G,H,re,le,ye)}};J=he([Z(0,b.IStorageService),Z(1,f.IRequestService),Z(2,N.ILogService),Z(3,I.IEnvironmentService),Z(4,v.ITelemetryService),Z(5,y.IFileService),Z(6,c.IProductService),Z(7,u.IConfigurationService)],J),e.ExtensionGalleryService=J;let C=class extends q{constructor(T,U,z,G,H,re,le){super(void 0,T,U,z,G,H,re,le)}};C=he([Z(0,f.IRequestService),Z(1,N.ILogService),Z(2,I.IEnvironmentService),Z(3,v.ITelemetryService),Z(4,y.IFileService),Z(5,c.IProductService),Z(6,u.IConfigurationService)],C),e.ExtensionGalleryServiceWithNoStorageService=C}),define(Q[153],_([0,1,11,17,13,6,133,27,22,3,67]),function(x,e,O,R,P,k,D,S,g,u,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let E=class $e extends g.UserDataProfilesService{constructor(N,c,f,p,b){super(f,p,c,b),this.O=N,this.P=f}I(){return this.O.getItem($e.b,[]).map(c=>({...c,location:(0,u.isString)(c.location)?this.r.extUri.joinPath(this.profilesHome,c.location):O.URI.revive(c.location)}))}L(){const N=this.O.getItem($e.c,{});return this.O.getItem($e.a,!1)?N:this.H(N)}N(){return this.r.extUri.joinPath(O.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};E.a="profileAssociationsMigration",E=he([Z(0,D.IStateReadService),Z(1,S.IUriIdentityService),Z(2,R.INativeEnvironmentService),Z(3,P.IFileService),Z(4,k.ILogService)],E),e.UserDataProfilesReadonlyService=E;let d=class ze extends E{constructor(N,c,f,p,b){super(N,c,f,p,b),this.U=N}J(N){N.length?this.U.setItem(ze.b,N.map(c=>({...c,location:this.r.extUri.basename(c.location)}))):this.U.removeItem(ze.b)}I(){const N=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(N),this.U.setItem("userDataProfilesMigration",!0)),N}M(N){N.emptyWindows||N.workspaces?this.U.setItem(ze.c,N):this.U.removeItem(ze.c)}L(){const N="workspaceAndProfileInfo",c=this.U.getItem(N,void 0);if(c){this.U.removeItem(N);const p=c.reduce((b,{workspace:v,profile:m})=>(b[O.URI.revive(v).toString()]=O.URI.revive(m).toString(),b),{});this.U.setItem(ze.c,{workspaces:p})}const f=super.L();return this.U.getItem(ze.a,!1)||(this.M(f),this.U.setItem(ze.a,!0)),f}};d=he([Z(0,D.IStateService),Z(1,S.IUriIdentityService),Z(2,R.INativeEnvironmentService),Z(3,P.IFileService),Z(4,k.ILogService)],d),e.UserDataProfilesService=d;let w=class extends d{constructor(N,c,f,p){super(new I.StateService(0,c,p,f),N,c,f,p)}async init(){return await this.U.init(),super.init()}};w=he([Z(0,S.IUriIdentityService),Z(1,R.INativeEnvironmentService),Z(2,P.IFileService),Z(3,k.ILogService)],w),e.ServerUserDataProfilesService=w}),define(Q[69],_([0,1,120,5,15,3,20,85,167,168]),function(x,e,O,R,P,k,D,S,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(t,s){let i=s.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=t,this.cause=s}}e.ExtractError=I;function E(m){const t=m.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,i)=>s+i,t&61440)}function d(m){if(m instanceof I)return m;let t;return/end of central directory record signature not found/.test(m.message)&&(t="CorruptZip"),new I(t,m)}function w(m,t,s,i,n,r){const o=P.dirname(t),a=P.join(i,o);if(!a.startsWith(i))return Promise.reject(new Error(S.localize(0,null,t)));const l=P.join(i,t);let h;return r.onCancellationRequested(()=>{h?.destroy()}),Promise.resolve(D.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((A,F)=>{if(!r.isCancellationRequested)try{h=(0,O.createWriteStream)(l,{mode:s}),h.once("close",()=>A()),h.once("error",F),m.once("error",F),m.pipe(h)}catch(X){F(X)}}))}function y(m,t,s,i){let n=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return i.onCancellationRequested(()=>{n.cancel(),m.close()}),new Promise((o,a)=>{const l=new R.Sequencer,h=A=>{A.isCancellationRequested||(r++,m.readEntry())};m.once("error",a),m.once("close",()=>n.then(()=>{i.isCancellationRequested||m.entryCount===r?o():a(new I("Incomplete",new Error(S.localize(1,null,r,m.entryCount))))},a)),m.readEntry(),m.on("entry",A=>{if(i.isCancellationRequested)return;if(!s.sourcePathRegex.test(A.fileName)){h(i);return}const F=A.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(F)){const te=P.join(t,F);n=(0,R.createCancelablePromise)(ie=>D.Promises.mkdir(te,{recursive:!0}).then(()=>h(ie)).then(void 0,a));return}const X=c(m,A),ee=E(A);n=(0,R.createCancelablePromise)(te=>l.queue(()=>X.then(ie=>w(ie,F,ee,t,s,te).then(()=>h(te)))).then(null,a))})})}function N(m,t=!1){return new Promise((s,i)=>{(0,g.open)(m,t?{lazyEntries:!0}:void 0,(n,r)=>{n?i(d(n)):s((0,k.assertIsDefined)(r))})})}function c(m,t){return new Promise((s,i)=>{m.openReadStream(t,(n,r)=>{n?i(d(n)):s((0,k.assertIsDefined)(r))})})}function f(m,t){return new Promise((s,i)=>{const n=new u.ZipFile;t.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const r=(0,O.createWriteStream)(m);n.outputStream.pipe(r),n.outputStream.once("error",i),r.once("error",i),r.once("finish",()=>s(m))})}e.zip=f;function p(m,t,s={},i){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=N(m,!0);return s.overwrite&&(r=r.then(o=>D.Promises.rm(t).then(()=>o))),r.then(o=>y(o,t,{sourcePathRegex:n},i))}e.extract=p;function b(m,t){return N(m).then(s=>new Promise((i,n)=>{s.on("entry",r=>{r.fileName===t&&c(s,r).then(o=>i(o),o=>n(o))}),s.once("close",()=>n(new Error(S.localize(2,null,t))))}))}function v(m,t){return b(m,t).then(s=>new Promise((i,n)=>{const r=[];s.once("error",n),s.on("data",o=>r.push(o)),s.on("end",()=>i(Buffer.concat(r)))}))}e.buffer=v}),define(Q[154],_([0,1,69,93]),function(x,e,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function P(k){return(0,O.buffer)(k,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}e.getManifest=P}),define(Q[155],_([0,1,5,14,23,34,7,4,2,36,16,15,12,18,41,3,11,29,20,69,92,58,17,147,21,26,40,47,135,148,154,128,136,32,44,13,10,6,31,25,27,22]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p,b,v,m,t,s,i,n,r,o,a,l,h,A,F,X,ee,te,ie,ne,ae,fe,oe,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ie.refineServiceDecorator)(i.IExtensionManagementService);let V=class extends s.AbstractExtensionManagementService{constructor(C,L,T,U,z,G,H,re,le,ye,me,ce){super(C,L,T,ye,ce),this.Z=z,this.ab=G,this.bb=H,this.cb=le,this.db=me,this.X=this.B(new S.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new u.ResourceSet;const ge=this.B(re.createInstance(l.ExtensionsLifecycle));this.S=this.B(re.createInstance(j,ue=>ge.postUninstall(ue))),this.U=this.B(new A.ExtensionsManifestCache(U,this)),this.W=this.B(re.createInstance(a.ExtensionsDownloader));const se=this.B(new F.ExtensionsWatcher(this,this.Z,ce,G,me,le,T));this.B(se.onDidChangeExtensionsByAnotherSource(ue=>this.kb(ue))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(C){this.v.trace("ExtensionManagementService#zip",C.identifier.id);const L=await this.jb(C),T=await(0,b.zip)((0,w.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)()).fsPath,L);return c.URI.file(T)}async unzip(C){return this.v.trace("ExtensionManagementService#unzip",C.toString()),(await this.install(C)).identifier}async getManifest(C){const{location:L,cleanup:T}=await this.fb(C),U=E.resolve(L.fsPath);try{return await(0,h.getManifest)(U)}finally{await T()}}getInstalled(C,L=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(C??null,L)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(C){return this.S.scanUserExtensionAtLocation(C)}async install(C,L={}){this.v.trace("ExtensionManagementService#install",C.toString());const{location:T,cleanup:U}=await this.fb(C);try{const z=await(0,h.getManifest)(E.resolve(T.fsPath));if(z.engines&&z.engines.vscode&&!(0,ee.isEngineValid)(z.engines.vscode,this.w.version,this.w.date))throw new Error(v.localize(0,null,(0,n.getGalleryExtensionId)(z.publisher,z.name),this.w.version));return await this.z(z,T,L)}finally{await U()}}async installFromLocation(C,L){this.v.trace("ExtensionManagementService#installFromLocation",C.toString());const T=await this.S.scanUserExtensionAtLocation(C);if(!T)throw new Error(`Cannot find a valid extension from the location ${C.toString()}`);return await this.ob([[T,void 0]],L),this.v.info("Successfully installed extension",T.identifier.id,L.toString()),T}async installExtensionsFromProfile(C,L,T){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",C,L.toString(),T.toString());const U=(await this.S.scanExtensions(1,L)).filter(z=>C.some(G=>(0,n.areSameExtensions)(G,z.identifier)));if(U.length){const z=await Promise.all(U.map(G=>this.S.scanMetadata(G,L)));await this.ob(U.map((G,H)=>[G,z[H]]),T),this.v.info("Successfully installed extensions",U.map(G=>G.identifier.id),T.toString())}return U}async updateMetadata(C,L,T=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",C.identifier.id),L.isPreReleaseVersion&&(L.preRelease=!0),L.isMachineScoped=L.isMachineScoped||void 0,L.isBuiltin=L.isBuiltin||void 0,L.pinned=L.pinned||void 0,C=await this.S.updateMetadata(C,L,T),this.U.invalidate(),this.X.fire(C),C}async reinstallFromGallery(C){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",C.identifier.id),!this.t.isEnabled())throw new Error(v.localize(1,null));const L=await this.getTargetPlatform(),[T]=await this.t.getExtensions([{...C.identifier,preRelease:C.preRelease}],{targetPlatform:L,compatible:!0},P.CancellationToken.None);if(!T)throw new Error(v.localize(2,null));await this.S.setUninstalled(C);try{await this.S.removeUninstalledExtension(C)}catch(U){throw new Error(v.localize(3,null,(0,k.toErrorMessage)(U)))}return this.installFromGallery(T)}copyExtensions(C,L){return this.S.copyExtensions(C,L)}markAsUninstalled(...C){return this.S.setUninstalled(...C)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(C){this.v.error(C)}}async download(C,L){const{location:T}=await this.W.download(C,L);return T}async fb(C){if(C.scheme===I.Schemas.file)return{location:C,async cleanup(){}};this.v.trace("Downloading extension from",C.toString());const L=(0,w.joinPath)(this.W.extensionsDownloadDir,(0,f.generateUuid)());return await this.bb.download(C,L),this.v.info("Downloaded extension to",L.toString()),{location:L,cleanup:async()=>{try{await this.cb.del(L)}catch(U){this.v.error(U)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(C,L,T){if(c.URI.isUri(L))return new W(C,L,T,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const U=n.ExtensionKey.create(L).toString();let z=this.Y.get(U);return z||(this.Y.set(U,z=new $(C,L,T,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),z.waitUntilTaskIsFinished().then(()=>this.Y.delete(U))),z}R(C,L){return new q(C,L.profileLocation,this.ab)}async jb(C){const L=async U=>{let z=await p.Promises.readdir(U);z=z.map(re=>E.join(U,re));const G=await Promise.all(z.map(re=>p.Promises.stat(re)));let H=Promise.resolve([]);return G.forEach((re,le)=>{const ye=z[le];re.isFile()&&(H=H.then(me=>[...me,ye])),re.isDirectory()&&(H=H.then(me=>L(ye).then(ce=>[...me,...ce])))}),H};return(await L(C.location.fsPath)).map(U=>({path:`extension/${E.relative(C.location.fsPath,U)}`,localPath:U}))}async kb({added:C,removed:L}){if(L)for(const T of L.extensions)this.v.info("Extensions removed from another source",T.id,L.profileLocation.toString()),this.p.fire({identifier:T,profileLocation:L.profileLocation});if(C){const U=(await this.S.scanExtensions(1,C.profileLocation)).filter(z=>C.extensions.some(G=>(0,n.areSameExtensions)(G,z.identifier)));this.m.fire(U.map(z=>(this.v.info("Extensions added from another source",z.identifier.id,C.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:C.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(L=>this.lb.add(L)));const C=await this.cb.resolve(this.Z.userExtensionsLocation);for(const L of C.children??[])L.isDirectory&&this.lb.add(L.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(L=>this.nb(L)))}async nb(C){if(!C.affects(this.Z.userExtensionsLocation,1))return;const L=[];for(const T of C.rawAdded){if(this.lb.has(T)||!this.db.extUri.isEqual(this.db.extUri.dirname(T),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(T,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(T).startsWith(".")||!(await this.cb.stat(T)).isDirectory)continue;const U=await this.S.scanUserExtensionAtLocation(T);U&&U.installedTimestamp===void 0&&(this.lb.add(T),L.push(U))}L.length&&(await this.ob(L.map(T=>[T,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",L.map(T=>T.identifier.id)))}async ob(C,L){const T=C.map(U=>U[0]);await this.pb(T),await this.ab.addExtensionsToProfile(C,L),this.m.fire(T.map(U=>({local:U,identifier:U.identifier,operation:1,profileLocation:L})))}async pb(C){const L=await this.S.getUninstalledExtensions();for(const T of C){const U=n.ExtensionKey.create(T);!L[U.toString()]||(this.v.trace("Removing the extension from uninstalled list:",U.id),await this.S.setInstalled(U),this.v.info("Removed the extension from uninstalled list:",U.id))}}};V=he([Z(0,i.IExtensionGalleryService),Z(1,fe.ITelemetryService),Z(2,ne.ILogService),Z(3,t.INativeEnvironmentService),Z(4,o.IExtensionsScannerService),Z(5,r.IExtensionsProfileScannerService),Z(6,m.IDownloadService),Z(7,ie.IInstantiationService),Z(8,te.IFileService),Z(9,ae.IProductService),Z(10,oe.IUriIdentityService),Z(11,ve.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let j=class extends g.Disposable{constructor(C,L,T,U,z,G){super(),this.k=C,this.l=L,this.m=T,this.n=U,this.p=z,this.s=G,this.h=this.B(new S.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,w.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new O.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(C,L){const T={includeInvalid:!0,profileLocation:L};let U=[];return C===null||C===0?U.push(...await this.m.scanAllExtensions({includeInvalid:!0},T,!1)):C===1&&U.push(...await this.m.scanUserExtensions(T)),U=C!==null?U.filter(z=>z.type===C):U,Promise.all(U.map(z=>this.y(z)))}async scanAllUserExtensions(C){const L=await this.m.scanUserExtensions({includeAllVersions:!C,includeInvalid:!0});return Promise.all(L.map(T=>this.y(T)))}async scanUserExtensionAtLocation(C){try{const L=await this.m.scanExistingExtension(C,1,{includeInvalid:!0});if(L)return await this.y(L)}catch(L){this.s.error(L)}return null}async extractUserExtension(C,L,T,U){await this.j.catch(()=>{});const z=C.toString(),G=E.join(this.m.userExtensionsLocation.fsPath,`.${(0,f.generateUuid)()}`),H=E.join(this.m.userExtensionsLocation.fsPath,z);try{await p.Promises.rm(H)}catch{throw new i.ExtensionManagementError(v.localize(4,null,H,C.id),i.ExtensionManagementErrorCode.Delete)}await this.u(C,L,G,U),await this.m.updateMetadata(c.URI.file(G),T);try{this.h.fire(c.URI.file(H)),await this.v(C,G,H,Date.now()+2*60*1e3),this.s.info("Renamed to",H)}catch(re){try{await p.Promises.rm(G)}catch{}if(re.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",C.id);else throw this.s.info(`Rename failed because of ${(0,D.getErrorMessage)(re)}. Deleted from extracted location`,G),re}return this.w(c.URI.file(H),1)}async scanMetadata(C,L){return L?(await this.n.scanProfileExtensions(L)).find(U=>(0,n.areSameExtensions)(U.identifier,C.identifier))?.metadata:this.m.scanMetadata(C.location)}async updateMetadata(C,L,T){return T?await this.n.updateMetadata([[C,L]],T):await this.m.updateMetadata(C.location,L),this.w(C.location,C.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...C){const L=C.map(T=>n.ExtensionKey.create(T));await this.t(T=>L.forEach(U=>{T[U.toString()]=!0,this.s.info("Marked extension as uninstalled",U.toString())}))}async setInstalled(C){await this.t(L=>delete L[C.toString()])}async removeExtension(C,L){this.s.trace(`Deleting ${L} extension from disk`,C.identifier.id,C.location.fsPath);const T=this.p.extUri.joinPath(this.p.extUri.dirname(C.location),`.${(0,f.generateUuid)()}`);await this.v(C.identifier,C.location.fsPath,T.fsPath,Date.now()+2*60*1e3),await this.l.del(T,{recursive:!0}),this.s.info("Deleted from disk",C.identifier.id,C.location.fsPath)}async removeUninstalledExtension(C){await this.removeExtension(C,"uninstalled"),await this.t(L=>delete L[n.ExtensionKey.create(C).toString()])}async copyExtensions(C,L){const T=await this.scanExtensions(1,C),U=await Promise.all(T.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,C)]));await this.n.addExtensionsToProfile(U,L)}async t(C){return this.g.queue(async()=>{let L;try{L=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(U){if((0,te.toFileOperationResult)(U)!==1)throw U}let T={};if(L)try{T=JSON.parse(L)}catch{}return C&&(C(T),Object.keys(T).length?await this.l.writeFile(this.c,R.VSBuffer.fromString(JSON.stringify(T))):await this.l.del(this.c)),T})}async u(C,L,T,U){this.s.trace(`Started extracting the extension from ${L} to ${T}`);try{await p.Promises.rm(T)}catch(z){throw new i.ExtensionManagementError(this.D(z).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,b.extract)(L,T,{sourcePath:"extension",overwrite:!0},U),this.s.info(`Extracted extension to ${T}:`,C.id)}catch(z){try{await p.Promises.rm(T)}catch{}let G=i.ExtensionManagementErrorCode.Extract;throw z instanceof b.ExtractError&&(z.type==="CorruptZip"?G=i.ExtensionManagementErrorCode.CorruptZip:z.type==="Incomplete"&&(G=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(z.message,G)}}async v(C,L,T,U){try{await p.Promises.rename(L,T)}catch(z){if(d.isWindows&&z&&z.code==="EPERM"&&Date.now()<U)return this.s.info(`Failed renaming ${L} to ${T} with 'EPERM' error. Trying again...`,C.id),this.v(C,L,T,U);throw new i.ExtensionManagementError(z.message||v.localize(5,null,L,T),z.code||i.ExtensionManagementErrorCode.Rename)}}async w(C,L){const T=await this.m.scanExistingExtension(C,L,{includeInvalid:!0});if(T)return this.y(T);throw new Error(v.localize(6,null,C.path))}async y(C){const L=await this.l.resolve(C.location);let T,U;return L.children&&(T=L.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,U=L.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:C.identifier,type:C.type,isBuiltin:C.isBuiltin||!!C.metadata?.isBuiltin,location:C.location,manifest:C.manifest,targetPlatform:C.targetPlatform,validations:C.validations,isValid:C.isValid,readmeUrl:T,changelogUrl:U,publisherDisplayName:C.metadata?.publisherDisplayName||null,publisherId:C.metadata?.publisherId||null,isApplicationScoped:!!C.metadata?.isApplicationScoped,isMachineScoped:!!C.metadata?.isMachineScoped,isPreReleaseVersion:!!C.metadata?.isPreReleaseVersion,preRelease:!!C.metadata?.preRelease,installedTimestamp:C.metadata?.installedTimestamp,updated:!!C.metadata?.updated,pinned:!!C.metadata?.pinned}}async z(){const C=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(C));const L=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),T=new Set;for(const z of L)C[n.ExtensionKey.create(z).toString()]||T.add(z.identifier.id.toLowerCase());try{const z=(0,n.groupByExtension)(L,G=>G.identifier);await O.Promises.settled(z.map(async G=>{const H=G.sort((re,le)=>y.rcompare(re.manifest.version,le.manifest.version))[0];T.has(H.identifier.id.toLowerCase())||await this.k(await this.y(H))}))}catch(z){this.s.error(z)}const U=L.filter(z=>z.metadata&&C[n.ExtensionKey.create(z).toString()]);await Promise.allSettled(U.map(z=>this.removeUninstalledExtension(z)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const C=[];let L;try{L=await this.l.resolve(this.m.userExtensionsLocation)}catch(T){(0,te.toFileOperationResult)(T)!==1&&this.s.error(T)}for(const T of L?.children??[])T.isDirectory&&T.name.startsWith(".")&&(0,f.isUUID)(T.name.substring(1))&&C.push((async()=>{this.s.trace("Deleting the generated extension folder",T.resource.toString());try{await this.l.del(T.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",T.resource.toString())}catch(U){this.s.error(U)}})());await Promise.allSettled(C)}D(C){const L=Array.isArray(C)?C:[C];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((T,U)=>new Error(`${T.message}${T.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};j=he([Z(1,te.IFileService),Z(2,o.IExtensionsScannerService),Z(3,r.IExtensionsProfileScannerService),Z(4,oe.IUriIdentityService),Z(5,ne.ILogService)],j),e.ExtensionsScanner=j;class M extends s.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,N.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(C,L,T,U,z,G,H,re,le){super(),this.identifier=C,this.source=L,this.l=T,this.m=U,this.n=z,this.o=G,this.p=H,this.q=re,this.s=le,this.j="Unverified",this.k=2}async h(C){const[L,T]=await this.x(C);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[L,T]],this.l.profileLocation),L}async u({zipPath:C,key:L,metadata:T},U){let z=await this.v(L);return z||(this.s.trace("Extracting extension...",L.id),z=await this.m.extractUserExtension(L,C,T,U),this.s.info("Extracting extension completed.",L.id)),z}async v(C){return await this.w(C)?(this.s.trace("Removing the extension from uninstalled list:",C.id),await this.m.setInstalled(C),this.s.info("Removed the extension from uninstalled list:",C.id),(await this.m.scanAllUserExtensions(!0)).find(U=>n.ExtensionKey.create(U).equals(C))):void 0}async w(C){return!!(await this.m.getUninstalledExtensions())[C.toString()]}}class $ extends M{constructor(C,L,T,U,z,G,H,re,le,ye){super(L.identifier,L,T,z,G,H,re,le,ye),this.y=C,this.z=L,this.A=U}async x(C){const T=(await this.m.scanExtensions(null,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(H.identifier,this.z.identifier));T&&(this.k=3);const U={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,X.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||T?.isMachineScoped,isBuiltin:this.l.isBuiltin||T?.isBuiltin,isSystem:T?.type===0?!0:void 0,updated:!!T,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,N.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:T?.preRelease)};if(T?.manifest.version===this.z.version)return[await this.m.updateMetadata(T,U),U];const{location:z,verificationStatus:G}=await this.A.download(this.z,this.k);try{return this.j=G,this.C(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.ExtensionKey.create(this.z),metadata:U},C),U]}catch(H){try{await this.A.delete(z)}catch(re){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,D.getErrorMessage)(re))}throw H}}async C(C){try{await(0,h.getManifest)(C)}catch(L){throw new i.ExtensionManagementError((0,s.joinErrors)(L).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=$;class W extends M{constructor(C,L,T,U,z,G,H,re,le,ye){super({id:(0,n.getGalleryExtensionId)(C.publisher,C.name)},L,T,z,G,H,re,le,ye),this.y=C,this.z=L,this.A=U}async x(C){const L=new n.ExtensionKey(this.identifier,this.y.version),U=(await this.m.scanExtensions(1,this.l.profileLocation)).find(H=>(0,n.areSameExtensions)(this.identifier,H.identifier)),z=await this.C(this.identifier.id,this.y.version,C);if(z.isApplicationScoped=(0,X.isApplicationScopedExtension)(this.y),z.isMachineScoped=this.l.isMachineScoped||U?.isMachineScoped,z.isBuiltin=this.l.isBuiltin||U?.isBuiltin,z.installedTimestamp=Date.now(),z.pinned=this.l.installGivenVersion?!0:void 0,U)if(this.k=3,L.equals(new n.ExtensionKey(U.identifier,U.manifest.version)))try{await this.m.removeExtension(U,"existing")}catch{throw new Error(v.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&y.gt(U.manifest.version,this.y.version)&&await this.m.setUninstalled(U);else{const H=await this.v(L);if(H)try{await this.m.removeExtension(H,"existing")}catch{throw new Error(v.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:E.resolve(this.z.fsPath),key:L,metadata:z},C),z]}async C(C,L,T){try{let[U]=await this.A.getExtensions([{id:C,version:L}],T);if(U||([U]=await this.A.getExtensions([{id:C}],T)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class q extends s.AbstractExtensionTask{constructor(C,L,T){super(),this.extension=C,this.j=L,this.k=T}async h(C){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Q[156],_([0,1,131,5,14,7,2,3,24,17,132,6,130,169]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let y=class extends D.Disposable{constructor(c,f,p){super(),this.h=c,this.i=f,this.j=p,this.k(),this.B(c.onDidChangeConfiguration(b=>{b.affectsConfiguration("http")&&this.k()}))}k(){const c=this.h.getValue("http");this.a=c?.proxy,this.b=!!c?.proxyStrictSSL,this.f=c?.proxyAuthorization}async request(c,f){this.j.trace("RequestService#request (node) - begin",c.url);const{a:p,b}=this;let v;try{v=await(0,I.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(s){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",s))}const m={...process.env,...v},t=c.agent?c.agent:await(0,d.getProxyAgent)(c.url||"",m,{proxyUrl:p,strictSSL:b});c.agent=t,c.strictSSL=b,this.f&&(c.headers={...c.headers||{},"Proxy-Authorization":this.f});try{const s=await this.m(c,f);return this.j.trace("RequestService#request (node) - success",c.url),s}catch(s){throw this.j.trace("RequestService#request (node) - error",c.url,s),s}}async l(c){return((0,O.parse)(c.url).protocol==="https:"?await new Promise((b,v)=>{x(["https"],b,v)}):await new Promise((b,v)=>{x(["http"],b,v)})).request}m(c,f){return R.Promises.withAsyncBody(async(p,b)=>{const v=(0,O.parse)(c.url),m=c.getRawRequest?c.getRawRequest(c):await this.l(c),t={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,S.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password);const s=m(t,i=>{const n=(0,S.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...c,url:i.headers.location,followRedirects:n-1},f).then(p,b);else{let r=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,w.createGunzip)())),p({res:i,stream:(0,P.streamToBufferReadableStream)(r)})}});s.on("error",b),c.timeout&&s.setTimeout(c.timeout),c.isChromiumNetwork&&s.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&s.write(c.data),s.end(),f.onCancellationRequested(()=>{s.abort(),b(new k.CancellationError)})})}async resolveProxy(c){}};y=he([Z(0,g.IConfigurationService),Z(1,u.INativeEnvironmentService),Z(2,E.ILogService)],y),e.RequestService=y}),define(Q[170],_([0,1,33,5,14,34,7,2,16,15,12,35,11,20,24,127,58,129,17,106,152,21,59,134,40,47,155,150,13,117,119,45,115,62,63,138,6,122,123,38,124,141,31,46,156,67,68,25,140,39,142,143,27,145,22,153,144,149,121]),function(x,e,O,R,P,k,D,S,g,u,I,E,d,w,y,N,c,f,p,b,v,m,t,s,i,n,r,o,a,l,h,A,F,X,ee,te,ie,ne,ae,fe,oe,ve,V,j,M,$,W,q,J,C,L,T,U,z,G,H,re,le,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class me extends S.Disposable{constructor(se){super(),this.b=se,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[se,ue]=await this.f();return se.invokeFunction(async we=>{const Pe=we.get(ie.ILogService),je=we.get(a.IFileService),Ue=we.get(p.INativeEnvironmentService),B=we.get(G.IUserDataProfilesService);Pe.info("CLI main",this.b),this.g(Pe),await this.h(Ue,je,B,se),await Promise.all(ue.map(K=>{(0,R.raceTimeout)(K.flush(),1e3)}))})}async f(){const se=new X.ServiceCollection,ue={_serviceBrand:void 0,...ve.default};se.set(V.IProductService,ue);const we=new b.NativeEnvironmentService(this.b,ue);se.set(p.INativeEnvironmentService,we),await Promise.all([we.appSettingsHome.fsPath,we.extensionsPath].map(Me=>Me?w.Promises.mkdir(Me,{recursive:!0}):void 0));const Pe=(0,ie.getLogLevel)(we),je=new ne.SpdLogLogger("cli",(0,u.join)(we.logsPath,"cli.log"),!0,!1,Pe),Ue=[];Pe===ie.LogLevel.Trace&&Ue.push(new ie.ConsoleLogger(Pe));const B=this.B(new ye.LogService(je,Ue));se.set(ie.ILogService,B);const K=this.B(new l.FileService(B));se.set(a.IFileService,K);const Y=this.B(new h.DiskFileSystemProvider(B));K.registerProvider(g.Schemas.file,Y);const de=new z.UriIdentityService(K);se.set(U.IUriIdentityService,de);const pe=new $.StateReadonlyService(1,we,B,K),Oe=new H.UserDataProfilesReadonlyService(pe,de,we,K,B);se.set(G.IUserDataProfilesService,Oe);const be=I.isWindows&&ue.win32RegValueName?this.B(new oe.NativePolicyService(B,ue.win32RegValueName)):we.policyFile?this.B(new ae.FilePolicyService(we.policyFile,K,B)):new fe.NullPolicyService;se.set(fe.IPolicyService,be);const Ne=this.B(new N.ConfigurationService(Oe.defaultProfile.settingsResource,K,be,B));se.set(y.IConfigurationService,Ne),await Promise.all([pe.init(),Ne.initialize()]),Oe.init(),se.set(U.IUriIdentityService,new z.UriIdentityService(K)),se.set(j.IRequestService,new A.SyncDescriptor(M.RequestService,void 0,!0)),se.set(c.IDownloadService,new A.SyncDescriptor(f.DownloadService,void 0,!0)),se.set(i.IExtensionsProfileScannerService,new A.SyncDescriptor(le.ExtensionsProfileScannerService,void 0,!0)),se.set(n.IExtensionsScannerService,new A.SyncDescriptor(o.ExtensionsScannerService,void 0,!0)),se.set(t.IExtensionSignatureVerificationService,new A.SyncDescriptor(t.ExtensionSignatureVerificationService,void 0,!0)),se.set(r.INativeServerExtensionManagementService,new A.SyncDescriptor(r.ExtensionManagementService,void 0,!0)),se.set(m.IExtensionGalleryService,new A.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService,void 0,!0)),se.set(ee.ILanguagePackService,new A.SyncDescriptor(te.NativeLanguagePackService,void 0,!1));const Re=[],Le=(0,C.isInternalTelemetry)(ue,Ne);if((0,C.supportsTelemetry)(ue,we)){ue.aiConfig&&ue.aiConfig.ariaKey&&Re.push(new L.OneDataSystemAppender(Le,"monacoworkbench",null,ue.aiConfig.ariaKey));const{installSourcePath:Me}=we,ke={appenders:Re,sendErrorTelemetry:!1,commonProperties:(async()=>{let Te;try{Te=await(0,re.resolveMachineId)(pe)}catch(Ae){Ae.code!=="ENOENT"&&B.error(Ae)}return(0,W.resolveCommonProperties)(K,(0,O.release)(),(0,O.hostname)(),process.arch,ue.commit,ue.version,Te,Le,Me)})(),piiPaths:(0,C.getPiiPathsFromEnvironment)(we)};se.set(q.ITelemetryService,new A.SyncDescriptor(J.TelemetryService,[ke],!1))}else se.set(q.ITelemetryService,C.NullTelemetryService);return[new F.InstantiationService(se),Re]}g(se){(0,D.setUnexpectedErrorHandler)(ue=>{const we=(0,k.toErrorMessage)(ue,!0);!we||se.error(`[uncaught exception in CLI]: ${we}`)}),process.on("uncaughtException",ue=>{(0,D.isSigPipeError)(ue)||(0,D.onUnexpectedError)(ue)}),process.on("unhandledRejection",ue=>(0,D.onUnexpectedError)(ue))}async h(se,ue,we,Pe){let je;if(se.args.profile&&(je=we.profiles.find(B=>B.name===se.args.profile),!je))throw new Error(`Profile '${se.args.profile}' not found.`);const Ue=(je??we.defaultProfile).extensionsResource;if(this.b["install-source"])return this.j(se,ue,this.b["install-source"]);if(this.b["list-extensions"])return Pe.createInstance(s.ExtensionManagementCLI).listExtensions(!!this.b["show-versions"],this.b.category,Ue);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const B={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:Ue};return Pe.createInstance(s.ExtensionManagementCLI).installExtensions(this.i(this.b["install-extension"]||[]),this.b["install-builtin-extension"]||[],B,!!this.b.force)}else{if(this.b["uninstall-extension"])return Pe.createInstance(s.ExtensionManagementCLI).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,Ue);if(this.b["locate-extension"])return Pe.createInstance(s.ExtensionManagementCLI).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.buildTelemetryMessage)(se.appRoot,se.extensionsPath))}}i(se){return se.map(ue=>/\.vsix$/i.test(ue)?d.URI.file((0,u.isAbsolute)(ue)?ue:(0,u.join)((0,E.cwd)(),ue)):ue)}async j(se,ue,we){await ue.writeFile(d.URI.file(se.installSourcePath),P.VSBuffer.fromString(we.slice(0,30)))}}async function ce(ge){const se=new me(ge);try{await se.run()}finally{se.dispose()}}e.main=ce})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc619de8d9efdabd781fc5658d0051813c347055/core/vs/code/node/cliProcessMain.js.map
